* SUBROUTINE EAFU02             ALL SYSTEMS                 90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FA  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAFU02(N,KA,X,FA,NEXT)
      INTEGER J,N,KA,NEXT
      $FLOAT X(N),FA
      $FLOAT A,B,C,D,U,V,W
      $FLOAT Y(65)
      COMMON /EMPR02/ Y
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     &      170,180,190,200,210,220,230,240,250,260,270,280,290,
     &      300),NEXT
   10 GOTO (11,12),KA
   11 FA=1.0$P 1*(X(2)-X(1)**2)
      RETURN
   12 FA=1.0$P 0-X(1)
      RETURN
   20 GOTO (21,22), KA
   21 FA=-1.3$P 1+X(1)+((5.0$P 0-X(2))*X(2)-2.0$P 0)*X(2)
      RETURN
   22 FA=-2.9$P 1+X(1)+((X(2)+1.0$P 0)*X(2)-1.4$P 1)*X(2)
      RETURN
   30 GOTO (31,32),KA
   31 FA=1.0$P 4*X(1)*X(2)-1.0$P 0
      RETURN
   32 FA=EXP(-X(1))+EXP(-X(2))-1.0001$P 0
      RETURN
   40 GOTO(41,42,43),KA
   41 FA=X(1)-1.0$P+6
      RETURN
   42 FA=X(2)-2.0$P-6
      RETURN
   43 FA=X(1)*X(2)-2.0$P 0
      RETURN
   50 FA=Y(KA)-X(1)*(1.0$P 0-X(2)**KA)
      RETURN
   60 FA=2.0$P 0+2.0$P 0*KA-(EXP(KA*X(1))+EXP(KA*X(2)))
      RETURN
   70 GOTO (71,72,73),KA
   71 B=X(1)
      IF(B.EQ.0.0$P 0)B=1$P-5
      A=0.5$P 0*ATAN(X(2)/B)/3.14159265358979323846$P 0
      IF(B.LT.0.0$P 0) A=A+0.5$P 0
      FA=1.0$P 1*(X(3)-1.0$P 1*A)
      RETURN
   72 FA=1.0$P 1*SQRT(X(1)**2+X(2)**2)-1.0$P 1
      RETURN
   73 FA=X(3)
      RETURN
   80 U=KA
      V=16-KA
      W=MIN(U,V)
      FA=Y(KA)-(X(1)+U/(V*X(2)+W*X(3)))
      RETURN
   90 FA=X(1)*EXP(-0.5$P 0*X(2)*(0.5$P 0*$DBLE(8-KA)-X(3))**2)-Y(KA)
      RETURN
  100 FA=X(1)*EXP(X(2)/($DBLE(45+5*KA)+X(3)))-Y(KA)
      RETURN
  110 FA=1.0$P 3*(EXP(-ABS(Y(KA)-X(2))**X(3)/X(1))-1.0$P-2*$DBLE(KA))
      RETURN
  120 A=1.0$P-1*$DBLE(KA)
      FA=EXP(-A*X(1))-EXP(-A*X(2))-X(3)*(EXP(-A)-EXP(-1.0$P 1*A))
      RETURN
  130 GOTO (131,132,133,134),KA
  131 FA=X(1)+1.0$P 1*X(2)
      RETURN
  132 FA=2.23606797749979$P 0*(X(3)-X(4))
      RETURN
  133 FA=(X(2)-2.0$P 0*X(3))**2
      RETURN
  134 FA=3.16227766016838$P 0*(X(1)-X(4))**2
      RETURN
  140 GOTO (141,142,143,144,145,146),KA
  141 FA=1.0$P 1*(X(2)-X(1)**2)
      RETURN
  142 FA=1.0$P 0-X(1)
      RETURN
  143 FA=9.486833$P 0*(X(4)-X(3)**2)
      RETURN
  144 FA=1.0$P 0-X(3)
      RETURN
  145 FA=3.16227766016838$P 0*(X(2)+X(4)-2.0$P 0)
      RETURN
  146 FA=(X(2)-X(4))/3.16227766016838$P 0
      RETURN
  150 FA=Y(KA+20)-Y(KA)*X(1)*(Y(KA)+X(2))/
     &  (Y(KA)*(Y(KA)+X(3))+X(4))
      RETURN
  160 W=0.2$P 0*$DBLE(KA)
      A=X(1)+W*X(2)-EXP(W)
      B=X(3)+SIN(W)*X(4)-COS(W)
      FA=A**2+B**2
      RETURN
  170 W=1.0$P 1*$DBLE(KA-1)
      A=EXP(-W*X(4))
      B=EXP(-W*X(5))
      FA=Y(KA)-(X(1)+X(2)*A+X(3)*B)
      RETURN
  180 W=0.1$P 0*$DBLE(KA)
      A=EXP(-W*X(1))
      B=EXP(-W*X(2))
      C=EXP(-W*X(3))
      FA=X(4)*A-X(5)*B+X(6)*C-Y(KA)
      RETURN
  190 W=0.1$P 0*$DBLE(KA-1)
      A=EXP(-W*X(5))
      B=EXP(-X(6)*(W-X(9))**2)
      C=EXP(-X(7)*(W-X(10))**2)
      D=EXP(-X(8)*(W-X(11))**2)
      FA=Y(KA)-(X(1)*A+X(2)*B+X(3)*C+X(4)*D)
      RETURN
  200 IF(KA.LT.30) THEN
      A=0.0$P 0
      B=X(1)
      W=$DBLE(KA)/2.9$P 1
      DO 201 J=2,N
      A=A+$DBLE(J-1)*X(J)*W**(J-2)
      B=B+X(J)*W**(J-1)
  201 CONTINUE
      FA=A-B**2-1.0$P 0
      ELSEIF(KA.EQ.30) THEN
      FA=X(1)
      ELSEIF(KA.GT.30) THEN
      FA=X(2)-X(1)**2-1.0$P 0
      ENDIF
      RETURN
  210 IF(MOD(KA,2).EQ.1) THEN
      FA=1.0$P 1*(X(KA+1)-X(KA)**2)
      ELSE
      FA=1.0$P 0-X(KA-1)
      ENDIF
      RETURN
  220 IF(MOD(KA,4).EQ.1) THEN
      FA=X(KA)+1.0$P 1*X(KA+1)
      ELSEIF(MOD(KA,4).EQ.2) THEN
      FA=2.23606797749979$P 0*(X(KA+1)-X(KA+2))
      ELSEIF(MOD(KA,4).EQ.3) THEN
      FA=(X(KA-1)-2.0$P 0*X(KA))**2
      ELSE
      FA=3.16227766016838$P 0*(X(KA-3)-X(KA))**2
      ENDIF
      RETURN
  230 IF(KA.LE.N) THEN
      FA=(X(KA)-1.0$P 0)/3.16227766016838$P 0**5
      ELSE
      FA=-0.25$P 0
      DO 231 J=1,N
      FA=FA+X(J)**2
  231 CONTINUE
      ENDIF
      RETURN
  240 IF(KA.EQ.1) THEN
      FA=X(1)-0.2$P 0
      ELSEIF(KA.LE.N) THEN
      FA=(EXP(0.1$P 0*X(KA))+EXP(0.1$P 0*X(KA-1))
     &   -EXP(0.1$P 0*$DBLE(KA))-EXP(0.1$P 0*$DBLE(KA-1)))/
     &   3.16227766016838$P 0**5
      ELSEIF(KA.LT.2*N) THEN
      FA=(EXP(0.1$P 0*X(KA+1-N))-EXP(-0.1$P 0))/3.16227766016838$P 0**5
      ELSE
      FA=-1.0$P 0
      DO 241 J=1,N
      FA=FA+$DBLE(N+1-J)*X(J)**2
  241 CONTINUE
      ENDIF
      RETURN
  250 IF(KA.LE.N) THEN
      FA=X(KA)-1.0$P 0
      ELSE
      FA=0.0$P 0
      DO 251 J=1,N
      FA=FA+$DBLE(J)*(X(J)-1.0$P 0)
  251 CONTINUE
      IF(KA.EQ.N+2) FA=FA**2
      ENDIF
      RETURN
  260 A=0.0$P 0
      DO 261 J=1,N
      A=A+COS(X(J))
  261 CONTINUE
      FA=$DBLE(N)-A+$DBLE(KA)*(1.0$P 0-COS(X(KA)))-SIN(X(KA))
      RETURN
  270 IF(KA.LT.N) THEN
      A=0.0$P 0
      DO 271 J=1,N
      A=A+X(J)
  271 CONTINUE
      FA=X(KA)+A-$DBLE(N+1)
      ELSE
      A=1.0$P 0
      DO 272 J=1,N
      A=A*X(J)
  272 CONTINUE
      FA=A-1.0$P 0
      ENDIF
      RETURN
  280 U=1.0$P 0/$DBLE(N+1)
      V=$DBLE(KA)*U
      FA=2.0$P 0*X(KA)+0.5$P 0*U*U*(X(KA)+V+1.0$P 0)**3
      IF(KA.GT.1) FA=FA-X(KA-1)
      IF(KA.LT.N) FA=FA-X(KA+1)
      RETURN
  290 U=1.0$P 0/$DBLE(N+1)
      V=$DBLE(KA)*U
      A=0.0$P 0
      B=0.0$P 0
      DO 291 J=1,N
      W=$DBLE(J)*U
      IF(J.LE.KA) THEN
      A=A+W*(X(J)+W+1.0$P 0)**3
      ELSE
      B=B+(1.0$P 0-W)*(X(J)+W+1.0$P 0)**3
      ENDIF
  291 CONTINUE
      FA=X(KA)+U*((1.0$P 0-V)*A+V*B)/2.0$P 0
      RETURN
  300 FA=(3.0$P 0-2.0$P 0*X(KA))*X(KA)+1.0$P 0
      IF(KA.GT.1) FA=FA-X(KA-1)
      IF(KA.LT.N) FA=FA-2.0$P 0*X(KA+1)
      RETURN
      END
