* SUBROUTINE EAFU20             ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION - LU VERSION WITH MODIFIED TESTS NO 7-10,12.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAFU20(N,KA,X,FA,NEXT)
      INTEGER N,NEXT
      $FLOAT X(N),FA
      $FLOAT A,B,C,D,P,Q,R,U,V
      INTEGER I,J,KA
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,110,120,160,170,
     & 160,80), NEXT
   10   A=X(KA)**2-X(KA+1)
        B=X(KA)-1.0$P 0
        FA=1.0$P 2*A**2+B**2
      RETURN
   20   I=2*KA-1
        A=X(I)**2-X(I+1)
        B=X(I)-1.0$P 0
        C=X(I+2)**2-X(I+3)
        D=X(I+2)-1.0$P 0
        U=X(I+1)+X(I+3)-2.0$P 0
        V=X(I+1)-X(I+3)
        FA=1.0$P 2*A**2+B**2+9.0$P 1*C**2+D**2+
     &    1.0$P 1*U**2+0.1$P 0*V**2
      RETURN
   30   I=2*KA-1
        A=X(I)+1.0$P 1*X(I+1)
        B=X(I+2)-X(I+3)
        C=X(I+1)-2.0$P 0*X(I+2)
        D=X(I)-X(I+3)
        FA=A**2+5.0$P 0*B**2+C**4+1.0$P 1*D**4
      RETURN
   40   I=2*KA-1
        A=EXP(X(I))
        B=A-X(I+1)
        D=X(I+1)-X(I+2)
        P=X(I+2)-X(I+3)
        Q=SIN(P)/COS(P)
        U=X(I)
        V=X(I+3)-1.0$P 0
        FA=B**4+1.0$P 2*D**6+Q**4+U**8+V**2
      RETURN
   50 P=7.0$P 0/3.0$P 0
        A=(3.0$P 0-2.0$P 0*X(KA))*X(KA)+1.0$P 0
        IF (KA.GT.1) A=A-X(KA-1)
        IF (KA.LT.N) A=A-X(KA+1)
        FA=ABS(A)**P
      RETURN
   60 P=7.0$P 0/3.0$P 0
        A=(2.0$P 0+5.0$P 0*X(KA)**2)*X(KA)+1.0$P 0
        DO 61 I=MAX(1,KA-5),MIN(N,KA+1)
          A=A+X(I)*(1.0$P 0+X(I))
   61   CONTINUE
        FA=ABS(A)**P
      RETURN
   70 A=$DBLE(KA)*(1.0$P 0-COS(X(KA)))
      IF(KA.GT.1) A=A+$DBLE(KA)*SIN(X(KA-1))
      IF(KA.LT.N) A=A-$DBLE(KA)*SIN(X(KA+1))
      FA=A
      RETURN
   80 P=-0.2008$P-2
      Q=-0.1900$P-2
      R=-0.0261$P-2
      I=5*(KA-1)
      A=1.0$P 0
      B=0.0$P 0
      DO  81 J=1,5
      A=A*X(I+J)
      B=B+X(I+J)**2
   81 CONTINUE
      A=EXP(A)
      B=B-1.0$P 1-P
      C=X(I+2)*X(I+3)-5.0$P 0*X(I+4)*X(I+5)-Q
      D=X(I+1)**3+X(I+2)**3+1.0$P 0-R
      FA=A+1.0$P 1*(B**2+C**2+D**2)
      RETURN
   90 I=2*KA-1
      A=X(I)-3.0$P 0
      B=X(I)-X(I+1)
      FA=1.0$P-4*A**2-B+EXP(2.0$P 1*B)
      RETURN
  100 I=2*KA-1
      A=X(I+1)**2
      B=X(I)**2
      C=A+1.0$P 0
      D=B+1.0$P 0
      FA=B**C+A**D
      RETURN
  110 I=(KA-1)/4
      J=I*3
      GO TO (111,112,113,114),MOD(KA,4)+1
  111 FA=(X(J+5)-1.0$P 0)**6
      RETURN
  112 FA=(X(J+1)-X(J+2))**2
      RETURN
  113 FA=(X(J+3)-1.0$P 0)**2
      RETURN
  114 FA=(X(J+4)-1.0$P 0)**4
      RETURN
  120 I=(KA-1)/4
      J=I*4
      GO TO (121,122,123,124),MOD(KA,4)+1
  121 FA=(X(J+4)-X(J+5))**4
      RETURN
  122 FA=(X(J+1)-X(J+2))**2
      RETURN
  123 FA=(X(J+2)-X(J+3))**2
      RETURN
  124 FA=(X(J+3)-X(J+4))**4
      RETURN
  130 I=(KA-1)/3
      J=I*3
      GO TO (131,132,133),MOD(KA,3)+1
  131 FA=(X(J+4)-X(J+5))**4
      RETURN
  132 FA=(X(J+1)-1.0$P 0)**2
      RETURN
  133 FA=(X(J+2)-X(J+3))**2
      RETURN
  160 I=(KA-1)/4
      J=I*4
      GO TO (161,162,163,164),MOD(KA,4)+1
  161 FA=(X(J+5)-1.0$P 0)**2
      RETURN
  162 FA=(X(J+1)-X(J+2))**4
      RETURN
  163 FA=(X(J+2)+X(J+3)-2.0$P 0)**2
      RETURN
  164 FA=(X(J+4)-1.0$P 0)**2
      RETURN
  170 I=(KA-1)/4
      J=I*4
      GO TO (171,172,173,174),MOD(KA,4)+1
  171 FA=(X(J+5)-1.0$P 0)**2
      RETURN
  172 FA=(4.0$P 0*X(J+1)-X(J+2))**2
      RETURN
  173 FA=(X(J+2)+X(J+3)-2.0$P 0)**4
      RETURN
  174 FA=(X(J+4)-1.0$P 0)**2
      RETURN
      END
