* SUBROUTINE EAGU17             ALL SYSTEMS                 92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF TEST FUNCTIONS FOR NONLINEAR EQUATIONS.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GA(N)  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU17(N,KA,X,GA,NEXT)
      INTEGER J,N,KA,NEXT
      $FLOAT X(N),GA(N)
      $FLOAT A,B,C,U,V,W,EX,DA,DB,PI,D1S,D2S
      INTEGER I
      $FLOAT Y(530)
      COMMON /EMPR17/ Y
      PI=3.14159265358979323846$P 0
      DO 1 I=1,N
      GA(I)=0.0$P 0
    1 CONTINUE
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,
     &      160,170,180,190,200,210,220,230,240,250,260,270,
     &      280,290,300),NEXT
   10 GOTO(11,12),KA
   11 GA(1)=-2.0$P 1*X(1)
      GA(2)=1.0$P 1
      RETURN
   12 GA(1)=-1.0$P 0
      GA(2)=0.0$P 0
      RETURN
   20 GOTO(21,22),KA
   21 GA(1)=-4.0$P 2*(X(2)-X(1)**2)*X(1)
      GA(2)=2.0$P 2*(X(2)-X(1)**2)
      RETURN
   22 GA(1)=2.0$P 0*(X(1)-1.0$P 0)
      GA(2)=0.0$P 0
      RETURN
   30 GOTO(31,32),KA
   31 GA(1)=1.0$P 4*X(2)
      GA(2)=1.0$P 4*X(1)
      RETURN
   32 GA(1)=-EXP(-X(1))
      GA(2)=-EXP(-X(2))
      RETURN
   40 GOTO(41,42,43),KA
   41 GA(1)=3.0$P 0
      GA(2)=1.0$P 0
      GA(3)=4.0$P 0*X(3)
      RETURN
   42 GA(1)=2.0$P 0*X(3)-3.0$P 0
      GA(2)=1.0$P 1*X(2)
      GA(3)=2.0$P 0*X(1)
      RETURN
   43 GA(1)=25.0$P 0*X(2)
      GA(2)=25.0$P 0*X(1)
      GA(3)=20.0$P 0
      RETURN
   50 GOTO(51,52,53),KA
   51 GA(1)=64.0$P 0*X(1)**3
      GA(2)=64.0$P 0*X(2)**3
      GA(3)=4.0$P 0*X(3)**3
      RETURN
   52 GA(1)=2.0$P 0*X(1)
      GA(2)=2.0$P 0*X(2)
      GA(3)=2.0$P 0*X(3)
      RETURN
   53 GA(1)=3.0$P 0*X(1)**2
      GA(2)=-1.0$P 0
      GA(3)=0.0$P 0
      RETURN
   60 A=5.0$P -1*$DBLE(KA)
      GA(1)=-A*EXP(-A*X(1))
      GA(2)=A*EXP(-A*X(2))
      GA(3)=-EXP(-A)+EXP(-10.0$P 0*A)
      RETURN
   70 GOTO(71,72,73),KA
   71 IF(X(1).EQ.0.0$P 0) THEN
      GA(1)=0.0$P 0
      GA(2)=0.0$P 0
      GA(3)=10.0$P 0
      ELSE
      GA(1)= 50.0D 0*X(2)/(X(1)**2+X(2)**2)/PI
      GA(2)=-50.0D 0*X(1)/(X(1)**2+X(2)**2)/PI
      GA(3)=10.0D 0
      ENDIF
      RETURN
   72 A=SQRT(X(1)**2+X(2)**2)
      GA(1)=1.0$P 1*X(1)/A
      GA(2)=1.0$P 1*X(2)/A
      GA(3)=0.0$P 0
      RETURN
   73 GA(1)=0.0$P 0
      GA(2)=0.0$P 0
      GA(3)=1.0$P 0
      RETURN
   80 GOTO(81,82,83,84),KA
   81 GA(1)=1.0$P 0
      GA(2)=1.0$P 1
      GA(3)=0.0$P 0
      GA(4)=0.0$P 0
      RETURN
   82 GA(1)=0.0$P 0
      GA(2)=0.0$P 0
      GA(3)=2.236068$P 0
      GA(4)=-2.236068$P 0
      RETURN
   83 A=X(2)-2.0$P 0*X(3)
      GA(1)=0.0$P 0
      GA(2)=2.0$P 0*A
      GA(3)=-4.0$P 0*A
      GA(4)=0.0$P 0
      RETURN
   84 A=3.162279$P 0*2.0$P 0*(X(1)-X(4))
      GA(1)=A
      GA(2)=0.0$P 0
      GA(3)=0.0$P 0
      GA(4)=-A
      RETURN
   90 W=0.3$P 0*$DBLE(KA)
      A=EXP(-W*X(1))
      B=EXP(-W*X(2))
      C=EXP(-W*X(3))
      GA(1)=-W*X(4)*A
      GA(2)=+W*X(5)*B
      GA(3)=-W*X(6)*C
      GA(4)=A
      GA(5)=-B
      GA(6)=C
      RETURN
  100 GOTO(101,102,103,104,105,106),KA
  101 GA(1)=Y(1)
      GA(2)=0.0$P 0
      GA(3)=0.0$P 0
      GA(4)=Y(2)
      GA(5)=0.0$P 0
      GA(6)=0.0$P 0
      RETURN
  102 GA(1)= 0.0$P 0
      GA(2)=Y(3)*X(3)**2-Y(2)
      GA(3)=2.0$P 0*Y(3)*X(2)*X(3)+Y(4)*X(6)
      GA(4)=0.0$P 0
      GA(5)=Y(2)
      GA(6)=Y(4)*X(3)
      RETURN
  103 GA(1)=0.0$P 0
      GA(2)=-Y(2)
      GA(3)=2.0$P 0*Y(5)*X(5)*X(3)+Y(6)*X(6)
      GA(4)=0.0$P 0
      GA(5)=Y(5)*X(3)**2+Y(2)
      GA(6)=Y(6)*X(3)
      RETURN
  104 GA(1)=0.0$P 0
      GA(2)=-Y(4)*X(3)
      GA(3)=2.0$P 0*Y(5)*X(6)*X(3)-Y(4)*X(2)+Y(6)*X(5)
      GA(4)=0.0$P 0
      GA(5)=Y(6)*X(3)
      GA(6)=Y(5)*X(3)**2-Y(2)
      RETURN
  105 GA(1)=3.0$P 0*Y(7)*(X(2)*X(3))**3+
     &   12.0$P 0*Y(7)*X(1)**2*X(2)*X(3)-
     &   8.0$P 0*Y(8)*X(1)*X(2)*X(3)+4.0$P 0*X(2)*X(3)*Y(9)
      GA(2)=(3.0$P 0*Y(7)*X(1)-Y(8))*3.0$P 0*X(2)**2*X(3)**3+
     &   4.0$P 0*((Y(7)*X(1)-Y(8))*X(1)+Y(9))*X(1)*X(3)
     &   -Y(4)*X(3)-Y(10)*X(3)
      GA(3)=(3.0$P 0*Y(7)*X(1)-Y(8))*3.0$P 0*X(2)**3*X(3)**2+
     &   4.0$P 0*((Y(7)*X(1)-Y(8))*X(1)+Y(9))*X(1)*X(2)
     &   -Y(4)*X(2)+Y(4)*X(5)-Y(10)*X(2)
      GA(4)=0.0$P 0
      GA(5)=Y(4)*X(3)
      GA(6)=-Y(2)
      RETURN
  106 GA(1)=(X(2)*X(3))**2*(6.0$P 0*Y(7)*X(1)-2.0$P 0*Y(8))+
     &    4.0$P 0*Y(7)*X(1)**3-3.0$P 0*Y(12)*X(1)**2+
     &    4.0$P 0*Y(9)*X(1)-Y(10)
      GA(2)=4.0$P 0*Y(11)*X(2)**3*X(3)**4+
     &    ((3.0$P 0*Y(7)*X(1)-2.0$P 0*Y(8))*X(1)+Y(9))*
     &    2.0$P 0*X(2)*X(3)**2
      GA(3)=4.0$P 0*Y(11)*X(2)**4*X(3)**3+
     &    ((3.0$P 0*Y(7)*X(1)-2.0$P 0*Y(8))*X(1)+Y(9))*
     &    2.0$P 0*X(2)**2*X(3)
      GA(4)=Y(2)
      GA(5)=0.0$P 0
      GA(6)=0.0$P 0
      RETURN
  110 GA(KA)=224.0$P 0
      DO 111 I=1,N
      IF (I.NE.KA) THEN
      A=SQRT(X(I)**2+$DBLE(KA)/$DBLE(I))
      DA=X(I)/A
      B=LOG(A)
      DB=X(I)/A**2
      GA(I)=DA*(SIN(B)**5+COS(B)**5)+
     &  A*(5.0$P 0*SIN(B)**4*COS(B)*DB-5.0$P 0*COS(B)**4*SIN(B)*DB)
      ENDIF
  111 CONTINUE
      RETURN
  120 J=(KA-1)*N
      DO 121 I=1,N
      GA(I)=-Y(J+I)*COS(X(I))+Y(J+I+256)*SIN(X(I))
  121 CONTINUE
      RETURN
  130 J=(KA-1)/5
      GA(KA)=GA(KA)-$DBLE(J+1)*SIN(X(KA))-COS(X(KA))
      J=J*5
      DO 131 I=J+1,J+5
      GA(I)=GA(I)+SIN(X(I))
  131 CONTINUE
      RETURN
  140 IF (KA.LT.2) THEN
      D1S=COS(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))
      D2S=SIN(X(KA)-X(KA+1))*COS(X(KA)+X(KA+1))
      GA(KA)=9.0$P 0*X(KA)**2+D1S+D2S
      GA(KA+1)=2.0$P 0-D1S+D2S
      ELSE IF (KA.LT.N) THEN
      D1S=COS(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))
      D2S=SIN(X(KA)-X(KA+1))*COS(X(KA)+X(KA+1))
      EX=EXP(X(KA-1)-X(KA))
      GA(KA-1)=-EX-X(KA-1)*EX
      GA(KA)=9.0$P 0*X(KA)**2+D1S+D2S+4.0$P 0+X(KA-1)*EX
      GA(KA+1)=2.0$P 0-D1S+D2S
      ELSE
      EX=EXP(X(KA-1)-X(KA))
      GA(KA-1)=-EX-X(KA-1)*EX
      GA(KA)=4.0$P 0+X(KA-1)*EX
      ENDIF
      RETURN
  150 IF (MOD(KA,2).EQ.1) THEN
      GA(KA)=0.0$P 0
      IF (KA.NE.1) THEN
      D1S=COS(X(KA-2)-X(KA-1)-X(KA))*SIN(X(KA-2)+X(KA-1)-X(KA))
      D2S=SIN(X(KA-2)-X(KA-1)-X(KA))*COS(X(KA-2)+X(KA-1)-X(KA))
      GA(KA-2)=-18.0$P 0*(X(KA-2)-X(KA))**2-2.0$P 0*(D1S+D2S)
      GA(KA-1)=-4.0$P 0+2.0$P 0*(D1S-D2S)
      GA(KA)=GA(KA)+18.0$P 0*(X(KA-2)-X(KA))**2+2.0$P 0*(D1S+D2S)
      ENDIF
      IF (KA.NE.N) THEN
      D1S=COS(X(KA)-X(KA+1)-X(KA+2))*SIN(X(KA)+X(KA+1)-X(KA+2))
      D2S=SIN(X(KA)-X(KA+1)-X(KA+2))*COS(X(KA)+X(KA+1)-X(KA+2))
      GA(KA)=GA(KA)+9.0$P 0*(X(KA)-X(KA+2))**2+D1S+D2S
      GA(KA+1)=2.0$P 0-D1S+D2S
      GA(KA+2)=-9.0$P 0*(X(KA)-X(KA+2))**2-D1S-D2S
      ENDIF
      ELSE
      EX=EXP(X(KA-1)-X(KA)-X(KA+1))
      W=X(KA-1)-X(KA+1)
      GA(KA-1)=-EX-W*EX
      GA(KA)=4.0$P 0+W*EX
      GA(KA+1)=EX+W*EX
      ENDIF
      RETURN
  160 W=0.0$P 0
      DO 161 I=1,N-1
      W=W+($DBLE(KA)/$DBLE(KA+I))*X(I)
  161 CONTINUE
      W=W+0.5$P 0+0.5$P 0*$DBLE(KA)/$DBLE(KA+N)*X(N)
      DO 162 I=1,N
      GA(I)=-0.4$P 0/$DBLE(N)*X(KA)*$DBLE(KA)/$DBLE(KA+I)
  162 CONTINUE
      GA(N)=0.5$P 0*GA(N)
      GA(KA)=GA(KA)+1.0$P 0-0.4$P 0*W/$DBLE(N)
      RETURN
  170 IF (KA.LT.2) THEN
      GA(KA)=4.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)
      ELSE IF (KA.LT.N) THEN
      GA(KA-1)=-8.0$P 0*X(KA)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)
      ELSE
      GA(KA-1)=-8.0$P 0*X(KA)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+2.0$P 0
      ENDIF
      RETURN
  180 IF (KA.LT.2) THEN
      GA(KA)=4.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)
      ELSE IF (KA.LT.3) THEN
      GA(KA-1)=-8.0$P 0*X(KA)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)
      ELSE IF (KA.LT.N-1) THEN
      GA(KA-2)=-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)
      ELSE IF (KA.LT.N) THEN
      GA(KA-2)=-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)
      ELSE
      GA(KA-2)=-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+2.0$P 0
      ENDIF
      RETURN
  190 IF (KA.LT.2) THEN
      GA(KA)=4.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.3) THEN
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.4) THEN
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.N-2) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.N-1) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      ELSE IF (KA.LT.N) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      ELSE
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+2.0$P 0
      ENDIF
      RETURN
  200 IF (KA.LE.N-2) THEN
      B=X(1)
      W=$DBLE(KA)/$DBLE(N-2)
      DO 202 J=2,N
      B=B+X(J)*W**(J-1)
  202 CONTINUE
      DO 203 J=2,N
      GA(J)=$DBLE(J-1)*W**(J-2)-2.0$P 0*B*W**(J-1)
  203 CONTINUE
      GA(1)=-2.0$P 0*B
      ELSE IF (KA.EQ.N-1) THEN
      GA(1)=1.0$P 0
      ELSE IF (KA.EQ.N) THEN
      GA(1)=-2.0$P 0*X(1)
      GA(2)=1.0$P 0
      ENDIF
      RETURN
  210 IF(MOD(KA,2).EQ.1) THEN
      GA(KA)=-2.0$P 1*X(KA)
      GA(KA+1)=10.$P 0
      ELSE
      GA(KA-1)=-1.0$P 0
      ENDIF
      RETURN
  220 DO 221 J=1,N
      GA(J)=0.0$P 0
  221 CONTINUE
      IF(MOD(KA,4).EQ.1) THEN
      GA(KA)=1.0$P 0
      GA(KA+1)=1.0$P 1
      ELSE IF(MOD(KA,4).EQ.2) THEN
      GA(KA+1)=2.23606797749979$P 0
      GA(KA+2)=-GA(KA+1)
      ELSE IF(MOD(KA,4).EQ.3) THEN
      GA(KA-1)=2.0$P 0*(X(KA-1)-2.0$P 0*X(KA))
      GA(KA)= -4.0$P 0*(X(KA-1)-2.0$P 0*X(KA))
      ELSE
      GA(KA-3)=3.16227766016838$P 0*2.0$P 0*(X(KA-3)-X(KA))
      GA(KA)= -3.16227766016838$P 0*2.0$P 0*(X(KA-3)-X(KA))
      ENDIF
      RETURN
  230 IF (MOD(KA,4).EQ.1) THEN
      GA(KA)=2.0$P 0*(EXP(X(KA))-X(KA+1))*EXP(X(KA))
      GA(KA+1)=-2.0$P 0*(EXP(X(KA))-X(KA+1))
      ELSE IF (MOD(KA,4).EQ.2) THEN
      GA(KA)=3.0$P 1*(X(KA)-X(KA+1))**2
      GA(KA+1)=-GA(KA)
      ELSE IF (MOD(KA,4).EQ.3) THEN
      GA(KA)=2.0$P 0*SIN(X(KA)-X(KA+1))/(COS(X(KA)-X(KA+1)))**3
      GA(KA+1)=-GA(KA)
      ELSE
      GA(KA)=1.0$P 0
      ENDIF
      RETURN
  240 IF (KA.LT.2) THEN
      GA(KA)=X(KA)-3.0$P 0
      GA(KA+1)=2.0$P 0
      ELSE IF (KA.LT.N) THEN
      GA(KA-1)=1.0$P 0
      GA(KA)=X(KA)-3.0$P 0
      GA(KA+1)=2.0$P 0
      ELSE
      GA(KA-1)=1.0$P 0
      GA(KA)=X(KA)-3.0$P 0
      ENDIF
      RETURN
  250 DO 251 J=MAX(1,KA-5),MIN(N,KA+1)
      GA(J)=1.0$P 0+2.0$P 0*X(J)
  251 CONTINUE
      GA(KA)=GA(KA)+2.0$P 0+15.0$P 0*X(KA)**2
      RETURN
  260 DO 261 J=1,N
      GA(J)=SIN(X(J))
  261 CONTINUE
      GA(KA)=GA(KA)+$DBLE(KA)*SIN(X(KA))-COS(X(KA))
      RETURN
  270 IF(KA.LT.N) THEN
      DO 271 J=1,N
      GA(J)=1.0$P 0
  271 CONTINUE
      GA(KA)=2.0$P 0
      ELSE
      A=1.0$P 0
      DO 272 J=1,N
      A=A*X(J)
  272 CONTINUE
      DO 273 J=1,N
      GA(J)=A/X(J)
  273 CONTINUE
      ENDIF
      RETURN
  280 DO 281 J=1,N
      GA(J)=0.0$P 0
  281 CONTINUE
      U=1.0$P 0/$DBLE(N+1)
      V=$DBLE(KA)*U
      GA(KA)=2.0$P 0+1.5$P 0*U**2*(X(KA)+V+1.0$P 0)**2
      IF(KA.GT.1) GA(KA-1)=-1.0$P 0
      IF(KA.LT.N) GA(KA+1)=-1.0$P 0
      RETURN
  290 U=1.0$P 0/$DBLE(N+1)
      V=$DBLE(KA)*U
      DO 291 J=1,N
      W=$DBLE(J)*U
      A=(X(J)+W+1.0$P 0)**2
      IF(J.LE.KA) THEN
      GA(J)=1.5$P 0*U*(1.0$P 0-V)*W*A
      ELSE
      GA(J)=1.5$P 0*U*(1.0$P 0-W)*V*A
      ENDIF
  291 CONTINUE
      GA(KA)=GA(KA)+1.0$P 0
      RETURN
  300 DO 301 J=1,N
      GA(J)=0.0$P 0
  301 CONTINUE
      GA(KA)=3.0$P 0-4.0$P 0*X(KA)
      IF(KA.GT.1) GA(KA-1)=-1.0$P 0
      IF(KA.LT.N) GA(KA+1)=-2.0$P 0
      RETURN
      END
