* SUBROUTINE EAGU26                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GA(N)  GRADIENT OF THE APPROXIMATED FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU26(N,KA,X,GA,NEXT)
      INTEGER N,KA,NEXT
      $FLOAT X(N),GA(N)
      INTEGER I,J,K,L,M,I1,I2,IA,IB,IC,J1,J2,N1,ND,LA
      $FLOAT A,B,C,D,E,A1,A2,A3,A4,AL,AL1,AL2,FF,FG,PAR,PI,BE,BE1,BE2,
     & CA,CB,D1S,D2S,GB,H,H2,Q,R,S,S1,S2,S3,T,U,V,W,EX,ALFA
      $FLOAT GA1(2),GA2(2),GA3(6),GA4(6)
      $FLOAT Y(20)
      COMMON /EMPR15/ Y
      COMMON /EMPR18/ PAR,M
      PI=3.14159265358979323846$P 0
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,
     & 230,240,250,260,270,280,290,310,340,360,
     & 370,380,390,400,410,420,430,440,450,460,470,480,490,500,520,
     & 510,530,540,550,560,570,580,590,600,620,630,640,650),
     & NEXT
   10 I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      GA(I)=2.0$P 1*X(I)
      GA(I+1)=-1.0$P 1
      ELSE
      GA(I)=1.0$P 0
      ENDIF
      RETURN
   20 I=2*((KA+5)/6)
      A=SQRT(9.0$P 1)
      B=SQRT(1.0$P 1)
      IF (MOD(KA,6).EQ.1) THEN
      GA(I-1)=2.0$P 1 *X(I-1)
      GA(I)=-1.0$P 1
      ELSEIF (MOD(KA,6).EQ.2) THEN
      GA(I-1)=1.0$P 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      GA(I+1)=2.0$P 0*A*X(I+1)
      GA(I+2)=-A
      ELSEIF (MOD(KA,6).EQ.4) THEN
      GA(I+1)=1.0$P 0
      ELSEIF (MOD(KA,6).EQ.5) THEN
      GA(I)=B
      GA(I+2)=B
      ELSE
      GA(I)=1.0$P 0/B
      GA(I+2)=-1.0$P 0/B
      ENDIF
      RETURN
   30 I=2*((KA+3)/4)
      A=SQRT(5.0$P 0)
      B=SQRT(1.0$P 1)
      IF (MOD(KA,4).EQ.1) THEN
      GA(I-1)=1.0$P 0
      GA(I)=1.0$P 1
      ELSEIF (MOD(KA,4).EQ.2) THEN
      GA(I+1)=A
      GA(I+2)=-A
      ELSEIF (MOD(KA,4).EQ.3) THEN
      C=X(I)-2.0$P 0*X(I+1)
      GA(I)=2.0$P 0*C
      GA(I+1)=-4.0$P 0*C
      ELSE
      C=X(I-1)-X(I+2)
      D=2.0$P 0*B*C
      GA(I-1)=D
      GA(I+2)=-D
      ENDIF
      RETURN
   40 I=2*((KA+4)/5)
      IF (MOD(KA,5).EQ.1) THEN
      A=EXP(X(I-1))
      B=A-X(I)
      C=2.0$P 0*B
      GA(I-1)=C*A
      GA(I)=-C
      ELSEIF (MOD(KA,5).EQ.2) THEN
      A=X(I)-X(I+1)
      B=3.0$P 1*A**2
      GA(I)=B
      GA(I+1)=-B
      ELSEIF (MOD(KA,5).EQ.3) THEN
      C=X(I+1)-X(I+2)
      Q=SIN(C)/COS(C)
      R=COS(C)
      D=2.0$P 0*Q/R**2
      GA(I+1)=D
      GA(I+2)=-D
      ELSEIF (MOD(KA,5).EQ.4) THEN
      GA(I-1)=4.0$P 0*X(I-1)**3
      ELSE
      GA(I+2)=1.0$P 0
      ENDIF
      RETURN
   50 I=KA
      GA(I)=3.0$P 0-4.0$P 0*X(I)
      IF (I.GT.1) GA(I-1)=-1.0$P 0
      IF (I.LT.N) GA(I+1)=-1.0$P 0
      RETURN
   60 I=KA
      DO 61 J=MAX(1,I-5),MIN(N,I+1)
      GA(J)=1.0$P 0+2.0$P 0*X(J)
   61 CONTINUE
      GA(I)=GA(I)+2.0$P 0+1.5$P 1*X(I)**2
      RETURN
   70 I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      GA(I)=1.0$P 0
      GA(I+1)=1.0$P 1*X(I+1)-3.0$P 0*X(I+1)**2-2.0$P 0
      ELSE
      GA(I)=1.0$P 0
      GA(I+1)=2.0$P 0*X(I+1)+3.0$P 0*X(I+1)**2-1.4$P 1
      ENDIF
      RETURN
   80 I=MOD(KA,N/2)+1
      J=I+N/2
      M=5*N
      IF (KA.LE.M/2) THEN
      IA=1
      ELSE
      IA=2
      ENDIF
      IB=5-KA/(M/4)
      IC=MOD(KA,5)+1
      A=$DBLE(IA)
      B=$DBLE(IB)
      C=$DBLE(IC)
      D=X(I)**IA-X(J)**IB
      IF (D.EQ.0.0$P 0) THEN
      GA(I)=0.0$P 0
      GA(J)=0.0$P 0
      ELSE
      E=C*D**(IC-1)
      IF (X(I).EQ.0.0$P 0.AND.IA.LE.1) THEN
      GA(I)=0.0$P 0
      ELSE
      GA(I)= E*A*X(I)**(IA-1)
      ENDIF
      IF (X(J).EQ.0.0$P 0.AND.IB.LE.1) THEN
      GA(J)=0.0$P 0
      ELSE
      GA(J)=-E*B*X(J)**(IB-1)
      ENDIF
      ENDIF
      RETURN
   90 I=2*((KA+5)/6)-1
      IF (MOD(KA,6).EQ.1) THEN
      GA(I)=1.0$P 0
      GA(I+1)=3.0$P 0*(X(I+2)-1.0$P 0)
      GA(I+2)=3.0$P 0*X(I+1)
      GA(I+3)=2.0$P 0*X(I+3)
      ELSEIF (MOD(KA,6).EQ.2) THEN
      GA(I)=2.0$P 0*(X(I)+X(I+1))
      GA(I+1)=2.0$P 0*(X(I)+X(I+1))
      GA(I+2)=2.0$P 0*(X(I+2)-1.0$P 0)
      GA(I+3)=-1.0$P 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      GA(I)=X(I+1)
      GA(I+1)=X(I)
      GA(I+2)=-X(I+3)
      GA(I+3)=-X(I+2)
      ELSEIF (MOD(KA,6).EQ.4) THEN
      GA(I)=2.0$P 0*X(I+2)
      GA(I+1)=X(I+3)
      GA(I+2)=2.0$P 0*X(I)
      GA(I+3)=X(I+1)
      ELSEIF (MOD(KA,6).EQ.5) THEN
      GA(I)=2.0$P 0*(X(I)+X(I+1)+X(I+2)+X(I+3))+2.0$P 0*(X(I)-1.0$P 0)
      GA(I+1)=2.0$P 0*(X(I)+X(I+1)+X(I+2)+X(I+3))
      GA(I+2)=2.0$P 0*(X(I)+X(I+1)+X(I+2)+X(I+3))
      GA(I+3)=2.0$P 0*(X(I)+X(I+1)+X(I+2)+X(I+3))
      ELSE
      GA(I)=X(I+1)*X(I+2)*X(I+3)
      GA(I+1)=X(I)*X(I+2)*X(I+3)
      GA(I+2)=X(I)*X(I+1)*X(I+3)
      GA(I+3)=X(I)*X(I+1)*X(I+2)+2.0$P 0*(X(I+3)-1.0$P 0)
      ENDIF
      RETURN
  100 IF (N.GE.2) THEN
      I=(KA+1)/2
      J=MOD(KA,2)
      IF (J.EQ.0) THEN
      GA(I)=-2.0$P 0*EXP(2.0$P 0*X(I))
      GA(I+1)=-2.0$P 0*EXP(2.0$P 0*X(I+1))
      ELSEIF (I.EQ.1) THEN
      GA(I)=-EXP(X(I))
      GA(I+1)=-EXP(X(I+1))
      ELSEIF (I.EQ.N) THEN
      GA(I-1)=-3.0$P 0*EXP(3.0$P 0*X(I-1))
      GA(I)=-3.0$P 0*EXP(3.0$P 0*X(I))
      ELSE
      GA(I-1)=-3.0$P 0*EXP(3.0$P 0*X(I-1))
      GA(I)=-3.0$P 0*EXP(3.0$P 0*X(I))-EXP(X(I))
      GA(I+1)=-EXP(X(I+1))
      ENDIF
      ENDIF
      RETURN
  110 I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      GA(I)=2.0$P 1*(1.0$P 0-X(I)**2)/(1.0$P 0+X(I)**2)**2
      GA(I+1)=-1.0$P 1
      ELSE
      GA(I)=1.0$P 0
      ENDIF
      RETURN
  120 I=3*((KA+5)/6)-2
      IF (MOD(KA,6).EQ.1) THEN
      GA(I)=2.0$P 1*X(I)
      GA(I+1)=-1.0$P 1
      ELSEIF (MOD(KA,6).EQ.2) THEN
      GA(I+2)=1.0$P 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      GA(I+3)=2.0$P 0*(X(I+3)-1.0$P 0)
      ELSEIF (MOD(KA,6).EQ.4) THEN
      GA(I+4)=3.0$P 0*(X(I+4)-1.0$P 0)**2
      ELSEIF (MOD(KA,6).EQ.5) THEN
      GA(I)=2.0$P 0*X(I)*X(I+3)
      GA(I+3)=X(I)**2+COS(X(I+3)-X(I+4))
      GA(I+4)=-COS(X(I+3)-X(I+4))
      ELSE
      GA(I+1)=1.0$P 0
      GA(I+2)=4.0$P 0*X(I+2)*(X(I+2)*X(I+3))**2
      GA(I+3)=2.0$P 0*X(I+2)**4*X(I+3)
      ENDIF
      RETURN
  130 I=3*((KA+6)/7)-2
      IF (MOD(KA,7).EQ.1) THEN
      GA(I)=2.0$P 1*X(I)
      GA(I+1)=-1.0$P 1
      ELSEIF (MOD(KA,7).EQ.2) THEN
      GA(I+1)=2.0$P 1*X(I+1)
      GA(I+2)=-1.0$P 1
      ELSEIF (MOD(KA,7).EQ.3) THEN
      GA(I+2)= 2.0$P 0*(X(I+2)-X(I+3))
      GA(I+3)=-2.0$P 0*(X(I+2)-X(I+3))
      ELSEIF (MOD(KA,7).EQ.4) THEN
      GA(I+3)= 2.0$P 0*(X(I+3)-X(I+4))
      GA(I+4)=-2.0$P 0*(X(I+3)-X(I+4))
      ELSEIF (MOD(KA,7).EQ.5) THEN
      GA(I)=1.0$P 0
      GA(I+1)=2.0$P 0*X(I+1)
      GA(I+2)=1.0$P 0
      ELSEIF (MOD(KA,7).EQ.6) THEN
      GA(I+1)=1.0$P 0
      GA(I+2)=-2.0$P 0*X(I+2)
      GA(I+3)=1.0$P 0
      ELSE
      GA(I)=X(I+4)
      GA(I+4)=X(I)
      ENDIF
      RETURN
  140 I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      DO 141 J=1,4
      GA(I+J)=0.0$P 0
  141 CONTINUE
      DO 144 K=1,3
      A=$DBLE(K*K)/$DBLE(L)
      DO 142 J=1,4
      A=A*SIGN(1.0$P 0,X(I+J))*ABS(X(I+J))**($DBLE(J)/$DBLE(K*L))
  142 CONTINUE
      DO 143 J=1,4
      GA(I+J)=GA(I+J)+($DBLE(J)/$DBLE(K*L))*A/X(I+J)
  143 CONTINUE
  144 CONTINUE
      RETURN
  150 I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      DO 151 J=1,4
      GA(I+J)=0.0$P 0
  151 CONTINUE
      DO 154 K=1,3
      A=0.0$P 0
      DO 152 J=1,4
      A=A+X(I+J)*($DBLE(J)/$DBLE(K*L))
  152 CONTINUE
      A=EXP(A)*$DBLE(K*K)/$DBLE(L)
      DO 153 J=1,4
      GA(I+J)=GA(I+J)+A*($DBLE(J)/$DBLE(K*L))
  153 CONTINUE
  154 CONTINUE
      RETURN
  160 I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      DO 161 J=1,4
      GA(I+J)=$DBLE((1-2*MOD(J,2))*L*J*J)*COS(X(I+J))-
     & $DBLE(L*L*J)*SIN(X(I+J))
  161 CONTINUE
      RETURN
  170 ALFA=0.5$P 0
      IF (KA.EQ.1) THEN
      GA(1)=-1.0$P 0-4.0$P 0*X(2)
      GA(2)=-4.0$P 0*X(1)
      GA(3)=ALFA-1.0$P 0
      ELSEIF(KA.EQ.2) THEN
      GA(1)=-4.0$P 0*X(2)
      GA(2)=-1.0$P 0-4.0$P 0*X(1)
      GA(4)=-2.0$P 0+ALFA
      ELSEIF(KA.EQ.N-1) THEN
      GA(N-3)=ALFA
      GA(N-1)=-1.0$P 0-4.0$P 0*X(N)
      GA(N)=-4.0$P 0*X(N-1)
      ELSEIF (KA.EQ.N) THEN
      GA(N-2)=ALFA
      GA(N-1)=-4.0$P 0*X(N)
      GA(N)=-1.0$P 0-4.0$P 0*X(N-1)
      ELSEIF (MOD(KA,2).EQ.1) THEN
      GA(KA-2)=ALFA
      GA(KA)=-1.0$P 0-4.0$P 0*X(KA+1)
      GA(KA+1)=-4.0$P 0*X(KA)
      GA(KA+2)=-1.0$P 0+ALFA
      ELSE
      GA(KA-2)=ALFA
      GA(KA-1)=-4.0$P 0*X(KA)
      GA(KA)=-1.0$P 0-4.0$P 0*X(KA-1)
      GA(KA+2)=-2.0$P 0+ALFA
      ENDIF
      RETURN
  180 IF (KA.LT.2) THEN
      GA(KA)=4.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)
      ELSE IF (KA.LT.N) THEN
      GA(KA-1)=-8.0$P 0*X(KA)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)
      ELSE
      GA(KA-1)=-8.0$P 0*X(KA)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+2.0$P 0
      ENDIF
      RETURN
  190 IF (KA.EQ.1) THEN
      GA(N-4)=3.0$P 0
      GA(N-3)=-1.0$P 0
      GA(N-2)=-1.0$P 0
      GA(N-1)=0.50$P 0
      GA(N)=-1.0$P 0
      GA(KA)=-4.0$P 0*X(KA)+3.0$P 0
      GA(KA+1)=-2.0$P 0
      ELSEIF (KA.LE.N-1) THEN
      GA(KA-1)=0.0$P 0
      GA(KA)=0.0$P 0
      GA(KA+1)=0.0$P 0
      GA(N-4)=3.0$P 0
      GA(N-3)=-1.0$P 0
      GA(N-2)=-1.0$P 0
      GA(N-1)=0.50$P 0
      GA(N)=-1.0$P 0
      GA(KA-1)=GA(KA-1)-1.0$P 0
      GA(KA)=GA(KA)-4.0$P 0*X(KA)+3.0$P 0
      GA(KA+1)=GA(KA+1)-2.0$P 0
      ELSE
      GA(N-4)=3.0$P 0
      GA(N-3)=-1.0$P 0
      GA(N-2)=-1.0$P 0
      GA(N-1)=-0.5$P 0
      GA(N)=-4.0$P 0*X(N)+2.0$P 0
      ENDIF
      RETURN
  200 U=1.0$P 0/$DBLE(N+1)
      V=$DBLE(KA)*U
      GA(KA)=2.0$P 0+1.5$P 0*U**2*(X(KA)+V+1.0$P 0)**2
      IF(KA.GT.1) GA(KA-1)=-1.0$P 0
      IF(KA.LT.N) GA(KA+1)=-1.0$P 0
      RETURN
  210 I=3*((KA+6)/7)-2
      IF (MOD(KA,7).EQ.1) THEN
      GA(I)=2.0$P 1*X(I)
      GA(I+1)=-1.0$P 1
      ELSEIF (MOD(KA,7).EQ.2) THEN
      GA(I+1)=1.0$P 0
      GA(I+2)=1.0$P 0
      ELSEIF (MOD(KA,7).EQ.3) THEN
      GA(I+3)=1.0$P 0
      ELSEIF (MOD(KA,7).EQ.4) THEN
      GA(I+4)=1.0$P 0
      ELSEIF (MOD(KA,7).EQ.5) THEN
      GA(I)=1.0$P 0
      GA(I+1)=3.0$P 0
      ELSEIF (MOD(KA,7).EQ.6) THEN
      GA(I+2)=1.0$P 0
      GA(I+3)=1.0$P 0
      GA(I+4)=-2.0$P 0
      ELSE
      GA(I+1)=2.0$P 1*X(I+1)
      GA(I+4)=-1.0$P 1
      ENDIF
      RETURN
  220 I=KA/2
      IF (KA.EQ.1) THEN
      GA(KA)=1.0$P 0
      ELSE IF (MOD(KA,2).EQ.0) THEN
      GA(I)=2.0$P 1*X(I)
      GA(I+1)=-1.0$P 1
      ELSE
      A=2.0$P 0*EXP(-(X(I)-X(I+1))**2)
      B=EXP(-2.0$P 0*(X(I+1)-X(I+2))**2)
      GA(I)= -2.0$P 0*(X(I)-X(I+1))*A
      GA(I+1)=2.0$P 0*(X(I)-X(I+1))*A-4.0$P 0*(X(I+1)-X(I+2))*B
      GA(I+2)=4.0$P 0*(X(I+1)-X(I+2))*B
      ENDIF
      RETURN
  230 A1=0.414214$P 0
      IF (KA.EQ.1) THEN
      GA(1)=1.0$P 0+X(3)
      GA(2)=-4.0$P 0*A1
      GA(3)=-1.0$P 0+X(1)
      ELSEIF (KA.EQ.2) THEN
      GA(1)=X(4)
      GA(2)=-4.0$P 0*A1
      GA(4)=-1.0$P 0+X(1)
      ELSEIF (KA.EQ.3) THEN
      GA(1)=A1+X(5)
      GA(2)=-4.0$P 0*X(3)
      GA(3)=-1.0$P 0-4.0$P 0*X(2)
      GA(5)=-1.0$P 0+X(1)
      ELSEIF (KA.LE.N-2) THEN
      GA(1)= X(KA-2)+X(KA+2)
      GA(KA-2)=X(1)
      GA(KA-1)=-4.0$P 0*X(KA)
      GA(KA)=-1.0$P 0-4.0$P 0*X(KA-1)
      GA(KA+2)=-1.0$P 0+X(1)
      ELSEIF (KA.EQ.N-1) THEN
      GA(1)= X(N-3)
      GA(N-3)=X(1)
      GA(N-2)=-4.0$P 0*X(N-1)
      GA(N-1)=-1.0$P 0-4.0$P 0*X(N-2)
      ELSE
      GA(1)= X(N-2)+1.0$P 0
      GA(N-2)=X(1)
      GA(N-1)=-4.0$P 0*X(N)
      GA(N)=-1.0$P 0-4.0$P 0*X(N-1)
      ENDIF
      RETURN
  240 J=(KA-1)/5
      GA(KA)=-$DBLE(J+1)*SIN(X(KA))-COS(X(KA))
      J=J*5
      DO 241 I=J+1,J+5
      IF (I.EQ.KA) THEN
      GA(I)=GA(I)+SIN(X(I))
      ELSE
      GA(I)=SIN(X(I))
      ENDIF
  241 CONTINUE
      RETURN
  250 IF (KA.LT.2) THEN
      D1S=COS(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))
      D2S=SIN(X(KA)-X(KA+1))*COS(X(KA)+X(KA+1))
      GA(KA)=9.0$P 0*X(KA)**2+D1S+D2S
      GA(KA+1)=2.0$P 0-D1S+D2S
      ELSE IF (KA.LT.N) THEN
      D1S=COS(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))
      D2S=SIN(X(KA)-X(KA+1))*COS(X(KA)+X(KA+1))
      EX=EXP(X(KA-1)-X(KA))
      GA(KA-1)=-EX-X(KA-1)*EX
      GA(KA)=9.0$P 0*X(KA)**2+D1S+D2S+4.0$P 0+X(KA-1)*EX
      GA(KA+1)=2.0$P 0-D1S+D2S
      ELSE
      EX=EXP(X(KA-1)-X(KA))
      GA(KA-1)=-EX-X(KA-1)*EX
      GA(KA)=4.0$P 0+X(KA-1)*EX
      ENDIF
      RETURN
  260 IF (MOD(KA,2).EQ.1) THEN
      GA(KA)=0.0$P 0
      IF (KA.NE.1) THEN
      D1S=COS(X(KA-2)-X(KA-1)-X(KA))*SIN(X(KA-2)+X(KA-1)-X(KA))
      D2S=SIN(X(KA-2)-X(KA-1)-X(KA))*COS(X(KA-2)+X(KA-1)-X(KA))
      GA(KA-2)=-18.0$P 0*(X(KA-2)-X(KA))**2-2.0$P 0*(D1S+D2S)
      GA(KA-1)=-4.0$P 0+2.0$P 0*(D1S-D2S)
      GA(KA)=GA(KA)+18.0$P 0*(X(KA-2)-X(KA))**2+2.0$P 0*(D1S+D2S)
      ENDIF
      IF (KA.NE.N) THEN
      D1S=COS(X(KA)-X(KA+1)-X(KA+2))*SIN(X(KA)+X(KA+1)-X(KA+2))
      D2S=SIN(X(KA)-X(KA+1)-X(KA+2))*COS(X(KA)+X(KA+1)-X(KA+2))
      GA(KA)=GA(KA)+9.0$P 0*(X(KA)-X(KA+2))**2+D1S+D2S
      GA(KA+1)=2.0$P 0-D1S+D2S
      GA(KA+2)=-9.0$P 0*(X(KA)-X(KA+2))**2-D1S-D2S
      ENDIF
      ELSE
      EX=EXP(X(KA-1)-X(KA)-X(KA+1))
      W=X(KA-1)-X(KA+1)
      GA(KA-1)=-EX-W*EX
      GA(KA)=4.0$P 0+W*EX
      GA(KA+1)=EX+W*EX
      ENDIF
      RETURN
  270 H=2.0$P 0
      IF (KA.EQ.1) THEN
      GA(1)=2.0$P 0*((3.0$P 0-H*X(1))*X(1)-2.0$P 0*X(2)+1.0$P 0)*
     & (3.0$P 0-2.0$P 0*H*X(1))
      GA(2)=-4.0$P 0*((3.0$P 0-H*X(1))*X(1)-2.0$P 0*X(2)+1.0$P 0)
      ELSE IF (KA.LE.N-1) THEN
      GA(KA-1)=-2.0$P 0*
     & ((3.0$P 0-H*X(KA))*X(KA)-X(KA-1)-2.0$P 0*X(KA+1)+1.0$P 0)
      GA(KA)=2.0$P 0*
     & ((3.0$P 0-H*X(KA))*X(KA)-X(KA-1)-2.0$P 0*X(KA+1)+1.0$P 0)*
     & (3.0$P 0-2.0$P 0*H*X(KA))
      GA(KA+1)=-4.0$P 0*
     & ((3.0$P 0-H*X(KA))*X(KA)-X(KA-1)-2.0$P 0*X(KA+1)+1.0$P 0)
      ELSE
      GA(N-1)=-2.0$P 0*((3.0$P 0-H*X(N))*X(N)-X(N-1)+1.0$P 0)
      GA(N)=2.0$P 0*
     & ((3.0$P 0-H*X(N))*X(N)-X(N-1)+1.0$P 0)*
     & (3.0$P 0-2.0$P 0*H*X(N))
      ENDIF
      RETURN
  280 IF (KA.LT.2) THEN
      GA(KA)=4.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)
      ELSE IF (KA.LT.3) THEN
      GA(KA-1)=-8.0$P 0*X(KA)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)
      ELSE IF (KA.LT.N-1) THEN
      GA(KA-2)=-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)
      ELSE IF (KA.LT.N) THEN
      GA(KA-2)=-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)
      ELSE
      GA(KA-2)=-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+2.0$P 0
      ENDIF
      RETURN
  290 IF (KA.LT.2) THEN
      GA(KA)=4.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.3) THEN
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.4) THEN
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.N-2) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.N-1) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      ELSE IF (KA.LT.N) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      ELSE
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+2.0$P 0
      ENDIF
      RETURN
  310 IF(MOD(KA,2).EQ.1) THEN
      GA(KA)=1.0$P 0
      GA(KA+1)=10.0$P 0*X(KA+1)-3.0$P 0*X(KA+1)**2-2.0$P 0
      ELSE
      GA(KA-1)=1.0$P 0
      GA(KA)=3.0$P 0*X(KA)**2+2.0$P 0*X(KA)-1.4$P 1
      ENDIF
      RETURN
  340 IF (KA.LT.2) THEN
      GA(KA)=X(KA)-3.0$P 0
      GA(KA+1)=2.0$P 0
      ELSE IF (KA.LT.N) THEN
      GA(KA-1)=1.0$P 0
      GA(KA)=X(KA)-3.0$P 0
      GA(KA+1)=2.0$P 0
      ELSE
      GA(KA-1)=1.0$P 0
      GA(KA)=X(KA)-3.0$P 0
      ENDIF
      RETURN
  360 IF(MOD(KA,2).EQ.1) THEN
      GA(KA)=1.0$P 4*X(KA+1)
      GA(KA+1)=1.0$P 4*X(KA)
      ELSE
      GA(KA-1)=-EXP(-X(KA-1))
      GA(KA)=-EXP(-X(KA))
      ENDIF
      RETURN
  370 IF(MOD(KA,4).EQ.1) THEN
      GA(KA)=-2.0$P 2*(X(KA+1)-3.0$P 0*X(KA)**2)+1.0$P 0
      GA(KA+1)=-2.0$P 2*X(KA)
      ELSE IF(MOD(KA,4).EQ.2) THEN
      GA(KA-1)=-4.0$P 2*X(KA-1)
      GA(KA)=2.202$P 2
      GA(KA+2)=1.98$P 1
      ELSE IF(MOD(KA,4).EQ.3) THEN
      GA(KA)=-1.8$P 2*(X(KA+1)-3.0$P 0*X(KA)**2)+1.0$P 0
      GA(KA+1)=-1.8$P 2*X(KA)
      ELSE
      GA(KA-2)=1.98$P 1
      GA(KA-1)=-3.6$P 2*X(KA-1)
      GA(KA)=2.002$P 2
      ENDIF
      RETURN
  380 IF (KA.LT.2) THEN
      GA(KA+1)=EXP(COS($DBLE(KA)*(X(KA)+X(KA+1))))*
     & $DBLE(KA)*SIN($DBLE(KA)*(X(KA)+X(KA+1)))
      GA(KA)=GA(KA+1)+1.0$P 0
      ELSEIF (KA.LT.N) THEN
      GA(KA-1)=EXP(COS($DBLE(KA)*(X(KA-1)+X(KA)+X(KA+1))))*
     & SIN($DBLE(KA)*(X(KA-1)+X(KA)+X(KA+1)))*$DBLE(KA)
      GA(KA+1)=GA(KA-1)
      GA(KA)=1.0$P 0+GA(KA-1)
      ELSE
      GA(KA-1)=EXP(COS($DBLE(KA)*(X(KA-1)+X(KA))))*
     & SIN($DBLE(KA)*(X(KA-1)+X(KA)))*$DBLE(KA)
      GA(KA)=1.0$P 0+GA(KA-1)
      ENDIF
      RETURN
  390 U=1.0$P 0/$DBLE(N+1)
      V=$DBLE(KA)*U
      GA(KA)=2.0$P 0+1.5$P 0*U**2*(X(KA)+V+1.0$P 0)**2
      IF(KA.GT.1) GA(KA-1)=-1.0$P 0
      IF(KA.LT.N) GA(KA+1)=-1.0$P 0
      RETURN
  400 IF(KA.EQ.1) THEN
      GA(KA)=3.0$P 0*(X(KA+1)-4.0$P 0*X(KA))
      GA(KA+1)=3.0$P 0*X(KA)+0.5$P 0*X(KA+1)
      ELSEIF(KA.EQ.N) THEN
      GA(KA-1)=3.0$P 0*X(KA)-0.5$P 0*(2.0$P 1-X(KA-1))
      GA(KA)=3.0$P 0*(2.0$P 1-4.0$P 0*X(KA)+X(KA-1))
      ELSE
      GA(KA-1)=3.0$P 0*X(KA)-0.5$P 0*(X(KA+1)-X(KA-1))
      GA(KA)=3.0$P 0*(X(KA+1)-4.0$P 0*X(KA)+X(KA-1))
      GA(KA+1)=3.0$P 0*X(KA)+0.5$P 0*(X(KA+1)-X(KA-1))
      ENDIF
      RETURN
  410 H=1.0$P 0/$DBLE(N+1)
      IF (KA.LT.2) THEN
      GA(KA)=2.0$P 0+PAR**2*H**2*COSH(PAR*X(KA))
      GA(KA+1)=-1.0$P 0
      ELSE IF (KA.LT.N) THEN
      GA(KA-1)=-1.0$P 0
      GA(KA)=2.0$P 0+PAR**2*H**2*COSH(PAR*X(KA))
      GA(KA+1)=-1.0$P 0
      ELSE
      GA(KA)=2.0$P 0+PAR**2*H**2*COSH(PAR*X(KA))
      GA(KA-1)=-1.0$P 0
      ENDIF
      RETURN
  420 GA(KA)=6.0$P 0
C      FA=6.0$P 0*X(KA)
      A1=0.0$P 0
      A2=0.0$P 0
      A3=0.0$P 0
      GA1(1)=0.0$P 0
      GA1(2)=0.0$P 0
      GA2(1)=0.0$P 0
      GA2(2)=0.0$P 0
      IF (KA.GT.1) THEN
      GA(KA-1)=-4.0$P 0+PAR*X(KA)
      A1=A1-X(KA-1)
      A2=A2+X(KA-1)
      A3=A3+2.0$P 0*X(KA-1)
      GA1(1)=-1.0$P 0
      GA2(1)= 1.0$P 0
      ENDIF
      IF (KA.GT.2) THEN
      GA(KA-2)=1.0$P 0-0.5$P 0*PAR*X(KA)
      A3=A3-X(KA-2)
      ENDIF
      IF (KA.LT.N-1) THEN
      GA(KA+2)=1.0$P 0+0.5$P 0*PAR*X(KA)
      A3=A3+X(KA+2)
      ENDIF
      IF (KA.LT.N) THEN
      GA(KA+1)=-4.0$P 0-PAR*X(KA)
      A1=A1+X(KA+1)
      A2=A2+X(KA+1)
      A3=A3-2.0$P 0*X(KA+1)
      GA1(2)= 1.0$P 0
      GA2(2)= 1.0$P 0
      ENDIF
      IF (KA.GE.N-1) THEN
      A3=A3+1.0$P 0
      ENDIF
      IF (KA.GE.N) THEN
      A1=A1+1.0$P 0
      A2=A2+1.0$P 0
      A3=A3-2.0$P 0
      ENDIF
      GA(KA)=GA(KA)+0.5$P 0*PAR*A3
      IF (KA.GT.1)
     & GA(KA-1)=GA(KA-1)-0.5$P 0*PAR*(GA1(1)*A2+A1*GA2(1))
      IF (KA.LT.N)
     & GA(KA+1)=GA(KA+1)-0.5$P 0*PAR*(GA1(2)*A2+A1*GA2(2))
      RETURN
  430 H=1.0$P 0/(M+1)
      IF(KA.LE.M) THEN
      J=KA+M
      GA(KA)=6.0$P 0
      GA(J)=0.0$P 0
      A1=0.0$P 0
      A2=0.0$P 0
      IF (KA.EQ.1) THEN
      A1=A1+1.0$P 0
      ENDIF
      IF (KA.GT.1) THEN
      A1=A1-X(J-1)
      A2=A2+2.0$P 0*X(KA-1)
      GA(KA-1)=-4.0$P 0+PAR*H*X(KA)
      GA(J-1)=-0.5$P 0*PAR*H**3*X(J)
      ENDIF
      IF (KA.GT.2) THEN
      A2=A2-X(KA-2)
      GA(KA-2)=1.0$P 0-0.5$P 0*PAR*H*X(KA)
      ENDIF
      IF (KA.LT.M-1) THEN
      A2=A2+X(KA+2)
      GA(KA+2)=1.0$P 0+0.5$P 0*PAR*H*X(KA)
      ENDIF
      IF (KA.LT.M) THEN
      A1=A1+X(J+1)
      A2=A2-2.0$P 0*X(KA+1)
      GA(KA+1)=-4.0$P 0-PAR*H*X(KA)
      GA(J+1)= 0.5$P 0*PAR*H**3*X(J)
      ENDIF
      IF (KA.EQ.M) THEN
      A1=A1+1.0$P 0
      ENDIF
      GA(KA)=GA(KA)+0.5$P 0*PAR*H*A2
      GA(J)=GA(J)+0.5$P 0*PAR*H**3*A1
      ELSE
      J=KA-M
      GA(KA)=-2.0$P 0
      GA(J)=0.0$P 0
      A1=0.0$P 0
      A2=0.0$P 0
      IF (J.EQ.1) THEN
      A2=A2+1.0$P 0
      ENDIF
      IF (J.GT.1) THEN
      A1=A1-X(J-1)
      A2=A2-X(KA-1)
      GA(KA-1)=1.0$P 0-0.5$P 0*PAR*H*X(J)
      GA(J-1)=-0.5$P 0*PAR*H*X(KA)
      ENDIF
      IF (J.LT.M) THEN
      A1=A1+X(J+1)
      A2=A2+X(KA+1)
      GA(KA+1)=1.0$P 0+0.5$P 0*PAR*H*X(J)
      GA(J+1)= 0.5$P 0*PAR*H*X(KA)
      ENDIF
      IF (J.EQ.M) THEN
      A2=A2+1.0$P 0
      ENDIF
      GA(KA)=GA(KA)+0.5$P 0*PAR*H*A1
      GA(J)=GA(J)+0.5$P 0*PAR*H*A2
      ENDIF
      RETURN
  440 GA(KA)=4.0$P 0-PAR*EXP(X(KA))
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      IF(J.GT.1) GA(KA-M)=-1.0$P 0
      IF(I.GT.1) GA(KA-1)=-1.0$P 0
      IF(I.LT.M) GA(KA+1)=-1.0$P 0
      IF(J.LT.M) GA(KA+M)=-1.0$P 0
      RETURN
  450 GA(KA)=4.0$P 0
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      GA(KA)=GA(KA)+3.0$P 0*PAR*X(KA)**2/(1.0$P 0+PAR*$DBLE(I)**2+
     & PAR*$DBLE(J)**2)
      IF(I.GT.1) GA(KA-1)=-1.0$P 0
      IF(I.LT.M) GA(KA+1)=-1.0$P 0
      IF(J.GT.1) GA(KA-M)=-1.0$P 0
      IF(J.LT.M) GA(KA+M)=-1.0$P 0
      RETURN
  460 GA(KA)=4.0$P 0-2.0$P 0*PI*PAR*COS(2.0$P 0*PI*X(KA))
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      A1=DBLE(I)/DBLE(M+1)
      A2=DBLE(J)/DBLE(M+1)
      IF(I.EQ.1) GA(KA+1)=-1.0$P 0-PI*DBLE(M+1)*PAR*COS(PI*X(KA+1)*
     & DBLE(M+1))
      IF(I.GT.1.AND.I.LT.M) THEN
      GA(KA-1)=-1.0$P 0+PI*DBLE(M+1)*PAR*COS(PI*(X(KA+1)-X(KA-1))*
     & DBLE(M+1))
      GA(KA+1)=-1.0$P 0-PI*DBLE(M+1)*PAR*COS(PI*(X(KA+1)-X(KA-1))*
     & DBLE(M+1))
      ENDIF
      IF(I.EQ.M) GA(KA-1)=-1.0$P 0+PI*DBLE(M+1)*PAR*COS(PI*X(KA-1)*
     & DBLE(M+1))
      IF(J.EQ.1) GA(KA+M)=-1.0$P 0-PI*DBLE(M+1)*PAR*COS(PI*X(KA+M)*
     & DBLE(M+1))
      IF(J.GT.1.AND.J.LT.M) THEN
      GA(KA-M)=-1.0$P 0+PI*DBLE(M+1)*PAR*COS(PI*(X(KA+M)-X(KA-M))*
     & DBLE(M+1))
      GA(KA+M)=-1.0$P 0-PI*DBLE(M+1)*PAR*COS(PI*(X(KA+M)-X(KA-M))*
     & DBLE(M+1))
      ENDIF
      IF(J.EQ.M) GA(KA-M)=-1.0$P 0+PI*DBLE(M+1)*PAR*COS(PI*X(KA-M)*
     & DBLE(M+1))
      RETURN
  470 GA(KA)=1.6$P 1*X(KA)
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      IF(I.EQ.1) THEN
      GA(KA)=GA(KA)-2.0$P 0*(X(KA+1)+1.0$P 0)-3.0$P 0*X(KA)*
     & (X(KA+1)-1.0$P 0)*PAR
      GA(KA+1)=-2.0$P 0*X(KA)-(X(KA+1)-1.0$P 0)-1.5$P 0*X(KA)**2*PAR
      ENDIF
      IF(I.GT.1.AND.I.LT.M) THEN
      GA(KA)=GA(KA)-2.0$P 0*(X(KA+1)+X(KA-1))-3.0$P 0*X(KA)*
     & (X(KA+1)-X(KA-1))*PAR
      GA(KA-1)=-2.0$P 0*X(KA)+(X(KA+1)-X(KA-1))+1.5$P 0*X(KA)**2*PAR
      GA(KA+1)=-2.0$P 0*X(KA)-(X(KA+1)-X(KA-1))-1.5$P 0*X(KA)**2*PAR
      ENDIF
      IF(I.EQ.M) THEN
      GA(KA)=GA(KA)-2.0$P 0*X(KA-1)+3.0$P 0*X(KA)*X(KA-1)*PAR
      GA(KA-1)=-2.0$P 0*X(KA)-X(KA-1)+1.5$P 0*X(KA)**2*PAR
      ENDIF
      IF(J.EQ.1) THEN
      GA(KA)=GA(KA)-2.0$P 0*(X(KA+M)+1.0$P 0)
      GA(KA+M)=-2.0$P 0*X(KA)-(X(KA+M)-1.0$P 0)
      ENDIF
      IF(J.GT.1.AND.J.LT.M) THEN
      GA(KA)=GA(KA)-2.0$P 0*(X(KA+M)+X(KA-M))
      GA(KA-M)=-2.0$P 0*X(KA)+(X(KA+M)-X(KA-M))
      GA(KA+M)=-2.0$P 0*X(KA)-(X(KA+M)-X(KA-M))
      ENDIF
      IF(J.EQ.M) THEN
      GA(KA)=GA(KA)-2.0$P 0*X(KA-M)
      GA(KA-M)=-2.0$P 0*X(KA)-X(KA-M)
      ENDIF
      RETURN
  480 GA(KA)=4.0$P 0
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      A1=PAR*DBLE(I)
      A2=PAR*DBLE(J)
      A3=0.0$P 0
      IF(I.GT.1) THEN
      GA(KA-1)=-1.0$P 0-2.0$P 1*PAR*X(KA)
      A3=A3-X(KA-1)
      ENDIF
      IF(I.LT.M) THEN
      GA(KA+1)=-1.0$P 0+2.0$P 1*PAR*X(KA)
      A3=A3+X(KA+1)
      ENDIF
      IF(J.GT.1) THEN
      GA(KA-M)=-1.0$P 0-2.0$P 1*PAR*X(KA)
      A3=A3-X(KA-M)
      ENDIF
      IF(J.LT.M) THEN
      GA(KA+M)=-1.0$P 0+2.0$P 1*PAR*X(KA)
      A3=A3+X(KA+M)
      ENDIF
      GA(KA)=GA(KA)+2.0$P 1*PAR*A3
      RETURN
  490 GA(KA)=2.0$P 1-PAR
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      IF (J.GT.2) THEN
        GA(KA-M-M)=1.0$P 0
      ENDIF
      IF (J.GT.1) THEN
        IF (I.GT.1) THEN
          GA(KA-M-1)=2.0$P 0
        ENDIF
        GA(KA-M)=-8.0$P 0
        IF (I.LT.M) THEN
          GA(KA-M+1)=2.0$P 0
        ENDIF
      ENDIF
      IF (I.GT.1) THEN
        IF (I.GT.2) THEN
          GA(KA-2)=1.0$P 0
        ENDIF
        GA(KA-1)=-8.0$P 0
      ENDIF
      IF (I.LT.M) THEN
        GA(KA+1)=-8.0$P 0
        IF (I.LT.M-1) THEN
          GA(KA+2)=1.0$P 0
        ENDIF
      ENDIF
      IF (J.LT.M) THEN
        IF (I.GT.1) THEN
          GA(KA+M-1)=2.0$P 0
        ENDIF
        GA(KA+M)=-8.0$P 0
        IF (I.LT.M) THEN
          GA(KA+M+1)=2.0$P 0
        ENDIF
      ENDIF
      IF (J.LT.M-1) THEN
        GA(KA+M+M)=1.0$P 0
      ENDIF
      RETURN
  500 H=0.5$P 0/$DBLE(M+2)
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      GA(KA)=2.0$P 1
      A1=0.0$P 0
      A2=0.0$P 0
      A3=0.0$P 0
      A4=0.0$P 0
      GA1(1)=0.0$P 0
      GA1(2)=0.0$P 0
      GA2(1)=0.0$P 0
      GA2(2)=0.0$P 0
      DO 501 K=1,6
      GA3(K)=0.0$P 0
      GA4(K)=0.0$P 0
  501 CONTINUE
      IF (J.GT.2) THEN
        GA(KA-M-M)=1.0$P 0
        GA4(1)=GA4(1)+1.0$P 0
        A4=A4+X(KA-M-M)
      ENDIF
      IF (J.GT.1) THEN
        IF (I.GT.1) THEN
          GA(KA-M-1)=2.0$P 0
          GA3(1)=GA3(1)+1.0$P 0
          GA4(2)=GA4(2)+1.0$P 0
          A3=A3+X(KA-M-1)
          A4=A4+X(KA-M-1)
        ENDIF
        GA(KA-M)=-8.0$P 0
        GA1(1)=GA1(1)-1.0$P 0
        A1=A1-X(KA-M)
        IF (I.LT.M) THEN
          GA(KA-M+1)=2.0$P 0
          GA3(2)=GA3(2)-1.0$P 0
          GA4(3)=GA4(3)+1.0$P 0
          A3=A3-X(KA-M+1)
          A4=A4+X(KA-M+1)
        ENDIF
      ENDIF
      IF (I.GT.1) THEN
        IF (I.GT.2) THEN
          GA(KA-2)=1.0$P 0
          GA3(3)=GA3(3)+1.0$P 0
          A3=A3+X(KA-2)
        ENDIF
        GA(KA-1)=-8.0$P 0
        GA2(1)=GA2(1)-1.0$P 0
        A2=A2-X(KA-1)
      ENDIF
      IF (I.LT.M) THEN
        GA(KA+1)=-8.0$P 0
        GA2(2)=GA2(2)+1.0$P 0
        A2=A2+X(KA+1)
        IF (I.LT.M-1) THEN
          GA(KA+2)=1.0$P 0
          GA3(4)=GA3(4)-1.0$P 0
          A3=A3-X(KA+2)
        ENDIF
      ENDIF
      IF (J.LT.M) THEN
        IF (I.GT.1) THEN
          GA(KA+M-1)=2.0$P 0
          GA3(5)=GA3(5)+1.0$P 0
          GA4(4)=GA4(4)-1.0$P 0
          A3=A3+X(KA+M-1)
          A4=A4-X(KA+M-1)
        ENDIF
        GA(KA+M)=-8.0$P 0
        GA1(2)=GA1(2)+1.0$P 0
        A1=A1+X(KA+M)
        IF (I.LT.M) THEN
          GA(KA+M+1)=2.0$P 0
          GA3(6)=GA3(6)-1.0$P 0
          GA4(5)=GA4(5)-1.0$P 0
          A3=A3-X(KA+M+1)
          A4=A4-X(KA+M+1)
        ENDIF
      ENDIF
      IF (J.LT.M-1) THEN
        GA(KA+M+M)=1.0$P 0
        GA4(6)=GA4(6)-1.0$P 0
        A4=A4-X(KA+M+M)
      ENDIF
      IF (J.EQ.M) THEN
        IF (I.GT.1) THEN
          A3=A3-H
          A4=A4+H
        ENDIF
        A1=A1-H
        IF (I.LT.M) THEN
          A3=A3+H
          A4=A4+H
        ENDIF
        A4=A4-H
      ENDIF
      IF (J.EQ.M-1) THEN
        A4=A4+H
      ENDIF
      IF (KA.GT.M+M)
     & GA(KA-M-M)=GA(KA-M-M)+0.25$P 0*PAR*(-A2*GA4(1))
      IF (KA.GT.M+1)
     & GA(KA-M-1)=GA(KA-M-1)+0.25$P 0*PAR*(+A1*GA3(1)-A2*GA4(2))
      IF (KA.GT.M)
     & GA(KA-M)=GA(KA-M)+0.25$P 0*PAR*(GA1(1)*A3)
      IF (KA.GT.M-1)
     & GA(KA-M+1)=GA(KA-M+1)+0.25$P 0*PAR*(+A1*GA3(2)-A2*GA4(3))
      IF (KA.GT.2)
     & GA(KA-2)=GA(KA-2)+0.25$P 0*PAR*(+A1*GA3(3))
      IF (KA.GT.1)
     & GA(KA-1)=GA(KA-1)+0.25$P 0*PAR*(-GA2(1)*A4)
      IF (KA.LE.N-1)
     & GA(KA+1)=GA(KA+1)+0.25$P 0*PAR*(-GA2(2)*A4)
      IF (KA.LE.N-2)
     & GA(KA+2)=GA(KA+2)+0.25$P 0*PAR*(+A1*GA3(4))
      IF (KA.LE.N-M+1)
     & GA(KA+M-1)=GA(KA+M-1)+0.25$P 0*PAR*(+A1*GA3(5)-A2*GA4(4))
      IF (KA.LE.N-M)
     & GA(KA+M)=GA(KA+M)+0.25$P 0*PAR*(GA1(2)*A3)
      IF (KA.LE.N-M-1)
     & GA(KA+M+1)=GA(KA+M+1)+0.25$P 0*PAR*(+A1*GA3(6)-A2*GA4(5))
      IF (KA.LE.N-M-M)
     & GA(KA+M+M)=GA(KA+M+M)+0.25$P 0*PAR*(-A2*GA4(6))
      RETURN
  510 H=1.0$P 0/$DBLE(N+1)
      A1=$DBLE(KA)*H
      A2=(A1-0.5$P 0)**2
      IF (A1.GE.0.5$P 0) THEN
      A3= 1.0$P 6
      ELSE
      A3=-1.0$P 6
      ENDIF
      IF (KA.LT.2) THEN
      GA(KA)=2.0$P 0+
     & H**2*(3.0$P 0*X(KA)**2*EXP(X(KA))+X(KA)**3*EXP(X(KA)))
      GA(KA+1)=-1.0$P 0+
     & H**2*5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))
      ELSEIF (KA.LT.N) THEN
      GA(KA-1)=-1.0$P 0-
     & H**2*5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))
      GA(KA)=2.0$P 0+
     & H**2*(3.0$P 0*X(KA)**2*EXP(X(KA))+X(KA)**3*EXP(X(KA)))
      GA(KA+1)=-1.0$P 0+
     & H**2*5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))
      ELSE
      GA(KA-1)=-1.0$P 0+
     & H**2*5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))
      GA(KA)=2.0$P 0+
     & H**2*(3.0$P 0*X(KA)**2*EXP(X(KA))+X(KA)**3*EXP(X(KA)))
      ENDIF
      RETURN
  520 H=1.0$P 0/DBLE(N+1)
      A1=DBLE(KA)*H
      A2=(A1-0.5$P 0)**2
      IF (KA.LT.2) THEN
      GA(KA+1)=-1.0$P 0
      GA(KA)=2.0$P 0+H**2*(3*X(KA)**2+2.0$P-4*(2.0$P-4*A2-1.0$P 0))
      ELSEIF (KA.LT.N) THEN
      GA(KA-1)=-1.0$P 0
      GA(KA)=2.0$P 0+H**2*(3*X(KA)**2+2.0$P-4*(2.0$P-4*A2-1.0$P 0))
      GA(KA+1)=-1.0$P 0
      ELSE
      GA(KA-1)=-1.0$P 0
      GA(KA)=2.0$P 0+H**2*(3*X(KA)**2+2.0$P-4*(2.0$P-4*A2-1.0$P 0))
      ENDIF
      RETURN
  530 IF (KA.EQ.1) THEN
      GA(1)=-1.0D 0
      ELSE
      GA(KA)=20.0D 0*DBLE(KA-1)*(X(KA)-X(KA-1))
      GA(KA-1)=-20.0D 0*DBLE(KA-1)*(X(KA)-X(KA-1))
      ENDIF
      RETURN
  540 IF (KA.EQ.N) THEN
      GA(1)=-0.20D 0*X(1)
      GA(N)=1.0D 0
      ELSE
      GA(KA)=1.0D 0
      GA(KA+1)=-0.2D 0*X(KA+1)
      ENDIF
      RETURN
  550 S=(1.0D 0/DBLE(N+1))**2*EXP(X(KA))
      IF (N.EQ.1) THEN
      GA(KA)=-(2.0D 0+S)
      ELSE IF (KA.EQ.1) THEN
      GA(KA)=-(2.0D 0+S)
      GA(KA+1)=1.0D 0
      ELSE IF (KA.EQ.N) THEN
      GA(KA)=-(2.0D 0+S)
      GA(KA-1)=1.0D 0
      ELSE
      GA(KA)=-(2.0D 0+S)
      GA(KA-1)=1.0D 0
      GA(KA+1)=1.0D 0
      ENDIF
      RETURN
  560 S=0.1D 0
      IF (N.EQ.1) THEN
      GA(KA)=3.0D 0-2.0D 0*S*X(KA)
      ELSE IF (KA.EQ.1) THEN
      GA(KA)=3.0D 0-2.0D 0*S*X(KA)
      GA(KA+1)=-2.0D 0
      ELSE IF (KA.EQ.N) THEN
      GA(KA)=3.0D 0-2.0D 0*S*X(KA)
      GA(KA-1)=-1.0D 0
      ELSE
      GA(KA)=3.0D 0-2.0D 0*S*X(KA)
      GA(KA-1)=-1.0D 0
      GA(KA+1)=-2.0D 0
      ENDIF
      RETURN
  570 S1=1.0D 0
      S2=1.0D 0
      S3=1.0D 0
      J1=3
      J2=3
      IF (KA-J1.GT.1) THEN
      I1=KA-J1
      ELSE
      I1=1
      ENDIF
      IF (KA+J2.LT.N) THEN
      I2=KA+J2
      ELSE
      I2=N
      ENDIF
      S=0.0D 0
      DO 571 J=I1,I2
      IF (J.NE.KA) S=S+X(J)+X(J)**2
  571 CONTINUE
      GA(KA)=S1+3.0D 0*S2*X(KA)**2
      DO 572 J=I1,I2
      IF (J.NE.KA) GA(J)=-S3*(1.0D 0+2.0D 0*X(J))
  572 CONTINUE
      RETURN
  580 IF (KA.EQ.1) THEN
      GA(1)=2.0D 0*X(1)
      ELSE
      GA(KA-1)=2.0D 0*X(KA-1)
      GA(KA)=1.0D 0/X(KA)
      ENDIF
      RETURN
  590 IF (KA.EQ.1) THEN
      GA(1)=1.0D 0
      ELSE
      GA(KA)=1.0D 0
      GA(KA-1)=-SIN(X(KA-1))
      ENDIF
      RETURN
  600 S=(1.0D 0/DBLE(N+1))**2
      IF (N.EQ.1) THEN
      GA(KA)=2.0D 0+S*(1.0D 0+COS(X(KA)))
      ELSE IF (KA.EQ.1) THEN
      GA(KA)=2.0D 0+S*(1.0D 0+COS(X(KA)))
      GA(KA+1)=-1.0D 0
      ELSE IF (KA.EQ.N) THEN
      GA(KA)=2.0D 0+S*(1.0D 0+COS(X(KA)))
      GA(KA-1)=-1.0D 0
      ELSE
      GA(KA)=2.0D 0+S*(1.0D 0+COS(X(KA)))
      GA(KA-1)=-1.0D 0
      GA(KA+1)=-1.0D 0
      ENDIF
      RETURN
  610 IF (KA-5.GT.1) THEN
      I1=KA-5
      ELSE
      I1=1
      ENDIF
      IF (KA+1.LT.N) THEN
      I2=KA+1
      ELSE
      I2=N
      ENDIF
      S=0.0D 0
      DO 611 J=I1,I2
      IF (J.NE.KA) S=S+X(J)*(1.0D 0+X(J))
  611 CONTINUE
      GA(KA)=2.0D 0+15.0D 0*X(KA)**2
      DO 612 J=I1,I2
      IF (J.NE.KA) GA(J)=-(1.0D 0+2.0D 0*X(J))
  612 CONTINUE
  613 CONTINUE
      RETURN
  620 H=1.0D 0/DBLE(N+1)
      T=2.0D 0*H**2
      IF (KA.EQ.1) THEN
      GA(KA)=2.0D 0*(1.0D 0-T*X(KA))
      GA(KA+1)=-(1.0D 0+H)
      ELSE IF (1.LT.KA.AND.KA.LT.N) THEN
      GA(KA)=2.0D 0*(1.0D 0-T*X(KA))
      GA(KA-1)=-(1.0D 0-H)
      GA(KA+1)=-(1.0D 0+H)
      ELSE IF (KA.EQ.N) THEN
      GA(KA)=2.0D 0*(1.0D 0-T*X(KA))
      GA(KA-1)=-(1.0D 0-H)
      ENDIF
      RETURN
  630 A=-9.0D-3
      B=1.0D-3
      AL=0.0D 0
      BE=25.0D 0
      GB=20.0D 0
      CA=0.3D 0
      CB=0.3D 0
      H=(B-A)/DBLE(N+1)
      T=A+DBLE(KA)*H
      H=H**2
      S=DBLE(KA)/DBLE(N+1)
      U=AL*(1.0D 0-S)+BE*S+X(KA)
      FF=CB*EXP(GB*(U-BE))-CA*EXP(GB*(AL-U))
      FG=GB*(CB*EXP(GB*(U-BE))+CA*EXP(GB*(AL-U)))
      IF (T.LE.0) THEN
      FF=FF+CA
      ELSE
      FF=FF-CB
      ENDIF
      IF (N.EQ.1) THEN
      GA(KA)=2.0D 0+H*FG
      ELSE IF (KA.EQ.1) THEN
      GA(KA)=2.0D 0+H*FG
      GA(KA+1)=-1.0D 0
      ELSE IF (KA.LT.N) THEN
      GA(KA)=2.0D 0+H*FG
      GA(KA-1)=-1.0D 0
      GA(KA+1)=-1.0D 0
      ELSE
      GA(KA)=2.0D 0+H*FG
      GA(KA-1)=-1.0D 0
      ENDIF
      RETURN
  640 AL1=0.0D 0
      AL2=0.0D 0
      BE1=0.0D 0
      BE2=0.0D 0
      N1=N/2
      H=1.0D 0/DBLE(N1+1)
      T=DBLE(KA)*H
      IF (KA.EQ.1) THEN
      S1=2.0D 0*X(KA)-X(KA+1)
      B=AL1
      ELSE IF (KA.EQ.N1+1) THEN
      S1=2.0D 0*X(KA)-X(KA+1)
      B=AL2
      ELSE IF (KA.EQ.N1) THEN
      S1=-X(KA-1)+2.0D 0*X(KA)
      B=BE1
      ELSE IF (KA.EQ.N) THEN
      S1=-X(KA-1)+2.0D 0*X(KA)
      B=BE2
      ELSE
      S1=-X(KA-1)+2.0D 0*X(KA)-X(KA+1)
      B=0.0D 0
      ENDIF
      IF (KA.LE.N1) THEN
      S2=X(KA)**2+X(KA)+0.1D 0*X(N1+KA)**2-1.2D 0
      ELSE
      S2=0.2D 0*X(KA-N1)**2+X(KA)**2+2.0D 0*X(KA)-0.6D 0
      ENDIF
      H=1.0D 0/DBLE(N1+1)**2
      IF (KA.EQ.1) THEN
      GA(KA)=2.0D 0+H*(2.0D 0*X(KA)+1.0D 0)
      GA(KA+1)=-1.0D 0
      GA(N1+KA)=H*0.2D 0*X(N1+KA)
      ELSE IF (KA.EQ.N1+1) THEN
      GA(1)=H*0.4D 0*X(1)
      GA(KA)=2.0D 0+H*(2.0D 0*X(KA)+2.0D 0)
      GA(KA+1)=-1.0D 0
      ELSE IF (KA.EQ.N1) THEN
      GA(KA-1)=-1.0D 0
      GA(KA)=2.0D 0+H*(2.0D 0*X(KA)+1.0D 0)
      GA(N1+KA)=H*0.2D 0*X(N1+KA)
      ELSE IF (KA.EQ.N) THEN
      GA(N1)=H*0.4D 0*X(N1)
      GA(KA-1)=-1.0D 0
      GA(KA)=2.0D 0+H*(2.0D 0*X(KA)+2.0D 0)
      ELSE IF (KA.LT.N1) THEN
      GA(KA-1)=-1.0D 0
      GA(KA)=2.0D 0+H*(2.0D 0*X(KA)+1.0D 0)
      GA(KA+1)=-1.0D 0
      GA(N1+KA)=H*0.2D 0*X(N1+KA)
      ELSE
      GA(KA-N1)=H*0.4D 0*X(KA-N1)
      GA(KA-1)=-1.0D 0
      GA(KA)=2.0D 0+H*(2.0D 0*X(KA)+2.0D 0)
      GA(KA+1)=-1.0D 0
      ENDIF
      RETURN
  650 ND=INT(SQRT(DBLE(N)))
      L=MOD(KA,ND)
      IF (L.EQ.0) THEN
      K=KA/ND
      L=ND
      ELSE
      K=INT(KA/ND)+1
      ENDIF
      LA=1.0D 0
      H=1.0D 0/DBLE(ND+1)
      H2=LA*H*H
      IF (L.EQ.1.AND.K.EQ.1) THEN
      GA(1)=4.0D 0+H2*EXP(X(1))
      GA(2)=-1.0D 0
      GA(ND+1)=-1.0D 0
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
      GA(L)=4.0D 0+H2*EXP(X(L))
      GA(L-1)=-1.0D 0
      GA(L+1)=-1.0D 0
      GA(L+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.1) THEN
      GA(ND)=4.0D 0+H2*EXP(X(ND))
      GA(ND-1)=-1.0D 0
      GA(ND+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
      GA(KA)=4.0D 0+H2*EXP(X(KA))
      GA(KA-ND)=-1.0D 0
      GA(KA+1)=-1.0D 0
      GA(KA+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      GA(KA)=4.0D 0+H2*EXP(X(KA))
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      GA(KA+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.1.AND.K.EQ.ND) THEN
      GA(KA)=4.0D 0+H2*EXP(X(KA))
      GA(KA-ND)=-1.0D 0
      GA(KA+1)=-1.0D 0
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
      GA(KA)=4.0D 0+H2*EXP(X(KA))
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      GA(KA+1)=-1.0D 0
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.ND) THEN
      GA(KA)=4.0D 0+H2*EXP(X(KA))
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      GA(KA)=4.0D 0+H2*EXP(X(KA))
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      GA(KA+1)=-1.0D 0
      GA(KA+ND)=-1.0D 0
      ENDIF
      RETURN
  660 ND=INT(SQRT(DBLE(N)))
      L=MOD(KA,ND)
      IF (L.EQ.0) THEN
      K=KA/ND
      L=ND
      ELSE
      K=INT(KA/ND)+1
      ENDIF
      H=1.0D 0/DBLE(ND+1)
      H2=H*H
      IF (L.EQ.1.AND.K.EQ.1) THEN
      GA(1)=4.0D 0+H2*X(1)*2.0D 0
      GA(2)=-1.0D 0
      GA(ND+1)=-1.0D 0
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
      GA(L)=4.0D 0+H2*X(L)*2.0D 0
      GA(L-1)=-1.0D 0
      GA(L+1)=-1.0D 0
      GA(L+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.1) THEN
      GA(ND)=4.0D 0+H2*X(ND)*2.0D 0
      GA(ND-1)=-1.0D 0
      GA(ND+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
      GA(KA)=4.0D 0+H2*X(KA)*2.0D 0
      GA(KA-ND)=-1.0D 0
      GA(KA+1)=-1.0D 0
      GA(KA+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      GA(KA)=4.0D 0+H2*X(KA)*2.0D 0
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      GA(KA+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.1.AND.K.EQ.ND) THEN
      GA(KA)=4.0D 0+H2*X(KA)*2.0D 0
      GA(KA-ND)=-1.0D 0
      GA(KA+1)=-1.0D 0
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
      GA(KA)=4.0D 0+H2*X(KA)*2.0D 0
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      GA(KA+1)=-1.0D 0
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.ND) THEN
      GA(KA)=4.0D 0+H2*X(KA)*2.0D 0
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      GA(KA)=4.0D 0+H2*X(KA)*2.0D 0
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      GA(KA+1)=-1.0D 0
      GA(KA+ND)=-1.0D 0
      ENDIF
      RETURN
      END

