* SUBROUTINE EAGU43             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GA(N)  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU43(N,KA,X,GA,NEXT)
      INTEGER N,KA,NEXT
      $FLOAT X(N),GA(N)
      $FLOAT A,B,C
      $FLOAT Y(65)
      COMMON /EMPR43/ Y
      GOTO (10,20,30,40,50,60),NEXT
   10 A=EXP(X(2)+X(3)*Y(KA+10))
      GA(1)=1.0$P 0
      GA(2)=A
      GA(3)=Y(KA+10)*A
      RETURN
   20 GA(1)=-KA*EXP(KA*X(1))
      GA(2)=-KA*EXP(KA*X(2))
      RETURN
   30 A=$DBLE(45+5*KA)+X(3)
      B=EXP(X(1)+X(2)/A)
      GA(1)=B
      GA(2)=B/A
      GA(3)=-B*X(2)/A**2
      RETURN
   40 C=-$DBLE(KA)
      A=EXP(X(1)+C*X(3))
      B=EXP(X(2)+C*X(4))
      GA(1)=A
      GA(2)=B
      GA(3)=C*A
      GA(4)=C*B
      RETURN
   50 C=Y(KA+16)
      A=EXP(X(1)+C*X(3))
      B=EXP(X(2)+C*X(4))
      GA(1)=A
      GA(2)=B
      GA(3)=C*A
      GA(4)=C*B
      RETURN
   60 C=LOG($DBLE(KA+11))
      A=EXP(X(1)+C*X(3))
      B=EXP(X(2)+C*X(4))
      GA(1)=A
      GA(2)=B
      GA(3)=C*A
      GA(4)=C*B
      RETURN
      END

