* SUBROUTINE EAFU15             ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(LA)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EBFU15(N,KA,LA,X,FA,NEXT)
      INTEGER N,KA,LA,NEXT
      $FLOAT X(LA),FA
      $FLOAT A,B,C,D,P,ALFA,U,V
      INTEGER I,J,K,L,M,IA,IB,IC
      $FLOAT Y(20)
      COMMON /EMPR15/ Y
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,260,270),NEXT
   10 IF (MOD(KA,2).EQ.1) THEN
      FA=1.0$P 1*(X(1)**2-X(2))
      ELSE
      FA=X(1)-1.0$P 0
      ENDIF
      RETURN
   20 A=SQRT(10.0$P 0)
      D=SQRT(90.0$P 0)
      IF (MOD(KA,6).EQ.1) THEN
      FA=1.0$P 1*(X(1)**2-X(2))
      ELSEIF (MOD(KA,6).EQ.2) THEN
      FA=X(1)-1.0$P 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      FA=D*(X(1)**2-X(2))
      ELSEIF (MOD(KA,6).EQ.4) THEN
      FA=X(1)-1.0$P 0
      ELSEIF (MOD(KA,6).EQ.5) THEN
      FA=A*(X(1)+X(2)-2.0$P 0)
      ELSE
      FA=(X(1)-X(2))/A
      ENDIF
      RETURN
   30 A=SQRT(1.0$P 1)
      C=SQRT(5.0$P 0)
      IF (MOD(KA,4).EQ.1) THEN
      FA=X(1)+1.0$P 1*X(2)
      ELSEIF (MOD(KA,4).EQ.2) THEN
      FA=C*(X(1)-X(2))
      ELSEIF (MOD(KA,4).EQ.3) THEN
      FA=(X(1)-2.0$P 0*X(2))**2
      ELSE
      FA=A*(X(1)-X(2))**2
      ENDIF
      RETURN
   40 IF (MOD(KA,5).EQ.1) THEN
      FA=(EXP(X(1))-X(2))**2
      ELSEIF (MOD(KA,5).EQ.2) THEN
      FA=1.0$P 1*(X(1)-X(2))**3
      ELSEIF (MOD(KA,5).EQ.3) THEN
      P=X(1)-X(2)
      FA=(SIN(P)/COS(P))**2
      ELSEIF (MOD(KA,5).EQ.4) THEN
      FA=X(1)**4
      ELSE
      FA=X(1)-1.0$P 0
      ENDIF
      RETURN
   50 IF (KA.EQ.1) THEN
      FA=(3.0$P 0-2.0$P 0*X(1))*X(1)+1.0$P 0-X(2)
      ELSE
      FA=(3.0$P 0-2.0$P 0*X(2))*X(2)+1.0$P 0-X(1)
      IF (KA.LT.N) FA=FA-X(3)
      ENDIF
      RETURN
   60 FA=1.0$P 0
      DO I=1,MIN(KA+1,6)
        FA=FA+X(I)*(X(I)+1.0$P 0)
      ENDDO
      IF (KA.GT.5.AND.KA.LT.N) FA=FA+X(7)*(X(7)+1.0$P 0)
      IF (KA.LE.5) THEN
        FA=FA+(2.0$P 0+5.0$P 0*X(KA)**2)*X(KA)
      ELSE
        FA=FA+(2.0$P 0+5.0$P 0*X(6)**2)*X(6)
      ENDIF
      RETURN
   70 IF (MOD(KA,2).EQ.1) THEN
      FA=X(1)+X(2)*((5.0$P 0-X(2))*X(2)-2.0$P 0)-1.3$P 1
      ELSE
      FA=X(1)+X(2)*((1.0$P 0+X(2))*X(2)-1.4$P 1)-2.9$P 1
      ENDIF
      RETURN
   80 M=5*N
      IF (KA.LE.M/2) THEN
      IA=1
      ELSE
      IA=2
      ENDIF
      IB=5-KA/(M/4)
      IC=MOD(KA,5)+1
      FA=(X(1)**IA-X(2)**IB)**IC
      RETURN
   90 IF (MOD(KA,6).EQ.1) THEN
      FA=X(1)+3.0$P 0*X(2)*(X(3)-1.0$P 0)+X(4)**2-1.0$P 0
      ELSEIF (MOD(KA,6).EQ.2) THEN
      FA=(X(1)+X(2))**2+(X(3)-1.0$P 0)**2-X(4)-3.0$P 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      FA=X(1)*X(2)-X(3)*X(4)
      ELSEIF (MOD(KA,6).EQ.4) THEN
      FA=2.0$P 0*X(1)*X(3)+X(2)*X(4)-3.0$P 0
      ELSEIF (MOD(KA,6).EQ.5) THEN
      FA=(X(1)+X(2)+X(3)+X(4))**2+(X(1)-1.0$P 0)**2
      ELSE
      FA=X(1)*X(2)*X(3)*X(4)+(X(4)-1.0$P 0)**2-1.0$P 0
      ENDIF
      RETURN
  100 I=(KA+1)/2
      J=MOD(KA,2)
      IF (J.EQ.0) THEN
      FA=6.0$P 0-EXP(2.0$P 0*X(1))-EXP(2.0$P 0*X(2))
      ELSEIF (I.EQ.1) THEN
      FA=4.0$P 0-EXP(X(1))-EXP(X(2))
      ELSEIF (I.EQ.N) THEN
      FA=8.0$P 0-EXP(3.0$P 0*X(1))-EXP(3.0$P 0*X(2))
      ELSE
      FA=8.0$P 0-EXP(3.0$P 0*X(1))-EXP(3.0$P 0*X(2))+
     & 4.0$P 0-EXP(X(2))-EXP(X(3))
      ENDIF
      RETURN
  110 IF (MOD(KA,2).EQ.1) THEN
      FA=1.0$P 1*(2.0$P 0*X(1)/(1.0$P 0+X(1)**2)-X(2))
      ELSE
      FA=X(1)-1.0$P 0
      ENDIF
      RETURN
  120 IF (MOD(KA,6).EQ.1) THEN
      FA=1.0$P 1*(X(1)**2-X(2))
      ELSEIF (MOD(KA,6).EQ.2) THEN
      FA=X(1)-1.0$P 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      FA=(X(1)-1.0$P 0)**2
      ELSEIF (MOD(KA,6).EQ.4) THEN
      FA=(X(1)-1.0$P 0)**3
      ELSEIF (MOD(KA,6).EQ.5) THEN
      FA=X(1)**2*X(2)+SIN(X(2)-X(3))-1.0$P 1
      ELSE
      FA=X(1)+(X(2)**2*X(3))**2-2.0$P 1
      ENDIF
      RETURN
  130 IF (MOD(KA,7).EQ.1) THEN
      FA=1.0$P 1*(X(1)**2-X(2))
      ELSEIF (MOD(KA,7).EQ.2) THEN
      FA=1.0$P 1*(X(1)**2-X(2))
      ELSEIF (MOD(KA,7).EQ.3) THEN
      FA=(X(1)-X(2))**2
      ELSEIF (MOD(KA,7).EQ.4) THEN
      FA=(X(1)-X(2))**2
      ELSEIF (MOD(KA,7).EQ.5) THEN
      FA=X(1)+X(2)**2+X(3)-3.0$P 1
      ELSEIF (MOD(KA,7).EQ.6) THEN
      FA=X(1)-X(2)**2+X(3)-1.0$P 1
      ELSE
      FA=X(1)*X(2)-1.0$P 1
      ENDIF
      RETURN
  140 L=MOD((KA-1),4)+1
      FA=-Y(L)
      DO K=1,3
      A=$DBLE(K*K)/$DBLE(L)
      DO J=1,4
      IF (X(J).EQ.0) X(J)=1.0$P-16
      A=A*SIGN(1.0$P 0,X(J))*ABS(X(J))**($DBLE(J)/$DBLE(K*L))
      ENDDO
      FA=FA+A
      ENDDO
      RETURN
  150 L=MOD((KA-1),4)+1
      FA=-Y(L)
      DO K=1,3
      A=0.0$P 0
      DO J=1,4
      A=A+X(J)*($DBLE(J)/$DBLE(K*L))
      ENDDO
      FA=FA+EXP(A)*$DBLE(K*K)/$DBLE(L)
      ENDDO
      RETURN
  160 L=MOD((KA-1),4)+1
      FA=-Y(L)
      DO J=1,4
      FA=FA+$DBLE((1-2*MOD(J,2))*L*J*J)*SIN(X(J))+$DBLE(L*L*J)*COS(X(J))
      ENDDO
      RETURN
  170 ALFA=0.5$P 0
      IF (KA.EQ.1) THEN
      FA=ALFA-(1.0$P 0-ALFA)*X(3)-X(1)*(1.0$P 0+4.0$P 0*X(2))
      ELSEIF(KA.EQ.2) THEN
      FA=-(2.0$P 0-ALFA)*X(3)-X(2)*(1.0$P 0+4.0$P 0*X(1))
      ELSEIF(KA.EQ.N-1) THEN
      FA=ALFA*X(1)-X(2)*(1.0$P 0+4.0$P 0*X(3))
      ELSEIF (KA.EQ.N) THEN
      FA=ALFA*X(1)-(2.0$P 0-ALFA)-X(3)*(1.0$P 0+4.0$P 0*X(2))
      ELSEIF (MOD(KA,2).EQ.1) THEN
      FA=ALFA*X(1)-(1.0$P 0-ALFA)*X(4)-X(2)*(1.0$P 0+4.0$P 0*X(3))
      ELSE
      FA=ALFA*X(1)-(2.0$P 0-ALFA)*X(4)-X(3)*(1.0$P 0+4.0$P 0*X(2))
      ENDIF
      RETURN
  180 IF (KA.EQ.1) THEN
      FA=4.0$P 0*(X(1)-X(2)**2)
      ELSE
      FA=8.0$P 0*X(2)*(X(2)**2-X(1))-2.0$P 0*(1.0$P 0-X(2))
      IF (KA.LT.N) FA=FA+4.0$P 0*(X(2)-X(3)**2)
      ENDIF
      RETURN
  190 IF (KA.EQ.1) THEN
      FA=-2.0$P 0*X(1)**2+3.0$P 0*X(1)-2.0$P 0*X(2)+
     & 3.0$P 0*X(3)-X(4)-X(5)+0.5$P 0*X(6)-X(7)+1.0$P 0
      ELSEIF (KA.GT.1.AND.KA.LT.N-5) THEN
      FA=-2.0$P 0*X(2)**2+3.0$P 0*X(2)-X(1)-2.0$P 0*X(3)+
     & 3.0$P 0*X(4)-X(5)-X(6)+0.5$P 0*X(7)-X(8)+1.0$P 0
      ELSEIF (KA.EQ.N-5) THEN
      FA=-2.0$P 0*X(2)**2+3.0$P 0*X(2)-X(1)-2.0$P 0*X(3)+
     & 3.0$P 0*X(3)-X(4)-X(5)+0.5$P 0*X(6)-X(7)+1.0$P 0
      ELSEIF (KA.EQ.N-4) THEN
      FA=-2.0$P 0*X(2)**2+3.0$P 0*X(2)-X(1)-2.0$P 0*X(3)+
     & 3.0$P 0*X(2)-X(3)-X(4)+0.5$P 0*X(5)-X(6)+1.0$P 0
      ELSEIF (KA.EQ.N-3) THEN
      FA=-2.0$P 0*X(2)**2+3.0$P 0*X(2)-X(1)-2.0$P 0*X(3)+
     & 3.0$P 0*X(1)-X(2)-X(3)+0.5$P 0*X(4)-X(5)+1.0$P 0
      ELSEIF (KA.EQ.N-2) THEN
      FA=-2.0$P 0*X(3)**2+3.0$P 0*X(3)-X(2)-2.0$P 0*X(4)+
     & 3.0$P 0*X(1)-X(2)-X(3)+0.5$P 0*X(4)-X(5)+1.0$P 0
      ELSEIF (KA.EQ.N-1) THEN
      FA=-2.0$P 0*X(4)**2+3.0$P 0*X(4)-X(3)-2.0$P 0*X(5)+
     & 3.0$P 0*X(1)-X(2)-X(3)+0.5$P 0*X(4)-X(5)+1.0$P 0
      ELSE
      FA=-2.0$P 0*X(5)**2+3.0$P 0*X(5)-X(4)+
     & 3.0$P 0*X(1)-X(2)-X(3)+0.5$P 0*X(4)-X(5)+1.0$P 0
      ENDIF
      RETURN
  200 U=1.0$P 0/$DBLE(N+1)
      V=$DBLE(KA)*U
      IF (KA.EQ.1) THEN
      FA=2.0$P 0*X(1)+0.5$P 0*U*U*(X(1)+V+1.0$P 0)**3-X(2)+1.0$P 0
      ELSE
      FA=2.0$P 0*X(2)+0.5$P 0*U*U*(X(2)+V+1.0$P 0)**3-X(1)+1.0$P 0
      IF(KA.LT.N) FA=FA-X(3)
      ENDIF
      RETURN
  210 IF (MOD(KA,7).EQ.1) THEN
      FA=1.0$P 1*(X(1)**2-X(2))
      ELSEIF (MOD(KA,7).EQ.2) THEN
      FA=X(1)+X(2)-2.0$P 0
      ELSEIF (MOD(KA,7).EQ.3) THEN
      FA=X(1)-1.0$P 0
      ELSEIF (MOD(KA,7).EQ.4) THEN
      FA=X(1)-1.0$P 0
      ELSEIF (MOD(KA,7).EQ.5) THEN
      FA=X(1)+3.0$P 0*X(2)
      ELSEIF (MOD(KA,7).EQ.6) THEN
      FA=X(1)+X(2)-2.0$P 0*X(3)
      ELSE
      FA=1.0$P 1*(X(1)**2-X(2))
      ENDIF
      RETURN
  220 IF (KA.EQ.1) THEN
      FA=X(1)-1.0$P 0
      ELSEIF (MOD(KA,2).EQ.0) THEN
      FA=1.0$P 1*(X(1)**2-X(2))
      ELSE
      FA=2.0$P 0*EXP(-(X(1)-X(2))**2)+EXP(-2.0$P 0*(X(2)-X(3))**2)
      ENDIF
      RETURN
  260 M=5*N
      IA=KA/(M/4)+1
      B=$DBLE(KA/(M/5)+1)
      C=$DBLE(MOD(KA,M/4+M/5))
      FA=X(1)**IA*EXP(B*X(2))+X(2)-C
      RETURN

  270 IA=MIN(MAX(MOD(KA,13)-2,1),7)
      IB=(KA+12)/13
      I=IA+IB-1
      IF (IA.EQ.7) THEN
      J=IB
      ELSE
      J=IA+IB
      ENDIF
      C=3.0$P 0*$DBLE(IA)/1.0$P 1
      A=0.0$P 0
      DO 271 L=0,6
      IF (IB+L.NE.I.AND.IB+L.NE.J) A=A+SIN(X(IB+L))-Y(1)
  271 CONTINUE
      FA=(1.0$P 0+COS(C))*(X(J)-SIN(X(I))-1.0$P 0)+
     $ 5.0$P 0*(X(I)-2.0$P 0)*EXP(SIN(C*X(J)))+0.5$P 0*A
      RETURN
      END
