* SUBROUTINE EBGU14                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION - LU VERSION WITH MODIFIED TESTS NO 7-10,12.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(LA)  VECTOR OF VARIABLES.
*  RO  G(LA)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EBGU14(N,KA,LA,X,GA,NEXT)
      INTEGER N,KA,LA,NEXT
      $FLOAT X(LA),GA(LA)
      $FLOAT A,B,C,D,P,Q,R,U,V
      INTEGER I,J,K,L,M
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220),NEXT
   10 A=X(1)**2-X(2)
      B=X(1)-1.0$P 0
      GA(1)=4.0$P 2*X(1)*A+2.0$P 0*B
      GA(2)=-2.0$P 2*A
      RETURN
   20 A=X(1)**2-X(2)
      B=X(1)-1.0$P 0
      C=X(3)**2-X(4)
      D=X(3)-1.0$P 0
      U=X(2)+X(4)-2.0$P 0
      V=X(2)-X(4)
      GA(1)=4.0$P 2*X(1)*A+2.0$P 0*B
      GA(2)=-2.0$P 2*A+2.0$P 1*U+0.2$P 0*V
      GA(3)=3.6$P 2*X(3)*C+2.0$P 0*D
      GA(4)=-1.8$P 2*C+2.0$P 1*U-0.2$P 0*V
      RETURN
   30 A=X(1)+1.0$P 1*X(2)
      B=X(3)-X(4)
      C=X(2)-2.0$P 0*X(3)
      D=X(1)-X(4)
      GA(1)=2.0$P 0*A+4.0$P 1*D**3
      GA(2)=2.0$P 1*A+4.0$P 0*C**3
      GA(3)=-8.0$P 0*C**3+1.0$P 1*B
      GA(4)=-4.0$P 1*D**3-1.0$P 1*B
      RETURN
   40 A=EXP(X(1))
      B=A-X(2)
      B=4.0$P 0*B**3
      D=X(2)-X(3)
      D=6.0$P 2*D**5
      P=X(3)-X(4)
      C=COS(P)
      Q=SIN(P)/COS(P)
      Q=4.0$P 0*Q**3/C**2
      U=X(1)
      V=X(4)-1.0$P 0
      GA(1)=A*B+8.0$P 0*U**7
      GA(2)=D-B
      GA(3)=Q-D
      GA(4)=2.0$P 0*V-Q
      RETURN
   50 P=7.0$P 0/3.0$P 0
      IF (KA.EQ.1) THEN
        A=(3.0$P 0-2.0$P 0*X(1))*X(1)-X(2)+1.0$P 0
        B=P*ABS(A)**(P-1.0$P 0)*SIGN(1.0$P 0,A)
        GA(1)=B*(3.0$P 0-4.0$P 0*X(1))
        GA(2)=-B
      ELSE
        A=(3.0$P 0-2.0$P 0*X(2))*X(2)-X(1)+1.0$P 0
        IF (KA.LT.N) A=A-X(3)
        B=P*ABS(A)**(P-1.0$P 0)*SIGN(1.0$P 0,A)
        GA(1)=-B
        GA(2)=B*(3.0$P 0-4.0$P 0*X(2))
        IF (KA.LT.N) GA(3)=-B
      ENDIF
      RETURN
   60 P=7.0$P 0/3.0$P 0
      A=1.0$P 0
      DO I=1,MIN(KA+1,6)
        A=A+X(I)*(X(I)+1.0$P 0)
      ENDDO
      IF (KA.GT.5.AND.KA.LT.N) A=A+X(7)*(X(7)+1.0$P 0)
      IF (KA.LE.5) THEN
        A=A+(2.0$P 0+5.0$P 0*X(KA)**2)*X(KA)
      ELSE
        A=A+(2.0$P 0+5.0$P 0*X(6)**2)*X(6)
      ENDIF
      B=P*ABS(A)**(P-1.0$P 0)*SIGN(1.0$P 0,A)
      IF (KA.LE.5) THEN
        DO I=1,KA+1
          GA(I)=B*(1.0$P 0+2.0$P 0*X(I))
        ENDDO
        GA(KA)=GA(KA)+B*(2.0$P 0+1.5$P 1*X(KA)**2)
      ELSE
        DO I=1,6
          GA(I)=B*(1.0$P 0+2.0$P 0*X(I))
        ENDDO
        GA(6)=GA(6)+B*(2.0$P 0+1.5$P 1*X(6)**2)
        IF (KA.LT.N) GA(7)=B*(1.0$P 0+2.0$P 0*X(7))
      ENDIF
      RETURN
   70 P=7.0$P 0/3.0$P 0
      IF (KA.LE.N) THEN
        IF (KA.EQ.1) THEN
          A=(3.0$P 0-2.0$P 0*X(1))*X(1)-X(2)+1.0$P 0
          B=P*ABS(A)**(P-1.0$P 0)*SIGN(1.0$P 0,A)
          GA(1)=B*(3.0$P 0-4.0$P 0*X(1))
          GA(2)=-B
        ELSE
          A=(3.0$P 0-2.0$P 0*X(2))*X(2)-X(1)+1.0$P 0
          IF (KA.LT.N) A=A-X(3)
          B=P*ABS(A)**(P-1.0$P 0)*SIGN(1.0$P 0,A)
          GA(1)=-B
          GA(2)=B*(3.0$P 0-4.0$P 0*X(2))
          IF (KA.LT.N) GA(3)=-B
        ENDIF
      ELSE
        A=X(1)+X(2)
        B=P*ABS(A)**(P-1.0$P 0)*SIGN(1.0$P 0,A)
        GA(1)=B
        GA(2)=B
      ENDIF
      RETURN
   80 P=0.0$P 0
      K=MAX(1,KA-2)
      L=MIN(N,KA+2)
      IF (KA.LE.N/2) THEN
        DO I=K,L
          A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
          B=$DBLE(I+KA)/1.0$P 1
          IF (KA.LE.2) THEN
            P=P+A*SIN(X(I))+B*COS(X(I))
          ELSE
            J=I+3-KA
            P=P+A*SIN(X(J))+B*COS(X(J))
          ENDIF
        ENDDO
        IF (KA.LE.2) J=KA+2
        I=N/2+KA
        A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
        B=$DBLE(I+KA)/1.0$P 1
        P=P+A*SIN(X(J+1))+B*COS(X(J+1))
        P=2.0$P 0*($DBLE(N+KA)-P)/$DBLE(N)
        DO I=K,L
          A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
          B=$DBLE(I+KA)/1.0$P 1
          IF (KA.EQ.1.OR.KA.EQ.2) THEN
            GA(I)=-P*(A*COS(X(I))-B*SIN(X(I)))
          ELSE
            J=I+3-KA
            GA(J)=-P*(A*COS(X(J))-B*SIN(X(J)))
          ENDIF
        ENDDO
        IF (KA.LE.2) J=KA+2
        I=N/2+KA
        A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
        B=$DBLE(I+KA)/1.0$P 1
        GA(J+1)=-P*(A*COS(X(J+1))-B*SIN(X(J+1)))
      ELSE
        I=KA-N/2
        A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
        B=$DBLE(I+KA)/1.0$P 1
        P=P+A*SIN(X(1))+B*COS(X(1))
        DO I=K,L
          J=I+4-KA
          A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
          B=$DBLE(I+KA)/1.0$P 1
          P=P+A*SIN(X(J))+B*COS(X(J))
        ENDDO
        P=2.0$P 0*($DBLE(N+KA)-P)/$DBLE(N)
        I=KA-N/2
        A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
        B=$DBLE(I+KA)/1.0$P 1
        GA(1)=-P*(A*COS(X(1))-B*SIN(X(1)))
        DO I=K,L
          A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
          B=$DBLE(I+KA)/1.0$P 1
          J=I+4-KA
          GA(J)=-P*(A*COS(X(J))-B*SIN(X(J)))
        ENDDO
      ENDIF
      RETURN
   90 P=1.0$P 0/$DBLE(N)
      K=MAX(1,KA-2)
      L=MIN(N,KA+2)
      IF (KA.LE.N/2) THEN
        DO I=K,L
          A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
          B=$DBLE(I+KA)/1.0$P 1
          IF (KA.LE.2) THEN
            GA(I)=P*(A*COS(X(I))-B*SIN(X(I)))
          ELSE
            J=I+3-KA
            GA(J)=P*(A*COS(X(J))-B*SIN(X(J)))
          ENDIF
        ENDDO
        IF (KA.LE.2) J=KA+2
        I=N/2+KA
        A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
        B=$DBLE(I+KA)/1.0$P 1
        GA(J+1)=P*(A*COS(X(J+1))-B*SIN(X(J+1)))
        IF (KA.LE.2) THEN
          GA(KA)=GA(KA)+P*$DBLE(KA)*SIN(X(KA))
        ELSE
          GA(3)=GA(3)+P*$DBLE(KA)*SIN(X(3))
        ENDIF
      ELSE
        I=KA-N/2
        A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
        B=$DBLE(I+KA)/1.0$P 1
        GA(1)=P*(A*COS(X(1))-B*SIN(X(1)))
        DO I=K,L
          A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
          B=$DBLE(I+KA)/1.0$P 1
          J=I+4-KA
          GA(J)=P*(A*COS(X(J))-B*SIN(X(J)))
        ENDDO
        GA(4)=GA(4)+P*$DBLE(KA)*SIN(X(4))
      ENDIF
      RETURN
  100 P=1.0$P 0/$DBLE(N)
      IF (KA.LE.2) M=KA
      IF (KA.GE.3.AND.KA.LE.N/2) M=3
      IF (KA.GT.N/2) M=4
      K=MAX(1,KA-2)
      L=MIN(N,KA+2)
      C=1.0$P 0+$DBLE(KA)/1.0$P 1
      Q=C*X(M)
      GA(M)=0.0$P 0
      IF (KA.LE.N/2) THEN
        DO I=K,L
          A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
          B=$DBLE(I+KA)/1.0$P 1
          D=1.0$P 0+$DBLE(I)/1.0$P 1
          IF (KA.LE.2) THEN
            IF (I.EQ.KA) THEN
              GA(M)=GA(M)+P*A*COS(B+Q+D*X(I))*2.0$P 0*C
            ELSE
              GA(I)=P*A*COS(B+Q+D*X(I))*D
              GA(M)=GA(M)+P*A*COS(B+Q+D*X(I))*C
            ENDIF
          ELSE
            J=I+3-KA
            IF (I.EQ.KA) THEN
              GA(M)=GA(M)+P*A*COS(B+Q+D*X(J))*2.0$P 0*C
            ELSE
              GA(J)=P*A*COS(B+Q+D*X(J))*D
              GA(M)=GA(M)+P*A*COS(B+Q+D*X(J))*C
            ENDIF
          ENDIF
        ENDDO
        IF (KA.LE.2) J=KA+2
        I=N/2+KA
        A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
        B=$DBLE(I+KA)/1.0$P 1
        D=1.0$P 0+$DBLE(I)/1.0$P 1
        GA(J+1)=P*A*COS(B+Q+D*X(J+1))*D
        GA(M)=GA(M)+P*A*COS(B+Q+D*X(J+1))*C
      ELSE
        I=KA-N/2
        A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
        B=$DBLE(I+KA)/1.0$P 1
        D=1.0$P 0+$DBLE(I)/1.0$P 1
        GA(1)=P*A*COS(B+Q+D*X(1))*D
        GA(M)=GA(M)+P*A*COS(B+Q+D*X(1))*C
        DO I=K,L
          A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
          B=$DBLE(I+KA)/1.0$P 1
          D=1.0$P 0+$DBLE(I)/1.0$P 1
          J=I+4-KA
          IF (I.EQ.KA) THEN
            GA(M)=GA(M)+P*A*COS(B+Q+D*X(J))*2.0$P 0*C
          ELSE
            GA(J)=P*A*COS(B+Q+D*X(J))*D
            GA(M)=GA(M)+P*A*COS(B+Q+D*X(J))*C
          ENDIF
        ENDDO
      ENDIF
      RETURN
  110 P=-0.2008$P-2
      Q=-0.1900$P-2
      R=-0.0261$P-2
      A=1.0$P 0
      B=0.0$P 0
      DO J=1,5
        A=A*X(J)
        B=B+X(J)**2
      ENDDO
      A=A*EXP(A)
      B=B-1.0$P 1-P
      C=X(2)*X(3)-5.0$P 0*X(4)*X(5)-Q
      D=X(1)**3+X(2)**3+1.0$P 0-R
      GA(1)=A/X(1)+2.0$P 1*(2.0$P 0*B*X(1)+3.0$P 0*D*X(1)**2)
      GA(2)=A/X(2)+2.0$P 1*(2.0$P 0*B*X(2)+C*X(3)+3.0$P 0*D*X(2)**2)
      GA(3)=A/X(3)+2.0$P 1*(2.0$P 0*B*X(3)+C*X(2))
      GA(4)=A/X(4)+2.0$P 1*(2.0$P 0*B*X(4)-5.0$P 0*C*X(5))
      GA(5)=A/X(5)+2.0$P 1*(2.0$P 0*B*X(5)-5.0$P 0*C*X(4))
      RETURN
  120 A=X(1)-3.0$P 0
      B=X(1)-X(2)
      GA(1)=2.0$P 0*A+2.0$P 0*B+2.0$P 1*EXP(2.0$P 1*B)
      GA(2)=-2.0$P 0*B-2.0$P 1*EXP(2.0$P 1*B)
      RETURN
  130 A=X(2)**2
      B=X(1)**2
      C=A+1.0$P 0
      D=B+1.0$P 0
      P=0.0$P 0
      IF (A.GT.P) P=LOG(A)
      Q=0.0$P 0
      IF (B.GT.Q) Q=LOG(B)
      GA(1)=2.0$P 0*X(1)*(C*B**A+P*A**D)
      GA(2)=2.0$P 0*X(2)*(D*A**B+Q*B**C)
      RETURN
  140 P=1.0$P 0/$DBLE(N+1)
      Q=0.5$P 0*P**2
      IF (KA.EQ.1) THEN
        A=2.0$P 0*X(1)-X(2)+Q*(X(1)+$DBLE(KA)*P+1.0$P 0)**3
        GA(1)=A*(4.0$P 0+6.0$P 0*Q*(X(1)+$DBLE(KA)*P+1.0$P 0)**2.0$P 0)
        GA(2)=-2.0$P 0*A
      ELSE
        A=2.0$P 0*X(2)-X(1)+Q*(X(2)+$DBLE(KA)*P+1.0$P 0)**3
        IF (KA.LT.N) A=A-X(3)
        GA(1)=-2.0$P 0*A
        GA(2)=A*(4.0$P 0+6.0$P 0*Q*(X(2)+$DBLE(KA)*P+1.0$P 0)**2.0$P 0)
        IF (KA.LT.N) GA(3)=-2.0$P 0*A
      ENDIF
      RETURN
  150 P=1.0$P 0/$DBLE(N+1)
      Q=2.0$P 0/P
      R=2.0$P 0*P
      A=X(1)-X(2)
      GA(1)=Q*(2.0$P 0*X(1)-X(2))
      GA(2)=-Q*X(1)
      IF (ABS(A).LE.1.0$P-6) THEN
        GA(1)=GA(1)+R*EXP(X(2))*
     &    (1.0$P 0/2.0$P 0+A*(1.0$P 0/3.0$P 0+A/8.0$P 0))
        GA(2)=GA(2)+R*EXP(X(2))*
     &    (1.0$P 0/2.0$P 0+A*(1.0$P 0/6.0$P 0+A/24.0$P 0))
      ELSE
        B=EXP(X(1))-EXP(X(2))
        GA(1)=GA(1)+R*(EXP(X(1))*A-B)/A**2
        GA(2)=GA(2)-R*(EXP(X(2))*A-B)/A**2
      ENDIF
      IF (KA.EQ.1) THEN
        GA(1)=GA(1)+R*(EXP(X(1))*(X(1)-1.0$P 0)+1.0$P 0)/X(1)**2
      ELSEIF (KA.EQ.N-1) THEN
        GA(2)=GA(2)+2.0$P 0*Q*X(2)
     &           +R*(EXP(X(2))*(X(2)-1.0$P 0)+1.0$P 0)/X(2)**2
      ENDIF
      RETURN
  160 IF (KA.EQ.1) THEN
        GA(1)=$DBLE(KA)*SIN(X(1))
        GA(2)=-$DBLE(KA)*COS(X(2))
      ELSE
        GA(1)=$DBLE(KA)*COS(X(1))
        GA(2)=$DBLE(KA)*SIN(X(2))
        IF (KA.LT.N) GA(3)=-$DBLE(KA)*COS(X(3))
      ENDIF
      RETURN
  170 P=1.0$P 0/$DBLE(N+1)
      IF (KA.EQ.1) THEN
      GA(1)=0.5$P 0*X(1)/P+P*EXP(X(1))
      GA(2)=0.25$P 0*X(2)/P
      ELSE IF (KA.EQ.N) THEN
      GA(2)=0.5$P 0*X(2)/P+P*EXP(X(2))
      GA(1)=0.25$P 0*X(1)/P
      ELSE
      A=0.25$P 0*(X(3)-X(1))/P
      GA(2)=P*EXP(X(2))
      GA(1)=-A
      GA(3)= A
      ENDIF
      RETURN
  180 P=1.0$P 0/$DBLE(N+1)
      Q=$DBLE(KA)*P
      IF (KA.EQ.1) THEN
      GA(1)=X(1)/P-2.0$P 0*P*(X(1)+Q)
      GA(2)=0.5$P 0*X(2)/P
      ELSE IF (KA.EQ.N) THEN
      GA(2)=X(2)/P-2.0$P 0*P*(X(2)+Q)
      GA(1)=0.5$P 0*X(1)/P
      ELSE
      A=0.5$P 0*(X(3)-X(1))/P
      GA(2)=-2.0$P 0*P*(X(2)+Q)
      GA(1)=-A
      GA(3)= A
      ENDIF
      RETURN
  190 P=1.0$P 0/$DBLE(N+1)
      Q=EXP(2.0$P 0*$DBLE(KA)*P)
      IF (KA.EQ.1) THEN
      R=1.0$P 0/3.0$P 0
      A=0.5$P 0*(X(2)-R)/P
      GA(1)=2.0$P 0*P*(X(1)+Q)+(X(1)-R)/P
      GA(2)= A
      ELSE IF (KA.EQ.N) THEN
      R=EXP(2.0$P 0)/3.0$P 0
      A=0.5$P 0*(X(1)-R)/P
      GA(2)=2.0$P 0*P*(X(2)+Q)+(X(2)-R)/P
      GA(1)= A
      ELSE
      A=0.5$P 0*(X(3)-X(1))/P
      GA(2)=2.0$P 0*P*(X(2)+Q)
      GA(1)=-A
      GA(3)= A
      ENDIF
      RETURN
  200 P=1.0$P 0/$DBLE(N+1)
      IF (KA.EQ.1) THEN
      A=EXP(-2.0$P 0*X(1)**2)
      B=0.5$P 0*X(2)/P
      GA(1)=X(1)/P-4.0$P 0*X(1)*A*P*(B**2-1.0$P 0)
      GA(2)= A*B
      ELSE IF (KA.EQ.N) THEN
      A=EXP(-2.0$P 0*X(2)**2)
      B=0.5$P 0*X(1)/P
      GA(2)=X(2)/P*EXP(-2.0$P 0)-4.0$P 0*X(2)*A*P*(B**2-1.0$P 0)
      GA(1)= A*B
      ELSE
      A=EXP(-2.0$P 0*X(2)**2)
      B=0.5$P 0*(X(3)-X(1))/P
      GA(2)=-4.0$P 0*X(2)*A*P*(B**2-1.0$P 0)
      GA(1)=-A*B
      GA(3)= A*B
      ENDIF
      RETURN
  210 P=1.0$P 0/$DBLE(N+1)
      IF (KA.EQ.1) THEN
      A=0.5$P 0*(X(2)-1.0$P 0)/P
      B=(X(1)-1.0$P 0)/P
      U=0.5$P 0*ATAN(A)
      V=0.5$P 0*ATAN(B)
      GA(1)=2.0$P 0*P*X(1)+V
      GA(2)= U
      ELSE IF (KA.EQ.N) THEN
      A=0.5$P 0*(2.0$P 0-X(1))/P
      B=(2.0$P 0-X(2))/P
      U=0.5$P 0*ATAN(A)
      V=0.5$P 0*ATAN(B)
      GA(2)=2.0$P 0*P*X(2)-V
      GA(1)=-U
      ELSE
      A=0.5$P 0*(X(3)-X(1))/P
      U=0.5$P 0*ATAN(A)
      GA(2)=2.0$P 0*P*X(2)
      GA(1)=-U
      GA(3)= U
      ENDIF
      RETURN
  220 P=1.0$P 0/$DBLE(N+1)
      IF (KA.EQ.1) THEN
      A= 0.5$P 0*X(2)/P
      B= X(1)/P
      GA(1)=2.0D 2*P*(X(1)-A**2)+2.0D 2*B**3-(1.0$P 0-B)
      GA(2)=-2.0D 2*(X(1)-A**2)*A-(1.0$P 0-A)
      ELSE IF (KA.EQ.N) THEN
      A=-0.5$P 0*X(1)/P
      B=-X(2)/P
      GA(2)=2.0D 2*P*(X(2)-A**2)-2.0D 2*B**3+(1.0$P 0-B)
      GA(1)= 2.0D 2*(X(2)-A**2)*A+(1.0$P 0-A)
      ELSE
      A=0.5$P 0*(X(3)-X(1))/P
      GA(2)=2.0D 2*P*(X(2)-A**2)
      GA(1)= 2.0D 2*(X(2)-A**2)*A+(1.0$P 0-A)
      GA(3)=-2.0D 2*(X(2)-A**2)*A-(1.0$P 0-A)
      ENDIF
      RETURN
      END
