* SUBROUTINE ECGU41             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF TEST FUNCTIONS FOR NONLINEAR EQUATIONS.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GC(N)  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE ECGU41(N,KC,X,GC,NEXT)
      INTEGER N,KC,NEXT
      $FLOAT X(N),GC(N)
      INTEGER J,L
      GO TO (10,20,30), NEXT
   10 J=2*((KC-1)/3+1)
      L=MOD(KC,3)
      GO TO (11,12,13), L+1
   11 GC(J-1)=2.0$P 0*X(J-1)+1.0$P 0
      GC(J  )=2.0$P 0*X(J  )-1.0$P 0
      GC(J+1)=2.0$P 0*X(J+1)+1.0$P 0
      GC(J+2)=2.0$P 0*X(J+2)-1.0$P 0
      RETURN
   12 GC(J-1)=2.0$P 0*X(J-1)-1.0$P 0
      GC(J  )=4.0$P 0*X(J  )
      GC(J+1)=2.0$P 0*X(J+1)
      GC(J+2)=4.0$P 0*X(J+2)-1.0$P 0
      RETURN
   13 GC(J-1)=4.0$P 0*X(J-1)+2.0$P 0
      GC(J  )=2.0$P 0*X(J  )-1.0$P 0
      GC(J+1)=2.0$P 0*X(J+1)
      GC(J+2)=-1.0$P 0
      RETURN
   20 CONTINUE
      RETURN
   30 CONTINUE
      RETURN
      END
