* SUBROUTINE EFFU09                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR GLOBAL MINIMIZATION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      $FLOAT FUNCTION FFSHKL(X,M)
      $FLOAT X(4)
      INTEGER M,I,J
      REAL*8 ASH(4,10),CSH(10),FF,S
      DATA ASH /
     &     4.0D0,4.0D0,4.0D0,4.0D0,
     &     1.0D0,1.0D0,1.0D0,1.0D0,
     &     8.0D0,8.0D0,8.0D0,8.0D0,
     &     6.0D0,6.0D0,6.0D0,6.0D0,
     &     3.0D0,7.0D0,3.0D0,7.0D0,
     &     2.0D0,9.0D0,2.0D0,9.0D0,
     &     5.0D0,5.0D0,3.0D0,3.0D0,
     &     8.0D0,1.0D0,8.0D0,1.0D0,
     &     6.0D0,2.0D0,6.0D0,2.0D0,
     &     7.0D0,3.6D0,7.0D0,3.6D0/
      DATA CSH /
     &     0.1D0,0.2D0,0.2D0,0.4D0,
     &     0.4D0,0.6D0,0.3D0,0.7D0,
     &     0.5D0,0.5D0/
      FF=0.0D0
      DO 20 I=1,M
        S=0.0D0
        DO 10 J=1,4
          S=S+(X(J)-ASH(J,I))**2
   10   CONTINUE
        FF=FF+1.0D0/(S+CSH(I))
   20 CONTINUE
      FFSHKL=-FF
      END

      $FLOAT FUNCTION FFHAR3(NF,X)
      INTEGER NF
      $FLOAT X(NF)
      INTEGER I,J
      REAL*8 AHT(4,3),CHT(4),PHT(4,3),FF,S
      DATA AHT /
     &     3.0D0, 10.0D0, 30.0D0,
     &     0.1D0, 10.0D0, 35.0D0,
     &     3.0D0, 10.0D0, 30.0D0,
     &     0.1D0, 10.0D0, 35.0D0/
      DATA CHT /
     &     1.0D0, 1.2D0, 3.0D0, 3.2D0/
      DATA PHT /
     &     0.3689D0, 0.1170D0, 0.2673D0,
     &     0.4699D0, 0.4387D0, 0.7470D0,
     &     0.1091D0, 0.8732D0, 0.5547D0,
     &     0.03815D0, 0.5743D0, 0.8828D0/
      FF=0
      DO 20 I=1,4
        S=0
        DO 10 J=1,NF
          S=S+AHT(I,J)*(X(J)-PHT(I,J))**2
   10   CONTINUE
        FF=FF+CHT(I)*EXP(-S)
   20 CONTINUE
      FFHAR3=-FF
      END

      $FLOAT FUNCTION FFHAR6(NF,X)
      INTEGER NF
      $FLOAT X(NF)
      INTEGER I,J
      REAL*8 AHT(4,6),CHT(4),PHT(4,6),FF,S
      DATA AHT /
     &     10.0D0, 3.0D0, 17.0D0, 3.5D0, 1.7D0, 8.0D0,
     &     0.05D0, 10.0D0, 17.0D0, 0.1D0, 8.0D0, 14.0D0,
     &     3.0D0, 3.50D0, 1.7D0, 10.0D0, 17.0D0, 8.0D0,
     &     17.0D0, 8.0D0, 0.05D0, 10.0D0, 0.1D0, 14.0D0/
      DATA CHT /
     &     1.0D0, 1.2D0, 3.0D0, 3.2D0/
      DATA PHT /
     &     0.1312D0, 0.1696D0, 0.5569D0, 0.0124D0, 0.8283D0, 0.5886D0,
     &     0.2329D0, 0.4135D0, 0.8307D0, 0.3736D0, 0.1004D0, 0.9991D0,
     &     0.2348D0, 0.1451D0, 0.3522D0, 0.2883D0, 0.3047D0, 0.6650D0,
     &     0.4047D0, 0.8828D0, 0.8732D0, 0.5743D0, 0.1091D0, 0.0381D0/
      FF=0
      DO 20 I=1,4
        S=0
        DO 10 J=1,NF
          S=S+AHT(I,J)*(X(J)-PHT(I,J))**2
   10   CONTINUE
        FF=FF+CHT(I)*EXP(-S)
   20 CONTINUE
      FFHAR6=-FF
      END

      SUBROUTINE EFFU09(N,X,F,NEXT)
      INTEGER N,NEXT
      $FLOAT X(N),F
      $FLOAT FFSHKL, FFHAR3, FFHAR6
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130), NEXT
C
C     SPONA FUNCTION
C
   10 F=((X(1)-3.D0)*(X(1)+5.D0))**2+
     &  ((X(2)-2.D0)*(X(2)+3.D0))**2-(X(1)*X(2))**2
      RETURN
C
C     TRECCANI FUNCTION
C
   20 F=X(1)**4+4.0*X(1)**3+4.0*X(1)**2+X(2)**2
      RETURN
C
C     SIMPLIFIED ROSENBROCK'S FUNCTION
C
   30 F=0.5*(X(1)**2-X(2))**2 + (X(1)-1.0)**2
      RETURN
C
C     RASTRIGIN FUNCTION
C
   40 F=X(1)**2+X(2)**2-COS(18.0D0*X(1))-COS(18.0D0*X(2))
      RETURN
C
C     BRANIN FUNCTION
C
   50 F=(X(2)-(5.1D0/(4.0D0*3.14D0**2))*X(1)**2+(5.0D0/3.14D0)*X(1)
     &  -6.0D0)**2+10.0D0*(1.0D0-(1.0D0/(8.0D0*3.140D0)))*COS(X(1))
     &  +10.0D0
      RETURN
C
C     GOLDSTEIN AND PRICE FUNCTION
C
   60 F=(1.0D0+(X(1)+X(2)+1.0D0)**2 * (19.0D0-14.0D0*X(1)
     &  +3.0D0*X(1)**2-14.0D0*X(2)+6.0D0*X(1)*X(2)+3.0D0*X(2)**2))
     &  *(30.0D0+((2.0D0*X(1)-3.0D0*X(2))**2) * (18.0D0-32.0D0*X(1)
     &  +12.0D0*X(1)**2+48.0D0*X(2)-36.0D0*X(1)*X(2)+27.0D0
     &  *X(2)**2))
      RETURN
C
C     3 HUMP CAMEL-BACK FUNCTION
C
   70 F=2.0*X(1)**2-1.05*X(1)**4+(X(1)**6)/6.0-X(1)*X(2)+X(2)**2
      RETURN
C
C     6 HUMP CAMEL-BACK FUNCTION
C
   80 F=4.0*X(1)**2-2.1*X(1)**4+(X(1)**6)/3.0-X(1)*X(2)
     &   -4.0*X(2)**2+4.0*X(2)**4
      RETURN
C
C     SHEKEL 5 FUNCTION
C
   90 F=FFSHKL(X,5)
      RETURN
C
C     SHEKEL 7 FUNCTION
C
  100 F=FFSHKL(X,7)
      RETURN
C
C     SHEKEL 9 FUNCTION
C
  110 F=FFSHKL(X,9)
      RETURN
C
C     HARTMAN 3 FUNCTION
C
  120 F=FFHAR3(N,X)
      RETURN
C
C     HARTMAN 6 FUNCTION
C
  130 F=FFHAR6(N,X)
      RETURN
      END
