* SUBROUTINE EFGU13                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF MODEL FUNCTIONS FOR CONSTRAINED MINIMIZATION.
*  SPARSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GF(N) GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFGU13(N,X,GF,NEXT)
      INTEGER N,NEXT
      $FLOAT X(N),GF(N),A,B
      $FLOAT PI
      $FLOAT ONE,TWO
      PARAMETER (PI=3.14159265358979323846264338$P 0)
      PARAMETER (ONE=1.0$P 0,TWO=2.0$P 0)
      INTEGER I,J
      GOTO (10,20,30,40,50,60) NEXT
   10 CONTINUE
      I=2*(N/3)
      DO 11 J=1,I
        A=COS(X(J))-SIN(X(J))
        GF(J)=A
   11 CONTINUE
      DO 12 J=I+1,N
        GF(J)=0.0$P 0
   12 CONTINUE
      RETURN
   20 CONTINUE
      A=PI/12
      B=PI/16
      GF(1)=COS(B*X(2))*COS(X(1)*A)*A
      GF(2)=-SIN(A*X(1))*SIN(X(2)*B)*B
      RETURN
   30 CONTINUE
      I=2*(N/3)
      DO 31 J=1,I
        A=COS(X(J))-SIN(X(J))
        GF(J)=A
   31 CONTINUE
      DO 32 J=I+1,N
        GF(J)=0.0$P 0
   32 CONTINUE
      RETURN
   40 CONTINUE
      I=2*(N/3)
      DO 41 J=1,I
        A=COS(X(J))-SIN(X(J))
        GF(J)=A
   41 CONTINUE
      DO 42 J=I+1,N
        GF(J)=0.0$P 0
   42 CONTINUE
      RETURN
   50 CONTINUE
      I=2*(N/3)
      DO 51 J=1,I
        A=COS(X(J))-SIN(X(J))
        GF(J)=A
   51 CONTINUE
      DO 52 J=I+1,N
        GF(J)=0.0$P 0
   52 CONTINUE
      RETURN
   60 CONTINUE
      GF(1)=-X(2)*X(3)
      GF(2)=-X(1)*X(3)
      GF(3)=-X(1)*X(2)
      RETURN
      END
