* SUBROUTINE EFHD19                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
*  HESSIAN MATRICES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  H(N*(N+1)/2)  HESSIAN MATRIX OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFHD19(N,X,H,NEXT)
      INTEGER N,NEXT,I,IN,J,K,KK,L
      $FLOAT X(N),H(N*(N+1)/2)
      $FLOAT AI,AJ,ETA9,F1,F2,F3,F4,F,T,Y(2700)
      COMMON /EMPR19/ Y
      PARAMETER (ETA9=1.0$P 60)
      IN(I,J)=(J-1)*J/2+I
      DO 1 I=1,N*(N+1)/2
        H(I)=0.0$(P)0
    1 CONTINUE
      GO TO (10,20,30,30,50,60,70,80,90,180,100,110,230,240,170,120,
     & 210,220,130,140,150,160,190,200,250), NEXT
   10 H(1)=1200$P 0*X(1)**2-400$P 0*X(2)+2.0$P 0
      H(2)=-400$P 0*X(1)
      H(3)= 200$P 0
      RETURN
   20 T=X(1)**2+(X(2)-1.0$P 0)**2-1.0$P 0
      F=SIGN(2.0$P 0,T)
      H(1)=F
      H(3)=F
      RETURN
   30 I=NEXT-2
      J=5-NEXT
      F1=X(I)**2+X(J)**4
      F2=(2.0$P 0-X(1))**2+(2.0$P 0-X(2))**2
      F3=2.0$P 0*EXP(-X(1)+X(2))
      IF ((F1.GE.F2).AND.(F1.GE.F3)) THEN
        H(NEXT*2-5)=2.0$P 0
        H(9-NEXT*2)=12.0$P 0*X(J)**2
      ELSE IF ((F2.GE.F1).AND.(F2.GE.F3)) THEN
        H(1)=2.0$P 0
        H(3)=2.0$P 0
      ELSE
        H(1)= 2.0$P 0*EXP(X(2)-X(1))
        H(2)=-H(1)
        H(3)= H(1)
      ENDIF
      RETURN
   50 F1=5.0$P 0*X(1)+X(2)
      F2=-5.0$P 0*X(1)+X(2)
      F3=X(1)**2+X(2)**2+4.0$P 0*X(2)
      IF ((F1.GE.F2).AND.(F1.GE.F3)) THEN
      ELSE IF ((F2.GE.F1).AND.(F2.GE.F3)) THEN
      ELSE
        H(1)=2.0$P 0
        H(3)=2.0$P 0
      ENDIF
      RETURN
   60 H(1)=2.0$P 0
      H(3)=2.0$P 0
      RETURN
   70 F1=-X(1)-X(2)
      F2=F1+(X(1)**2+X(2)**2-1.0$P 0)
      IF (F1.LT.F2) THEN
        H(1)=2.0$P 0
        H(3)=2.0$P 0
      ENDIF
      RETURN
   80 F1=X(1)**2+X(2)**2-1.0$P 0
      IF (F1.GE.0.0$P 0) THEN
        H(1)=40.0$P 0
        H(3)=40.0$P 0
      ENDIF
      RETURN
   90 F1=SIGN(3.5$P 0,X(1)**2+X(2)**2-1.0$P 0)+4.0$P 0
      H(1)=F1
      H(3)=F1
      RETURN
  180 IF (X(1).GT.ABS(X(2))) THEN
        F1=720$P 0*(9.0$P 0*X(1)**2+16.0$P 0*X(2)**2)**(-1.5$P 0)
        H(1)= F1*X(2)**2
        H(2)=-F1*X(1)*X(2)
        H(3)= F1*X(1)**2
      ELSE
        IF (X(1).LT.0.0$P 0) H(1)=-72.0$P 0*X(1)**8
      ENDIF
      RETURN
  100 F=X(1)**2+X(2)**2+X(3)**2
      F2=F+X(4)**2+X(1)-X(2)+X(3)-X(4)-8.0$P 0
      F3=F+X(2)**2+2.0$P 0*X(4)**2-X(1)-X(4)-10.0$P 0
      F4=F+2.0$P 0*X(1)-X(2)-X(4)-5.0$P 0
      L=1
      IF (F2.GT.0.0$P 0) L=2
      IF (F3.GT.MAX(F2,0.0$P 0)) L=3
      IF (F4.GT.MAX(F2,F3,0.0$P 0)) L=4
      GO TO (101,102,103,104),L
  101 H(1)= 2.0$P 0
      H(3)= 2.0$P 0
      H(6)= 4.0$P 0
      H(10)=2.0$P 0
      RETURN
  102 H(10)=22.0$P 0
      GO TO 106
  103 H(3)= 42.0$P 0
      H(10)=42.0$P 0
      GO TO 105
  104 H(10)= 2.0$P 0
  106 H(3)= 22.0$P 0
  105 H(1)= 22.0$P 0
      H(6)= 24.0$P 0
      RETURN
  110 F=-ETA9
      DO 112 I=1,10
      F1=0.0$P 0
      DO 113 J=1,5
      F1=F1+(X(J)-Y(5*(I-1)+J))**2
  113 CONTINUE
      F1=F1*Y(50+I)
      IF (F.LT.F1) K=I
      F=MAX(F,F1)
  112 CONTINUE
      DO 114 J=1,5
      H(J*(J+1)/2)=2.0$P 0*Y(50+K)
  114 CONTINUE
      RETURN
  230 DO 231 J=1,5
      H(J*(J+1)/2)=6.0$P 0*Y(85+J)*X(J)
  231 CONTINUE
      K=1
      DO 232 I=1,N
      DO 232 J=1,I
      H(K)=H(K)+2.0$P 0*Y(55+I+J*5)
      K=K+1
  232 CONTINUE
      RETURN
  240 H(1)= 0.0$P 0
      H(2)= X(3)*X(4)*X(5)
      H(3)= 0.0$P 0
      H(4)= X(2)*X(4)*X(5)
      H(5)= X(1)*X(4)*X(5)
      H(6)= 0.0$P 0
      H(7)= X(2)*X(3)*X(5)
      H(8)= X(1)*X(3)*X(5)
      H(9)= X(1)*X(2)*X(5)
      H(10)=0.0$P 0
      H(11)=X(2)*X(3)*X(4)
      H(12)=X(1)*X(3)*X(4)
      H(13)=X(1)*X(2)*X(4)
      H(14)=X(1)*X(2)*X(3)
      H(15)=0.0$P 0
      F1=X(1)**2+X(2)**2+X(3)**2+X(4)**2+X(5)**2-1.0$P 1
      F4=1.0$P 0
      IF (F1.LT.0.0$P 0) F4=-F4
      L=0
      DO 241 I=1,5
      L=L+I
      H(L)=H(L)+2.0$P 1*F4
  241 CONTINUE
      F2=X(2)*X(3)-5.0$P 0*X(4)*X(5)
      F4=1.0$P 0
      IF (F2.LT.0.0$P 0) F4=-F4
      H( 5)=H( 5)+1.0$P 1*F4
      H(14)=H(14)-5.0$P 1*F4
      F3=X(1)**3+X(2)**3+1.0$P 0
      F4=1.0$P 0
      IF (F3.LT.0.0$P 0) F4=-F4
      H(1)=H(1)+6.0$P 1*F4*X(1)
      H(3)=H(3)+6.0$P 1*F4*X(2)
      RETURN
  170 DO 172 I=1,51
      T=$DBLE(I-1)/10.0$P 0
      F=0.5$P 0*EXP(-T)-EXP(-T*2.0$P 0)+0.5$P 0*EXP(-T*3.0$P 0)+
     & 1.5$P 0*EXP(-T*1.5$P 0)*SIN(7.0$P 0*T)+
     & EXP(-T*2.5$P 0)*SIN(5.0$P 0*T)
      F1=EXP(-X(2)*T)
      F2=EXP(-X(6)*T)
      F3=COS(X(3)*T+X(4))
      F4=SIN(X(3)*T+X(4))
      AI=SIGN(1.0$P 0,X(1)*F1*F3+X(5)*F2-F)
      H(2)=H(2)-AI*F1*F3*T
      H(3)=H(3)+AI*F1*F3*T*T*X(1)
      H(4)=H(4)-AI*F1*F4*T
      H(5)=H(5)+AI*F1*F4*T*T*X(1)
      H(6)=H(6)-AI*F1*F3*T*T*X(1)
      H(7)=H(7)-AI*F1*F4
      H(8)=H(8)+AI*F1*F4*T*X(1)
      H(9)=H(9)-AI*F1*F3*T*X(1)
      H(10)=H(10)-AI*F1*F3*X(1)
      H(15)=H(15)-AI*F2*T
      H(20)=H(20)-AI*F2*T
      H(21)=H(21)+AI*F2*T*T*X(5)
  172 CONTINUE
      RETURN
  120 F=-ETA9
      L=1
      KK=0
      DO 123 K=1,5
      F1=0.0$P 0
      DO 122 I=1,N
      F1=F1-Y(KK+100+I)*X(I)
      DO 122 J=1,N
      F1=F1+Y(KK+(I-1)*N+J)*X(I)*X(J)
  122 CONTINUE
      IF (F.LT.F1) L=K
      F=MAX(F,F1)
      KK=KK+110
  123 CONTINUE
      K=1
      DO 124 I=1,N
      DO 124 J=1,I
      H(K)=2.0$P 0*Y((L-1)*110+(I-1)*N+J)
      K=K+1
  124 CONTINUE
      RETURN
  210 F1=0.0$P 0
      DO 211 I=1,10
      F1=F1+X(I)**2
  211 CONTINUE
      F4=F1-0.25$P 0
      F1=1.0$P -3*F4*F4
      DO 212 I=1,10
      F1=F1+(X(I)-1.0$P 0)**2
  212 CONTINUE
      F2=0.0$P 0
      DO 215 I=2,30
      AI=$DBLE(I-1)/29$P 0
      F=0.0$P 0
      DO 213 J=1,10
      F=F+X(J)*AI**(J-1)
  213 CONTINUE
      F=-F*F-1.0$P 0
      DO 214 J=2,10
      AJ=$DBLE(J-1)
      F=F+X(J)*AJ*AI**(J-2)
  214 CONTINUE
      F2=F2+F*F
  215 CONTINUE
      F2=F2+X(1)**2+(X(2)-X(1)**2-1.0$P 0)**2
      F3=0.0$P 0
      DO 216 I=2,10
      F3=F3+100.0$P 0*(X(I)-X(I-1)**2)**2+(1.0$P 0-X(I))**2
  216 CONTINUE
      IF ((F1.GE.F2).AND.(F1.GE.F3)) THEN
        L=1
        DO 218 I=1,N
        DO 218 J=1,I
        H(L)=8.0$P-3*X(I)*X(J)
        IF (J.EQ.I) H(L)=H(L)+2.0$P 0+4.0$P-3*F4
        L=L+1
  218   CONTINUE
      ELSE IF ((F2.GE.F1).AND.(F2.GE.F3)) THEN
        KK=1
        DO 2186 J=1,N
        DO 2186 L=1,J
        DO 2185 I=2,30
        AI=$DBLE(I-1)/29.0$P 0
        F=0.0$P 0
        DO 2183 K=1,10
        F=F-X(K)*AI**(K-1)
 2183   CONTINUE
        T=2.0$P 0*F*AI**(J-1)
        IF (J.GE.2) T=T+(J-1)*AI**(J-2)
        F4=2.0$P 0*F*AI**(L-1)
        IF (L.GE.2) F4=F4+(L-1)*AI**(L-2)
        F=-F*F-1.0$P 0
        DO 2184 K=2,10
        F=F+X(K)*(K-1)*AI**(K-2)
 2184   CONTINUE
        H(KK)=H(KK)+2.0$P 0*(T*F4-2.0$P 0*F*AI**(J+L-2))
 2185   CONTINUE
        KK=KK+1
 2186   CONTINUE
        H(1)=H(1)+12.0$P 0*X(1)**2-4.0$P 0*X(2)+6.0$P 0
        H(2)=H(2)-4.0$P 0*X(1)
        H(3)=H(3)+2.0$P 0
      ELSE
        DO 219 I=1,10
        J=I*(I+1)/2
        IF (I.GE.2) H(J)=202.0$P 0
        IF (I.LE.9) H(J)=H(J)+4.0$P 2*(3.0$P 0*X(I)**2-X(I+1))
        IF (I.LE.9) H(J+I)=-4.0$P 2*X(I)
  219   CONTINUE
      ENDIF
      RETURN
  220 T= (X(1)**2+X(7)**2)**1.5$P 0
      H(1) = X(7)**2/T
      H(22)=-X(1)*X(7)/T
      H(28)= X(1)**2/T
      T=((5.5$P 0-X(6))**2+(1.0$P 0+X(12))**2)**1.5$P 0
      H(21)=(1.0$P 0+X(12))**2/T
      H(72)=(5.5$P 0-X(6))*(1.0$P 0+X(12))/T
      H(78)=(5.5$P 0-X(6))**2/T
      DO 223 J=1,6
      T=Y(12+J)/((Y(J)-X(J))**2+(Y(6+J)-X(6+J))**2)**1.5$P 0
      H(IN(J,J))    =H(IN(J,J))    +(Y(J+6)-X(J+6))**2*T
      H(IN(J,J+6))  =H(IN(J,J+6))  -(Y(J+6)-X(J+6))*(Y(J)-X(J))*T
      H(IN(J+6,J+6))=H(IN(J+6,J+6))+(Y(J)-X(J))**2*T
  223 CONTINUE
      DO 224 J=1,6
      IF (J.LT.6) THEN
        F1=X(J)-X(J+1)
        F2=X(J+6)-X(J+7)
        T=Y(18+J)/(F1*F1+F2*F2)**1.5$P 0
        H(IN(J,J))    =H(IN(J,J))    +F2*F2*T
        H(IN(J,J+1))  =H(IN(J,J+1))  -F2*F2*T
        H(IN(J,J+6))  =H(IN(J,J+6))  -F1*F2*T
        H(IN(J,J+7))  =H(IN(J,J+7))  +F1*F2*T
        H(IN(J+6,J+6))=H(IN(J+6,J+6))+F1*F1*T
        H(IN(J+6,J+7))=H(IN(J+6,J+7))-F1*F1*T
      ENDIF
      IF (J.GT.1) THEN
        F1=X(J)-X(J-1)
        F2=X(J+6)-X(J+5)
        T=Y(17+J)/(F1*F1+F2*F2)**1.5$P 0
        H(IN(J,J))    =H(IN(J,J))    +F2*F2*T
        H(IN(J,J+5))  =H(IN(J,J+5))  +F1*F2*T
        H(IN(J,J+6))  =H(IN(J,J+6))  -F1*F2*T
        H(IN(J+6,J+6))=H(IN(J+6,J+6))+F1*F1*T
      ENDIF
  224 CONTINUE
      RETURN
  130 F=X(1)**2
      K=1
      DO 131 I=2,20
      F1=X(I)**2
      IF (F.LT.F1) K=I
      F=MAX(F,F1)
  131 CONTINUE
      H(K*(K+1)/2)=2.0$P 0
      RETURN
  140 RETURN
  150 RETURN
  160 RETURN
  190 RETURN
  200 RETURN
  250 F1=0$P 0
      DO 251 J=1,5
      F1=F1+Y(85+J)*X(J)**3
  251 CONTINUE
      DO 252 J=1,5
      H(J*(J+1)/2)=SIGN(12.0$P 0,F1)*Y(85+J)*X(J)
  252 CONTINUE
      K=1
      DO 253 I=1,5
      DO 253 J=1,I
      H(K)=H(K)+2.0$P 0*Y(55+I+J*5)
      K=K+1
  253 CONTINUE
      DO 257 J=1,5
      T=-3.0$P 0*Y(85+J)*X(J)*X(J)-Y(90+J)
      DO 255 I=1,15
      IF (I.LE.5) T=T-2.0$P 0*Y(55+I+J*5)*X(I)
      IF (I.GT.5) T=T+Y(I+J*10-15)*X(I)
  255 CONTINUE
      IF (T.LE.0.0$P 0) GO TO 257
      I=J*(J+1)/2
      H(I)=H(I)-6.0$P 2*Y(85+J)
  257 CONTINUE
      RETURN
      END
