* SUBROUTINE EFHD28                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  H(N*(N+1)/2)  HESSIAN MATRIX OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFHD28(N,NA,X,H,NEXT)
      INTEGER N,NA,NEXT
      $FLOAT X(N),H(N*(N+1)/2)
      $FLOAT FA,GA(100),HA(5050)
      INTEGER KA
      IF (NEXT.LE.15) THEN
      CALL EFHD01(N,X,H,NEXT)
      ELSE IF (NEXT.LE.25) THEN
      WRITE (*,*) 'HESSIAN MATRICES ARE NOT GIVEN'
      STOP
      ELSE IF (NEXT.LE.35) THEN
      CALL UXVSET(N*(N+1)/2,0.0$P 0,H)
      DO 1 KA=1,NA
      CALL EAFU02(N,KA,X,FA,NEXT-5)
      CALL EAGU02(N,KA,X,GA,NEXT-5)
      CALL EAHD02(N,KA,X,HA,NEXT-5)
      CALL UXDSMU(N,H,1.0$P 0,GA)
      CALL UXVDIR(N*(N+1)/2,FA,HA,H,H)
    1 CONTINUE
      ELSE
      WRITE (*,*) 'HESSIAN MATRICES ARE NOT GIVEN'
      STOP
      ENDIF
      RETURN
      END
