* SUBROUTINE EIND99                ALL SYSTEMS                11/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  STRUCTURE OF CONSTRAINTS, COMPLEMENTARITIES AND THE SPARSE JACOBIAN
*  MATRIX FOR COMPLEMENTARITY PROBLEMS.
*
* PARAMETERS :
*  IU  NC  NUMBER OF GENERAL CONSTRAINTS.
*  IU  NCC  NUMBER OF COMPLEMENTARITY CONSTRAINTS.
*  IO  IC(NC)  VECTOR CONTAINING TYPES OF GENERAL CONSTRAINTS.
*  IO  CL(NC)  LOWER BOUNDS FOR CONSTRAINTS.
*  IO  CU(NC)  UPPER BOUNDS FOR CONSTRAINTS.
*  IO  ICC(2*NCC) INDICES OF COMPLEMENTARITY FUNCTIONS.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EIND99(NC,IC,CL,CU,NEXT)
      INTEGER NC,IC(NC),NEXT
      INTEGER I
      $FLOAT CL(NC),CU(NC)
      GOTO (10,20,30,40,40,40,40,40,40,40,40,40,40,140,140,140,140,140,
     &140,140,140,140,140,240,250,260,270,280,290), NEXT
C
C     DESILVA QQR-AY-NCP-6-2-2
C
   10 NC=4
      IC(1)=5
      CL(1)=0.0$P 0
      IC(2)=5
      CL(2)=0.0$P 0
      IC(3)=1
      CL(3)=0.0$P 0
      IC(4)=1
      CL(4)=0.0$P 0
      RETURN
C
C     DF1 QQR-AY-NCP-2-2-1
C
   20 NC=2
      IC(1)=2
      CU(1)=3.0$P 0
      IC(2)=1
      CL(2)=0.0$P 0
      RETURN
C
C     DEMPE QQR-AY-LCP-4-2-2
C
   30 NC=2
      IC(1)=5
      CL(1)=3.0$P 0
      IC(2)=2
      CL(2)=0.0$P 0
      RETURN
C
C     GNASH10 OOR-AY-LCP-13-4-8
C     GNASH11 OOR-AY-LCP-13-4-8
C     GNASH12 OOR-AY-LCP-13-4-8
C     GNASH13 OOR-AY-LCP-13-4-8
C     GNASH14 OOR-AY-LCP-13-4-8
C     GNASH15 OOR-AY-LCP-13-4-8
C     GNASH16 OOR-AY-LCP-13-4-8
C     GNASH17 OOR-AY-LCP-13-4-8
C     GNASH18 OOR-AY-LCP-13-4-8
C     GNASH19 OOR-AY-LCP-13-4-8
C
   40 NC=8
      DO 41 I=1,4
        IC(I)=5
        IC(I+4)=1
        CL(I)=0.0$P 0
        CL(I+4)=0.0$P 0
   41 CONTINUE
      RETURN
C
C     GNASH10M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH11M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH12M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH13M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH14M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH15M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH16M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH17M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH18M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH19M OOR-AY-LCP-9-8-8   MODIFIED
C
  140 NC=8
      DO 141 I=1,4
        IC(I)=5
        IC(I+4)=1
        CL(I)=0.0$P 0
        CL(I+4)=0.0$P 0
  141 CONTINUE
      RETURN
C
C     DESIGN-CENT-1 QOR-AY-NLP-12-9-3
C
  240 NC=11
      IC(1)=2
      CL(1)=0.0$P 0
      IC(2)=2
      CL(2)=3.0$P 0
      DO 241 I=3,8
        IC(I)=5
  241 CONTINUE
      CL(3)=-1.0$P 0
      CL(4)=0.0$P 0
      CL(5)=2.5$P-1
      CL(6)=1.0$P 0
      CL(7)=0.0$P 0
      CL(8)=-1.0$P 0
      DO 242 I=9,11
        IC(I)=2
        CL(I)=0.0$P 0
  242 CONTINUE
      RETURN
C
C     DESIGN-CENT-2 QOR-MY-NLP-13-13-3
C
  250 DO 252 I=9,11
        IC(I)=2
        CU(I)=1.0$P 0
  252 CONTINUE
  251 NC=15
      IC(1)=2
      CU(1)=0.0$P 0
      IC(2)=2
      CU(2)=3.0$P 0
      DO 253 I=3,8
        IC(I)=5
  253 CONTINUE
      CL(3)=-1.0$P 0
      CL(4)=0.0$P 0
      CL(5)=2.5$P-1
      CL(6)=1.0$P 0
      CL(7)=0.0$P 0
      CL(8)=-1.0$P 0
      IC(12)=2
      CU(12)=0.0$P 0
      IC(13)=1
      CU(13)=0.0$P 0
      IC(14)=1
      CU(14)=0.0$P 0
      IC(15)=2
      CU(15)=0.0$P 0
      RETURN
C
C     DESIGN-CENT-21 QOR-MY-NLP-13-13-3
C
  260 DO 261 I=9,11
        IC(I)=2
        CU(I)=0.0$P 0
  261 CONTINUE
      GOTO 251
C
C     DESIGN-CENT-3 QOR-MY-NLP-15-9-3
C
  270 NC=11
      IC(1)=2
      CU(1)=0.0$P 0
      IC(2)=2
      CU(2)=3.0$P 0
      DO 272 I=3,8
        IC(I)=5
  272 CONTINUE
      CL(3)=-1.0$P 0
      CL(4)=0.0$P 0
      CL(5)=2.5$P-1
      CL(6)=1.0$P 0
      CL(7)=0.0$P 0
      CL(8)=-1.0$P 0
      DO 273 I=9,11
        IC(I)=2
        CU(I)=1.0$P 0
  273 CONTINUE
  271 CONTINUE
      RETURN
C
C     DESIGN-CENT-31 QOR-MY-NLP-15-9-3
C
  280 NC=11
      IC(1)=2
      CU(1)=0.0$P 0
      IC(2)=2
      CU(2)=3.0$P 0
      DO 282 I=3,8
        IC(I)=5
        CL(I)=0.0$P 0
  282 CONTINUE
      DO 283 I=9,11
        IC(I)=2
        CU(I)=0.0$P 0
  283 CONTINUE
      GOTO 271
C
C	DESIGN-CENT-4 QOR-AY-NLP-22-9-12
C
  290 NC=20
      IC(1)=2
      CU(1)=0.0$P 0
      IC(2)=2
      CU(2)=3.0$P 0
      DO 291 I=3,8
        IC(I)=5
  291 CONTINUE
      CL(3)=-1.0$P 0
      CL(4)=0.0$P 0
      CL(5)=2.5$P-1
      CL(6)=1.0$P 0
      CL(7)=0.0$P 0
      CL(8)=-1.0$P 0
      DO 292 I=9,20
        IC(I)=2
        CU(I)=0.0$P 0
  292 CONTINUE
      RETURN

      END
