* SUBROUTINE EINS20                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION WITH CHANGED TESTS 7-10, 12.
*  CHANGED FOR THE TESTS.
*
* PARAMETERS :
*  IU  N  NUMBER OF VARIABLES.
*  IU  NC  NUMBER OF CONSTRAINTS.
*  IU  NCL  NUMBER OF LINEAR CONSTRAINTS.
*  IU  MC  NUMBER OF ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  IO  IC(NC+1)  POINTERS OF THE FIRST ELEMENTS IN ROWS OF THE
*         JACOBIAN MATRIX.
*  IO  JC(MC)  INDICES OF THE NONZERO ELEMENTS OF THE JACOBIAN MATRIX IN
*             THE PACKED ROW.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EINS20(N,NC,NCL,MC,IC,JC,NEXT)
      INTEGER N,NC,NCL,MC,NEXT
      INTEGER IC(NC+1),JC(*)
      INTEGER I,J
      NCL=0
      GOTO (10,20,30,10,50,60,70,10,90,10,110,120,130,140,150,160,160,
     & 160,100), NEXT
   10 NC=N-2
      MC=0
      IC(1)=1
      DO 13 I=2,N-1
      MC=MC+1
      JC(MC)=I-1
      MC=MC+1
      JC(MC)=I
      MC=MC+1
      JC(MC)=I+1
      IC(I)=MC+1
   13 CONTINUE
      RETURN
   20 NC=N-7
      MC=0
      IC(1)=1
      DO 24 I=1,NC
      DO 23 J=1,7
      MC=MC+1
      JC(MC)=I+J-1
   23 CONTINUE
      IC(I+1)=MC+1
   24 CONTINUE
      RETURN
   30 NC=2
      MC=0
      J=1
      IC(1)=1
      DO 34 I=1,N,N-1
      IF(I.GT.1) THEN
      MC=MC+1
      JC(MC)=I-1
      ENDIF
      MC=MC+1
      JC(MC)=I
      IF(I.LT.N) THEN
      MC=MC+1
      JC(MC)=I+1
      ENDIF
      J=J+1
      IC(J)=MC+1
   34 CONTINUE
      RETURN
   50 NC=N-4
      MC=0
      IC(1)=1
      DO 53 I=3,N-2
      MC=MC+1
      JC(MC)=I-2
      MC=MC+1
      JC(MC)=I-1
      MC=MC+1
      JC(MC)=I
      MC=MC+1
      JC(MC)=I+1
      MC=MC+1
      JC(MC)=I+2
      IC(I-1)=MC+1
   53 CONTINUE
      RETURN
   60 NC=N/2
      MC=0
      J=1
      IC(1)=1
      DO 63 I=1,N
      IF (MOD(I,2).EQ.0) THEN
      MC=MC+3
      JC(MC-2)=I-1
      JC(MC-1)=I
      JC(MC)=I+1
      J=J+1
      IC(J)=MC+1
      ENDIF
   63 CONTINUE
      RETURN
   70 NC=4
      MC=0
      J=1
      IC(1)=1
      DO 73 I=1,N
      IF(I.GT.2.AND.I.LT.N-1) GO TO 73
      IF(I.GT.2) THEN
      MC=MC+1
      JC(MC)=I-2
      ENDIF
      IF(I.GT.1) THEN
      MC=MC+1
      JC(MC)=I-1
      ENDIF
      MC=MC+1
      JC(MC)=I
      IF(I.LT.N) THEN
      MC=MC+1
      JC(MC)=I+1
      ENDIF
      IF(I.LT.N-1) THEN
      MC=MC+1
      JC(MC)=I+2
      ENDIF
      J=J+1
      IC(J)=MC+1
   73 CONTINUE
      RETURN
   90 NC=6
      MC=0
      J=1
      IC(1)=1
      DO 93 I=1,N
      IF(I.GT.3.AND.I.LT.N-2) GO TO 93
      IF(I.GT.3) THEN
      MC=MC+1
      JC(MC)=I-3
      ENDIF
      IF(I.GT.2) THEN
      MC=MC+1
      JC(MC)=I-2
      ENDIF
      IF(I.GT.1) THEN
      MC=MC+1
      JC(MC)=I-1
      ENDIF
      MC=MC+1
      JC(MC)=I
      IF(I.LT.N) THEN
      MC=MC+1
      JC(MC)=I+1
      ENDIF
      IF(I.LT.N-1) THEN
      MC=MC+1
      JC(MC)=I+2
      ENDIF
      IF(I.LT.N-2) THEN
      MC=MC+1
      JC(MC)=I+3
      ENDIF
      J=J+1
      IC(J)=MC+1
   93 CONTINUE
      RETURN
  110 NC=2*(N-2)/3
      MC=1
      DO 113 I=1,NC/2
      J=(I-1)*3
      IC(2*I-1)=MC
      IC(2*I)=MC+3
      JC(MC)=J+1
      JC(MC+1)=J+4
      JC(MC+2)=J+5
      JC(MC+3)=J+2
      JC(MC+4)=J+3
      JC(MC+5)=J+4
      MC=MC+6
  113 CONTINUE
      IC(NC+1)=MC
      MC=MC-1
      RETURN
  120 NC=3*(N-1)/4
      MC=1
      DO 123 I=1,NC/3
      J=(I-1)*4
      IC(3*I-2)=MC
      IC(3*I-1)=MC+3
      IC(3*I)=MC+6
      JC(MC)=J+1
      JC(MC+1)=J+2
      JC(MC+2)=J+3
      JC(MC+3)=J+2
      JC(MC+4)=J+3
      JC(MC+5)=J+4
      JC(MC+6)=J+1
      JC(MC+7)=J+5
      MC=MC+8
  123 CONTINUE
      IC(NC+1)=MC
      MC=MC-1
      RETURN
  130 NC=2*(N-2)/3
      MC=1
      DO 133 I=1,NC/2
      J=(I-1)*3
      IC(2*I-1)=MC
      IC(2*I)=MC+5
      JC(MC)=J+1
      JC(MC+1)=J+2
      JC(MC+2)=J+3
      JC(MC+3)=J+4
      JC(MC+4)=J+5
      JC(MC+5)=J+3
      JC(MC+6)=J+4
      JC(MC+7)=J+5
      MC=MC+8
  133 CONTINUE
      IC(NC+1)=MC
      MC=MC-1
      RETURN
  140 NC=2*(N-2)/3
      MC=1
      DO 143 I=1,NC/2
      J=(I-1)*3
      IC(2*I-1)=MC
      IC(2*I)=MC+4
      JC(MC)=J+1
      JC(MC+1)=J+2
      JC(MC+2)=J+3
      JC(MC+3)=J+4
      JC(MC+4)=J+3
      JC(MC+5)=J+5
      MC=MC+6
  143 CONTINUE
      IC(NC+1)=MC
      MC=MC-1
      RETURN
  150 NC=3*(N-1)/4
      MC=1
      DO 153 I=1,NC/3
      J=(I-1)*4
      IC(3*I-2)=MC
      IC(3*I-1)=MC+3
      IC(3*I)=MC+6
      JC(MC)=J+1
      JC(MC+1)=J+2
      JC(MC+2)=J+3
      JC(MC+3)=J+2
      JC(MC+4)=J+3
      JC(MC+5)=J+4
      JC(MC+6)=J+3
      JC(MC+7)=J+4
      JC(MC+8)=J+5
      MC=MC+9
  153 CONTINUE
      IC(NC+1)=MC
      MC=MC-1
      RETURN
  160 NC=3*(N-1)/4
      MC=1
      DO 163 I=1,NC/3
      J=(I-1)*4
      IC(3*I-2)=MC
      IC(3*I-1)=MC+2
      IC(3*I)=MC+5
      JC(MC)=J+1
      JC(MC+1)=J+2
      JC(MC+2)=J+3
      JC(MC+3)=J+4
      JC(MC+4)=J+5
      JC(MC+5)=J+2
      JC(MC+6)=J+5
      MC=MC+7
  163 CONTINUE
      IC(NC+1)=MC
      MC=MC-1
      RETURN
  100 NC=N-7
      MC=0
      IC(1)=1
      DO 101 I=1,NC
      MC=MC+3
      JC(MC-2)=I
      JC(MC-1)=I+1
      JC(MC)=I+2
      MC=MC+5
      JC(MC-4)=N-4
      JC(MC-3)=N-3
      JC(MC-2)=N-2
      JC(MC-1)=N-1
      JC(MC)=N
      IC(I+1)=MC+1
  101 CONTINUE
      RETURN
      END
