C SUBROUTINE EIUD09                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  INITIATION FOR GLOBAL MINIMIZATION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RO  XL(N)  LOWER BOUNDS.
*  RO  XU(N)  UPPER BOUNDS.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD09(N,XL,XU,NEXT,IERR)
      INTEGER N,NEXT,IERR
      $FLOAT XL(N),XU(N)
      IERR=0
      GOTO (10,20,30,40,50,60,70,80,90,90,90,100,110), NEXT
C
C     SPONA FUNCTION
C
   10 IF (N.GE.2) THEN
      N=2
      XL(1)=-12.D0
      XU(1)=10.D0
      XL(2)=-12.D0
      XU(2)=10.D0
      ELSE
      IERR=1
      ENDIF
      RETURN
C
C     TRECCANI FUNCTION
C
   20 IF (N.GE.2) THEN
      N=2
      XL(1)=-3.0
      XU(1)=3.0
      XL(2)=-3.0
      XU(2)=3.0
      ELSE
      IERR=1
      ENDIF
      RETURN
C
C     SIMPLIFIED ROSENBROCK'S FUNCTION
C
   30 IF (N.GE.2) THEN
      N=2
      XL(1)=-3.0
      XU(1)=3.0
      XL(2)=-3.0
      XU(2)=3.0
      ELSE
      IERR=1
      ENDIF
      RETURN
C
C     RASTRIGIN
C
   40 IF (N.GE.2) THEN
      N=2
      XL(1)=-1.0D0
      XL(2)=-1.0D0
      XU(1)=1.0D0
      XU(2)=1.0D0
      ELSE
      IERR=1
      ENDIF
      RETURN
C
C     BRANIN
C
   50 IF (N.GE.2) THEN
      N=2
      XL(1)=-5.0D0
      XL(2)=0.0D0
      XU(1)=10.0D0
      XU(2)=15.0D0
      ELSE
      IERR=1
      ENDIF
      RETURN
C
C     GOLDSTEIN AND PRICE
C
   60 IF (N.GE.2) THEN
      N=2
      XL(1)=-2.0D0
      XL(2)=-2.0D0
      XU(1)=2.0D0
      XU(2)=2.0D0
      ELSE
      IERR=1
      ENDIF
      RETURN
C
C     3 HUMP CAMEL-BACK
C
   70 IF (N.GE.2) THEN
      N=2
      XL(1)=-3.0
      XU(1)=3.0
      XL(2)=-3.0
      XU(2)=3.0
      ELSE
      IERR=1
      ENDIF
      RETURN
C
C     6 HUMP CAMEL-BACK
C
   80 IF (N.GE.2) THEN
      N=2
      XL(1)=-3.0
      XU(1)=3.0
      XL(2)=-3.0
      XU(2)=3.0
      ELSE
      IERR=1
      ENDIF
      RETURN
C
C     SHEKEL 5,7,9
C
   90 IF (N.GE.4) THEN
      N=4
      XL(1)=0.0D0
      XL(2)=0.0D0
      XL(3)=0.0D0
      XL(4)=0.0D0
      XU(1)=10.0D0
      XU(2)=10.0D0
      XU(3)=10.0D0
      XU(4)=10.0D0
      ELSE
      IERR=1
      ENDIF
      RETURN
C
C     HARTMAN 3
C
  100 IF (N.GE.3) THEN
      N=3
      XL(1)=0.0D0
      XL(2)=0.0D0
      XL(3)=0.0D0
      XU(1)=1.0D0
      XU(2)=1.0D0
      XU(3)=1.0D0
      ELSE
      IERR=1
      ENDIF
      RETURN
C
C     HARTMAN 6
C
  110 IF (N.GE.6) THEN
      N=6
      XL(1)=0.0D0
      XL(2)=0.0D0
      XL(3)=0.0D0
      XL(4)=0.0D0
      XL(5)=0.0D0
      XL(6)=0.0D0
      XU(1)=1.0D0
      XU(2)=1.0D0
      XU(3)=1.0D0
      XU(4)=1.0D0
      XU(5)=1.0D0
      XU(6)=1.0D0
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
