* SUBROUTINE EIUD15                ALL SYSTEMS                00/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION WITH CHANGED TESTS 7-10, 12.
*  CHANGED FOR THE TESTS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NB  NUMBER OF APPROXIMATED FUNCTIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD15(N,NB,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NB,NEXT,IEXT,IERR
      $FLOAT X(N),FMIN,XMAX
      INTEGER I
      $FLOAT Y(20)
      COMMON /EMPR15/ Y
      $FLOAT ETA9
      PARAMETER (ETA9=1.0$P 60)
      FMIN=0.0$P 0
      XMAX=1.0$P 3
      IEXT=0
      IERR=0
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,260,270),NEXT
   10 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 11 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.2$P 0
        ELSE
          X(I)=1.0$P 0
        ENDIF
   11 CONTINUE
      NB=2*(N-1)
      RETURN
   20 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 21 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-2.0$P 0
          IF(I.LE.4) X(I)=-3.0$P 0
        ELSE
          X(I)=0.0$P 0
          IF(I.LE.4) X(I)=-1.0$P 0
        ENDIF
   21 CONTINUE
      NB=3*(N-2)
      RETURN
   30 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 31 I=1,N
        IF(MOD(I,4).EQ.1) THEN
          X(I)=3.0$P 0
        ELSEIF(MOD(I,4).EQ.2) THEN
          X(I)=-1.0$P 0
        ELSEIF(MOD(I,4).EQ.3) THEN
          X(I)=0.0$P 0
        ELSE
          X(I)=1.0$P 0
        ENDIF
   31 CONTINUE
      NB=2*(N-2)
      RETURN
   40 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 41 I=1,N
        X(I)=2.0$P 0
   41 CONTINUE
      X(1)=1.0$P 0
      NB=5*(N-2)/2
      XMAX=1.0$P 1
      RETURN
   50 IF (N.LT.3) GO TO 999
      DO 51 I=1,N
        X(I)=-1.0$P 0
   51 CONTINUE
      NB=N
      RETURN
   60 IF (N.LT.6) GO TO 999
      DO 61 I=1,N
        X(I)=-1.0$P 0
   61 CONTINUE
      NB=N
      RETURN
   70 IF (N.LT.2) GO TO 999
      DO 71 I=1,N-1
        X(I)=0.5$P 0
   71 CONTINUE
      X(N)=-2.0$P 0
      NB=2*(N-1)
      RETURN
   80 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      DO 81 I=1,N
        X(I)=SIN($DBLE(I))**2
   81 CONTINUE
      NB=5*N
      RETURN
   90 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 91 I=1,N
        X(I)=5.0$P 0
   91 CONTINUE
      NB=3*(N-2)
      RETURN
  100 IF (N.LT.2) GO TO 999
      DO 101 I=1,N
        X(I)=0.2$P 0
  101 CONTINUE
      NB=2*(N-1)
      RETURN
  110 CONTINUE
      IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 111 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-0.8$P 0
        ELSE
          X(I)=-0.8$P 0
        ENDIF
  111 CONTINUE
      NB=2*(N-1)
      RETURN
  120 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 121 I=1,N
        X(I)=-1.0$P 0
  121 CONTINUE
      NB=6*((N-5)/3+1)
      RETURN
  130 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 131 I=1,N
        X(I)=-1.0$P 0
  131 CONTINUE
      NB=7*((N-5)/3+1)
      RETURN
  140 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 141 I=1,N
        IF (MOD(I,4).EQ.1) THEN
          X(I)=-0.8$P 0
        ELSE IF (MOD(I,4).EQ.2) THEN
          X(I)= 1.2$P 0
        ELSE IF (MOD(I,4).EQ.3) THEN
          X(I)=-1.2$P 0
        ELSE
          X(I)= 0.8$P 0
        ENDIF
  141 CONTINUE
      Y(1)=14.4$P 0
      Y(2)=6.8$P 0
      Y(3)=4.2$P 0
      Y(4)=3.2$P 0
  142 IF (MOD(N-4,2).NE.0) N=N-MOD(N-4,2)
      NB=4*((N-4)/2+1)
      RETURN
  150 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 151 I=1,N
        IF (MOD(I,4).EQ.1) THEN
          X(I)=-0.8$P 0
        ELSE IF (MOD(I,4).EQ.2) THEN
          X(I)= 1.2$P 0
        ELSE IF (MOD(I,4).EQ.3) THEN
          X(I)=-1.2$P 0
        ELSE
          X(I)= 0.8$P 0
        ENDIF
  151 CONTINUE
      Y(1)=35.8$P 0
      Y(2)=11.2$P 0
      Y(3)=6.2$P 0
      Y(4)=4.4$P 0
      GO TO 142
  160 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 161 I=1,N
        IF (MOD(I,4).EQ.1) THEN
          X(I)=-0.8$P 0
        ELSE IF (MOD(I,4).EQ.2) THEN
          X(I)= 1.2$P 0
        ELSE IF (MOD(I,4).EQ.3) THEN
          X(I)=-1.2$P 0
        ELSE
          X(I)= 0.8$P 0
        ENDIF
  161 CONTINUE
      Y(1)=30.6$P 0
      Y(2)=72.2$P 0
      Y(3)=124.4$P 0
      Y(4)=187.4$P 0
      GO TO 142
  170 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      NB=N
      DO 171 I=1,N
        IF (MOD(I,8).EQ.1) X(I)=1.0$P-1
        IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0$P-1
        IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0$P-1
        IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0$P-1
        IF (MOD(I,8).EQ.5) X(I)=5.0$P-1
  171 CONTINUE
      RETURN
  180 IF (N.LT.3) GO TO 999
      NB=N
      DO 181 I=1,N
        X(I)=1.2$P 1
  181 CONTINUE
      RETURN
  190 IF (N.LT.7) GO TO 999
      NB=N
      DO 191 I=1,N
        X(I)=-1.0$P 0
  191 CONTINUE
      RETURN
  200 IF (N.LT.3) GO TO 999
      NB=N
      DO 201 I=1,N
        X(I)=$DBLE(I)/$DBLE(N+1)
        X(I)=X(I)*(X(I)-1.0$P 0)
  201 CONTINUE
      RETURN
  210 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 211 I=1,N
        X(I)=-1.0$P 0
  211 CONTINUE
      NB=7*((N-5)/3+1)
      RETURN
  220 IF (N.LT.3) GO TO 999
      DO 221 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.2$P 0
        ELSE
          X(I)= 1.0$P 0
        ENDIF
  221 CONTINUE
      NB=2*(N-1)
      RETURN
  260 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      DO 261 I=1,N
        X(I)=1.0$P 0
  261 CONTINUE
      NB=5*N
      RETURN
  270 IF (N.LT.7) GO TO 999
      DO 271 I=1,N
        X(I)=5.0$P 0
  271 CONTINUE
      Y(1)=SIN(1.0$P 0)
      NB=13*(N-6)
      RETURN
  999 IERR=1
      RETURN
      END
