* SUBROUTINE EIUD18             ALL SYSTEMS                 92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR NONLINEAR APPROXIMATION.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  IO  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD18(N,NA,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NA,NEXT,IEXT,IERR
      $FLOAT X(N),FMIN,XMAX,PAR
      INTEGER I,J,K,M,N1
      $FLOAT S,T
      COMMON /EMPR18/ PAR,M
      FMIN=0.0$P 0
      XMAX=1.0$P 4
      IEXT=0
      IERR=0
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,230,240,250,260,270,280,290,300,310,
     & 310,420,430,440,450,470,480,490,500,520,530,540,550),
     & NEXT
   10 IF(N.GE.4) THEN
      N=N-MOD(N,2)
      NA=N
      DO 11 I=1,N
      IF (MOD(I,8).EQ.1) X(I)=1.0$P-1
      IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0$P-1
      IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0$P-1
      IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0$P-1
      IF (MOD(I,8).EQ.5) X(I)=5.0$P-1
   11 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
   20 IF(N.GE.5) THEN
      N=N-MOD(N,2)
      NA=N
      DO 21 I=1,N
      IF (MOD(I,8).EQ.1) X(I)=1.0$P-1
      IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0$P-1
      IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0$P-1
      IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0$P-1
      IF (MOD(I,8).EQ.5) X(I)=5.0$P-1
   21 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
   30 IF(N.GE.5) THEN
      N=N-MOD(N,5)
      NA=N
      DO 31 I=1,N
      X(I)=1.0$P 0/$DBLE(N)
   31 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
   40 IF(N.GE.3) THEN
      DO 41 I=1,N
      X(I)=0.0$P 0
   41 CONTINUE
   42 NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
   50 IF(N.GE.3) THEN
      IF (MOD(N,2).NE.1) N=N-1
      NA=N
      DO 51 I=1,N
      X(I)=1.0$P 0
   51 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
   60 IF(N.GE.3) THEN
      DO 61 I=1,N
      X(I)=-1.0$P 0
   61 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
   70 IF(N.GE.3) THEN
      DO 71 I=1,N
      X(I)=1.2$P 1
   71 CONTINUE
      XMAX=1.0$P 2
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
   80 IF(N.GE.5) THEN
      NA=N
      DO 81 I=1,N
      X(I)=-2.0$P 0
   81 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
   90 IF(N.GE.7) THEN
      NA=N
      DO 91 I=1,N
      X(I)=-3.0$P 0
   91 CONTINUE
      XMAX=1.0$P 1
      ELSE
      IERR=1
      ENDIF
      RETURN
  100 IF(N.GE.7) THEN
      NA=N
      DO 101 I=1,N
      X(I)=-1.0$P 0
  101 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  110 IF(N.GE.2) THEN
      N=N-MOD(N,2)
      NA=N
      DO 111 I=1,N
      IF(MOD(I,2).EQ.1) THEN
      X(I)=9.0$P 1
      ELSE
      X(I)=6.0$P 1
      ENDIF
  111 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  120 IF(N.GE.4) THEN
      N=N-MOD(N,4)
      NA=N
      DO 121 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=3.0$P 0
      ELSE IF(MOD(I,4).EQ.2) THEN
      X(I)=-1.0$P 0
      ELSEIF(MOD(I,4).EQ.3) THEN
      X(I)=0.0$P 0
      ELSE
      X(I)=1.0$P 0
      ENDIF
  121 CONTINUE
      XMAX=1.0$P 2
      ELSE
      IERR=1
      ENDIF
      RETURN
  130 IF(N.GE.4) THEN
      N=N-MOD(N,4)
      NA=N
      DO 131 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=1.0$P 0
      ELSE IF(MOD(I,4).EQ.2) THEN
      X(I)=2.0$P 0
      ELSEIF(MOD(I,4).EQ.3) THEN
      X(I)=2.0$P 0
      ELSE
      X(I)=2.0$P 0
      ENDIF
  131 CONTINUE
      XMAX=1.0$P 1
      ELSE
      IERR=1
      ENDIF
      RETURN
  140 IF(N.GE.3) THEN
      DO 141 I=1,N
      X(I)=-1.0$P 0
  141 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  150 IF(N.GE.7) THEN
      NA=N
      DO 152 I=1,5
      X(I)=-1.0$P 0
  152 CONTINUE
      DO 154 I=6,N-1
      X(I)=-1.0$P 0
  154 CONTINUE
      X(N)=-1.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  160 IF(N.GE.2) THEN
      N=N-MOD(N,2)
      NA=N
      DO 161 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=0.0$P 0
      ELSE
      X(I)=1.0$P 0
      ENDIF
  161 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  170 IF (N.GE.4) THEN
      N=N-MOD(N,4)
      NA=N
      DO 171 I=2,N,2
      X(I-1)=-3.0$P 0
      X(I)=-1.0$P 0
  171 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  190 IF(N.GE.3) THEN
      DO 191 I=1,N
      X(I)=$DBLE(I)/$DBLE(N+1)
      X(I)=X(I)*(X(I)-1.0$P 0)
  191 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  310 IF(N.GE.3) THEN
      DO 311 I=1,N
      X(I)=5.0$P 0*MIN($DBLE(I)/$DBLE(N+1),1.0$P 0-$DBLE(I)/$DBLE(N+1))
  311 CONTINUE
      XMAX=1.0$P 4
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  200 IF(N.GE.3) THEN
      DO 201 I=1,N
      X(I)=1.0$P 1
  201 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  240 IF (N.GE.16) THEN
      M=INT(SQRT($DBLE(N)))
      PAR=6.8$P 0/$DBLE(M+1)**2
      N=M*M
      K=0
      DO 242 J=1,M
      DO 241 I=1,M
      K=K+1
      X(K)=0.0$P 0
  241 CONTINUE
  242 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  300 IF (N.GE.16) THEN
      M=INT(SQRT($DBLE(N)))
      N=M*M
      PAR=500.0$P 0
      K=0
      DO 302 J=1,M
      DO 301 I=1,M
      K=K+1
      X(K)=0.0$P 0
  301 CONTINUE
  302 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  320 IF (N.GE.3) THEN
      DO 321 I=1,N
      X(I)=5.0$P 0*MIN($DBLE(I)/$DBLE(N+1),1.0$P 0-$DBLE(I)/$DBLE(N+1))
  321 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  210 IF (N.GE.3) THEN
      DO 211 I=1,N
      X(I)=1.0$P 0
  211 CONTINUE
      PAR=1.0$P 1
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  180 IF (N.GE.3) THEN
      DO 181 I=1,N
      X(I)=1.5$P 0
  181 CONTINUE
C      XMAX=1.0$P 0
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  290 IF (N.GE.16) THEN
      M=INT(SQRT($DBLE(N)))
      N=M*M
      PAR=500.0$P 0/$DBLE(M+2)**4
      K=0
      DO 292 J=1,M
      DO 291 I=1,M
      K=K+1
      X(K)=0.0$P 0
  291 CONTINUE
  292 CONTINUE
      NA=N
      ELSE
        IERR=1
      ENDIF
      RETURN
  270 IF (N.GE.16) THEN
      M=INT(SQRT($DBLE(N)))
      PAR=5.0$P 1/$DBLE(M+1)
      N=M*M
      K=0
      DO 272 J=1,M
      DO 271 I=1,M
      K=K+1
      X(K)=1.0$P 0-$DBLE(I)*$DBLE(J)/$DBLE(M+1)**2
  271 CONTINUE
  272 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  250 IF (N.GE.16) THEN
      M=INT(SQRT($DBLE(N)))
      PAR=1.0$P 0/$DBLE(M+1)**2
      N=M*M
      K=0
      DO 252 J=1,M
      DO 251 I=1,M
      K=K+1
      X(K)=-1.0$P 0
  251 CONTINUE
  252 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  280 IF (N.GE.16) THEN
      M=INT(SQRT($DBLE(N)))
      PAR=1.0$P 0/$DBLE(M+1)
      N=M*M
      K=0
      DO 282 J=1,M
      DO 281 I=1,M
      K=K+1
      X(K)=0.0$P 0
  281 CONTINUE
  282 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  260 IF (N.GE.16) THEN
      M=INT(SQRT($DBLE(N)))
      PAR=1.0$P 0/$DBLE(M+1)**2
      N=M*M
      K=0
      DO 262 J=1,M
      DO 261 I=1,M
      K=K+1
      X(K)=0.0$P 0
  261 CONTINUE
  262 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  220 IF (N.GE.5) THEN
      PAR=5.0$P 2/$DBLE(N+2)
      NA=N
      DO 221 I=1,N
      X(I)=((DBLE(I)+0.5$P 0)/DBLE(N+2)-0.5$P 0)**2
  221 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  230 IF (N.GE.10) THEN
      N=N-MOD(N,2)
      M=N/2
      PAR=5.0$P 2
      NA=N
      DO 231 I=1,M
      X(I)=(DBLE(I)/DBLE(M+1)-0.5$P 0)**2
  231 CONTINUE
      DO 232 I=M+1,N
      K=I-M
      X(I)=DBLE(K)/DBLE(M+1)-0.5$P 0
  232 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  410 IF (N.LT.2) GO TO 999
      N1=N-1
      DO 411 I=1,N1
      X(I)=-1.2D 0
  411 CONTINUE
      X(N)=-1.0D 0
      NA=N
      RETURN
  420 IF (N.LT.3) GO TO 999
      DO 421 I=1,N
      X(I)=2.0D 0
  421 CONTINUE
      NA=N
      RETURN
  430 IF (N.LT.3) GO TO 999
      DO 431 I=1,N
      X(I)=0.0D 0
  431 CONTINUE
      NA=N
      RETURN
  440 IF (N.LT.3) GO TO 999
      DO 441 I=1,N
      X(I)=-1.0D 0
  441 CONTINUE
      NA=N
      RETURN
  450 IF (N.LT.7) GO TO 999
      DO 451 I=1,N
      X(I)=-1.0D 0
  451 CONTINUE
      NA=N
      RETURN
  460 IF (N.LT.2) GO TO 999
      DO 461 I=1,N
      X(I)=0.5D 0
  461 CONTINUE
      NA=N
      RETURN
  470 IF (N.LT.2) GO TO 999
      DO 471 I=1,N
      X(I)=0.5D 0
  471 CONTINUE
      NA=N
      RETURN
  480 IF (N.LT.3) GO TO 999
      DO 481 I=1,N
      X(I)=1.0D 0
  481 CONTINUE
      NA=N
      RETURN
  490 IF (N.LT.7) GO TO 999
      DO 491 I=1,N
      X(I)=-1.0D 0
  491 CONTINUE
      NA=N
      RETURN
  500 IF (N.LT.3) GO TO 999
      DO 501 I=1,N
      X(I)=1.0D 0
  501 CONTINUE
      NA=N
      RETURN
  520 IF (N.LT.3) GO TO 999
      DO 521 I=1,N
      X(I)=1.0D 0
  521 CONTINUE
      NA=N
      RETURN
  530 T=DBLE(2)/DBLE(N+2)
      N1=N/2
      DO 531 I=1,N1
      S=DBLE(I)*T
      X(I)=S*(1.0D 0-S)
      X(N1+I)=X(I)
  531 CONTINUE
      NA=N
      RETURN
  540 N1=INT(SQRT(DBLE(N)))
      N=N1*N1
      NA=N
      DO 541 I=1,N
      X(I)=1.0D 0
  541 CONTINUE
      RETURN
  550 N1=INT(SQRT(DBLE(N)))
      N=N1*N1
      NA=N
      DO 551 I=1,N
      X(I)=1.0D 0
  551 CONTINUE
      RETURN
  999 IERR=1
      RETURN
      END
