* SUBROUTINE EIUD30                ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR UNCONSTRAINED MINIMIZATION.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  IU  N  NUMBER OF VARIABLES.
*  IU  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  YA(NE)  INITIAL VALUES.
*  RO  EW(NE)  WEIGHT COEFFICIENTS IN THE TERMINAL FUNCTION.
*  RO  EY(NE)  REQUIRED VALUES IN THE TERMINAL FUNCTION.
*  RO  RMIN  MINIMUM FUNCTION VALUE.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  RO  TA  INITIAL TIME.
*  RO  TAMAX  FINAL TIME.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  II  IEXT  TYPE OF EXTREMUM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD30(N,NE,X,YA,EW,EY,FMIN,XMAX,TA,TAMAX,NEXT,IEXT,
     & IERR)
      INTEGER N,NE,NEXT,IEXT,IERR
      $FLOAT X(N),YA(NE),EW(NE),EY(NE),FMIN,XMAX,TA,TAMAX
      INTEGER I
      FMIN=0.0$P 0
      XMAX=1.0$P 3
      IEXT=0
      IERR=0
      DO 1 I=1,N
      X(I)=0.0$P 0
    1 CONTINUE
      DO 2 I=1,NE
      EY(I)=0.0$P 0
      EW(I)=0.0$P 0
    2 CONTINUE
      GOTO (10,10,30,40), NEXT
   10 N=2
      NE=4
      TA=0.0$P 0
      TAMAX=1.0$P 0
      EY(1)=1.0$P 0
      EW(1)=1.0$P 0
      EW(3)=1.0$P 0
      YA(2)=0.0$P 0
      YA(4)=0.0$P 0
      RETURN
   30 N=2
      NE=5
      TA=0.0$P 0
      TAMAX=3.5$P 0
      EY(4)=1.0$P 0
      EW(2)=1.0$P 0
      EW(4)=1.0$P 0
      YA(1)=0.0$P 0
      YA(2)=0.0$P 0
      YA(4)=0.0$P 0
      RETURN
   40 N=3
      NE=5
      TA=0.0$P 0
      TAMAX=1.0$P 0
      EY(3)=0.5$P 0
      EW(1)=1.0$P 0
      EW(3)=1.0$P 0
      EW(5)=1.0$P 0
      YA(1)=0.0$P 0
      YA(3)=1.0$P 0
      YA(5)=0.0$P 0
      RETURN
      END
