* SUBROUTINE EIUD36             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR NONLINEAR EQUATIONS.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  IO  N  NUMBER OF VARIABLES.
*  IO  NA  NUMBER OF EQUATIONS.
*  IO  NAL NUMBER OF LINEAR EQUATIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  IO  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD36(N,NA,NAL,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NA,NAL,NEXT,IEXT,IERR
      $FLOAT X(N),FMIN,XMAX
      NA=N
      NAL=0
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      IF (NEXT.LE.32) THEN
      CALL EIUD16(N,NA,NAL,X,FMIN,XMAX,NEXT,IEXT,IERR)
      ELSE IF (NEXT.LE.62) THEN
      CALL EIUD17(N,NA,NAL,X,FMIN,XMAX,NEXT-32,IEXT,IERR)
      ELSE IF (NEXT.LE.94) THEN
      CALL EIUD18(N,NA,X,FMIN,XMAX,NEXT-62,IEXT,IERR)
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
