* SUBROUTINE EIUD43             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR NONLINEAR APPROXIMATION.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  IO  N  NUMBER OF VARIABLES.
*  IO  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  IO  NAL NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  IO  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD43(N,NA,NAL,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NA,NAL,NEXT,IEXT,IERR
      $FLOAT X(N),FMIN,XMAX
      $FLOAT Y(65)
      COMMON /EMPR43/ Y
      NAL=0
      FMIN=0.0$P 0
      XMAX=1.0$P 3
      IEXT=0
      IERR=0
      GOTO(10,20,30,40,50,60),NEXT
   10 IF(N.GE.3.AND.NA.GE.10) THEN
      N=3
      NA=10
      X(1)=2.0$P 1
      X(2)=LOG(2.0$P 0)
      X(3)=5.0$P-1
      Y(1)=16.7$P 0
      Y(2)=16.8$P 0
      Y(3)=16.9$P 0
      Y(4)=17.1$P 0
      Y(5)=17.2$P 0
      Y(6)=17.4$P 0
      Y(7)=17.6$P 0
      Y(8)=17.9$P 0
      Y(9)=18.1$P 0
      Y(10)=18.7$P 0
      Y(11)=1.0$P 0
      Y(12)=5.0$P 0
      Y(13)=10.0$P 0
      Y(14)=15.0$P 0
      Y(15)=20.0$P 0
      Y(16)=25.0$P 0
      Y(17)=30.0$P 0
      Y(18)=35.0$P 0
      Y(19)=40.0$P 0
      Y(20)=50.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   20 IF(N.GE.2.AND.NA.GE.10) THEN
      N=2
      NA=10
      X(1)=0.3$P 0
      X(2)=0.4$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   30 IF(N.GE.3.AND.NA.GE.16) THEN
      N=3
      NA=16
      X(1)=LOG(2.0$P-2)
      X(2)=4.0$P 3
      X(3)=2.5$P 2
      Y(1)=3478$P 1
      Y(2)=2861$P 1
      Y(3)=2365$P 1
      Y(4)=1963$P 1
      Y(5)=1637$P 1
      Y(6)=1372$P 1
      Y(7)=1154$P 1
      Y(8)=9744$P 0
      Y(9)=8261$P 0
      Y(10)=7030$P 0
      Y(11)=6005$P 0
      Y(12)=5147$P 0
      Y(13)=4427$P 0
      Y(14)=3820$P 0
      Y(15)=3307$P 0
      Y(16)=2872$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   40 IF(N.GE.4.AND.NA.GE.10) THEN
      N=4
      NA=10
      X(1)=LOG(1.0$P 0)
      X(2)=LOG(1.0$P 0)
      X(3)=1.0$P 0
      X(4)=1.0$P 0
      Y(1)=99.6$P 0
      Y(2)=67.1$P 0
      Y(3)=45.9$P 0
      Y(4)=31.9$P 0
      Y(5)=22.5$P 0
      Y(6)=16.1$P 0
      Y(7)=11.7$P 0
      Y(8)=8.60$P 0
      Y(9)=6.38$P 0
      Y(10)=4.78$P 0
      XMAX=1.0$P 1
      ELSE
      IERR=1
      ENDIF
      RETURN
   50 IF(N.GE.4.AND.NA.GE.16) THEN
      N=4
      NA=16
      X(1)=LOG(1.0$P 5)
      X(2)=LOG(1.0$P 5)
      X(3)=-1.679$P 0
      X(4)=-1.310$P 0
      Y(1)=57.544$P 0
      Y(2)=53.546$P 0
      Y(3)= 3.006$P 0
      Y(4)=19.498$P 0
      Y(5)=16.444$P 0
      Y(6)= 4.305$P 0
      Y(7)=45.290$P 0
      Y(8)=27.952$P 0
      Y(9)=11.803$P 0
      Y(10)= 4.764$P 0
      Y(11)=51.286$P 0
      Y(12)=31.623$P 0
      Y(13)=21.777$P 0
      Y(14)=13.996$P 0
      Y(15)= 7.727$P 0
      Y(16)= 4.990$P 0
      Y(17)= 7.448$P 0
      Y(18)= 7.448$P 0
      Y(19)= 9.439$P 0
      Y(20)= 7.969$P 0
      Y(21)= 8.176$P 0
      Y(22)= 9.284$P 0
      Y(23)= 7.552$P 0
      Y(24)= 7.877$P 0
      Y(25)= 8.552$P 0
      Y(26)= 9.314$P 0
      Y(27)= 7.607$P 0
      Y(28)= 7.847$P 0
      Y(29)= 8.176$P 0
      Y(30)= 8.523$P 0
      Y(31)= 8.903$P 0
      Y(32)= 9.314$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   60 IF(N.GE.4.AND.NA.GE.12) THEN
      N=4
      NA=12
      X(1)=LOG(1.0$P 2)
      X(2)=LOG(1.0$P-2)
      X(3)=2.0$P 0
      X(4)=1.0$P 1
      Y(1)=7.31$P 0
      Y(2)=7.55$P 0
      Y(3)=7.80$P 0
      Y(4)=8.05$P 0
      Y(5)=8.31$P 0
      Y(6)=8.57$P 0
      Y(7)=8.84$P 0
      Y(8)=9.12$P 0
      Y(9)=9.40$P 0
      Y(10)=9.69$P 0
      Y(11)=9.99$P 0
      Y(12)=10.30$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
