* SUBROUTINE EIUS99                ALL SYSTEMS                11/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES, STRUCTURE OF SIMPLE BOUNDS AND
*  THE SPARSE HESSIAN MATRIX FOR COMPLEMENTARITY PROBLEMS.
*
* PARAMETERS :
*  IU  NF  NUMBER OF VARIABLES.
*  IU  NX  NUMBER OF BOX CONSTRAINTS (SIMPLE BOUNDS).
*  IU  M  NUMBER OF ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  RO  X(NF)  INITIAL VECTOR OF VARIABLES.
*  IO  IX(NX)  VECTOR CONTAINING TYPES OF BOX CONSTRAINTS.
*  IO  XL(NX)  LOWER BOUNDS FOR VARIABLES
*  IO  XU(NX)  UPPER BOUNDS FOR VARIABLES
*  IO  IH(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EIUS99(NF,NX,M,X,IX,XL,XU,IH,JH,FMIN,XMAX,NEXT)
      INTEGER NF,NX,M,IX(NX),IH(NF+1),JH(*),NEXT
      $FLOAT X(NF),XL(NX),XU(NX),FMIN,XMAX
      INTEGER I
      $FLOAT WL
      FMIN=-1.0$P 120
      XMAX=1.0$P 3
      GOTO (10,20,30,40,40,40,40,40,90,100,110,120,130,140,140,140,140,
     &140,190,200,210,220,230,240,250,250,270,270,290), NEXT
C
C     DESILVA QQR-AY-NCP-6-2-2
C
   10 NF=6
      NX=4
      DO 11 I=1,NF
        X(I)=0.0$P 0
   11 CONTINUE
      DO 12 I=1,4
        IX(I)=1
        XL(I)=0.0$P 0
   12 CONTINUE
      IX(5)=0
      IX(6)=0
      M=6
      DO 13 I=1,NF
        IH(I)=I
        JH(I)=I
   13 CONTINUE
      IH(7)=7
      RETURN
C
C     DF1 QQR-AY-NCP-2-2-1
C
   20 NF=2
      NX=2
      DO 21 I=1,NF
        X(I)=0.0$P 0
   21 CONTINUE
      IX(1)=3
      XL(1)=-1.0$P 0
      XU(1)=SQRT(2.0$P 0)
      IX(2)=1
      XL(2)=0.0$P 0
      M=3
      IH(1)=1
      IH(2)=3
      IH(3)=4
      JH(1)=1
      JH(2)=2
      JH(3)=2
      RETURN
C
C     DEMPE QQR-AY-LCP-4-2-2
C
   30 NF=3
      NX=1
      X(1)=3.003790$P 0
      X(2)=0.183193$P 0
      X(3)=0.428106$P 0
      IX(1)=1
      XL(1)=0.0$P 0
      M=3
      DO 31 I=1,NF
        IH(I)=I
        JH(I)=I
   31 CONTINUE
      IH(4)=4
      RETURN
C
C     GNASH10 OOR-AY-LCP-13-4-8
C     GNASH11 OOR-AY-LCP-13-4-8
C     GNASH12 OOR-AY-LCP-13-4-8
C     GNASH13 OOR-AY-LCP-13-4-8
C     GNASH14 OOR-AY-LCP-13-4-8
C
   40 WL=1.5$P 2
      NF=13
   41 NX=NF
      IX(1)=3
      XL(1)=1.0$P-8
      XU(1)=WL
      DO 42 I=2,NF
        IX(I)=1
        XL(I)=0.0$P 0
   42 CONTINUE
      X(1)=7.5$P 1
      DO 43 I=2,NF
        X(I)=0.0$P 0
   43 CONTINUE
      IH(1)=1
      JH(1)=1
      JH(2)=2
      JH(3)=3
      JH(4)=4
      JH(5)=5
      IH(2)=6
      JH(6)=2
      JH(7)=3
      JH(8)=4
      JH(9)=5
      IH(3)=10
      JH(10)=3
      JH(11)=4
      JH(12)=5
      IH(4)=13
      JH(13)=4
      JH(14)=5
      IH(5)=15
      DO 44 I=5,NF
        JH(10+I)=I
        IH(I+1)=IH(I)+1
   44 CONTINUE
      M=IH(NF)
      RETURN
C
C     GNASH15 OOR-AY-LCP-13-4-8
C
   90 WL=5.0$P 1
      NF=13
      GOTO 41
C
C     GNASH16 OOR-AY-LCP-13-4-8
C
  100 WL=4.0$P 1
      NF=13
      GOTO 41
C
C     GNASH17 OOR-AY-LCP-13-4-8
C
  110 WL=3.0$P 1
      NF=13
      GOTO 41
C
C     GNASH18 OOR-AY-LCP-13-4-8
C
  120 WL=2.5$P 1
      NF=13
      GOTO 41
C
C     GNASH19 OOR-AY-LCP-13-4-8
C
  130 WL=2.0$P 1
      NF=13
      GOTO 41
C
C     GNASH10M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH11M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH12M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH13M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH14M OOR-AY-LCP-9-8-8   MODIFIED
C
  140 WL=1.5$P 2
      NF=9
      GOTO 41
C
C     GNASH15M OOR-AY-LCP-9-8-8   MODIFIED
C
  190 WL=5.0$P 1
      NF=9
      GOTO 41
C
C     GNASH16M OOR-AY-LCP-9-8-8   MODIFIED
C
  200 WL=4.0$P 1
      NF=9
      GOTO 41
C
C     GNASH17M OOR-AY-LCP-9-8-8   MODIFIED
C
  210 WL=3.0$P 1
      NF=9
      GOTO 41
C
C     GNASH18M OOR-AY-LCP-9-8-8   MODIFIED
C
  220 WL=2.5$P 1
      NF=9
      GOTO 41
C
C     GNASH19M OOR-AY-LCP-9-8-8   MODIFIED
C
  230 WL=2.0$P 1
      NF=9
      GOTO 41
C
C     DESIGN-CENT-1 QOR-AY-NLP-12-9-3
C
  240 NF=12
      NX=NF
      DO 241 I=1,8
        IX(I)=0
  241 CONTINUE
      IX(9)=1
      XL(9)=-1.0$P 0
      DO 242 I=10,12
        IX(I)=1
        XL(I)=0.0$P 0
  242 CONTINUE
      X(1)=0.0$P 0
      X(2)=0.0$P 0
      X(3)=1.0$P 0
      X(4)=-1.000000000000073$P 0
      X(5)=0.2425356250359245$P 0
      X(6)=0.0$P 0
      X(7)=0.0$P 0
      X(8)=0.9701425001468117$P 0
      X(9)=-1.000000000026019$P 0
      X(10)=0.5000000393303194$P 0
      X(11)=0.5153882031999911$P 0
      X(12)=0.4999999999777709$P 0
      DO 243 I=1,NF
        IH(I)=I
        JH(I)=I
  243 CONTINUE
      IH(NF+1)=NF+1
      M=NF
      RETURN
C
C     DESIGN-CENT-2 QOR-MY-NLP-13-13-3
C     DESIGN-CENT-21 QOR-MY-NLP-13-13-3
C
  250 NF=13
      NX=NF-1
      DO 251 I=1,8
        IX(I)=0
  251 CONTINUE
      IX(9)=1
      XL(9)=-1.0$P 0
      DO 252 I=10,12
        IX(I)=1
        XL(I)=0.0$P 0
  252 CONTINUE
      IX(13)=0
      X(1)=0.0$P 0
      X(2)=0.0$P 0
      X(3)=1.0$P 0
      X(4)=-1.000000000000073$P 0
      X(5)=0.2425356250359245$P 0
      X(6)=0.0$P 0
      X(7)=0.0$P 0
      X(8)=0.9701425001468117$P 0
      X(9)=-1.000000000026019$P 0
      X(10)=0.5000000393303194$P 0
      X(11)=0.5153882031999911$P 0
      X(12)=0.4999999999777709$P 0
      X(13)=1.0$P 0
      DO 253 I=1,3
        IH(I)=I
        JH(I)=I
  253 CONTINUE
      IH(4)=5
      JH(4)=4
      DO 254 I=4,NF
        JH(I+1)=I
        IH(I+1)=IH(I)+1
  254 CONTINUE
      M=NF+1
      RETURN
C
C     DESIGN-CENT-3 QOR-MY-NLP-15-9-3
C     DESIGN-CENT-31 QOR-MY-NLP-15-9-3
C
  270 NF=15
      NX=NF
      DO 271 I=1,11
        IX(I)=0
  271 CONTINUE
      IX(12)=1
      XL(12)=-1.0$P 0
      DO 272 I=13,15
        IX(I)=1
        XL(I)=0.0$P 0
  272 CONTINUE
      X(1)=0.0$P 0
      X(2)=0.0$P 0
      X(3)=1.0$P 0
      X(4)=0.0$P 0
      X(5)=0.0$P 0
      X(6)=1.0$P 0
      X(7)=-1.000000000000073$P 0
      X(8)=0.2425356250359245$P 0
      X(9)=0.0$P 0
      X(10)=0.0$P 0
      X(11)=0.9701425001468117$P 0
      X(12)=-1.000000000026019$P 0
      X(13)=0.5000000393303194$P 0
      X(14)=0.5153882031999911$P 0
      X(15)=0.4999999999777709$P 0
      DO 273 I=1,3
        IH(I)=I
        JH(I)=I
  273 CONTINUE
      IH(4)=5
      IH(5)=7
      JH(4)=6
      JH(5)=4
      JH(6)=5
      DO 274 I=5,NF
        IH(I+1)=IH(I)+1
        JH(I+2)=I
  274 CONTINUE
      M=NF+2
      RETURN
C
C	DESIGN-CENT-4 QOR-AY-NLP-22-9-12
C
  290 NF=22
      NX=NF
      DO 291 I=1,9
        IX(I)=0
  291 CONTINUE
      IX(10)=1
      XL(10)=-1.0$P 0
      DO 292 I=11,22
        IX(I)=1
        XL(I)=0.0$P 0
  292 CONTINUE
      X(1)=3.0$P 0
      X(2)=0.0$P 0
      X(3)=0.0$P 0
      X(4)=-1.0$P 0
      X(5)=0.0$P 0
      X(6)=3.0$P 0
      X(7)=0.0$P 0
      X(8)=0.0$P 0
      X(9)=0.0$P 0
      X(10)=-1.0$P 0
      DO 293 I=11,23
        X(I)=0.0$P 0
  293 CONTINUE
      X(22)=1.0$P 0
      IH(1)=1
      JH(1)=1
      JH(2)=2
      JH(3)=4
      IH(2)=4
      JH(4)=2
      JH(5)=3
      IH(3)=6
      JH(6)=3
      JH(7)=4
      IH(4)=8
      DO 294 I=4,NF
        JH(I+4)=I
        IH(I+1)=IH(I)+1
  294 CONTINUE
      M=NF+4
      RETURN
      

      END
      