* SUBROUTINE EAFU17             ALL SYSTEMS                 92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR EQUATIONS.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FA  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAFU17(N,KA,X,FA,NEXT)
      INTEGER I,J,N,KA,NEXT
      REAL*8 X(N),FA
      REAL*8 A,B,C,U,V,W
      REAL*8 Y(530)
      COMMON /EMPR17/ Y
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     &      170,180,190,200,210,220,230,240,250,260,270,280,290,
     &      300),NEXT
   10 GOTO (11,12),KA
   11 FA=1.0D 1*(X(2)-X(1)**2)
      RETURN
   12 FA=1.0D 0-X(1)
      RETURN
   20 GOTO (21,22), KA
   21 FA=1.0D 2*(X(2)-X(1)**2)**2
      RETURN
   22 FA=(X(1)-1.0D 0)**2
      RETURN
   30 GOTO (31,32),KA
   31 FA=1.0D 4*X(1)*X(2)-1.0D 0
      RETURN
   32 FA=EXP(-X(1))+EXP(-X(2))-1.0001D 0
      RETURN
   40 GOTO(41,42,43),KA
   41 FA=3.0D 0*X(1)+X(2)+2.0D 0*X(3)**2-3.0D 0
      RETURN
   42 FA=2.0D 0*X(1)*X(3)-3.0D 0*X(1)+5.0D 0*X(2)**2-1.0D 0
      RETURN
   43 FA=2.5D 1*X(1)*X(2)+2.0D 1*X(3)+1.2D 1
      RETURN
   50 GOTO(51,52,53),KA
   51 FA=1.6D 1*(X(1)**4+X(2)**4-1.0D 0)+X(3)**4
      RETURN
   52 FA=X(1)**2+X(2)**2+X(3)**2-3.0D 0
      RETURN
   53 FA=X(1)**3-X(2)
      RETURN
   60 A=5.0D-1*DBLE(KA)
      FA=EXP(-A*X(1))-EXP(-A*X(2))-X(3)*(EXP(-A)-EXP(-1.0D 1*A))
      RETURN
   70 GOTO (71,72,73),KA
   71 IF(X(1).EQ.0.0D 0) THEN
      A=0.0D 0
      ELSE
      A=0.5D 0*ATAN(X(2)/X(1))/3.14159265358979323846D 0
      ENDIF
      IF(X(1).LT.0.0D 0) A=A+0.5D 0
      FA=1.0D 1*(X(3)-1.0D 1*A)
      RETURN
   72 FA=1.0D 1*SQRT(X(1)**2+X(2)**2)-1.0D 0
      RETURN
   73 FA=X(3)
      RETURN
   80 GOTO (81,82,83,84),KA
   81 FA=X(1)+1.0D 1*X(2)
      RETURN
   82 FA=2.236068D 0*(X(3)-X(4))
      RETURN
   83 FA=(X(2)-2.0D 0*X(3))**2
      RETURN
   84 FA=3.162279D 0*(X(1)-X(4))**2
      RETURN
   90 W=0.3D 0*DBLE(KA)
      A=EXP(-W*X(1))
      B=EXP(-W*X(2))
      C=EXP(-W*X(3))
      FA=X(4)*A-X(5)*B+X(6)*C-Y(KA)
      RETURN
  100 GO TO (101,102,103,104,105,106),KA
  101 FA=Y(1)*X(1)+Y(2)*X(4)-1014845.07D 0
      RETURN
  102 FA=(Y(3)*X(2)*X(3)+Y(4)*X(6))*X(3)-Y(2)*(X(2)-X(5))
      RETURN
  103 FA=(Y(5)*X(5)*X(3)+Y(6)*X(6))*X(3)-Y(2)*(X(2)-X(5))
      RETURN
  104 FA=(Y(5)*X(6)*X(3)-Y(4)*X(2)+Y(6)*X(5))*X(3)-Y(2)*X(6)
      RETURN
  105 FA=(3.0D 0*Y(7)*X(1)-Y(8))*(X(2)*X(3))**3+
     & 4.0D 0*((Y(7)*X(1)-Y(8))*X(1)+Y(9))*X(1)*X(2)*X(3)-
     & (Y(4)*(X(2)-X(5))+Y(10)*X(2))*X(3)-Y(2)*X(6)
      RETURN
  106 FA=Y(11)*(X(2)*X(3))**4+Y(2)*(X(4)-1.0D 0)+
     & ((3.0D 0*Y(7)*X(1)-2.0D 0*Y(8))*X(1)+Y(9))*(X(2)*X(3))**2+
     & (((Y(7)*X(1)-Y(12))*X(1)+2.0D 0*Y(9))*X(1)-Y(10))*X(1)
      RETURN
  110 FA=224.0D 0*X(KA)+DBLE(KA-8)**3
      DO 111 I=1,N
      IF (I.NE.KA) THEN
      A=SQRT(X(I)**2+DBLE(KA)/DBLE(I))
      B=LOG(A)
      FA=FA+A*(SIN(B)**5+COS(B)**5)
      ENDIF
  111 CONTINUE
      RETURN
  120 J=(KA-1)*N
      FA=Y(KA+512)
      DO 121 I=1,N
      FA=FA-Y(J+I)*SIN(X(I))-Y(J+I+256)*COS(X(I))
  121 CONTINUE
      RETURN
  130 J=(KA-1)/5
      FA=5.0D 0-DBLE(J+1)*(1.0D 0-COS(X(KA)))-SIN(X(KA))
      J=J*5
      DO 131 I=J+1,J+5
      FA=FA-COS(X(I))
  131 CONTINUE
      RETURN
  140 IF (KA.LT.2) THEN
      FA=3.0D 0*X(KA)**3+2.0D 0*X(KA+1)-5.0D 0+
     & SIN(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))
      ELSE IF (KA.LT.N) THEN
      FA=3.0D 0*X(KA)**3+2.0D 0*X(KA+1)-5.0D 0+
     & SIN(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))+4.0D 0*X(KA)-
     & X(KA-1)*EXP(X(KA-1)-X(KA))-3.0D 0
      ELSE
      FA=4.0D 0*X(KA)-X(KA-1)*EXP(X(KA-1)-X(KA))-3.0D 0
      ENDIF
      RETURN
  150 IF (MOD(KA,2).EQ.1) THEN
      FA=0.0D 0
      IF (KA.NE.1) FA=FA-6.0D 0*(X(KA-2)-X(KA))**3+1.0D 1-
     & 4.0D 0*X(KA-1)-2.0D 0*SIN(X(KA-2)-X(KA-1)-X(KA))*
     & SIN(X(KA-2)+X(KA-1)-X(KA))
      IF (KA.NE.N) FA=FA+3.0D 0*(X(KA)-X(KA+2))**3-5.0D 0+
     & 2.0D 0*X(KA+1)+SIN(X(KA)-X(KA+1)-X(KA+2))*
     & SIN(X(KA)+X(KA+1)-X(KA+2))
      ELSE
      FA=4.0D 0*X(KA)-(X(KA-1)-X(KA+1))*EXP(X(KA-1)-X(KA)-X(KA+1))-
     & 3.0D 0
      ENDIF
      RETURN
  160 W=0.0D 0
      DO 161 I=1,N-1
      W=W+(DBLE(KA)/DBLE(KA+I))*X(I)
  161 CONTINUE
      FA=X(KA)-(1.0D 0+(0.4D 0/DBLE(N))*X(KA)*(0.5D 0+W+
     & 0.5D 0*(DBLE(KA)/DBLE(KA+N))*X(N)))
      RETURN
  170 IF (KA.LT.2) THEN
      FA=4.0D 0*(X(KA)-X(KA+1)**2)
      ELSE IF (KA.LT.N) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)
      ELSE
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))
      ENDIF
      RETURN
  180 IF (KA.LT.2) THEN
      FA=4.0D 0*(X(KA)-X(KA+1)**2)+X(KA+1)-X(KA+2)**2
      ELSE IF (KA.LT.3) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA+1)-X(KA+2)**2
      ELSE IF (KA.LT.N-1) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+X(KA+1)-
     & X(KA+2)**2
      ELSE IF (KA.LT.N) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)
      ELSE
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))
     & +X(KA-1)**2-X(KA-2)
      ENDIF
      RETURN
  190 IF (KA.LT.2) THEN
      FA=4.0D 0*(X(KA)-X(KA+1)**2)+X(KA+1)-X(KA+2)**2+
     & X(KA+2)-X(KA+3)**2
      ELSE IF (KA.LT.3) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2+X(KA+1)-X(KA+2)**2+
     & X(KA+2)-X(KA+3)**2
      ELSEIF (KA.LT.4) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+
     & X(KA+1)-X(KA+2)**2+X(KA-2)**2+X(KA+2)-X(KA+3)**2
      ELSE IF (KA.LT.N-2) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+
     & X(KA+1)-X(KA+2)**2+X(KA-2)**2-X(KA-3)+X(KA+2)-X(KA+3)**2
      ELSE IF (KA.LT.N-1) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+
     & X(KA+1)-X(KA+2)**2+X(KA-2)**2-X(KA-3)+X(KA+2)
      ELSE IF (KA.LT.N) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+
     & X(KA+1)+X(KA-2)**2-X(KA-3)
      ELSE
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))
     & +X(KA-1)**2-X(KA-2)+X(KA-2)**2-X(KA-3)
      ENDIF
      RETURN
  200 IF(KA.LE.N-2) THEN
      A=0.0D 0
      B=X(1)
      W=DBLE(KA)/DBLE(N-2)
      DO 201 J=2,N
      A=A+DBLE(J-1)*X(J)*W**(J-2)
      B=B+X(J)*W**(J-1)
  201 CONTINUE
      FA=A-B**2-1.0D 0
      ELSEIF(KA.EQ.N-1) THEN
      FA=X(1)
      ELSEIF(KA.EQ.N) THEN
      FA=X(2)-X(1)**2-1.0D 0
      ENDIF
      RETURN
  210 IF(MOD(KA,2).EQ.1) THEN
      FA=1.0D 1*(X(KA+1)-X(KA)**2)
      ELSE
      FA=1.0D 0-X(KA-1)
      ENDIF
      RETURN
  220 IF(MOD(KA,4).EQ.1) THEN
      FA=X(KA)+1.0D 1*X(KA+1)
      ELSEIF(MOD(KA,4).EQ.2) THEN
      FA=2.23606797749979D 0*(X(KA+1)-X(KA+2))
      ELSEIF(MOD(KA,4).EQ.3) THEN
      FA=(X(KA-1)-2.0D 0*X(KA))**2
      ELSE
      FA=3.16227766016838D 0*(X(KA-3)-X(KA))**2
      ENDIF
      RETURN
  230 IF(MOD(KA,4).EQ.1) THEN
      FA=(EXP(X(KA))-X(KA+1))**2
      ELSE IF (MOD(KA,4).EQ.2) THEN
      FA=1.0D 1*(X(KA)-X(KA+1))**3
      ELSE IF (MOD(KA,4).EQ.3) THEN
      FA=X(KA)-X(KA+1)
      FA=(SIN(FA)/COS(FA))**2
      ELSE
      FA=X(KA)-1.0D 0
      ENDIF
      RETURN
  240 IF(KA.LT.2) THEN
      FA=X(KA)*(0.5D 0*X(KA)-3.0D 0)-1.0D 0+2.0D 0*X(KA+1)
      ELSE IF (KA.LT.N) THEN
      FA=X(KA-1)+X(KA)*(0.5D 0*X(KA)-3.0D 0)-1.0D 0+2.0D 0*X(KA+1)
      ELSE
      FA=X(KA-1)+X(KA)*(0.5D 0*X(KA)-3.0D 0)-1.0D 0
      ENDIF
      RETURN
  250 FA=(2.0D 0+5.0D 0*X(KA)**2)*X(KA)+1.0D 0
      DO 251 I=MAX(1,KA-5),MIN(N,KA+1)
      FA=FA+X(I)*(1.0D 0+X(I))
  251 CONTINUE
      RETURN
  260 A=0.0D 0
      DO 261 J=1,N
      A=A+COS(X(J))
  261 CONTINUE
      FA=DBLE(N)-A+DBLE(KA)*(1.0D 0-COS(X(KA)))-SIN(X(KA))
      RETURN
  270 IF(KA.LT.N) THEN
      A=0.0D 0
      DO 271 J=1,N
      A=A+X(J)
  271 CONTINUE
      FA=X(KA)+A-DBLE(N+1)
      ELSE
      A=1.0D 0
      DO 272 J=1,N
      A=A*X(J)
  272 CONTINUE
      FA=A-1.0D 0
      ENDIF
      RETURN
  280 U=1.0D 0/DBLE(N+1)
      V=DBLE(KA)*U
      FA=2.0D 0*X(KA)+0.5D 0*U*U*(X(KA)+V+1.0D 0)**3
      IF(KA.GT.1) FA=FA-X(KA-1)
      IF(KA.LT.N) FA=FA-X(KA+1)
      RETURN
  290 U=1.0D 0/DBLE(N+1)
      V=DBLE(KA)*U
      A=0.0D 0
      B=0.0D 0
      DO 291 J=1,N
      W=DBLE(J)*U
      IF(J.LE.KA) THEN
      A=A+W*(X(J)+W+1.0D 0)**3
      ELSE
      B=B+(1.0D 0-W)*(X(J)+W+1.0D 0)**3
      ENDIF
  291 CONTINUE
      FA=X(KA)+U*((1.0D 0-V)*A+V*B)/2.0D 0
      RETURN
  300 FA=(3.0D 0-2.0D 0*X(KA))*X(KA)+1.0D 0
      IF(KA.GT.1) FA=FA-X(KA-1)
      IF(KA.LT.N) FA=FA-2.0D 0*X(KA+1)
      RETURN
      END
