* SUBROUTINE EAGU06             ALL SYSTEMS                 90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FA  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU06(N,KA,X,GA,NEXT)
      INTEGER N,KA,NEXT
      REAL*8 X(N),GA(N)
      REAL*8 FA,T,X1,X2,X3,X4,X5,X6,X7,X8
      COMPLEX*16 CA(4),CB(4),CC(6),C1,C2,C3
      REAL*8 XA(3),XB(3),XC(3),BETA
      INTEGER I,J
      REAL*8 Y(123),PI
      COMMON /EMPR06/ Y
      PARAMETER (PI=3.14159265358979323846D 0)
      GOTO(10,190,180,80,20,170,120,90,230,210,140,150,200,30,130,100,
     & 40,110,50,60,70,220,160,240,250),NEXT
   10 X1=X(1)*X(1)
      X2=X(2)*X(2)
      X3=X(1)+X(1)
      X4=X(2)+X(2)
      GO TO (11,12,13),KA
   11 GA(1)=X3
      GA(2)=(X2+X2)*X4
      RETURN
   12 GA(1)=-4.0D 0+X3
      GA(2)=-4.0D 0+X4
      RETURN
   13 FA=2.0D 0*EXP(X(2)-X(1))
      GA(1)=-FA
      GA(2)=+FA
      RETURN
  190 X1=1.0D 0/(X(1)+1.0D-1)**2
      GA(2)=2.0D 0*X(2)
      IF (KA.EQ.1) THEN
      GA(1)=0.5D 0*( 1.0D 0+X1)
      ELSE IF (KA.EQ.2) THEN
      GA(1)=0.5D 0*(-1.0D 0+X1)
      ELSE IF (KA.EQ.3) THEN
      GA(1)=0.5D 0*( 1.0D 0-X1)
      ENDIF
      RETURN
  180 X1=X(1)**2+X(2)**2
      X2=SQRT(X1)
      X3=COS(X2)
      X4=SIN(X2)
      IF (KA.EQ.1) THEN
      X5=2.0D 0*(X(1)-X2*X3)
      X6=-(X3/X2-X4)
      GA(1)=X5*(X(1)*X6+1.0D 0)+1.0D-2*X(1)
      GA(2)=X5*X(2)*X6+1.0D-2*X(2)
      ELSE IF (KA.EQ.2) THEN
      X5=2.0D 0*(X(2)-X2*X4)
      X6=-(X4/X2+X3)
      GA(1)=X5*X(1)*X6+1.0D-2*X(1)
      GA(2)=X5*(X(2)*X6+1.0D 0)+1.0D-2*X(2)
      ENDIF
      RETURN
   80 GO TO (81,82,83,84,85,86),KA
   81 GA(1)=2.0D 0*X(1)
      GA(2)=2.0D 0*X(2)
      GA(3)=2.0D 0*X(3)
      RETURN
   82 GA(1)=2.0D 0*X(1)
      GA(2)=2.0D 0*X(2)
      GA(3)=2.0D 0*(X(3)-2.0D 0)
      RETURN
   83 GA(1)=1.0D 0
      GA(2)=1.0D 0
      GA(3)=1.0D 0
      RETURN
   84 GA(1)= 1.0D 0
      GA(2)= 1.0D 0
      GA(3)=-1.0D 0
      RETURN
   85 GA(1)=6.0D 0*X(1)**2-4.0D 0*(5.0D 0*X(3)-X(1)+1.0D 0)
      GA(2)=1.2D 1*X(2)
      GA(3)=2.0D 1*(5.0D 0*X(3)-X(1)+1.0D 0)
      RETURN
   86 GA(1)= 2.0D 0*X(1)
      GA(2)= 0.0D 0
      GA(3)=-9.0D 0
      RETURN
   20 X1=X(1)*X(1)
      X2=X(2)*X(2)
      X3=X(3)*X(3)
      X4=X(4)*X(4)
      X5=X(1)+X(1)
      X6=X(2)+X(2)
      X7=X(3)+X(3)
      X8=X(4)+X(4)
      GA(1)=X5-5.0D 0
      GA(2)=X6-5.0D 0
      GA(3)=X7+X7-2.1D 1
      GA(4)=X8+7.0D 0
      GO TO (31,22,23,24),KA
   22 GA(1)=GA(1)+1.0D 1*(X5+1.0D 0)
      GA(2)=GA(2)+1.0D 1*(X6-1.0D 0)
      GA(3)=GA(3)+1.0D 1*(X7+1.0D 0)
      GA(4)=GA(4)+1.0D 1*(X8-1.0D 0)
      RETURN
   23 GA(1)=GA(1)+1.0D 1*(X5-1.0D 0)
      GA(2)=GA(2)+1.0D 1*(X6+X6)
      GA(3)=GA(3)+1.0D 1*X7
      GA(4)=GA(4)+1.0D 1*(X8+X8-1.0D 0)
      RETURN
   24 GA(1)=GA(1)+1.0D 1*(X5+2.0D 0)
      GA(2)=GA(2)+1.0D 1*(X6-1.0D 0)
      GA(3)=GA(3)+1.0D 1*X7
      GA(4)=GA(4)-1.0D 1
      RETURN
  170 X1=X(1)-(X(4)+1.0D 0)**4
      X2=X1*X1
      X3=X(2)-X2*X2
      X4=X1*X3
      X5=-4.0D 0*(X(4)+1.0D 0)**3
      GA(1)=2.0D 0*X1-8.0D 0*X4-5.0D 0*(1.0D 0-4.0D 0*X1)
      GA(2)=2.0D 0*X3-5.0D 0
      GA(3)=4.0D 0*X(3)-2.1D 1
      GA(4)=2.0D 0*X1*X5-8.0D 0*X4*X5+2.0D 0*X(4)-
     & 5.0D 0*(X5-4.0D 0*X1*X5)+7.0D 0
      GO TO (171,172,173,174),KA
  171 CONTINUE
      RETURN
  172 GA(1)=GA(1)+1.0D 1*(2.0D 0*X1-8.0D 0*X4+1.0D 0+4.0D 0*X1)
      GA(2)=GA(2)+1.0D 1*(2.0D 0*X3-1.0D 0)
      GA(3)=GA(3)+1.0D 1*(2.0D 0*X(3)+1.0D 0)
      GA(4)=GA(4)+1.0D 1*(2.0D 0*X1*X5-8.0D 0*X4*X5+2.0D 0*X(4)+
     & X5+4.0D 0*X1*X5-1.0D 0)
      RETURN
  173 GA(1)=GA(1)+1.0D 1*(2.0D 0*X1-1.6D 1*X4-1.0D 0)
      GA(2)=GA(2)+1.0D 1*(4.0D 0*X3)
      GA(3)=GA(3)+1.0D 1*(2.0D 0*X(3))
      GA(4)=GA(4)+1.0D 1*(2.0D 0*X1*X5-1.6D 1*X4*X5+4.0D 0*X(4)-X5-
     & 1.0D 0)
      RETURN
  174 GA(1)=GA(1)+1.0D 1*(2.0D 0*X1-8.0D 0*X4+2.0D 0+4.0D 0*X1)
      GA(2)=GA(2)+1.0D 1*(2.0D 0*X3-1.0D 0)
      GA(3)=GA(3)+1.0D 1*(2.0D 0*X(3))
      GA(4)=GA(4)+1.0D 1*(2.0D 0*X1*X5-8.0D 0*X4*X5+
     & 2.0D 0*X5+4.0D 0*X1*X5-1.0D 0)
      RETURN
  120 T=Y(KA)
      X1=EXP(-X(1)*T)/X(2)
      X2=SIN( X(2)*T)
      X3=COS( X(2)*T)
      GA(1)=-T*X(3)*X1*X2
      GA(2)= X(3)*X1*(T*X3-X2/X(2))
      GA(3)= X1*X2
      RETURN
   90 C1=DBLE(16-KA)
      C2=DBLE(MIN(KA,16-KA))
      C3=DBLE(KA)/(C1*X(2)+C2*X(3))**2
      GA(1)=-1.0D 0
      GA(2)=C1*C3
      GA(3)=C2*C3
      RETURN
  230 T=Y(KA+11)
      X1=X(1)*T*(T+X(2))
      X2=((T+X(3))*T+X(4))
      X3=X1/X2**2
      GA(1)=-T*(T+X(2))/X2
      GA(2)=-T*X(1)/X2
      GA(3)=T*X3
      GA(4)=X3
      RETURN
  210 T=0.2D 0*DBLE(KA)
      GA(1)=2.0D 0*(X(1)+X(2)*T-EXP(T))
      GA(2)=2.0D 0*(X(1)+X(2)*T-EXP(T))*T
      GA(3)=2.0D 0*(X(3)+X(4)*SIN(T)-COS(T))
      GA(4)=2.0D 0*(X(3)+X(4)*SIN(T)-COS(T))*SIN(T)
      RETURN
  140 T=Y(KA)
      X1=-2.0D 0*((X(1)*T+X(2))*T+X(3))
      GA(1)=X1*T**2
      GA(2)=X1*T
      GA(3)=X1
      GA(4)=1.0D 0
      RETURN
  150 T=Y(KA)
      X1=EXP(X(3)*T)
      X2=EXP(X(4)*T)
      GA(1)=X1
      GA(2)=X2
      GA(3)=X(1)*T*X1
      GA(4)=X(2)*T*X2
      RETURN
  200 T=Y(KA)
      X1=T+X(2)+1.0D 0/(X(3)*T+X(4))
      IF(X1.EQ.0D 0)X1=1D-30
      X2=X1/((T+1.0D 0)*Y(61+KA))
      GA(1)=ABS(X2)**(T+5.0D-1)
      GA(2)=X(1)*GA(1)*(T+5.0D-1)/X1
      GA(4)=-GA(2)/(X(3)*T+X(4))**2
      GA(3)=GA(4)*T
      RETURN
   30 T=0.1D 0*DBLE(KA-1)-1.0D 0
      X1=X(1)+T*X(2)
      X2=1.0D 0/(1.0D 0+T*(X(3)+T*(X(4)+T*X(5))))
      X3=X1*X2-EXP(T)
      GA(1)=X2
      GA(2)=X2*T
      GA(3)=-X1*X2*X2*T
      GA(4)=GA(3)*T
      GA(5)=GA(4)*T
   31 RETURN
  130 T=Y(KA)
      X1=1.0D 0/(1.0D 0+T*(X(4)+T*X(5)))
      X2=X(1)+T*(X(2)+T*X(3))
      GA(1)= X1
      GA(2)= X1*T
      GA(3)= X1*T*T
      GA(4)=-X2*X1**2*T
      GA(5)=-X2*X1**2*T*T
      RETURN
  100 T=0.1D 0*DBLE(KA-1)
      X1=EXP(-X(2)*T)
      X2=COS(X(3)*T+X(4))
      X3=SIN(X(3)*T+X(4))
      X4=EXP(-X(6)*T)
      GA(1)= X1*X2
      GA(2)=-X1*X2*X(1)*T
      GA(3)=-X1*X3*X(1)*T
      GA(4)=-X1*X3*X(1)
      GA(5)= X4
      GA(6)=-X4*X(5)*T
      RETURN
   40 BETA=0.5D 0*PI*Y(KA)
      DO 41 I=1,3
      J=I+I
      XA(I)=X(J-1)
      XB(I)=X(J)
   41 CONTINUE
      CA(4)=CMPLX(1.0D 0,0.0D 0)
      CB(4)=1.0D 1*CA(4)
      DO 42 J=1,3
      I=4-J
      XC(I)=BETA*XA(I)
      T=XC(I)
      X1=COS(T)
      X2=SIN(T)
      C1=CMPLX(X1,0.0D 0)
      C2=CMPLX(0.0D 0,(X2*XB(I)))
      C3=CMPLX(0.0D 0,(X2/XB(I)))
      CB(I)=C1*CB(I+1)+C2*CA(I+1)
      CA(I)=C3*CB(I+1)+C1*CA(I+1)
   42 CONTINUE
      C1=-CA(1)
      C2=CB(1)-C1
      C3=1.0D 0+2.0D 0*C1/C2
      FA=ABS(C3)
      C3=CONJG(C3)
      C1=2.0D 0/C2
      DO 43 I=1,3
      T=XC(I)
      J=I+I
      CC(J)=(CB(I)*CA(I)-CB(I+1)*CA(I+1))/(C2*XB(I))
      CC(J-1)=BETA*(CB(I)*CA(I+1)-CB(I+1)*CA(I))/(C2*SIN(T))
   43 CONTINUE
      DO 44 I=1,6
      GA(I)=DBLE(C1*C3*CC(I))/FA
   44 CONTINUE
      RETURN
  110 T=Y(41+KA)
      BETA=Y(82+KA)
      X1=(X(1)+(1D 0+X(2))*T)**2+((1D 0-X(2))*BETA)**2
      X2=(X(3)+(1D 0+X(4))*T)**2+((1D 0-X(4))*BETA)**2
      X3=(X(5)+(1D 0+X(6))*T)**2+((1D 0-X(6))*BETA)**2
      X4=(X(7)+(1D 0+X(8))*T)**2+((1D 0-X(8))*BETA)**2
      IF(X1.EQ.0D 0)X1=1D-30
      IF(X2.EQ.0D 0)X2=1D-30
      IF(X3.EQ.0D 0)X3=1D-30
      IF(X4.EQ.0D 0)X4=1D-30
      FA=SQRT(X1/X2)*SQRT(X3/X4)
      GA(9)=FA
      FA=X(9)*FA
      GA(1)=FA/X1*(X(1)+T*(1D 0+X(2)))
      GA(2)=FA/X1*(X(2)+2D 0*T*T-1D 0+X(1)*T)
      GA(3)=-FA/X2*(X(3)+T*(1D 0+X(4)))
      GA(4)=-FA/X2*(X(4)+2D 0*T*T-1D 0+X(3)*T)
      GA(5)=FA/X3*(X(5)+T*(1D 0+X(6)))
      GA(6)=FA/X3*(X(6)+2D 0*T*T-1D 0+X(5)*T)
      GA(7)=-FA/X4*(X(7)+T*(1D 0+X(8)))
      GA(8)=-FA/X4*(X(8)+2D 0*T*T-1D 0+X(7)*T)
      RETURN
   50 GA(1)=2.0D 0*(X(1)-1.0D 1)
      GA(2)=1.0D 1*(X(2)-1.2D 1)
      GA(3)=4.0D 0*X(3)**3
      GA(4)=6.0D 0*(X(4)-1.1D 1)
      GA(5)=6.0D 1*X(5)**5
      GA(6)=1.4D 1*X(6)-4.0D 0*X(7)-1.0D 1
      GA(7)=4.0D 0*X(7)**3-4.0D 0*X(6)-8.0D 0
      GO TO (31,52,53,54,55),KA
   52 GA(1)=GA(1)+4.0D 1*X(1)
      GA(2)=GA(2)+1.2D 2*X(2)**3
      GA(3)=GA(3)+1.0D 1
      GA(4)=GA(4)+8.0D 1*X(4)
      GA(5)=GA(5)+5.0D 1
      RETURN
   53 GA(1)=GA(1)+7.0D 1
      GA(2)=GA(2)+3.0D 1
      GA(3)=GA(3)+2.0D 2*X(3)
      GA(4)=GA(4)+1.0D 1
      GA(5)=GA(5)-1.0D 1
      RETURN
   54 GA(1)=GA(1)+2.3D 2
      GA(2)=GA(2)+2.0D 1*X(2)
      GA(6)=GA(6)+1.2D 2*X(6)
      GA(7)=GA(7)-8.0D 1
      RETURN
   55 GA(1)=GA(1)+8.0D 1*X(1)-3.0D 1*X(2)
      GA(2)=GA(2)+2.0D 1*X(2)-3.0D 1*X(1)
      GA(3)=GA(3)+4.0D 1*X(3)
      GA(6)=GA(6)+5.0D 1
      GA(7)=GA(7)-1.1D 2
      RETURN
   60 GA(1)=2.0D 0*X(1)+X(2)-1.4D 1
      GA(2)=2.0D 0*X(2)+X(1)-1.6D 1
      GA(3)=2.0D 0*(X(3)-1.0D 1)
      GA(4)=8.0D 0*(X(4)-5.0D 0)
      GA(5)=2.0D 0*(X(5)-3.0D 0)
      GA(6)=4.0D 0*(X(6)-1.0D 0)
      GA(7)=1.0D 1*X(7)
      GA(8)=1.4D 1*(X(8)-1.1D 1)
      GA(9)=4.0D 0*(X(9)-1.0D 1)
      GA(10)=2.0D 0*(X(10)-7.0D 0)
      GO TO (31,62,63,64,65,66,67,68,69),KA
   62 GA(1)=GA(1)+6.0D 1*(X(1)-2.0D 0)
      GA(2)=GA(2)+8.0D 1*(X(2)-3.0D 0)
      GA(3)=GA(3)+4.0D 1*X(3)
      GA(4)=GA(4)-7.0D 1
      RETURN
   63 GA(1)=GA(1)+1.0D 2*X(1)
      GA(2)=GA(2)+8.0D 1
      GA(3)=GA(3)+2.0D 1*(X(3)-6.0D 0)
      GA(4)=GA(4)-2.0D 1
      RETURN
   64 GA(1)=GA(1)+1.0D 1*(X(1)-8.0D 0)
      GA(2)=GA(2)+4.0D 1*(X(2)-4.0D 0)
      GA(5)=GA(5)+6.0D 1*X(5)
      GA(6)=GA(6)-1.0D 1
      RETURN
   65 GA(1)=GA(1)+2.0D 1*X(1)-2.0D 1*X(2)
      GA(2)=GA(2)+4.0D 1*(X(2)-2.0D 0)-2.0D 1*X(1)
      GA(5)=GA(5)+1.4D 2
      GA(6)=GA(6)-6.0D 1
      RETURN
   66 GA(1)=GA(1)+4.0D 1
      GA(2)=GA(2)+5.0D 1
      GA(7)=GA(7)-3.0D 1
      GA(8)=GA(8)+9.0D 1
      RETURN
   67 GA(1)=GA(1)+1.0D 2
      GA(2)=GA(2)-8.0D 1
      GA(7)=GA(7)-1.7D 2
      GA(8)=GA(8)+2.0D 1
      RETURN
   68 GA(1)=GA(1)-3.0D 1
      GA(2)=GA(2)+6.0D 1
      GA(9)=GA(9)+2.4D 2*(X(9)-8.0D 0)
      GA(10)=GA(10)-7.0D 1
      RETURN
   69 GA(1)=GA(1)-8.0D 1
      GA(2)=GA(2)+2.0D 1
      GA(9)=GA(9)+5.0D 1
      GA(10)=GA(10)-2.0D 1
      RETURN
   70 GA(1)=2.0D 0*X(1)+X(2)-1.4D 1
      GA(2)=2.0D 0*X(2)+X(1)-1.6D 1
      GA(3)=2.0D 0*(X(3)-1.0D 1)
      GA(4)=8.0D 0*(X(4)-5.0D 0)
      GA(5)=2.0D 0*(X(5)-3.0D 0)
      GA(6)=4.0D0*(X(6)-1.0D 0)
      GA(7)=1.0D 1*X(7)
      GA(8)=1.4D 1*(X(8)-1.1D 1)
      GA(9)=4.0D 0*(X(9)-1.0D 1)
      GA(10)=2.0D 0*(X(10)-7.0D0)
      GA(11)=2.0D 0*(X(11)-9.0D0)
      GA(12)=2.0D 1*(X(12)-1.0D 0)
      GA(13)=1.0D 1*(X(13)-7.0D 0)
      GA(14)=8.0D 0*(X(14)-1.4D 1)
      GA(15)=5.4D 1*(X(15)-1.0D 0)
      GA(16)=4.0D 0*X(16)**3
      GA(17)=2.0D 0*(X(17)-2.0D 0)
      GA(18)=2.6D 1*(X(18)-2.0D 0)
      GA(19)=2.0D 0*(X(19)-3.0D 0)
      GA(20)=2.0D 0*X(20)
      GO TO (31,62,63,64,65,66,67,68,69,72,73,74,75,76,77,78,79,89),KA
   72 GA(1)=GA(1)+1.0D 1
      GA(2)=GA(2)+1.0D 1
      GA(11)=GA(11)+4.0D 1
      GA(12)=GA(12)-2.1D 2
      RETURN
   73 GA(1)=GA(1)+2.0D 1*X(1)
      GA(11)=GA(11)+1.5D 2
      GA(12)=GA(12)-8.0D 1
      RETURN
   74 GA(1)=GA(1)+4.0D 1
      GA(2)=GA(2)+9.0D 1
      GA(13)=GA(13)+1.0D 2*X(13)
      GA(14)=GA(14)-9.0D 1
      RETURN
   75 GA(1)=GA(1)+3.0D 1
      GA(2)=GA(2)+4.0D 1
      GA(13)=GA(13)+6.0D 1*(X(13)-6.0D 0)
      GA(14)=GA(14)-1.4D 2
      RETURN
   76 GA(1)=GA(1)+2.8D 2*X(1)
      GA(15)=GA(15)+3.5D 2
      GA(16)=GA(16)-7.9D 2
      RETURN
   77 GA(2)=GA(2)+3.0D 2*X(2)
      GA(15)=GA(15)+1.1D 2
      GA(16)=GA(16)-6.1D 2
      RETURN
   78 GA(1)=GA(1)+1.0D 2*X(1)
      GA(2)=GA(2)+2.0D 1
      GA(17)=GA(17)+3.6D 2*X(17)**3
      GA(18)=GA(18)-1.0D 1
      RETURN
   79 GA(1)=GA(1)+2.0D 1*X(1)
      GA(2)=GA(2)-1.0D 1
      GA(19)=GA(19)+1.9D 2
      GA(20)=GA(20)-2.0D 2
      RETURN
   89 GA(1)=GA(1)+1.4D 2*X(1)
      GA(2)=GA(2)+1.0D 2*X(2)
      GA(19)=GA(19)+2.0D 1*X(19)
      GA(20)=GA(20)-3.0D 2
      RETURN
  220 X1=0.0D 0
      DO 221 I=1,N
      X3=1.0D 0
      X4=X(I)
      IF (I.EQ.1) X3=1.0D-8
      IF (I.EQ.4) X3=4.0D 0
      IF (I.EQ.2.AND.KA.EQ.1) X4=X(I)+2.0D 0
      IF (I.EQ.2.AND.KA.EQ.2) X4=X(I)-2.0D 0
      X1=X1+X3*X4**2
  221 CONTINUE
      X2=EXP(X1)
      DO 222 I=1,N
      X3=2.0D 0
      X4=X(I)
      IF (I.EQ.1) X3=2.0D-8
      IF (I.EQ.4) X3=8.0D 0
      IF (I.EQ.2.AND.KA.EQ.1) X4=X(I)+2.0D 0
      IF (I.EQ.2.AND.KA.EQ.2) X4=X(I)-2.0D 0
      GA(I)=X2*X3*X4
  222 CONTINUE
      RETURN
  160 DO 161 I=1,N
      X1=1.0D 0*DBLE(I+KA-1)
      X2=X(I)-SIN(DBLE(2*I+KA-3))
      GA(I)=2.0D 0*X1*X2*EXP(X2**2)
  161 CONTINUE
      RETURN
  240 IF (KA.LE.2) THEN
      DO 241 I=2,N
      GA(I)=0.0D 0
  241 CONTINUE
      IF (KA.EQ.1) THEN
      GA(1)=1.0D 0
      ELSE IF (KA.EQ.2) THEN
      GA(1)=-2.0D 0*X(1)
      GA(2)= 1.0D 0
      ENDIF
      ELSE
      GA(1)=0.0D 0
      T=DBLE(KA-2)/2.9D 1
      X2=X(1)
      DO 242 I=2,N
      X2=X2+X(I)*T**(I-1)
  242 CONTINUE
      DO 243 I=1,N
      IF (I.GT.1) GA(I)=DBLE(I-1)*T**(I-2)
      GA(I)=GA(I)-2.0D 0*X2*T**(I-1)
  243 CONTINUE
      ENDIF
      RETURN
  250 T=1.0D-1*DBLE(KA-1)
      X1=EXP(-X(5)*T)
      X2=EXP(-X(6)*(T-X( 9))**2)
      X3=EXP(-X(7)*(T-X(10))**2)
      X4=EXP(-X(8)*(T-X(11))**2)
      GA(1)= -X1
      GA(2)= -X2
      GA(3)= -X3
      GA(4)= -X4
      GA(5)=  X1*X(1)*T
      GA(6)=  X2*X(2)*(T-X( 9))**2
      GA(7)=  X3*X(3)*(T-X(10))**2
      GA(8)=  X4*X(4)*(T-X(11))**2
      GA(9)= -2.0D 0*X2*X(2)*X(6)*(T-X( 9))
      GA(10)=-2.0D 0*X3*X(3)*X(7)*(T-X(10))
      GA(11)=-2.0D 0*X4*X(4)*X(8)*(T-X(11))
      RETURN
      END
