* SUBROUTINE EAGU42             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GA(N)  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU42(N,KA,X,GA,NEXT)
      INTEGER N,KA,NEXT
      REAL*8 X(N),GA(N)
      REAL*8 A,B,C
      REAL*8 Y(65)
      COMMON /EMPR42/ Y
      GOTO (10,20,30,40,50,60),NEXT
   10 A=EXP(X(3)*Y(KA+10))
      GA(1)=1.0D 0
      GA(2)=A
      GA(3)=X(2)*Y(KA+10)*A
      RETURN
   20 GA(1)=-KA*EXP(KA*X(1))
      GA(2)=-KA*EXP(KA*X(2))
      RETURN
   30 A=DBLE(45+5*KA)+X(3)
      B=EXP(X(2)/A)
      GA(1)=B
      GA(2)=X(1)*B/A
      GA(3)=-X(1)*B*X(2)/A**2
      RETURN
   40 C=-DBLE(KA)
      A=EXP(C*X(3))
      B=EXP(C*X(4))
      GA(1)=A
      GA(2)=B
      GA(3)=X(1)*C*A
      GA(4)=X(2)*C*B
      RETURN
   50 C=Y(KA+16)
      A=EXP(C*X(3))
      B=EXP(C*X(4))
      GA(1)=A
      GA(2)=B
      GA(3)=X(1)*C*A
      GA(4)=X(2)*C*B
      RETURN
   60 C=LOG(DBLE(KA+11))
      A=EXP(C*X(3))
      B=EXP(C*X(4))
      GA(1)=A
      GA(2)=B
      GA(3)=X(1)*C*A
      GA(4)=X(2)*C*B
      RETURN
      END
