* SUBROUTINE EAHD22             ALL SYSTEMS                 95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  HA(N)  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAHD22(N,KA,X,HA,NEXT)
      INTEGER N,KA,NEXT,I,J,K,KK,L,LL
      REAL*8 X(N),HA(N*(N+1)/2)
      REAL*8 A,B,C,P,Q,R,S
      REAL*8 Y(163),PI
      COMMON /EMPR22/ Y
      PARAMETER (PI=3.14159265358979323846D 0)
      GOTO (10,10,30,30,80,50,100,190,200,60,70,90,130,150,170,120,140,
     & 160,150,110),NEXT
   10 GOTO (11,12,13),KA
   11 HA(1)=2.0D 0
      HA(2)=1.0D 0
      HA(3)=2.0D 0
      RETURN
   12 HA(1)=-SIN(X(1))
      HA(2)=0.0D 0
      HA(3)=0.0D 0
      RETURN
   13 HA(1)=0.0D 0
      HA(2)=0.0D 0
      HA(3)= COS(X(2))
      RETURN
   30 GOTO (31,32,33),KA
   31 HA(1)=-EXP(X(1)-X(2))
      HA(2)= EXP(X(1)-X(2))
      HA(3)=-EXP(X(1)-X(2))
      RETURN
   32 HA(1)=SINH(X(1)-1.0D 0)
      HA(2)=0.0D 0
      HA(3)=0.0D 0
      RETURN
   33 HA(1)=0.0D 0
      HA(2)=0.0D 0
      HA(3)=1.0D 0/X(2)**2
      RETURN
   80 DO 81 I=1,N*(N+1)/2
      HA(I)=0.0D 0
   81 CONTINUE
      GO TO (82,83,84) KA
   82 A=SQRT((X(1)-X(3))**2+(X(2)-X(4))**2)
      B=(X(1)-X(3))/A
      C=(X(2)-X(4))/A
      HA( 1)=-1.0D 0/A+B*B/A
      HA( 2)= B*C/A
      HA( 3)=-1.0D 0/A+C*C/A
      HA( 4)=-HA(1)
      HA( 5)=-HA(2)
      HA( 6)= HA(1)
      HA( 7)=-HA(2)
      HA( 8)=-HA(3)
      HA( 9)= HA(3)
      HA(10)= HA(3)
      RETURN
   83 A=SQRT((X(3)-X(5))**2+(X(4)-X(6))**2)
      B=(X(3)-X(5))/A
      C=(X(4)-X(6))/A
      HA( 6)=-1.0D 0/A+B*B/A
      HA( 9)= B*C/A
      HA(10)=-1.0D 0/A+C*C/A
      HA(13)=-HA( 6)
      HA(14)=-HA( 9)
      HA(15)= HA( 6)
      HA(18)=-HA( 9)
      HA(19)=-HA(10)
      HA(20)= HA( 9)
      HA(21)= HA(10)
      RETURN
   84 A=SQRT((X(5)-X(1))**2+(X(6)-X(2))**2)
      B=(X(5)-X(1))/A
      C=(X(6)-X(2))/A
      HA( 1)=-1.0D 0/A+B*B/A
      HA( 2)= B*C/A
      HA( 3)=-1.0D 0/A+C*C/A
      HA(11)=-HA(1)
      HA(12)=-HA(2)
      HA(15)= HA(1)
      HA(16)=-HA(2)
      HA(17)=-HA(3)
      HA(20)= HA(2)
      HA(21)= HA(3)
      RETURN
   50 DO 51 I=1,N*(N+1)/2
      HA(I)=0.0D 0
   51 CONTINUE
      DO 52 I=1,N
      J=I*(I+1)/2
      HA(J)=-2.0D 0*Y(KA)*Y(KA)*COS(Y(KA)*X(I))/1.5D 1
   52 CONTINUE
      RETURN
  100 DO 101 I=1,N*(N+1)/2
      HA(I)=0.0D 0
  101 CONTINUE
      K=0
      DO 105 I=1,5
      A=0.0D 0
      P=0.0D 0
      DO 102 J=1,N
      A=A+Y(K+J)*X(J)**(1.0D 0-Y(I+80))
      P=P+Y(K+J+40)*X(J)
  102 CONTINUE
      B=Y(K+KA)/(X(KA)**Y(I+80)*A)
      C=B*Y(I+80)/X(KA)
      KK=0
      DO 104 J=1,N
      Q=Y(K+J)*(1.0D 0-Y(I+80))/(X(J)**Y(I+80)*A)
      DO 103 L=1,J
      R=Y(K+L)*(1.0D 0-Y(I+80))/(X(L)**Y(I+80)*A)
      KK=KK+1
      HA(KK)=HA(KK)+B*(2.0D 0*P*Q*R-Q*Y(K+L+40)-R*Y(K+J+40))
      IF (J.EQ.L ) HA(KK)=HA(KK)+C*Q*P
      IF (L.EQ.KA) HA(KK)=HA(KK)-C*(Y(K+J+40)-Q*P)
      IF (J.EQ.KA) HA(KK)=HA(KK)-C*(Y(K+L+40)-R*P)
  103 CONTINUE
  104 CONTINUE
      KK=KA*(KA+1)/2
      Q=Y(K+KA)*(1.0D 0-Y(I+80))/(X(KA)**Y(I+80)*A)
      HA(KK)=HA(KK)+C*P*(1.0D 0+Y(I+80))/X(KA)
      K=K+N
  105 CONTINUE
      RETURN
  190 DO 191 I=1,N*(N+1)/2
      HA(I)=0.0D 0
  191 CONTINUE
      HA(1)=2.0D 0
      HA(2)=1.0D 0
      HA(3)=2.0D 0
      HA(6)=2.0D 0
      HA(10)=8.0D 0
      HA(15)=2.0D 0
      HA(21)=4.0D 0
      HA(28)=1.0D 1
      HA(36)=1.4D 1
      HA(45)=4.0D 0
      HA(55)=2.0D 0
      GO TO (197,192,193,194,195,196),KA
  192 HA(1)=HA(1)+6.0D 1
      HA(3)=HA(3)+8.0D 1
      HA(6)=HA(6)+4.0D 1
      RETURN
  193 HA(1)=HA(1)+1.0D 2
      HA(6)=HA(6)+2.0D 1
      RETURN
  194 HA(1)=HA(1)+1.0D 1
      HA(3)=HA(3)+4.0D 1
      HA(15)=HA(15)+6.0D 1
      RETURN
  195 HA(1)=HA(1)+1.0D 1
      HA(2)=HA(2)-2.0D 1
      HA(3)=HA(3)+4.0D 1
      RETURN
  196 HA(45)=HA(45)+2.4D 2
  197 RETURN
  200 DO 201 I=1,N*(N+1)/2
      HA(I)=0.0D 0
  201 CONTINUE
      HA(1)=2.0D 0
      HA(2)=1.0D 0
      HA(3)=2.0D 0
      HA(6)=2.0D 0
      HA(10)=8.0D 0
      HA(15)=2.0D 0
      HA(21)=4.0D 0
      HA(28)=1.0D 1
      HA(36)=1.4D 1
      HA(45)=4.0D 0
      HA(55)=2.0D 0
      HA(66)=2.0D 0
      HA(78)=2.0D 1
      HA(91)=1.0D 1
      HA(105)=8.0D 0
      HA(120)=5.4D 1
      HA(136)=1.2D 1*X(16)**2
      HA(153)=2.0D 0
      HA(171)=2.6D 1
      HA(190)=2.0D 0
      HA(210)=2.0D 0
      GO TO (197,192,193,194,195,196,202,203,204,205,206,207,208,209),KA
  202 HA(1)=HA(1)+2.0D 1
      RETURN
  203 HA(91)=HA(91)+1.0D 2
      RETURN
  204 HA(91)=HA(91)+6.0D 1
      RETURN
  205 HA(1)=HA(1)+2.8D 2
      RETURN
  206 HA(3)=HA(3)+3.0D 2
      RETURN
  207 HA(1)=HA(1)+1.0D 2
      HA(153)=HA(153)+10.8D 2*X(17)**2
      RETURN
  208 HA(1)=HA(1)+2.0D 1
      RETURN
  209 HA(1)=HA(1)+1.4D 2
      HA(3)=HA(3)+1.0D 2
      HA(190)=HA(190)+2.0D 1
      RETURN
   60 DO 61 I=1,N*(N+1)/2
      HA(I)=0.0D 0
   61 CONTINUE
      IF (MOD(KA,2).EQ.0) THEN
      I=(KA+2)/2
      J=I*(I+1)/2
      HA(J)=HA(J)+2.0D 0
      ELSE
      I=(KA+1)/2
      J=I*(I+1)/2
      HA(J)=HA(J)+4.0D 0
      ENDIF
      RETURN
   70 DO 71 I=1,N*(N+1)/2
      HA(I)=0.0D 0
   71 CONTINUE
      K=(N-1)/2
      KK=K*(K+1)/2
      A=Y(KA)**2
      L=0
      LL=KK
      S=1.0D 0
      IF (KA.GT.62.AND.KA.LT.124) S=-S
      DO 72 I=1,K
      L=L+I
      B=X(I+K)**2-A
      C=A*X(I)**2
      P=B*B+C
      Q=B*B-C
      R=S*P*P
      HA(L)=A*Q/R
      HA(L+LL)=-4.0D 0*A*B*X(I)*X(I+K)/R
      LL=LL+K
      HA(L+LL)=2.0D 0*S*B/P-4.0D 0*Q*X(I+K)**2/R
   72 CONTINUE
      RETURN
   90 P=5.0D 2
      A=0.99D 0
      DO 89 I=1,N*(N+1)/2
      HA(I)=0.0D 0
   89 CONTINUE
      HA(25)=-0.63D-1
      GO TO (91,92,93,94,95,96,97,98,99),KA
   91 CONTINUE
      RETURN
   92 HA(29)= P*(1.3167D-1-1.334D-2*X(8))
      HA(36)=-P*X(1)*1.334D-2
      RETURN
   93 HA(29)=-P*(1.3167D-1-1.334D-2*X(8))
      HA(36)= P*X(1)*1.334D-2
      RETURN
   94 HA(36)=-0.76D-1*P
      RETURN
   95 HA(36)= 0.76D-1*P
      RETURN
   96 C=(X(4)*X(9)+1.0D 3*X(3))**3
      Q=(X(4)*X(9)-1.0D 3*X(3))
      HA( 6)=-1.96D 8*P*X(4)*X(9)/C
      HA( 9)=-9.80D 4*P*X(9)*Q/C
      HA(10)= 1.96D 5*P*X(3)*X(9)**2/C
      HA(39)=-9.80D 4*P*X(4)*Q/C
      HA(40)= 9.80D 4*P*X(3)*Q/C
      HA(45)= 1.96D 5*P*X(3)*X(4)**2/C
      RETURN
   97 C=(X(4)*X(9)+1.0D 3*X(3))**3
      Q=(X(4)*X(9)-1.0D 3*X(3))
      HA( 6)= 1.96D 8*P*X(4)*X(9)/C
      HA( 9)= 9.80D 4*P*X(9)*Q/C
      HA(10)=-1.96D 5*P*X(3)*X(9)**2/C
      HA(39)= 9.80D 4*P*X(4)*Q/C
      HA(40)=-9.80D 4*P*X(3)*Q/C
      HA(45)=-1.96D 5*P*X(3)*X(4)**2/C
      RETURN
   98 HA( 1)= 2.0D 0*P*(X(2)+X(5))/X(1)**3
      HA( 2)=-P/X(1)**2
      HA(11)=-P/X(1)**2
      RETURN
   99 HA( 1)=-2.0D 0*P*(X(2)+X(5))/X(1)**3
      HA( 2)= P/X(1)**2
      HA(11)= P/X(1)**2
      RETURN
  130 P=1.0D 5
      DO 131 I=1,N*(N+1)/2
      HA(I)=0.0D 0
  131 CONTINUE
      HA(13)=Y(6)
      HA(16)=Y(2)
      GO TO (152,132,133,134,135,136,137,138,139,106,107,108,109),KA
  132 HA( 1)= 2.0D 0*P*Y(8)*X(3)/X(1)**3
      HA( 4)=-P*Y(8)/X(1)**2
      HA(21)= 2.0D 0*P*Y(7)
      RETURN
  133 HA( 4)=-P*(Y(10)+Y(11)*X(6)+Y(12)*X(6)**2)/X(3)**2
      HA( 6)= 2.0D 0*P*(Y(10)+Y(11)*X(6)+Y(12)*X(6)**2)*X(1)/X(3)**3
      HA(16)= HA(16)+P*(Y(11)+2.0D 0*Y(12)*X(6))/X(3)
      HA(18)=-P*(Y(11)+2.0D 0*Y(12)*X(6))*X(1)/X(3)**2
      HA(21)= 2.0D 0*P*Y(12)*X(1)/X(3)
      RETURN
  134 HA(21)= 2.0D 0*P*Y(13)
      RETURN
  135 HA(14)=-P*Y(19)/X(5)**2
      HA(15)= 2.0D 0*P*(Y(17)+Y(18)*X(6)+Y(19)*X(4)+
     & Y(20)*X(6)**2)/X(5)**3
      HA(20)=-P*(Y(18)+2.0D 0*Y(20)*X(6))/X(5)**2
      HA(21)= 2.0D 0*P*Y(20)/X(5)
      RETURN
  136 HA( 5)=-P*(Y(22)/X(4)+Y(23))/X(3)**2
      HA( 6)= 2.0D 0*P*(Y(22)/X(4)+Y(23))*X(2)/X(3)**3
      HA( 8)=-P*Y(22)/(X(3)*X(4)**2)
      HA( 9)= P*Y(22)*X(2)/(X(3)*X(4))**2
      HA(10)= 2.0D 0*P*Y(22)*X(2)/(X(3)*X(4)**3)
      RETURN
  137 HA( 5)=-P*(Y(25)+Y(26)/X(4))/(X(3)**2*X(7))
      HA( 6)= 2.0D 0*P*(Y(25)+Y(26)/X(4))*X(2)/(X(3)**3*X(7))
      HA( 8)=-P*Y(26)/(X(3)*X(4)**2*X(7))
      HA( 9)= P*Y(26)*X(2)/((X(3)*X(4))**2*X(7))
      HA(10)= 2.0D 0*P*Y(26)*X(2)/(X(3)*X(4)**3*X(7))
      HA(23)=-P*(Y(25)+Y(26)/X(4))/(X(3)*X(7)**2)
      HA(24)= P*(Y(25)+Y(26)/X(4))*X(2)/(X(3)*X(7))**2
      HA(25)= P*Y(26)*X(2)/(X(3)*(X(4)*X(7))**2)
      HA(28)= 2.0D 0*P*(Y(24)+(Y(25)+Y(26)/X(4))*X(2)/X(3))/X(7)**3
      RETURN
  138 HA(15)= 2.0D 0*P*(Y(27)+Y(28)*X(7))/X(5)**3
      HA(26)=-P*Y(28)/X(5)**2
      RETURN
  139 HA( 4)=-P*Y(33)/X(3)**2
      HA( 6)= 2.0D 0*P*(Y(33)*X(1)+Y(34))/X(3)**3
      RETURN
  106 HA( 5)=-P*(Y(35)/X(4)+Y(36))/X(3)**2
      HA( 6)= 2.0D 0*P*(Y(35)/X(4)+Y(36))*X(2)/X(3)**3
      HA( 8)=-P*Y(35)/(X(3)*X(4)**2)
      HA( 9)= P*Y(35)*X(2)/(X(3)*X(4))**2
      HA(10)= 2.0D 0*P*Y(35)*X(2)/(X(3)*X(4)**3)
      RETURN
  107 HA( 3)= 2.0D 0*P*Y(38)*X(3)*X(4)/X(2)**3
      HA( 5)=-P*Y(38)*X(4)/X(2)**2
      HA( 8)=-P*Y(38)*X(3)/X(2)**2
      HA( 9)= P*Y(38)/X(2)
      RETURN
  108 HA(16)=HA(16)+P*Y(39)
      RETURN
  109 HA( 1)= 2.0D 0*P*(Y(42)*X(3)+Y(43))/X(1)**3
      HA( 4)=-P*Y(42)/X(1)**2
      RETURN
  150 P=1.0D 5
      DO 151 I=1,N*(N+1)/2
      HA(I)=0.0D 0
  151 CONTINUE
      GO TO (152,153,154,155),KA
  152 CONTINUE
      RETURN
  153 HA( 1)= 2.0D 0*P*(833.33252D 0*X(4)-
     & 83333.333D 0)/(X(1)**3*X(6))
      HA( 7)=-P*833.33252D 0/(X(1)**2*X(6))
      HA(16)= P*(833.33252D 0*X(4)-83333.333D 0)/(X(1)**2*X(6)**2)
      HA(19)=-P*833.33252D 0/(X(1)*X(6)**2)
      HA(21)= 2.0D 0*P*(833.33252D 0*X(4)/X(1)+1.0D 2-
     & 83333.333D 0/X(1))/X(6)**3
      RETURN
  154 HA( 3)= P*2.50D 3*(X(5)-X(4))/(X(2)**3*X(7))
      HA( 8)= P*1.25D 3/(X(2)**2*X(7))
      HA(12)=-P*1.25D 3/(X(2)**2*X(7))
      HA(23)= P*1.25D 3*(X(5)-X(4))/(X(2)**2*X(7)**2)
      HA(25)=-P*(1.0D 0-1.25D 3/X(2))/X(7)**2
      HA(26)=-P*1.25D 3/(X(2)*X(7)**2)
      HA(28)=2.0D 0*P*(1.25D 3*(X(5)-X(4))/X(2)+X(4))/X(7)**3
      RETURN
  155 HA( 6)= 2.0D 0*P*(1.25D 6-2.5D 3*X(5))/(X(3)**3*X(8))
      HA(13)= P*2.5D 3/(X(3)**2*X(8))
      HA(31)= P*(1.25D 6-2.5D 3*X(5))/(X(3)**2*X(8)**2)
      HA(33)=-P*(1.00D 0-2.5D 3/X(3))/X(8)**2
      HA(36)= 2.0D 0*P*((1.25D 6-2.5D 3*X(5))/X(3)+X(5))/X(8)**3
      RETURN
  170 P=1.0D 3
      DO 171 I=1,N*(N+1)/2
      HA(I)=0.0D 0
  171 CONTINUE
      HA( 67)=-1.231060D 0
      HA( 80)=-1.231060D 0
      HA( 94)=-1.231060D 0
      HA(109)=-1.231060D 0
      HA(125)=-1.231060D 0
      GO TO (152,172,173,174,175,176,177,178,179,116,117,118,128,
     & 129,146,147,148,149,159),KA
  172 HA( 1)=-P*1.95D-2/X(6)
      HA(16)=-P*(3.475D-2-1.95D-2*X(1))/X(6)**2
      HA(21)= 2.0D 0*P*X(1)*(3.475D-2-9.75D-3*X(1))/X(6)**3
      RETURN
  173 HA( 3)=-P*1.95D-2/X(7)
      HA(23)=-P*(3.475D-2-1.95D-2*X(2))/X(7)**2
      HA(28)= 2.0D 0*P*X(2)*(3.475D-2-9.75D-3*X(2))/X(7)**3
      RETURN
  174 HA( 6)=-P*1.95D-2/X(8)
      HA(31)=-P*(3.475D-2-1.95D-2*X(3))/X(8)**2
      HA(36)= 2.0D 0*P*X(3)*(3.475D-2-9.75D-3*X(3))/X(8)**3
      RETURN
  175 HA(10)=-P*1.95D-2/X(9)
      HA(40)=-P*(3.475D-2-1.95D-2*X(4))/X(9)**2
      HA(45)= 2.0D 0*P*X(4)*(3.475D-2-9.75D-3*X(4))/X(9)**3
      RETURN
  176 HA(15)=-P*1.95D-2/X(10)
      HA(50)=-P*(3.475D-2-1.95D-2*X(5))/X(10)**2
      HA(55)= 2.0D 0*P*X(5)*(3.475D-2-9.75D-3*X(5))/X(10)**3
      RETURN
  177 HA(22)=-P*X(12)/(X(11)*X(7)**2)
      HA(27)=-P*(1.0D 0-X(12)/X(11))/X(7)**2
      HA(28)= 2.0D 0*P*(X(6)+(X(1)-X(6))*X(12)/X(11))/X(7)**3
      HA(56)=-P*X(12)/(X(7)*X(11)**2)
      HA(61)= P*X(12)/(X(7)*X(11)**2)
      HA(62)= P*(X(1)-X(6))*X(12)/(X(11)*X(7))**2
      HA(66)= 2.0D 0*P*(X(1)-X(6))*X(12)/(X(7)*X(11)**3)
      HA(67)= HA(67)+P/(X(11)*X(7))
      HA(72)=-P/(X(11)*X(7))
      HA(73)=-P*(X(1)-X(6))/(X(11)*X(7)**2)
      HA(77)=-P*(X(1)-X(6))/(X(7)*X(11)**2)
      RETURN
  178 HA(29)= 2.0D-3*P*X(12)/X(8)**2
      HA(30)=-2.0D-3*P*X(13)/X(8)**2
      HA(35)=-P*(1.0D 0+2.0D-3*X(12))/X(8)**2
      HA(36)= 2.0D 0*P*(X(7)+2.0D-3*((X(7)-X(1))*X(12)+
     & X(2)*X(13)))/X(8)**3
      HA(67)= HA(67)-2.0D-3*P/X(8)
      HA(73)= 2.0D-3*P/X(8)
      HA(74)=-2.0D-3*P*(X(7)-X(1))/X(8)**2
      HA(80)= HA(80)+2.0D-3*P/X(8)
      HA(86)=-2.0D-3*P*X(2)/X(8)**2
      RETURN
  179 HA( 80)= HA(80)-P*2.0D-3
      HA( 86)= P*2.0D-3
      HA( 94)= HA(94)+P*2.0D-3
      HA(100)=-P*2.0D-3
      RETURN
  116 HA(  6)= 2.0D 0*P*(X(9)+((X(4)-X(8))*X(15)+5.0D 2*
     & (X(10)-X(9)))/X(14))/X(3)**3
      HA(  9)=-P*X(15)/(X(14)*X(3)**2)
      HA( 31)= P*X(15)/(X(14)*X(3)**2)
      HA( 39)=-P*(1.0D 0-5.0D 2/X(14))/X(3)**2
      HA( 48)=-5.0D 2*P/(X(14)*X(3)**2)
      HA( 94)= HA( 94)+P*((X(4)-X(8))*X(15)+5.0D 2*
     & (X(10)-X(9)))/(X(14)*X(3))**2
      HA( 95)=-P*X(15)/(X(3)*X(14)**2)
      HA( 99)= P*X(15)/(X(3)*X(14)**2)
      HA(100)= 5.0D 2*P/(X(3)*X(14)**2)
      HA(101)=-5.0D 2*P/(X(3)*X(14)**2)
      HA(105)= 2.0D 0*P*((X(4)-X(8))*X(15)+5.0D 2*
     & (X(10)-X(9)))/(X(3)*X(14)**3)
      HA(108)=-P*(X(4)-X(8))/(X(14)*X(3)**2)
      HA(109)= HA(109)+P/(X(3)*X(14))
      HA(113)=-P/(X(3)*X(14))
      HA(119)=-P*(X(4)-X(8))/(X(3)*X(14)**2)
      RETURN
  117 HA( 10)= 2.0D 0*P*(X(10)+(X(5)*X(16)-5.0D 2*
     & X(10))/X(15))/X(4)**3
      HA( 14)=-P*X(16)/(X(15)*X(4)**2)
      HA( 49)=-P*(1.0D 0-5.0D 2/X(15))/X(4)**2
      HA(109)= HA(109)+P*(X(5)*X(16)-5.0D 2*X(10))/(X(15)*X(4))**2
      HA(110)=-P*X(16)/(X(4)*X(15)**2)
      HA(115)= 5.0D 2*P/(X(4)*X(15)**2)
      HA(120)= 2.0D 0*P*(5.0D 2-X(16)+(X(5)*X(16)-5.0D 2*
     & X(10))/X(4))/X(15)**3
      HA(124)=-P*X( 5)/(X(15)*X(4)**2)
      HA(125)= HA(125)+P/(X(4)*X(15))
      HA(135)=-P*(X(5)/X(4)-1.0D 0)/X(15)**2
      RETURN
  118 HA( 10)= 2.0D 0*P*(9.0D-1-2.0D-3*X(5)*X(16))/X(4)**3
      HA( 14)= P*(2.0D-3*X(16))/X(4)**2
      HA(124)= P*(2.0D-3*X( 5))/X(4)**2
      HA(125)=HA(125)-P*2.0D-3/X(4)
      RETURN
  128 HA(66)= 2.0D 0*P*X(12)/X(11)**3
      HA(77)=-P/X(11)**2
      RETURN
  129 HA(14)=-P/X(5)**2
      HA(15)= 2.0D 0*P*X(4)/X(5)**3
      RETURN
  146 HA( 9)=-P/X(4)**2
      HA(10)= 2.0D 0*P*X(3)/X(4)**3
      RETURN
  147 HA( 5)=-P/X(3)**2
      HA( 6)= 2.0D 0*P*X(2)/X(3)**3
      RETURN
  148 HA( 2)=-P/X(2)**2
      HA( 3)= 2.0D 0*P*X(1)/X(2)**3
      RETURN
  149 HA(54)=-P/X(10)**2
      HA(55)= 2.0D 0*P*X(9)/X(10)**3
      RETURN
  159 HA(44)=-P/X(9)**2
      HA(45)= 2.0D 0*P*X(8)/X(9)**3
      RETURN
  120 P=1.0D 4
      DO 121 I=1,N*(N+1)/2
      HA(I)=0.0D 0
  121 CONTINUE
      HA( 6)=2.0D 0*Y(1)
      HA(11)=Y(2)
      GO TO (152,122,123,124,125,126,127),KA
  122 HA( 7)=P*Y(7)
      HA(12)=P*Y(6)
      HA(13)=P*Y(5)
      RETURN
  123 HA( 7)=P*Y(9)
      HA(12)=P*Y(8)
      HA(13)=P*Y(10)
      RETURN
  124 HA( 3)= 2.0D 0*P*(Y(11)+Y(13)*X(3)**2)/(X(5)*X(2)**3)
      HA( 5)=-2.0D 0*P*Y(13)*X(3)/(X(5)*X(2)**2)
      HA( 6)= HA(6)+2.0D 0*P*Y(13)/(X(2)*X(5))
      HA(11)= HA(11)-P*Y(12)/X(5)**2
      HA(12)= P*(Y(11)+Y(13)*X(3)**2)/(X(2)*X(5))**2
      HA(13)=-2.0D 0*P*Y(13)*X(3)/(X(2)*X(5)**2)
      HA(15)= 2.0D 0*P*(Y(12)*X(1)+(Y(11)+Y(13)*X(3)**2)/X(2))/X(5)**3
      RETURN
  125 HA( 2)=Y(15)
      HA( 6)=HA(6)+2.0D 0*P*Y(16)
      HA(12)=Y(14)
      RETURN
  126 HA( 6)= HA(6)+2.0D 0*P*Y(17)/(X(5)*X(3)**3)
      HA(11)= HA(11)-P*Y(18)/X(5)**2
      HA(13)= P*Y(17)/(X(3)*X(5))**2
      HA(14)=-P*Y(19)/X(5)**2
      HA(15)= 2.0D 0*P*(Y(17)/X(3)+Y(18)*X(1)+Y(19)*X(4))/X(5)**3
      RETURN
  127 HA( 4)=Y(21)
      HA( 9)=Y(22)
      HA(13)=Y(20)
      RETURN
  140 P=1.0D 2
      S=6.7D-1
      A=0.0588D 0
      DO 141 I=1,N*(N+1)/2
      HA(I)=0.0D 0
  141 CONTINUE
      HA( 1)= 4.0D-1*S*(S-1.0D 0)*(X(1)/X(7))**S/X(1)**2
      HA( 3)= 4.0D-1*S*(S-1.0D 0)*(X(2)/X(8))**S/X(2)**2
      HA(22)=-4.0D-1*S*S*(X(1)/X(7))**S/(X(1)*X(7))
      HA(28)= 4.0D-1*S*(S+1.0D 0)*(X(1)/X(7))**S/X(7)**2
      HA(30)=-4.0D-1*S*S*(X(2)/X(8))**S/(X(2)*X(8))
      HA(36)= 4.0D-1*S*(S+1.0D 0)*(X(2)/X(8))**S/X(8)**2
      GO TO (152,142,143,144,145),KA
  142 HA(26)=P*A
      RETURN
  143 HA(34)=P*A
      RETURN
  144 HA( 6)= P*(2.0D 0*0.71D 0*1.71D 0/(X(3)**2.71D 0*X(5))+
     & A*1.3D 0*2.3D 0*X(7)/X(3)**3.3D 0)
      HA(13)=-P*(4.0D 0-1.42D 0/X(3)**1.71D 0)/X(5)**2
      HA(15)= 2.0D 0*P*(4.0D 0*X(3)+2.0D 0/X(3)**0.71D 0)/X(5)**3
      HA(24)=-P*1.3D 0*A/X(3)**2.3D 0
      RETURN
  145 HA(10)= P*(2.0D 0*0.71D 0*1.71D 0/(X(4)**2.71D 0*X(6))+
     & A*1.3D 0*2.3D 0*X(8)/X(4)**3.3D 0)
      HA(19)=-P*(4.0D 0-1.42D 0/X(4)**1.71D 0)/X(6)**2
      HA(21)= 2.0D 0*P*(4.0D 0*X(4)+2.0D 0/X(4)**0.71D 0)/X(6)**3
      HA(32)=-P*1.3D 0*A/X(4)**2.3D 0
      RETURN
  160 CONTINUE
      RETURN
  110 P=1.0D 4
      A=1.0D 5
      DO 111 I=1,11
      A=A*X(I)**Y(30+I)
  111 CONTINUE
      L=0
      DO 57 I=1,11
      DO 56 J=1,I-1
      HA(L+J)=Y(30+I)*Y(30+J)*A/(X(I)*X(J))
   56 CONTINUE
      L=L+I
      HA(L)=Y(30+I)*(Y(30+I)-1.0D 0)*A/X(I)**2
   57 CONTINUE
      DO 58 I=1,12
      HA(L+I)=0.0D 0
   58 CONTINUE
      GO TO (112,113,114,115),KA
  112 CONTINUE
      RETURN
  113 HA(14)=HA(14)+P*Y(4)
      RETURN
  114 HA( 8)=HA( 8)+P*(Y(14)*X(5)-Y(15)*X(5)/(X(4)*X(12))**2)
      HA(10)=HA(10)+2.0D 0*P*Y(15)*X(2)*X(5)/(X(4)**3*X(12)**2)
      HA(12)=HA(12)+P*((Y(13)+Y(15)/X(4))/X(12)+Y(14)*X(4))
      HA(14)=HA(14)+P*(Y(12)+Y(14)*X(2)-Y(15)*X(2)/(X(4)*X(12))**2)
      HA(68)=HA(68)-P*(Y(9)*X(5)+Y(10)*X(6)+(Y(13)+Y(15)/X(4))*
     & X(5)/X(12)**2)
      HA(70)=HA(70)+P*(Y(8)+Y(15)/X(4)**2*X(2)*X(5))/X(12)**2
      HA(71)=HA(71)-P*(Y(9)-(Y(13)+Y(15)/X(4))*X(2))/X(12)**2
      HA(72)=HA(72)-P*Y(10)/X(12)**2
      HA(73)=HA(73)+P*Y(11)
      HA(76)=HA(76)-P*Y(16)/X(12)**2
      HA(78)=HA(78)+2.0D 0*P*(Y(9)*X(5)+Y(10)*X(6)+
     & (Y(13)+Y(15)/X(4))*X(2)*X(5)+Y(16)*X(10))/X(12)**3
      RETURN
  115 HA( 8)=HA( 8)+P*X(5)*(Y(26)-Y(27)/X(4)**2)
      HA(10)=HA(10)+P*Y(27)*X(2)*X(5)/X(4)**3
      HA(12)=HA(12)+P*X(5)*(Y(25)+Y(26)*X(4)+Y(27)/X(4))
      HA(14)=HA(14)+P*(Y(24)+X(2)*(Y(25)+Y(26)-Y(27)/X(4)**2))
      HA(37)=HA(37)+P*Y(29)
      RETURN
      END
