* SUBROUTINE EAGU15                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION - LU VERSION WITH MODIFIED TESTS NO 7-10,12.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(LA)  VECTOR OF VARIABLES.
*  RO  G(LA)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EBGU15(N,KA,LA,X,GA,NEXT)
      INTEGER N,KA,LA,NEXT
      REAL*8 X(LA),GA(LA)
      REAL*8 A,B,C,D,Q,R,E,ALFA,U,V
      INTEGER I,J,K,L,M,IA,IB,IC
      REAL*8 Y(20)
      COMMON /EMPR15/ Y
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,260,270),NEXT
   10 IF (MOD(KA,2).EQ.1) THEN
      GA(1)=2.0D 1*X(1)
      GA(2)=-1.0D 1
      ELSE
      GA(1)=1.0D 0
      ENDIF
      RETURN
   20 A=SQRT(9.0D 1)
      B=SQRT(1.0D 1)
      IF (MOD(KA,6).EQ.1) THEN
      GA(1)=2.0D 1 *X(1)
      GA(2)=-1.0D 1
      ELSEIF (MOD(KA,6).EQ.2) THEN
      GA(1)=1.0D 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      GA(1)=2.0D 0*A*X(1)
      GA(2)=-A
      ELSEIF (MOD(KA,6).EQ.4) THEN
      GA(1)=1.0D 0
      ELSEIF (MOD(KA,6).EQ.5) THEN
      GA(1)=B
      GA(2)=B
      ELSE
      GA(1)=1.0D 0/B
      GA(2)=-1.0D 0/B
      ENDIF
      RETURN
   30 A=SQRT(5.0D 0)
      B=SQRT(1.0D 1)
      IF (MOD(KA,4).EQ.1) THEN
      GA(1)=1.0D 0
      GA(2)=1.0D 1
      ELSEIF (MOD(KA,4).EQ.2) THEN
      GA(1)=A
      GA(2)=-A
      ELSEIF (MOD(KA,4).EQ.3) THEN
      C=X(1)-2.0D 0*X(2)
      GA(1)=2.0D 0*C
      GA(2)=-4.0D 0*C
      ELSE
      C=X(1)-X(2)
      D=2.0D 0*B*C
      GA(1)=D
      GA(2)=-D
      ENDIF
      RETURN
   40 IF (MOD(KA,5).EQ.1) THEN
      A=EXP(X(1))
      B=A-X(2)
      C=2.0D 0*B
      GA(1)=C*A
      GA(2)=-C
      ELSEIF (MOD(KA,5).EQ.2) THEN
      A=X(1)-X(2)
      B=3.0D 1*A**2
      GA(1)=B
      GA(2)=-B
      ELSEIF (MOD(KA,5).EQ.3) THEN
      C=X(1)-X(2)
      Q=SIN(C)/COS(C)
      R=COS(C)
      D=2.0D 0*Q/R**2
      GA(1)=D
      GA(2)=-D
      ELSEIF (MOD(KA,5).EQ.4) THEN
      GA(1)=4.0D 0*X(1)**3
      ELSE
      GA(1)=1.0D 0
      ENDIF
      RETURN
   50 IF (KA.EQ.1) THEN
      GA(1)=3.0D 0-4.0D 0*X(1)
      GA(2)=-1.0D 0
      ELSE
      GA(1)=-1.0D 0
      GA(2)=3.0D 0-4.0D 0*X(2)
      IF (KA.LT.N) GA(3)=-1.0D 0
      ENDIF
      RETURN
   60 DO I=1,MIN(KA+1,6)
        GA(I)=1.0D 0+2.0D 0*X(I)
      ENDDO
      IF (KA.GT.5.AND.KA.LT.N) GA(7)=1.0D 0+2.0D 0*X(7)
      IF (KA.LE.5) THEN
        GA(KA)=GA(KA)+2.0D 0+1.5D 1*X(KA)**2
      ELSE
        GA(6)=GA(6)+2.0D 0+1.5D 1*X(6)**2
      ENDIF
      RETURN
   70 IF (MOD(KA,2).EQ.1) THEN
      GA(1)=1.0D 0
      GA(2)=1.0D 1*X(2)-3.0D 0*X(2)**2-2.0D 0
      ELSE
      GA(1)=1.0D 0
      GA(2)=2.0D 0*X(2)+3.0D 0*X(2)**2-1.4D 1
      ENDIF
      RETURN
   80 I=MOD(KA,N/2)+1
      J=I+N/2
      M=5*N
      IF (KA.LE.M/2) THEN
      IA=1
      ELSE
      IA=2
      ENDIF
      IB=5-KA/(M/4)
      IC=MOD(KA,5)+1
      A=DBLE(IA)
      B=DBLE(IB)
      C=DBLE(IC)
      D=X(1)**IA-X(2)**IB
      IF (D.EQ.0.0D 0) THEN
      GA(1)=0.0D 0
      GA(2)=0.0D 0
      ELSE
      E=C*D**(IC-1)
      IF (X(1).EQ.0.0D 0.AND.IA.LE.1) THEN
      GA(1)=0.0D 0
      ELSE
      GA(1)= E*A*X(1)**(IA-1)
      ENDIF
      IF (X(2).EQ.0.0D 0.AND.IB.LE.1) THEN
      GA(2)=0.0D 0
      ELSE
      GA(2)=-E*B*X(2)**(IB-1)
      ENDIF
      ENDIF
      RETURN
   90 IF (MOD(KA,6).EQ.1) THEN
      GA(1)=1.0D 0
      GA(2)=3.0D 0*(X(3)-1.0D 0)
      GA(3)=3.0D 0*X(2)
      GA(4)=2.0D 0*X(4)
      ELSEIF (MOD(KA,6).EQ.2) THEN
      A=2.0D 0*(X(1)+X(2))
      GA(1)=A
      GA(2)=A
      GA(3)=2.0D 0*(X(3)-1.0D 0)
      GA(4)=-1.0D 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      GA(1)=X(2)
      GA(2)=X(1)
      GA(3)=-X(4)
      GA(4)=-X(3)
      ELSEIF (MOD(KA,6).EQ.4) THEN
      GA(1)=2.0D 0*X(3)
      GA(2)=X(4)
      GA(3)=2.0D 0*X(1)
      GA(4)=X(2)
      ELSEIF (MOD(KA,6).EQ.5) THEN
      A=2.0D 0*(X(1)+X(2)+X(3)+X(4))
      GA(1)=A+2.0D 0*(X(1)-1.0D 0)
      GA(2)=A
      GA(3)=A
      GA(4)=A
      ELSE
      A=X(1)*X(2)*X(3)*X(4)
      GA(1)=A/X(1)
      GA(2)=A/X(2)
      GA(3)=A/X(3)
      GA(4)=A/X(4)+2.0D 0*(X(4)-1.0D 0)
      ENDIF
      RETURN
  100 I=(KA+1)/2
      J=MOD(KA,2)
      IF (J.EQ.0) THEN
      GA(1)=-2.0D 0*EXP(2.0D 0*X(1))
      GA(2)=-2.0D 0*EXP(2.0D 0*X(2))
      ELSEIF (I.EQ.1) THEN
      GA(1)=-EXP(X(1))
      GA(2)=-EXP(X(2))
      ELSEIF (I.EQ.N) THEN
      GA(1)=-3.0D 0*EXP(3.0D 0*X(1))
      GA(2)=-3.0D 0*EXP(3.0D 0*X(2))
      ELSE
      GA(1)=-3.0D 0*EXP(3.0D 0*X(1))
      GA(2)=-3.0D 0*EXP(3.0D 0*X(2))-EXP(X(2))
      GA(3)=-EXP(X(3))
      ENDIF
      RETURN
  110 IF (MOD(KA,2).EQ.1) THEN
      GA(1)=2.0D 1*(1.0D 0-X(1)**2)/(1.0D 0+X(1)**2)**2
      GA(2)=-1.0D 1
      ELSE
      GA(1)=1.0D 0
      ENDIF
      RETURN
  120 IF (MOD(KA,6).EQ.1) THEN
      GA(1)=2.0D 1*X(1)
      GA(2)=-1.0D 1
      ELSEIF (MOD(KA,6).EQ.2) THEN
      GA(1)=1.0D 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      GA(1)=2.0D 0*(X(1)-1.0D 0)
      ELSEIF (MOD(KA,6).EQ.4) THEN
      GA(1)=3.0D 0*(X(1)-1.0D 0)**2
      ELSEIF (MOD(KA,6).EQ.5) THEN
      GA(1)=2.0D 0*X(1)*X(2)
      GA(2)=X(1)**2+COS(X(2)-X(3))
      GA(3)=-COS(X(2)-X(3))
      ELSE
      GA(1)=1.0D 0
      GA(2)=4.0D 0*X(2)*(X(2)*X(3))**2
      GA(3)=2.0D 0*X(2)**4*X(3)
      ENDIF
      RETURN
  130 IF (MOD(KA,7).EQ.1) THEN
      GA(1)=2.0D 1*X(1)
      GA(2)=-1.0D 1
      ELSEIF (MOD(KA,7).EQ.2) THEN
      GA(1)=2.0D 1*X(1)
      GA(2)=-1.0D 1
      ELSEIF (MOD(KA,7).EQ.3) THEN
      A=2.0D 0*(X(1)-X(2))
      GA(1)=A
      GA(2)=-A
      ELSEIF (MOD(KA,7).EQ.4) THEN
      A=2.0D 0*(X(1)-X(2))
      GA(1)=A
      GA(2)=-A
      ELSEIF (MOD(KA,7).EQ.5) THEN
      GA(1)=1.0D 0
      GA(2)=2.0D 0*X(2)
      GA(3)=1.0D 0
      ELSEIF (MOD(KA,7).EQ.6) THEN
      GA(1)=1.0D 0
      GA(2)=-2.0D 0*X(2)
      GA(3)=1.0D 0
      ELSE
      GA(1)=X(2)
      GA(2)=X(1)
      ENDIF
      RETURN
  140 L=MOD((KA-1),4)+1
      DO J=1,4
        GA(J)=0.0D 0
      ENDDO
      DO K=1,3
        A=DBLE(K*K)/DBLE(L)
        DO J=1,4
          A=A*SIGN(1.0D 0,X(J))*ABS(X(J))**(DBLE(J)/DBLE(K*L))
        ENDDO
        DO J=1,4
          GA(J)=GA(J)+(DBLE(J)/DBLE(K*L))*A/X(J)
        ENDDO
      ENDDO
      RETURN
  150 L=MOD((KA-1),4)+1
      DO J=1,4
        GA(J)=0.0D 0
      ENDDO
      DO K=1,3
        A=0.0D 0
        DO J=1,4
          A=A+X(J)*(DBLE(J)/DBLE(K*L))
        ENDDO
        A=EXP(A)*DBLE(K*K)/DBLE(L)
        DO J=1,4
          GA(J)=GA(J)+A*(DBLE(J)/DBLE(K*L))
        ENDDO
      ENDDO
      RETURN
  160 L=MOD((KA-1),4)+1
      DO J=1,4
      GA(J)=DBLE((1-2*MOD(J,2))*L*J*J)*COS(X(J))-DBLE(L*L*J)*SIN(X(J))
      ENDDO
      RETURN
  170 ALFA=0.5D 0
      IF (KA.EQ.1) THEN
      GA(1)=-1.0D 0-4.0D 0*X(2)
      GA(2)=-4.0D 0*X(1)
      GA(3)=ALFA-1.0D 0
      ELSEIF(KA.EQ.2) THEN
      GA(1)=-4.0D 0*X(2)
      GA(2)=-1.0D 0-4.0D 0*X(1)
      GA(3)=-2.0D 0+ALFA
      ELSEIF(KA.EQ.N-1) THEN
      GA(1)=ALFA
      GA(2)=-1.0D 0-4.0D 0*X(3)
      GA(3)=-4.0D 0*X(2)
      ELSEIF (KA.EQ.N) THEN
      GA(1)=ALFA
      GA(2)=-4.0D 0*X(3)
      GA(3)=-1.0D 0-4.0D 0*X(2)
      ELSEIF (MOD(KA,2).EQ.1) THEN
      GA(1)=ALFA
      GA(2)=-1.0D 0-4.0D 0*X(3)
      GA(3)=-4.0D 0*X(2)
      GA(4)=-1.0D 0+ALFA
      ELSE
      GA(1)=ALFA
      GA(2)=-4.0D 0*X(3)
      GA(3)=-1.0D 0-4.0D 0*X(2)
      GA(4)=-2.0D 0+ALFA
      ENDIF
      RETURN
  180 IF (KA.LT.2) THEN
      GA(1)=4.0D 0
      GA(2)=-8.0D 0*X(2)
      ELSE
      GA(1)=-8.0D 0*X(2)
      GA(2)=2.4D 1*X(2)**2-8.0D 0*X(1)+2.0D 0
      IF (KA.LT.N) THEN
      GA(2)=GA(2)+4.0D 0
      GA(3)=-8.0D 0*X(3)
      ENDIF
      ENDIF
      RETURN
  190 IF (KA.EQ.1) THEN
      GA(1)=-4.0D 0*X(1)+3.0D 0
      GA(2)=-2.0D 0
      GA(3)=3.0D 0
      GA(4)=-1.0D 0
      GA(5)=-1.0D 0
      GA(6)=0.5D 0
      GA(7)=-1.0D 0
      ELSEIF (KA.GT.1.AND.KA.LT.N-5) THEN
      GA(1)=-1.0D 0
      GA(2)=-4.0D 0*X(2)+3.0D 0
      GA(3)=-2.0D 0
      GA(4)=3.0D 0
      GA(5)=-1.0D 0
      GA(6)=-1.0D 0
      GA(7)=0.5D 0
      GA(8)=-1.0D 0
      ELSEIF (KA.EQ.N-5) THEN
      GA(1)=-1.0D 0
      GA(2)=-4.0D 0*X(2)+3.0D 0
      GA(3)=1.0D 0
      GA(4)=-1.0D 0
      GA(5)=-1.0D 0
      GA(6)=0.5D 0
      GA(7)=-1.0D 0
      ELSEIF (KA.EQ.N-4) THEN
      GA(1)=-1.0D 0
      GA(2)=-4.0D 0*X(2)+6.0D 0
      GA(3)=-3.0D 0
      GA(4)=-1.0D 0
      GA(5)=0.5D 0
      GA(6)=-1.0D 0
      ELSEIF (KA.EQ.N-3) THEN
      GA(1)=2.0D 0
      GA(2)=-4.0D 0*X(2)+2.0D 0
      GA(3)=-3.0D 0
      GA(4)=0.5D 0
      GA(5)=-1.0D 0
      ELSEIF (KA.EQ.N-2) THEN
      GA(1)=3.0D 0
      GA(2)=-2.0D 0
      GA(3)=-4.0D 0*X(3)+2.0D 0
      GA(4)=-1.5D 0
      GA(5)=-1.0D 0
      ELSEIF (KA.EQ.N-1) THEN
      GA(1)=3.0D 0
      GA(2)=-1.0D 0
      GA(3)=-2.0D 0
      GA(4)=-4.0D 0*X(4)+3.5D 0
      GA(5)=-3.0D 0
      ELSE
      GA(1)=3.0D 0
      GA(2)=-1.0D 0
      GA(3)=-1.0D 0
      GA(4)=-0.5D 0
      GA(5)=-4.0D 0*X(5)+2.0D 0
      ENDIF
      RETURN
  200 U=1.0D 0/DBLE(N+1)
      V=DBLE(KA)*U
      IF (KA.EQ.1) THEN
      GA(1)=2.0D 0+1.5D 0*U**2*(X(1)+V+1.0D 0)**2
      GA(2)=-1.0D 0
      ELSE
      GA(1)=-1.0D 0
      GA(2)=2.0D 0+1.5D 0*U**2*(X(2)+V+1.0D 0)**2
      IF(KA.LT.N) GA(3)=-1.0D 0
      ENDIF
      RETURN
  210 IF (MOD(KA,7).EQ.1) THEN
      GA(1)=2.0D 1*X(1)
      GA(2)=-1.0D 1
      ELSEIF (MOD(KA,7).EQ.2) THEN
      GA(1)=1.0D 0
      GA(2)=1.0D 0
      ELSEIF (MOD(KA,7).EQ.3) THEN
      GA(1)=1.0D 0
      ELSEIF (MOD(KA,7).EQ.4) THEN
      GA(1)=1.0D 0
      ELSEIF (MOD(KA,7).EQ.5) THEN
      GA(1)=1.0D 0
      GA(2)=3.0D 0
      ELSEIF (MOD(KA,7).EQ.6) THEN
      GA(1)=1.0D 0
      GA(2)=1.0D 0
      GA(3)=-2.0D 0
      ELSE
      GA(1)=2.0D 1*X(1)
      GA(2)=-1.0D 1
      ENDIF
      RETURN
  220 I=KA/2
      IF (KA.EQ.1) THEN
      GA(1)=1.0D 0
      ELSEIF (MOD(KA,2).EQ.0) THEN
      GA(1)=2.0D 1*X(1)
      GA(2)=-1.0D 1
      ELSE
      A=2.0D 0*EXP(-(X(1)-X(2))**2)
      B=EXP(-2.0D 0*(X(2)-X(3))**2)
      GA(1)= -2.0D 0*(X(1)-X(2))*A
      GA(2)=2.0D 0*(X(1)-X(2))*A-4.0D 0*(X(2)-X(3))*B
      GA(3)=4.0D 0*(X(2)-X(3))*B
      ENDIF
      RETURN
  260 M=5*N
      IA=KA/(M/4)+1
      A=DBLE(IA)
      B=DBLE(KA/(M/5)+1)
      GA(1)=A*X(1)**(IA-1)*EXP(B*X(2))
      GA(2)=B*X(1)**IA*EXP(B*X(2))+1.0D 0
      RETURN
  270 IA=MIN(MAX(MOD(KA,13)-2,1),7)
      IB=(KA+12)/13
      I=IA+IB-1
      IF (IA.EQ.7) THEN
      J=IB
      ELSE
      J=IA+IB
      ENDIF
      C=3.0D 0*DBLE(IA)/1.0D 1
      A=COS(C)
      B=EXP(SIN(C*X(J)))
      GA(I)=-COS(X(I))*(1.0D 0+A)+5.0D 0*B
      GA(J)=(1.0D 0+A)+5.0D 0*(X(I)-2.0D 0)*C*COS(C*X(J))*B
      DO 271 L=0,6
      IF (IB+L.NE.I.AND.IB+L.NE.J) GA(IB+L)=0.5D 0*COS(X(IB+L))
  271 CONTINUE
      RETURN
      END
