* SUBROUTINE ECFU99             ALL SYSTEMS                 94/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF CONSTRAINT FUNCTIONS FOR COMPLEMENTARITY PROBLEMS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KC  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FC  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE ECFU99(N,KC,X,FC,NEXT)
      INTEGER N,KC,NEXT
      REAL*8 X(N),FC
      REAL*8 WL,WC,WBB,WG,WGG,WX,WXX,WDET,WRA,WRB,WRC
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,
     &180,190,200,210,220,230,240,250,260,270,280,290), NEXT
   10 IF (KC.EQ.1) THEN
        FC=2.0D 0*X(5)-2.0D 0*X(1)+2.0D 0*(X(5)-1.0D 0)*X(3)
      ELSEIF (KC.EQ.2) THEN
        FC=2.0D 0*X(6)-2.0D 0*X(2)+2.0D 0*(X(6)-1.0D 0)*X(4)
      ELSEIF (KC.EQ.3) THEN
        FC=2.5D-1-(X(5)-1.0D 0)**2
      ELSEIF (KC.EQ.4) THEN
        FC=2.5D-1-(X(6)-1.0D 0)**2
      ENDIF
      RETURN
   20 IF (KC.EQ.1) THEN
        FC=(X(1)-1.0D 0)**2+(X(2)-1.0D 0)**2
      ELSEIF (KC.EQ.2) THEN
        FC=X(2)-X(1)**2+1.0D 0
      ENDIF
      RETURN
   30 IF (KC.EQ.1) THEN
        FC=2.0D 0*X(1)*X(3)+X(3)
      ELSEIF (KC.EQ.2) THEN
        FC=X(3)**2-X(2)
      ENDIF
      RETURN
   40 WL=1.5D 2
      WG=1.0D 0
   41 WGG=1.0D 0/WG
      WX=X(1)+X(2)+X(3)+X(4)+X(5)
      WXX=(5.0D 3/WX)**WGG
      IF (KC.LE.4) THEN
        WC=1.0D 1-2.0D 0*DBLE(KC)
        WBB=-1.0D 0/(1.2D 0-1.0D-1*DBLE(KC))
        FC=WC+X(KC+1)*5.0D 0**WBB-WXX+X(KC+1)*WGG*WXX/WX
     &     -(X(2*KC+4)-X(2*KC+5))
      ELSEIF (KC.LE.8) THEN
        FC=WL-X(KC-3)
      ENDIF
      RETURN
   50 WL=1.5D 2
      WG=1.1D 0
      GOTO 41
   60 WL=1.5D 2
      WG=1.3D 0
      GOTO 41
   70 WL=1.5D 2
      WG=1.5D 0
      GOTO 41
   80 WL=1.5D 2
      WG=1.7D 0
      GOTO 41
   90 WL=5.0D 1
      WG=1.0D 0
      GOTO 41
  100 WL=4.0D 1
      WG=1.1D 0
      GOTO 41
  110 WL=3.0D 1
      WG=1.3D 0
      GOTO 41
  120 WL=2.5D 1
      WG=1.5D 0
      GOTO 41
  130 WL=2.0D 1
      WG=1.7D 0
      GOTO 41
  140 WL=1.5D 2
      WG=1.0D 0
  141 WGG=1.0D 0/WG
      WX=X(1)+X(2)+X(3)+X(4)+X(5)
      WXX=(5.0D 3/WX)**WGG
      IF (KC.LE.4) THEN
        WC=1.0D 1-2.0D 0*DBLE(KC)
        WBB=-1.0D 0/(1.2D 0-1.0D-1*DBLE(KC))
        FC=WC+X(KC+1)*5.0D 0**WBB-WXX+X(KC+1)*WGG*WXX/WX-X(KC+5)
      ELSEIF (KC.LE.8) THEN
        FC=WL-X(KC-3)
      ENDIF
      RETURN
  150 WL=1.5D 2
      WG=1.1D 0
      GOTO 141
  160 WL=1.5D 2
      WG=1.3D 0
      GOTO 141
  170 WL=1.5D 2
      WG=1.5D 0
      GOTO 141
  180 WL=1.5D 2
      WG=1.7D 0
      GOTO 141
  190 WL=5.0D 1
      WG=1.0D 0
      GOTO 141
  200 WL=4.0D 1
      WG=1.1D 0
      GOTO 141
  210 WL=3.0D 1
      WG=1.3D 0
      GOTO 141
  220 WL=2.5D 1
      WG=1.5D 0
      GOTO 141
  230 WL=2.0D 1
      WG=1.7D 0
      GOTO 141
  240 IF (KC.EQ.1) THEN
        FC=-X(4)-X(7)**2
      ELSEIF (KC.EQ.2) THEN
        FC=X(5)+4.0D 0*X(8)
      ELSEIF (KC.EQ.3) THEN
        FC=2.0D 0*(X(4)-X(1))*X(10)
      ELSEIF (KC.EQ.4) THEN
        FC=2.0D 0*X(7)+2.0D 0*(X(7)-X(2))*X(10)
      ELSEIF (KC.EQ.5) THEN
        FC=2.0D 0*(X(5)-X(1))*X(11)
      ELSEIF (KC.EQ.6) THEN
        FC=2.0D 0*(X(8)-X(2))*X(11)
      ELSEIF (KC.EQ.7) THEN
        FC=2.0D 0*(X(6)-X(1))*X(12)
      ELSEIF (KC.EQ.8) THEN
        FC=2.0D 0*(X(9)-X(2))*X(12)
      ELSEIF (KC.EQ.9) THEN
        FC=(X(4)-X(1))**2+(X(7)-X(2))**2-X(3)**2
      ELSEIF (KC.EQ.10) THEN
        FC=(X(5)-X(1))**2+(X(8)-X(2))**2-X(3)**2
      ELSEIF (KC.EQ.11) THEN
        FC=(X(6)-X(1))**2+(X(9)-X(2))**2-X(3)**2
      ENDIF
      RETURN
  250 IF (KC.EQ.9) THEN
        FC=(X(4)-X(1))**2/X(3)**2+(X(7)-X(2))**2/X(13)**2
      ELSEIF (KC.EQ.10) THEN
        FC=(X(5)-X(1))**2/X(3)**2+(X(8)-X(2))**2/X(13)**2
      ELSEIF (KC.EQ.11) THEN
        FC=(X(6)-X(1))**2/X(3)**2+(X(9)-X(2))**2/X(13)**2
      ENDIF
  251 IF (KC.EQ.1) THEN
        FC=-X(4)-X(7)**2
      ELSEIF (KC.EQ.2) THEN
        FC=X(5)+4.0D 0*X(8)
      ELSEIF (KC.EQ.3) THEN
        FC=2.0D 0*(X(4)-X(1))*X(10)/X(3)**2
      ELSEIF (KC.EQ.4) THEN
        FC=2.0D 0*X(7)+2.0D 0*(X(7)-X(2))*X(10)/X(13)**2
      ELSEIF (KC.EQ.5) THEN
        FC=2.0D 0*(X(5)-X(1))*X(11)/X(3)**2
      ELSEIF (KC.EQ.6) THEN
        FC=2.0D 0*(X(8)-X(2))*X(11)/X(13)**2
      ELSEIF (KC.EQ.7) THEN
        FC=2.0D 0*(X(6)-X(1))*X(12)/X(3)**2
      ELSEIF (KC.EQ.8) THEN
        FC=2.0D 0*(X(9)-X(2))*X(12)/X(13)**2
      ELSEIF (KC.EQ.12) THEN
        FC=X(4)-X(1)
      ELSEIF (KC.EQ.13) THEN
        FC=X(5)-X(1)
      ELSEIF (KC.EQ.14) THEN
        FC=X(8)-X(2)
      ELSEIF (KC.EQ.15) THEN
        FC=X(9)-X(2)
      ENDIF
      RETURN
  260 IF (KC.EQ.9) THEN
        FC=(X(4)-X(1))**2*X(13)**2+(X(7)-X(2))**2*X(3)**2-
     &     (X(3)*X(13))**2
      ELSEIF (KC.EQ.10) THEN
        FC=(X(5)-X(1))**2*X(13)**2+(X(8)-X(2))**2*X(3)**2-
     &     (X(3)*X(13))**2
      ELSEIF (KC.EQ.11) THEN
        FC=(X(6)-X(1))**2*X(13)**2+(X(9)-X(2))**2*X(3)**2-
     &     (X(3)*X(13))**2
      ENDIF
      GOTO 251
  270 IF (KC.EQ.1) THEN
        FC=-X(7)-X(10)**2
      ELSEIF (KC.EQ.2) THEN
        FC=X(8)+4.0D 0*X(11)
      ELSEIF (KC.EQ.3) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)/WDET
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        FC=X(13)*(WRA*(X(7)-X(1))+WRB*(X(10)-X(2)))
      ELSEIF (KC.EQ.4) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRC=2.0D 0*(X(3)**2+X(4)**2)/WDET
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        FC=X(13)*(WRC*(X(10)-X(2))+WRB*(X(7)-X(1)))+2.0D 0*X(10)
      ELSEIF (KC.EQ.5) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)/WDET
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        FC=X(14)*(WRA*(X(8)-X(1))+WRB*(X(11)-X(2)))
      ELSEIF (KC.EQ.6) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRC=2.0D 0*(X(3)**2+X(4)**2)/WDET
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        FC=X(14)*(WRC*(X(11)-X(2))+WRB*(X(8)-X(1)))
      ELSEIF (KC.EQ.7) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)/WDET
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        FC=X(15)*(WRA*(X(9)-X(1))+WRB*(X(12)-X(2)))
      ELSEIF (KC.EQ.8) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRC=2.0D 0*(X(3)**2+X(4)**2)/WDET
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        FC=X(15)*(WRC*(X(12)-X(2))+WRB*(X(9)-X(1)))
      ELSEIF (KC.EQ.9) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=(X(5)**2+X(6)**2)/WDET
        WRB=-(X(3)*X(5)+X(4)*X(6))/WDET
        WRC=(X(3)**2+X(4)**2)/WDET
        FC=WRA*(X(7)-X(1))**2+WRC*(X(10)-X(2))**2
     &    +2.0D 0*WRB*(X(7)-X(1))*(X(10)-X(2))
      ELSEIF (KC.EQ.10) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=(X(5)**2+X(6)**2)/WDET
        WRB=-(X(3)*X(5)+X(4)*X(6))/WDET
        WRC=(X(3)**2+X(4)**2)/WDET
        FC=WRA*(X(8)-X(1))**2+WRC*(X(11)-X(2))**2
     &    +2.0D 0*WRB*(X(8)-X(1))*(X(11)-X(2))
      ELSEIF (KC.EQ.11) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=(X(5)**2+X(6)**2)/WDET
        WRB=-(X(3)*X(5)+X(4)*X(6))/WDET
        WRC=(X(3)**2+X(4)**2)/WDET
        FC=WRA*(X(9)-X(1))**2+WRC*(X(12)-X(2))**2
     &    +2.0D 0*WRB*(X(9)-X(1))*(X(12)-X(2))
      ENDIF
      RETURN
  280 IF (KC.EQ.1) THEN
        FC=-X(7)-X(10)**2
      ELSEIF (KC.EQ.2) THEN
        FC=X(8)+4.0D 0*X(11)
      ELSEIF (KC.EQ.3) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        FC=X(13)*(WRA*(X(7)-X(1))+WRB*(X(10)-X(2)))+WDET
      ELSEIF (KC.EQ.4) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRC=2.0D 0*(X(3)**2+X(4)**2)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        FC=X(13)*(WRC*(X(10)-X(2))+WRB*(X(7)-X(1)))+2.0D 0*X(10)*WDET
      ELSEIF (KC.EQ.5) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        FC=X(14)*(WRA*(X(8)-X(1))+WRB*(X(11)-X(2)))-2.5D-1*WDET
      ELSEIF (KC.EQ.6) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRC=2.0D 0*(X(3)**2+X(4)**2)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        FC=X(14)*(WRC*(X(11)-X(2))+WRB*(X(8)-X(1)))-WDET
      ELSEIF (KC.EQ.7) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        FC=X(15)*(WRA*(X(9)-X(1))+WRB*(X(12)-X(2)))
      ELSEIF (KC.EQ.8) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRC=2.0D 0*(X(3)**2+X(4)**2)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        FC=X(15)*(WRC*(X(12)-X(2))+WRB*(X(9)-X(1)))+WDET
      ELSEIF (KC.EQ.9) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=X(5)**2+X(6)**2
        WRB=-(X(3)*X(5)+X(4)*X(6))
        WRC=X(3)**2+X(4)**2
        FC=WRA*(X(7)-X(1))**2+WRC*(X(10)-X(2))**2
     &    +2.0D 0*WRB*(X(7)-X(1))*(X(10)-X(2))-WDET
      ELSEIF (KC.EQ.10) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=X(5)**2+X(6)**2
        WRB=-(X(3)*X(5)+X(4)*X(6))
        WRC=X(3)**2+X(4)**2
        FC=WRA*(X(8)-X(1))**2+WRC*(X(11)-X(2))**2
     &    +2.0D 0*WRB*(X(8)-X(1))*(X(11)-X(2))-WDET
      ELSEIF (KC.EQ.11) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=X(5)**2+X(6)**2
        WRB=-(X(3)*X(5)+X(4)*X(6))
        WRC=X(3)**2+X(4)**2
        FC=WRA*(X(9)-X(1))**2+WRC*(X(12)-X(2))**2
     &    +2.0D 0*WRB*(X(9)-X(1))*(X(12)-X(2))-WDET
      ENDIF
      RETURN
  290 IF (KC.EQ.1) THEN
        FC=-X(5)-X(8)**2
      ELSEIF (KC.EQ.2) THEN
        FC=X(6)+4.0D 0*X(9)
      ELSEIF (KC.EQ.3) THEN
        FC=X(11)-X(17)
      ELSEIF (KC.EQ.4) THEN
        FC=2.0D 0*X(8)+X(14)-X(20)
      ELSEIF (KC.EQ.5) THEN
        FC=X(12)-X(18)
      ELSEIF (KC.EQ.6) THEN
        FC=X(15)-X(21)
      ELSEIF (KC.EQ.7) THEN
        FC=X(13)-X(19)
      ELSEIF (KC.EQ.8) THEN
        FC=X(16)-X(22)
      ELSEIF (KC.LE.11) THEN
        FC=X(KC-4)-X(1)
      ELSEIF (KC.LE.14) THEN
        FC=X(KC-4)-X(2)
      ELSEIF (KC.LE.17) THEN
        FC=X(3)-X(KC-10)
      ELSEIF (KC.LE.20) THEN
        FC=X(4)-X(KC-10)
      ENDIF
      RETURN
      END
