* SUBROUTINE ECGU07             ALL SYSTEMS                 90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF TEST FUNCTIONS FOR NONLINEAR PROGRAMMING.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KC  INDEX OF THE CONSTRAINT.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GC GRADIENT OF THE CONSTRAINT FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE ECGU07(N,KC,X,GC,NEXT)
      INTEGER N,KC,NEXT
      REAL*8 X(N),GC(N)
      REAL*8 X1,X2,X3,X4,X5,X6,X7,X8
      INTEGER I,J,K
      REAL*8 Y(128)
      COMMON /EMPR07/ Y
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,
     * 180,190,200,210,220,230,240,250,260,270,280,290,300,310,320,330,
     * 340),NEXT
   10 GC(1)=2.0D 0*X(1)
      GC(2)=2.0D 0*X(2)
      RETURN
   20 GC(1)=6.0D 0*X(1)-2.0D 0*X(2)
      GC(2)=2.0D 0*(X(2)-X(1))
      RETURN
   30 GC(1)=8.0D 0*X(1)
      GC(2)=2.0D 0*X(2)
      RETURN
   40 GC(1)=-3.0D 0*(1.0D 0-X(1))**2
      GC(2)=-1.0D 0
      RETURN
   50 GC(1)=-X(2)
      GC(2)=0.49D 0-X(1)
      RETURN
   60 GO TO (61,62),KC
   61 GC(1)=-1.0D 0
      GC(2)= 2.0D 0*X(2)
      RETURN
   62 GC(1)=2.0D 0*X(1)
      GC(2)=-1.0D 0
      RETURN
   70 GO TO (71,72),KC
   71 GC(1)=2.0D 0*(X(1)-5.0D 0)
      GC(2)=2.0D 0*(X(2)-5.0D 0)
      RETURN
   72 GC(1)=2.0D 0*(X(1)-6.0D 0)
      GC(2)=2.0D 0*(X(2)-5.0D 0)
      RETURN
   80 GO TO (81,82,10),KC
   81 GC(1)=1.0D 0
      GC(2)=2.0D 0*X(2)
      RETURN
   82 GC(1)=2.0D 0*X(1)
      GC(2)=1.0D 0
      RETURN
   90 GO TO (91,92,93),KC
   91 GC(1)=X(2)
      GC(2)=X(1)
      RETURN
   92 GC(1)=-2.0D 0*X(1)/125.0D 0
      GC(2)= 1.0D 0
      RETURN
   93 GC(1)=-5.0D 0
      GC(2)= 2.0D 0*(X(2)-5.0D 1)
      RETURN
  100 GC(1)= 2.0D 0*X(1)
      GC(2)= 4.0D 0*X(2)
      GC(3)= 8.0D 0*X(3)
      RETURN
  110 GC(1)=2.0D 0*X(1)
      GC(2)=2.0D 0*X(2)
      GC(3)=0.0D 0
      RETURN
  120 GC(1)=X(2)
      GC(2)=X(1)
      GC(3)=0.0D 0
      RETURN
  130 GC(1)=-4.0D 0/X(1)**2
      GC(2)=-3.2D 1/X(2)**2
      GC(3)=-1.2D 2/X(3)**2
      RETURN
  140 GO TO (141,142),KC
  141 GC(1)=EXP(X(1))
      GC(2)=-1.0D 0
      GC(3)= 0.0D 0
      RETURN
  142 GC(1)= 0.0D 0
      GC(2)=EXP(X(2))
      GC(3)=-1.0D 0
      RETURN
  150 X2=1.6D 0*X(1)
      Y(4)=1.6D 0
      Y(5)=0.0D 0
      Y(6)=0.0D 0
  151 X3=1.22D 0*X2-X(1)
      Y(7)=1.22D 0*Y(4)-1.0D 0
      Y(8)=1.22D 0*Y(5)
      Y(9)=1.22D 0*Y(6)
      X6=(X(2)+X3)/X(1)
      Y(16)=Y(7)/X(1)-(X(2)+X3)/X(1)**2
      Y(17)=(1.0D 0+Y(8))/X(1)
      Y(18)=Y(9)/X(1)
      X1=0.01D 0*X(1)*(112.0D 0+13.167D 0*X6-0.6667D 0*X6**2)
      Y(1)=0.01D 0*(112.0D 0+13.167D 0*X6-0.6667D 0*X6**2)+
     * 0.01D 0*X(1)*(13.167*Y(16)-1.3334D 0*X6*Y(16))
      Y(2)=0.01D 0*X(1)*(13.167D 0*Y(17)-1.3334D 0*X6*Y(17))
      Y(3)=0.01D 0*X(1)*(13.167D 0*Y(18)-1.3334D 0*X6*Y(18))
      IF (ABS(X1-X2).GT.0.001D 0) THEN
      X2=X1
      Y(4)=Y(1)
      Y(5)=Y(2)
      Y(6)=Y(3)
      GO TO 151
      ENDIF
      X4=93.0D 0
      Y(10)=0.0D 0
      Y(11)=0.0D 0
      Y(12)=0.0D 0
  152 X5=86.35D 0+1.098D 0*X6-0.038D 0*X6**2+0.325D 0*(X4-89.0D 0)
      Y(13)=1.098D 0*Y(16)-0.076D 0*X6*Y(16)+0.325D 0*Y(10)
      Y(14)=1.098D 0*Y(17)-0.076D 0*X6*Y(17)+0.325D 0*Y(11)
      Y(15)=1.098D 0*Y(18)-0.076D 0*X6*Y(18)+0.325D 0*Y(12)
      X8=3.0D 0*X5-133.0D 0
      Y(22)=3.0D 0*Y(13)
      Y(23)=3.0D 0*Y(14)
      Y(24)=3.0D 0*Y(15)
      X7=35.82D 0-0.222D 0*X8
      Y(19)=-0.222D 0*Y(22)
      Y(20)=-0.222D 0*Y(23)
      Y(21)=-0.222D 0*Y(24)
      Y(89)=X2*X7+1000.0D 0*X(3)
      Y(90)=Y(89)**2
      X1=98000.0D 0*X(3)/Y(89)
      Y(1)=-98000.0D 0*X(3)*(Y(4)*X7+X2*Y(19))/Y(90)
      Y(2)=-98000.0D 0*X(3)*(Y(5)*X7+X2*Y(20))/Y(90)
      Y(3)=-98000.0D 0*X(3)*(Y(6)*X7+X2*Y(21)+1000.0D 0)/Y(90)+
     * 98000.0D 0/Y(89)
      IF (ABS(X1-X4).GT.0.001D 0) THEN
      X4=X1
      Y(10)=Y(1)
      Y(11)=Y(2)
      Y(12)=Y(3)
      GO TO 152
      ENDIF
      GO TO (153,154,155,156,157,158,159),KC
  153 CONTINUE
      GC(1)=Y(4)
      GC(2)=Y(5)
      GC(3)=Y(6)
      RETURN
  154 CONTINUE
      GC(1)=Y(7)
      GC(2)=Y(8)
      GC(3)=Y(9)
      RETURN
  155 CONTINUE
      GC(1)=Y(10)
      GC(2)=Y(11)
      GC(3)=Y(12)
      RETURN
  156 CONTINUE
      GC(1)=Y(13)
      GC(2)=Y(14)
      GC(3)=Y(15)
      RETURN
  157 CONTINUE
      GC(1)=Y(16)
      GC(2)=Y(17)
      GC(3)=Y(18)
      RETURN
  158 CONTINUE
      GC(1)=Y(19)
      GC(2)=Y(20)
      GC(3)=Y(21)
      RETURN
  159 CONTINUE
      GC(1)=Y(22)
      GC(2)=Y(23)
      GC(3)=Y(24)
      RETURN
  160 GC(1)=0.0D 0
      GC(2)=0.0D 0
      GC(3)=1.0D 0-X(4)
      GC(4)=1.0D 0-X(3)
      RETURN
  170 GO TO (171,172),KC
  171 GC(1)=-4.00D 0/X(1)**2
      GC(2)=-2.25D 0/X(2)**2
      GC(3)=-1.00D 0/X(3)**2
      GC(4)=-0.25D 0/X(4)**2
      RETURN
  172 GC(1)=-0.16D 0/X(1)**2
      GC(2)=-0.36D 0/X(2)**2
      GC(3)=-0.64D 0/X(3)**2
      GC(4)=-0.64D 0/X(4)**2
      RETURN
  180 X5=X(1)+X(1)
      X6=X(2)+X(2)
      X7=X(3)+X(3)
      X8=X(4)+X(4)
      GO TO (182,183,184),KC
  182 GC(1)=X5+1.0D 0
      GC(2)=X6-1.0D 0
      GC(3)=X7+1.0D 0
      GC(4)=X8-1.0D 0
      RETURN
  183 GC(1)=X5-1.0D 0
      GC(2)=X6+X6
      GC(3)=X7
      GC(4)=X8+X8-1.0D 0
      RETURN
  184 GC(1)=X5+X5+2.0D 0
      GC(2)=X6-1.0D 0
      GC(3)=X7
      GC(4)=-1.0D 0
      RETURN
  190 GO TO (191,192,193),KC
  191 GC(1)=2.0D 0*X(1)
      GC(2)=2.0D 0*X(2)
      GC(3)=2.0D 0*X(3)
      GC(4)=2.0D 0*X(4)
      GC(5)=2.0D 0*X(5)
      RETURN
  192 GC(1)=2.0D 0*X(1)*X(3)
      GC(2)=0.0D 0
      GC(3)=X(1)**2
      GC(4)=X(5)
      GC(5)=X(4)
      RETURN
  193 GC(1)=10.0D 0*X(5)
      GC(2)=2.0D 0*X(2)*X(4)
      GC(3)=0.0D 0
      GC(4)=X(2)**2
      GC(5)=10.0D 0*X(1)
      RETURN
  200 GO TO (201,202,203),KC
  201 GC(1)= 0.0006262D 0*X(4)
      GC(2)= 0.0056868D 0*X(5)
      GC(3)=-0.0022053D 0*X(5)
      GC(4)= 0.0006262D 0*X(1)
      GC(5)= 0.0056868D 0*X(2)-0.0022053D 0*X(3)
      RETURN
  202 GC(1)=0.0029955D 0*X(2)
      GC(2)=0.0071317D 0*X(5)+0.0029955D 0*X(1)
      GC(3)=0.0043626D 0*X(3)
      GC(4)=0.0D 0
      GC(5)=0.0071317D 0*X(2)
      RETURN
  203 GC(1)=0.0012547D 0*X(3)
      GC(2)=0.0D 0
      GC(3)=0.0047026D 0*X(5)+0.0012547D 0*X(1)+0.0019085D 0*X(4)
      GC(4)=0.0019085D 0*X(3)
      GC(5)=0.0047026D 0*X(3)
      RETURN
  210 GO TO (211,212,213),KC
  211 GC(1)=-145421.4020D 0+2931.15060D 0*X(2)-
     * 40.4279320D 0*X(3)+5106.1920D 0*X(4)+15711.36D 0*X(5)
      GC(2)=2931.15060D 0*X(1)
      GC(3)=-40.4279320D 0*X(1)
      GC(4)=5106.1920D 0*X(1)
      GC(5)=15711.36D 0*X(1)
      RETURN
  212 GC(1)=-155011.1084D 0+4360.53352D 0*X(2)+
     * 12.9492344D 0*X(3)+10236.884D 0*X(4)+13176.786D 0*X(5)
      GC(2)=4360.53352D 0*X(1)
      GC(3)=12.9492344D 0*X(1)
      GC(4)=10236.884D 0*X(1)
      GC(5)=13176.786D 0*X(1)
      RETURN
  213 GC(1)=-326669.5104D 0+7390.68412D 0*X(2)-
     * 27.8986976D 0*X(3)+16643.076D 0*X(4)+30988.146D 0*X(5)
      GC(2)=7390.68412D 0*X(1)
      GC(3)=-27.8986976D 0*X(1)
      GC(4)=16643.076D 0*X(1)
      GC(5)=30988.146D 0*X(1)
      RETURN
  220 IF(KC.EQ.2) THEN
      GC(1)=0.0D 0
      GC(2)=1.5D 0
      GC(3)=-1.0D 0
      GC(4)=0.0D 0
      GC(5)=0.0D 0
      RETURN
      ENDIF
      X1=146.312D 3
      Y(1)=X(2)+X(3)+41.6D 0
      Y(18)=0.024D 0*X(4)-4.62D 0
      Y(2)=12.5D 0/Y(18)+12.0D 0
      Y(19)=0.0003535D 0*X(1)**2+0.5311D 0*X(1)+0.08705D 0*Y(2)*X(1)
      Y(20)=0.052D 0*X(1)+78.0D 0+0.002377D 0*Y(2)*X(1)
      Y(3)=Y(19)/Y(20)
      Y(4)=19.0D 0*Y(3)
      Y(21)=0.04782D 0*(X(1)-Y(3))+0.1956D 0*(X(1)-Y(3))**2/X(2)+
     * 0.6376D 0*Y(4)+1.594D 0*Y(3)
      Y(22)=100.0D 0*X(2)
      Y(23)=X(1)-Y(3)-Y(4)
      Y(24)=0.95D 0-Y(21)/Y(22)
      Y(5)=Y(23)*Y(24)
      Y(6)=X(1)-Y(5)-Y(4)-Y(3)
      Y(25)=(Y(5)+Y(4))*0.995D 0
      Y(7)=Y(25)/Y(1)
      Y(8)=Y(25)/3798.0D 0
      Y(26)=Y(7)-0.0663D 0*Y(7)/Y(8)-0.3153D 0
      Y(9)=96.82D 0/Y(26)+0.321D 0*Y(1)
      Y(10)=1.29D 0*Y(5)+1.258D 0*Y(4)+2.29D 0*Y(3)+1.71D 0*Y(6)
      Y(11)=1.71D 0*X(1)-0.452D 0*Y(4)+0.58D 0*Y(3)
      Y(27)=12.3D 0/752.3D 0
      Y(28)=1.75D 0*Y(2)*0.995D 0*X(1)
      Y(29)=0.995D 0*Y(10)+1998.0D 0
      Y(12)=Y(27)*X(1)+Y(28)/Y(29)
      Y(13)=Y(29)-1.75D 0*Y(2)
      Y(14)=3623.0D 0+64.4D 0*X(2)+58.4D 0*X(3)+X1/(Y(9)+
     * X(5))
      Y(30)=0.995D 0*Y(10)+60.8D 0*X(2)+48.0D 0*X(4)-0.1121D 0*Y(14)-
     * 5095.0D 0
      Y(15)=Y(13)/Y(30)
      Y(16)=148.0D 3-331.0D 3*Y(15)+40.0D 0*Y(13)-61.0D 0*Y(15)*Y(13)
      Y(31)=2324.0D 0*Y(10)-2.874D 7*Y(2)
      Y(17)=1.413D 7-1328.0D 0*Y(10)-531.0D 0*Y(11)+Y(31)/Y(29)
      Y(32)=Y(13)/Y(15)-Y(13)/0.52D 0
      Y(33)=1.104D 0-0.72D 0*Y(15)
      Y(34)=Y(9)+X(5)
      Y(35)=1.0D 0
      Y(36)=0.024D 0
      Y(37)=-12.5D 0*Y(36)/Y(18)**2
      Y(38)=0.000707D 0*X(1)+0.5311D 0+0.08705D 0*Y(2)
      Y(39)=0.08705D 0*X(1)*Y(37)
      Y(40)=0.052D 0+0.002377D 0*Y(2)
      Y(41)=0.002377D 0*X(1)*Y(37)
      Y(42)=(Y(38)*Y(20)-Y(19)*Y(40))/Y(20)**2
      Y(43)=(Y(39)*Y(20)-Y(19)*Y(41))/Y(20)**2
      Y(44)=19.0D 0*Y(42)
      Y(45)=19.0D 0*Y(43)
      Y(46)=0.04782D 0*(1.0D 0-Y(42))+0.3912D 0*(X(1)-Y(3))*(1.0D 0-
     * Y(42))/X(2)+0.6376D 0*Y(44)+1.594D 0*Y(42)
      Y(47)=-0.1956D 0*(X(1)-Y(3))**2/X(2)**2
      Y(48)=-0.04782D 0*Y(43)-0.3912D 0*(X(1)-Y(3))*Y(43)/X(2)+
     * 0.6376D 0*Y(45)+1.594D 0*Y(43)
      Y(49)=100.0D 0
      Y(50)=1.0D 0-Y(42)-Y(44)
      Y(51)=-Y(43)-Y(45)
      Y(52)=-Y(46)/Y(22)
      Y(53)=(Y(21)*Y(49)-Y(47)*Y(22))/Y(22)**2
      Y(54)=-Y(48)/Y(22)
      Y(55)=Y(50)*Y(24)+Y(23)*Y(52)
      Y(56)=Y(23)*Y(53)
      Y(57)=Y(51)*Y(24)+Y(23)*Y(54)
      Y(58)=1.0D 0-Y(55)-Y(44)-Y(42)
      Y(59)=-Y(56)
      Y(60)=-Y(57)-Y(45)-Y(43)
      Y(61)=0.995D 0*(Y(55)+Y(44))
      Y(62)=0.995D 0*Y(56)
      Y(63)=0.995D 0*(Y(57)+Y(45))
      Y(64)=Y(61)/Y(1)
      Y(65)=(Y(62)*Y(1)-Y(25)*Y(35))/Y(1)**2
      Y(66)=-Y(25)*Y(35)/Y(1)**2
      Y(67)=Y(63)/Y(1)
      Y(68)=Y(61)/3798.0D 0
      Y(69)=Y(62)/3798.0D 0
      Y(70)=Y(63)/3798.0D 0
      Y(71)=Y(64)-0.0663D 0*(Y(64)*Y(8)-Y(7)*Y(68))/Y(8)**2
      Y(72)=Y(65)-0.0663D 0*(Y(65)*Y(8)-Y(7)*Y(69))/Y(8)**2
      Y(73)=Y(66)-0.0663D 0*Y(66)/Y(8)
      Y(74)=Y(67)-0.0663D 0*(Y(67)*Y(8)-Y(7)*Y(70))/Y(8)**2
      Y(75)=-96.82D 0*Y(71)/Y(26)**2
      Y(76)=-96.82D 0*Y(72)/Y(26)**2+0.321D 0*Y(35)
      Y(77)=-96.82D 0*Y(73)/Y(26)**2+0.321D 0*Y(35)
      Y(78)=-96.82D 0*Y(74)/Y(26)**2
      Y(79)=1.29D 0*Y(55)+1.258D 0*Y(44)+2.29D 0*Y(42)+1.71D 0*Y(58)
      Y(80)=1.29D 0*Y(56)+1.71D 0*Y(59)
      Y(81)=1.29D 0*Y(57)+1.258D 0*Y(45)+2.29D 0*Y(43)+1.71D 0*Y(60)
      Y(82)=1.71D 0-0.452D 0*Y(44)+0.58D 0*Y(42)
      Y(83)=-0.452D 0*Y(45)+0.58D 0*Y(43)
      Y(84)=1.75D 0*Y(2)*0.995D 0
      Y(85)=1.75D 0*Y(37)*0.995D 0*X(1)
      Y(86)=0.995D 0*Y(79)
      Y(87)=0.995D 0*Y(80)
      Y(88)=0.995D 0*Y(81)
      Y(89)=Y(27)+(Y(84)*Y(29)-Y(28)*Y(86))/Y(29)**2
      Y(90)=-Y(28)*Y(87)/Y(29)**2
      Y(91)=(Y(85)*Y(29)-Y(28)*Y(88))/Y(29)**2
      Y(92)=Y(88)-1.75D 0*Y(37)
      Y(93)=-X1*Y(75)/(Y(9)+X(5))**2
      Y(94)=64.4D 0-X1*Y(76)/(Y(9)+X(5))**2
      Y(95)=58.4D 0-X1*Y(77)/(Y(9)+X(5))**2
      Y(96)=-X1*Y(78)/(Y(9)+X(5))**2
      Y(97)=-X1/(Y(9)+X(5))**2
      Y(98)=0.995D 0*Y(79)-0.1121D 0*Y(93)
      Y(99)=0.995D 0*Y(80)+60.8D 0-0.1121D 0*Y(94)
      Y(100)=-0.1121D 0*Y(95)
      Y(101)=0.995D 0*Y(81)+48.0D 0-0.1121D 0*Y(96)
      Y(102)=-0.1121D 0*Y(97)
      Y(103)=(Y(86)*Y(30)-Y(13)*Y(98))/Y(30)**2
      Y(104)=(Y(87)*Y(30)-Y(13)*Y(99))/Y(30)**2
      Y(105)=-Y(13)*Y(100)/Y(30)**2
      Y(106)=(Y(92)*Y(30)-Y(13)*Y(101))/Y(30)**2
      Y(107)=-Y(13)*Y(102)/Y(30)**2
      Y(108)=-3.31D 5*Y(103)+40.0D 0*Y(86)-61.0D 0*(Y(103)*Y(13)+
     * Y(15)*Y(86))
      Y(109)=-3.31D 5*Y(104)+40.0D 0*Y(87)-61.0D 0*(Y(104)*Y(13)+
     * Y(15)*Y(87))
      Y(110)=-3.31D 5*Y(105)-61.0D 0*Y(105)*Y(13)
      Y(111)=-3.31D 5*Y(106)+40.0D 0*Y(92)-61.0D 0*(Y(106)*Y(13)+
     * Y(15)*Y(92))
      Y(112)=-3.31D 5*Y(107)-61.0D 0*Y(107)*Y(13)
      Y(113)=2.324D 3*Y(79)
      Y(114)=2.324D 3*Y(80)
      Y(115)=2.324D 3*Y(81)-2.874D 7*Y(37)
      Y(116)=-1.328D 3*Y(79)-531.0D 0*Y(82)+(Y(113)*Y(29)-Y(31)*
     * Y(86))/Y(29)**2
      Y(117)=-1.328D 3*Y(80)+(Y(114)*Y(29)-Y(31)*Y(87))/Y(29)**2
      Y(118)=-1.328D 3*Y(81)-531.0D 0*Y(83)+(Y(115)*Y(29)-Y(31)*
     * Y(88))/Y(29)**2
      Y(119)=(Y(86)*Y(15)-Y(13)*Y(103))/Y(15)**2-Y(86)/0.52D 0
      Y(120)=(Y(87)*Y(15)-Y(13)*Y(104))/Y(15)**2-Y(87)/0.52D 0
      Y(121)=-Y(13)*Y(105)/Y(15)**2
      Y(122)=(Y(92)*Y(15)-Y(13)*Y(106))/Y(15)**2-Y(92)/0.52D 0
      Y(123)=-Y(13)*Y(107)/Y(15)**2
      Y(124)=-0.72D 0*Y(103)
      Y(125)=-0.72D 0*Y(104)
      Y(126)=-0.72D 0*Y(105)
      Y(127)=-0.72D 0*Y(106)
      Y(128)=-0.72D 0*Y(107)
      IF (KC.EQ.1) THEN
      GC(1)=Y(44)-0.28D 0*Y(55)/0.72D 0
      GC(2)=-0.28D 0*Y(56)/0.72D 0
      GC(3)=0.0D 0
      GC(4)=Y(45)-0.28D 0*Y(57)/0.72D 0
      GC(5)=0.0D 0
      RETURN
      ENDIF
      GO TO (503,504,505,506,507,508,509,510,511,512,513,514,515,516,
     * 517,518,519,520,521),KC-2
  503 GC(1)=-3496.0D 0*Y(2)*Y(86)/Y(29)**2
      GC(2)=-3496.0D 0*Y(2)*Y(87)/Y(29)**2
      GC(3)=0.0D 0
      GC(4)=3496.0D 0*(Y(37)*Y(29)-Y(2)*Y(88))/Y(29)**2
      GC(5)=0.0D 0
      RETURN
  504 GC(1)=-62212.0D 0*Y(75)/Y(34)**2
      GC(2)=-62212.0D 0*Y(76)/Y(34)**2-Y(35)
      GC(3)=-62212.0D 0*Y(77)/Y(34)**2-Y(35)
      GC(4)=-62212.0D 0*Y(78)/Y(34)**2
      GC(5)=-62212.0D 0*Y(35)/Y(34)**2
      RETURN
  505 GC(1)=0.0D 0
      GC(2)=Y(35)
      GC(3)=Y(35)
      GC(4)=0.0D 0
      GC(5)=0.0D 0
      RETURN
  506 GC(1)=0.0D 0
      GC(2)=0.0D 0
      GC(3)=0.0D 0
      GC(4)=Y(37)
      GC(5)=0.0D 0
      RETURN
  507 GC(1)=Y(42)
      GC(2)=0.0D 0
      GC(3)=0.0D 0
      GC(4)=Y(43)
      GC(5)=0.0D 0
      RETURN
  508 GC(1)=Y(44)
      GC(2)=0.0D 0
      GC(3)=0.0D 0
      GC(4)=Y(45)
      GC(5)=0.0D 0
      RETURN
  509 GC(1)=Y(55)
      GC(2)=Y(56)
      GC(3)=0.0D 0
      GC(4)=Y(57)
      GC(5)=0.0D 0
      RETURN
  510 GC(1)=Y(58)
      GC(2)=Y(59)
      GC(3)=0.0D 0
      GC(4)=Y(60)
      GC(5)=0.0D 0
      RETURN
  511 GC(1)=Y(64)
      GC(2)=Y(65)
      GC(3)=Y(66)
      GC(4)=Y(67)
      GC(5)=0.0D 0
      RETURN
  512 GC(1)=Y(68)
      GC(2)=Y(69)
      GC(3)=0.0D 0
      GC(4)=Y(70)
      GC(5)=0.0D 0
      RETURN
  513 GC(1)=Y(75)
      GC(2)=Y(76)
      GC(3)=Y(77)
      GC(4)=Y(78)
      GC(5)=0.0D 0
      RETURN
  514 GC(1)=Y(79)
      GC(2)=Y(80)
      GC(3)=0.0D 0
      GC(4)=Y(81)
      GC(5)=0.0D 0
      RETURN
  515 GC(1)=Y(82)
      GC(2)=0.0D 0
      GC(3)=0.0D 0
      GC(4)=Y(83)
      GC(5)=0.0D 0
      RETURN
  516 GC(1)=Y(89)
      GC(2)=Y(90)
      GC(3)=0.0D 0
      GC(4)=Y(91)
      GC(5)=0.0D 0
      RETURN
  517 GC(1)=Y(86)
      GC(2)=Y(87)
      GC(3)=0.0D 0
      GC(4)=Y(92)
      GC(5)=0.0D 0
      RETURN
  518 GC(1)=Y(93)
      GC(2)=Y(94)
      GC(3)=Y(95)
      GC(4)=Y(96)
      GC(5)=Y(97)
      RETURN
  519 GC(1)=Y(103)
      GC(2)=Y(104)
      GC(3)=Y(105)
      GC(4)=Y(106)
      GC(5)=Y(107)
      RETURN
  520 GC(1)=Y(108)
      GC(2)=Y(109)
      GC(3)=Y(110)
      GC(4)=Y(111)
      GC(5)=Y(112)
      RETURN
  521 GC(1)=Y(116)
      GC(2)=Y(117)
      GC(3)=0.0D 0
      GC(4)=Y(118)
      GC(5)=0.0D 0
      RETURN
  230 GO TO (231,232),KC
  231 GC(1)=2.0D 0*X(1)
      GC(2)=2.0D 0*X(2)
      GC(3)=2.0D 0*X(3)
      GC(4)=0.0D 0
      GC(5)=0.0D 0
      GC(6)=0.0D 0
      RETURN
  232 GC(1)=0.0D 0
      GC(2)=0.0D 0
      GC(3)=0.0D 0
      GC(4)=2.0D 0*(X(4)-3.0D 0)
      GC(5)=2.0D 0*X(5)
      GC(6)=0.0D 0
      RETURN
  240 GO TO (241,242),KC
  241 GC(1)=0.001D 0*X(2)*X(3)*X(4)*X(5)*X(6)
      GC(2)=0.001D 0*X(1)*X(3)*X(4)*X(5)*X(6)
      GC(3)=0.001D 0*X(1)*X(2)*X(4)*X(5)*X(6)
      GC(4)=0.001D 0*X(1)*X(2)*X(3)*X(5)*X(6)
      GC(5)=0.001D 0*X(1)*X(2)*X(3)*X(4)*X(6)
      GC(6)=0.001D 0*X(1)*X(2)*X(3)*X(4)*X(5)
      RETURN
  242 GC(1)=0.00124D 0*X(1)*X(4)*X(5)**2+
     * 0.00062D 0*X(4)*X(5)**2*(X(2)+X(3))+
     * 0.00058D 0*X(2)*X(3)*X(6)**2
      GC(2)=0.00062D 0*X(1)*X(4)*X(5)**2+
     * 0.00116D 0*1.57D 0*X(2)*X(3)*X(6)**2+
     * 0.00058D 0*X(3)*X(6)**2*(X(1)+X(4))
      GC(3)=0.00062D 0*X(1)*X(4)*X(5)**2+
     * 0.00058D 0*X(2)*X(6)**2*(X(1)+1.57D 0*X(2)+X(4))
      GC(4)=0.00062D 0*X(1)*X(5)**2*(X(1)+X(2)+X(3))+
     * 0.00058D 0*X(2)*X(3)*X(6)**2
      GC(5)=0.00124D 0*X(1)*X(4)*X(5)*(X(1)+X(2)+X(3))
      GC(6)=0.00116D 0*X(2)*X(3)*X(6)*(X(1)+1.57D 0*X(2)+X(4))
      RETURN
  250 GO TO (251,252,253,254),KC
  251 GC(1)=17.1D 0-169.0D 0*X(3)
      GC(2)=38.2D 0
      GC(3)=204.2D 0-169.0D 0*X(1)-3580.0D 0*X(5)
      GC(4)=212.3D 0-3810.0D 0*X(5)-18500.0D 0*X(6)
      GC(5)=623.4D 0-3580.0D 0*X(3)-3810.0D 0*X(4)-24300.0D 0*X(6)
      GC(6)=1495.5D 0-18500.0D 0*X(4)-24300.0D 0*X(5)
      RETURN
  252 GC(1)=17.9D 0-139.0D 0*X(3)
      GC(2)=36.8D 0
      GC(3)=113.9D 0-139.0D 0*X(1)
      GC(4)=169.7D 0-2450.0D 0*X(5)-16600.0D 0*X(6)
      GC(5)=337.8D 0-2450.0D 0*X(4)-17200.0D 0*X(6)
      GC(6)=1385.2D 0-16600.0D 0*X(4)-17200.0D 0*X(5)
      RETURN
  253 GC(1)=0.0D 0
      GC(2)=-273.0D 0
      GC(3)=0.0D 0
      GC(4)=-70.0D 0+26000.0D 0*X(5)
      GC(5)=-819.0D 0+26000.0D 0*X(4)
      GC(6)=0 0D 0
      RETURN
  254 GC(1)=159.9D 0-14000.0D 0*X(6)
      GC(2)=-311.0D 0
      GC(3)=0.0D 0
      GC(4)=587.0D 0
      GC(5)=391.0D 0
      GC(6)=2198.0D 0-14000.0D 0*X(1)
      RETURN
  260 GC(1)=0.0D 0
      GC(2)=0.0D 0
      GC(3)=0.0D 0
      GC(4)=0.0D 0
      GC(5)=0.0D 0
      GC(6)=0.0D 0
      GC(7)=0.0D 0
      GO TO (261,262,263,264),KC
  261 GC(1)=4.0D 0*X(1)
      GC(2)=1.2D 1*X(2)**3
      GC(3)=1.0D 0
      GC(4)=8.0D 0*X(4)
      GC(5)=5.0D 0
      RETURN
  262 GC(1)=7.0D 0
      GC(2)=3.0D 0
      GC(3)=2.0D 1*X(3)
      GC(4)=1.0D 0
      GC(5)=-1.0D 0
      RETURN
  263 GC(1)=2.3D 1
      GC(2)=2.0D 0*X(2)
      GC(6)=1.2D 1*X(6)
      GC(7)=-8.0D 0
      RETURN
  264 GC(1)=8.0D 0*X(1)-3.0D 0*X(2)
      GC(2)=2.0D 0*X(2)-3.0D 0*X(1)
      GC(3)=4.0D 0*X(3)
      GC(6)=5.0D 0
      GC(7)=-1.1D 1
      RETURN
  270 GO TO (271,272,273,274,275),KC
  271 GC(1)=0.25D 0*X(7)/(X(1)**0.5D 0*X(3)*X(6)**2)+
     * 2.1D 0*X(1)**2*X(2)*X(6)*X(7)**0.5D 0/X(3)**2
      GC(2)=0.7D 0*X(1)**3*X(6)*X(7)**0.5D 0/X(3)**2-
     * 0.2D 0*X(3)*X(6)**(2.0D 0/3.0D 0)*X(7)**(1.0D 0/4.0D 0)/
     * (X(2)**2*X(4)**0.5D 0)
      GC(3)=-0.5D 0*X(1)**0.5D 0*X(7)/(X(3)*X(6))**2-
     * 1.4D 0*X(1)**3*X(2)*X(6)*X(7)**0.5D 0/X(3)**3+
     * 0.2D 0*X(6)**(2.0D 0/3.0D 0)*X(7)**(1.0D 0/4.0D 0)/
     * (X(2)*X(4)**0.5D 0)
      GC(4)=-0.1D 0*X(3)*X(6)**(2.0D 0/3.0D 0)*
     * X(7)**(1.0D 0/4.0D 0)/(X(2)*X(4)**1.5D 0)
      GC(5)=0.0D 0
      GC(6)=-1.0D 0*X(1)**0.5D 0*X(7)/(X(3)*X(6)**3)+
     * 0.7D 0*X(1)**3*X(2)*X(7)**0.5D 0/X(3)**2+
     * (0.4D 0/3.0D 0)*X(3)*X(7)**(1.0D 0/4.0D 0)/
     * (X(2)*X(4)**0.5D 0*X(6)**(1.0D 0/3.0D 0))
      GC(7)=0.5D 0*X(1)**0.5D 0/(X(3)*X(6)**2)+
     * 0.35D 0*X(1)**3*X(2)*X(6)/(X(3)**2*X(7)**0.5D 0)+
     * 0.05D 0*X(3)*X(6)**(2.0D 0/3.0D 0)/
     * (X(2)*X(4)**0.5D 0*X(7)**0.75D 0)
      RETURN
  272 GC(1)=-0.65D 0*X(2)*X(6)/(X(1)**1.5D 0*X(3)*X(5))-
     * 3.1D 0*X(2)**0.5D 0*X(6)**(1.0D 0/3.0D 0)/
     * ((X(1)*X(4))**2*X(5))
      GC(2)=1.3D 0*X(6)/(X(1)**0.5D 0*X(3)*X(5))+
     * 1.55D 0*X(6)**(1.0D 0/3.0D 0)/
     * (X(1)*X(2)**0.5D 0*X(4)**2*X(5))
      GC(3)=-1.3D 0*X(2)*X(6)/(X(1)**0.5D 0*X(3)**2*X(5))+
     * 0.8D 0*X(6)**2/(X(4)*X(5))
      GC(4)=-0.8D 0*X(3)*X(6)**2/(X(4)**2*X(5))-
     * 6.2D 0*X(2)**0.5D 0*X(6)**(1.0D 0/3.0D 0)/
     * (X(1)*X(4)**3*X(5))
      GC(5)=-1.3D 0*X(2)*X(6)/(X(1)**0.5D 0*X(3)*X(5)**2)-
     * 0.8D 0*X(3)*X(6)**2/(X(4)*X(5)**2)-
     * 3.1D 0*X(2)**0.5D 0*X(6)**(1.0D 0/3.0D 0)/
     * (X(1)*(X(4)*X(5))**2)
      GC(6)=1.3D 0*X(2)/(X(1)**0.5D 0*X(3)*X(5))+
     * 1.6D 0*X(3)*X(6)/(X(4)*X(5))+
     * (3.1D 0/3.0D 0)*X(2)**0.5D 0/
     * (X(1)*X(4)**2*X(5)*X(6)**(2.0D 0/3.0D 0))
      GC(7)=0.0D 0
      RETURN
  273 GC(1)=2.0D 0*X(5)*X(7)**(4.0D 0/3.0D 0)/(X(3)**1.5D 0*X(6))-
     * X(2)*X(3)**0.5D 0*X(5)/X(1)**2
      GC(2)=0.1D 0*X(5)/(X(3)**0.5D 0*X(6)*X(7)**0.5D 0)+
     * X(3)**0.5D 0*X(5)/X(1)-
     * 1.3D 0*X(3)*X(5)*X(7)/(X(2)**3*X(6))
      GC(3)=-3.0D 0*X(1)*X(5)*X(7)**(4.0D 0/3.0D 0)/(X(3)**2.5D 0*
     * X(6))-0.05D 0*X(2)*X(5)/(X(3)**1.5D 0*X(6)*X(7)**0.5D 0)+
     * 0.5D 0*X(2)*X(5)/(X(1)*X(3)**0.5D 0)+
     * 0.65D 0*X(5)*X(7)/(X(2)**2*X(6))
      GC(4)=0.0D 0
      GC(5)=2.0D 0*X(1)*X(7)**(4.0D 0/3.0D 0)/(X(3)**1.5D 0*X(6))+
     * 0.1D 0*X(2)/(X(3)**0.5D 0*X(6)*X(7)**0.5D 0)+
     * X(2)*X(3)**0.5D 0/X(1)+
     * 0.65D 0*X(3)*X(7)/(X(2)**2*X(6))
      GC(6)=-2.0D 0*X(1)*X(5)*X(7)**(4.0D 0/3.0D 0)/(X(3)**1.5D 0*
     * X(6)**2)-0.1D 0*X(2)*X(5)/(X(3)**0.5D 0*X(6)**2*X(7)**0.5D 0)-
     * 0.65D 0*X(3)*X(5)*X(7)/(X(2)**2*X(6)**2)
      GC(7)=(8.0D 0/3.0D 0)*X(1)*X(5)*X(7)**(1.0D 0/3.0D 0)/
     * (X(3)**1.5D 0*X(6))-0.05D 0*X(2)*X(5)/(X(3)**0.5D 0*X(6)*
     * X(7)**1.5D 0)+0.65D 0*X(3)*X(5)/(X(2)**2*X(6))
      RETURN
  274 GC(1)=-0.4D 0*X(2)*X(5)**0.5D 0*X(7)**(1.0D 0/3.0D 0)/
     * (X(1)**3*X(4))+
     * 0.15D 0*X(2)**2*X(3)*X(4)**(1.0D 0/3.0D 0)*
     * X(7)**(1.0D 0/4.0D 0)/(X(1)**0.5D 0*X(5)**(2.0D 0/3.0D 0))-
     * 1.2D 0*X(3)*X(5)*X(7)**(3.0D 0/4.0D 0)/(X(1)**4*X(2)**2)
      GC(2)=0.2D 0*X(5)**0.5D 0*X(7)**(1.0D 0/3.0D 0)/
     * (X(1)**2*X(4))+
     * 0.6D 0*X(1)**0.5D 0*X(2)*X(3)*X(4)**(1.0D 0/3.0D 0)*
     * X(7)**0.25D 0/X(5)**(2.0D 0/3.0D 0)-
     * 0.8D 0*X(3)*X(5)*X(7)**0.75D 0/(X(1)*X(2))**3
      GC(3)=0.3D 0*X(1)**0.5D 0*X(2)**2*X(4)**(1.0D 0/3.0D 0)*
     * X(7)**(1.0D 0/4.0D 0)/X(5)**(2.0D 0/3.0D 0)+
     * 0.4D 0*X(5)*X(7)**(3.0D 0/4.0D 0)/(X(1)**3*X(2)**2)-
     * X(4)*X(7)**0.5D 0/X(3)**3
      GC(4)=-0.2D 0*X(2)*X(5)**0.5D 0*X(7)**(1.0D 0/3.0D 0)/
     * (X(1)*X(4))**2+
     * (0.3D 0/3.0D 0)*X(1)**0.5D 0*X(2)**2*X(3)*
     * X(7)**(1.0D 0/4.0D 0)/(X(4)**(2.0D 0/3.0D 0)*X(5)**
     * (2.0D 0/3.0D 0))+0.5D 0*X(7)**0.5D 0/X(3)**2
      GC(5)=0.1D 0*X(2)*X(7)**(1.0D 0/3.0D 0)/
     * (X(1)**2*X(4)*X(5)**0.5D 0)-
     * (0.6D 0/3.0D 0)*X(1)**0.5D 0*X(2)**2*X(3)*X(4)**(1.0D 0/
     * 3.0D 0)*X(7)**(1.0D 0/4.0D 0)/X(5)**(5.0D 0/3.0D 0)+
     * 0.4D 0*X(3)*X(7)**(3.0D 0/4.0D 0)/(X(1)**3*X(2)**2)
      GC(6)=0.0D 0
      GC(7)=(0.2D 0/3.0D 0)*X(2)*X(5)**0.5D 0/
     * (X(1)**2*X(4)*X(7)**(2.0D 0/3.0D 0))+
     * 0.075D 0*X(1)**0.5D 0*X(2)**2*X(3)*X(4)**(1.0D 0/3.0D 0)/
     * (X(5)**(2.0D 0/3.0D 0)*X(7)**(3.0D 0/4.0D 0))+
     * 0.3D 0*X(3)*X(5)/(X(1)**3*X(2)**2*X(7)**(1.0D 0/4.0D 0))+
     * 0.25D 0*X(4)/(X(3)**2*X(7)**0.5D 0)
      RETURN
  275 GC(1)=10.0D 0*X(4)**2/(X(2)*X(6)**3*X(7)**0.25D 0)-
     * 15.0D 0*X(3)*X(4)/((X(1)*X(2))**2*X(5)*X(7)**0.5D 0)-
     * 40.0D 0*X(2)*X(6)/(X(1)**3*X(4)*X(5)**2)+
     * 50.0D 0*X(1)*X(2)**2*X(5)**0.5D 0*X(7)/(X(3)*X(6)**2)
      GC(2)=-10.0D 0*X(1)*X(4)**2/(X(2)**2*X(6)**3*X(7)**0.25D 0)-
     * 30.0D 0*X(3)*X(4)/(X(1)*X(2)**3*X(5)*X(7)**0.5D 0)+
     * 20.0D 0*X(6)/(X(1)**2*X(4)*X(5)**2)+
     * 50.0D 0*X(1)**2*X(2)*X(5)**0.5D 0*X(7)/(X(3)*X(6)**2)
      GC(3)=15.0D 0*X(4)/(X(1)*X(2)**2*X(5)*X(7)**0.5D 0)-
     * 25.0D 0*X(1)**2*X(2)**2*X(5)**0.5D 0*X(7)/(X(3)*X(6))**2
      GC(4)=20.0D 0*X(1)*X(4)/(X(2)*X(6)**3*X(7)**0.25D 0)+
     * 15.0D 0*X(3)/(X(1)*X(2)**2*X(5)*X(7)**0.5D 0)-
     * 20.0D 0*X(2)*X(6)/(X(1)*X(4)*X(5))**2
      GC(5)=-15.0D 0*X(3)*X(4)/(X(1)*(X(2)*X(5))**2*X(7)**0.5D 0)-
     * 40.0D 0*X(2)*X(6)/(X(1)**2*X(4)*X(5)**3)+
     * 12.5D 0*X(1)**2*X(2)**2*X(7)/(X(3)*X(5)**0.5D 0*X(6)**2)
      GC(6)=-30.0D 0*X(1)*X(4)**2/(X(2)*X(6)**4*X(7)**0.25D 0)+
     * 20.0D 0*X(2)/(X(1)**2*X(4)*X(5)**2)-
     * 50.0D 0*X(1)**2*X(2)**2*X(5)**0.5D 0*X(7)/(X(3)*X(6)**3)
      GC(7)=-2.5D 0*X(1)*X(4)**2/(X(2)*X(6)**3*X(7)**1.25D 0)-
     * 7.5D 0*X(3)*X(4)/(X(1)*X(2)**2*X(5)*X(7)**1.5D 0)+
     * 25.0D 0*X(1)**2*X(2)**2*X(5)**0.5D 0/(X(3)*X(6)**2)
      RETURN
  280 GC(1)=0.0D 0
      GC(2)=0.0D 0
      GC(3)=0.0D 0
      GC(4)=0.0D 0
      GC(5)=0.0D 0
      GC(6)=0.0D 0
      GC(7)=0.0D 0
      GC(8)=0.0D 0
      GO TO (281,282,283,284,285),KC
  281 GC(1)=0.1D 0
      GC(5)=0.0588D 0*X(7)
      GC(7)=0.0588D 0*X(5)
      RETURN
  282 GC(1)=0.1D 0
      GC(2)=0.1D 0
      GC(6)=0.0588D 0*X(8)
      GC(8)=0.0588D 0*X(6)
      RETURN
  283 GC(3)=4.0D 0/X(5)-1.42D 0/(X(3)**1.71D 0*X(5))-
     * 0.0588D 0*1.3D 0*X(7)/X(3)**2.3D 0
      GC(5)=-4.0D 0*X(3)/X(5)**2-2.0D 0/(X(3)**0.71D 0*X(5)**2)
      GC(7)=0.0588D 0/X(3)**1.3D 0
      RETURN
  284 GC(4)=4.0D 0/X(6)-1.42D 0/(X(4)**1.71D 0*X(6))-
     * 0.0588D 0*1.3D 0*X(8)/X(4)**2.3D 0
      GC(6)=-4.0D 0*X(4)/X(6)**2-2.0D 0/(X(4)**0.71D 0*X(6)**2)
      GC(8)=0.0588D 0/X(4)**1.3D 0
      RETURN
  285 GC(1)=0.268D 0*(X(7)/X(1))**0.33D 0/X(7)-1.0D 0
      GC(2)=0.268D 0*(X(8)/X(2))**0.33D 0/X(8)-1.0D 0
      GC(7)=-0.268D 0*(X(1)/X(7))**0.67D 0/X(7)
      GC(8)=-0.268D 0*(X(2)/X(8))**0.67D 0/X(8)
      RETURN
  290 GC(1)=0.0D 0
      GC(2)=0.0D 0
      GC(3)=0.0D 0
      GC(4)=0.0D 0
      GC(5)=0.0D 0
      GC(6)=0.0D 0
      GC(7)=0.0D 0
      GC(8)=0.0D 0
      GO TO (291,292,293,294,295,296),KC
  291 GC(4)=0.0025D 0
      GC(6)=0.0025D 0
      RETURN
  292 GC(4)=-0.0025D 0
      GC(5)= 0.0025D 0
      GC(7)= 0.0025D 0
      RETURN
  293 GC(5)=-0.01D 0
      GC(8)= 0.01D 0
      RETURN
  294 GC(1)=X(6)-100.0D 0
      GC(4)=-833.33252D 0
      GC(6)=X(1)
      RETURN
  295 GC(2)=X(7)-X(4)
      GC(4)=-X(2)+1250.0D 0
      GC(5)=-1250.0D 0
      GC(7)=X(2)
      RETURN
  296 GC(3)=X(8)-X(5)
      GC(5)=-X(3)+2500.0D 0
      GC(8)=X(3)
      RETURN
  300 GC(1)=0.0D 0
      GC(2)=0.0D 0
      GC(3)=0.0D 0
      GC(4)=0.0D 0
      GC(5)=0.0D 0
      GC(6)=0.0D 0
      GC(7)=0.0D 0
      GC(8)=0.0D 0
      GC(9)=0.0D 0
      GO TO (301,302,303,304,305,306,307,308,309,910,911,912,913),KC
  301 GC(3)=2.0D 0*X(3)
      GC(4)=2.0D 0*X(4)
      RETURN
  302 GC(5)=2.0D 0*X(5)
      GC(6)=2.0D 0*X(6)
      RETURN
  303 GC(1)= 2.0D 0*(X(1)-X(5))
      GC(2)= 2.0D 0*(X(2)-X(6))
      GC(5)=-2.0D 0*(X(1)-X(5))
      GC(6)=-2.0D 0*(X(2)-X(6))
      RETURN
  304 GC(1)= 2.0D 0*(X(1)-X(7))
      GC(2)= 2.0D 0*(X(2)-X(8))
      GC(7)=-2.0D 0*(X(1)-X(7))
      GC(8)=-2.0D 0*(X(2)-X(8))
      RETURN
  305 GC(3)= 2.0D 0*(X(3)-X(5))
      GC(4)= 2.0D 0*(X(4)-X(6))
      GC(5)=-2.0D 0*(X(3)-X(5))
      GC(6)=-2.0D 0*(X(4)-X(6))
      RETURN
  306 GC(3)= 2.0D 0*(X(3)-X(7))
      GC(4)= 2.0D 0*(X(4)-X(8))
      GC(7)=-2.0D 0*(X(3)-X(7))
      GC(8)=-2.0D 0*(X(4)-X(8))
      RETURN
  307 GC(7)= 2.0D 0*X(7)
      GC(8)= 2.0D 0*(X(8)-X(9))
      GC(9)=-2.0D 0*(X(8)-X(9))
      RETURN
  308 GC(1)= 2.0D 0*X(1)
      GC(2)= 2.0D 0*(X(2)-X(9))
      GC(9)=-2.0D 0*(X(2)-X(9))
      RETURN
  309 GC(9)=2.0D 0*X(9)
      RETURN
  910 GC(3)=X(9)
      GC(9)=X(3)
      RETURN
  911 GC(5)= X(8)
      GC(6)=-X(7)
      GC(7)=-X(6)
      GC(8)= X(5)
      RETURN
  912 GC(1)= X(4)
      GC(2)=-X(3)
      GC(3)=-X(2)
      GC(4)= X(1)
      RETURN
  913 GC(5)=X(9)
      GC(9)=X(5)
      RETURN
  310 GC(1)=0.0D 0
      GC(2)=0.0D 0
      GC(3)=0.0D 0
      GC(4)=0.0D 0
      GC(5)=0.0D 0
      GC(6)=0.0D 0
      GC(7)=0.0D 0
      GC(8)=0.0D 0
      GC(9)=0.0D 0
      GC(10)=0.0D 0
      GO TO (311,312,313,314,315,316,317,318),KC
  311 GC(1)=6.0D 0*(X(1)-2.0D 0)
      GC(2)=8.0D 0*(X(2)-3.0D 0)
      GC(3)=4.0D 0*X(3)
      GC(4)=-7.0D 0
      RETURN
  312 GC(1)=1.0D 1*X(1)
      GC(2)=8.0D 0
      GC(3)=2.0D 0*(X(3)-6.0D 0)
      GC(4)=-2.0D 0
      RETURN
  313 GC(1)=1.0D 0*(X(1)-8.0D 0)
      GC(2)=4.0D 0*(X(2)-4.0D 0)
      GC(5)=6.0D 0*X(5)
      GC(6)=-1.0D 0
      RETURN
  314 GC(1)=2.0D 0*X(1)-2.0D 0*X(2)
      GC(2)=4.0D 0*(X(2)-2.0D 0)-2.0D 0*X(1)
      GC(5)=1.4D 1
      GC(6)=-6.0D 0
      RETURN
  315 GC(1)=4.0D 0
      GC(2)=5.0D 0
      GC(7)=-3.0D 0
      GC(8)=9.0D 0
      RETURN
  316 GC(1)=1.0D 1
      GC(2)=-8.0D 0
      GC(7)=-1.7D 1
      GC(8)=2.0D 0
      RETURN
  317 GC(1)=-3.0D 0
      GC(2)=6.0D 0
      GC(9)=2.4D 1*(X(9)-8.0D 0)
      GC(10)=-7.0D 0
      RETURN
  318 GC(1)=-8.0D 0
      GC(2)=2.0D 0
      GC(9)=5.0D 0
      GC(10)=-2.0D 0
      RETURN
  320 K=(KC-1)*5
      DO 321 J=1,5
      GC(J+10)=2.0D 0*Y(K+J+60)
  321 CONTINUE
      GC(KC+10)=GC(KC+10)+6.0D 0*Y(KC+85)*X(KC+10)
      K=(KC-1)*10
      DO 322 I=1,10
      GC(I)=-Y(K+I)
  322 CONTINUE
      RETURN
  330 DO 331 I=1,16
      GC(I)=0.0D 0
  331 CONTINUE
      IF (KC.LT.6) THEN
      K=11+3*(KC-1)
      GC(KC)=Y(K+1)+(Y(K)+2.0D 0*X(KC)*Y(K+2))/X(KC+5)
      GC(KC+5)=-(Y(K)+Y(K+2)*X(KC))*X(KC)/X(KC+5)**2
      RETURN
      ELSE IF (KC.LT.14) THEN
      GO TO (332,333,334,335,336,337,338,339),KC-5
  332 GC(1)=Y(27)*X(12)/(X(7)*X(11))
      GC(6)=(Y(26)+Y(28)*X(12)/X(11))/X(7)
      GC(7)=-(Y(26)*X(6)+(Y(27)*X(1)+Y(28)*X(6))*X(12)/X(11))/X(7)**2
      GC(11)=-((Y(27)*X(1)+Y(28)*X(6))*X(12)/X(7))/X(11)**2
      GC(12)=(Y(27)*X(1)+Y(28)*X(6))/(X(7)*X(11))
      RETURN
  333 GC(1)=Y(33)*X(12)/X(8)
      GC(2)=Y(31)*X(13)/X(8)
      GC(7)=(Y(29)+Y(30)*X(12))/X(8)
      GC(8)=-(Y(29)*X(7)+(Y(30)*X(7)+Y(33)*X(1))*X(12)+
     * Y(31)*X(2)*X(13))/X(8)**2
      GC(12)=(Y(30)*X(7)+Y(33)*X(1))/X(8)
      GC(13)=Y(32)+Y(31)*X(2)/X(8)
      RETURN
  334 GC(2)=Y(38)*X(13)
      GC(3)=Y(36)*X(14)
      GC(8)=Y(35)*X(13)+Y(34)
      GC(9)=Y(39)*X(14)+Y(37)
      GC(13)=Y(35)*X(8)+Y(38)*X(2)
      GC(14)=Y(36)*X(3)+Y(39)*X(9)
      RETURN
  335 GC(3)=-((Y(40)+Y(43)/X(14))*X(9)+((Y(41)*X(4)+Y(44)*X(8))*X(15)+
     * Y(42)*X(10))/X(14))/X(3)**2
      GC(4)=Y(41)*X(15)/(X(3)*X(14))
      GC(8)=Y(44)*X(15)/(X(3)*X(14))
      GC(9)=(Y(40)+Y(43)/X(14))/X(3)
      GC(10)=Y(42)/(X(3)*X(14))
      GC(14)=-((Y(41)*X(4)+Y(44)*X(8))*X(15)+Y(42)*X(10)+
     * Y(43)*X(9))/(X(3)*X(14)**2)
      GC(15)=(Y(41)*X(4)+Y(44)*X(8))/(X(3)*X(14))
      RETURN
  336 GC(4)=-((Y(45)*X(5)*X(16)+Y(49)*X(10))/X(15)+Y(46)*X(10))/X(4)**2
      GC(5)=Y(45)*X(16)/(X(4)*X(15))
      GC(10)=(Y(46)+Y(49)/X(15))/X(4)
      GC(15)=-((Y(45)*X(5)*X(16)+Y(49)*X(10))/X(4)+Y(47)+
     * Y(48)*X(16))/X(15)**2
      GC(16)=(Y(45)*X(5)/X(4)+Y(48))/X(15)
      RETURN
  337 GC(4)=-(Y(50)+Y(52)*X(5)*X(16))/X(4)**2
      GC(5)=Y(52)*X(16)/X(4)
      GC(16)=Y(51)+Y(52)*X(5)/X(4)
      RETURN
  338 GC(11)=Y(53)
      GC(12)=Y(54)
      RETURN
  339 GC(11)=-Y(55)*X(12)/X(11)**2
      GC(12)=Y(55)/X(11)
      RETURN
      ELSE IF (KC.LT.18) THEN
      I=KC-13
      K=5-I
      GC(K)=Y(I+55)/X(K+1)
      GC(K+1)=-Y(I+55)*X(K)/X(K+1)**2
      RETURN
      ELSE IF (KC.EQ.18) THEN
      GC(9)=Y(60)/X(10)
      GC(10)=-Y(60)*X(9)/X(10)**2
      RETURN
      ELSE
      GC(8)=Y(61)/X(9)
      GC(9)=-Y(61)*X(8)/X(9)**2
      RETURN
      ENDIF
  340 GC(1)=0.0D 0
      GC(2)=0.0D 0
      GC(3)=0.0D 0
      GC(4)=0.0D 0
      GC(5)=0.0D 0
      GC(6)=0.0D 0
      GC(7)=0.0D 0
      GC(8)=0.0D 0
      GC(9)=0.0D 0
      GC(10)=0.0D 0
      GC(11)=0.0D 0
      GC(12)=0.0D 0
      GC(13)=0.0D 0
      GC(14)=0.0D 0
      GC(15)=0.0D 0
      GC(16)=0.0D 0
      GC(17)=0.0D 0
      GC(18)=0.0D 0
      GC(19)=0.0D 0
      GC(20)=0.0D 0
      GO TO (311,312,313,314,315,316,317,318,341,342,343,344,345,346,
     * 347,348,349),KC
  341 GC(1)=1.0D 0
      GC(2)=1.0D 0
      GC(11)=4.0D 0
      GC(12)=-2.1D 1
      RETURN
  342 GC(1)=2.0D 0*X(1)
      GC(11)=1.5D 1
      GC(12)=-8.0D 0
      RETURN
  343 GC(1)=4.0D 0
      GC(2)=9.0D 0
      GC(13)=1.0D 1*X(13)
      GC(14)=-9.0D 0
      RETURN
  344 GC(1)=3.0D 0
      GC(2)=4.0D 0
      GC(13)=6.0D 0*(X(13)-6.0D 0)
      GC(14)=-1.4D 1
      RETURN
  345 GC(1)=2.8D 1*X(1)
      GC(15)=3.5D 1
      GC(16)=-7.9D 1
      RETURN
  346 GC(2)=3.0D 1*X(2)
      GC(15)=1.1D 1
      GC(16)=-6.1D 1
      RETURN
  347 GC(1)=1.0D 1*X(1)
      GC(2)=2.0D 0
      GC(17)=3.6D 1*X(17)**3
      GC(18)=-1.0D 0
      RETURN
  348 GC(1)=2.0D 0*X(1)
      GC(2)=-1.0D 0
      GC(19)=1.9D 1
      GC(20)=-2.0D 1
      RETURN
  349 GC(1)=1.4D 1*X(1)
      GC(2)=1.0D 1*X(2)
      GC(19)=2.0D 0*X(19)
      GC(20)=-3.0D 1
      RETURN
      END
