* SUBROUTINE EFFU20                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION - LU VERSION WITH MODIFIED TESTS NO 7-10,12.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU20(N,X,F,NEXT)
      INTEGER N,NEXT
      REAL*8 X(N),F
      REAL*8 A,B,C,D,P,Q,R,U,V
      INTEGER I,J,K
      F=0.0D 0
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,110,120,160,170,
     & 160,20), NEXT
   10 DO 11 J=2,N
        A=X(J-1)**2-X(J)
        B=X(J-1)-1.0D 0
        F=F+1.0D 2*A**2+B**2
   11 CONTINUE
      RETURN
   20 DO 21 J=2,N-2,2
        A=X(J-1)**2-X(J)
        B=X(J-1)-1.0D 0
        C=X(J+1)**2-X(J+2)
        D=X(J+1)-1.0D 0
        U=X(J)+X(J+2)-2.0D 0
        V=X(J)-X(J+2)
        F=F+1.0D 2*A**2+B**2+9.0D 1*C**2+D**2+
     &    1.0D 1*U**2+0.1D 0*V**2
   21 CONTINUE
      RETURN
   30 DO 31 J=2,N-2,2
        A=X(J-1)+1.0D 1*X(J)
        B=X(J+1)-X(J+2)
        C=X(J)-2.0D 0*X(J+1)
        D=X(J-1)-X(J+2)
        F=F+A**2+5.0D 0*B**2+C**4+1.0D 1*D**4
   31 CONTINUE
      RETURN
   40 DO 41 J=2,N-2,2
        A=EXP(X(J-1))
        B=A-X(J)
        D=X(J)-X(J+1)
        P=X(J+1)-X(J+2)
        Q=SIN(P)/COS(P)
        U=X(J-1)
        V=X(J+2)-1.0D 0
        F=F+B**4+1.0D 2*D**6+Q**4+U**8+V**2
   41 CONTINUE
      RETURN
   50 P=7.0D 0/3.0D 0
      DO 51 J=1,N
        A=(3.0D 0-2.0D 0*X(J))*X(J)+1.0D 0
        IF (J.GT.1) A=A-X(J-1)
        IF (J.LT.N) A=A-X(J+1)
        F=F+ABS(A)**P
   51 CONTINUE
      RETURN
   60 P=7.0D 0/3.0D 0
      DO 62 J=1,N
        A=(2.0D 0+5.0D 0*X(J)**2)*X(J)+1.0D 0
        DO 61 I=MAX(1,J-5),MIN(N,J+1)
          A=A+X(I)*(1.0D 0+X(I))
   61   CONTINUE
        F=F+ABS(A)**P
   62 CONTINUE
      RETURN
   70 DO 72 J=1,N
        A=DBLE(J)*(1.0D 0-COS(X(J)))
        IF(J.GT.1) A=A+DBLE(J)*SIN(X(J-1))
        IF(J.LT.N) A=A-DBLE(J)*SIN(X(J+1))
        F=F+A
   72 CONTINUE
      RETURN
   80 P=-0.2008D-2
      Q=-0.1900D-2
      R=-0.0261D-2
      DO 82 I=0,N-5,5
      A=1.0D 0
      B=0.0D 0
      DO 81 J=1,5
      A=A*X(I+J)
      B=B+X(I+J)**2
   81 CONTINUE
      A=EXP(A)
      B=B-1.0D 1-P
      C=X(I+2)*X(I+3)-5.0D 0*X(I+4)*X(I+5)-Q
      D=X(I+1)**3+X(I+2)**3+1.0D 0-R
      F=F+A+1.0D 1*(B**2+C**2+D**2)
   82 CONTINUE
      RETURN
   90 C=0.0D 0
      DO 91 J=2,N,2
      A=X(J-1)-3.0D 0
      B=X(J-1)-X(J)
      F=F+1.0D-4*A**2-B+EXP(2.0D 1*B)
   91 CONTINUE
      RETURN
  100 DO 101 J=2,N,2
      A=X(J)**2
      B=X(J-1)**2
      C=A+1.0D 0
      D=B+1.0D 0
      F=F+B**C+A**D
  101 CONTINUE
      RETURN
  110 K=(N-2)/3
      DO 111 I=1,K
      J=(I-1)*3
      F=F+(X(J+1)-X(J+2))**2+(X(J+3)-1.0D 0)**2+(X(J+4)-1.0D 0)**4+
     &    (X(J+5)-1.0D 0)**6
  111 CONTINUE
      RETURN
  120 K=(N-1)/4
      DO 121 I=1,K
      J=(I-1)*4
      F=F+(X(J+1)-X(J+2))**2+(X(J+2)-X(J+3))**2+(X(J+3)-X(J+4))**4+
     &    (X(J+4)-X(J+5))**4
  121 CONTINUE
      RETURN
  130 K=(N-2)/3
      DO 131 I=1,K
      J=(I-1)*3
      F=F+(X(J+1)-1.0D 0)**2+(X(J+2)-X(J+3))**2+(X(J+4)-X(J+5))**4
  131 CONTINUE
      RETURN
  160 K=(N-1)/4
      DO 161 I=1,K
      J=(I-1)*4
      F=F+(X(J+1)-X(J+2))**4+(X(J+2)+X(J+3)-2.0D 0)**2+
     &    (X(J+4)-1.0D 0)**2+(X(J+5)-1.0D 0)**2
  161 CONTINUE
      RETURN
  170 K=(N-1)/4
      DO 171 I=1,K
      J=(I-1)*4
      F=F+(4.0D 0*X(J+1)-X(J+2))**2+(X(J+2)+X(J+3)-2.0D 0)**4+
     &    (X(J+4)-1.0D 0)**2+(X(J+5)-1.0D 0)**2
  171 CONTINUE
      RETURN
      END
