* SUBROUTINE EFGU99                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF MODEL FUNCTIONS FOR COMPLEMENTARITY PROBLEMS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RI  G(N)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFGU99(N,X,G,NEXT)
      INTEGER N,NEXT
      REAL*8 X(N),G(N)
      REAL*8 WC,WB,WG,WBB,WGG,WW,WTEMPR,WPI
      GOTO (10,20,30,40,50,60,70,80,40,50,60,70,80,40,50,60,70,80,40,50,
     &60,70,80,240,250,250,270,270,290), NEXT
   10 G(1)=2.0D 0*X(1)-2.0D 0
      G(2)=2.0D 0*X(2)-2.0D 0
      G(5)=2.0D 0*X(5)
      G(6)=2.0D 0*X(6)
      RETURN
   20 WTEMPR=2.0D 0*(X(1)-X(2)-1.0D 0)
      G(1)= WTEMPR
      G(2)=-WTEMPR
      RETURN
   30 G(2)=2.0D 0*(X(2)-3.5D 0)
      G(3)=2.0D 0*(X(3)+4.0D 0)
      RETURN
   40 WG=1.0D 0
   41 WC=1.0D 1
      WB=1.2D 0
      WBB=1.0D 0/WB
      WGG=1.0D 0/WG
      WW=X(1)*WGG*5.0D 3**WGG*(X(1)+X(2)+X(3)+X(4)+X(5))**(-WGG-1)
      G(1)=WC+(X(1)/5.0D 0)**WBB+WW-
     & (5.0D 3/(X(1)+X(2)+X(3)+X(4)+X(5)))**WGG
      G(2)=WW
      G(3)=WW
      G(4)=WW
      G(5)=WW
      RETURN
   50 WG=1.1D 0
      GOTO 41
   60 WG=1.3D 0
      GOTO 41
   70 WG=1.5D 0
      GOTO 41
   80 WG=1.7D 0
      GOTO 41
  240 WPI=3.141592654D 0
      G(3)=-2.0D 0*WPI*X(3)
      RETURN
  250 WPI=3.141592654D 0
      G(3)=-WPI*X(4)
      G(4)=-WPI*X(3)
      RETURN
  270 WPI=3.141592654D 0
      WTEMPR=0.0D 0
      IF (X(3)*X(6)-X(4)*X(5).GT.0.0D 0) THEN
        WTEMPR=-WPI
      ELSEIF (X(3)*X(6)-X(4)*X(5).LT.0.0D 0) THEN
        WTEMPR=WPI
      ENDIF
      G(3)=WTEMPR*X(6)
      G(4)=-WTEMPR*X(5)
      G(5)=-WTEMPR*X(4)
      G(6)=WTEMPR*X(3)
      RETURN
  290 G(1)=X(4)-X(2)
      G(2)=X(3)-X(1)
      G(3)=X(2)-X(4)
      G(4)=X(1)-X(3)
      RETURN
      END
