* SUBROUTINE EFHT10                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  THREE DIAGONALS OF HESSIAN MATRICES OF TEST FUNCTIONS FOR UNCONSTRAINED
*   MINIMIZATION. SPARSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  M  NUMBER OF ELEMENTS OF THE SPARSE MATRIX.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  H(M)  NUMERICAL VALUES OF THE SPARSE HESSIAN MATRIX STORED IN
*            THE PACKED ROW FORM.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EFHT10(N,X,D,DU,NEXT)
      INTEGER N,NEXT
      REAL*8 X(N),D(N),DU(N)
      REAL*8 A,B,C,E,P,Q,R
      INTEGER I,J
      DO 1 I=1,N
        D(I)=0.0D0
        DU(I)=0.0D0
    1 CONTINUE
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150),NEXT
   10 DO 11 I=2,N
        D(I-1)=D(I-1)+1.2D3*X(I-1)**2-4D2*X(I)+2D0
        DU(I-1)=DU(I-1)-4D2*X(I-1)
        D(I)=D(I)+2D2
   11 CONTINUE
      RETURN
   20 DO 21 I=1,N-3,2
        D(I)=D(I)-4D2*X(I+1)+1.2D3*X(I)**2+2D0
        DU(I)=DU(I)-4D2*X(I)
        D(I+1)=D(I+1)+2.202D2
        D(I+2)=D(I+2)+1.08D3*X(I+2)**2-3.6D2*X(I+3)+2D0
        DU(I+2)=DU(I+2)-3.6D2*X(I+2)
        D(I+3)=D(I+3)+2.002D2
   21 CONTINUE
      RETURN
   30 DO 31 I=1,N-3,2
        A=1.2D2*(X(I)-X(I+3))**2
        B=1.2D1*(X(I+1)-2D0*X(I+2))**2
        D(I)=D(I)+A+2D0
        DU(I)=DU(I)+2D1
        D(I+1)=D(I+1)+2D2+B
        DU(I+1)=DU(I+1)-2D0*B
        D(I+2)=D(I+2)+1D1+4D0*B
        DU(I+2)=DU(I+2)-1D1
        D(I+3)=D(I+3)+1D1+A
   31 CONTINUE
      RETURN
   40 DO 41 I=1,N-3,2
        A=(EXP(X(I))-X(I+1))**2
        B=3D3*(X(I+1)-X(I+2))**4
        C=(X(I+2)-X(I+3))
        E=4D0*(3D0+2D0*SIN(C)**2)*SIN(C)**2/COS(C)**6
        D(I)=D(I)+4D0*EXP(X(I))*A*(4D0*EXP(X(I))-
     *       X(I+1))+5.6D1*X(I)**6
        DU(I)=DU(I)-1.2D1*EXP(X(I))*A
        D(I+1)=D(I+1)+1.2D1*A+B
        DU(I+1)=DU(I+1)-B
        D(I+2)=D(I+2)+B+E
        DU(I+2)=DU(I+2)-E
        D(I+3)=D(I+3)+E+2D0
   41 CONTINUE
      RETURN
   50 P=7D0/3D0
      DO 51 I=1,N
        A=(3D0-2D0*X(I))*X(I)+1D0
        IF (I.GT.1) A=A-X(I-1)
        IF (I.LT.N) A=A-X(I+1)
        B=P*(P-1D0)*ABS(A)**(P-2D0)
        C=(3D0-4D0*X(I))
        IF (I.GT.1) THEN
          D(I-1)=D(I-1)+B
          DU(I-1)=DU(I-1)-B*C
        ENDIF
        IF(I.NE.N) THEN
          D(I)=D(I)+B*C**2-4D0*SIGN(1D0,A)*P*ABS(A)**(P-1D0)
        ELSE
          D(N)=D(N)+B*C**2-4D0*SIGN(1D0,A)*P*ABS(A)**(P-1D0)
        END IF
        IF (I.LT.N) THEN
          DU(I)=DU(I)-B*C
          IF(I+1.NE.N) THEN
            D(I+1)=D(I+1)+B
          ELSE
            D(N)=D(N)+B
          ENDIF
        ENDIF
   51 CONTINUE
      RETURN
   60 P=7D0/3D0
      DO 61 I=1,N
        A=0D0
        DO 62 J=MAX(1,I-5),MIN(N,I+1)
          A=A+X(J)*(1D0+X(J))
   62   CONTINUE
        A=A+1D0+X(I)*(2D0+5D0*X(I)**2)
        B=SIGN(1D0,A)*P*ABS(A)**(P-1D0)
        C=P*(P-1D0)*ABS(A)**(P-2D0)
        E=(1.5D1*X(I)**2+2D0*X(I)+3D0)
        D(I)=D(I)+C*E**2+B*(3D1*X(I)+2D0)
        DO 63 J=I,MIN(N,I+1)
          IF (I.LT.J) DU(I)=DU(I)+C*E*(1D0+2D0*X(J))
          IF (J.NE.I) THEN
            D(J)=D(J)+C*(1D0+2D0*X(J))**2+2D0*B
          ENDIF
   63   CONTINUE
   61 CONTINUE
      RETURN
   70 P=7D0/3D0
      DO 71 I=1,N
        A=(3D0-2D0*X(I))*X(I)+1D0
        IF (I.GT.1) A=A-X(I-1)
        IF (I.LT.N) A=A-X(I+1)
        B=P*(P-1D0)*ABS(A)**(P-2D0)
        C=(3D0-4D0*X(I))
        IF (I.GT.1) THEN
          D(I-1)=D(I-1)+B
          DU(I-1)=DU(I-1)-B*C
        ENDIF
        IF(I.NE.N) THEN
          D(I)=D(I)+B*C**2-4D0*SIGN(1D0,A)*P*ABS(A)**(P-1D0)
        ELSE
          D(N)=D(N)+B*C**2-4D0*SIGN(1D0,A)*P*ABS(A)**(P-1D0)
        END IF
        IF (I.LT.N) THEN
          DU(I)=DU(I)-B*C
          IF(I+1.NE.N) THEN
            D(I+1)=D(I+1)+B
          ELSE
            D(N)=D(N)+B
          ENDIF
        ENDIF
   71 CONTINUE
      RETURN
   80 DO 82 J=1,N
      DO 81 I=1,N
        A=5D0*(1D0+MOD(I,5)+MOD(J,5))
        B=DBLE(I+J)/1D1
        D(J)=D(J)+2.0D0*COS(2.0D0*X(J))*
     *     (A**2-B**2)-4.0D0*SIN(2.0D0*X(J))*A*B
   81 CONTINUE
   82 CONTINUE
      RETURN
   90 DO 91 I=1,N
      D(I)=D(I)+DBLE(I)*COS(X(I))
   91 CONTINUE
      D(1)=D(1)-SIN(X(1))
      D(N)=D(N)+SIN(X(N))
      RETURN
  100 DO 101 I=1,N
      D(I)=D(I)+2.0D3*DBLE(I)**2*(1.0D0-2.0D0*X(I))/
     *    (1.0D0+X(I))**4
  101 CONTINUE
      RETURN
  110 DO 111 I=1,N-4,5
        Q=X(I)*X(I+1)*X(I+2)*X(I+3)*X(I+4)
        A=EXP(Q)
        B=X(I)**2+X(I+1)**2+X(I+2)**2+X(I+3)**2+X(I+4)**2
     *     -1D1+2.008D-3
        C=X(I+1)*X(I+2)-5D0*X(I+3)*X(I+4)+1.9D-3
        E=X(I)**3+X(I+1)**3+1D0+2.61D-4
        DO 112 J=I,I+4
          D(J)=D(J)+A*(Q/X(J))**2+1D1*(8D0*X(J)**2+4D0*B)
          DU(J)=DU(J)+A*Q*(1D0+Q)/(X(J)*X(J+1))
  112   CONTINUE
        D(I)=D(I)+1.8D2*X(I)**4+1.2D2*X(I)*E
        DU(I)=DU(I)+1.8D2*(X(I)*X(I+1))**2
        DU(I)=DU(I)+8D1*X(I)*X(J)
        D(I+1)=D(I+1)+2D1*X(I+2)**2+1.8D2*X(I+1)**4+
     *         1.2D2*E*X(I+1)
        DU(I+1)=DU(I+1)+8D1*X(I+1)*X(I+2)+2D1*X(I+1)*X(I+2)+
     *         2D1*C
        D(I+2)=D(I+2)+2D1*X(I+1)**2
        DU(I+2)=DU(I+2)+8D1*X(I+2)*X(I+3)-1D2*X(I+1)*X(I+4)
        D(I+3)=D(I+3)+5D2*X(I+4)**2
        DU(I+3)=DU(I+3)+8D1*X(I+3)*X(I+4) +5D2*X(I+3)*X(I+4)-
     *          1D2*C
        D(I+4)=D(I+4)+5D2*X(I+3)**2
  111 CONTINUE
      RETURN
  120 DO 121 I=1,N-1,2
      A=2D1*(X(I)-X(I+1))
      B=4D2*EXP(A)
      D(I)=D(I)+2D-3+B
      DU(I)=DU(I)-B
      D(I+1)=D(I+1)+B
  121 CONTINUE
      RETURN
  130 DO 131 I=1,N-1,2
        A=X(I)**2
        B=X(I+1)**2
        C=0D0
        IF (A.GT.C) C=LOG(A)
        E=0D0
        IF (B.GT.E) E=LOG(B)
        D(I)=D(I)+2D0*(B+1D0)*(2D0*B+1D0)*A**B+
     *       2D0*E*(2D0*A*E+1D0)*B**(A+1D0)
        DU(I)=DU(I)+4D0*X(I)*X(I+1)+((1D0+(B+1D0)*C)*A**B+
     *       (1D0+(A+1D0)*E)*B**A)
        D(I+1)=D(I+1)+2D0*(A+1D0)*(2D0*A+1D0)*B**A+
     *         2D0*C*(2D0*B*C+1D0)*A**(B+1D0)
  131 CONTINUE
      RETURN
  140 Q=1D0/(N+1D0)
      DO 141 I=1,N
        B=(X(I)+I*Q+1D0)
        C=3D0*Q**2*B**2+4D0
        A=2D0*X(I)+Q**2*(X(I)+I*Q+1)**3/2D0
        IF (I.GT.1) A=A-X(I-1)
        IF (I.LT.N) A=A-X(I+1)
        IF (I.GT.1) THEN
          D(I-1)=D(I-1)+2D0
          DU(I-1)=DU(I-1)-C
        ENDIF
        IF (I.LT.N) THEN
          D(I)=D(I)+ C**2/2D0 + 6D0*A*B*Q**2
          DU(I)=DU(I)-C
          IF (I.LT.N-1) THEN
            D(I+1)=D(I+1)+2D0
          ELSE
            D(N)=D(N)+2D0
          ENDIF
        ELSE
          D(N)=D(N)+C**2/2D0+6D0*A*B*Q**2
        ENDIF
  141 CONTINUE
      RETURN
  150 Q= 2.0D0*DBLE(N+1)
      R=-6.8D0/DBLE(N+1)
      DO 151 I=1,N-1
        A=X(I+1)-X(I)
        B=EXP(X(I))
        C=EXP(X(I+1))
        D(I)=D(I)+2D0*Q
        DU(I)=DU(I)-Q
        IF (ABS(A).LE.1D-6) THEN
        D(I)=D(I)+R*B*(1D0/3D0+A/12D0)
        DU(I)=DU(I)+R*B*(1D0/6D0+A/12D0)
        D(I+1)=D(I+1)+R*B*(1D0/3D0+A/4D0)
        ELSE
        D(I)=D(I)+(2D0*((C-B)/A-B)/A-B)*R/A
        DU(I)=DU(I)+B*R*(1D0+2D0/A)/A**2+
     *        C*R*(1D0-2D0/A)/A**2
        D(I+1)=D(I+1)+(2D0*((C-B)/A-C)/A+C)*R/A
        ENDIF
  151 CONTINUE
      D(1)=D(1)+((2D0/X(1)-2D0)/X(1)+1D0)*R*EXP(X(1))/X(1)-
     *     2D0*R/X(1)**3
      D(N)=D(N)+2D0*Q+
     *     ((2D0/X(N)-2D0)/X(N)+1D0)*R*EXP(X(N))/X(N)-
     *     2D0*R/X(N)**3
      RETURN
      END
