* SUBROUTINE EIND08             ALL SYSTEMS                 90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR NONLINEAR PROGRAMMING.
*  DENSE VERSION.
*
* PARAMETERS :
*  IO  N  NUMBER OF VARIABLES.
*  IO  NC  NUMBER OF CONSTRAINTS.
*  IO  NCL NUMBER OF LINEAR CONSTRAINTS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  IO  IC(NC)  TYPES OF CONSTRAINTS.
*  RO  CL(NC)  LOWER BOUNDS OF CONSTRAINTS.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  IO  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIND08(N,NC,NCL,X,IC,CL,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER I,N,NC,NCL,IC(NC),NEXT,IEXT,IERR
      REAL*8 X(N),CL(NC),FMIN,XMAX
      REAL*8 Y(20)
      COMMON /EMPR08/ Y
      NCL=0
      FMIN=-1.0D 60
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      DO 1 I=1,NC
      IC(I)=5
      CL(I)=0.0D 0
    1 CONTINUE
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,
     * 180,190,200,210,220,230,240,250,260,270,270,290,300,310) NEXT
   10 IF(N.GE.2.AND.NC.GE.1) THEN
      N=2
      NC=1
      X(1)=-1.0D 0
      X(2)= 1.0D 0
      CL(1)=2.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   20 IF(N.GE.2.AND.NC.GE.1) THEN
      N=2
      NC=1
      X(1)=0.8D 0
      X(2)=0.6D 0
      CL(1)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   30 IF(N.GE.2.AND.NC.GE.1) THEN
      N=2
      NC=1
      X(1)=-1.20D 0
      X(2)= 1.0D 0
      CL(1)=-12.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   40 IF(N.GE.2.AND.NC.GE.1) THEN
      N=2
      NC=1
      X(1)=-1.2D 0
      X(2)= 1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   50 IF(N.GE.2.AND.NC.GE.1) THEN
      N=2
      NC=1
      X(1)=2.0D 0
      X(2)=2.0D 0
      CL(1)=4.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   60 IF(N.GE.2.AND.NC.GE.2) THEN
      N=2
      NC=2
      X(1)=20.0D 0
      X(2)=20.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   70 IF(N.GE.3.AND.NC.GE.1) THEN
      N=3
      NC=1
      X(1)=-2.6D 0
      X(2)= 2.0D 0
      X(3)= 2.0D 0
      CL(1)=3.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   80 IF(N.GE.3.AND.NC.GE.1) THEN
      N=3
      NC=1
      X(1)=2.0D 0
      X(2)=2.0D 0
      X(3)=2.0D 0
      CL(1)=-1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   90 IF(N.GE.3.AND.NC.GE.1) THEN
      N=3
      NC=1
      X(1)=2.0D 0
      X(2)=2.0D 0
      X(3)=2.0D 0
      CL(1)=4.0D 0+3.0D 0*SQRT(2.0D 0)
      ELSE
      IERR=1
      ENDIF
      RETURN
  100 IF(N.GE.3.AND.NC.GE.2) THEN
      N=3
      NC=2
      X(1)=3.122D 0
      X(2)=1.489D 0
      X(3)=-3.611D 0
      CL(1)=25.0D 0
      CL(2)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  110 IF(N.GE.3.AND.NC.GE.2) THEN
      N=3
      NC=2
      X(1)=0.0D 0
      X(2)=0.0D 0
      X(3)=0.0D 0
      CL(1)=7.0D 0
      CL(2)=11.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  120 IF(N.GE.3.AND.NC.GE.2) THEN
      N=3
      NC=2
      X(1)=2.0D 0
      X(2)=2.0D 0
      X(3)=2.0D 0
      CL(1)=56.0D 0
      CL(2)=25.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  130 IF(N.GE.3.AND.NC.GE.2) THEN
      N=3
      NC=2
      X(1)=1.0D 0
      X(2)=1.0D 0
      X(3)=1.0D 0
      CL(2)=0.01D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  140 IF(N.GE.4.AND.NC.GE.2) THEN
      N=4
      NC=2
      X(1)=2.0D 0
      X(2)=2.0D 0
      X(3)=2.0D 0
      X(4)=2.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  150 IF(N.GE.4.AND.NC.GE.2) THEN
      N=4
      NC=2
      X(1)=1.0D 0
      X(2)=1.0D 0
      X(3)=1.0D 0
      X(4)=1.0D 0
      CL(1)=2.0D 0
      CL(2)=2.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  160 IF(N.GE.4.AND.NC.GE.2) THEN
      N=4
      NC=2
      X(1)=1.0D 0
      X(2)=1.0D 0
      X(3)=1.0D 0
      X(4)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  170 IF(N.GE.5.AND.NC.GE.2) THEN
      N=5
      NC=1
      X(1)=1.0D 0
      X(2)=2.0D 0
      X(3)=3.0D 0
      X(4)=4.0D 0
      X(5)=228.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  180 IF(N.GE.5.AND.NC.GE.2) THEN
      N=5
      NC=2
      X(1)=1.0D 0
      X(2)=1.0D 0
      X(3)=1.0D 0
      X(4)=0.0D 0
      X(5)=0.0D 0
      CL(1)=1.0D 0
      CL(2)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  190 IF(N.GE.5.AND.NC.GE.2) THEN
      N=5
      NC=2
      X(1)=0.5D 0*SQRT(2.0D 0)
      X(2)=1.75D 0
      X(3)=0.5D 0
      X(4)=2.0D 0
      X(5)=2.0D 0
      CL(1)=1.0D 0
      CL(2)=2.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  200 IF(N.GE.5.AND.NC.GE.2) THEN
      N=5
      NC=2
      X(1)=2.0D 0
      X(2)=2.0D 0
      X(3)=2.0D 0
      X(4)=2.0D 0
      X(5)=2.0D 0
      CL(1)=2.0D 0*SQRT(2.0D 0)
      CL(2)=8.0D 0+SQRT(2.0D 0)
      ELSE
      IERR=1
      ENDIF
      RETURN
  210 IF(N.GE.5.AND.NC.GE.3) THEN
      N=5
      NC=3
      X(1)=2.0D 0
      X(2)=2.0D 0
      X(3)=2.0D 0
      X(4)=2.0D 0
      X(5)=2.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  220 IF(N.GE.5.AND.NC.GE.3) THEN
      N=5
      NC=3
      X(1)=-2.0D 1
      X(2)=1.0D 1
      X(3)=1.0D 0
      X(4)=1.0D 0
      X(5)=1.0D 0
      CL(1)=1.0D 0
      CL(3)=0.5D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  230 IF(N.GE.5.AND.NC.GE.3) THEN
      N=5
      NC=3
      X(1)=2.0D 0
      X(2)=2.0D 0
      X(3)=2.0D 0
      X(4)=2.0D 0
      X(5)=2.0D 0
      CL(1)=25.0D 0
      CL(2)=25.0D 0
      CL(3)=2.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  240 IF(N.GE.5.AND.NC.GE.3) THEN
      N=5
      NC=3
      X(1)=2.0D 0
      X(2)=SQRT(2.0D 0)
      X(3)=-1.0D 0
      X(4)=2.0D 0-SQRT(2.0D 0)
      X(5)=0.5D 0
      CL(1)=3.0D 0
      CL(2)=1.0D 0
      CL(3)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  250 IF(N.GE.5.AND.NC.GE.3) THEN
      N=5
      NC=3
      X(1)=-2.0D 0
      X(2)= 1.5D 0
      X(3)= 2.0D 0
      X(4)=-1.0D 0
      X(5)=-1.0D 0
      CL(1)=10.0D 0
      CL(3)=-1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  260 IF(N.GE.5.AND.NC.GE.3) THEN
      N=5
      NC=3
      X(1)=2.0D 0
      X(2)=2.0D 0
      X(3)=2.0D 0
      X(4)=2.0D 0
      X(5)=2.0D 0
      CL(1)= 2.0D 0+3.0D 0*SQRT(2.0D 0)
      CL(2)=-2.0D 0+2.0D 0*SQRT(2.0D 0)
      CL(3)=2.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  270 IF(N.GE.5.AND.NC.GE.3) THEN
      N=5
      NC=3
      X(1)=-2.0D 0
      X(2)=2.0D 0
      X(3)=2.0D 0
      X(4)=-1.0D 0
      X(5)=-1.0D 0
      CL(1)=10.0D 0
      CL(3)=-1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  290 IF(N.GE.6.AND.NC.GE.4) THEN
      N=6
      NC=4
      X(1)=390.0D 0
      X(2)=1000.0D 0
      X(3)=419.5D 0
      X(4)=340.5D 0
      X(5)=198.175D 0
      X(6)=0.5D 0
      CL(1)=-300.0D 0
      CL(4)=-200.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  300 IF(N.GE.7.AND.NC.GE.2) THEN
      N=7
      NC=2
      X(1)=0.5D 0
      X(2)=0.5D 0
      X(3)=0.5D 0
      X(4)=0.5D 0
      X(5)=0.5D 0
      X(6)=0.5D 0
      X(7)=0.5D 0
      CL(1)=1.0D 5
      CL(2)=1.0D 3
      Y(1)=50.0D 0
      Y(2)=50.0D 0
      Y(3)=75.0D 0
      Y(4)=75.0D 0
      Y(5)=75.0D 0
      Y(6)=10.0D 1
      Y(7)=10.0D 1
      Y(8)=25.0D 0
      Y(9)=25.0D 0
      Y(10)=50.0D 0
      Y(11)=50.0D 0
      Y(12)=50.0D 0
      Y(13)=90.0D 0
      Y(14)=90.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  310 IF(N.GE.10.AND.NC.GE.3) THEN
      N=10
      NC=3
      X(1)=-2.3D 0
      X(2)=-2.3D 0
      X(3)=-2.3D 0
      X(4)=-2.3D 0
      X(5)=-2.3D 0
      X(6)=-2.3D 0
      X(7)=-2.3D 0
      X(8)=-2.3D 0
      X(9)=-2.3D 0
      X(10)=-2.3D 0
      CL(1)=2.0D 0
      CL(2)=1.0D 0
      CL(3)=1.0D 0
      Y(1)= -6.089D 0
      Y(2)=-17.164D 0
      Y(3)=-34.054D 0
      Y(4)= -5.914D 0
      Y(5)=-24.721D 0
      Y(6)=-14.986D 0
      Y(7)=-24.100D 0
      Y(8)=-10.708D 0
      Y(9)=-26.662D 0
      Y(10)=-22.179D 0
      XMAX=1.0D 1
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
