* SUBROUTINE EIUB15                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION WITH CHANGED TESTS 7-10, 12.
*  CHANGED FOR THE TESTS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NB  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MB  NUMBER OF ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  RO  X(N)  VECTOR OF VARIABLES.
*  IO  IH(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUB15(N,NB,MB,X,IH,JH,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NB,MB,NEXT,IEXT,IERR
      INTEGER IH(NB+1),JH(*)
      REAL*8 X(N),FMIN,XMAX
      INTEGER I,J,K,L,II,JJ,KK,LL,MM,KA
      REAL*8 Y(20)
      COMMON /EMPR15/ Y
      REAL*8 ETA9
      PARAMETER (ETA9=1.0D 60)
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,260,270),NEXT
   10 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 11 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.2D 0
        ELSE
          X(I)=1.0D 0
        ENDIF
   11 CONTINUE
      DO 12 I=1,N-1
        L=3*(I-1)+1
        JH(L)=I
        JH(L+1)=I+1
        JH(L+2)=I
        K=2*(I-1)+1
        IH(K)=L
        IH(K+1)=L+2
   12 CONTINUE
      IH(K+2)=L+3
      NB=2*(N-1)
      MB=3*(N-1)
      RETURN
   20 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 21 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-2.0D 0
          IF(I.LE.4) X(I)=-3.0D 0
        ELSE
          X(I)=0.0D 0
          IF(I.LE.4) X(I)=-1.0D 0
        ENDIF
   21 CONTINUE
      DO 22 I=2,N-2,2
        L=5*(I-2)+1
        JH(L)=I-1
        JH(L+1)=I
        JH(L+2)=I-1
        JH(L+3)=I+1
        JH(L+4)=I+2
        JH(L+5)=I+1
        JH(L+6)=I
        JH(L+7)=I+2
        JH(L+8)=I
        JH(L+9)=I+2
        K=3*(I-2)+1
        IH(K)=L
        IH(K+1)=L+2
        IH(K+2)=L+3
        IH(K+3)=L+5
        IH(K+4)=L+6
        IH(K+5)=L+8
   22 CONTINUE
      IH(K+6)=L+10
      NB=K+5
      MB=L+9
      RETURN
   30 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 31 I=1,N
        IF(MOD(I,4).EQ.1) THEN
          X(I)=3.0D 0
        ELSEIF(MOD(I,4).EQ.2) THEN
          X(I)=-1.0D 0
        ELSEIF(MOD(I,4).EQ.3) THEN
          X(I)=0.0D 0
        ELSE
          X(I)=1.0D 0
        ENDIF
   31 CONTINUE
      DO 32 I=2,N-2,2
        L=4*(I-2)+1
        JH(L)=I-1
        JH(L+1)=I
        JH(L+2)=I+1
        JH(L+3)=I+2
        JH(L+4)=I
        JH(L+5)=I+1
        JH(L+6)=I-1
        JH(L+7)=I+2
        K=2*(I-2)+1
        IH(K)=L
        IH(K+1)=L+2
        IH(K+2)=L+4
        IH(K+3)=L+6
   32 CONTINUE
      IH(K+4)=L+8
      NB=K+3
      MB=L+7
      RETURN
   40 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 41 I=1,N
        X(I)=2.0D 0
   41 CONTINUE
      X(1)=1.0D 0
      DO 42 I=2,N-2,2
        L=4*(I-2)+1
        JH(L)=I-1
        JH(L+1)=I
        JH(L+2)=I
        JH(L+3)=I+1
        JH(L+4)=I+1
        JH(L+5)=I+2
        JH(L+6)=I-1
        JH(L+7)=I+2
        K=5*(I-2)/2+1
        IH(K)=L
        IH(K+1)=L+2
        IH(K+2)=L+4
        IH(K+3)=L+6
        IH(K+4)=L+7
   42 CONTINUE
      IH(K+5)=L+8
      NB=K+4
      MB=L+7
      XMAX=1.0D 1
      RETURN
   50 IF (N.LT.3) GO TO 999
      DO 51 I=1,N
        X(I)=-1.0D 0
   51 CONTINUE
      JH(1)=1
      JH(2)=2
      IH(1)=1
      DO 52 I=2,N-1
        K=3*(I-2)+3
        JH(K)=I-1
        JH(K+1)=I
        JH(K+2)=I+1
        IH(I)=K
   52 CONTINUE
      JH(K+3)=N-1
      JH(K+4)=N
      IH(N)=K+3
      IH(N+1)=IH(N)+2
      NB=N
      MB=3*N-2
      RETURN
   60 IF (N.LT.6) GO TO 999
      DO 61 I=1,N
        X(I)=-1.0D 0
   61 CONTINUE
      L=1
      DO 62 I=1,5
        IH(I)=L
        DO 63 K=1,I+1
          JH(L)=K
          L=L+1
   63   CONTINUE
   62 CONTINUE
      DO 64 I=6,N-1
      IH(I)=L
        DO 65 K=I-5,I+1
        JH(L)=K
        L=L+1
   65   CONTINUE
   64 CONTINUE
      IH(N)=L
      DO 66 K=N-5,N
        JH(L)=K
        L=L+1
   66 CONTINUE
      IH(N+1)=L
      NB=N
      MB=L-1
      RETURN
   70 IF (N.LT.2) GO TO 999
      DO 71 I=1,N-1
        X(I)=0.5D 0
        K=4*(I-1)+1
        JH(K)=I
        JH(K+1)=I+1
        JH(K+2)=I
        JH(K+3)=I+1
        L=2*(I-1)+1
        IH(L)=K
        IH(L+1)=K+2
   71 CONTINUE
      X(N)=-2.0D 0
      IH(L+2)=IH(L+1)+2
      NB=2*(N-1)
      MB=2*NB
      RETURN
   80 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      DO 81 I=1,N
        X(I)=SIN(DBLE(I))**2
   81 CONTINUE
      MM=5*N
      K=1
      DO 82 KA=1,MM
        I=MOD(KA,N/2)+1
        J=I+N/2
        K=2*(KA-1)+1
        JH(K)=I
        JH(K+1)=J
        IH(KA)=K
   82 CONTINUE
      IH(MM+1)=K+2
      NB=MM
      MB=2*MM
      RETURN
   90 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 91 I=1,N
        X(I)=5.0D 0
   91 CONTINUE
      DO 93 I=2,N-2,2
        L=12*(I-2)+1
        DO 92 J=1,6
          K=(J-1)*4
          JH(L+K)=I-1
          JH(L+K+1)=I
          JH(L+K+2)=I+1
          JH(L+K+3)=I+2
   92   CONTINUE
        K=3*(I-2)+1
        IH(K)=L
        IH(K+1)=L+4
        IH(K+2)=L+8
        IH(K+3)=L+12
        IH(K+4)=L+16
        IH(K+5)=L+20
   93 CONTINUE
      IH(K+6)=L+24
      NB=K+5
      MB=L+23
      RETURN
  100 IF (N.LT.2) GO TO 999
      DO 101 I=1,N
        X(I)=0.2D 0
  101 CONTINUE
      MM=2*N-2
      JH(1)=1
      JH(2)=2
      JH(3)=1
      JH(4)=2
      IH(1)=1
      IH(2)=3
      K=5
      L=3
      DO 102 KA=3,MM,2
        I=(KA+1)/2-1
        JH(K)=I
        JH(K+1)=I+1
        JH(K+2)=I+2
        JH(K+3)=I+1
        JH(K+4)=I+2
        IH(L)=K
        IH(L+1)=K+3
        K=K+5
        L=L+2
  102 CONTINUE
      JH(K)=N-1
      JH(K+1)=N
      IH(L)=K
      IH(L+1)=K+2
      NB=L
      MB=K+1
      RETURN
  110 CONTINUE
      IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 111 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-0.8D 0
        ELSE
          X(I)=-0.8D 0
        ENDIF
  111 CONTINUE
      IH(1)=1
      NB=2*(N-1)
      MB=1
      L=1
      DO 112 K=1,N-1
        JH(MB)=K
        MB=MB+1
        JH(MB)=K+1
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=K
        MB=MB+1
        L=L+1
        IH(L)=MB
  112 CONTINUE
      MB=IH(NB+1)-1
      RETURN
  120 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 121 I=1,N
        X(I)=-1.0D 0
  121 CONTINUE
      IH(1)=1
      KK=(N-5)/3+1
      NB=6*KK
      MB=1
      L=1
      DO 122 K=1,KK
        I=3*(K-1)+1
        JH(MB)=I
        MB=MB+1
        JH(MB)=I+1
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I+2
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I+3
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I+4
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I
        MB=MB+1
        JH(MB)=I+3
        MB=MB+1
        JH(MB)=I+4
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I+1
        MB=MB+1
        JH(MB)=I+2
        MB=MB+1
        JH(MB)=I+3
        MB=MB+1
        L=L+1
        IH(L)=MB
  122 CONTINUE
      MB=IH(NB+1)-1
      RETURN
  130 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 131 I=1,N
        X(I)=-1.0D 0
  131 CONTINUE
      IH(1)=1
      KK=(N-5)/3+1
      NB=7*KK
      MB=1
      L=1
      DO 132 K=1,KK
        I=3*(K-1)+1
        JH(MB)=I
        MB=MB+1
        JH(MB)=I+1
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I+1
        MB=MB+1
        JH(MB)=I+2
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I+2
        MB=MB+1
        JH(MB)=I+3
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I+3
        MB=MB+1
        JH(MB)=I+4
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I
        MB=MB+1
        JH(MB)=I+1
        MB=MB+1
        JH(MB)=I+2
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I+1
        MB=MB+1
        JH(MB)=I+2
        MB=MB+1
        JH(MB)=I+3
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I
        MB=MB+1
        JH(MB)=I+4
        MB=MB+1
        L=L+1
        IH(L)=MB
  132 CONTINUE
      MB=IH(NB+1)-1
      RETURN
  140 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 141 I=1,N
        IF (MOD(I,4).EQ.1) THEN
          X(I)=-0.8D 0
        ELSE IF (MOD(I,4).EQ.2) THEN
          X(I)= 1.2D 0
        ELSE IF (MOD(I,4).EQ.3) THEN
          X(I)=-1.2D 0
        ELSE
          X(I)= 0.8D 0
        ENDIF
  141 CONTINUE
      Y(1)=14.4D 0
      Y(2)=6.8D 0
      Y(3)=4.2D 0
      Y(4)=3.2D 0
      II=4
      JJ=4
      LL=2
      IH(1)=1
  142 IF (MOD(N-II,LL).NE.0) N=N-MOD(N-II,LL)
      KK=(N-II)/LL+1
      NB=JJ*KK
      MB=1
      L=1
      DO 145 K=1,KK
        MM=(K-1)*LL
        DO 144 J=1,JJ
          DO 143 I=1,II
            JH(MB)=MM+I
            MB=MB+1
  143     CONTINUE
          L=L+1
          IH(L)=MB
  144   CONTINUE
  145 CONTINUE
      MB=IH(NB+1)-1
      RETURN
  150 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 151 I=1,N
        IF (MOD(I,4).EQ.1) THEN
          X(I)=-0.8D 0
        ELSE IF (MOD(I,4).EQ.2) THEN
          X(I)= 1.2D 0
        ELSE IF (MOD(I,4).EQ.3) THEN
          X(I)=-1.2D 0
        ELSE
          X(I)= 0.8D 0
        ENDIF
  151 CONTINUE
      Y(1)=35.8D 0
      Y(2)=11.2D 0
      Y(3)=6.2D 0
      Y(4)=4.4D 0
      II=4
      JJ=4
      LL=2
      IH(1)=1
      GO TO 142
  160 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 161 I=1,N
        IF (MOD(I,4).EQ.1) THEN
          X(I)=-0.8D 0
        ELSE IF (MOD(I,4).EQ.2) THEN
          X(I)= 1.2D 0
        ELSE IF (MOD(I,4).EQ.3) THEN
          X(I)=-1.2D 0
        ELSE
          X(I)= 0.8D 0
        ENDIF
  161 CONTINUE
      Y(1)=30.6D 0
      Y(2)=72.2D 0
      Y(3)=124.4D 0
      Y(4)=187.4D 0
      II=4
      JJ=4
      LL=2
      IH(1)=1
      GO TO 142
  170 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      NB=N
      MB=0
      IH(1)=1
      DO 171 I=1,N
        IF (MOD(I,8).EQ.1) X(I)=1.0D-1
        IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0D-1
        IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0D-1
        IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0D-1
        IF (MOD(I,8).EQ.5) X(I)=5.0D-1
        IF (I.GT.2) THEN
          MB=MB+1
          JH(MB)=I-2
        ENDIF
        MB=MB+2
        IF (MOD(I,2).EQ.1) THEN
          JH(MB-1)=I
          JH(MB)=I+1
        ELSE
          JH(MB-1)=I-1
          JH(MB)=I
        ENDIF
        IF (I.LT.N-1) THEN
          MB=MB+1
          JH(MB)=I+2
        ENDIF
        IH(I+1)=MB+1
  171 CONTINUE
      RETURN
  180 IF (N.LT.3) GO TO 999
      NB=N
      MB=0
      IH(1)=1
      DO 181 I=1,N
        X(I)=1.2D 1
        IF(I.GT.1) THEN
          MB=MB+1
          JH(MB)=I-1
        ENDIF
        MB=MB+1
        JH(MB)=I
        IF(I.LT.N) THEN
          MB=MB+1
          JH(MB)=I+1
        ENDIF
        IH(I+1)=MB+1
  181 CONTINUE
      RETURN
  190 IF (N.LT.7) GO TO 999
      NB=N
      MB=0
      IH(1)=1
      DO 191 I=1,N
        X(I)=-1.0D 0
        IF (I.GT.1.AND.I.LT.N-3) THEN
          MB=MB+1
          JH(MB)=I-1
        ENDIF
        IF (I.LT.N-4) THEN
          MB=MB+1
          JH(MB)=I
        ENDIF
        IF (I.LT.N-5) THEN
          MB=MB+1
          JH(MB)=I+1
        ENDIF
        MB=MB+5
        JH(MB-4)=N-4
        JH(MB-3)=N-3
        JH(MB-2)=N-2
        JH(MB-1)=N-1
        JH(MB)=N
        IH(I+1)=MB+1
  191 CONTINUE
      RETURN
  200 IF (N.LT.3) GO TO 999
      NB=N
      MB=0
      IH(1)=1
      DO 201 I=1,N
        X(I)=DBLE(I)/DBLE(N+1)
        X(I)=X(I)*(X(I)-1.0D 0)
        IF(I.GT.1) THEN
          MB=MB+1
          JH(MB)=I-1
        ENDIF
        MB=MB+1
        JH(MB)=I
        IF (I.LT.N) THEN
          MB=MB+1
          JH(MB)=I+1
        ENDIF
        IH(I+1)=MB+1
  201 CONTINUE
      RETURN
  210 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 211 I=1,N
        X(I)=-1.0D 0
  211 CONTINUE
      IH(1)=1
      KK=(N-5)/3+1
      NB=7*KK
      MB=1
      L=1
      DO 212 K=1,KK
        I=3*(K-1)+1
        JH(MB)=I
        MB=MB+1
        JH(MB)=I+1
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I+1
        MB=MB+1
        JH(MB)=I+2
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I+3
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I+4
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I
        MB=MB+1
        JH(MB)=I+1
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I+2
        MB=MB+1
        JH(MB)=I+3
        MB=MB+1
        JH(MB)=I+4
        MB=MB+1
        L=L+1
        IH(L)=MB
        JH(MB)=I+1
        MB=MB+1
        JH(MB)=I+4
        MB=MB+1
        L=L+1
        IH(L)=MB
  212 CONTINUE
      MB=IH(NB+1)-1
      RETURN
  220 IF (N.LT.3) GO TO 999
      DO 221 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.2D 0
        ELSE
          X(I)= 1.0D 0
        ENDIF
  221 CONTINUE
      NB=2*(N-1)
      MB=2
      IH(1)=1
      IH(2)=2
      JH(1)=1
      DO 222 KA=1,NB-1
        I=(KA+1)/2
        IF (MOD(KA,2).EQ.1) THEN
          JH(MB)=I
          MB=MB+1
          JH(MB)=I+1
          MB=MB+1
        ELSE
          JH(MB)=I
          MB=MB+1
          JH(MB)=I+1
          MB=MB+1
          JH(MB)=I+2
          MB=MB+1
        ENDIF
        IH(KA+2)=MB
  222 CONTINUE
      MB=MB-1
      RETURN
  260 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      DO 261 I=1,N
        X(I)=1.0D 0
  261 CONTINUE
      MM=5*N
      K=1
      DO 262 KA=1,MM
        I=MOD(KA,N/2)+1
        J=I+N/2
        K=2*(KA-1)+1
        JH(K)=I
        JH(K+1)=J
        IH(KA)=K
  262 CONTINUE
      IH(MM+1)=K+2
      NB=MM
      MB=2*MM
      RETURN
  270 IF (N.LT.7) GO TO 999
      DO 271 I=1,N
        X(I)=5.0D 0
  271 CONTINUE
      Y(1)=SIN(1.0D 0)
      NB=13*(N-6)
      MB=1
      IH(1)=1
      DO 273 K=1,NB
        II=MIN(MAX(MOD(K,13)-2,1),7)
        JJ=(K+12)/13
        I=II+JJ-1
        IF (II.EQ.7) THEN
          J=JJ
        ELSE
          J=II+JJ
        ENDIF
        DO 272 L=0,6
          JH(MB)=JJ+L
          MB=MB+1
  272   CONTINUE
        IH(K+1)=MB
  273 CONTINUE
      MB=MB-1
      RETURN
  999 IERR=1
      RETURN
      END
