* SUBROUTINE EIUB18             ALL SYSTEMS                 92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR NONLINEAR APPROXIMATION.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  IO  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF ELEMENTS OF THE SPARSE MATRIX.
*  RO  X(N)  VECTOR OF VARIABLES.
*  IO  IA(NA+1)  POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  IO  JA(MA)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUB18(N,NA,MA,X,IA,JA,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NA,MA,NEXT,IEXT,IERR
      INTEGER IA(NA+1),JA(*)
      REAL*8 X(N),FMIN,XMAX,PAR
      INTEGER I,J,K,L,M,I1,I2,J1,J2,N1,ND
      REAL*8 T,S
      COMMON /EMPR18/ PAR,M
      FMIN=0.0D 0
      XMAX=1.0D 4
      IEXT=0
      IERR=0
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,230,240,250,260,270,280,290,300,320,
     & 310,420,430,440,450,470,480,490,500,520,530,540,550),
     & NEXT
   10 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      NA=N
      MA=0
      IA(1)=1
      DO 11 I=1,N
      IF (MOD(I,8).EQ.1) X(I)=1.0D-1
      IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0D-1
      IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0D-1
      IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0D-1
      IF (MOD(I,8).EQ.5) X(I)=5.0D-1
      IF (I.GT.2) THEN
      MA=MA+1
      JA(MA)=I-2
      ENDIF
      MA=MA+2
      IF (MOD(I,2).EQ.1) THEN
      JA(MA-1)=I
      JA(MA)=I+1
      ELSE
      JA(MA-1)=I-1
      JA(MA)=I
      ENDIF
      IF (I.LT.N-1) THEN
      MA=MA+1
      JA(MA)=I+2
      ENDIF
      IA(I+1)=MA+1
   11 CONTINUE
      RETURN
   20 IF (N.LT.5) GO TO 999
      N=N-MOD(N,2)
      NA=N
      MA=0
      IA(1)=1
      DO 21 I=1,N
      IF (MOD(I,8).EQ.1) X(I)=1.0D-1
      IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0D-1
      IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0D-1
      IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0D-1
      IF (MOD(I,8).EQ.5) X(I)=5.0D-1
      MA=MA+1
      JA(MA)=1
      IF (I.GT.3) THEN
      MA=MA+1
      JA(MA)=I-2
      ENDIF
      IF (I.GT.2) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      IF (I.GT.1) THEN
      MA=MA+1
      JA(MA)=I
      ENDIF
      IF (I.EQ.1) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IF (I.LT.N-1) THEN
      MA=MA+1
      JA(MA)=I+2
      ENDIF
      IA(I+1)=MA+1
   21 CONTINUE
      RETURN
   30 IF (N.LT.5) GO TO 999
      N=N-MOD(N,5)
      NA=N
      MA=0
      IA(1)=1
      DO 31 I=1,N
      X(I)=1.0D 0/DBLE(N)
      J=(I-1)/5*5
      MA=MA+5
      JA(MA-4)=J+1
      JA(MA-3)=J+2
      JA(MA-2)=J+3
      JA(MA-1)=J+4
      JA(MA)=J+5
      IA(I+1)=MA+1
   31 CONTINUE
      RETURN
   40 IF (N.LT.3) GO TO 999
      DO 41 I=1,N
      X(I)=0.0D 0
   41 CONTINUE
   42 NA=N
      MA=0
      IA(1)=1
      DO 43 I=1,N
      IF(I.GT.1) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IF(I.LT.N) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IA(I+1)=MA+1
   43 CONTINUE
      RETURN
   50 IF (N.LT.3) GO TO 999
      IF (MOD(N,2).NE.1) N=N-1
      NA=N
      MA=0
      IA(1)=1
      DO 51 I=1,N
      X(I)=1.0D 0
      IF (MOD(I,2).EQ.1) THEN
      IF(I.GT.1) THEN
      MA=MA+2
      JA(MA-1)=I-2
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IF(I.LT.N) THEN
      MA=MA+2
      JA(MA-1)=I+1
      JA(MA)=I+2
      ENDIF
      ELSE
      MA=MA+3
      JA(MA-2)=I-1
      JA(MA-1)=I
      JA(MA)=I+1
      ENDIF
      IA(I+1)=MA+1
   51 CONTINUE
      RETURN
   60 IF (N.LT.3) GO TO 999
      DO 61 I=1,N
      X(I)=-1.0D 0
   61 CONTINUE
      GO TO 42
   70 IF (N.LT.3) GO TO 999
      DO 71 I=1,N
      X(I)=1.2D 1
   71 CONTINUE
      XMAX=1.0D 3
      GO TO 42
   80 IF (N.LT.5) GO TO 999
      NA=N
      MA=0
      IA(1)=1
      DO 81 I=1,N
      X(I)=-2.0D 0
      IF(I.GT.2) THEN
      MA=MA+1
      JA(MA)=I-2
      ENDIF
      IF(I.GT.1) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IF(I.LT.N) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IF(I.LT.N-1) THEN
      MA=MA+1
      JA(MA)=I+2
      ENDIF
      IA(I+1)=MA+1
   81 CONTINUE
      RETURN
   90 IF (N.LT.7) GO TO 999
      NA=N
      MA=0
      IA(1)=1
      DO 91 I=1,N
      X(I)=-3.0D 0
      IF(I.GT.3) THEN
      MA=MA+1
      JA(MA)=I-3
      ENDIF
      IF(I.GT.2) THEN
      MA=MA+1
      JA(MA)=I-2
      ENDIF
      IF(I.GT.1) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IF(I.LT.N) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IF(I.LT.N-1) THEN
      MA=MA+1
      JA(MA)=I+2
      ENDIF
      IF(I.LT.N-2) THEN
      MA=MA+1
      JA(MA)=I+3
      ENDIF
      IA(I+1)=MA+1
   91 CONTINUE
      XMAX=1.0D 1
      RETURN
  100 IF (N.LT.7) GO TO 999
      NA=N
      MA=0
      IA(1)=1
      DO 101 I=1,N
      X(I)=-1.0D 0
      IF (I.GT.1.AND.I.LT.N-3) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      IF (I.LT.N-4) THEN
      MA=MA+1
      JA(MA)=I
      ENDIF
      IF (I.LT.N-5) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      MA=MA+5
      JA(MA-4)=N-4
      JA(MA-3)=N-3
      JA(MA-2)=N-2
      JA(MA-1)=N-1
      JA(MA)=N
      IA(I+1)=MA+1
  101 CONTINUE
      RETURN
  110 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      NA=N
      MA=0
      IA(1)=1
      DO 111 I=1,N
      IF(MOD(I,2).EQ.1) THEN
      X(I)=9.0D 1
      MA=MA+2
      JA(MA-1)=I
      JA(MA)=I+1
      ELSE
      X(I)=6.0D 1
      MA=MA+2
      JA(MA-1)=I-1
      JA(MA)=I
      ENDIF
      IA(I+1)=MA+1
  111 CONTINUE
      RETURN
  120 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      NA=N
      MA=0
      IA(1)=1
      DO 121 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=3.0D 0
      MA=MA+2
      JA(MA-1)=I
      JA(MA)=I+1
      ELSE IF (MOD(I,4).EQ.2) THEN
      X(I)=-1.0D 0
      MA=MA+2
      JA(MA-1)=I+1
      JA(MA)=I+2
      ELSE IF (MOD(I,4).EQ.3) THEN
      X(I)=0.0D 0
      MA=MA+2
      JA(MA-1)=I-1
      JA(MA)=I
      ELSE
      X(I)=1.0D 0
      MA=MA+2
      JA(MA-1)=I-3
      JA(MA)=I
      ENDIF
      IA(I+1)=MA+1
  121 CONTINUE
      XMAX=1.0D 2
      RETURN
  130 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      NA=N
      MA=0
      IA(1)=1
      DO 131 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=1.0D 0
      MA=MA+2
      JA(MA-1)=I
      JA(MA)=I+1
      ELSE IF (MOD(I,4).EQ.2) THEN
      X(I)=2.0D 0
      MA=MA+2
      JA(MA-1)=I
      JA(MA)=I+1
      ELSE IF (MOD(I,4).EQ.3) THEN
      X(I)=2.0D 0
      MA=MA+2
      JA(MA-1)=I
      JA(MA)=I+1
      ELSE
      X(I)=2.0D 0
      MA=MA+1
      JA(MA)=I
      ENDIF
      IA(I+1)=MA+1
  131 CONTINUE
      XMAX=1.0D 1
      RETURN
  140 IF (N.LT.3) GO TO 999
      DO 141 I=1,N
      X(I)=-1.0D 0
  141 CONTINUE
      GO TO 42
  150 IF (N.LT.7) GO TO 999
      NA=N
      MA=0
      IA(1)=1
      DO 152 I=1,5
      X(I)=-1.0D 0
      DO 151 K=1,I+1
      MA=MA+1
      JA(MA)=K
  151 CONTINUE
      IA(I+1)=MA+1
  152 CONTINUE
      DO 154 I=6,N-1
      X(I)=-1.0D 0
      DO 153 K=I-5,I+1
      MA=MA+1
      JA(MA)=K
  153 CONTINUE
      IA(I+1)=MA+1
  154 CONTINUE
      X(N)=-1.0D 0
      DO 155 K=N-5,N
      MA=MA+1
      JA(MA)=K
  155 CONTINUE
      IA(N+1)=MA+1
      RETURN
  160 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      NA=N
      DO 161 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=0.0D 0
      ELSE
      X(I)=1.0D 0
      ENDIF
  161 CONTINUE
      MA=1
      DO 163 I=1,N-1,2
      IA(I)=2*I-1
      IA(I+1)=2*I+1
      DO 162 J=1,2
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      MA=MA+1
  162 CONTINUE
  163 CONTINUE
      IA(N+1)=MA
      MA=MA-1
      RETURN
  170 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      NA=N
      IA(1)=1
      J=0
      DO 171 I=2,N,2
      X(I-1)=-3.0D 0
      X(I)=-1.0D 0
      IA(I)=IA(I-1)+2
      IA(I+1)=IA(I)+3
      MA=IA(I-1)+4
      JA(MA-4)=I-1
      JA(MA-3)=I
      IF (J.EQ.0) THEN
      JA(MA-2)=I-1
      JA(MA-1)=I
      JA(MA)=I+2
      J=1
      ELSE
      JA(MA-2)=I-2
      JA(MA-1)=I-1
      JA(MA)=I
      J=0
      ENDIF
  171 CONTINUE
      RETURN
  190 IF (N.LT.3) GO TO 999
      DO 191 I=1,N
      X(I)=DBLE(I)/DBLE(N+1)
      X(I)=X(I)*(X(I)-1.0D 0)
  191 CONTINUE
      GO TO 42
  310 IF (N.LT.3) GO TO 999
      DO 311 I=1,N
      X(I)=5.0D 0*MIN(DBLE(I)/DBLE(N+1),1.0D 0-DBLE(I)/DBLE(N+1))
  311 CONTINUE
      XMAX=1.0D 4
      GO TO 42
  200 IF (N.LT.3) GO TO 999
      DO 201 I=1,N
      X(I)=1.0D 1
  201 CONTINUE
      GO TO 42
  240 IF (N.LT.16) GO TO 999
      M=INT(SQRT(DBLE(N)))
      PAR=6.7D 0/DBLE(M+1)**2
      N=M*M
      K=0
      DO 242 J=1,M
      DO 241 I=1,M
      K=K+1
      X(K)=0.0D 0
  241 CONTINUE
  242 CONTINUE
      GO TO 263
  300 IF (N.LT.16) GO TO 999
      M=INT(SQRT(DBLE(N)))
      N=M*M
      PAR=500.0D 0
      K=0
      DO 302 J=1,M
      DO 301 I=1,M
      K=K+1
      X(K)=0.0D 0
  301 CONTINUE
  302 CONTINUE
  303 NA=N
      MA=0
      IA(1)=1
      K=0
      DO 305 J=1,M
      DO 304 I=1,M
      K=K+1
      IF (J.GT.2) THEN
        MA=MA+1
        JA(MA)=K-M-M
      ENDIF
      IF (J.GT.1) THEN
        IF (I.GT.1) THEN
          MA=MA+1
          JA(MA)=K-M-1
        ENDIF
        MA=MA+1
        JA(MA)=K-M
        IF (I.LT.M) THEN
          MA=MA+1
          JA(MA)=K-M+1
        ENDIF
      ENDIF
      IF (I.GT.1) THEN
        IF (I.GT.2) THEN
          MA=MA+1
          JA(MA)=K-2
        ENDIF
        MA=MA+1
        JA(MA)=K-1
      ENDIF
      MA=MA+1
      JA(MA)=K
      IF (I.LT.M) THEN
        MA=MA+1
        JA(MA)=K+1
        IF (I.LT.M-1) THEN
          MA=MA+1
          JA(MA)=K+2
        ENDIF
      ENDIF
      IF (J.LT.M) THEN
        IF (I.GT.1) THEN
          MA=MA+1
          JA(MA)=K+M-1
        ENDIF
        MA=MA+1
        JA(MA)=K+M
        IF (I.LT.M) THEN
          MA=MA+1
          JA(MA)=K+M+1
        ENDIF
      ENDIF
      IF (J.LT.M-1) THEN
        MA=MA+1
        JA(MA)=K+M+M
      ENDIF
      IA(K+1)=MA+1
  304 CONTINUE
  305 CONTINUE
      RETURN
  320 IF (N.LT.3) GO TO 999
      DO 321 I=1,N
      X(I)=5.0D 0*MIN(DBLE(I)/DBLE(N+1),1.0D 0-DBLE(I)/DBLE(N+1))
  321 CONTINUE
      GO TO 42
  210 IF (N.LT.3) GO TO 999
      DO 211 I=1,N
      X(I)=1.0D 0
  211 CONTINUE
      PAR=1.0D 1
      GO TO 42
  180 IF (N.LT.3) GO TO 999
      DO 181 I=1,N
      X(I)=1.5D 0
  181 CONTINUE
      XMAX=1.0D 0
      GO TO 42
  290 IF (N.LT.16) GO TO 999
      M=INT(SQRT(DBLE(N)))
      N=M*M
      PAR=500.0D 0/DBLE(M+2)**4
      K=0
      DO 292 J=1,M
      DO 291 I=1,M
      K=K+1
      X(K)=0.0D 0
  291 CONTINUE
  292 CONTINUE
      GO TO 303
  270 IF (N.LT.16) GO TO 999
      M=INT(SQRT(DBLE(N)))
      PAR=5.0D 1/DBLE(M+1)
      N=M*M
      K=0
      DO 272 J=1,M
      DO 271 I=1,M
      K=K+1
      X(K)=1.0D 0-DBLE(I)*DBLE(J)/DBLE(M+1)**2
  271 CONTINUE
  272 CONTINUE
      GO TO 263
  250 IF (N.LT.16) GO TO 999
      M=INT(SQRT(DBLE(N)))
      PAR=1.0D 0/DBLE(M+1)**2
      N=M*M
      K=0
      DO 252 J=1,M
      DO 251 I=1,M
      K=K+1
      X(K)=-1.0D 0
  251 CONTINUE
  252 CONTINUE
      GO TO 263
  280 IF (N.LT.16) GO TO 999
      M=INT(SQRT(DBLE(N)))
      PAR=1.0D 0/DBLE(M+1)
      N=M*M
      K=0
      DO 282 J=1,M
      DO 281 I=1,M
      K=K+1
      X(K)=0.0D 0
  281 CONTINUE
  282 CONTINUE
      GO TO 263
  260 IF (N.LT.16) GO TO 999
      M=INT(SQRT(DBLE(N)))
      PAR=1.0D 0/DBLE(M+1)**2
      N=M*M
      K=0
      DO 262 J=1,M
      DO 261 I=1,M
      K=K+1
      X(K)=0.0D 0
  261 CONTINUE
  262 CONTINUE
  263 NA=N
      MA=0
      IA(1)=1
      K=0
      DO 265 J=1,M
      DO 264 I=1,M
      K=K+1
      IF (J.GT.1) THEN
      MA=MA+1
      JA(MA)=K-M
      ENDIF
      IF (I.GT.1) THEN
      MA=MA+1
      JA(MA)=K-1
      ENDIF
      MA=MA+1
      JA(MA)=K
      IF (I.LT.M) THEN
      MA=MA+1
      JA(MA)=K+1
      ENDIF
      IF (J.LT.M) THEN
      MA=MA+1
      JA(MA)=K+M
      ENDIF
      IA(K+1)=MA+1
  264 CONTINUE
  265 CONTINUE
      RETURN
  220 IF (N.LT.5) GO TO 999
      PAR=5.0D 2/DBLE(N+2)
      NA=N
      MA=0
      IA(1)=1
      DO 221 I=1,N
      X(I)=((DBLE(I)+0.5D 0)/DBLE(N+2)-0.5D 0)**2
      IF (I.GT.2) THEN
      MA=MA+1
      JA(MA)=I-2
      ENDIF
      IF (I.GT.1) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IF (I.LT.N) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IF (I.LT.N-1) THEN
      MA=MA+1
      JA(MA)=I+2
      ENDIF
      IA(I+1)=MA+1
  221 CONTINUE
      RETURN
  230 IF (N.LT.10) GO TO 999
      N=N-MOD(N,2)
      M=N/2
      PAR=5.0D 2
      NA=N
      MA=0
      IA(1)=1
      DO 231 I=1,M
      K=I+M
      X(I)=(DBLE(I)/DBLE(M+1)-0.5D 0)**2
      IF (I.GT.2) THEN
      MA=MA+1
      JA(MA)=I-2
      ENDIF
      IF (I.GT.1) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IF (I.LT.M) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IF (I.LT.M-1) THEN
      MA=MA+1
      JA(MA)=I+2
      ENDIF
      IF(I.GT.1) THEN
      MA=MA+1
      JA(MA)=K-1
      ENDIF
      MA=MA+1
      JA(MA)=K
      IF(I.LT.M) THEN
      MA=MA+1
      JA(MA)=K+1
      ENDIF
      IA(I+1)=MA+1
  231 CONTINUE
      DO 232 I=M+1,N
      K=I-M
      X(I)=DBLE(K)/DBLE(M+1)-0.5D 0
      IF (K.GT.1) THEN
      MA=MA+1
      JA(MA)=K-1
      ENDIF
      MA=MA+1
      JA(MA)=K
      IF (K.LT.M) THEN
      MA=MA+1
      JA(MA)=K+1
      ENDIF
      IF(K.GT.1) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IF(K.LT.M) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IA(I+1)=MA+1
  232 CONTINUE
      RETURN
  410 IF (N.LT.2) GO TO 999
      N1=N-1
      DO 411 I=1,N1
      X(I)=-1.2D 0
  411 CONTINUE
      X(N)=-1.0D 0
  412 NA=N
      MA=0
      IA(1)=1
      DO 413 I=1,N
      IF (I.GT.1) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IA(I+1)=MA+1
  413 CONTINUE
      RETURN
  420 IF (N.LT.3) GO TO 999
      DO 421 I=1,N
      X(I)=2.0D 0
  421 CONTINUE
      NA=N
      MA=0
      IA(1)=1
      DO 422 I=1,N
      IF (I.EQ.N) THEN
      MA=MA+1
      JA(MA)=1
      MA=MA+1
      JA(MA)=N
      ELSE
      MA=MA+1
      JA(MA)=I
      IF (I.LE.N-1) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      ENDIF
      IA(I+1)=MA+1
  422 CONTINUE
      RETURN
  430 IF (N.LT.3) GO TO 999
      DO 431 I=1,N
      X(I)=0.0D 0
  431 CONTINUE
      GO TO 42
  440 IF (N.LT.3) GO TO 999
      DO 441 I=1,N
      X(I)=-1.0D 0
  441 CONTINUE
      GO TO 42
  450 IF (N.LT.7) GO TO 999
      DO 451 I=1,N
      X(I)=-1.0D 0
  451 CONTINUE
      NA=N
      MA=0
      IA(1)=1
      J1=3
      J2=3
      DO 453 I=1,N
      IF (I-J1.GT.1) THEN
      I1=I-J1
      ELSE
      I1=1
      ENDIF
      IF (I+J2.LT.N) THEN
      I2=I+J2
      ELSE
      I2=N
      ENDIF
      DO 452 J=I1,I2
      MA=MA+1
      JA(MA)=J
  452 CONTINUE
      IA(I+1)=MA+1
  453 CONTINUE
      RETURN
  460 IF (N.LT.2) GO TO 999
      DO 461 I=1,N
      X(I)=0.5D 0
  461 CONTINUE
      GO TO 412
      RETURN
  470 IF (N.LT.2) GO TO 999
      DO 471 I=1,N
      X(I)=0.5D 0
  471 CONTINUE
      GO TO 412
  480 IF (N.LT.3) GO TO 999
      DO 481 I=1,N
      X(I)=1.0D 0
  481 CONTINUE
      GO TO 42
  490 IF (N.LT.7) GO TO 999
      DO 491 I=1,N
      X(I)=-1.0D 0
  491 CONTINUE
      NA=N
      MA=0
      IA(1)=1
      DO 493 I=1,N
      IF (I-5.GT.1) THEN
      I1=I-5
      ELSE
      I1=1
      ENDIF
      IF (I+1.LT.N) THEN
      I2=I+1
      ELSE
      I2=N
      ENDIF
      DO 492 J=I1,I2
      MA=MA+1
      JA(MA)=J
  492 CONTINUE
      IA(I+1)=MA+1
  493 CONTINUE
      RETURN
  500 IF (N.LT.3) GO TO 999
      DO 501 I=1,N
      X(I)=1.0D 0
  501 CONTINUE
      GO TO 42
  520 IF (N.LT.3) GO TO 999
      DO 521 I=1,N
      X(I)=1.0D 0
  521 CONTINUE
      GO TO 42
  530 T=DBLE(2)/DBLE(N+2)
      N1=N/2
      DO 531 I=1,N1
      S=DBLE(I)*T
      X(I)=S*(1.0D 0-S)
      X(N1+I)=X(I)
  531 CONTINUE
      NA=N
      N1=N/2
      MA=0
      IA(1)=1
      DO 532 I=1,N
      IF (I.EQ.1) THEN
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      MA=MA+1
      JA(MA)=I+N1
      ELSE IF (I.EQ.N1+1) THEN
      MA=MA+1
      JA(MA)=1
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      ELSE IF (I.EQ.N1) THEN
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+N1
      ELSE IF (I.EQ.N) THEN
      MA=MA+1
      JA(MA)=N1
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      ELSE IF (I.LT.N1) THEN
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      MA=MA+1
      JA(MA)=I+N1
      ELSE
      MA=MA+1
      JA(MA)=I-N1
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IA(I+1)=MA+1
  532 CONTINUE
      RETURN
  540 N1=INT(SQRT(DBLE(N)))
      N=N1*N1
      DO 541 I=1,N
      X(I)=1.0D 0
  541 CONTINUE
  542 NA=N
      ND=INT(SQRT(DBLE(N)))
      MA=0
      IA(1)=1
      DO 543 I=1,N
      L=MOD(I,ND)
      IF (L.EQ.0) THEN
      K=I/ND
      L=ND
      ELSE
      K=INT(I/ND)+1
      ENDIF
      IF (L.EQ.1.AND.K.EQ.1) THEN
      MA=MA+1
      JA(MA)=1
      MA=MA+1
      JA(MA)=2
      MA=MA+1
      JA(MA)=ND+1
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
      MA=MA+1
      JA(MA)=L-1
      MA=MA+1
      JA(MA)=L
      MA=MA+1
      JA(MA)=L+1
      MA=MA+1
      JA(MA)=L+ND
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.1) THEN
      MA=MA+1
      JA(MA)=ND-1
      MA=MA+1
      JA(MA)=ND
      MA=MA+1
      JA(MA)=2*ND
      ENDIF
      IF (L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
      MA=MA+1
      JA(MA)=I-ND
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      MA=MA+1
      JA(MA)=I+ND
      ENDIF
      IF (L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      MA=MA+1
      JA(MA)=I-ND
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+ND
      ENDIF
      IF (L.EQ.1.AND.K.EQ.ND) THEN
      MA=MA+1
      JA(MA)=I-ND
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
      MA=MA+1
      JA(MA)=I-ND
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.ND) THEN
      MA=MA+1
      JA(MA)=I-ND
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      MA=MA+1
      JA(MA)=I-ND
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      MA=MA+1
      JA(MA)=I+ND
      ENDIF
      IA(I+1)=MA+1
  543 CONTINUE
      RETURN
  550 N1=INT(SQRT(DBLE(N)))
      N=N1*N1
      DO 551 I=1,N
      X(I)=1.0D 0
  551 CONTINUE
      GO TO 542
  999 IERR=1
      RETURN
      END
