* SUBROUTINE EIUB20                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION WITH CHANGED TESTS 7-10, 12.
*  CHANGED FOR THE TESTS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NB  NUMBER OF ELEMENTS OF THE SPARSE MATRIX.
*  RO  X(N)  VECTOR OF VARIABLES.
*  IO  IH(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUB20(N,NB,MB,X,IH,JH,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NB,MB,NEXT,IEXT,IERR
      INTEGER IH(NB+1),JH(*)
      REAL*8 X(N),FMIN,XMAX
      INTEGER I,J,K
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,
     & 170,80), NEXT
   10 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 11 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.2D 0
        ELSE
          X(I)=1.0D 0
        ENDIF
   11 CONTINUE
      NB=N-1
      DO 12 I=1,NB
        J=2*(I-1)+1
        JH(J)=I
        JH(J+1)=I+1
        IH(I)=J
   12 CONTINUE
      MB=2*NB
      IH(NB+1)=MB+1
      RETURN
   20 IF (N.LT.8) GO TO 999
      N=N-MOD(N,2)
      DO 21 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-2.0D 0
        ELSE
          X(I)= 1.0D 0
        ENDIF
   21 CONTINUE
      NB=(N-2)/2
      DO 22 I=1,NB
        J=4*(I-1)+1
        K=2*I-1
        JH(J)=K
        JH(J+1)=K+1
        JH(J+2)=K+2
        JH(J+3)=K+3
        IH(I)=J
   22 CONTINUE
      MB=4*NB
      IH(NB+1)=IH(NB)+4
      RETURN
   30 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 31 I=1,N
        IF(MOD(I,4).EQ.1) THEN
          X(I)=3.0D 0
        ELSEIF(MOD(I,4).EQ.2) THEN
          X(I)=-1.0D 0
        ELSEIF(MOD(I,4).EQ.3) THEN
          X(I)=0.0D 0
        ELSE
          X(I)=1.0D 0
        ENDIF
   31 CONTINUE
      NB=(N-2)/2
      DO 32 I=1,NB
        J=4*(I-1)+1
        K=2*I-1
        JH(J)=K
        JH(J+1)=K+1
        JH(J+2)=K+2
        JH(J+3)=K+3
        IH(I)=J
   32 CONTINUE
      MB=4*NB
      IH(NB+1)=IH(NB)+4
      RETURN
   40 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 41 I=1,N
        X(I)=2.0D 0
        IF (MOD(I,4).EQ.1) X(I)=1.0D 0
   41 CONTINUE
      NB=(N-2)/2
      DO 42 I=1,NB
        J=4*(I-1)+1
        K=2*I-1
        JH(J)=K
        JH(J+1)=K+1
        JH(J+2)=K+2
        JH(J+3)=K+3
        IH(I)=J
   42 CONTINUE
      MB=4*NB
      IH(NB+1)=IH(NB)+4
      RETURN
   50 IF (N.LT.3) GO TO 999
      DO 51 I=1,N
        X(I)=-1.0D 0
   51 CONTINUE
   52 MB=1
      NB=N
      DO 53 I=1,NB
        IH(I)=MB
        IF (I.GT.1) THEN
          JH(MB)=I-1
          MB=MB+1
        ENDIF
        JH(MB)=I
        MB=MB+1
        IF (I.LT.N) THEN
          JH(MB)=I+1
          MB=MB+1
        ENDIF
   53 CONTINUE
      IH(NB+1)=MB
      MB=MB-1
      RETURN
   60 IF (N.LT.7) GO TO 999
      N=N-1+MOD(N,2)
      DO 61 I=1,N
        X(I)=3.0D 0
   61 CONTINUE
      MB=1
      NB=N
      DO 62 I=1,NB
        IH(I)=MB
        IF (I.GT.5) THEN
          JH(MB)=I-5
          MB=MB+1
        ENDIF
        IF (I.GT.4) THEN
          JH(MB)=I-4
          MB=MB+1
        ENDIF
        IF (I.GT.3) THEN
          JH(MB)=I-3
          MB=MB+1
        ENDIF
        IF (I.GT.2) THEN
          JH(MB)=I-2
          MB=MB+1
        ENDIF
        IF (I.GT.1) THEN
          JH(MB)=I-1
          MB=MB+1
        ENDIF
          JH(MB)=I
          MB=MB+1
        IF (I.LT.N) THEN
          JH(MB)=I+1
          MB=MB+1
        ENDIF
   62 CONTINUE
      IH(NB+1)=MB
      MB=MB-1
      XMAX=1.0D 1
      RETURN
   70 IF (N.LT.2) GO TO 999
      DO 71 I=1,N
        X(I)=1.0D 0
   71 CONTINUE
      GO TO 52
   80 IF (N.LT.5) GO TO 999
      N=N-MOD(N,5)
      DO 81 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.0D 0
        ELSE
          X(I)= 2.0D 0
        ENDIF
   81 CONTINUE
      MB=1
      NB=N/5
      DO 82 I=1,NB
        J=5*(I-1)+1
        IH(I)=MB
        MB=MB+5
        JH(MB-5)=J
        JH(MB-4)=J+1
        JH(MB-3)=J+2
        JH(MB-2)=J+3
        JH(MB-1)=J+4
   82 CONTINUE
      IH(NB+1)=MB
      MB=MB-1
      XMAX=2.0D 0
      RETURN
   90 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 91 I=1,N
        X(I)=-1.0D 0
   91 CONTINUE
      NB=N/2
      DO 92 I=1,NB
        J=2*I-1
        JH(J)=J
        JH(J+1)=J+1
        IH(I)=J
   92 CONTINUE
      MB=N
      IH(NB+1)=IH(NB)+2
      XMAX=1.0D 1
      RETURN
  100 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 101 I=2,N,2
        X(I-1)=-1.0D 0
        X(I)=1.0D 0
  101 CONTINUE
      NB=N/2
      DO 102 I=1,NB
        J=2*I-1
        JH(J)=J
        JH(J+1)=J+1
        IH(I)=J
  102 CONTINUE
      MB=N
      IH(NB+1)=MB+1
      XMAX=1.0D 1
      RETURN
  110 IF (N.LT.5) GO TO 999
      N=N-MOD(N-2,3)
      DO 111 I=1,N
        IF (MOD(I,3).EQ.1) X(I)=2.0D 0
        IF (MOD(I,3).EQ.2) X(I)=1.5D 0
        IF (MOD(I,3).EQ.0) X(I)=0.5D 0
  111 CONTINUE
  112 K=(N-2)/3
      NB=1
      MB=1
      DO 113 I=1,K
        J=(I-1)*3
        IH(NB)=MB
        IH(NB+1)=MB+2
        IH(NB+2)=MB+3
        IH(NB+3)=MB+4
        NB=NB+4
        MB=MB+5
        JH(MB-5)=J+1
        JH(MB-4)=J+2
        JH(MB-3)=J+3
        JH(MB-2)=J+4
        JH(MB-1)=J+5
  113 CONTINUE
      IH(NB)=MB
      NB=NB-1
      MB=MB-1
      RETURN
  120 IF (N.LT.5) GO TO 999
      N=N-MOD(N-1,4)
      DO 121 I=1,N
        IF (MOD(I,4).EQ.1) X(I)= 2.0D 0
        IF (MOD(I,4).EQ.2) X(I)= 1.5D 0
        IF (MOD(I,4).EQ.3) X(I)=-1.0D 0
        IF (MOD(I,4).EQ.0) X(I)= 0.5D 0
  121 CONTINUE
  122 K=(N-1)/4
      NB=1
      MB=1
      DO 123 I=1,K
        J=(I-1)*4
        IH(NB)=MB
        IH(NB+1)=MB+2
        IH(NB+2)=MB+4
        IH(NB+3)=MB+6
        NB=NB+4
        MB=MB+8
        JH(MB-8)=J+1
        JH(MB-7)=J+2
        JH(MB-6)=J+2
        JH(MB-5)=J+3
        JH(MB-4)=J+3
        JH(MB-3)=J+4
        JH(MB-2)=J+4
        JH(MB-1)=J+5
  123 CONTINUE
      IH(NB)=MB
      NB=NB-1
      MB=MB-1
      RETURN
  130 IF (N.LT.5) GO TO 999
      N=N-MOD(N-2,3)
      DO 131 I=1,N
        IF (MOD(I,3).EQ.1) X(I)= 3.0D 0
        IF (MOD(I,3).EQ.2) X(I)= 5.0D 0
        IF (MOD(I,3).EQ.0) X(I)=-3.0D 0
  131 CONTINUE
      K=(N-2)/3
      NB=1
      MB=1
      DO 132 I=1,K
        J=(I-1)*3
        IH(NB)=MB
        IH(NB+1)=MB+1
        IH(NB+2)=MB+3
        NB=NB+3
        MB=MB+5
        JH(MB-5)=J+1
        JH(MB-4)=J+2
        JH(MB-3)=J+3
        JH(MB-2)=J+4
        JH(MB-1)=J+5
  132 CONTINUE
      IH(NB)=MB
      NB=NB-1
      MB=MB-1
      RETURN
  140 IF (N.LT.5) GO TO 999
      N=N-MOD(N-2,3)
      DO 141 I=1,N
        IF (MOD(I,3).EQ.1) X(I)= 1.0D 1
        IF (MOD(I,3).EQ.2) X(I)= 7.0D 0
        IF (MOD(I,3).EQ.0) X(I)=-3.0D 0
  141 CONTINUE
      GO TO 112
  150 IF (N.LT.5) GO TO 999
      N=N-MOD(N-1,4)
      DO 151 I=1,N
        IF (MOD(I,4).EQ.1) X(I)= 3.5D 1
        IF (MOD(I,4).EQ.2) X(I)= 1.1D 1
        IF (MOD(I,4).EQ.3) X(I)= 5.0D 0
        IF (MOD(I,4).EQ.0) X(I)=-5.0D 0
  151 CONTINUE
      GO TO 122
  160 IF (N.LT.5) GO TO 999
      N=N-MOD(N-1,4)
      DO 161 I=1,N
        IF (MOD(I,4).EQ.1) X(I)= 2.5D 0
        IF (MOD(I,4).EQ.2) X(I)= 0.5D 0
        IF (MOD(I,4).EQ.3) X(I)= 2.0D 0
        IF (MOD(I,4).EQ.0) X(I)=-1.0D 0
  161 CONTINUE
  162 K=(N-1)/4
      NB=1
      MB=1
      DO 163 I=1,K
        J=(I-1)*4
        IH(NB)=MB
        IH(NB+1)=MB+2
        IH(NB+2)=MB+4
        IH(NB+3)=MB+5
        NB=NB+4
        MB=MB+6
        JH(MB-6)=J+1
        JH(MB-5)=J+2
        JH(MB-4)=J+2
        JH(MB-3)=J+3
        JH(MB-2)=J+4
        JH(MB-1)=J+5
  163 CONTINUE
      IH(NB)=MB
      NB=NB-1
      MB=MB-1
      RETURN
  170 IF (N.LT.5) GO TO 999
      N=N-MOD(N-1,4)
      DO 171 I=1,N
        X(I)=2.0D 0
  171 CONTINUE
      GO TO 162
  999 IERR=1
      RETURN
      END
