* SUBROUTINE EIUB34                ALL SYSTEMS                04/12/01
C PORTABILITY : ALL SYSTEMS
C 04/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION WITH CHANGED TESTS 7-10, 12.
*  CHANGED FOR THE TESTS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NB  NUMBER OF ELEMENTS OF THE SPARSE MATRIX.
*  RO  X(N)  VECTOR OF VARIABLES.
*  IO  IH(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUB34(N,NB,MB,X,IH,JH,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NB,MB,NEXT,IEXT,IERR
      INTEGER IH(NB+1),JH(*)
      REAL*8 X(N),FMIN,XMAX
      INTEGER I,L
      REAL*8 Y(20)
      COMMON /EMPR15/ Y
      REAL*8 ETA9
      PARAMETER (ETA9=1.0D 60)
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      GOTO(10,20,30,40,50,60,70),NEXT
   10 IF (N.LT.2) GO TO 999
      DO 11 I=1,N
        X(I)=-0.5D 0
   11 CONTINUE
      IH(1)=1
      DO 12 I=1,N-1
        L=2*(I-1)+1
        JH(L)=I
        JH(L+1)=I+1
        IH(I+1)=L+2
   12 CONTINUE
      NB=N-1
      MB=2*(N-1)
      RETURN
   20 IF (N.LT.2) GO TO 999
      DO 21 I=1,N
        X(I)=2.0D 0
   21 CONTINUE
      DO 22 I=1,N-1
        L=2*(I-1)+1
        JH(L)=I
        JH(L+1)=I+1
        IH(I+1)=L+2
   22 CONTINUE
      NB=N-1
      MB=2*(N-1)
      RETURN
   30 IF (N.LT.2) GO TO 999
      DO 31 I=1,N
        X(I)=2.0D 0
   31 CONTINUE
      DO 32 I=1,N-1
        L=2*(I-1)+1
        JH(L)=I
        JH(L+1)=I+1
        IH(I+1)=L+2
   32 CONTINUE
      NB=N-1
      MB=2*(N-1)
      RETURN
   40 IF (N.LT.4) GO TO 999
      DO 41 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.0D 0
        ELSE
          X(I)= 1.0D 0
        ENDIF
   41 CONTINUE
      DO 42 I=1,N-1
        L=2*(I-1)+1
        JH(L)=I
        JH(L+1)=I+1
        IH(I+1)=L+2
   42 CONTINUE
      RETURN
   50 IF (N.LT.2) GO TO 999
      DO 51 I=1,N
        X(I)=-1.0D 0
   51 CONTINUE
      DO 52 I=1,N-1
        L=2*(I-1)+1
        JH(L)=I
        JH(L+1)=I+1
        IH(I+1)=L+2
   52 CONTINUE
      RETURN
   60 IF (N.LT.2) GO TO 999
      DO 61 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.5D 0
        ELSE
          X(I)= 2.0D 0
        ENDIF
   61 CONTINUE
      DO 62 I=1,N-1
        L=2*(I-1)+1
        JH(L)=I
        JH(L+1)=I+1
        IH(I+1)=L+2
   62 CONTINUE
      RETURN
   70 IF (N.LT.2) GO TO 999
      DO 71 I=1,N-1
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.5D 0
        ELSE
          X(I)= 2.0D 0
        ENDIF
   71 CONTINUE
      DO 72 I=1,N-1
        L=2*(I-1)+1
        JH(L)=I
        JH(L+1)=I+1
        IH(I+1)=L+2
   72 CONTINUE
      RETURN
  999 IERR=1
      RETURN
      END
