* SUBROUTINE EIUD29                ALL SYSTEMS                00/12/01
C PORTABILITY : ALL SYSTEMS
C 00/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR UNCONSTRAINED MINIMIZATION.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RO  X(N)  VECTOR OF VARIABLES.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IER  ERROR INDICATOR.
*
      SUBROUTINE EIUD29(N,X,FMIN,XMAX,NEXT,IEXT,IER)
      INTEGER N,NEXT,IEXT,IER,I,J,K,M
      REAL*8 X(N),Y(20),ETA9,FMIN,PAR,XMAX
      COMMON /EMPR15/ Y
      COMMON /EMPR18/ PAR,M
      PARAMETER (ETA9=1.0D 60)
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IER=0
      IF (N.LT.7) GO TO 999
      GO TO (10,10,30,40,40,190,190,80,190,190,80,120,130,140,150,160,
     & 170,180,190,190,190,220,230,240,250,260,270,280,290,300,310),NEXT
   10 DO 11 I=1,N
      X(I)=I*(1-(I+I-1)/N*2)*1.0D 0/N
   11 CONTINUE
      RETURN
   30 DO 31 I=1,N
      X(I)=(1-(I+I-1)/N*2)*1.0D 0
   31 CONTINUE
      RETURN
   40 DO 41 I=1,N
      X(I)=1.0D 0
   41 CONTINUE
      RETURN
   80 DO 81 I=1,N-1
      X(I)=0.5D 0
   81 CONTINUE
      X(N)=-2.0D 0
      RETURN
  120 N=N-MOD(N,2)
      DO 121 I=1,N
        IF(MOD(I,4).EQ.1) THEN
          X(I)=3.0D 0
        ELSEIF(MOD(I,4).EQ.2) THEN
          X(I)=-1.0D 0
        ELSEIF(MOD(I,4).EQ.3) THEN
          X(I)=0.0D 0
        ELSE
          X(I)=1.0D 0
        ENDIF
  121 CONTINUE
      RETURN
  130 N=N-MOD(N,2)
      DO 131 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=-0.8D 0
      ELSE IF (MOD(I,4).EQ.2) THEN
      X(I)= 1.2D 0
      ELSE IF (MOD(I,4).EQ.3) THEN
      X(I)=-1.2D 0
      ELSE
      X(I)= 0.8D 0
      ENDIF
  131 CONTINUE
      Y(1)=14.4D 0
      Y(2)=6.8D 0
      Y(3)=4.2D 0
      Y(4)=3.2D 0
      RETURN
  140 N=N-MOD(N,2)
      DO 141 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=-0.8D 0
      ELSE IF (MOD(I,4).EQ.2) THEN
      X(I)= 1.2D 0
      ELSE IF (MOD(I,4).EQ.3) THEN
      X(I)=-1.2D 0
      ELSE
      X(I)= 0.8D 0
      ENDIF
  141 CONTINUE
      Y(1)=35.8D 0
      Y(2)=11.2D 0
      Y(3)=6.2D 0
      Y(4)=4.4D 0
      RETURN
  150 N=N-MOD(N,4)
      DO 151 I=1,N
        X(I)=SIN(DBLE(I))**2
  151 CONTINUE
      RETURN
  160 DO 161 I=1,N
        X(I)=DBLE(I)/DBLE(N+1)
        X(I)=X(I)*(X(I)-1.0D 0)
  161 CONTINUE
      RETURN
  170 N=N-MOD(N,5)
      DO 171 I=1,N
      X(I)=1.0D 0/DBLE(N)
  171 CONTINUE
      RETURN
  180 DO 181 I=1,N
      X(I)=0D 0
  181 CONTINUE
      RETURN
  190 DO 191 I=1,N
      X(I)=-1.0D 0
  191 CONTINUE
      RETURN
  220 DO 221 I=1,N
      X(I)=DBLE(I)/DBLE(N+1)
      X(I)=X(I)*(X(I)-1.0D 0)
  221 CONTINUE
      RETURN
  230 DO 231 I=1,N
      X(I)=1.0D 1
  231 CONTINUE
      RETURN
  240 PAR=1.0D 1
      GOTO40
  250 IF (N.LT.16) GOTO999
      M=INT(SQRT(DBLE(N)))
      PAR=5.0D 1/DBLE(M+1)
      N=M*M
      K=0
      DO 252 J=1,M
      DO 251 I=1,M
      K=K+1
      X(K)=1.0D 0-DBLE(I)*DBLE(J)/DBLE(M+1)**2
  251 CONTINUE
  252 CONTINUE
      RETURN
  260 N=N-MOD(N,2)
      DO 261 I=1,N
      IF (MOD(I,8).EQ.1) X(I)=1.0D-1
      IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0D-1
      IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0D-1
      IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0D-1
      IF (MOD(I,8).EQ.5) X(I)=5.0D-1
  261 CONTINUE
      RETURN
  270 N=N-MOD(N,2)
      DO 271 I=1,N
      IF (MOD(I,8).EQ.1) X(I)=1.0D-1
      IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0D-1
      IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0D-1
      IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0D-1
      IF (MOD(I,8).EQ.5) X(I)=5.0D-1
  271 CONTINUE
      RETURN
  280 DO 281 I=1,N
      X(I)=1.5D 0
  281 CONTINUE
      XMAX=1.0D 0
      RETURN
  290 IF (N.LT.16) GOTO999
      M=INT(SQRT(DBLE(N)))
      PAR=1.0D 0/DBLE(M+1)**2
      N=M*M
      GOTO190
  300 N=N-MOD(N,2)
      DO 301 I=2,N
        X(I)=2.0D 0
  301 CONTINUE
      X(1)=1.0D 0
      XMAX=1.0D 1
      RETURN
  310 DO 311 I=1,N
        X(I)=0.2D 0
  311 CONTINUE
      RETURN
  999 IER=1
      RETURN
      END
