* SUBROUTINE EIUD37             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR NONLINEAR EQUATIONS.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  IO  N  NUMBER OF VARIABLES.
*  IO  NA  NUMBER OF EQUATIONS.
*  IO  NAL NUMBER OF LINEAR EQUATIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  IO  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD37(N,NA,NAL,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NA,NAL,NEXT,IEXT,IERR
      REAL*8 X(N),FMIN,XMAX,PAR
      INTEGER I,J,K,M,N1,ALF,BET
C      REAL*8 Y(1000),F,S,T
      REAL*8 F,S,T
      COMMON /EMPR18/ PAR,M
      NA=N
      NAL=0
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,230,240,250,260,270,280,290,300,310,
     & 310,401,402,403,404,405,406,407,408,409,412,413,414,419,420,
     & 421,422,423,424,426,427,428,429,430,431,431,560,590,600,670,
     & 690,710,710),NEXT
   10 IF(N.GE.4) THEN
      N=N-MOD(N,2)
      NA=N
      DO 11 I=1,N
      IF (MOD(I,8).EQ.1) X(I)=1.0D-1
      IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0D-1
      IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0D-1
      IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0D-1
      IF (MOD(I,8).EQ.5) X(I)=5.0D-1
   11 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
   20 IF(N.GE.5) THEN
      N=N-MOD(N,2)
      NA=N
      DO 21 I=1,N
      IF (MOD(I,8).EQ.1) X(I)=1.0D-1
      IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0D-1
      IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0D-1
      IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0D-1
      IF (MOD(I,8).EQ.5) X(I)=5.0D-1
   21 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
   30 IF(N.GE.5) THEN
      N=N-MOD(N,5)
      NA=N
      DO 31 I=1,N
      X(I)=1.0D 0/DBLE(N)
   31 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
   40 IF(N.GE.3) THEN
      DO 41 I=1,N
      X(I)=0.0D 0
   41 CONTINUE
   42 NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
   50 IF(N.GE.3) THEN
      IF (MOD(N,2).NE.1) N=N-1
      NA=N
      DO 51 I=1,N
      X(I)=1.0D 0
   51 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
   60 IF(N.GE.3) THEN
      DO 61 I=1,N
      X(I)=-1.0D 0
   61 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
   70 IF(N.GE.3) THEN
      DO 71 I=1,N
      X(I)=1.2D 1
   71 CONTINUE
      XMAX=1.0D 2
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
   80 IF(N.GE.5) THEN
      NA=N
      DO 81 I=1,N
      X(I)=-2.0D 0
   81 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
   90 IF(N.GE.7) THEN
      NA=N
      DO 91 I=1,N
      X(I)=-3.0D 0
   91 CONTINUE
      XMAX=1.0D 1
      ELSE
      IERR=1
      ENDIF
      RETURN
  100 IF(N.GE.7) THEN
      NA=N
      DO 101 I=1,N
      X(I)=-1.0D 0
  101 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  110 IF(N.GE.2) THEN
      N=N-MOD(N,2)
      NA=N
      DO 111 I=1,N
      IF(MOD(I,2).EQ.1) THEN
      X(I)=9.0D 1
      ELSE
      X(I)=6.0D 1
      ENDIF
  111 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  120 IF(N.GE.4) THEN
      N=N-MOD(N,4)
      NA=N
      DO 121 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=3.0D 0
      ELSE IF(MOD(I,4).EQ.2) THEN
      X(I)=-1.0D 0
      ELSEIF(MOD(I,4).EQ.3) THEN
      X(I)=0.0D 0
      ELSE
      X(I)=1.0D 0
      ENDIF
  121 CONTINUE
      XMAX=1.0D 2
      ELSE
      IERR=1
      ENDIF
      RETURN
  130 IF(N.GE.4) THEN
      N=N-MOD(N,4)
      NA=N
      DO 131 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=1.0D 0
      ELSE IF(MOD(I,4).EQ.2) THEN
      X(I)=2.0D 0
      ELSEIF(MOD(I,4).EQ.3) THEN
      X(I)=2.0D 0
      ELSE
      X(I)=2.0D 0
      ENDIF
  131 CONTINUE
      XMAX=1.0D 1
      ELSE
      IERR=1
      ENDIF
      RETURN
  140 IF(N.GE.3) THEN
      DO 141 I=1,N
      X(I)=-1.0D 0
  141 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  150 IF(N.GE.7) THEN
      NA=N
      DO 152 I=1,5
      X(I)=-1.0D 0
  152 CONTINUE
      DO 154 I=6,N-1
      X(I)=-1.0D 0
  154 CONTINUE
      X(N)=-1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  160 IF(N.GE.2) THEN
      N=N-MOD(N,2)
      NA=N
      DO 161 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=0.0D 0
      ELSE
      X(I)=1.0D 0
      ENDIF
  161 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  170 IF (N.GE.4) THEN
      N=N-MOD(N,4)
      NA=N
      DO 171 I=2,N,2
      X(I-1)=-3.0D 0
      X(I)=-1.0D 0
  171 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  190 IF(N.GE.3) THEN
      DO 191 I=1,N
      X(I)=DBLE(I)/DBLE(N+1)
      X(I)=X(I)*(X(I)-1.0D 0)
  191 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  310 IF(N.GE.3) THEN
      DO 311 I=1,N
      X(I)=5.0D 0*MIN(DBLE(I)/DBLE(N+1),1.0D 0-DBLE(I)/DBLE(N+1))
  311 CONTINUE
      XMAX=1.0D 4
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  200 IF(N.GE.3) THEN
      DO 201 I=1,N
      X(I)=1.0D 1
  201 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  240 IF (N.GE.16) THEN
      M=INT(SQRT(DBLE(N)))
      PAR=6.8D 0/DBLE(M+1)**2
      N=M*M
      K=0
      DO 242 J=1,M
      DO 241 I=1,M
      K=K+1
      X(K)=0.0D 0
  241 CONTINUE
  242 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  300 IF (N.GE.16) THEN
      M=INT(SQRT(DBLE(N)))
      N=M*M
      PAR=500.0D 0
      K=0
      DO 302 J=1,M
      DO 301 I=1,M
      K=K+1
      X(K)=0.0D 0
  301 CONTINUE
  302 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  320 IF (N.GE.3) THEN
      DO 321 I=1,N
      X(I)=5.0D 0*MIN(DBLE(I)/DBLE(N+1),1.0D 0-DBLE(I)/DBLE(N+1))
  321 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  210 IF (N.GE.3) THEN
      DO 211 I=1,N
      X(I)=1.0D 0
  211 CONTINUE
      PAR=1.0D 1
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  180 IF (N.GE.3) THEN
      DO 181 I=1,N
      X(I)=1.5D 0
  181 CONTINUE
C      XMAX=1.0D 0
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  290 IF (N.GE.16) THEN
      M=INT(SQRT(DBLE(N)))
      N=M*M
      PAR=500.0D 0/DBLE(M+2)**4
      K=0
      DO 292 J=1,M
      DO 291 I=1,M
      K=K+1
      X(K)=0.0D 0
  291 CONTINUE
  292 CONTINUE
      NA=N
      ELSE
        IERR=1
      ENDIF
      RETURN
  270 IF (N.GE.16) THEN
      M=INT(SQRT(DBLE(N)))
      PAR=5.0D 1/DBLE(M+1)
      N=M*M
      K=0
      DO 272 J=1,M
      DO 271 I=1,M
      K=K+1
      X(K)=1.0D 0-DBLE(I)*DBLE(J)/DBLE(M+1)**2
  271 CONTINUE
  272 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  250 IF (N.GE.16) THEN
      M=INT(SQRT(DBLE(N)))
      PAR=1.0D 0/DBLE(M+1)**2
      N=M*M
      K=0
      DO 252 J=1,M
      DO 251 I=1,M
      K=K+1
      X(K)=-1.0D 0
  251 CONTINUE
  252 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  280 IF (N.GE.16) THEN
      M=INT(SQRT(DBLE(N)))
      PAR=1.0D 0/DBLE(M+1)
      N=M*M
      K=0
      DO 282 J=1,M
      DO 281 I=1,M
      K=K+1
      X(K)=0.0D 0
  281 CONTINUE
  282 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  260 IF (N.GE.16) THEN
      M=INT(SQRT(DBLE(N)))
      PAR=1.0D 0/DBLE(M+1)**2
      N=M*M
      K=0
      DO 262 J=1,M
      DO 261 I=1,M
      K=K+1
      X(K)=0.0D 0
  261 CONTINUE
  262 CONTINUE
      NA=N
      ELSE
      IERR=1
      ENDIF
      RETURN
  220 IF (N.GE.5) THEN
      PAR=5.0D 2/DBLE(N+2)
      NA=N
      DO 221 I=1,N
      X(I)=((DBLE(I)+0.5D 0)/DBLE(N+2)-0.5D 0)**2
  221 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  230 IF (N.GE.10) THEN
      N=N-MOD(N,2)
      M=N/2
      PAR=5.0D 2
      NA=N
      DO 231 I=1,M
      X(I)=(DBLE(I)/DBLE(M+1)-0.5D 0)**2
  231 CONTINUE
      DO 232 I=M+1,N
      K=I-M
      X(I)=DBLE(K)/DBLE(M+1)-0.5D 0
  232 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
401   N1=N-1
      DO 3030 I=1,N1
        X(I)=-1.2D 0
3030  CONTINUE
      X(N)=-1.0D 0
      RETURN
402   DO 3040 I=1,N
        X(I)=2.0D 0
3040  CONTINUE
      RETURN
403   DO 3050 I=1,N
        X(I)=0.5D 0
3050  CONTINUE
      RETURN
404   N1=N-1
      DO 3060 I=1,N1,2
        X(I)=-1.2D 0
        X(I+1)=1.0D 0
3060  CONTINUE
      RETURN
405   DO 3070 I=1,N
        X(I)=1.5D 0
3070  CONTINUE
      RETURN
406   DO 3080 I=1,N
        X(I)=0.0D 0
3080  CONTINUE
      RETURN
407   DO 3090 I=1,N
        X(I)=-1.0D 0
3090  CONTINUE
      RETURN
408   DO 4000 I=1,N
        X(I)=-1.0D 0
4000  CONTINUE
      RETURN
409   DO 4010 I=1,N
        X(I)=0.5D 0
4010  CONTINUE
      RETURN
412   DO 4040 I=1,N
        X(I)=0.5D 0
4040  CONTINUE
      RETURN
413   DO 4050 I=1,N
        X(I)=1.0D 0
4050  CONTINUE
      RETURN
414   DO 4060 I=1,N
        X(I)=-1.0D 0
4060  CONTINUE
      RETURN
419   DO 5010 I=1,N
        T=DBLE(I)/DBLE(N+1)
        X(I)=T*(T-1.D 0)
5010  CONTINUE
      RETURN
420   DO 5020 I=1,N
        X(I)=1.0D 0/DBLE(N)
5020  CONTINUE
      RETURN
421   DO 5030 I=1,N
        X(I)=1.0D 0-DBLE(I)/DBLE(N)
5030  CONTINUE
      RETURN
422   DO 5040 I=1,N
        X(I)=-1.0D 0
5040  CONTINUE
      RETURN
423   ALF=5
      BET=14
      DO 5051 I=1,N
        X(I)=0.0D 0
5051  CONTINUE
C      DO 5052 I=1,N
C        CALL EAFU37(N,I,X,F,49)
C        Y(I)=-F
C 5052  CONTINUE
      S=DBLE(BET*N)/DBLE(BET**2*N**2-(ALF+1)**2*(N-1)**2)
      DO 5050 I=1,N
        CALL EAFU37(N,I,X,F,49)
        X(I)=-S*F
C        X(I)=S*Y(I)
5050  CONTINUE
      RETURN
424   DO 5060 I=1,N
        X(I)=1.0D 0
5060  CONTINUE
      RETURN
426   DO 5080 I=1,N
        X(I)=1.0D 0
5080   CONTINUE
      RETURN
427   DO 5090 I=1,N
        X(I)=1.0D 0
5090   CONTINUE
      RETURN
428   DO 6000 I=1,N
        X(I)=1.0D 0
6000   CONTINUE
      RETURN
429   DO 6010 I=1,N
        X(I)=1.0D 0
6010  CONTINUE
      RETURN
430   T=DBLE(2)/DBLE(N+2)
      N1=N/2
      DO 6020 I=1,N1
        S=DBLE(I)*T
        X(I)=S*(1.0D 0-S)
        X(N1+I)=X(I)
6020   CONTINUE
      RETURN
431   N1=INT(SQRT(DBLE(N)))
      N=N1*N1
      NA=N
      DO 6030 I=1,N
        X(I)=1.0D 0
6030  CONTINUE
      RETURN
  550 IF(N.GE.3) THEN
      IF (MOD(N,2).NE.1) N=N-1
      NA=N
      DO 551 I=1,N
      X(I)=1.0D 0
  551 CONTINUE
C      XMAX=1.0D 2
      ELSE
      IERR=1
      ENDIF
      RETURN
  560 IF(N.GE.2) THEN
      NA=N
      DO 561 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=1.0D 0
      ELSE
      X(I)=3.0D 0
      ENDIF
  561 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  590 IF(N.GE.7) THEN
      NA=N
      DO 591 I=1,N
      X(I)=-3.0D 0
  591 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  600 IF(N.GE.3) THEN
      NA=N
      DO 601 I=1,N
      X(I)=0.0D 0
  601 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  610 IF(N.GE.2) THEN
      N=N-MOD(N,2)
      NA=N
      DO 611 I=1,N
      IF(MOD(I,2).EQ.1) THEN
      X(I)=-1.2D 0
      ELSE
      X(I)= 1.0D 0
      ENDIF
  611 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  670 IF(N.GE.2) THEN
      NA=N
      DO 671 I=1,N
      X(I)=4.0D 0
  671 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  690 IF(N.GE.3) THEN
      NA=N
      DO 691 I=1,N
      X(I)=DBLE(I)/DBLE(N+1)
      X(I)=X(I)*(X(I)-1.0D 0)
  691 CONTINUE
      ELSE
      IERR=1
      ENDIF
  710 IF(N.GE.6) THEN
      NA=N
      DO 711 I=1,N
      X(I)=0.5D 0
  711 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
