* SUBROUTINE UALNF3             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE LINEAR FUNCTION VALUE. THE SPARSE CASE.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF FUNCTIONS.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD AG.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING PARAMETERS.
*  RO  AG(MA)  SPARSE JACOBIAN MATRIX.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  RI  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  RO  FA  VALUE OF THE SELECTED FUNCTION.
*  II  ISNA  SAVING SPECIFICATION. ISNA=0-NO SAVING. ISNA=1-FUNCTION
*         VALUES ARE STORED. ISNA=2-FUNCTION VALUES AND GRADIENTS ARE
*         STORED.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UALNF3(NF,NA,MA,KA,X,XN,AG,IAG,JAG,FA,ISNA,NORMF)
      INTEGER NF,NA,MA,KA,IAG(NA+1),JAG(MA),ISNA,NORMF
      REAL*8 X(NF),XN(NF),AG(MA),FA
      INTEGER J,JP,K,L
      FA=0.0D 0
      K=IAG(KA)
      L=IAG(KA+1)-K
      IF (NORMF.GT.0.AND.ISNA.GT.2) THEN
      DO 1 J=1,L
      JP=ABS(JAG(K))
      FA=FA+AG(K)*X(JP)/XN(JP)
      K=K+1
    1 CONTINUE
      ELSE
      DO 2 J=1,L
      JP=ABS(JAG(K))
      FA=FA+AG(K)*X(JP)
      K=K+1
    2 CONTINUE
      ENDIF
      RETURN
      END
