* SUBROUTINE UANOR1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE SCALING FACTORS.
*
* PARAMETERS :
*  II  NA NUMBER OF APPROXIMATED FUNCTIONS.
*  II  IA(NA)  VECTOR CONTAINING TYPES OF DEVIATIONS.
*  RI  AM(NA)  VECTOR CONTAINING MEAN VALUES FOR APPROXIMATED
*         FUNCTIONS.
*  RO  AW(NA)  VECTOR OF SCALING FACTORS.
*  II  NORMA  SCALING SPECIFICATION. NORMA=0-NO SCALING IS PERFORMED.
*         NORMA=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMA=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  RI  REXP  EXPONENT IN A SUM OF POWERS.
*
      SUBROUTINE UANOR1(NA,IA,AM,AW,NORMA,REXP)
      INTEGER NA,IA(NA),NORMA
      REAL*8 AM(NA),AW(NA),REXP
      INTEGER KA
      DO 1 KA=1,NA
      IF (NORMA.LE.0) RETURN
      IF (NORMA.EQ.1) THEN
      IF (IA(KA).EQ.0) THEN
      AW(KA)=1.0D 0
      ELSE
      AW(KA)=ABS(AM(KA))**(1.0D 0/REXP)
      ENDIF
      ENDIF
      IF (AW(KA).LE.0.0D 0) AW(KA)=1.0D 0
    1 CONTINUE
      RETURN
      END
