* SUBROUTINE UARED1             ALL SYSTEMS                   07/12/01
C PORTABILITY : ALL SYSTEMS
C 07/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE SPARSE JACOBIAN MATRIX FROM INDIVIDUAL GRADIENTS
* OF THE APPROXIMATED FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF FUNCTIONS.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD AG.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  RI  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RO  XRED(NF)  REDUCED VECTOR OF VARIABLES.
*  IO  L  DIMENSION OF THE VECTOR XRED.
*
      SUBROUTINE UARED1(NF,NA,MA,KA,IAG,JAG,X,XRED,L)
      INTEGER NF,NA,MA,KA,IAG(NA+1),JAG(MA),L
      REAL*8 X(NF),XRED(NF)
      INTEGER J,JP,K
      K=IAG(KA)
      L=IAG(KA+1)-K
      DO 2 J=1,L
      JP=ABS(JAG(K))
      XRED(J)=X(JP)
      K=K+1
    2 CONTINUE
      RETURN
      END
