* SUBROUTINE UASDH2             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE DENSE HESSIAN MATRIX FROM THE SPARSE JACOBIAN
* MATRIX.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF ROWS OF THE SPARSE JACOBIAN MATRIX.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  RU  H(N*(N+1)/2)  ELEMENTS OF THE DENSE HESSIAN MATRIX.
*  II  IAG(NA+1)  POSITIONS OF THE FIRST ROWS ELEMENTS IN THE SPARSE
*         JACOBIAN STRUCTURE.
*  II  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE SPARSE JACOBIAN
*         STRUCTURE.
*  RU  HA(N*(N+1)/2)  PACKED HESSIAN MATRIX OF THE SELECTED FUNCTION.
*  II  KA  INDEX OF THE SELECTED FUNCTION (ROW OF THE SPARSE JACOBIAN
*         MATRIX).
*  RI  FACTOR  SCALING FACTOR.
*
      SUBROUTINE UASDH2(N,NA,MA,ME,H,HA,IAG,JAG,KA,FACTOR)
      INTEGER N,NA,MA,ME,IAG(NA+1),JAG(MA),KA
      REAL*8 H(N*(N+1)/2),HA(ME),FACTOR
      INTEGER I,J,IJ,JA,IA,I1,I2,L,IND
      IND(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      L=0
      I1=IAG(KA)
      I2=IAG(KA+1)-1
      DO 6 IA=I1,I2
      I=ABS(JAG(IA))
      DO 5 JA=I1,IA
      J=ABS(JAG(JA))
      IJ=IND(I,J)
      L=L+1
      H(IJ)=H(IJ)+FACTOR*HA(L)
    5 CONTINUE
    6 CONTINUE
      RETURN
      END
