* SUBROUTINE UASET7             ALL SYSTEMS                   07/12/01
C PORTABILITY : ALL SYSTEMS
C 07/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SPARSE STRUCTURE OF THE JACOBIAN IS COMPUTED FROM THE INPUT DATA.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS IN THE SPARSE JACOBIAN MATRIX.
*  IU  IAG(MA+NA)  ON INPUT ROW INDICES OF NONZERO ELEMENTS IN THE FIELD AG.
*          ON OUTPUT POSITIONS OF THE FIRST ROW ELEMENTS IN THE FIELD AG.
*  II  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*
      SUBROUTINE UASET7(NA,MA,IAG,JAG)
      INTEGER NA,MA,IAG(MA+NA),JAG(MA)
      INTEGER I,J,K,L,KA
      CALL UXVSR7(MA,IAG,JAG)
      CALL UXVINS(NA,0,IAG(MA+1))
      DO 1 J=1,MA
      IAG(IAG(J)+MA)=IAG(IAG(J)+MA)+1
    1 CONTINUE
      IAG(1)=1
      DO 2 KA=1,NA
      IAG(KA+1)=IAG(KA)+IAG(KA+MA)
    2 CONTINUE
      I=0
      DO 4 KA=1,NA
      K=IAG(KA)
      L=IAG(KA+1)-K
      CALL UXVSRT(L,JAG(K))
      IAG(KA)=IAG(KA)-I
      DO 3 J=1,L
      IF (J.GT.1.AND.JAG(K).EQ.JAG(K-1)) THEN
      I=I+1
      ELSE
      JAG(K-I)=JAG(K)
      ENDIF
      K=K+1
    3 CONTINUE
    4 CONTINUE
      IAG(NA+1)=IAG(NA+1)-I
      MA=IAG(NA+1)-1
      RETURN
      END
