* SUBROUTINE UASTEP              ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  DETERMINATION OF THE INITIAL STEPSIZE.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  AF(NA)  VECTOR CONTAINING VALUES OF THE APPROXIMATED
*         FUNCTIONS.
*  RO  AFD(NA)  VECTOR CONTAINING INCREMENTS OF THE APPROXIMATED
*         FUNCTIONS.
*  II  IA(NA)  VECTOR CONTAINING TYPES OF DEVIATIONS.
*  RO  R  VALUE OF THE STEPSIZE PARAMETER.
*  RI  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RI  P  VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RI  ETA9  MAXIMUM MACHINE NUMBER.
*
      SUBROUTINE UASTEP(NA,AF,AFD,IA,R,F,P,ETA9)
      INTEGER NA,IA(NA)
      REAL*8 AF(NA),AFD(NA),R,F,P,ETA9
      REAL*8 TEMP
      INTEGER KA
      R=ETA9
      DO 1 KA=1,NA
      IF (IA(KA).EQ.1.OR.IA(KA).GE.3) THEN
      TEMP=P+AFD(KA)
      IF (TEMP.LT.0.0D 0) THEN
      R=MIN(R,-(F+AF(KA))/TEMP)
      ENDIF
      ENDIF
      IF (IA(KA).EQ.2.OR.IA(KA).GE.3) THEN
      TEMP=P-AFD(KA)
      IF (TEMP.LT.0.0D 0) THEN
      R=MIN(R,-(F-AF(KA))/TEMP)
      ENDIF
      ENDIF
    1 CONTINUE
      R=MIN(R,1.0D 0)
      RETURN
      END
