* SUBROUTINE UASVB1             ALL SYSTEMS                   17/12/01
C PORTABILITY : ALL SYSTEMS
C 17/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE GRADIENT OF THE LINEAR APPROXIMATED FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF FUNCTIONS.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  AG(NF*NA)  DENSE JACOBIAN MATRIX.
*  RI  FA  VALUE OF THE SELECTED FUNCTION.
*  RI  GA(NF)  GRADIENT OF THE SELECTED FUNCTION.
*  RU  GO(NF)  VECTOR TRANS(AG)*AF WITH AG FROM PREVIOUS ITERATION.
*  IU  IDECA  DECOMPOSITION INDICATOR. IDECA=0-NO DECOMPOSITION.
*  II  ISNA  SAVING SPECIFICATION. ISNA=0-NO SAVING. ISNA=1-FUNCTION
*         VALUES ARE SAVED. ISNA=2-FUNCTION VALUES AND GRADIENTS ARE
*         SAVED.
*  IU  LDA  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  TI  JASA  STORE OF THE JACOBIAN MATRIX. JASA='R'-ROWWISE.
*            JASA='C'-COLUMNWISE.
*
* COMMON DATA :
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVMUL  MULTIPLICATION OF A VECTOR BY A DIAGONAL MATRIX.
*
      SUBROUTINE UASVB1(NF,NA,KA,XN,AG,FA,GA,GO,IDECA,ISNA,LDA,NORMF,
     & JASA)
      INTEGER NF,NA,KA,IDECA,ISNA,LDA,NORMF
      REAL*8 XN(NF),AG(NF*NA),FA,GA(NF),GO(NF)
      CHARACTER*1 JASA
      INTEGER I,L
      IF (ISNA.LT.2) RETURN
      IF (JASA.EQ.'R') THEN
      CALL UXVDIR(NF,FA,AG((KA-1)*NF+1),GO,GO)
      IF (NORMF.GT.0.AND.ISNA.GT.2) THEN
      CALL UXVMUL(NF,XN,GA,AG((KA-1)*NF+1),1)
      ELSE
      CALL UXVCOP(NF,GA,AG((KA-1)*NF+1))
      ENDIF
      ELSE
      L=0
      IF (NORMF.GT.0.AND.ISNA.GT.2) THEN
      DO 1 I=1,NF
      GO(I)=GO(I)+FA*AG(L+KA)
      AG(L+KA)=XN(I)*GA(I)
      L=L+NA
    1 CONTINUE
      ELSE
      DO 2 I=1,NF
      GO(I)=GO(I)+FA*AG(L+KA)
      AG(L+KA)=GA(I)
      L=L+NA
    2 CONTINUE
      ENDIF
      ENDIF
      IF (KA.EQ.NA) LDA=MAX(LDA,1)
      IDECA=0
      RETURN
      END
