* SUBROUTINE UCCACT             ALL SYSTEMS                 08/12/01
C PORTABILITY : ALL SYSTEMS
C 08/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF ACTIVE CONSTRAINTS.
*
* PARAMETERS :
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCC  NUMBER OF COMPLEMENTRITY CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  IX(NX)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  II  ICC(2*NCC)  VECTOR CONTAINING INDICES OF COMPLEMENTRIRY
*         CONSTRAINTS.
*  IO  ICA(NCA)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  IO  ICCA(NCA)  VECTOR CONTAINING INDICES OF COUPLED COMPLEMENTARITY
*         CONSTRAINTS.
*  IO  ID(NX+NC+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD D.
*  IO  JD(2*(NX+NC))  COLUMN INDICES OF ELEMENTS IN THE FIELD D.
*  IO  IER  ERROR INDICATOR. IER=0-NO ERROR. IER=1-TWO-SIDE BOUND
*         OCCURED. IER=2-TWO-SIDE CONSTRAINT OCCURED. IER=3-EQUALITY
*         IN COMPLEMENTARITY CONSTRAINT OCCURED. IER=4-COUPLED
*         COMPLEMENTARITY CONSTRAINT IS MISSING.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*  IO  ITERM  TERMINATION INDICATOR.
*
      SUBROUTINE UCCACT(NX,NC,NCC,NCA,IX,IC,ICC,ICA,ICCA,ID,JD)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER NX,NC,NCC,NCA,IX(NX),IC(NC),ICC(2*NCC),ICA(NX+NC),
     & ICCA(NX+NC),ID(NX+NC+1),JD(2*(NX+NC))
      INTEGER I,K,L,MM
      MM=0
      CALL UXVINS(NX+NC,0,ID)
      DO 2 I=1,NCC
      DO 1 L=1,2
      K=ICC((L-1)*NCC+I)
      IF (K.LT.0) THEN
      ID(-K)=I
      ELSE
      ID(NX+K)=I
      ENDIF
      MM=MM+NCC
    1 CONTINUE
    2 CONTINUE
      NCA=0
      IF (KBF.GT.0) THEN
      DO 3 K=1,NX
      IF (IX(K).GE.1.AND.IX(K).LE.4) THEN
      NCA=NCA+1
      ICA(NCA)=-K
      IX(K)=-IX(K)
      ICCA(NCA)=ID(K)
      ENDIF
    3 CONTINUE
      ENDIF
      IF (KBC.GT.0) THEN
      DO 4 K=1,NC
      IF (IC(K).GE.1.AND.IC(K).LE.4) THEN
      NCA=NCA+1
      ICA(NCA)=K
      IC(K)=-IC(K)
      ICCA(NCA)=ID(NX+K)
      ELSE IF (IC(K).EQ.5) THEN
      IF (ID(NX+K).EQ.0) THEN
      NCA=NCA+1
      ICA(NCA)=K
      IC(K)=-IC(K)
      ICCA(NCA)=0
      ENDIF
      ENDIF
    4 CONTINUE
      ENDIF
      MM=1
      ID(1)=MM
      DO 7 K=1,NCA
      JD(MM)=K
      MM=MM+1
      IF (ICCA(K).LT.0) THEN
      ICCA(K)=-ICCA(K)
      ELSE IF (ICCA(K).GT.0) THEN
      DO 5 L=K+1,NCA
      IF (ICCA(L).EQ.ICCA(K)) THEN
      ICCA(K)= L
      ICCA(L)=-K
      JD(MM)=L
      MM=MM+1
      GO TO 6
      ENDIF
    5 CONTINUE
      ENDIF
    6 ID(K+1)=MM
    7 CONTINUE
      RETURN
      END
