* SUBROUTINE UCCSS2             ALL SYSTEMS                   08/12/01
C PORTABILITY : ALL SYSTEMS
C 08/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE SPARSE SCHUR COMPLEMENT STRUCTURE FOR THE
* KARUSH-KUHN-TUCKER MATRIX WITH THE UNIT HESSIAN BLOCK.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINT FUNCTIONS.
*  II  MC  NUMBER OF NONZERO ELEMENTS IN THE FIELD CG.
*  II  NCC  NUMBER OF COMPLEMENTARITY CONSTRAINTS.
*  II  ICC(2*NCC)  VECTOR CONTAINING INDICES OF COMPLEMENTRIRY
*         CONSTRAINTS.
*  II  ICG(NC+NCC+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE
*         FIELD CG.
*  II  JCG(MC)  COLUMN INDICES OF ELEMENTS IN THE FIELD CG.
*  II  JOB  TYPE OF THE JACOBIAN MATRIX. JOB=0-STANDARD JACOBIAN
*         MATRIX. JOB=1-JACOBIAN MATRIX WITH THE MINIMAX ROW.
*
      SUBROUTINE UCCSS2(NF,NC,MC,NCC,ICC,ICG,JCG,JOB)
      INTEGER NF,NC,MC,NCC,ICC(2*NCC),ICG(NC+NCC+1),JCG(*),JOB
      INTEGER I,K,KK,KSTRT,KSTOP,L,LL,LSTRT,LSTOP,MM,IPOM
      MM=ICG(NC+1)
      DO 3 I=1,NCC
      K=ICC(I)
      L=ICC(NCC+I)
      IF (K.GT.0.AND.L.LT.0) THEN
      KK=K
      K=L
      L=KK
      ENDIF
      IF (K.LT.0) THEN
      K=-K
      IF (L.LT.0) THEN
      L=-L
      JCG(MM)=MIN(K,L)
      JCG(MM+1)=MAX(K,L)
      MM=MM+2
      ELSE
      LSTRT=ICG(L)
      LSTOP=ICG(L+1)-1
      IPOM=0
      DO 1 LL=LSTRT,LSTOP
      IF (JCG(LL).GT.K.AND.IPOM.EQ.0) THEN
      JCG(MM)=K
      MM=MM+1
      IPOM=1
      ELSE IF (JCG(LL).EQ.K) THEN
      IPOM=1
      ENDIF
      JCG(MM)=JCG(LL)
      MM=MM+1
    1 CONTINUE
      ENDIF
      ELSE
      KSTRT=ICG(K)
      KSTOP=ICG(K+1)-1
      LSTRT=ICG(L)
      LSTOP=ICG(L+1)-1
      KK=KSTRT
      LL=LSTRT
    2 CONTINUE
      IF (KK.LE.KSTOP) THEN
      IF (LL.GT.LSTOP) THEN
      JCG(MM)=JCG(KK)
      KK=KK+1
      MM=MM+1
      GO TO 2
      ELSE IF (JCG(KK).LT.JCG(LL)) THEN
      JCG(MM)=JCG(KK)
      KK=KK+1
      MM=MM+1
      GO TO 2
      ELSE IF (JCG(KK).EQ.JCG(LL)) THEN
      JCG(MM)=JCG(KK)
      KK=KK+1
      LL=LL+1
      MM=MM+1
      GO TO 2
      ENDIF
      ELSE IF (LL.LE.LSTOP) THEN
      IF (KK.GT.KSTOP) THEN
      JCG(MM)=JCG(LL)
      LL=LL+1
      MM=MM+1
      GO TO 2
      ELSE IF (JCG(LL).LT.JCG(KK)) THEN
      JCG(MM)=JCG(LL)
      LL=LL+1
      MM=MM+1
      GO TO 2
      ENDIF
      ENDIF
      ENDIF
      IF (JOB.GT.0) THEN
      JCG(MM)=NF+1
      MM=MM+1
      ENDIF
      ICG(NC+I+1)=MM
    3 CONTINUE
      MC=MM-1
      RETURN
      END
