* SUBROUTINE UCIRES             ALL SYSTEMS                 11/12/01
C PORTABILITY : ALL SYSTEMS
C 11/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* ACTIVE CONSTRAINT PART OF RIGHT HAND SIDE VECTOR.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NX)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NX)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NX)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  XZL(NX)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NX)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  RI  G(NF)  GRADIENT OF THE LAGRANGIAN FUNCTION.
*  RI  RPF3  BARRIER COEFFICIENT.
*  RO  SIG  SQUARED NORM OF THE KKT RESIDUAL VECTOR.
*  II  JOB  CHOICE OF THE IP FORMULATION. JOB=1-PRIMAL FORMULATION.
*         JOB=2-PRIMAL-DUAL FORMULATION.
*
      SUBROUTINE UCIRES(NF,NX,NC,X,IX,XL,XU,XSL,XSU,XZL,XZU,CF,IC,
     & CL,CU,CSL,CSU,CZL,CZU,G,RPF3,SIG,JOB)
      INTEGER NF,NX,NC,IX(NX),IC(NC),JOB
      REAL*8 X(NF),XL(NX),XU(NX),XSL(NX),XSU(NX),XZL(NX),XZU(NX),CF(NC),
     & CL(NC),CU(NC),CSL(NC),CSU(NC),CZL(NC),CZU(NC),G(NF),RPF3,SIG
      INTEGER I,K,KC
      REAL*8 UXVDOT
      SIG=UXVDOT(NF,G,G)
      DO 1 I=1,NX
      K=ABS(IX(I))
      IF (K.EQ.1.OR.K.EQ.3) THEN
      IF (JOB.EQ.1) THEN
      SIG=SIG+(XZL(I)-RPF3/XSL(I))**2
      ELSE
      SIG=SIG+(XSL(I)*XZL(I)-RPF3)**2
      ENDIF
      SIG=SIG+(XL(I)-X(I)+XSL(I))**2
      ENDIF
      IF (K.EQ.2.OR.K.EQ.4) THEN
      IF (JOB.EQ.1) THEN
      SIG=SIG+(XZU(I)-RPF3/XSU(I))**2
      ELSE
      SIG=SIG+(XSU(I)*XZU(I)-RPF3)**2
      ENDIF
      SIG=SIG+(XU(I)-X(I)+XSU(I))**2
      ENDIF
    1 CONTINUE
      DO 2 KC=1,NC
      K=ABS(IC(KC))
      IF (K.EQ.1.OR.K.EQ.3) THEN
      IF (JOB.EQ.1) THEN
      SIG=SIG+(CZL(KC)-RPF3/CSL(KC))**2
      ELSE
      SIG=SIG+(CSL(KC)*CZL(KC)-RPF3)**2
      ENDIF
      SIG=SIG+(CL(KC)-CF(KC)+CSL(KC))**2
      ENDIF
      IF (K.EQ.2.OR.K.EQ.4) THEN
      IF (JOB.EQ.1) THEN
      SIG=SIG+(CZU(KC)-RPF3/CSU(KC))**2
      ELSE
      SIG=SIG+(CSU(KC)*CZU(KC)-RPF3)**2
      ENDIF
      SIG=SIG+(CU(KC)-CF(KC)+CSU(KC))**2
      ENDIF
      IF (K.EQ.5) THEN
      SIG=SIG+CF(KC)**2
      ENDIF
    2 CONTINUE
      SIG=SQRT(SIG)
      RETURN
      END
