* SUBROUTINE UCMAXD              ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  DETERMINATION OF THE INITIAL STEPSIZE.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NC  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF THE CONSTRAINT
*         FUNCTIONS.
*  RO  CFD(NC+1)  VECTOR CONTAINING INCREMENTS OF THE CONSTRAINT
*         FUNCTIONS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CG(NF*MCL)  MATRIX WHOSE COLUMNS ARE GRADIENTS OF THE LINEAR
*          CONSTRAINT FUNCTIONS.
*  RI  CP(NC)  VECTOR CONTAINING PENALTY PARAMETERS.
*  RI  S(NF)  DIRECTION VECTOR.
*  RA  PAR  AUXILIARY VARIABLE.
*
* SUBPROGRAMS USED.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*
      SUBROUTINE UCMAXD(NF,NC,CF,CFD,IC,CL,CU,CG,CP,S,PAR)
      INTEGER NF,NC,IC(NC)
      REAL*8 CF(NC+1),CFD(NC+1),CL(NC),CU(NC),CG(NF*NC),CP(NC),S(NF),PAR
      REAL*8 POM,DER,UXVDOT
      INTEGER JCG,K,KC
      PAR=CFD(NC+1)
      JCG=1
      DO 1 KC=1,NC
      IF (IC(KC).NE.0) THEN
      POM=CF(KC)
      K=ABS(IC(KC))
      IF (IC(KC).GT.0) THEN
      DER=CFD(KC)
      ELSE
      DER=UXVDOT(NF,CG(JCG),S)
      CFD(KC)=DER
      ENDIF
      IF (K.EQ.1.OR.K.GE.3) THEN
      IF (0.0D 0.GT.CF(KC)-CL(KC)) THEN
      PAR=PAR-CP(KC)*DER
      ENDIF
      ENDIF
      IF (K.EQ.2.OR.K.GE.3) THEN
      IF (0.0D 0.LT.CF(KC)-CU(KC)) THEN
      PAR=PAR+CP(KC)*DER
      ENDIF
      ENDIF
      ENDIF
      JCG=JCG+NF
    1 CONTINUE
      RETURN
      END
