* SUBROUTINE UCMAXS              ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  DETERMINATION OF THE INITIAL STEPSIZE.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NC  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MC  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT
*         FUNCTIONS.
*  RO  CFD(NC)  VECTOR CONTAINING INCREMENTS OF THE CONSTRAINT
*         FUNCTIONS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CG(MC)  SPARSE JACOBIAN MATRIX.
*  II  ICG(NC+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD CG.
*  II  JCG(MC) COLUMN INDICES OF ELEMENTS IN THE FIELD CG.
*  RI  CP(NC)  VECTOR CONTAINING PENALTY PARAMETERS.
*  RI  S(NF)  DIRECTION VECTOR.
*  RA  PAR  AUXILIARY VARIABLE.
*
*
      SUBROUTINE UCMAXS(NF,NC,MC,CF,CFD,IC,CL,CU,CG,ICG,JCG,CP,S,PAR)
      INTEGER NF,NC,MC,IC(NC),ICG(NC+1),JCG(MC)
      REAL*8 CF(NC),CFD(NC),CL(NC),CU(NC),CG(MC),CP(NC),S(NF),PAR
      REAL*8 POM,DER
      INTEGER I,J,K,L,JP,KC
      PAR=CFD(NC+1)
      DO 2 KC=1,NC
      I=ICG(KC)
      L=ICG(KC+1)-I
      IF (IC(KC).NE.0) THEN
      POM=CF(KC)
      K=ABS(IC(KC))
      IF (IC(KC).GT.0) THEN
      DER=CFD(KC)
      ELSE
      DER=0.0D 0
      DO 1 J=1,L
      JP=JCG(I)
      DER=DER+CG(I)*S(JP)
      I=I+1
    1 CONTINUE
      CFD(KC)=DER
      ENDIF
      IF (K.EQ.1.OR.K.GE.3) THEN
      IF (0.0D 0.GT.CF(KC)-CL(KC)) THEN
      PAR=PAR-CP(KC)*DER
      ENDIF
      ENDIF
      IF (K.EQ.2.OR.K.GE.3) THEN
      IF (0.0D 0.LT.CF(KC)-CU(KC)) THEN
      PAR=PAR+CP(KC)*DER
      ENDIF
      ENDIF
      ENDIF
    2 CONTINUE
      RETURN
      END
