* SUBROUTINE UCSVF2             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* FORMULATION OF THE MINIMAX APPROXIMATION PROBLEM FROM THE NONLINEAR
* PROGRAMMING PROBLEM. GRADIENTS.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINTS.
*  IA  KC  INDEX OF THE CONSTRAINT.
*  IA  KCP  AUXILIARY VARIABLE.
*  IA  KA  INDEX OF THE AUXILIARY FUNCTION.
*  RI  AF(2*NC+1)  VECTOR CONTAINING VALUES OF THE APPROXIMATED
*         FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  FF  VALUE OF THE MODEL FUNCTION.
*  RI  FC  VALUE OF THE CONSTRAINT FUNCTION.
*  RO  CMAX  MAXIMUM CONSTRAINT VIOLATION.
*  RI  RPF1  PENALTY COEFFICIENT.
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*
      SUBROUTINE UCSVF2(NC,KC,KCP,KA,AF,IC,CL,CU,FF,FC,CMAX,RPF1,IEXT)
      INTEGER NC,KC,KCP,KA,IC(NC),IEXT
      REAL*8 AF(2*NC+1),CL(NC),CU(NC),FF,FC,CMAX,RPF1
      IF (KC.EQ.0) THEN
      IF (IEXT.LE.0) THEN
      AF(1)= FF
      ELSE
      AF(1)=-FF
      ENDIF
      CMAX=0.0D 0
      KCP=1
      ELSE
      IF (IC(KC).LE.0) THEN
      ELSE IF (IC(KC).EQ.1) THEN
      AF(KA+1)=AF(1)+RPF1*(CL(KC)-FC)
      CMAX=MAX(CMAX,CL(KC)-FC)
      KCP=KA+1
      ELSE IF (IC(KC).EQ.2) THEN
      AF(KA+1)=AF(1)+RPF1*(FC-CU(KC))
      CMAX=MAX(CMAX,FC-CU(KC))
      KCP=KA+1
      ELSE
      AF(KA+1)=AF(1)+RPF1*(CL(KC)-FC)
      AF(KA+2)=AF(1)+RPF1*(FC-CU(KC))
      CMAX=MAX(CMAX,CL(KC)-FC)
      CMAX=MAX(CMAX,FC-CU(KC))
      KCP=KA+2
      ENDIF
      ENDIF
      RETURN
      END
