* SUBROUTINE UCSVG2             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* FORMULATION OF THE MINIMAX APPROXIMATION PROBLEM FROM THE NONLINEAR
* PROGRAMMING PROBLEM. GRADIENTS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  IA  KC  INDEX OF THE CONSTRAINT.
*  IA  KCP  AUXILIARY VARIABLE.
*  IA  KA  INDEX OF THE AUXILIARY FUNCTION.
*  RO  AG(NF*(2*NC+1))  MATRIX WHOSE COLUMNS ARE GRADIENTS OF THE LINEAR
*          APPROXIMATED FUNCTIONS.
*  RI  GF  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  GC  GRADIENT OF THE CONSTRAINT.
*  RI  RPF1  PENALTY COEFFICIENT.
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*
      SUBROUTINE UCSVG2(NF,NC,KC,KCP,KA,AG,IC,GF,GC,RPF1,IEXT)
      INTEGER NF,NC,KC,KCP,KA,IC(NC),IEXT
      REAL*8 AG(NF*(2*NC+1)),GF(NF),GC(NF),RPF1
      IF (KC.EQ.0) THEN
      IF (IEXT.LE.0) THEN
      CALL UXVCOP(NF,GF,AG)
      ELSE
      CALL UXVNEG(NF,GF,AG)
      ENDIF
      KCP=1
      ELSE
      IF (IC(KC).LE.0) THEN
      ELSE IF (IC(KC).EQ.1) THEN
      CALL UXVDIR(NF,-RPF1,GC,AG,AG(KA*NF+1))
      KCP=KA+1
      ELSE IF (IC(KC).EQ.2) THEN
      CALL UXVDIR(NF, RPF1,GC,AG,AG(KA*NF+1))
      KCP=KA+1
      ELSE
      CALL UXVDIR(NF,-RPF1,GC,AG,AG(KA*NF+1))
      CALL UXVDIR(NF, RPF1,GC,AG,AG((KA+1)*NF+1))
      KCP=KA+2
      ENDIF
      ENDIF
      RETURN
      END
