* SUBROUTINE UE2DQ1             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION
* WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  MEL  ACTUAL NUMBER OF DIFFERENTIAL EQUATIONS.
*  IU  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*  II  M
*  RU  GE(NF)  GRADIENT OF THE RIGHT HAND SIDE FUNCTION.
*  RU  DE(NF)  DERIVATIVES OF THE RIGHT HAND SIDE FUNCTION.
*  RI  YA(MEL)  SOLUTION VECTOR.
*  RO  EF(MEL)  RIGHT HAND SIDE VECTOR.
*  RI  FE  VALUE OF THE RIGHT HAND SIDE FUNCTION.
*  RI  WE  WEIGHT COEFFICIENT.
*  RI  YE  REQUIRED VALUE OF THE RIGHT HAND SIDE FUNCTION.
*
* COMMON DATA :
*  II  KD  ORDER OF REQUIRED DERIVATIVES.
*  II  KDA  ORDER OF ANALYTICALLY COMPUTED DERIVATIVES.
*  II  KDE  ORDER OF ANALYTICALLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*  S  UXDCMD  MATRIX-VECTOR PRODUCT AUGMENTED BY SCALED VECTOR.
*  S  UXDCMM  MATRIX-VECTOR PRODUCT.
*  S  UXDSMU  RANK ONE UPDATE OF THE MATRIX.
*  S  UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  S  UXVSET  INITIATION OF A VECTOR.
*
      SUBROUTINE UE2DQ1(NF,NE,MEL,KE,M,GE,DE,YA,EF,FE,WE,YE)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER NF,NE,MEL,KE,M
      REAL*8 GE(NF),DE(NE),YA(MEL),EF(MEL),FE,WE,YE
      INTEGER L,N2,N3
      SAVE L,N2,N3
      IF (TSS(NS).NE.'UEXX') CALL UYPRO1('UEXX',-1)
      GO TO (1,5) ISP(NS)
    1 CONTINUE
      IF (KD.LE.0) THEN
      N2=NE
      ELSE
      N2=NE*(NF+1)
      ENDIF
      IF (KDA.GE.0) THEN
      EF(N2+1)=ZERO
      IF (KD.GT.0) CALL UXVSET(NF,ZERO,EF(N2+2))
      IF (KD.GT.1) THEN
      N3=N2+NF+1
      CALL UXVSET(M,ZERO,EF(N3+1))
      ENDIF
      ENDIF
      KE=1
      IF (KD.GT.0) L=NE+1
    4 IF (KE.GT.NE) GO TO 6
      CALL UYSET0(1,2)
      RETURN
    5 CONTINUE
      EF(KE)=FE
      IF (KDA.GE.0) EF(N2+1)=EF(N2+1)+HALF*WE*(YA(KE)-YE)**2
      IF (KD.GT.0) THEN
      IF (KDA.GE.0) CALL UXVDIR(NF,WE*(YA(KE)-YE),YA(L),EF(N2+2),
     & EF(N2+2))
      IF (KDE.LE.0) THEN
      CALL UXDCMM(NF,NE,YA(NE+1),DE,EF(L))
      ELSE
      CALL UXDCMD(NF,NE,YA(NE+1),DE,ONE,GE,EF(L))
      ENDIF
      IF (KD.GT.1.AND.KDA.GE.0) CALL UXDSMU(NF,EF(N3+1),WE,YA(L))
      L=L+NF
      ENDIF
      KE=KE+1
      GO TO 4
    6 CALL UYEPI1(-1)
      RETURN
      END
