* SUBROUTINE UFSET5             ALL SYSTEMS                   05/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE SPARSE STRUCTURE OF THE HESSIAN MATRIX FROM THE
* SPARSE STRUCTURE OF THE JACOBIAN MATRIX.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIADLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS IN THE FIELD CG.
*  II  M  NUMBER OF NONZERO ELEMENTS IN THE FIELD H.
*  II  MMAX DECLARED LENGTH OF THE ARRAYS JH,H.
*  RI  H  FIELD CONTAINING NONZERO ELEMENTS OF THE HESSIAN MATRIX.
*  IO  IH(NF+1)  POINTERS OF THE DIAGONAL ELEMENTS OF H.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF H.
*  II  ICG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD CG.
*  II  JCG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD CG.
*  IO  ITERM  CAUSE OF TERMINATION.
*
      SUBROUTINE UFSET5(NF,NC,MC,M,MMAX,H,IH,JH,ICG,JCG,ITERM)
      INTEGER NF,NC,MC,M,MMAX,IH(NF+1),JH(MMAX),ICG(NC+1),JCG(MC),
     & ITERM
      REAL*8 H(MMAX)
      INTEGER I,J,JF,JC,K,LF,LC,KC
      M=IH(NF+1)-1
      IF (M.GT.MMAX) THEN
      ITERM=-104
      CALL UOERR1('UFSET5',104)
      RETURN
      ENDIF
      DO 7 KC=1,NC
      LC=ICG(KC+1)-1
      DO 6 K=ICG(KC),LC
      I=JCG(K)
      JF=IH(I)
      LF=IH(I+1)-1
      DO 5 JC=K,LC
      J=JCG(JC)
    2 IF (JH(JF).LT.J.AND.JF.LE.LF) THEN
      JF=JF+1
      IF (JF.LE.LF) GO TO 2
      ENDIF
      IF (JH(JF).GT.J .OR.JF.GT.LF) THEN
      DO 3 J=I+1,NF+1
      IH(J)=IH(J)+1
    3 CONTINUE
      DO 4 J=M,JF,-1
      JH(J+1)=JH(J)
      H(J+1)=H(J)
    4 CONTINUE
      H(JF)=0.0D 0
      JH(JF)=JCG(JC)
      JF=JF+1
      LF=LF+1
      M=M+1
      IF (M.GT.MMAX) THEN
      ITERM=-104
      CALL UOERR1('UFSET5',104)
      RETURN
      ENDIF
      ENDIF
    5 CONTINUE
    6 CONTINUE
    7 CONTINUE
      RETURN
      END
