* SUBROUTINE UFSEX4             ALL SYSTEMS                   05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE SPARSE HESSIAN MATRIX FROM THE PARTITIONED HESSIAN
* MATRIX.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIADLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  II  MB  NUMBER OF NONZERO ELEMENTS OF THE PARTITIONED HESSIAN MATRIX.
*  IO  M  NUMBER OF NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  RU  B(M)  ELEMENTS OF THE SPARSE MATRIX B.
*  IO  IH(NF+1)  POINTERS OF THE DIAGONAL ELEMENTS OF B.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF B.
*  II  AH(MB)  ELEMENTS OF THE PARTITIONED MATRIX H.
*  II  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  II  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  RI  AFU(NA)  VECTOR OF LAGRANGE MULTIPLIERS.
*
      SUBROUTINE UFSEX4(NF,NA,MA,MB,M,B,IH,JH,AH,IAG,JAG,AZL,AZU,IEXT)
      INTEGER NF,NA,MA,MB,M,IH(NF+1),JH(M),IAG(NA+1),JAG(MA),IEXT
      REAL*8 B(M),AH(MB),AZL(NA),AZU(NA)
      INTEGER I,II,IA,J,JJ,JA,JF,K,KK,L,KA
      KK=0
      DO 7 KA=1,NA
      II=IAG(KA)
      L=IAG(KA+1)-II
      DO 6 IA=1,L
      KK=KK+IA
      I=JAG(II)
      IF (I.LE.0) GO TO 5
      JF=IH(I)
      JJ=II
      K=KK
      DO 4 JA=IA,L
      J=JAG(JJ)
      IF (J.LE.0) GO TO 3
    2 IF (JH(JF).LT.J) THEN
      JF=JF+1
      GO TO 2
      ENDIF
      IF (IEXT.EQ.0) THEN
      B(JF)=B(JF)+(AZU(KA)-AZL(KA))*AH(K)
      ELSE IF (IEXT.LT.0) THEN
      B(JF)=B(JF)+AZU(KA)*AH(K)
      ELSE IF (IEXT.LT.0) THEN
      B(JF)=B(JF)-AZL(KA)*AH(K)
      ENDIF
    3 K=K+JA
      JJ=JJ+1
    4 CONTINUE
    5 II=II+1
    6 CONTINUE
    7 CONTINUE
      RETURN
      END
