* SUBROUTINE UKMAI1                 ALL SYSTEMS                99/06/01
C PORTABILITY : ALL SYSTEMS
C 99/06/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INPUT OF THE JACOBIAN MATRIX ELEMENT AG(KA,I)
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF FUNCTIONS.
*  IU  IAG(NA+1) VECTOR POINTING AT BEGINNINGS OF THE JACOBIAN MATRIX
*         ROWS.
*  IU  JAG(MA) JACOBIAN MATRIX COLUMN INDICES.
*  RU  AG(MA) JACOBIAN MATRIX VALUES.
*  II  JOB  OPTION. JOB=0-NUMERICAL VALUE IS NOT INSERTED.
*  IO  IER OUTPUT ERROR INFORMATION.
*  II  K  INPUT ROW INDEX.
*  II  I  INPUT COLUMN INDEX.
*  RI  VAL  INPUT NUMERICAL VALUE.
*
      SUBROUTINE UKMAI1(NF,NA,IAG,JAG,AG,JOB,IER,K,I,VAL)
      INTEGER NF,NA,IAG(NA+1),JAG(*),JOB,IER,K,I
      REAL*8 AG(*),VAL
      INTEGER J,L
      IER=0
      IF (I.LE.0.OR.I.GT.NF) IER=2
      IF (K.LE.0.OR.K.GT.NA) IER=3
      IF (IER.NE.0) RETURN
      L=IAG(K+1)
      DO 1 J=IAG(K),L-1
      IF (JAG(J).EQ.I) THEN
      IF (JOB.NE.0) AG(J)=VAL
      IER=1
      RETURN
      ELSE IF (JAG(J).GT.I) THEN
      L=J
      GO TO 2
      ENDIF
    1 CONTINUE
    2 DO 3 J=IAG(NA+1)-1,L,-1
      JAG(J+1)=JAG(J)
      IF (JOB.NE.0) AG(J+1)=AG(J)
    3 CONTINUE
      JAG(L)=I
      IF (JOB.NE.0) AG(L)=VAL
      DO 4 J=K+1,NA+1
      IAG(J)=IAG(J)+1
    4 CONTINUE
      RETURN
      END
