* SUBROUTINE ULATGB               ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* GRADIENT OF THE OBJECTIVE FUNCTION IS PREMULTIPLIED BY TRANSPOSE
* OF THE MATRIX WHOSE COLUMNS ARE NORMALS OF CURRENT ACTIVE CONSTRAINTS.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CURRENT LINEAR CONSTRAINTS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  II  ICA(NF)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  CG(NF*NC)  MATRIX WHOSE COLUMNS ARE NORMALS OF THE LINEAR
*         CONSTRAINTS.
*  RO  S(NF)  OUTPUT VECTOR.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RA  GN(NF)  AUXILIARY VECTOR.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*  S   UXVMUL  DIAGONAL PREMULTIPLICATION OF A VECTOR.
*
      SUBROUTINE ULATGB(NF,N,NC,XN,ICA,CG,S,G,GN,NORMF)
      INTEGER NF,N,NC,ICA(NF),NORMF
      REAL*8 XN(NF),CG(NF*NC),S(NF),G(NF),GN(NF)
      REAL*8 UXVDOT
      INTEGER NCA,I,J,K
      IF (N.EQ.NF) RETURN
      NCA=NF-N
      IF (NORMF.GT.0) THEN
      CALL UXVMUL(NF,XN,G,GN,1)
      ELSE
      CALL UXVCOP(NF,G,GN)
      ENDIF
      DO 1 J=1,NCA
      K=ICA(J)
      IF (K.GT.0) THEN
      S(J)=UXVDOT(NF,CG((K-1)*NF+1),GN)
      ELSE
      I=-K
      S(J)=GN(I)
      ENDIF
    1 CONTINUE
      RETURN
      END
