* SUBROUTINE ULMINT             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE NEW ACTIVE TRUST REGION BOUND.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  XO(NF)  SAVED VECTOR OF VARIABLES.
*  RI  S(NF)  DIRECTION VECTOR.
*  RU  XDEL  TRUST REGION BOUND.
*  RI  EPS9  TOLERANCE FOR ACTIVE CONSTRAINTS.
*  RA  PAR  AUXILIARY VARIABLE.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  IO  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*  IO  KNEW  SIGNUM OF THE NEW NORMAL.
*
      SUBROUTINE ULMINT(NF,IX,XN,XO,S,XDEL,EPS9,PAR,NORMF,INEW,KNEW)
      INTEGER NF,IX(NF),NORMF,INEW,KNEW
      REAL*8 XN(NF),XO(NF),S(NF),XDEL,EPS9,PAR
      REAL*8 POM,TEMP
      INTEGER I
      DO 1 I=1,NF
      IF(IX(I).GE.0) THEN
      TEMP=1.0D 0
      IF (NORMF.GT.0) TEMP=XN(I)
      POM=(S(I)+XDEL)*TEMP
      IF (POM.LT.MIN(PAR,-EPS9*MAX(ABS(XO(I)),TEMP))) THEN
      INEW=-I
      KNEW= 2
      PAR=POM
      ENDIF
      POM=(XDEL-S(I))*TEMP
      IF (POM.LT.MIN(PAR,-EPS9*MAX(ABS(XO(I)),TEMP))) THEN
      INEW=-I
      KNEW=-2
      PAR=POM
      ENDIF
      ENDIF
    1 CONTINUE
      RETURN
      END
