C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* ROOT OF THE NONLINEAR EQUATION (S/B)*((S+C)/B)**(P-1) = 1.
*
* PARAMETERS :
*  RI  C  INPUT PARAMETER.
*  RO  S  COMPUTED SOLUTION POINT.
*  RI  P  REAL PARAMETER.
*  RI  B  REAL PARAMETER.
*  RI  TOL  REQUIRED PRECISION FOR THE NONLINEAR FUNCTION.
*  IO  IE  ERROR SPECIFICATION.
*
      SUBROUTINE UNLAG6(C,S,P,B,TOL,IE)
      INTEGER IE
      REAL*8 C,S,P,B,TOL
      INTEGER I
      REAL*8 X,R,W,F
      IF (C.LT.0.0D 0) THEN
      R=1.0D 0/(P-1.0D 0)
      W=-C/B
      ELSE
      R=P-1.0D 0
      W= C/B
      ENDIF
      IF (ABS(W).LT.1.0D 0) THEN
      X=1.0D 0
      ELSE
      X=1.0D 0/W**R
      ENDIF
      DO 1 I=1,10
      F=1.0D 0-X*(W+X)**R
      IF (ABS(F).LE.TOL) THEN
      IE= 0
      GO TO 2
      ENDIF
      X=X-((W+X)/(W+X+R*X))*(X-1.0D 0/(W+X)**R)
    1 CONTINUE
      IE=-1
    2 S=B*X
      RETURN
      END
