* SUBROUTINE UO1FM2                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL VISUALIZATION OF THE FINAL RESULTS.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RO  AF(NA)  VECTOR CONTAINING EITHER VALUES OF APPROXIMATED
*         FUNCTIONS OR COMPUTED SOLUTIONS OF DIFFERENTIAL EQUATIONS.
*  RI  AM(NA)  VECTOR CONTAINING REQUIRED VALUES OF APPROXIMATED
*         FUNCTIONS.
*  II  IA(NA)  VECTOR CONTAINING TYPES OF DEVIATIONS.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  AT(NA)  VECTOR CONTAINING MESH POINTS.
*  NGR  NUMBER OF NODES FOR THE COLOR MAP.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS.
*  II  KBA  SPECIFICATION OF DEVIATIONS.
*  II  KBC  SPECIFICATION OF GENERAL CONSTRAINTS.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
      SUBROUTINE UO1FM2(NF,NA,NAL,MAL,NC,NCL,MCL,NE,X,XL,XU,IX,AF,AM,
     & CF,CL,CU,IC,AT,EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,
     & EPS8,EPS9,ETA0,ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,
     & ALF1,ALF2,ALF3,BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,
     & F,FMIN,FMAX,DMAX,GMAX,XMAX,XDEL,RPF1,RPF2,RPF3,RPF4,RPF5,
     & MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
     & MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
     & MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
     & MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
     & KSF,KCF,KSA,KCA,KSC,KCC,KTERS,INITD,INITS,INITH,IREM,IADD,
     & MRED,IRES1,IRES2,XPA,FPA,JOB)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER IGR,JGR,KGR,NGR,NPH,IMIN,JMIN,KMIN,ICOLOR,IRET,
     & IMAP,IHIL,ICON,IPA,NPA,IGCOM(4),LLC(28)
      COMMON /UMGRFI/ IGR,JGR,KGR,NGR,NPH,IMIN,JMIN,KMIN,ICOLOR,IRET,
     & IMAP,IHIL,ICON,IPA,NPA,IGCOM,LLC
      REAL*8 XLIGR,XUIGR,XLJGR,XUJGR,VALMIN,VALMAX,XIGR,XJGR,RGCOM(2)
      COMMON /UMGRFR/ XLIGR,XUIGR,XLJGR,XUJGR,VALMIN,VALMAX,XIGR,XJGR,
     & RGCOM
      INTEGER NF,NA,NAL,MAL,NC,NCL,MCL,NE,IX(NF),IC(NC),
     & MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
     & MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
     & MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
     & MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
     & KSF,KCF,KSA,KCA,KSC,KCC,KTERS,INITD,INITS,INITH,IREM,IADD,
     & MRED,IRES1,IRES2,JOB
      REAL*8 X(NF),XL(NF),XU(NF),AF(*),AM(NA),CF(NC),CL(NC),CU(NC),
     & AT(NA),EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,ETA0,
     & ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,ALF1,ALF2,ALF3,
     & BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,F,FMIN,FMAX,DMAX,
     & GMAX,XMAX,XDEL,RPF1,RPF2,RPF3,RPF4,RPF5,FPA(NPA),YPA(3*NPA)
      REAL*4 XPA(NPA,*)
      INTEGER NED,IG,JG,KG,NPAC,IGRP,JGRP,INFO,STA,STO,I,J,MENU(20),GFMT
      SAVE NPAC,IGRP,JGRP,MENU,TEXT
      CHARACTER*30 TEXT(20)
      CHARACTER WHAT
      LOGICAL VYPISF(3)
C
      IF (NS.EQ.0) NS=1
      IF (TSS(NS).NE.'UOXX') CALL UYPRO1('UOXX',-1)
      GO TO (10,1,1) ISP(NS)
   10 CONTINUE
      NPAC=MIN(NPA,NIT)
      IF (JOB.EQ.1) THEN
        IGRP=IGR
        JGRP=JGR
      ENDIF
      TEXT(1) = 'V = VARIABLES'
      TEXT(2) = 'A = APPROXIMATIONS'
      TEXT(3) = 'C = CONSTRAINTS'
      TEXT(4) = 'S = ISOLINES/MAP/SURFACE'
      TEXT(5) = 'P = PATH WITH ISOLINES/MAP'
      TEXT(6) = 'X = PATH OF VARIABLES'
      TEXT(7) = 'F = PATH OF FUNCTION VALUES'
      TEXT(11)= 'T = 1D TRAJECTORY'
      TEXT(12)= 'O = 2D ORBIT'
      TEXT(13)= 'P = 3D PICTURE'
      TEXT(15)= 'R = OPTIONS'
      TEXT(19)= 'N = NEW INDEXES'   ! FOR DIFFERENTIAL EQUATIONS
      TEXT(20)= 'E = EXIT'
      DO I=1,20
        MENU(I)=0
      ENDDO
C     DEFINITION OF POSSIBLE GRAPHICS: MENU(.)=1
C     TEXT(I) IS DISPLAYED ON THE SCREEN IF MENU(I)=1
      IF (NF.GT.0) MENU(1)=1
      IF (NA.GT.0.AND.NE.EQ.0) MENU(2)=1
      IF (NC.GT.0) MENU(3)=1
      IF (NGR.GT.0) THEN
        MENU(4)=1
        IF (JOB.NE.0) MENU(5)=1
      ENDIF
      IF (JOB.NE.0.AND.NF.GT.0) THEN
        MENU(6)=1
        MENU(7)=1
      ENDIF
      IF (NE.GT.0) THEN
        MENU(11)=1
        NED=MIN(NE,3)
        IF (NED.GE.2.AND.NA.GE.1) THEN
          MENU(12)=1
          IF (NED.EQ.3.AND.NA.GE.1) THEN
            MENU(13)=1
          ENDIF
        ENDIF
        IF (NE.GE.4.AND.NA.GE.1) MENU(19)=1
      ENDIF
      MENU(15)=0
      MENU(20)=1
C
    2 CONTINUE
      IF (MENU(11).EQ.1.OR.MENU(12).EQ.1.OR.MENU(13).EQ.1) THEN
        IF (NED.GE.1.AND.NA.GE.1) THEN
          IF (NE.LE.NED) THEN
            IG=1
            JG=2
            KG=3
          ELSE
            CALL UOJZD2(NE,NED,IG,JG,KG)
          ENDIF
        ENDIF
      ENDIF
C
    1 CONTINUE
      GFMT=0   ! INTERNAL GRAPHICS, NO GENERATING OF *.EPS, *.PNG FILES
      DO I=1,20
        IF (MENU(I).EQ.1) WRITE(*,'(A)') TEXT(I)
      ENDDO
      READ(*,*,ERR=90) WHAT
      IF (MENU(1).EQ.1.AND.(WHAT.EQ.'V'.OR.WHAT.EQ.'v')) THEN
        GOTO 100
      ELSEIF (MENU(2).EQ.1.AND.(WHAT.EQ.'A'.OR.WHAT.EQ.'a')) THEN
        GOTO 200
      ELSEIF (MENU(3).EQ.1.AND.(WHAT.EQ.'C'.OR.WHAT.EQ.'c')) THEN
        GOTO 300
      ELSEIF (MENU(6).EQ.1.AND.(WHAT.EQ.'X'.OR.WHAT.EQ.'x')) THEN
        GOTO 400
      ELSEIF (MENU(7).EQ.1.AND.(WHAT.EQ.'F'.OR.WHAT.EQ.'f')) THEN
        GOTO 500
      ELSEIF (MENU(4).EQ.1.AND.(WHAT.EQ.'S'.OR.WHAT.EQ.'s')) THEN
        GOTO 600
      ELSEIF (MENU(5).EQ.1.AND.(WHAT.EQ.'P'.OR.WHAT.EQ.'p')) THEN
        GOTO 700
      ELSEIF (MENU(11).EQ.1.AND.(WHAT.EQ.'T'.OR.WHAT.EQ.'t')) THEN
        GOTO 800
      ELSEIF (MENU(12).EQ.1.AND.(WHAT.EQ.'O'.OR.WHAT.EQ.'o')) THEN
        GOTO 800
      ELSEIF (MENU(13).EQ.1.AND.(WHAT.EQ.'P'.OR.WHAT.EQ.'p')) THEN
        GOTO 800
      ELSEIF (MENU(15).EQ.1.AND.(WHAT.EQ.'R'.OR.WHAT.EQ.'r')) THEN
        GOTO 900
      ELSEIF (MENU(19).EQ.1.AND.(WHAT.EQ.'N'.OR.WHAT.EQ.'n')) THEN
        GOTO 2
      ELSEIF (MENU(20).EQ.1.AND.(WHAT.EQ.'E'.OR.WHAT.EQ.'e')) THEN
        GOTO 9
      ELSE
        WRITE(*,'(3A)') 'ERROR: ',WHAT,' IS NOT DEFINED'
        GOTO 1
      ENDIF
   90 WRITE(*,'(3A)') 'ERROR: ',WHAT,' IS NOT DEFINED'
      GOTO 1
C
C     variables
C
  100 CONTINUE
      CALL UOMSCR('V',NF,0,0,0,0,GFMT,STA,STO,INFO,0,0)
      IF (INFO.GT.0) CALL UOMVAR(NF,KBF,X,XL,XU,IX,INFO,STA,STO,GFMT)
      GOTO 1
C
C     approximation
C
  200 CONTINUE
      CALL UOMSCR('A',NA,KBA,0,0,0,GFMT,STA,STO,INFO,0,0)
      IF (INFO.GT.0) CALL UOMAPP(NA,AF,AM,INFO,STA,STO,GFMT)
      GOTO 1
C
C     constraints
C
  300 CONTINUE
      CALL UOMSCR('C',NC,0,0,0,0,GFMT,STA,STO,INFO,0,0)
      IF (INFO.GT.0) CALL UOMCON(NC,KBC,CF,CL,CU,IC,INFO,STA,STO,GFMT)
      GOTO 1
C
C     iterations of x
C
  400 CONTINUE
      IF (NF.EQ.1) THEN
  491   CALL UOMSCR('X',NF,0,IGR,JGR,KGR,GFMT,STA,STO,INFO,0,0)
        IF (INFO.GT.0) THEN
          DO J=1,NPAC
            YPA(J)=DBLE(XPA(J,1))
          ENDDO
          IF (INFO.EQ.11) CALL UOMPTH(NPAC,YPA,IGR,JGR,KGR,11,INFO,GFMT)
          IF (INFO.EQ.12) CALL UOMPTH(NPAC,YPA,IGR,JGR,KGR,12,INFO,GFMT)
          GOTO 491
        ENDIF
      ELSEIF (JOB.EQ.1) THEN
        IGR=IGRP
        JGR=JGRP
  492   CALL UOMSCR('X',NF,JOB,IGR,JGR,KGR,GFMT,STA,STO,INFO,0,0)
        IF (INFO.GT.0) THEN
          I=INFO/10
          IF (I.EQ.1.OR.I.EQ.3) THEN
            DO J=1,NPAC
              YPA(J)=DBLE(XPA(J,1))
            ENDDO
          ELSEIF (I.EQ.2) THEN
            DO J=1,NPAC
              YPA(J)=DBLE(XPA(J,2))
            ENDDO
          ENDIF
          IF (I.EQ.3) THEN
            DO J=1,NPAC
              YPA(NPAC+J)=DBLE(XPA(J,2))
            ENDDO
          ENDIF
          IF (INFO.EQ.11) CALL UOMPTH(NPAC,YPA,IGR,JGR,KGR,11,INFO,GFMT)
          IF (INFO.EQ.12) CALL UOMPTH(NPAC,YPA,IGR,JGR,KGR,12,INFO,GFMT)
          IF (INFO.EQ.21) CALL UOMPTH(NPAC,YPA,JGR,IGR,KGR,11,INFO,GFMT)
          IF (INFO.EQ.22) CALL UOMPTH(NPAC,YPA,JGR,IGR,KGR,12,INFO,GFMT)
          IF (INFO.EQ.31) CALL UOMPTH(NPAC,YPA,IGR,JGR,KGR,21,INFO,GFMT)
          IF (INFO.EQ.32) CALL UOMPTH(NPAC,YPA,IGR,JGR,KGR,22,INFO,GFMT)
          GOTO 492
        ENDIF
      ELSEIF (JOB.EQ.2) THEN
  410   WRITE(*,'(A)') 'INDEX OF THE 1-ST VARIABLE:'
        READ(*,*,ERR=410) IGR
        IF (IGR.LE.0.OR.IGR.GT.NF) GO TO 410
  420   WRITE(*,'(A)') 'INDEX OF THE 2-ND VARIABLE:'
        READ(*,*,ERR=420) JGR
        IF (JGR.LE.0.OR.JGR.GT.NF.OR.JGR.EQ.IGR) GO TO 420
  430   WRITE(*,'(A)') 'INDEX OF THE 3-RD VARIABLE:'
        READ(*,*,ERR=430) KGR
        IF (KGR.LE.0.OR.KGR.GT.NF.OR.KGR.EQ.IGR.OR.KGR.EQ.JGR) GO TO 430
  493   CALL UOMSCR('X',NF,JOB,IGR,JGR,KGR,GFMT,STA,STO,INFO,0,0)
        IF (INFO.EQ.-1) GOTO 410
        IF (INFO.GT.0) THEN
          I=INFO/10
          IF (I.EQ.1.OR.I.EQ.4.OR.I.EQ.5.OR.I.EQ.7) THEN
            DO J=1,NPAC
              YPA(J)=DBLE(XPA(J,IGR))
            ENDDO
          ELSEIF (I.EQ.2.OR.I.EQ.6) THEN
            DO J=1,NPAC
              YPA(J)=DBLE(XPA(J,JGR))
            ENDDO
          ELSEIF (I.EQ.3) THEN
            DO J=1,NPAC
              YPA(J)=DBLE(XPA(J,KGR))
            ENDDO
          ENDIF
          IF (I.EQ.4.OR.I.EQ.7) THEN
            DO J=1,NPAC
              YPA(NPAC+J)=DBLE(XPA(J,JGR))
            ENDDO
          ELSEIF (I.EQ.5.OR.I.EQ.6) THEN
            DO J=1,NPAC
              YPA(NPAC+J)=DBLE(XPA(J,KGR))
            ENDDO
          ENDIF
          IF (I.EQ.7) THEN
            DO J=1,NPAC
              YPA(2*NPAC+J)=DBLE(XPA(J,KGR))
            ENDDO
          ENDIF
          IF (INFO.EQ.11) CALL UOMPTH(NPAC,YPA,IGR,JGR,KGR,11,INFO,GFMT)
          IF (INFO.EQ.12) CALL UOMPTH(NPAC,YPA,IGR,JGR,KGR,12,INFO,GFMT)
          IF (INFO.EQ.21) CALL UOMPTH(NPAC,YPA,JGR,IGR,KGR,11,INFO,GFMT)
          IF (INFO.EQ.22) CALL UOMPTH(NPAC,YPA,JGR,IGR,KGR,12,INFO,GFMT)
          IF (INFO.EQ.31) CALL UOMPTH(NPAC,YPA,KGR,IGR,JGR,11,INFO,GFMT)
          IF (INFO.EQ.32) CALL UOMPTH(NPAC,YPA,KGR,IGR,JGR,12,INFO,GFMT)
          IF (INFO.EQ.41) CALL UOMPTH(NPAC,YPA,IGR,JGR,KGR,21,INFO,GFMT)
          IF (INFO.EQ.42) CALL UOMPTH(NPAC,YPA,IGR,JGR,KGR,22,INFO,GFMT)
          IF (INFO.EQ.51) CALL UOMPTH(NPAC,YPA,IGR,KGR,JGR,21,INFO,GFMT)
          IF (INFO.EQ.52) CALL UOMPTH(NPAC,YPA,IGR,KGR,JGR,22,INFO,GFMT)
          IF (INFO.EQ.61) CALL UOMPTH(NPAC,YPA,JGR,KGR,IGR,21,INFO,GFMT)
          IF (INFO.EQ.62) CALL UOMPTH(NPAC,YPA,JGR,KGR,IGR,22,INFO,GFMT)
          IF (INFO.EQ.71) CALL UOMPTH(NPAC,YPA,IGR,JGR,KGR,31,INFO,GFMT)
          IF (INFO.EQ.72) CALL UOMPTH(NPAC,YPA,IGR,JGR,KGR,32,INFO,GFMT)
          GOTO 493
        ENDIF
      ENDIF
      GOTO 1
C
C     iterations of f
C
  500 CONTINUE
      CALL UOMSCR('F',0,0,0,0,0,GFMT,STA,STO,INFO,0,0)
      IF (INFO.GT.0) THEN
        DO J=1,NPAC
          YPA(J)=FPA(J)
        ENDDO
        IF (INFO.EQ.11) CALL UOMPTH(NPAC,YPA,IGR,JGR,KGR,1,1,GFMT)
        IF (INFO.EQ.12) CALL UOMPTH(NPAC,YPA,IGR,JGR,KGR,2,2,GFMT)
      ENDIF
      GOTO 1
C
C     isolines/map/surface
C
  600 CONTINUE
      CALL UYSET0(1,2)
      RETURN
C
C     path with isolines/map
C
  700 CONTINUE
      IF (JOB.EQ.1) THEN
        IGR=IGRP
        JGR=JGRP
      ENDIF
      CALL UYSET0(2,2)
      RETURN
C
C     differential equations
C
  800 CONTINUE
      VYPISF(1)=.FALSE.
      VYPISF(2)=.FALSE.
      VYPISF(3)=.FALSE.
      IF (WHAT.EQ.'T'.OR.WHAT.EQ.'t') THEN
        CALL UOMSCR('T',NA,NED,IG,JG,KG,GFMT,STA,STO,INFO,0,0)
        IF (NED.EQ.1.AND.NA.GE.1.AND.INFO.GT.0) THEN
          CALL UOMTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'100',INFO,STA,STO,GFMT)
        ELSEIF (NED.EQ.2.AND.NA.GE.1.AND.INFO.EQ.1) THEN
          CALL UOMTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'100',INFO,STA,STO,GFMT)
        ELSEIF (NED.EQ.2.AND.NA.GE.1.AND.INFO.EQ.2) THEN
          CALL UOMTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'010',INFO,STA,STO,GFMT)
        ELSEIF (NED.EQ.2.AND.NA.GE.1.AND.INFO.EQ.3) THEN
          CALL UOMTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'110',INFO,STA,STO,GFMT)
        ELSEIF (NED.EQ.3.AND.NA.GE.1.AND.INFO.EQ.1) THEN
          CALL UOMTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'100',INFO,STA,STO,GFMT)
        ELSEIF (NED.EQ.3.AND.NA.GE.1.AND.INFO.EQ.2) THEN
          CALL UOMTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'010',INFO,STA,STO,GFMT)
        ELSEIF (NED.EQ.3.AND.NA.GE.1.AND.INFO.EQ.3) THEN
          CALL UOMTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'001',INFO,STA,STO,GFMT)
        ELSEIF (NED.EQ.3.AND.NA.GE.1.AND.INFO.EQ.4) THEN
          CALL UOMTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'110',INFO,STA,STO,GFMT)
        ELSEIF (NED.EQ.3.AND.NA.GE.1.AND.INFO.EQ.5) THEN
          CALL UOMTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'101',INFO,STA,STO,GFMT)
        ELSEIF (NED.EQ.3.AND.NA.GE.1.AND.INFO.EQ.6) THEN
          CALL UOMTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'011',INFO,STA,STO,GFMT)
        ELSEIF (NED.EQ.3.AND.NA.GE.1.AND.INFO.EQ.7) THEN
          CALL UOMTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'111',INFO,STA,STO,GFMT)
        ENDIF
      ELSEIF (WHAT.EQ.'O'.OR.WHAT.EQ.'o') THEN
        CALL UOMSCR('O',NA,NED,IG,JG,KG,GFMT,STA,STO,INFO,0,0)
        IF (NED.EQ.2.AND.NA.GE.1.AND.INFO.EQ.1) THEN
          CALL UOMORB(NA,NE,AF,IG,JG,KG,VYPISF,'110',INFO,GFMT)
        ELSEIF (NED.EQ.3.AND.NA.GE.1.AND.INFO.EQ.1) THEN
          CALL UOMORB(NA,NE,AF,IG,JG,KG,VYPISF,'110',INFO,GFMT)
        ELSEIF (NED.EQ.3.AND.NA.GE.1.AND.INFO.EQ.2) THEN
          CALL UOMORB(NA,NE,AF,IG,JG,KG,VYPISF,'101',INFO,GFMT)
        ELSEIF (NED.EQ.3.AND.NA.GE.1.AND.INFO.EQ.3) THEN
          CALL UOMORB(NA,NE,AF,IG,JG,KG,VYPISF,'011',INFO,GFMT)
        ENDIF
      ELSEIF (WHAT.EQ.'P'.OR.WHAT.EQ.'p') THEN
        CALL UOMSCR('P',NA,NED,IG,JG,KG,GFMT,STA,STO,INFO,0,0)
        IF (INFO.EQ.1) CALL UOMPIC(NA,NE,AF,IG,JG,KG,VYPISF,INFO,GFMT)
      ENDIF
      GOTO 1
C
C     parameters
C
  900 CONTINUE
C
C     function
C
      OPEN(13,FILE='P.PAR',STATUS='UNKNOWN')
      WRITE(13,'(16I5)') NIT,NFV,NFG,NFH,NAV,NAG,NAH,NCV,NCG,NCH,NDECF,
     & NCGR,NRES,NREM,NADD,NEXT
      WRITE(13,'(4D20.12)') F,DMAX,GMAX
C
C     data
C
      WRITE(13,'(16I5)') NF,NA,NAL,MAL,NC,NCL,MCL,KDF,KBF,KSF,KCF,ISNF,
     & NORMF,KDA,KBA,KSA,KCA,ISNA,NORMA,KDC,KBC,KSC,KCC,ISNC,NORMC
C
C     options
C
      WRITE(13,'(16I5)') MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,
     & MOT3,MOT4,MOT5,MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,
     & MOS4,MOS5,MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,
     & MOP5,MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,KTERS,
     & INITD,INITS,INITH,IREM,IADD, MRED,IRES1,IRES2,MIC,MIT,MFV,MFG,
     & MCGR,MSTP
      WRITE(13,'(4D20.12)') XDEL,XMAX,FMIN,FMAX,RPF1,RPF2,RPF3,RPF4,
     & RPF5,EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,ETA0,
     & ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,ALF1,ALF2,ALF3,
     & BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,TOLX,TOLF,TOLG,
     & TOLB,TOLC,TOLA,TOLR
      CLOSE(13)
      WRITE(*,'(A)') 'FILE P.PAR IS GENERATED'
      GOTO 1
C
C     exit
C
    9 CONTINUE
      CALL UYEPI1(-1)
      IF (NS.EQ.1) NS=0
      RETURN
      END
