* SUBROUTINE UO1FS3                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  SCILAB GRAPHICAL VISUALIZATION OF THE FINAL RESULTS - GENERATING OF EPS FILES
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RO  AF(NA)  VECTOR CONTAINING EITHER VALUES OF APPROXIMATED
*         FUNCTIONS OR COMPUTED SOLUTIONS OF DIFFERENTIAL EQUATIONS.
*  RI  AM(NA)  VECTOR CONTAINING REQUIRED VALUES OF APPROXIMATED
*         FUNCTIONS.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  AT(NA)  VECTOR CONTAINING MESH POINTS.
*  II  NGR  NUMBER OF NODES FOR THE COLOR MAP.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS.
*  II  KBA  SPECIFICATION OF DEVIATIONS.
*  II  KBC  SPECIFICATION OF GENERAL CONSTRAINTS.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
      SUBROUTINE UO1FS3(NF,NA,NAL,MAL,NC,NCL,MCL,NE,X,XL,XU,IX,AF,AM,
     & CF,CL,CU,IC,AT,EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,
     & EPS9,ETA0,ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,ALF1,
     & ALF2,ALF3,BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,F,FMIN,
     & FMAX,DMAX,GMAX,XMAX,XDEL,RPF1,RPF2,RPF3,RPF4,RPF5,
     & MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
     & MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
     & MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
     & MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
     & KSF,KCF,KSA,KCA,KSC,KCC,KTERS,INITD,INITS,INITH,IREM,IADD,
     & MRED,IRES1,IRES2,XPA,FPA,GFMT,JOB)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER IGR,JGR,KGR,NGR,NPH,IMIN,JMIN,KMIN,ICOLOR,IRET,
     & IMAP,IHIL,ICON,IPA,NPA,IGCOM(4),LLC(28)
      COMMON /UMGRFI/ IGR,JGR,KGR,NGR,NPH,IMIN,JMIN,KMIN,ICOLOR,IRET,
     & IMAP,IHIL,ICON,IPA,NPA,IGCOM,LLC
      REAL*8 XLIGR,XUIGR,XLJGR,XUJGR,VALMIN,VALMAX,XIGR,XJGR,RGCOM(2)
      COMMON /UMGRFR/ XLIGR,XUIGR,XLJGR,XUJGR,VALMIN,VALMAX,XIGR,XJGR,
     & RGCOM
      INTEGER NF,NA,NAL,MAL,NC,NCL,MCL,NE,IX(NF),IC(NC),
     & MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
     & MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
     & MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
     & MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
     & KSF,KCF,KSA,KCA,KSC,KCC,KTERS,INITD,INITS,INITH,IREM,IADD,
     & MRED,IRES1,IRES2,GFMT,JOB
      REAL*8 X(NF),XL(NF),XU(NF),AF(*),AM(NA),CF(NC),CL(NC),CU(NC),
     & AT(NA),EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,ETA0,
     & ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,ALF1,ALF2,ALF3,
     & BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,F,FMIN,FMAX,DMAX,
     & GMAX,XMAX,XDEL,RPF1,RPF2,RPF3,RPF4,RPF5,FPA(NPA),YPA(3*NPA)
      REAL*4 XPA(NPA,*)
      INTEGER NED,IG,JG,KG,NPAC,IGRP,JGRP,KGRP,I,J,STA,STO,INFO
      SAVE IGRP,JGRP,KGRP
      LOGICAL VYPISF(3)
C
      IF (NS.EQ.0) NS=1
      IF (TSS(NS).NE.'UOXX') CALL UYPRO1('UOXX',-1)
      GO TO (1,2,3) ISP(NS)
    1 CONTINUE
      IF (JOB.GT.0) THEN
        IGRP=IGR
        JGRP=JGR
        IF (JOB.EQ.2) KGRP=KGR
      ENDIF
C
C     variables
C
      CALL UOSOPN(-10,GFMT)
      IF (NF.GT.0) THEN
        CALL UOMSCR('V',NF,0,0,0,0,GFMT,STA,STO,INFO,0,0)
        IF (INFO.GT.0) CALL UOSVAR(NF,KBF,X,XL,XU,IX,INFO,STA,STO,GFMT)
      ENDIF
C
C     approximation
C
      IF (NA.GT.0.AND.NE.EQ.0) THEN
        CALL UOMSCR('A',NA,KBA,0,0,0,GFMT,STA,STO,INFO,0,0)
        IF (INFO.GT.0) CALL UOSAPP(NA,AF,AM,INFO,STA,STO,GFMT)
      ENDIF
C
C     constraints
C
      IF (NC.GT.0) THEN
        CALL UOMSCR('C',NC,0,0,0,0,GFMT,STA,STO,INFO,0,0)
        IF (INFO.GT.0) CALL UOSCON(NC,KBC,CF,CL,CU,IC,INFO,STA,STO,GFMT)
      ENDIF
C
C     isolines/map/surface
C
      IF (NGR.LE.0) GO TO 2
      CALL UYSET0(1,2)
      RETURN
C
C     function
C
      OPEN(13,FILE='P.PAR',STATUS='UNKNOWN')
      WRITE(13,'(16I5)') NIT,NFV,NFG,NFH,NAV,NAG,NAH,NCV,NCG,NCH,NDECF,
     & NCGR,NRES,NREM,NADD,NEXT
      WRITE(13,'(4D20.12)') F,DMAX,GMAX
C
C     data
C
      WRITE(13,'(16I5)') NF,NA,NAL,MAL,NC,NCL,MCL,KDF,KBF,KSF,KCF,ISNF,
     & NORMF,KDA,KBA,KSA,KCA,ISNA,NORMA,KDC,KBC,KSC,KCC,ISNC,NORMC
C
C     options
C
      WRITE(13,'(16I5)') MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,
     & MOT3,MOT4,MOT5,MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,
     & MOS4,MOS5,MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,
     & MOP5,MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,KTERS,
     & INITD,INITS,INITH,IREM,IADD, MRED,IRES1,IRES2,MIC,MIT,MFV,MFG,
     & MCGR,MSTP
      WRITE(13,'(4D20.12)') XDEL,XMAX,FMIN,FMAX,RPF1,RPF2,RPF3,RPF4,
     & RPF5,EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,ETA0,
     & ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,ALF1,ALF2,ALF3,
     & BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,TOLX,TOLF,TOLG,
     & TOLB,TOLC,TOLA,TOLR
      CLOSE(13)
C
C     differential equations
C
    2 CONTINUE
      NED=MIN(NE,3)
      IF (NED.GE.1.AND.NA.GE.1) THEN
        IF (NE.LE.NED) THEN
          IG=1
          JG=2
          KG=3
        ELSE
          CALL UOJZD2(NE,NED,IG,JG,KG)
        ENDIF
      ELSE
        GOTO 9
      ENDIF
      VYPISF(1)=.FALSE.
      VYPISF(2)=.FALSE.
      VYPISF(3)=.FALSE.
      IF (NED.EQ.1.AND.NA.GE.1) THEN
C
        CALL UOMSCR('T',NA,NED,IG,JG,KG,GFMT,STA,STO,INFO,0,0)
        IF (INFO.GT.0) CALL UOSTRA
     &     (NA,NE,AT,AF,IG,JG,KG,VYPISF,'100',INFO,STA,STO,GFMT)
C
      ELSEIF (NED.EQ.2.AND.NA.GE.1) THEN
C
        CALL UOMSCR('T',NA,NED,IG,JG,KG,GFMT,STA,STO,INFO,0,0)
        IF (INFO.EQ.1) CALL UOSTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'100',INFO,STA,STO,GFMT)
        IF (INFO.EQ.2) CALL UOSTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'010',INFO,STA,STO,GFMT)
        IF (INFO.EQ.3) CALL UOSTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'110',INFO,STA,STO,GFMT)
C
        CALL UOMSCR('O',NA,NED,IG,JG,KG,GFMT,STA,STO,INFO,0,0)
        IF (INFO.EQ.1)
     &    CALL UOSORB(NA,NE,AF,IG,JG,KG,VYPISF,'110',INFO,GFMT)
C
      ELSEIF (NED.EQ.3.AND.NA.GE.1) THEN
C
        CALL UOMSCR('T',NA,NED,IG,JG,KG,GFMT,STA,STO,INFO,0,0)
        IF (INFO.EQ.1) CALL UOSTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'100',INFO,STA,STO,GFMT)
        IF (INFO.EQ.2) CALL UOSTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'010',INFO,STA,STO,GFMT)
        IF (INFO.EQ.3) CALL UOSTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'001',INFO,STA,STO,GFMT)
        IF (INFO.EQ.4) CALL UOSTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'110',INFO,STA,STO,GFMT)
        IF (INFO.EQ.5) CALL UOSTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'101',INFO,STA,STO,GFMT)
        IF (INFO.EQ.6) CALL UOSTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'011',INFO,STA,STO,GFMT)
        IF (INFO.EQ.7) CALL UOSTRA
     &    (NA,NE,AT,AF,IG,JG,KG,VYPISF,'111',INFO,STA,STO,GFMT)
C
        CALL UOMSCR('O',NA,NED,IG,JG,KG,GFMT,STA,STO,INFO,0,0)
        IF (INFO.EQ.1.OR.INFO.EQ.4.OR.INFO.EQ.5.OR.INFO.EQ.7)
     &    CALL UOSORB(NA,NE,AF,IG,JG,KG,VYPISF,'110',1,GFMT)
        IF (INFO.EQ.2.OR.INFO.EQ.4.OR.INFO.EQ.6.OR.INFO.EQ.7)
     &    CALL UOSORB(NA,NE,AF,IG,JG,KG,VYPISF,'101',2,GFMT)
        IF (INFO.EQ.3.OR.INFO.EQ.5.OR.INFO.EQ.6.OR.INFO.EQ.7)
     &    CALL UOSORB(NA,NE,AF,IG,JG,KG,VYPISF,'011',3,GFMT)
C
        CALL UOMSCR('P',NA,NED,IG,JG,KG,GFMT,STA,STO,INFO,0,0)
        IF (INFO.EQ.1) CALL UOSPIC(NA,NE,AF,IG,JG,KG,VYPISF,1,GFMT)
C
      ENDIF
C
C     path
C
    9 NPAC=MIN(NPA,NIT)
      IF (JOB.EQ.0.OR.NF.EQ.0) GOTO 3
      IF (NF.EQ.1) THEN
C
        CALL UOMSCR('X',NF,0,IGR,JGR,KGR,GFMT,STA,STO,INFO,0,0)
        IF (INFO.GT.0) THEN
          DO J=1,NPAC
            YPA(J)=DBLE(XPA(J,1))
          ENDDO
          IF (INFO.EQ.11) CALL UOSPTH(NPAC,YPA,IGR,JGR,KGR,11,INFO,GFMT)
          IF (INFO.EQ.12) CALL UOSPTH(NPAC,YPA,IGR,JGR,KGR,12,INFO,GFMT)
        ENDIF
C
      ELSE IF (JOB.EQ.1) THEN
C
        IGR=IGRP
        JGR=JGRP
        CALL UOMSCR('X',NF,JOB,IGR,JGR,KGR,GFMT,STA,STO,INFO,0,0)
        IF (INFO.GT.0) THEN
          I=INFO/10
          IF (I.EQ.1.OR.I.EQ.3) THEN
            DO J=1,NPAC
              YPA(J)=DBLE(XPA(J,1))
            ENDDO
          ELSEIF (I.EQ.2) THEN
            DO J=1,NPAC
              YPA(J)=DBLE(XPA(J,2))
            ENDDO
          ENDIF
          IF (I.EQ.3) THEN
            DO J=1,NPAC
              YPA(NPAC+J)=DBLE(XPA(J,2))
            ENDDO
          ENDIF
          IF (INFO.EQ.11) CALL UOSPTH(NPAC,YPA,IGR,JGR,KGR,11,INFO,GFMT)
          IF (INFO.EQ.12) CALL UOSPTH(NPAC,YPA,IGR,JGR,KGR,12,INFO,GFMT)
          IF (INFO.EQ.21) CALL UOSPTH(NPAC,YPA,JGR,IGR,KGR,11,INFO,GFMT)
          IF (INFO.EQ.22) CALL UOSPTH(NPAC,YPA,JGR,IGR,KGR,12,INFO,GFMT)
          IF (INFO.EQ.31) CALL UOSPTH(NPAC,YPA,IGR,JGR,KGR,21,INFO,GFMT)
          IF (INFO.EQ.32) CALL UOSPTH(NPAC,YPA,IGR,JGR,KGR,22,INFO,GFMT)
        ENDIF
C
      ELSE IF (JOB.EQ.2) THEN
C
        IGR=IGRP
        JGR=JGRP
        KGR=KGRP
        CALL UOMSCR('X',NF,JOB,IGR,JGR,KGR,GFMT,STA,STO,INFO,0,0)
        IF (INFO.GT.0) THEN
          I=INFO/10
          IF (I.EQ.1.OR.I.EQ.4.OR.I.EQ.5.OR.I.EQ.7) THEN
            DO J=1,NPAC
              YPA(J)=DBLE(XPA(J,1))
            ENDDO
          ELSEIF (I.EQ.2.OR.I.EQ.6) THEN
            DO J=1,NPAC
              YPA(J)=DBLE(XPA(J,2))
            ENDDO
          ELSEIF (I.EQ.3) THEN
            DO J=1,NPAC
              YPA(J)=DBLE(XPA(J,3))
            ENDDO
          ENDIF
          IF (I.EQ.4.OR.I.EQ.7) THEN
            DO J=1,NPAC
              YPA(NPAC+J)=DBLE(XPA(J,2))
            ENDDO
          ELSEIF (I.EQ.5.OR.I.EQ.6) THEN
            DO J=1,NPAC
              YPA(NPAC+J)=DBLE(XPA(J,3))
            ENDDO
          ENDIF
          IF (I.EQ.7) THEN
            DO J=1,NPAC
              YPA(2*NPAC+J)=DBLE(XPA(J,3))
            ENDDO
          ENDIF
          IF (INFO.EQ.11) CALL UOSPTH(NPAC,YPA,IGR,JGR,KGR,11,INFO,GFMT)
          IF (INFO.EQ.12) CALL UOSPTH(NPAC,YPA,IGR,JGR,KGR,12,INFO,GFMT)
          IF (INFO.EQ.21) CALL UOSPTH(NPAC,YPA,JGR,IGR,KGR,11,INFO,GFMT)
          IF (INFO.EQ.22) CALL UOSPTH(NPAC,YPA,JGR,IGR,KGR,12,INFO,GFMT)
          IF (INFO.EQ.31) CALL UOSPTH(NPAC,YPA,KGR,IGR,JGR,11,INFO,GFMT)
          IF (INFO.EQ.32) CALL UOSPTH(NPAC,YPA,KGR,IGR,JGR,12,INFO,GFMT)
          IF (INFO.EQ.41) CALL UOSPTH(NPAC,YPA,IGR,JGR,KGR,21,INFO,GFMT)
          IF (INFO.EQ.42) CALL UOSPTH(NPAC,YPA,IGR,JGR,KGR,22,INFO,GFMT)
          IF (INFO.EQ.51) CALL UOSPTH(NPAC,YPA,IGR,KGR,JGR,21,INFO,GFMT)
          IF (INFO.EQ.52) CALL UOSPTH(NPAC,YPA,IGR,KGR,JGR,22,INFO,GFMT)
          IF (INFO.EQ.61) CALL UOSPTH(NPAC,YPA,JGR,KGR,IGR,21,INFO,GFMT)
          IF (INFO.EQ.62) CALL UOSPTH(NPAC,YPA,JGR,KGR,IGR,22,INFO,GFMT)
          IF (INFO.EQ.71) CALL UOSPTH(NPAC,YPA,IGR,JGR,KGR,31,INFO,GFMT)
          IF (INFO.EQ.72) CALL UOSPTH(NPAC,YPA,IGR,JGR,KGR,32,INFO,GFMT)
        ENDIF
C
      ENDIF
C
      CALL UOMSCR('F',0,0,0,0,0,GFMT,STA,STO,INFO,0,0)
      IF (INFO.GT.0) THEN
        DO J=1,NPAC
          YPA(J)=FPA(J)
        ENDDO
        IF (INFO.EQ.11) CALL UOSPTH(NPAC,YPA,IGR,JGR,KGR,1,1,GFMT)
        IF (INFO.EQ.12) CALL UOSPTH(NPAC,YPA,IGR,JGR,KGR,2,2,GFMT)
      ENDIF
C
      IF (NGR.LE.0) GO TO 3
      CALL UYSET0(2,3)
      RETURN
    3 CONTINUE
      CALL UYEPI1(-1)
      IF (NS.EQ.1) NS=0
      RETURN
      END
