* SUBROUTINE UOMAPP                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL VISUALIZATION OF APPROXIMATIONS.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  AF(NA)  VECTOR CONTAINING THE VALUES OF APPROXIMATED FUNCTIONS.
*  RI  AM(NA)  VECTOR CONTAINING REQUIRED VALUES OF APPROXIMATED FUNCTIONS.
*  II  CISLO  SERIAL NUMBER OF THE MATLAB SOURCE CODE.
*  II  STA  START INDEX OF THE VARIABLES IN THE GRAPH.
*  II  STO  STOP INDEX OF THE VARIABLES IN THE GRAPH.
*  II  GFMT  GRAPHIC FORMAT.
*
      SUBROUTINE UOMAPP(NA,AF,AM,CISLO,STA,STO,GFMT)
      INTEGER NA,CISLO,STA,STO,GFMT
      REAL*8 AF(NA),AM(NA),EPS,MINIM,MAXIM,TEMP
      CHARACTER*16 RETSTA,RETSTO
      CHARACTER*25 RETMIN,RETMAX
C
      CALL UOMOPN(11,GFMT)
      CALL UOMAPN(NA,AF,AM,CISLO,STA,STO,MINIM,MAXIM)
C
      EPS=1.0D-15
      IF (CISLO.EQ.1) THEN
        WRITE(11,'(A)') 'h = plot(ii,af);'
        WRITE(11,'(A)') 'set(h,{''LineStyle''},{''none''});'
        WRITE(11,'(A)') 'set(h,{''Marker''},{''*''});'
        WRITE(11,'(A)') 'set(h,{''MarkerSize''},{2});'
        WRITE(11,'(A)') 'set(h,{''MarkerEdgeColor''},{''r''});'
        WRITE(11,'(A)') 'set(h,{''MarkerFaceColor''},{''r''});'
      ELSEIF (CISLO.EQ.2) THEN
        WRITE(11,'(A)') 'h = plot(ii,af);'
        WRITE(11,'(A)') 'set(h,{''LineStyle''},{''-''});'
        WRITE(11,'(A)') 'set(h,{''LineWidth''},{1});'
        WRITE(11,'(A)') 'set(h,{''Color''},{''r''});'
      ELSEIF (CISLO.EQ.3) THEN
        WRITE(11,'(A)') 'h = plot(ii,af);'
        WRITE(11,'(A)') 'set(h,{''LineStyle''},{''none''});'
        WRITE(11,'(A)') 'for i=1:length(ii)'
        WRITE(11,'(A)') 'hl=line([ii(i) ii(i)],[0 af(i)]);'
        WRITE(11,'(A)') 'set(hl,{''Color''},{''r''});'
        WRITE(11,'(A)') 'end'
      ELSEIF (CISLO.EQ.4) THEN
        WRITE(11,'(A)') 'h=plot(ii,af,ii,am);'
        WRITE(11,'(A)') 'set(h,{''LineStyle''},{''none''});'
        WRITE(11,'(A)') 'set(h,{''Marker''},{''*'';''s''});'
        WRITE(11,'(A)') 'set(h,{''MarkerSize''},{2;2});'
        WRITE(11,'(A)') 'set(h,{''MarkerEdgeColor''},{''r'';''b''});'
        WRITE(11,'(A)') 'set(h,{''MarkerFaceColor''},{''r'';''b''});'
      ELSEIF (CISLO.EQ.5) THEN
        WRITE(11,'(A)') 'h=plot(ii,af,ii,am);'
        WRITE(11,'(A)') 'set(h,{''LineStyle''},{''-'';''none''});'
        WRITE(11,'(A)') 'set(h,{''LineWidth''},{1});'
        WRITE(11,'(A)') 'set(h,{''Color''},{''r''});'
        WRITE(11,'(A)') 'set(h,{''Marker''},{''none'';''s''});'
        WRITE(11,'(A)') 'set(h,{''MarkerSize''},{2});'
        WRITE(11,'(A)') 'set(h,{''MarkerEdgeColor''},{''b''});'
        WRITE(11,'(A)') 'set(h,{''MarkerFaceColor''},{''b''});'
      ELSEIF (CISLO.EQ.6) THEN
        WRITE(11,'(A)') 'h=plot(ii,am);'
        WRITE(11,'(A)') 'set(h,{''LineStyle''},{''none''});'
        WRITE(11,'(A)') 'set(h,{''Marker''},{''s''});'
        WRITE(11,'(A)') 'set(h,{''MarkerSize''},{2});'
        WRITE(11,'(A)') 'set(h,{''MarkerEdgeColor''},{''b''});'
        WRITE(11,'(A)') 'set(h,{''MarkerFaceColor''},{''b''});'
        WRITE(11,'(A)') 'for i=1:length(ii)'
        WRITE(11,'(A)') 'hl=line([ii(i) ii(i)],[0 af(i)]);'
        WRITE(11,'(A)') 'set(hl,{''Color''},{''r''});'
        WRITE(11,'(A)') 'end'
      ELSEIF (CISLO.EQ.7) THEN
        WRITE(11,'(A)') 'h=plot(ii,dif);'
        WRITE(11,'(A)') 'set(h,{''LineStyle''},{''none''});'
        WRITE(11,'(A)') 'set(h,{''Marker''},{''*''});'
        WRITE(11,'(A)') 'set(h,{''MarkerSize''},{2});'
        WRITE(11,'(A)') 'set(h,{''MarkerEdgeColor''},{''r''});'
        WRITE(11,'(A)') 'set(h,{''MarkerFaceColor''},{''r''});'
      ELSEIF (CISLO.EQ.8) THEN
        WRITE(11,'(A)') 'h=plot(ii,dif);'
        WRITE(11,'(A)') 'set(h,{''LineStyle''},{''-''});'
        WRITE(11,'(A)') 'set(h,{''LineWidth''},{1});'
        WRITE(11,'(A)') 'set(h,{''Color''},{''r''});'
      ELSEIF (CISLO.EQ.9) THEN
        WRITE(11,'(A)') 'h=plot(ii,dif);'
        WRITE(11,'(A)') 'set(h,{''LineStyle''},{''none''});'
        WRITE(11,'(A)') 'for i=1:length(ii)'
        WRITE(11,'(A)') 'hl=line([ii(i) ii(i)],[0 dif(i)]);'
        WRITE(11,'(A)') 'set(hl,{''Color''},{''r''});'
        WRITE(11,'(A)') 'end'
      ENDIF
C
      TEMP=(MAXIM-MINIM)*1.0D-1
      IF ((MAXIM-MINIM).LE.MAX(ABS(MAXIM+MINIM),1.0D0)*EPS) TEMP=EPS
      WRITE(RETSTA,'(I10)') STA-1
      RETSTA=ADJUSTL(RETSTA)
      WRITE(RETSTO,'(I10)') STO+1
      RETSTO=ADJUSTL(RETSTO)
      WRITE(RETMIN,'(D25.16)') MINIM-TEMP
      RETMIN=ADJUSTL(RETMIN)
      WRITE(RETMAX,'(D25.16)') MAXIM+TEMP
      RETMAX=ADJUSTL(RETMAX)
      WRITE(11,'(9A)') 'axis([',TRIM(RETSTA), ' ', TRIM(RETSTO), ' ',
     &  TRIM(RETMIN), ' ', TRIM(RETMAX), ']);'
      WRITE(11,'(A)') 'tit=title(''Approximations'');'
      WRITE(11,'(A)') 'xl=xlabel(''Indices of approximations'');'
      IF (CISLO.LE.6) THEN
        WRITE(11,'(A)') 'yl=ylabel(''Values of approximations'');'
      ELSE
        WRITE(11,'(A)') 'yl=ylabel(''Differences of approximations'');'
      ENDIF
      WRITE(11,'(A)') 'set(gca,''FontSize'',15);'
      WRITE(11,'(A)') 'set(tit,''FontSize'',25);'
      WRITE(11,'(A)') 'set(xl,''FontSize'',15);'
      WRITE(11,'(A)') 'set(yl,''FontSize'',15);'
      CALL UOMGRX(11,'PMAPP',CISLO,GFMT)
      RETURN
      END
