* SUBROUTINE UOMIMS                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB AND SCILAB GRAPHICAL VISUALIZATION OF ISOLINES, MAP AND SURFACE - PRIN
*
* PARAMETERS :
*  II  NGR  THE NUMBER OF NODES CORRESPONDING TO EVERY SELECTED VARIABLE
*  RI  XIGR  THE VALUE OF THE FIRST VARIABLE IN THE MINIMUM POINT
*  RI  XJGR  THE VALUE OF THE SECOND VARIABLE IN THE MINIMUM POINT
*  RI  XLIGR  THE MINIMUM VALUE OF THE FIRST VARIABLE OF THE SELECTED REGION
*  RI  XUIGR  THE MAXIMUM VALUE OF THE FIRST VARIABLE OF THE SELECTED REGION
*  RI  XLJGR  THE MINIMUM VALUE OF THE SECOND VARIABLE OF THE SELECTED REGION
*  RI  XUIGR  THE MAXIMUM VALUE OF THE SECOND VARIABLE OF THE SELECTED REGION
*  II  IMIN  THE FIRST COORDINATE OF THE MINIMUM IN THE SELECTED REGION
*  II  JMIN  THE SECOND COORDINATE OF THE MINIMUM IN THE SELECTED REGION
*  RI  FL(NGR,NGR)  THE FIELD CONTAINING DRAWN FUNCTION VALUES
*  LU  VYPISF   THE SAME DRAWN FUNCTION VALUES CAN BE PUT INTO P.* ONLY ONCE
*  IU  SCALE  LINEAR OR LOGARITHMIC SCALE OF THE PLOT
*  LI  INFO  INFORMATION ABOUT THE CASE: 'I' - ISOLINES, 'M' - MAP, 'S' - SURFAC
*  LO  ENLX  IF THE PLOTTING BOX IN X-AXES IS SUFFICIENTLY LARGE
*  LO  ENLY  IF THE PLOTTING BOX IN Y-AXES IS SUFFICIENTLY LARGE
*  LO  CONSTF  IF THE DIFFERENCE BETWEEN MAX AND MIN OF THE PLOTTING VALUES IS S
*
      SUBROUTINE UOMIMS(NGR,XIGR,XJGR,XLIGR,XUIGR,XLJGR,XUJGR,
     & IMIN,JMIN,FL,VYPISF,SCALE,INFO,ENLX,ENLY,CONSTF)
      INTEGER NGR,IMIN,JMIN,SCALE,I,J,K,L
      REAL*4 FL(NGR,NGR),MINIM,MAXIM,EPSS,WF(10)
      REAL*8 XIGR,XJGR,XLIGR,XUIGR,XLJGR,XUJGR,EPSD
      CHARACTER INFO
      CHARACTER*160 RET
      LOGICAL VYPISF,ENLX,ENLY,CONSTF
C
      EPSD=1.0D-15
      EPSS=1.0E-6
      ENLX=.FALSE.
      ENLY=.FALSE.
      CONSTF=.FALSE.
      MINIM= 1.0E30
      MAXIM=-1.0E30
      IF ((XUIGR-XLIGR).LE.MAX(ABS(XUIGR+XLIGR),1.0D0)*EPSD) ENLX=.TRUE.
      IF ((XUJGR-XLJGR).LE.MAX(ABS(XUJGR+XLJGR),1.0D0)*EPSD) ENLY=.TRUE.
      DO I=1,NGR
        DO J=1,NGR
          MINIM=MIN(MINIM,FL(I,J))
          MAXIM=MAX(MAXIM,FL(I,J))
        ENDDO
      ENDDO
      IF ((MAXIM-MINIM).LE.MAX(ABS(MAXIM+MINIM),1.0E0)*EPSS)
     &  CONSTF=.TRUE.
      IF (MINIM.LE.0.0D0) SCALE=1   ! 1=LINEAR, 2=LOGARITHMIC
C
      IF (VYPISF) RETURN
      WRITE(RET,'(I15)') NGR
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'ngr=',TRIM(RET),';'
      WRITE(RET,'(D25.16)') XLIGR
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'xligr=',TRIM(RET),';'
      WRITE(RET,'(D25.16)') XUIGR
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'xuigr=',TRIM(RET),';'
      WRITE(RET,'(D25.16)') XLJGR
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'xljgr=',TRIM(RET),';'
      WRITE(RET,'(D25.16)') XUJGR
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'xujgr=',TRIM(RET),';'
      WRITE(12,'(A)') 'stx=(xuigr-xligr)/(ngr-1);'
      WRITE(12,'(A)') 'sty=(xujgr-xljgr)/(ngr-1);'
      WRITE(12,'(A)') 'x=xligr:stx:xuigr;'
      WRITE(12,'(A)') 'y=xljgr:sty:xujgr;'
C
      WRITE(12,'(A)') 'f=['
      DO J=1,NGR
        K=0
        DO I=1,NGR
          K=K+1
          WF(K)=FL(I,J)
          IF (K.EQ.10) THEN
            WRITE(RET,'(10E16.7)') (WF(L),L=1,K)
            WRITE(12,'(2A)') TRIM(RET),' ...'
            K=0
          ENDIF
        ENDDO
        IF (K.GT.0) THEN
          WRITE(RET,'(10E16.7)') (WF(L),L=1,K)
          WRITE(12,'(2A)') TRIM(RET),';'
        ELSE
          WRITE(12,'(A)') ';'
        ENDIF
      ENDDO
      WRITE(12,'(A)') '];'
      IF (SCALE.EQ.2) WRITE(12,'(A)') 'f=log10(f);';
C
      IF (INFO.NE.'S'.AND.(IMIN.GT.0.OR.JMIN.GT.0)) THEN
        WRITE(RET,'(D25.16)') XIGR
        RET=ADJUSTL(RET)
        WRITE(12,'(3A)') 'xm=',TRIM(RET),';'
        WRITE(RET,'(D25.16)') XJGR
        RET=ADJUSTL(RET)
        WRITE(12,'(3A)') 'ym=',TRIM(RET),';'
      ENDIF
      VYPISF=.TRUE.
      RETURN
      END
