* SUBROUTINE UOMORB                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL VISUALIZATION OF ORBIT.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RI  AY(*)  VECTOR CONTAINING COMPUTED SOLUTIONS OF DIFFERENTIAL EQUATIONS.
*  II  IG  INDEX OF THE 1-ST VISUALIZED DIFFERENTIAL EQUATION.
*  II  JG  INDEX OF THE 2-ND VISUALIZED DIFFERENTIAL EQUATION.
*  II  KG  INDEX OF THE 3-RD VISUALIZED DIFFERENTIAL EQUATION.
*  LI  VYPISF(3)  THE SAME DRAWN FUNCTION VALUES CAN BE PUT INTO P.m ONLY ONCE
*  CI  INFO  WHICH INDEXES [IG JG KG] OF GRAPH TO PRINT = [110] OR [101] OR [011
*  II  CISLO  SERIAL NUMBER OF THE MATLAB SOURCE CODE
*  II  GFMT  GRAPHIC FORMAT
*
      SUBROUTINE UOMORB(NA,NE,AY,IG,JG,KG,VYPISF,INFO,CISLO,GFMT)
      INTEGER NA,NE,IG,JG,KG,CISLO,GFMT
      REAL*8 AY(*),MINIMX,MAXIMX,MINIMY,MAXIMY,TEMP,EPS
      CHARACTER*3 INFO
      CHARACTER*25 T1,T2,T3,T4
      LOGICAL VYPISF(3)
C
      CALL UOMOPN(14,GFMT)
      CALL UOMORT
     & (NA,NE,AY,IG,JG,KG,VYPISF,INFO,MINIMX,MAXIMX,MINIMY,MAXIMY)
C
      EPS=1.0D-15
      IF (INFO(3:3).EQ.'0') THEN
        WRITE(T1,'(I10)')IG
        T1=ADJUSTL(T1)
        WRITE(T2,'(I10)')JG
        T2=ADJUSTL(T2)
        WRITE(14,'(A)')'h = plot(y1,y2);'
      ELSEIF (INFO(2:2).EQ.'0') THEN
        WRITE(T1,'(I10)')IG
        T1=ADJUSTL(T1)
        WRITE(T2,'(I10)')KG
        T2=ADJUSTL(T2)
        WRITE(14,'(A)')'h = plot(y1,y3);'
      ELSE
        WRITE(T1,'(I10)')JG
        T1=ADJUSTL(T1)
        WRITE(T2,'(I10)')KG
        T2=ADJUSTL(T2)
        WRITE(14,'(A)')'h = plot(y2,y3);'
      ENDIF
      WRITE(14,'(A)')'set(h,{''LineWidth''},{2});'
      WRITE(14,'(A)')'set(h,{''LineStyle''},{''-''});'
      WRITE(14,'(A)')'set(h,{''Color''},{''b''});'
      WRITE(14,'(5A)')'tit=title(''Orbit of YA(', TRIM(T1),
     &   '), YA(', TRIM(T2), ')'');'
      WRITE(14,'(3A)')'xl=xlabel(''YA(', TRIM(T1), ')'');'
      WRITE(14,'(3A)')'yl=ylabel(''YA(', TRIM(T2), ')'');'
      WRITE(14,'(A)')'set(gca,''FontSize'',20);'
      WRITE(14,'(A)')'set(tit,''FontSize'',25);'
      WRITE(14,'(A)')'set(xl,''FontSize'',20);'
      WRITE(14,'(A)')'set(yl,''FontSize'',20);'
      WRITE(14,'(A)')'grid on;'
      TEMP=(MAXIMX-MINIMX)*1.0D-1
      IF ((MAXIMX-MINIMX).LE.MAX(ABS(MAXIMX+MINIMX),1.0D0)*EPS) TEMP=EPS
      WRITE(T1,'(D25.16)') MINIMX-TEMP
      T1=ADJUSTL(T1)
      WRITE(T2,'(D25.16)') MAXIMX+TEMP
      T2=ADJUSTL(T2)
      TEMP=(MAXIMY-MINIMY)*1.0D-1
      IF ((MAXIMY-MINIMY).LE.MAX(ABS(MAXIMY+MINIMY),1.0D0)*EPS) TEMP=EPS
      WRITE(T3,'(D25.16)') MINIMY-TEMP
      T3=ADJUSTL(T3)
      WRITE(T4,'(D25.16)') MAXIMY+TEMP
      T4=ADJUSTL(T4)
      WRITE(14,'(9A)')'axis([',
     & TRIM(T1), ' ', TRIM(T2), ' ', TRIM(T3), ' ', TRIM(T4), ']);'
      CALL UOMGRX(14,'PMORB',CISLO,GFMT)
      RETURN
      END
