* SUBROUTINE UOMTRY                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB AND SCILAB GRAPHICAL VISUALIZATION OF TRAJECTORY - PRINTING OF THE VAL
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RI  AT(NA)  VECTOR CONTAINING MESH POINTS.
*  RI  AY(*)  VECTOR CONTAINING COMPUTED SOLUTIONS OF DIFFERENTIAL EQUATIONS.
*  II  IG  INDEX OF THE 1-ST VISUALIZED DIFFERENTIAL EQUATION.
*  II  JG  INDEX OF THE 2-ND VISUALIZED DIFFERENTIAL EQUATION.
*  II  KG  INDEX OF THE 3-RD VISUALIZED DIFFERENTIAL EQUATION.
*  LU  VYPISF(3)  THE SAME DRAWN FUNCTION VALUES CAN BE PUT INTO P.m ONLY ONCE
*  CI  INFO  WHICH INDEXES [IG JG KG] OF GRAPH TO PRINT = [100] OR [010] OR [001
*  II  STA  START INDEX OF THE COMPUTED SOLUTION IN THE GRAPH.
*  II  STO  STOP INDEX OF THE COMPUTED SOLUTION IN THE GRAPH.
*  RO  MINIM  MINIMAL VALUE AMONG THE PLOTTING VALUES.
*  RO  MAXIM  MAXIMAL VALUE AMONG THE PLOTTING VALUES.
*
      SUBROUTINE UOMTRY
     & (NA,NE,AT,AY,IG,JG,KG,VYPISF,INFO,STA,STO,MINIM,MAXIM)
      INTEGER NA,NE,IG,JG,KG,STA,STO,I,J,K,L
      REAL*8 AT(NA),AY(*),WY(10),MINIM,MAXIM
      CHARACTER*3 INFO
      CHARACTER*250 RET
      LOGICAL VYPISF(3)
C
      MAXIM=-1D60
      MINIM= 1D60
C
      WRITE(14,'(A)') 'x=['
      J=0
      DO I=STA,STO
        J=J+1
        WY(J)=AT(I)
        IF (J.EQ.10) THEN
          WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
          WRITE(14,'(2A)') TRIM(RET), ' ...'
          J=0
        ENDIF
      ENDDO
      IF (J.GT.0) THEN
        WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
        WRITE(14,'(2A)') TRIM(RET), ' ...'
      ENDIF
      WRITE(14,'(A)') '];'
C
      IF (INFO(1:1).EQ.'1') THEN
        WRITE(14,'(A)') 'y1=['
        J=0
        DO I=STA,STO
          J=J+1
          L=(I-1)*NE+IG
          WY(J)=AY(L)
          MAXIM=MAX(MAXIM,AY(L))
          MINIM=MIN(MINIM,AY(L))
          IF (J.EQ.10) THEN
            WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
            WRITE(14,'(2A)') TRIM(RET), ' ...'
            J=0
          ENDIF
        ENDDO
        IF (J.GT.0) THEN
          WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
          WRITE(14,'(2A)') TRIM(RET), ' ...'
        ENDIF
        WRITE(14,'(A)') '];'
        IF (STA.EQ.1.AND.STO.EQ.NA) VYPISF(1)=.TRUE.
      ENDIF
C
      IF (INFO(2:2).EQ.'1') THEN
        WRITE(14,'(A)') 'y2=['
        J=0
        DO I=STA,STO
          J=J+1
          L=(I-1)*NE+JG
          WY(J)=AY(L)
          MAXIM=MAX(MAXIM,AY(L))
          MINIM=MIN(MINIM,AY(L))
          IF (J.EQ.10) THEN
            WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
            WRITE(14,'(2A)') TRIM(RET), ' ...'
            J=0
          ENDIF
        ENDDO
        IF (J.GT.0) THEN
          WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
          WRITE(14,'(2A)') TRIM(RET), ' ...'
        ENDIF
        WRITE(14,'(A)') '];'
        IF (STA.EQ.1.AND.STO.EQ.NA) VYPISF(2)=.TRUE.
      ENDIF
C
      IF (INFO(3:3).EQ.'1') THEN
        WRITE(14,'(A)') 'y3=['
        J=0
        DO I=STA,STO
          J=J+1
          L=(I-1)*NE+KG
          WY(J)=AY(L)
          MAXIM=MAX(MAXIM,AY(L))
          MINIM=MIN(MINIM,AY(L))
          IF (J.EQ.10) THEN
            WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
            WRITE(14,'(2A)') TRIM(RET), ' ...'
            J=0
          ENDIF
        ENDDO
        IF (J.GT.0) THEN
          WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
          WRITE(14,'(2A)') TRIM(RET), ' ...'
        ENDIF
        WRITE(14,'(A)') '];'
        IF (STA.EQ.1.AND.STO.EQ.NA) VYPISF(3)=.TRUE.
      ENDIF
C
      RETURN
      END
