* SUBROUTINE UOSTRA                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  SCILAB GRAPHICAL VISUALIZATION OF TRAJECTORY.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RI  AT(NA)  VECTOR CONTAINING MESH POINTS.
*  RI  AY(*)  VECTOR CONTAINING COMPUTED SOLUTIONS OF DIFFERENTIAL EQUATIONS.
*  II  IG  INDEX OF THE 1-ST VISUALIZED DIFFERENTIAL EQUATION.
*  II  JG  INDEX OF THE 2-ND VISUALIZED DIFFERENTIAL EQUATION.
*  II  KG  INDEX OF THE 3-RD VISUALIZED DIFFERENTIAL EQUATION.
*  LI  VYPISF(3)  THE SAME DRAWN FUNCTION VALUES CAN BE PUT INTO P.sci ONLY ONCE
*  CI  INFO  WHICH INDEXES [IG JG KG] OF GRAPH TO PRINT = [100] OR [010] OR [001
*  II  CISLO  SERIAL NUMBER OF THE SCILAB SOURCE CODE
*  II  STA  START INDEX OF THE COMPUTED SOLUTION IN THE GRAPH
*  II  STO  STOP INDEX OF THE COMPUTED SOLUTION IN THE GRAPH
*  II  GFMT  GRAPHIC FORMAT
*
      SUBROUTINE UOSTRA
     & (NA,NE,AT,AY,IG,JG,KG,VYPISF,INFO,CISLO,STA,STO,GFMT)
      INTEGER NA,NE,IG,JG,KG,CISLO,STA,STO,GFMT
      REAL*8 AT(NA),AY(*),MINIM,MAXIM,TEMP,EPS
      CHARACTER*3 INFO
      CHARACTER*25 T1,T2,T3,T4
      LOGICAL VYPISF(3)
C
      CALL UOSOPN(14,GFMT)
      CALL UOMTRY(NA,NE,AT,AY,IG,JG,KG,VYPISF,INFO,STA,STO,MINIM,MAXIM)
C
      EPS=1.0D-6
      IF
     & (INFO(1:1).EQ.'1'.AND.INFO(2:2).EQ.'0'.AND.INFO(3:3).EQ.'0') THEN
        WRITE(14,'(A)') 'plot(x,y1);'
      ELSEIF
     & (INFO(1:1).EQ.'0'.AND.INFO(2:2).EQ.'1'.AND.INFO(3:3).EQ.'0') THEN
        WRITE(14,'(A)') 'plot(x,y2);'
      ELSEIF
     & (INFO(1:1).EQ.'0'.AND.INFO(2:2).EQ.'0'.AND.INFO(3:3).EQ.'1') THEN
        WRITE(14,'(A)') 'plot(x,y3);'
      ELSEIF
     & (INFO(1:1).EQ.'1'.AND.INFO(2:2).EQ.'1'.AND.INFO(3:3).EQ.'0') THEN
        WRITE(14,'(A)') 'plot(x,y1,x,y2);'
      ELSEIF
     & (INFO(1:1).EQ.'1'.AND.INFO(2:2).EQ.'0'.AND.INFO(3:3).EQ.'1') THEN
        WRITE(14,'(A)') 'plot(x,y1,x,y3);'
      ELSEIF
     & (INFO(1:1).EQ.'0'.AND.INFO(2:2).EQ.'1'.AND.INFO(3:3).EQ.'1') THEN
        WRITE(14,'(A)') 'plot(x,y2,x,y3);'
      ELSE
        WRITE(14,'(A)') 'plot(x,y1,x,y2,x,y3);'
      ENDIF
      WRITE(14,'(A)') 'set(gca(),"grid",[1 1]);'
      WRITE(14,'(A)') 'a=gca();'
      WRITE(14,'(A)') 'a.font_size=4;'
      WRITE(T1,'(D25.16)')AT(STA)-(AT(STA+1)-AT(STA))
      T1=ADJUSTL(T1)
      WRITE(T2,'(D25.16)')AT(STO)+(AT(STO)-AT(STO-1))
      T2=ADJUSTL(T2)
      TEMP=(MAXIM-MINIM)*1.0D-1
      IF ((MAXIM-MINIM).LE.MAX(ABS(MAXIM+MINIM),1.0D0)*EPS) TEMP=EPS
      WRITE(T3,'(D25.16)') MINIM-TEMP
      T3=ADJUSTL(T3)
      WRITE(T4,'(D25.16)') MAXIM+TEMP
      T4=ADJUSTL(T4)
      WRITE(14,'(9A)') 'a.zoom_box=[',
     & TRIM(T1), ' ', TRIM(T3), ' ', TRIM(T2), ' ', TRIM(T4), '];'
      WRITE(14,'(A)') 'a.thickness=0.5;'
      WRITE(14,'(A)') 'e=gce();'
      IF(INFO(1:1).EQ.'1'.AND.INFO(2:2).EQ.'0'.AND.INFO(3:3).EQ.'0'.OR.
     &   INFO(1:1).EQ.'0'.AND.INFO(2:2).EQ.'1'.AND.INFO(3:3).EQ.'0'.OR.
     &   INFO(1:1).EQ.'0'.AND.INFO(2:2).EQ.'0'.AND.INFO(3:3).EQ.'1')THEN
C       JEDNA TRAJEKTORIE
        WRITE(14,'(A)') 'e.children(1).polyline_style=1;'
        WRITE(14,'(A)') 'e.children(1).line_style=1;'
        WRITE(14,'(A)') 'e.children(1).thickness=2;'
        WRITE(14,'(A)') 'e.children(1).foreground=2;'
        IF (INFO(1:1).EQ.'1') THEN
          WRITE(T1,'(I10)')IG
          T1=ADJUSTL(T1)
        ELSEIF (INFO(2:2).EQ.'1') THEN
          WRITE(T1,'(I10)')JG
          T1=ADJUSTL(T1)
        ELSE
          WRITE(T1,'(I10)')KG
          T1=ADJUSTL(T1)
        ENDIF
        WRITE(14,'(3A)')
     &   'title(''$\textrm{Trajectory of \textcolor{blue}{YA(',
     &   TRIM(T1), ')}}$'',''fontsize'',5);'
      ELSEIF
     &   (INFO(1:1).EQ.'0'.OR.INFO(2:2).EQ.'0'.OR.INFO(3:3).EQ.'0') THEN
C       DVE TRAJEKTORIE
        WRITE(14,'(A)') 'e.children(1).polyline_style=1;'
        WRITE(14,'(A)') 'e.children(1).line_style=3;'
        WRITE(14,'(A)') 'e.children(1).thickness=2;'
        WRITE(14,'(A)') 'e.children(1).foreground=5;'
        WRITE(14,'(A)') 'e.children(2).polyline_style=1;'
        WRITE(14,'(A)') 'e.children(2).line_style=1;'
        WRITE(14,'(A)') 'e.children(2).thickness=2;'
        WRITE(14,'(A)') 'e.children(2).foreground=2;'
        IF (INFO(3:3).EQ.'0') THEN
          WRITE(T1,'(I10)')IG
          T1=ADJUSTL(T1)
          WRITE(T2,'(I10)')JG
          T2=ADJUSTL(T2)
        ELSEIF (INFO(2:2).EQ.'0') THEN
          WRITE(T1,'(I10)')IG
          T1=ADJUSTL(T1)
          WRITE(T2,'(I10)')KG
          T2=ADJUSTL(T2)
        ELSE
          WRITE(T1,'(I10)')JG
          T1=ADJUSTL(T1)
          WRITE(T2,'(I10)')KG
          T2=ADJUSTL(T2)
        ENDIF
        WRITE(14,'(5A)')
     &   'title(''$\textrm{Trajectories of \textcolor{blue}{YA(',
     &   TRIM(T1), ')}, \textcolor{red}{YA(',
     &   TRIM(T2), ')}}$'',''fontsize'',5);'
      ELSE
C       TRI TRAJEKTORIE
        WRITE(14,'(A)') 'e.children(1).polyline_style=1;'
        WRITE(14,'(A)') 'e.children(1).line_style=4;'
        WRITE(14,'(A)') 'e.children(1).thickness=2;'
        WRITE(14,'(A)') 'e.children(1).foreground=13;'
        WRITE(14,'(A)') 'e.children(2).polyline_style=1;'
        WRITE(14,'(A)') 'e.children(2).line_style=3;'
        WRITE(14,'(A)') 'e.children(2).thickness=2;'
        WRITE(14,'(A)') 'e.children(2).foreground=5;'
        WRITE(14,'(A)') 'e.children(3).polyline_style=1;'
        WRITE(14,'(A)') 'e.children(3).line_style=1;'
        WRITE(14,'(A)') 'e.children(3).thickness=2;'
        WRITE(14,'(A)') 'e.children(3).foreground=2;'
        WRITE(T1,'(I10)')IG
        T1=ADJUSTL(T1)
        WRITE(T2,'(I10)')JG
        T2=ADJUSTL(T2)
        WRITE(T3,'(I10)')KG
        T3=ADJUSTL(T3)
        WRITE(14,'(7A)')
     &   'title(''$\textrm{Trajectories of \textcolor{blue}{YA(',
     &   TRIM(T1), ')}, \textcolor{red}{YA(',
     &   TRIM(T2), ')}, \textcolor{0,0.5,0}{YA(',
     &   TRIM(T3), ')}}$'',''fontsize'',5);'
      ENDIF
      WRITE(14,'(A)') 'xlabel(''Time'',''fontsize'',4);'
      WRITE(14,'(A)') 'ylabel(''Values of YA'',''fontsize'',4);'
      CALL UOSGRX(14,'PSTRA',CISLO,GFMT)
      RETURN
      END
