* SUBROUTINE UP0BX2             ALL SYSTEMS                 05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  AF(NA)  VECTOR CONTAINING VALUES OF APPROXIMATED FUNCTIONS.
*  RI  ASL(NA)  VECTOR CONTAINING LOWER EXPONENTIAL TERMS.
*  RI  ASU(NA)  VECTOR CONTAINING UPPER EXPONENTIAL TERMS.
*  RO  F  VALUE OF THE BARRIER FUNCTION.
*  RI  FF  VALUE OF THE MINIMAX FUNCTION.
*  RI  RPF3  BARRIER COEFFICIENT.
*  II  IEXT  KIND OF THE MINIMAX APPROXIMATION. IEXT=0-CHEBYSHEV
*         APPROXIMATION. IEXT=-1-MINIMAX. IEXT=+1-MAXIMIN.
*  II  MEP2  SAVING EXPONENTIAL TERMS. MEP2=0-SAVING SUPPRESSED.
*         MEP2=1-SAVING EXPONENTIAL TERMS.
*
      SUBROUTINE UP0BX2(NA,AF,ASL,ASU,F,FF,RPF3,IEXT,MEP2)
      INTEGER NA,IEXT,MEP2
      REAL*8 AF(NA),ASL(NA),ASU(NA),RPF3,F,FF
      REAL*8 FA
      INTEGER KA
      F=0.0D 0
      DO 1 KA=1,NA
      FA=AF(KA)
      IF (IEXT.EQ.0) THEN
      IF (MEP2.EQ.0) THEN
      F=F+EXP(-(FF-FA)/RPF3)+EXP(-(FF+FA)/RPF3)
      ELSE
      F=F+ASU(KA)+ASL(KA)
      ENDIF
      ELSE IF (IEXT.LT.0) THEN
      IF (MEP2.EQ.0) THEN
      F=F+EXP(-(FF-FA)/RPF3)
      ELSE
      F=F+ASU(KA)
      ENDIF
      ELSE IF (IEXT.GT.0) THEN
      IF (MEP2.EQ.0) THEN
      F=F+EXP(-(FF+FA)/RPF3)
      ELSE
      F=F+ASL(KA)
      ENDIF
      ENDIF
    1 CONTINUE
      F=FF+RPF3*LOG(F)
      RETURN
      END
