* LOGICAL FUNCTION UQCOND          ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  COMPARISON OF TWO SUBSTRINGS (EVALUATION OF CONDITION)
*
* PARAMETERS :
*  TI  STRAR1(MLEN1) - A STRING ARRAY
*  II  MLEN1 - MAX. LENGTH OF STRAR1
*  II  IPOS11 - POSITION OF THE FIRST CHARACTER OF A SUBSTRING IN STRAR1
*  II  IPOS12 - POSITION OF THE LAST CHARACTER OF A SUBSTRING IN STRAR1
*  TI  STRAR2(MLEN2) - A STRING ARRAY
*  II  MLEN2 - MAX. LENGTH OF STRAR2
*  II  IPOS21 - POSITION OF THE FIRST CHARACTER OF A SUBSTRING IN STRAR2
*  II  IPOS22 - POSITION OF THE LAST CHARACTER OF A SUBSTRING IN STRAR2
*
* SUBPROGRAMS USED :
*  LF  UQCHEQ   COMPARISON OF TWO CHARACTERS
*
* REMARK:
*  SPACES ARE IGNORED !
*  E.G. 'B A Y' AND 'BAY' ARE IDENTICAL SUBSTRINGS.
*  CHWC='?' IS A WILDCARD
*
      LOGICAL FUNCTION UQCOND(STRAR1,MLEN1,IPOS11,IPOS12,
     *                        STRAR2,MLEN2,IPOS21,IPOS22)
      INTEGER MLEN1,IPOS11,IPOS12,MLEN2,IPOS21,IPOS22
      CHARACTER*1 STRAR1(MLEN1),STRAR2(MLEN2)
      CHARACTER*1 CHWC
      PARAMETER(CHWC='?')
      INTEGER I,J,K,L
      LOGICAL UQCHEQ
      UQCOND=.FALSE.
      K=0
      L=0
      DO 1 I=IPOS11,IPOS12
        IF(STRAR1(I).NE.' ') K=K+1
    1 CONTINUE
      DO 2 I=IPOS21,IPOS22
        IF(STRAR2(I).NE.' ') L=L+1
    2 CONTINUE
      IF(K.NE.L) RETURN
      I=IPOS11
      J=IPOS21
    3 IF(STRAR1(I).EQ.' ') THEN
        IF(I.EQ.IPOS12) GOTO 5
        I=I+1
        GOTO 3
      ENDIF
    4 IF(STRAR2(J).EQ.' '.AND.J.LT.IPOS22) THEN
        IF(J.EQ.IPOS22) GOTO 5
        J=J+1
        GOTO 4
      ENDIF
      IF(.NOT.UQCHEQ(STRAR1(I),STRAR2(J))) THEN
        IF(.NOT.(STRAR1(I).EQ.CHWC.OR.STRAR2(J).EQ.CHWC)) RETURN
      ENDIF
      I=I+1
      J=J+1
      IF(I.LE.IPOS12.AND.J.LE.IPOS22) GOTO 3
    5 UQCOND=.TRUE.
      RETURN
      END
