* SUBROUTINE UUSSLU                ALL SYSTEMS               98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* UPDATED SPARSE MATRIX IS REWRITED INTO THE DATA STRUCTURE
* OF THE COMPRESSED CHOLESKY FACTOR.
*
*  PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES
*  II  N  ACTUAL NUMBER OF VARIABLES
*  II  M  SIZE OF THE UPDATED HESSIAN MATRIX.
*  II  MMAX  SIZE OF THE PRINCIPAL ARRAYS OF THE SPARSE MATRIX.
*  RO  H(MMAX)   NUMERICAL VALUES OF THE SPARSE HESSIAN APPROXIMATION
*             STORED AT THE POSITIONS 1, ...,M. LOWER TRIANGULAR
*             FACTOR OF THE HESSIAN APPROXIMATION STORED AT THE
*             POSITIONS M+1, ..., M+MB.
*  II  IH(NF) POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  II  JH(MMAX)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW FORM AT THE FIRST M POSITIONS. COMPACT
*             STRUCTURE OF INDICES OF ITS TRIANGULAR FACTOR IS ROWWISE
*             STORED.
*  II  PSL(NF+1)  POINTER VECTOR OF THE COMPACT FORM OF THE TRIANGULAR
*             FACTOR OF THE HESSIAN APPROXIMATION.
*  IA  WN13(NF+1) AUXILIARY VECTOR.
*
* COMMON DATA:
*  IU  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*
      SUBROUTINE UUSSLU(NF,N,M,MMAX,H,IH,JH,PSL,WN13)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER NF,N,M,MMAX,WN13(NF+1)
      INTEGER PSL(NF+1),IH(NF+1),JH(MMAX)
      INTEGER JSTRT,JSTOP,I,J,K,L,L1
      REAL*8 H(MMAX)
C
C REWRITE ELEMENTS OF HESSIAN APPROXIMATION INTO THE
C STRUCTURE OF FACTOR - AFTER FIRST M POSITIONS
C
      DO 740 I=1,N
      WN13(I)=0
  740 CONTINUE
      L1=M+PSL(1)
      DO 750 I=1,N
        JSTRT=IH(I)
        JSTOP=IH(I+1)-1
        DO 741 J=JSTRT,JSTOP
        K=JH(J)
        WN13(K)=J
  741   CONTINUE
        JSTRT=JH(M+I)+N+1
C
C DIAGONAL ELEMENT INCLUDED
C
        K=WN13(I)
        WN13(I)=0
        H(L1)=H(K)
        L1=L1+1
        DO 742 J=JSTRT,JSTRT+PSL(I+1)-PSL(I)-1
          L=JH(M+J)
          IF(WN13(L).NE.0) THEN
            H(L1)=H(WN13(L))
            WN13(L)=0
          ELSE
            H(L1)=0
          END IF
          L1=L1+1
  742   CONTINUE
  750 CONTINUE
      IDECF=0
      RETURN
      END
