* SUBROUTINE UUSTM3                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* TOINT COMPLETE GROUP FRACTIONED UPDATE.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  MMAX  NUMBER OF NONZERO ELEMENTS OF THE MATRIX.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RU  HF(MMAX) HESSIAN MATRIX OF THE MODEL FUNCTION
*  II  IH(NF)  POINTERS OF THE DIAGONAL ELEMENTS OF H.
*  II  JH(MMAX)  INDICES OF THE NONZERO ELEMENTS OF H.
*  RI  GF(NF)  GRADIENT OF THE MODEL FUNCTION.
*  RA  GO(NF)  AUXILIARY VECTOR.
*  RU  XO(NF)  VECTORS OF VARIABLES DIFFERENCE.
*  RA  S(NF)  AUXILIARY VECTOR.
*  IA  WN01(NF) AUXILIARY VECTOR.
*  IA  WN02(NF) AUXILIARY VECTOR.
*  RA  WR01(NF+1) AUXILIARY VECTOR.
*  RO  R  VALUE OF THE STEPSIZE PARAMETER.
*  RI  FF  VALUE OF THE MODEL FUNCTION.
*  RI  PO  INITIAL VALUE OF THE DIRECTIONAL DERIVATIVE.
*  II  MET1 CHOICE OF THE UPDATE.
*
* COMMON DATA :
*  IO  ITERH  TERMINATION INDICATOR. ITERH<0-BAD DECOMPOSITION.
*         ITERH=0-SUCCESSFUL UPDATE. ITERH>0-NONPOSITIVE PARAMETERS.
*  II  ITERD  TERMINATION INDICATOR. ITERD<0-BAD DECOMPOSITION.
*         ITERD=0-DESCENT DIRECTION. ITERD=1-NEWTON LIKE STEP.
*         ITERD=2-INEXACT NEWTON LIKE STEP. ITERD=3-BOUNDARY STEP.
*         ITERD=4-DIRECTION WITH THE NEGATIVE CURVATURE.
*         ITERD=5-MARQUARDT STEP.
*  II  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*  II  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  KIT  NUMBER OF THE ITERATION AFTER LAST RESTART.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*  S   UXVCOP  COPYING OF A VECTOR.
*
      SUBROUTINE UUSTM3(NF,MMAX,X,IX,H,IH,JH,GF,GO,XO,S,COL,WN01,WN02,
     & WR01,WR02,R,FF,PO,MET1)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER NF,MMAX,IX(NF),WN01(NF+1),WN02(NF+1),IH(NF+1),JH(MMAX),
     & COL(NF),MET1
      REAL*8 X(NF),H(MMAX),GF(NF),GO(NF),S(NF),XO(NF),WR01(NF+1)
      REAL*8 WR02(NF),R,FF,PO
      REAL*8 XSTEP,XTEMP,FTEMP
      REAL*8 A,B,C,D,UXVDOT,GAM
      INTEGER I,J,K,ISTRT,ISTOP,LSUM,IND,ML,L,MM,IVAR,JVAR
      LOGICAL L1
      SAVE L1
      SAVE ML,IVAR,JVAR
      SAVE XSTEP,XTEMP,FTEMP
      IF (TSS(NS).NE.'UUGX') CALL UYPRO1('UUGX',-1)
      GO TO (1,3) ISP(NS)
    1 CONTINUE
      IF(IDECF.NE.0) THEN
        ITERH=-1
        TUXX='BAD DEC0'
        CALL UOERR1('UUSTM3',1)
        GO TO 6
      ENDIF
      MM=IH(NF+1)-1
      D=UXVDOT(NF,XO,XO)
      IF(D.LE.ZERO) THEN
        ITERH=5
        TUXX='D - ZERO'
        GO TO 6
      ENDIF
      L1=MET1.GE.3.OR.MET1.EQ.2.AND.NIT.EQ.KIT
      FTEMP = FF
C
C     ON INPUT WE HAVE IN GO, XO DIFFERENCES
C     SHIFT OLD GRADIENT AND OLD VECTOR INTO X, GO
C
      CALL UXVDIF(NF,GF,GO,GO)
      CALL UXVDIF(NF,X,XO,X)
      CALL UXVCOP(NF,GF,WR01)
      IVAR = 1
C
C     NUMBER OF ELEMENTS IN THE STRICT UPPER HALF.
C
C     IND=IH(NF+1)-2-NF
      IND=2*IH(NF+1)-2-NF
C
C     WIDTHEN THE STRUCTURE AND INITIALIZE ARRAY H
C
      CALL UXSTG1(NF,ML,MMAX,IH,JH,WN02,WN01)
C
C     INITIATE WN01
C
      DO 40 I=1,NF
        WN01(I)=0
   40 CONTINUE
C
C     NUMBER OF ELEMENTS IN THE COLUMNS OF THE STRICT UPPER TRIANGLE
C
      DO 60 I=1,NF
        ISTRT=WN02(I)+1
        ISTOP=IH(I+1)-1
        DO 50 J=ISTRT,ISTOP
          K=JH(J)
          WN01(K)=WN01(K)+1
   50   CONTINUE
   60 CONTINUE
C
C     SHIFT LSUM IS USED TO MAP THE NEW STRUCTURE ONTO THE OLD ONE
C
      LSUM=0
      DO 70 I=1,NF
        LSUM=LSUM+WN01(I)
   70 CONTINUE
C
C     SHIFT OF THE ROW STRUCTURE OF THE NONSTRICT UPPER TRIANGLE
C
      DO 300 I=NF,1,-1
        ISTRT=IH(I+1)-1-LSUM
        ISTOP=WN02(I)-LSUM
        LSUM=LSUM-WN01(I)
        DO 100 J=ISTRT,ISTOP,-1
          H(IND)=H(J)
          IND=IND-1
  100   CONTINUE
        WN02(I)=IND+1
        DO 200 J=1,WN01(I)
          H(IND)=0
          IND=IND-1
  200   CONTINUE
        WN01(I)=IH(I)
  300 CONTINUE
C
C     INSERT INDICES INTO THE STRICT LOWER TRIANGLE OF THE HESSIAN
C
      DO 500 I=1,NF
        ISTRT=WN02(I)+1
        ISTOP=IH(I+1)-1
        DO 400 J=ISTRT,ISTOP
          K=JH(J)
          H(WN01(K))=J
          WN01(K)=WN01(K)+1
  400   CONTINUE
  500 CONTINUE
C
C     END OF INITIATION
C
    2 CONTINUE
      IF ( IVAR .GT. NF) GO TO 5
      DO 600 J=IVAR,NF
        IF(COL(J).GE.1) THEN
          GO TO 600
        ELSE
          JVAR=J
          GO TO 700
        ENDIF
  600 CONTINUE
  700 CONTINUE
      DO 800 J=IVAR,JVAR
      L=ABS(COL(J))
      IF (KBF.GT.0) THEN
        IF (IX(IVAR).LE.-7) GO TO 2
      ENDIF
C
C     DISPLACEMENT SELECTION
C
      XSTEP = XO(L)
      XTEMP = X(L)
      X(L) = X(L) + XSTEP
      XSTEP = X(L) - XTEMP
  800 CONTINUE
      CALL UYSET0(1,2)
      RETURN
    3 CONTINUE
C
C     UPDATE IN THE DIRECTION CORRESPONDING TO INDEX IVAR
C     RESULTING DIFFERENCE WE STORE IN GF
C
      CALL UXVDIF(NF,GF,GO,GF)
C
C     UPDATE GO
C
      CALL UXVSUM(NF,GF,GO,GO)
      A=ZERO
      IF (ITERD.NE.1) THEN
C
C     MULTIPLY TO GET THE PRODUCT H*S, WHERE S IS MULTIPLE OF ELEMENTARY
C     VECTOR
C
      CALL UXSTM2(NF,MMAX,H,IH,JH,IVAR,JVAR,COL,XO,S)
        IF (L1) C=UXVDOT(NF,XO,S)
      ELSE
        IF (ITRAN.EQ.0) THEN
          CALL UXVNEG(NF,GO,S)
        ELSE
          CALL UXVSUM(NF,GF,GO,S)
        ENDIF
        CALL UXVSCL(NF,R,S,S)
        IF (L1) C=-R*PO
      ENDIF
      IF (L1) THEN
        GAM=ONE
C
C     SELF SCALING
C
        B=XSTEP*GF(IVAR)
        IF (B.GT.ZERO.AND.C.GT.ZERO) THEN
          GAM=C/B
          CALL UXVSCL(MM,ONE/GAM,H,H)
          CALL UXVSCL(NF,ONE/GAM,S,S)
          NSCL=NSCL+1
        ENDIF
      ENDIF
      CALL UXVDIR(NF,-ONE,S,GF,S)
C
C     TOINT GROUP FRACTIONED UPDATE
C
      CALL UUSAMT(NF,MMAX,H,IH,JH,COL,XO,WN01,S,WR02,IVAR,JVAR)
      TUXX='FRC PROJ'
      NUPD=NUPD+1
      ITERH=0
C
C     RETRIEVE X
C
C     DO 900 J=IVAR,JVAR
C       L=ABS(COL(J))
C       X(L)=X(L)-XO(L)
C 900 CONTINUE
      IVAR=JVAR+1
      GO TO  2
    5 FF=FTEMP
      CALL UXVCOP(NF,WR01,GF)
C     CALL UXVSUM(NF,X,XO,X)
    6 CALL UYEPI1(-1)
C
C     SHRINK THE STRUCTURE
C
      CALL UXSTL2(NF,ML,MMAX,H,IH,JH,WN02)
      RETURN
      END
