* SUBROUTINE UUZMZ1                ALL SYSTEMS                 02/04/05
C PORTABILITY : ALL SYSTEMS
C 02/04/05 VL : ORIGINAL VERSION
*
* PURPOSE :
*   DERIVATION OF MATRIX TRANS(Z)*M*Z USED IN THE RANK TWO LIMITED
*   MEMORY METHOD FOLLOWED BY COMPUTATION OF ITS EIGENVALUES AND
*   EIGENVECTORS BY THE JACOBI METHOD.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES (NUMBER OF ROWS OF XM).
*  II  K  NUMBER OF LINEARLY INDEPENDENT COLUMNS OF AQ.
*  RI  AQ(15)  WORKSPACE ARRAY.
*  RA  ZZ(3*N) AUXILIARY ARRAY.
*  RU  S(N)  VECTORS OF VARIABLES DIFFERENCE.
*  RA  AY(N) VECTOR XM*TRANS(XM)*GO.
*  RA  BS(N)  VECTOR H**(-1)*XO.
*  RI  ZET  SHIFT PARAMETER ZETA.
*  RO  GAM  SCALING PARAMETER.
*  RU  SIG  SHIFT PARAMETER SIGMA.
*  RO  ET  BROYDEN PARAMETER.
*  RI  RO  NONQUADRATIC CORRECTION PARAMETER.
*  RI  A  INPUT PARAMETER.
*  RI  B  INPUT PARAMETER.
*  RI  AH  INPUT PARAMETER.
*  RI  AP  INPUT PARAMETER.
*  RI  BP  INPUT PARAMETER.
*  RI  CP  INPUT PARAMETER.
*
* SUBPROGRAMS USED :
*
* S   UNMINK
*
      SUBROUTINE UUZMZ1(N,K,AQ,ZZ,S,AY,BS,ZET,GAM,SIG,ET,RO,A,B,AH,AP,
     & BP,CP)
      INTEGER N,K
      REAL*8 AQ(15),AY(N),BS(N),S(N),ZZ(N*3),A,AH,AP,B,GAM,SIG,ET,ZET
      REAL*8 BP,CP,D,E,P1,P2,P3,Q1,Q2,Q3,RO,W1,W2,W3,W4,W5,W6,W7,W8,W9
      REAL*8 F(19),E1,E2
      INTEGER I,J,L
      PARAMETER (D=0.20D 0, E=0.6D 0, E1=0.25D 0, E2=1.5D 0)
      W1=0.0D 0
      W2=0.0D 0
      W3=0.0D 0
      W4=0.0D 0
      W5=0.0D 0
      W6=0.0D 0
      W7=0.0D 0
      W8=0.0D 0
      W9=0.0D 0
      DO1 I=1,N
      P1=ZZ(I)
      P2=ZZ(I+N)
      P3=ZZ(I+N+N)
      Q1=S(I)
      Q2=AY(I)
      Q3=BS(I)
      W1=W1+P1*Q1
      W2=W2+P1*Q2
      W3=W3+P1*Q3
      W4=W4+P2*Q1
      W5=W5+P2*Q2
      W6=W6+P2*Q3
      W7=W7+P3*Q1
      W8=W8+P3*Q2
   1  W9=W9+P3*Q3
      SIG=B/AH*0.4D 0
      DO10 L=1,6
      IF(L.EQ.1)ET=E1
      IF(L.EQ.2)ET=E2
      IF(L.GT.2)SIG=B/AH*(L-2)*D
      IF(L.EQ.3)THEN
        ET=E1
        IF(F(1).GE.F(2))ET=E2
      ENDIF
      IF(L.EQ.6)THEN
        CALL UNMINK(F(3),F(4),F(5),F(6),-D,D,D,E,SIG)
        SIG=SIG*B/AH
      ENDIF
      AQ(1)=ZET-RO/GAM*(SIG-W1*W1*AH/(B*(AH-B/SIG)))+W2*W2*AH*ZET/(A*AP)
     & +(W1*A/B-W2)**2*ET/A+(W1-ZET*W3-W2*BP/AP)**2*AP/(AP*CP-BP*BP)
      AQ(2)=ZET-RO/GAM*(SIG-W4*W4*AH/(B*(AH-B/SIG)))+W5*W5*AH*ZET/(A*AP)
     & +(W4*A/B-W5)**2*ET/A+(W4-ZET*W6-W5*BP/AP)**2*AP/(AP*CP-BP*BP)
      AQ(3)=ZET-RO/GAM*(SIG-W7*W7*AH/(B*(AH-B/SIG)))+W8*W8*AH*ZET/(A*AP)
     & +(W7*A/B-W8)**2*ET/A+(W7-ZET*W9-W8*BP/AP)**2*AP/(AP*CP-BP*BP)
      AQ(4)=RO/GAM*(W1*W4*AH/(B*(AH-B/SIG)))+W2*W5*AH*ZET/(A*AP)+(W1*A/B
     & -W2)*(W4*A/B-W5)*ET/A+(W1-ZET*W3-W2*BP/AP)*(W4-ZET*W6-W5*BP/AP)
     & *AP/(AP*CP-BP*BP)
      AQ(5)=RO/GAM*(W1*W7*AH/(B*(AH-B/SIG)))+W2*W8*AH*ZET/(A*AP)+(W1*A/B
     & -W2)*(W7*A/B-W8)*ET/A+(W1-ZET*W3-W2*BP/AP)*(W7-ZET*W9-W8*BP/AP)
     & *AP/(AP*CP-BP*BP)
      AQ(6)=RO/GAM*(W4*W7*AH/(B*(AH-B/SIG)))+W5*W8*AH*ZET/(A*AP)+(W4*A/B
     & -W5)*(W7*A/B-W8)*ET/A+(W4-ZET*W6-W5*BP/AP)*(W7-ZET*W9-W8*BP/AP)
     & *AP/(AP*CP-BP*BP)
      J=50
      CALL UXVJAC(K,AQ,J)
      Q1=AQ(1)
      J=1
      DO2 I=2,K
      IF(AQ(I).GT.Q1)J=I
   2  IF(AQ(I).GT.Q1)Q1=AQ(I)
      F(L)=AQ(1)**2-Q1*Q1
      DO3  I=2,K
   3  F(L)=F(L)+AQ(I)**2
  10  CONTINUE
      IF(Q1.LE.0.0D 0)AQ(J)=0.0D 0
      DO4 I=1,3
   4  AQ(6+I)=AQ(3+3*J+I)*SQRT(AQ(J))
      RETURN
      END
