* SUBROUTINE UXBSBQ                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VALUE OF A QUADRATIC FORM WITH A BLOCKED SYMMETRIC MATRIX A.
*
* PARAMETERS :
* PARAMETERS :
*  II  L  BLOCK DIMENSION.
*  II  N  VECTOR DIMENSION.
*  RI  ABL(L*(L+1)/2)  VALUES OF NONZERO ELEMENTS OF THE GIVEN BLOCK.
*  II  JBL(L)  INDICES OF THE INDIVIDUAL BLOCKS
*  RI  X(N)  UNPACKED INPUT VECTOR.
*  RI  Y(N)  UNPACKED OR PACKED OUTPUT VECTOR EQUAL TO A*X.
*  II  JOB  FORM OF THE VECTOR X. JOB=1-UNPACKED FORM. JOB=2-PACKED
*         FORM.
*
      FUNCTION UXBSBQ(L,N,ABL,JBL,X,Y,JOB)
      INTEGER L,N,JBL(L),JOB
      REAL*8 ABL(L*(L+1)/2),X(*),Y(N),UXBSBQ
      INTEGER I,J,IP,JP,K
      REAL*8 TEMP,TEMP1,TEMP2
      REAL*8 ZERO
      PARAMETER  (ZERO = 0.0D 0)
      UXBSBQ=ZERO
      K=0
      DO 4 I=1,L
      IP=JBL(I)
      TEMP=Y(IP)
      TEMP1=ZERO
      TEMP2=ZERO
      IF (JOB.EQ.1) THEN
      DO 2 J=1,I-1
      JP=JBL(J)
      K=K+1
      IF (IP.GT.0.AND.JP.GT.0) THEN
      TEMP1=TEMP1+ABL(K)*X(JP)
      TEMP2=TEMP2+ABL(K)*Y(JP)
      ENDIF
    2 CONTINUE
      K=K+1
      IF (IP.GT.0) UXBSBQ=UXBSBQ+X(IP)*(TEMP2+ABL(K)*TEMP)+TEMP*TEMP1
      ELSE
      DO 3 J=1,I-1
      JP=JBL(J)
      K=K+1
      IF (IP.GT.0.AND.JP.GT.0) THEN
      TEMP1=TEMP1+ABL(K)*X(J)
      TEMP2=TEMP2+ABL(K)*Y(JP)
      ENDIF
    3 CONTINUE
      K=K+1
      IF (IP.GT.0) UXBSBQ=UXBSBQ+X(I)*(TEMP2+ABL(K)*TEMP)+TEMP*TEMP1
      ENDIF
    4 CONTINUE
      RETURN
      END
