* SUBROUTINE UXDCMM               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A COLUMNWISE STORED DENSE RECTANGULAR MATRIX A
* BY A VECTOR X.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  M  NUMBER OF COLUMNS OF THE MATRIX A.
*  RI  A(N*M)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  RI  X(M)  INPUT VECTOR.
*  RO  Y(N)  OUTPUT VECTOR EQUAL TO A*X.
*
* SUBPROGRAMS USED :
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  S   UXVSET  INITIATION OF A VECTOR.
*
      SUBROUTINE UXDCMM(N,M,A,X,Y)
      INTEGER N,M
      REAL*8 A(N*M),X(M),Y(N)
      INTEGER J,K
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      CALL UXVSET(N,ZERO,Y)
      K=0
      DO 1 J=1,M
      CALL UXVDIR(N,X(J),A(K+1),Y,Y)
      K=K+N
    1 CONTINUE
      RETURN
      END
