* SUBROUTINE UXDCMU               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* UPDATE OF A COLUMNWISE STORED DENSE RECTANGULAR MATRIX A. THIS MATRIX
* IS UPDATED BY THE RULE A:=A+ALF*X*TRANS(Y).
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  M  NUMBER OF COLUMNS OF THE MATRIX A.
*  RU  A(N*M)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  RI  ALF  SCALAR PARAMETER.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(M)  INPUT VECTOR.
*
      SUBROUTINE UXDCMU(N,M,A,ALF,X,Y)
      INTEGER N,M
      REAL*8 A(N*M),ALF,X(N),Y(M)
      REAL*8 TEMP
      INTEGER I,J,K
      K=0
      DO 2 J=1,M
      TEMP=ALF*Y(J)
      DO 1 I=1,N
      A(K+I)=A(K+I)+TEMP*X(I)
    1 CONTINUE
      K=K+N
    2 CONTINUE
      RETURN
      END
