* SUBROUTINE UXDCMV               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* RANK-TWO UPDATE OF A COLUMNWISE STORED DENSE RECTANGULAR MATRIX A.
* THIS MATRIX IS UPDATED BY THE RULE A:=A+ALF*X*TRANS(U)+BET*Y*TRANS(V).
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  M  NUMBER OF COLUMNS OF THE MATRIX A.
*  RU  A(N*M)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  RI  ALF  SCALAR PARAMETER.
*  RI  X(N)  INPUT VECTOR.
*  RI  U(M)  INPUT VECTOR.
*  RI  BET  SCALAR PARAMETER.
*  RI  Y(N)  INPUT VECTOR.
*  RI  V(M)  INPUT VECTOR.
*
      SUBROUTINE UXDCMV(N,M,A,ALF,X,U,BET,Y,V)
      INTEGER N,M
      REAL*8 A(N*M),ALF,X(N),U(M),BET,Y(N),V(M)
      REAL*8 TEMPA,TEMPB
      INTEGER I,J,K
      K=0
      DO 2 J=1,M
      TEMPA=ALF*U(J)
      TEMPB=BET*V(J)
      DO 1 I=1,N
      A(K+I)=A(K+I)+TEMPA*X(I)+TEMPB*Y(I)
    1 CONTINUE
      K=K+N
    2 CONTINUE
      RETURN
      END
