* SUBROUTINE UXDCQM               ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR B IS PREMULTIPLIED BY THE ORTHOGONAL MATRIX TRANS(Q) AFTER QR
* DECOMPOSITION.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RI  A(M*N)  RECTANGULAR MATRIX STORED COLUMNMWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  RU  B(N)  ON INPUT THE RIGHT HAND SIDE. ON OUTPUT THE TRANSFORMED
*         RIGHT HAND SIDE.
*  RO  D(N)  VECTOR CONTAINING INFORMATION ABOUT HOUSEHOLDER
*         TRANSFORMATIONS.
*
      SUBROUTINE UXDCQM(N,M,A,B,D)
      INTEGER N,M
      REAL*8 A(N*M),B(M),D(N)
      REAL*8 POM,UXVDOT
      INTEGER K,L,KP
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      KP=N*M
      DO 3 K=N,1,-1
      KP=KP-M
      IF (D(K).NE.ZERO) THEN
      L=K+1
      IF (K.LT.M) THEN
      POM=D(K)*B(K)+UXVDOT(M-K,A(L+KP),B(L))
      ELSE
      POM=D(K)*B(K)
      ENDIF
      B(K)=B(K)-POM
      POM=POM/D(K)
      IF (K.LT.M) CALL UXVDIR(M-K,-POM,A(L+KP),B(L),B(L))
      ENDIF
    3 CONTINUE
      RETURN
      END
