* SUBROUTINE UXDCUB                ALL SYSTEMS               16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  TRANSFORMATION OF SOLUTION OBTAINED FROM THE TOTAL QR DECOMPOSITION.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M*N)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  IO  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX.
*  RU  B(M)  TRANSFORMED RIGHT HAND SIDE.
*  RU  X(N)  SOLUTION VECTOR.
*  II  NP  PSAUDORANK OF THE MATRIX A.
*  II  JOB  OPTION. IF JOB=0 THEN X:=A**(-1)*X. IF JOB>0 THEN
*         X:=TRANS(R)**(-1)*X. IF JOB<0 THEN X:=R**(-1)*X.
*
      SUBROUTINE UXDCUB(N,M,A,IA,B,X,NP,JOB)
      INTEGER N,M,IA(N),NP,JOB
      REAL*8 A(M*N),B(N),X(N)
      REAL*8 TEMP
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      INTEGER I,J,K,L,JP,KP
      IF (JOB.GE.0) THEN
      CALL UXVSET(N-NP,ZERO,X(NP+1))
      DO 2 K=1,NP
      L=IA(K)
      KP=(L-1)*M
      TEMP=B(L)
      DO 1 J=1,K-1
      TEMP=TEMP-A(KP+J)*X(J)
    1 CONTINUE
      X(K)=TEMP/A(KP+K)
    2 CONTINUE
      ENDIF
      IF (JOB.LE.ZERO) THEN
      DO 3 K=NP+1,N
      L=IA(K)
      X(L)=ZERO
    3 CONTINUE
      DO 5 K=NP,1,-1
      L=IA(K)
      KP=(L-1)*M
      TEMP=B(K)
      DO 4 J=K+1,NP
      I=IA(J)
      JP=(I-1)*M
      TEMP=TEMP-A(K+JP)*X(I)
    4 CONTINUE
      X(L)=TEMP/A(K+KP)
    5 CONTINUE
      ENDIF
      RETURN
      END
