* SUBROUTINE UXDGLF                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* FACTORIZATION A=P*L*U OF A DENSE GENERAL SQUARE MATRIX A WHERE P IS
* A PERMUTATION MATRIX, L IS A LOWER TRIANGULAR MATRIX AND U IS AN UPPER
* TRIANGULAR MATRIX,
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RU  A(N*N)  ON INPUT A GIVEN DENSE GENERAL SQUARE MATRIX A STORED IN
*         THE PACKED FORM. ON OUTPUT THE COMPUTED FACTORIZATION A=P*L*U.
*  IO  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*  IO  INF  AN INFORMATION OBTAINED IN THE FACTORIZATION PROCESS. IF
*         INF=0 THEN A IS SUFFICIENTLY NONSINGULAR. IF INF>0 THEN INF
*         IS A NUMBER OF THE ELIMINATION STEP IN WHICH A SINGULARITY
*         WAS DETECTED.
*  RI  TOL  ON INPUT A DESIRED TOLERANCE FOR POSITIVE DEFINITENESS. ON
*         OUTPUT THE MOST NEGATIVE DIAGONAL ELEMENT USED IN THE
*         FACTORIZATION PROCESS (IF INF>0).
*
* METHOD :
* GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING (LAPACK ROUTINE).
*
      SUBROUTINE UXDGLF(N,A,IA,INF,TOL)
      INTEGER N,IA(N),INF
      REAL*8 A(N,N),TOL
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      INTEGER I
      CALL DGETRF(N,N,A,N,IA,INF)
      DO 1 I=1,N
      IF (A(I,I).EQ.ZERO) A(I,I)=TOL
    1 CONTINUE
      RETURN
      END
