* FUNCTION UXDLBP                  ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER UXDLBP=TRANS(X)*D**(-1)*X WHERE D IS A
* BLOCK DIAGONAL MATRIX IN THE FACTORIZATION A=P*U*D*TRANS(U)*TRANS(P)
* OBTAINED BY THE SUBROUTINE UXDLBF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  FACTORIZATION A=P*U*D*TRANS(U)*TRANS(P) OBTAINED
*         BY THE SUBROUTINE UXDLBF.
*  II  IA(N)  PERMUTATION FIELD OBTAINED BY THE SUBROUTINE UXDLBF.
*  RI  X(N)  INPUT VECTOR.
*  RR  UXDLBP  COMPUTED NUMBER UXDLBP=TRANS(X)*D**(-1)*X.
*
      FUNCTION UXDLBP(N,A,IA,X)
      INTEGER  N,IA(N)
      REAL*8  A(N*(N+1)/2), X(N), UXDLBP
      REAL*8  TEMP,DET
      INTEGER K, KC
*
      K = N
      KC = N*( N+1 ) / 2
      TEMP = 0.0D 0
   10 CONTINUE
      IF( K.LT.1 ) GO TO 30
      IF( IA( K ).GT.0 ) THEN
*
*         1 x 1 diagonal block
*
          TEMP = TEMP + X(K)*X(K)/A(KC)
          KC = KC - K
          K = K - 1
      ELSE
*
*         2 x 2 diagonal block
*
          DET = A(KC)*A(KC-K) - A(KC-1)*A(KC-1)
          TEMP = TEMP + X(K)*X(K)*A(KC-K)/DET
          TEMP = TEMP + X(K-1)*X(K-1)*A(KC)/DET
          TEMP = TEMP + 2.0D 0*X(K)*X(K-1)*A(KC-1)/DET
          KC = KC - 2*K + 1
          K = K - 2
      END IF
      GOTO 10
   30 CONTINUE
      UXDLBP = TEMP
      RETURN
      END
