* SUBROUTINE UXDPGB                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SOLUTION OF A SYSTEM OF LINEAR EQUATIONS WITH A DENSE SYMMETRIC
* POSITIVE DEFINITE MATRIX A+E USING THE FACTORIZATION A+E=L*D*TRANS(L)
* OBTAINED BY THE SUBROUTINE UXDPGF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2) FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXDPGF.
*  RU  X(N)  ON INPUT THE RIGHT HAND SIDE OF A SYSTEM OF LINEAR
*         EQUATIONS. ON OUTPUT THE SOLUTION OF A SYSTEM OF LINEAR
*         EQUATIONS.
*  II  JOB  OPTION. IF JOB=0 THEN X:=(A+E)**(-1)*X. IF JOB>0 THEN
*         X:=L**(-1)*X. IF JOB<0 THEN X:=TRANS(L)**(-1)*X.
*
* METHOD :
* BACK SUBSTITUTION
*
      SUBROUTINE UXDPGB(N,A,X,JOB)
      INTEGER  N, JOB
      REAL*8  A(N*(N+1)/2), X(N)
      INTEGER  I, J, II, IJ
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      IF (JOB .GE. 0) THEN
C
C     PHASE 1 : X:=L**(-1)*X
C
      IJ = 0
      DO 3 I=1,N
      DO 2 J=1,I-1
      IJ = IJ + 1
      X(I) = X(I) - A(IJ)*X(J)
    2 CONTINUE
      IJ = IJ + 1
    3 CONTINUE
      ENDIF
      IF (JOB .EQ. 0) THEN
C
C     PHASE 2 : X:=D**(-1)*X
C
      II = 0
      DO 4 I=1,N
      II = II + I
      X(I) = X(I) / A(II)
    4 CONTINUE
      ENDIF
      IF (JOB .LE. 0) THEN
C
C     PHASE 3 : X:=TRANS(L)**(-1)*X
C
      II = N*(N-1)/2
      DO 6  I = N-1, 1, -1
      IJ = II
      DO 5  J = I+1, N
      IJ = IJ + J - 1
      X(I) = X(I) - A(IJ)*X(J)
    5 CONTINUE
      II = II - I
    6 CONTINUE
      ENDIF
      RETURN
      END
