* SUBROUTINE UXDPGI                ALL SYSTEMS                89/12/01
C PORTABILITY : ALL SYSTEMS
C 89/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INVERSION OF A DENSE SYMMETRIC MATRIX A+E USING THE DECOMPOSITION
*  A+E=L*D*TRANS(D) OBTAINED BY THE SUBROUTINE UXDPGF.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A
*  RU  A(N*(N+1)/2)  ON INPUT THE DECOMPOSITION A+E=L*D*TRANS(L)
*                    OBTAINED BY THE SUBROUTINE UXDPGF.
*                    ON OUTPUT THE INVERSION (A+E)**(-1).
*
* METHOD :
*  INVERSION OF THE LOWER TRIANGULAR MATRIX L AND BACK MULTIPLICATION
*  (A+E)**(-1) = TRANS(L)**(-1)*D**(-1)*L**(-1).
*
      SUBROUTINE UXDPGI(N,A)
      INTEGER  N
      REAL*8  A(N*(N+1)/2)
      REAL*8  AII,AIJ,AIK
      INTEGER  I,J,K,II,IJ,JJ,IK,KJ,KK
      REAL*8  ONE
      PARAMETER(ONE=1.0D 0)
C
C     INVERSION OF THE LOWER TRIANGULAR MATRIX L
C
      II=0
      DO 3 I=1,N
      II=II+I
      A(II)=ONE/A(II)
      IJ=II
      DO 2 J=I+1,N
      IJ=IJ+J-1
      AIJ=-A(IJ)
      IK=II
      KJ=IJ
      DO 1 K=I+1,J-1
      IK=IK+K-1
      KJ=KJ+1
      AIJ=AIJ-A(IK)*A(KJ)
    1 CONTINUE
      A(IJ)=AIJ
    2 CONTINUE
    3 CONTINUE
C
C     BACK MULTIPLICATION (A+E)**(-1)= TRANS(L**(-1))*D**(-1)*L**(-1)
C
      II=0
      DO 7 I=1,N
      II=II+I
      AII=A(II)
      IK=II
      KK=II
      DO 4 K=I+1,N
      IK=IK+K-1
      KK=KK+K
      AIK=A(IK)*A(KK)
      AII=AII+A(IK)*AIK
      A(IK)=AIK
    4 CONTINUE
      A(II)=AII
      IJ=II
      JJ=II
      DO 6 J=I+1,N
      IJ=IJ+J-1
      JJ=JJ+J
      AIJ=A(IJ)
      IK=IJ
      KJ=JJ
      DO 5 K=J+1,N
      IK=IK+K-1
      KJ=KJ+K-1
      AIJ=AIJ+A(IK)*A(KJ)
    5 CONTINUE
      A(IJ)=AIJ
    6 CONTINUE
    7 CONTINUE
      RETURN
      END
