* FUNCTION UXDPGQ                  ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER UXDPGQ=TRANS(X)*D*Y WHERE D IS A
* DIAGONAL MATRIX IN THE FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
* SUBROUTINE UXDPGF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2) FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXDPGF.
*  RI  X(N)  INPUT VECTOR.
*  RR  UXDPGQ  COMPUTED NUMBER UXDPGQ=TRANS(X)*D*Y.
*
      FUNCTION UXDPGQ(N,A,X,Y)
      INTEGER N
      REAL*8  A(N*(N+1)/2), X(N), Y(N), UXDPGQ
      REAL*8  TEMP
      INTEGER  I,J
      REAL*8 ZERO
      PARAMETER (ZERO = 0.0D 0)
      J = 0
      TEMP = ZERO
      DO  1  I = 1, N
      J = J + I
      TEMP = TEMP + X(I)*Y(I)*A(J)
    1 CONTINUE
      UXDPGQ = TEMP
      RETURN
      END
