* FUNCTION UXDRDP                  ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER UXDRDP=TRANS(X)*(D**2+ALF*I)**(-1)*Y WHERE
* I IS THE UNIT MATRIX AND D IS THE DIAGONAL OF THE MATRIX R IN THE
* FACTORIZATION A=TRANS(R)*R.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2) FACTORIZATION A=TRANS(R)*R.
*  RI  ALF  INPUT PARAMETER.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RR  UXDRDP  COMPUTED NUMBER UXDRDP=TRANS(X)*(D**2+ALF*I)**(-1)*Y.
*
      FUNCTION UXDRDP(N,A,ALF,X,Y)
      INTEGER N
      REAL*8 A(N*(N+1)/2),ALF,X(N),Y(N),UXDRDP
      REAL*8 TEMP
      INTEGER I,J
      REAL*8 ZERO,CON
      PARAMETER (ZERO=0.0D 0,CON=1.0D120)
      J=0
      TEMP=ZERO
      DO 1 I=1,N
      J=J+I
      TEMP=TEMP+X(I)*Y(I)/(A(J)**2+ALF)
    1 CONTINUE
      UXDRDP=TEMP
      RETURN
      END
