* SUBROUTINE UXDRRB                ALL SYSTEMS               16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  TRANSFORMATION OF SOLUTION OBTAINED FROM THE TOTAL QR DECOMPOSITION.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  IO  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX.
*  RU  B(M)  TRANSFORMED RIGHT HAND SIDE.
*  RU  X(N)  SOLUTION VECTOR.
*  II  NP  PSAUDORANK OF THE MATRIX A.
*
      SUBROUTINE UXDRRB(N,M,A,IA,B,X,NP)
      INTEGER N,M,IA(N),NP
      REAL*8 A(M*N),B(N),X(M)
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      INTEGER J,K,L,JP,KP
      DO 1 K=NP+1,N
      KP=IA(K)
      X(KP)=ZERO
    1 CONTINUE
      L=NP*N
      DO 3 K=NP,1,-1
      L=L-N
      KP=IA(K)
      X(KP)=B(K)
      DO 2 J=K+1,NP
      JP=IA(J)
      X(KP)=X(KP)-A(L+JP)*X(JP)
    2 CONTINUE
      X(KP)=X(KP)/A(L+KP)
    3 CONTINUE
      RETURN
      END
