* FUNCTION UXDSBP                  ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER UXDSBP=TRANS(X)*D**(-1)*Y WHERE D IS A
* BLOCK DIAGONAL MATRIX IN THE FACTORIZATION A=P*L*D*TRANS(L)*TRANS(P)
* OBTAINED BY THE SUBROUTINE UXDSBF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  FACTORIZATION A=P*L*D*TRANS(L)*TRANS(P) OBTAINED
*         BY THE SUBROUTINE UXDSBF.
*  II  IA(N)  PERMUTATION FIELD OBTAINED BY THE SUBROUTINE UXDSBF.
*  RI  X(N)  INPUT VECTOR.
*  RR  UXDSBP  COMPUTED NUMBER UXDPGP=TRANS(X)*D**(-1)*Y.
*
      FUNCTION UXDSBP(N,A,IA,X,Y)
      INTEGER  N,IA(N)
      REAL*8  A(N*(N+1)/2), X(N), Y(N), UXDSBP
      REAL*8  TEMP,DET
      INTEGER  IP,I,J,II,JJ,IJ,IND
      REAL*8 ZERO
      PARAMETER (ZERO = 0.0D 0)
      IND(I,J) = MAX(I,J) * (MAX(I,J) - 1) / 2 + MIN(I,J)
      TEMP = ZERO
      IP=1
    1 IF (IP.LE.N) THEN
      I = IA(IP)
      IF (I .GE. 0) THEN
      II = IND(I,I)
      TEMP=TEMP+X(I)*Y(I)/A(II)
      ELSE
      IP = IP + 1
      I = -I
      J = -IA(IP)
      II = IND(I,I)
      IJ = IND(I,J)
      JJ = IND(J,J)
      DET = A(II)*A(JJ) - A(IJ)*A(IJ)
      TEMP=TEMP+X(I)*(A(JJ)*Y(I)-A(IJ)*Y(J))/DET
      TEMP=TEMP+X(J)*(A(II)*Y(J)-A(IJ)*Y(I))/DET
      ENDIF
      IP=IP+1
      GO TO 1
      ENDIF
      UXDSBP=TEMP
      RETURN
      END
