* SUBROUTINE UXDSDB                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE VECTOR X:=(D+ALF*I)**(-1)*X WHERE I IS THE
* UNIT MATRIX AND D IS THE DIAGONAL MATRIX IN THE FACTORIZATION
* A+E=L*D*TRANS(L) OBTAINED BY THE SUBROUTINE UXDPGF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2) FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXDPGF.
*  RI  ALF  INPUT PARAMETER.
*  RU  X(N)  UPDATED VECTOR X:=(D+ALF*I)**(-1)*X.
*
* METHOD :
* BACK SUBSTITUTION.
*
      SUBROUTINE UXDSDB(N,A,ALF,X)
      INTEGER N
      REAL*8 A(N*(N+1)/2),ALF,X(N)
      INTEGER I,II
      II=0
      DO 4 I=1,N
      II=II+I
      X(I)=X(I)/(A(II)+ALF)
    4 CONTINUE
      RETURN
      END
