* SUBROUTINE UXDSMA             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DENSE SYMMETRIC MATRIX AUGMENTED BY THE SCALED DENSE SYMMETRIC MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRICES.
*  RI  ALF  SCALING FACTOR.
*  RI  A(N*(N+1)/2)  INPUT MATRIX.
*  RI  B(N*(N+1)/2)  INPUT MATRIX.
*  RO  C(N*(N+1)/2)  OUTPUT MATRIX WHERE C:=B+ALF*A.
*
      SUBROUTINE UXDSMA(N,ALF,A,B,C)
      INTEGER N
      REAL*8 ALF,A(N*(N+1)/2),B(N*(N+1)/2),C(N*(N+1)/2)
      INTEGER I
      DO 1 I=1,N*(N+1)/2
      C(I)=B(I)+ALF*A(I)
    1 CONTINUE
      RETURN
      END
