* SUBROUTINE UXDSRT                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* FACTORIZATION A=TRANS(P)*TRANS(R)*R*P IS TRANSFORMED TO
* A=P*L*D*TRANS(L)*TRANS(P).
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RU  A(N*(N+1)/2) FACTORIZATION OF THE MATRIX A.
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*
      SUBROUTINE UXDSRT(N,A,IA)
      INTEGER N,IA(N)
      REAL*8 A(N*(N+1)/2)
      REAL*8 TEMP
      INTEGER I,J,IP,JP,II,IJ,IND
      IND(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      DO 2 I=1,N
      IP=IA(I)
      II=IND(IP,IP)
      TEMP=A(II)
      A(II)=TEMP**2
      DO 1 J=I+1,N
      JP=IA(J)
      IJ=IND(IP,JP)
      A(IJ)=A(IJ)/TEMP
    1 CONTINUE
    2 CONTINUE
      RETURN
      END
