* SUBROUTINE UXDTTF                ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  TOTAL QR DECOMPOSITION USING HOUSEHOLDER TRANSFORMATIONS.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMERICAL RANK OF THE MATRIX A.
*  RU  A(N*(N+1)/2) UPPER TRIANGULAR MATRIX.
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*  RO  D(N)  VECTOR CONTAINING INFORMATION ABOUT HOUSEHOLDER
*         TRANSFORMATIONS.
*
      SUBROUTINE UXDTTF(N,M,A,IA,D)
      INTEGER N,M,IA(N)
      REAL*8 A(N*(N+1)/2),D(N)
      REAL*8 ALF,POM
      INTEGER I,J,K,IP,JP,KP,IJ,IK,KJ,KK,IND
      REAL*8 ZERO,ONE
      PARAMETER (ZERO=0.0D 0,ONE=1.0D 0)
      IND(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      IF(M.LT.N) THEN
      DO 8 K=M,1,-1
      KP=IA(K)
      KK=IND(KP,KP)
      POM=A(KK)**2
      DO 2 J=M+1,N
      JP=IA(J)
      KJ=IND(KP,JP)
      POM=POM+A(KJ)**2
    2 CONTINUE
      POM=SIGN(SQRT(POM),A(KK))
      A(KK)=A(KK)/POM+ONE
      DO 3 J=M+1,N
      JP=IA(J)
      KJ=IND(KP,JP)
      A(KJ)=A(KJ)/POM
    3 CONTINUE
      DO 6 I=1,K-1
      IP=IA(I)
      IK=IND(IP,KP)
      ALF=A(KK)*A(IK)
      DO 4 J=M+1,N
      JP=IA(J)
      IJ=IND(IP,JP)
      KJ=IND(KP,JP)
      ALF=ALF+A(KJ)*A(IJ)
    4 CONTINUE
      A(IK)=A(IK)-ALF
      ALF=ALF/A(KK)
      DO 5 J=M+1,N
      JP=IA(J)
      IJ=IND(IP,JP)
      KJ=IND(KP,JP)
      A(IJ)=A(IJ)-ALF*A(KJ)
    5 CONTINUE
    6 CONTINUE
      D(KP)=A(KK)
      A(KK)=-POM
    8 CONTINUE
      ENDIF
      RETURN
      END
