* SUBROUTINE UXECTF                ALL SYSTEMS               16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  TOTAL QR DECOMPOSITION USING HOUSEHOLDER TRANSFORMATIONS.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M,N)  RECTANGULAR MATRIX STORED IN THE TWO-DIMENSIONAL ARRAY.
*  RO  D(N)  VECTOR CONTAINING INFORMATION ABOUT HOUSEHOLDER
*         TRANSFORMATIONS.
*  II  NP  PSEUDORANK OF THE MATRIX A.
*
      SUBROUTINE UXECTF(M,N,A,D,NP)
      INTEGER M,N,NP
      REAL*8 A(M,N),D(N)
      INTEGER I,K,M1
      REAL*8 UXVDOG
      REAL*8 ONE,ZERO
      PARAMETER(ONE=1.0D 0,ZERO=0.0D 0)
*
*     PERFORM THE FACTORIZATION
*
      IF(NP.EQ.0) RETURN
      IF(NP.EQ.N) THEN
        DO 10 I=1,N
          D(I)=ZERO
   10   CONTINUE
      ELSE
        M1=MIN(NP+1,N)
        DO 40 K=NP,1,-1
*
*     USE A HOUSEHOLDER REFLECTION TO ZERO THE K-TH ROW OF A
*     FIRST SET UP THE REFLECTION
*
          CALL UXVORG(N-M+1,A(K,K),A(K,M1),M,D(K))
          IF ((D(K).NE.ZERO) .AND.(K.GT.1)) THEN
*
*     WE NOW PERFORM THE OPERATION A := A*P(k).
*
            CALL UXVCOP(K-1,A(1,K),D)
*
*     FORM W=A(K)+B*Z(K) IN D.
*
            DO 20 I=1,K-1
              D(I)=UXVDOG(N-M,A(I,M1),A(K,M1),M)
   20       CONTINUE
*
*     FORM A(K) := A(K)-D*W AND B := B-D*W*Z(K)'.
*
            CALL UXVDIR(K-1,-D(K),D,A(1,K),A(1,K))
            DO 30 I=1,K-1
              CALL UXVDIG(N-M,-D(K)*D(I),A(K,M1),A(I,M1),A(I,M1),M)
   30       CONTINUE
          END IF
   40   CONTINUE
      END IF
      RETURN
      END
