* SUBROUTINE UXECTM                ALL SYSTEMS               16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  TOTAL QR DECOMPOSITION USING HOUSEHOLDER TRANSFORMATIONS.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M,N)  RECTANGULAR MATRIX STORED IN THE TWO-DIMENSIONAL ARRAY.
*  RU  B(M)  ON INPUT THE RIGHT HAND SIDE. ON OUTPUT THE TRANSFORMED
*         RIGHT HAND SIDE.
*  RO  D(N)  VECTOR CONTAINING INFORMATION ABOUT HOUSEHOLDER
*         TRANSFORMATIONS.
*  IO  NP  PSEUDORANK OF THE MATRIX A.
*
      SUBROUTINE UXECTM(M,N,A,B,D,NP)
      INTEGER M,N,NP
      REAL*8 A(M,N),D(N),B(M)
      INTEGER I
      REAL*8 W,UXVDOG
      REAL*8 ONE,ZERO
      PARAMETER (ONE=1.0D 0,ZERO=0.0D 0)
      DO 30 I=NP+1,N
      B(I)=ZERO
   30 CONTINUE
      DO 40 I=NP,1,-1
      IF (D(I).EQ.ZERO) RETURN
      W=B(I)+UXVDOG(N-NP,A(I,NP+1),B(NP+1),-M)
      B(I)=B(I)-D(I)*W
      CALL UXVDIG(N-NP,-D(I)*W,A(I,NP+1),B(NP+1),B(NP+1),-M)
   40 CONTINUE
      RETURN
      END
