* SUBROUTINE UXPSMM                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A SYMMETRIC PENTADIAGONAL MATRIX A BY THE VECTOR X.
*
* PARAMETERS :
*  II  N  ORDER OF THE TRIDIAGONAL MATRIX T.
*  RI  D(N)  DIADONAL ELEMENTS OF THE MATRIX T.
*  RI  E(N)  THE FIRST SUBDIAGONAL ELEMENTS OF THE MATRIX T.
*  RI  F(N)  THE SECOND SUBDIAGONAL ELEMENTS OF THE MATRIX T.
*  RI  X(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR EQUAL TO T*X.
*
      SUBROUTINE UXPSMM(N,D,E,F,X,Z)
      INTEGER N
      REAL*8  D(N),E(N),F(N),X(N),Z(N)
      INTEGER I
      REAL*8 TEMP,TEMP1,TEMP2
      DO 1 I=1,N
      TEMP=X(I)
      IF (I.EQ.1) THEN
      Z(I)=D(I)*X(I)+E(I)*X(I+1)+F(I)*X(I+2)
      ELSE IF (I.EQ.2) THEN
      Z(I)=E(I-1)*TEMP1+D(I)*X(I)+E(I)*X(I+1)+F(I)*X(I+2)
      ELSE IF (I.LT.N-1) THEN
      Z(I)=F(I-2)*TEMP2+E(I-1)*TEMP1+D(I)*X(I)+E(I)*X(I+1)+F(I)*X(I+2)
      ELSE IF (I.LT.N) THEN
      Z(I)=F(I-2)*TEMP2+E(I-1)*TEMP1+D(I)*X(I)+E(I)*X(I+1)
      ELSE
      Z(I)=F(I-2)*TEMP2+E(I-1)*TEMP1+D(I)*X(I)
      ENDIF
      IF (I.GT.1) TEMP2=TEMP1
      TEMP1=TEMP
    1 CONTINUE
      RETURN
      END
