* SUBROUTINE UXSCDC               ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* CONVERSION OF A SPARSE RECTANGULAR MATRIX TO A DENSE RECTANGULAR
* MATRIX.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  NA NUMBER OF COLUMNS OF THE MATRIX A.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD A.
*  RI  A(MA)  RECTANGULAR MATRIX STORED AS A TWO-DIMENSIONAL ARRAY.
*  II  IA(NA+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD A.
*  II  JA(MA) COLUMN INDICES OF ELEMENTS IN THE FIELD A.
*  RO  B(N*NA)  DENSE RECTANGULAR MATRIX B := A.
*
* SUBPROGRAMS USED :
*  S   UXVSET  INITIATION OF A VECTOR.
*
      SUBROUTINE UXSCDC(N,NA,MA,A,IA,JA,B)
      INTEGER N,NA,MA,IA(NA+1),JA(MA)
      REAL*8 A(MA),B(N*NA)
      INTEGER I,J,K,L,JP
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      CALL UXVSET(N*NA,ZERO,B)
      DO 2 I=1,NA
      K=IA(I)
      L=IA(I+1)-K
      DO 1 J=1,L
      JP=JA(K)
      IF (JP.GT.0) B((I-1)*N+JP)=A(K)
      K=K+1
    1 CONTINUE
    2 CONTINUE
      RETURN
      END
