* SUBROUTINE UXSGD1                 ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 DA : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSGDB FROM UMFPACK.
*
      SUBROUTINE UXSGD1(NPIV,B,XX,II,W,X,ABLKP,AOFFP,AOFFI,
     & LUBLP,LUP,PERMR,PERMC,AOFFX,AN,ABLKS,
     & LUNS,ANZOFF,ABSPT,Z,VL)
      INTEGER AN,ABLKS,LUNS,II(*),ABLKP(ABLKS+1),NPIV,
     & AOFFP(AN+1),ANZOFF,AOFFI(*),LUBLP(ABLKS+1),
     & LUP(LUNS),PERMR(AN),PERMC(AN),I,ROW,K,M,N,
     & LXP,LIP,J,S,COL,KB,NODE,P,UXP,UIP,EP,
     & VL,M1,UXP1,PXP,K1,KI,KJ,LXP1,NODE1
      REAL*8 XX(*),AOFFX(*),B(AN),X(AN),
     & W(AN),Y,ABSPT,Z(AN),PIV,CON
      PARAMETER (CON=1.0D 120)
      DO 15 ROW = 1, AN
      W (ABS (PERMR (ROW))) = B (ROW)
15    CONTINUE
C
C     COPY THE STARTING W VECTOR INTO X, SO THAT WE CAN RECOVER
C     FROM ZERO PIVOTS
C
      DO 125 K = 1, AN
      X (K) = W (K)
125   CONTINUE
      NPIV = AN
      DO 100 KB = ABLKS, 1, -1
C
C     DO THE OFF-DIAGONAL BLOCK
C
      IF (ANZOFF .GT. 0 .AND. KB .LT. ABLKS) THEN
      DO 110 ROW = ABLKP (KB), ABLKP (KB+1) - 1
      Y = W (ROW)
      DO 120 P = AOFFP (ROW), AOFFP (ROW+1)-1
      Y = Y - W (AOFFI(P)) * AOFFX (P)
120   CONTINUE
      W (ROW) = Y
110   CONTINUE
      ENDIF
C
C     DO FORWARD-SUBSTITUTION FOR EACH ELEMENT IN LU FACTOR
C     OF DIAGONAL BLOCK
C
      K = ABLKP (KB) - 1
      DO 35 S = LUBLP (KB), LUBLP (KB+1) - 1
      EP = LUP (S)
      NODE = II((EP)+1)
      LXP = II(EP)
      LIP = ((EP)+5)
      IF (NODE .EQ. 1) THEN
C
C     ONLY ONE PIVOT, STRIDE-1 SPARSE SAXPY
C
      K = K + 1
      M = II((EP)+3) + 1
      PIV = XX (LXP)
      LXP = LXP + 1
      IF (ABS (PIV) .LE. ABSPT) THEN
C
C     (K)-TH ENTRY ON THE DIAGONAL OF U IS ZERO
C
      W (K) = X (K)
      NPIV = NPIV - 1
      ENDIF
      Y = W (K)
      DO 325 I = 2, M
      W (II (LIP)) = W (II (LIP)) - XX (LXP) * Y
      LXP = LXP + 1
      LIP = LIP + 1
325   CONTINUE
      ELSE
C
C     MORE THAN ONE PIVOT, STRIDE-1 SAXPY'S, AMORTIZED GATHER
C
      NODE1 = NODE + 1
      LIP = LIP - NODE1
      M = II((EP)+3) + NODE
      DO 111 I = 1, NODE
      Z (I) = W (K+I)
111   CONTINUE
      DO 101 I = NODE1, M
      Z (I) = W (II (LIP+I))
101   CONTINUE
      DO 20 J = 1, NODE
      PIV = XX (LXP)
      LXP = LXP + 1
      IF (ABS (PIV) .LE. ABSPT) THEN
C
C     (K+J)-TH ENTRY ON THE DIAGONAL OF U IS ZERO
C
      Z (J) = X (K+J)
      NPIV = NPIV - 1
      ENDIF
      Y = Z (J)
      DO 25 I = J+1, M
      Z (I) = Z (I) - XX (LXP) * Y
      IF (ABS(Z(I)).GE.CON) Z(I)=SIGN(CON,Z(I))
      LXP = LXP + 1
25    CONTINUE
      LXP = LXP + J
20    CONTINUE
      DO 112 I = 1, NODE
      W (K+I) = Z (I)
112   CONTINUE
      DO 102 I = NODE1, M
      W (II (LIP+I)) = Z (I)
102   CONTINUE
      K = K + NODE
      ENDIF
35    CONTINUE
C
C     DO BACK SUBSTITUTION FOR EACH ELEMENT IN LU FACTOR OF
C     DIAGONAL BLOCK
C
      DO 90 S = LUBLP (KB+1) - 1, LUBLP (KB), -1
      EP = LUP (S)
      NODE = II((EP)+1)
      LXP = II(EP)
      UIP = ((EP)+5+II((EP)+3))
      IF (NODE .EQ. 1) THEN
C
C     ONLY ONE PIVOT, STRIDE-1 SPARSE DOT PRODUCT
C
      PIV = XX (LXP)
      M = II((EP)+3) + 1
      N = II((EP)+2) + 1
      UXP = LXP + M
      IF (ABS (PIV) .GT. ABSPT) THEN
      Y = W (K)
      DO 440 J = 2, N
      Y = Y - XX (UXP) * W (II (UIP))
      UXP = UXP + 1
      UIP = UIP + 1
440   CONTINUE
      W (K) = Y / PIV
      ENDIF
      K = K - 1
      ELSE
      KJ = K
      M = II((EP)+3) + NODE
      N = II((EP)+2) + NODE
      K = K - NODE
      M1 = M + 1
      UXP = LXP + NODE*M
      PXP = LXP + (NODE-1)*M1
      LXP1 = UXP - M
      K1 = K + 1
      NODE1 = NODE + 1
C
C     DO BLOCK PART (MATRIX MULTIPLY)
C
      IF (NODE .LT. VL) THEN
C
C     NON-STRIDE-1 DOT PRODUCT, BUT LONGER LOOPS
C
      KI = K1
      DO 401 J = NODE1, N
      Z (J) = W (II (UIP))
      UIP = UIP + 1
401   CONTINUE
      DO 210 I = 1, NODE
      Y = W (KI)
      UXP1 = UXP
      DO 220 J = NODE1, N
      Y = Y - XX (UXP1) * Z (J)
      UXP1 = UXP1 + NODE
220   CONTINUE
      W (KI) = Y
      KI = KI + 1
      UXP = UXP + 1
210   CONTINUE
      ELSE
C
C     STRIDE-1 SAXPY'S
C
      DO 130 J = NODE1, N
      Y = W (II (UIP))
      UIP = UIP + 1
      DO 140 KI = K1, KJ
      W (KI) = W (KI) - XX (UXP) * Y
      UXP = UXP + 1
140   CONTINUE
130   CONTINUE
      ENDIF
C
C     DO TRIANGULAR PART (TRIANGULAR SOLVE), STRIDE-1 ACCESS
C
      DO 50 J = NODE, 1, -1
      PIV = XX (PXP)
      IF (ABS (PIV) .LE. ABSPT) THEN
      W (KJ) = X (KJ)
      KJ = KJ - 1
      ELSE
      Y = W (KJ) / PIV
      W (KJ) = Y
      KJ = KJ - 1
      LXP = LXP1
      DO 60 KI = K1, KJ
      W (KI) = W (KI) - XX (LXP) * Y
      LXP = LXP + 1
60    CONTINUE
      ENDIF
      LXP1 = LXP1 - M
      PXP = PXP - M1
50    CONTINUE
      ENDIF
90    CONTINUE
100   CONTINUE
C
C     COMPUTE THE FINAL SOLUTION, X = Q * DCOL * W
C
      DO 215 COL = 1, AN
      X (COL) = W (ABS (PERMC (COL)))
215   CONTINUE
      RETURN
      END
