* SUBROUTINE UXSGFU                 ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* UPDATE THE ORDER OF COLUMNS AND ROWS IN WHICH THEY WILL
* BE PROCESSED BY THE PIVOTING SUBROUTINE.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE SPARSE MATRIX
*  II  M  NUMBER OF PROCESSED COLUMNS THAT FORM THE COLUMS OF THE MATRIX
*         THAT DESCRIBES THE ACTIVE SET. M <= N.
*  II  P NUMBER OF ACTIVE BOUNDS.
*  II  K NUMBER OF ITERATION
*  IU  PORDC(N) INDEX VECTOR OF THE COLUMN ORDERING THAT IS UPDATED.
*  IU  ORDC(N) ORDER OF THE COLUMNS WHICH IS NOW UPDATED.
*  II  LENC(N) LENGTHS OF THE COLUMNS.
*  II  LENCH(N) LENGTHS OF THE U-PART OF THE COLUMN.
*  IU  PORDR(N) INDEX VECTOR OF THE ROW ORDERING THAT IS UPDATED.
*  IU  ORDR(N) ORDER OF THE ROWS WHICH IS NOW UPDATED.
*  II  LENR(N) LENGTHS OF THE ROWS OF THE ACTIVE MATRIX PART.
*
      SUBROUTINE UXSGFU(N,M,P,K,PORDC,ORDC,LENC,LENCH,PORDR,ORDR,
     *                  LENR)
      INTEGER N,M,P
      INTEGER PORDC(N),ORDC(N),PORDR(N),ORDR(N)
      INTEGER LENC(N),LENCH(N),LENR(N)
      INTEGER J,NI,NP,K,K1,K2,L1,L2,L3,M1
C
C     ORDC,PORDC UPDATE
C
      K2=PORDC(1)-1
      K1=K+1
      J=0
      M1=M+1
      NP=N-P
2300  IF(K1.EQ.M1) THEN
                   GO TO 2600
                   ELSE
          IF(K1.GT.K2)    THEN
                          GO TO 2500
                          ELSE
2400                      L1=ORDC(K1)
                          L2=LENC(L1)-LENCH(L1)
                          IF(L2.GT.J) THEN
                              IF(K1.EQ.K2) THEN
                                           PORDC(J+1)=K2
                                           GO TO 2500
                                           ELSE
                                           L3=ORDC(K2)
                                           ORDC(K2)=ORDC(K1)
                                           ORDC(K1)=L3
                                           PORDC(J+1)=K2
                                           K2=K2-1
                                           GO TO 2400
                              END IF
                                      ELSE
                                      K1=K1+1
                                      IF(K1.GT.K2) THEN
                                                   GO TO 2500
                                                   ELSE
                                                   GO TO 2400
                                      END IF
                          END IF
          END IF
      END IF
2500  J=J+1
      IF(J.LT.N) THEN
                 K1=PORDC(J)
                 K2=PORDC(J+1)-1
                 GO TO 2300
                 ELSE
          IF(J.EQ.N) THEN
                     K1=PORDC(J)
                     K2=M
                     GO TO 2300
          END IF
      END IF
2600  CONTINUE
      IF(J.EQ.0) THEN
                 RETURN
                 ELSE
                 J=MIN(J-1,N)
      END IF
      K1=PORDC(J)
      IF(J.NE.N) THEN
                 K2=PORDC(J+1)-1
                 ELSE
                 K2=M
      END IF
2700  IF(K1.GT.K2) THEN
                   GO TO 2900
                   ELSE
2800               L1=ORDC(K2)
                   L2=LENC(L1)-LENCH(L1)
          IF(L2.LT.J) THEN
              IF(K1.EQ.K2) THEN
                           PORDC(J)=K1+1
                           GO TO 2900
                           ELSE
                           L3=ORDC(K2)
                           ORDC(K2)=ORDC(K1)
                           ORDC(K1)=L3
                           PORDC(J)=K1+1
                           K1=K1+1
                           GO TO 2800
              END IF
                     ELSE
                      K2=K2-1
                      IF(K1.GT.K2) THEN
                                   GO TO 2900
                                   ELSE
                                   GO TO 2800
                      END IF
          END IF
      END IF
2900  J=J-1
      IF(J.GE.1) THEN
                 K1=PORDC(J)
                 K2=PORDC(J+1)-1
                 GO TO 2700
                 ELSE
          IF(J.EQ.0) THEN
                     K1=K+1
                     K2=PORDC(1)-1
                     GO TO 2700
          END IF
      END IF
C
C     ORDR,PORDR UPDATE
C
C
      K2=PORDR(1)-1
      K1=K+1
      J=0
      NI=NP+1
3000  IF(K1.EQ.NI) THEN
                   GO TO 3300
                   ELSE
          IF(K1.GT.K2)    THEN
                          GO TO 3200
                          ELSE
3100                      L1=ORDR(K1)
                          L2=LENR(L1)
                          IF(L2.GT.J) THEN
                              IF(K1.EQ.K2) THEN
                                           PORDR(J+1)=K2
                                           GO TO 3200
                                           ELSE
                                           L3=ORDR(K2)
                                           ORDR(K2)=ORDR(K1)
                                           ORDR(K1)=L3
                                           PORDR(J+1)=K2
                                           K2=K2-1
                                           GO TO 3100
                              END IF
                                      ELSE
                                      K1=K1+1
                                      IF(K1.GT.K2) THEN
                                                   GO TO 3200
                                                   ELSE
                                                   GO TO 3100
                                      END IF
                          END IF
          END IF
      END IF
3200  J=J+1
      IF(J.LT.M) THEN
                 K1=PORDR(J)
                 K2=PORDR(J+1)-1
                 GO TO 3000
                 ELSE
          IF(J.EQ.M) THEN
                     K1=PORDR(J)
                     K2=NP
                     GO TO 3000
          END IF
      END IF
3300  CONTINUE
      J=MIN(J,M)
      K1=PORDR(J)
      IF(J.NE.M) THEN
                 K2=PORDR(J+1)-1
                 ELSE
                 K2=NP
      END IF
3400  IF(K1.GT.K2) THEN
                   GO TO 3600
                   ELSE
3500               L1=ORDR(K2)
                   L2=LENR(L1)
          IF(L2.LT.J) THEN
              IF(K1.EQ.K2) THEN
                           PORDR(J)=K1+1
                           GO TO 3600
                           ELSE
                           L3=ORDR(K2)
                           ORDR(K2)=ORDR(K1)
                           ORDR(K1)=L3
                           PORDR(J)=K1+1
                           K1=K1+1
                           GO TO 3500
              END IF
                     ELSE
                      K2=K2-1
                      IF(K1.GT.K2) THEN
                                   GO TO 3600
                                   ELSE
                                   GO TO 3500
                      END IF
          END IF
      END IF
3600  J=J-1
      IF(J.GE.1) THEN
                 K1=PORDR(J)
                 K2=PORDR(J+1)-1
                 GO TO 3400
                 ELSE
          IF(J.EQ.0) THEN
                     K1=K+1
                     K2=PORDR(1)-1
                     GO TO 3400
          END IF
      END IF
      RETURN
      END
