* SUBROUTINE UXSIS3                 ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 DU : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSIBS.
* COMPRESS LISTS HELD BY UXSIS2 AND UXSIS5 IN IW AND ADJUST POINTERS
* IN IPE TO CORRESPOND.
*
      SUBROUTINE UXSIS3(N, IPE, IW, LW, IWFR)
      INTEGER N, LW
      INTEGER IPE(N)
      INTEGER IW(LW)
C
C     N IS THE MATRIX ORDER. IT IS NOT ALTERED.
C     IPE(I) POINTS TO THE POSITION IN IW OF THE START OF LIST I OR IS
C     ZERO IF THERE IS NO LIST I. ON EXIT IT POINTS TO THE NEW POSITION.
C     IW HOLDS THE LISTS, EACH HEADED BY ITS LENGTH. ON OUTPUT THE SAME
C     LISTS ARE HELD, BUT THEY ARE NOW COMPRESSED TOGETHER.
C     LW HOLDS THE LENGTH OF IW. IT IS NOT ALTERED.
C     IWFR NEED NOT BE SET ON ENTRY. ON EXIT IT POINTS TO THE FIRST FREE
C     LOCATION IN IW.
C     ON RETURN IT IS SET TO THE FIRST FREE LOCATION IN IW.
C
      INTEGER I, IERROR,  IR, IWFR,
     &        K, K1,K2,
     &        LWFR,
     &        NCMPA, NCMPBI, NCMPBR, NEIG,
     &        NIRADU,  NIRBDU, NIRNEC, NIRTOT,
     &        NRLADU,  NRLBDU,
     &        NRLNEC, NRLTOT, NTWO
      DOUBLE PRECISION OPS
      COMMON /UMMAT2/ OPS, IERROR, NRLTOT, NIRTOT, NRLNEC, NIRNEC,
     & NRLADU, NIRADU, NRLBDU, NIRBDU, NCMPA, NCMPBR, NCMPBI, NTWO,NEIG
      NCMPA = NCMPA + 1
C
C     PREPARE FOR COMPRESSING BY STORING THE LENGTHS OF THE
C     LISTS IN IPE AND SETTING THE FIRST ENTRY OF EACH LIST TO
C     -(LIST NUMBER).
C
      DO 10 I=1,N
        K1 = IPE(I)
        IF (K1.LE.0) GO TO 10
        IPE(I) = IW(K1)
        IW(K1) = -I
   10 CONTINUE
C
C     COMPRESS
C
C     IWFR POINTS JUST BEYOND THE END OF THE COMPRESSED FILE.
C     LWFR POINTS JUST BEYOND THE END OF THE UNCOMPRESSED FILE.
C
      IWFR = 1
      LWFR = IWFR
      DO 60 IR=1,N
        IF (LWFR.GT.LW) GO TO 70
C
C     SEARCH FOR THE NEXT NEGATIVE ENTRY.
C
        DO 20 K=LWFR,LW
          IF (IW(K).LT.0) GO TO 30
   20   CONTINUE
        GO TO 70
C
C     PICK UP ENTRY NUMBER, STORE LENGTH IN NEW POSITION, SET NEW POINTER
C     AND PREPARE TO COPY LIST.
C
   30   I = -IW(K)
        IW(IWFR) = IPE(I)
        IPE(I) = IWFR
        K1 = K + 1
        K2 = K + IW(IWFR)
        IWFR = IWFR + 1
        IF (K1.GT.K2) GO TO 50
C
C     COPY LIST TO NEW POSITION.
C
        DO 40 K=K1,K2
          IW(IWFR) = IW(K)
          IWFR = IWFR + 1
   40   CONTINUE
   50   LWFR = K2 + 1
   60 CONTINUE
   70 RETURN
      END
