* SUBROUTINE UXSKGN                ALL SYSTEMS                96/12/01
C PORTABILITY : ALL SYSTEMS
C 96/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SYMBOLIC TRANSFORMATION OF THE PARTITIONED KARUSH-KUHN-TUCKER MATRIX
* INTO THE COMPLETE GENERAL STRUCTURE.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE HESSIAN MATRIX.
*  RI  H(M)  NONZERO ELEMENTS OF THE HESSIAN MATRIX.
*  II  IH(N+1)  POINTERS OF THE HESSIAN MATRIX.
*  II  KH(M)  INDICES OF ELEMENTS OF THE ARRAY H IN THE ARRAY B.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS OF THE JACOBIAN MATRIX.
*  RI  CG(MC)  NONZERO ELEMENTS OF THE JACOBIAN MATRIX.
*  II  ICG(N+1)  POINTERS OF THE JACOBIAN MATRIX.
*  II  KCG(MC)  INDICES OF ELEMENTS OF THE ARRAY CG IN THE ARRAY B.
*  RO  B(2*(M+MC)-N)  NONZERO ELEMENTS OF THE GENERAL KARUSH-KUHN-TUCKER
*         MATRIX.
*  IO  IB(N+NC+1)  POINTERS OF THE GENERAL KARUSH-KUHN-TUCKER MATRIX.
*  IO  KB(N) POINTERS OF DIAGONAL ELEMENTS IN THE ARRAY B.
*         MATRIX.
*
      SUBROUTINE UXSKGN(N,M,H,IH,KH,NC,MC,CG,ICG,KCG,B,IB,KB)
      INTEGER N,M,IH(N+1),KH(M),NC,MC,ICG(NC+1),KCG(MC),
     & IB(N+NC+1),KB(N)
      REAL*8 H(M),CG(MC),B(2*(M+MC)-N)
      INTEGER I,J,KC
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
C
C     ELEMENTS OF THE MATRIX H
C
      DO 2 I=1,N
      DO 1 J=IH(I),IH(I+1)-1
      IF (J.GT.IH(I)) B(KH(J))=H(J)
      B(J+KB(I)-IH(I))=H(J)
    1 CONTINUE
    2 CONTINUE
C
C     ELEMENTS OF THE MATRIX CG
C
      DO 4 KC=1,NC
      DO 3 J=ICG(KC),ICG(KC+1)-1
      B(J+IB(N+KC)-ICG(KC))=CG(J)
      B(KCG(J))=CG(J)
    3 CONTINUE
C
C     ZERO SUBMATRIX
C
      B(IB(N+KC+1)-1)=ZERO
    4 CONTINUE
      RETURN
      END
