* SUBROUTINE UXSPCM                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A GIVEN VECTOR X BY A SPARSE SYMMETRIC POSITIVE
* DEFINITE MATRIX A+E USING THE FACTORIZATION A+E=L*D*TRANS(L) OBTAINED
* BY THE SUBROUTINE UXSPGN. FACTORS ARE STORED IN THE COMPACT FORM.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  II  MMAX  LENGTH OF THE PRINCIPAL MATRIX VECTORS (SL,A)
*  RI  A(MMAX)      FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXSPGN.IT CONTAINS THE NUMERICAL VALUES OF THE
*         FACTORS STORED IN THE COMPACT FORM ACCORDING TO THE
*         INFORMATION IN THE VECTORS PSL,SL.
*  II  PSL(N+1) POINTER ARRAY OF THE FACTORIZED SPARSE MATRIX
*  II  SL(MMAX) INDICES OF THE COMPACT SCHEME OF THE FACTORS.
*  RU  X(N)  ON INPUT THE GIVEN VECTOR, ON OUTPUT THE RESULT
*         OF MULTIPLICATION.
*  RA  RN01(N) AUXILIARY VECTOR.
*  II  JOB  OPTION. IF JOB=0 THEN X:=(A+E)*X. IF JOB>0 THEN
*         X:=TRANS(L)*X. IF JOB<0 THEN X:=L*X.
*
      SUBROUTINE UXSPCM(N,MMAX,A,PSL,SL,X,RN01,JOB)
      INTEGER N,MMAX
      INTEGER PSL(N+1),SL(MMAX),JOB
      REAL*8  A(MMAX),X(N),RN01(N),ZERO
      PARAMETER(ZERO=0.0D0)
      INTEGER I,J,IS
      DO 50 I=1,N
      RN01(I)=ZERO
 50   CONTINUE
C
C     FIRST PHASE:X=TRANS(L)*X
C
      IF (JOB.GE.0) THEN
                    DO 300 I=1,N
                    IS=SL(I)+N+1
                    DO 200 J=PSL(I)+I,PSL(I+1)+I-1
                    X(I)=X(I)+A(J)*X(SL(IS))
                    IS=IS+1
200                 CONTINUE
300                 CONTINUE
      END IF
C
C     SECOND PHASE:X=D*X
C
      IF (JOB.EQ.0) THEN
                    DO 400 I=1,N
                    X(I) = X(I)*A(PSL(I)+I-1)
400   CONTINUE
      END IF
C
C     THIRD PHASE:X=L*X
C
      IF (JOB.LE.0) THEN
                    DO 600 I=N,1,-1
                    IS=SL(I)+N+1
                    DO 500 J=PSL(I)+I,PSL(I+1)+I-1
                    RN01(SL(IS))=RN01(SL(IS))+A(J)*X(I)
                    IS=IS+1
500                 CONTINUE
600                 CONTINUE
                    DO 700 I=1,N
                    X(I)=RN01(I)+X(I)
700                 CONTINUE
      END IF
      RETURN
      END
