* SUBROUTINE UXSPML                ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SPARSE LANCZOS RECURRENCE.
*
* PARAMETERS :
*  II  N  ORDER OF THE SPARSE SYMMETRIC MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RO  D(K)  DIAGONAL ELEMENTS OF THE LANCZOS TRIDIAGONAL MATRIX.
*  RO  E(K)  SUBDIAGONAL ELEMENTS OF THE LANCZOS TRIDIAGONAL MATRIX.
*  RO  V(N*K)  LANCZOS VECTORS.
*  II  K  NUMBER OF LANCZOS STEPS.
*  IO  INF  ERROR INDICATOR.
*
      SUBROUTINE UXSPML(N,M,A,IA,JA,D,E,V,K,INF)
      INTEGER N,M,IA(N+1),JA(M),K,INF
      REAL*8  A(M),D(K),E(K),V(N*K)
      REAL*8  DI,EI,UXVDOT,UXVNOR,UXSSMQ
      REAL*8 ZERO,ONE
      INTEGER I,L,L1
      PARAMETER (ZERO=0.0D 0,ONE=1.0D 0)
      L=1
      INF=0
      EI=UXVNOR(N,V)
      DO 1 I=1,K
      L1=L+N
      CALL UXVSCL(N,ONE/EI,V(L),V(L))
      IF (I.LT.K) THEN
      IF (I.GT.1) THEN
      CALL UXVSCL(N,-EI,V(L-N),V(L1))
      ELSE
      CALL UXVSET(N,ZERO,V(L1))
      ENDIF
      CALL UXSSMD(N,M,A,IA,JA,V(L),ONE,V(L1),V(L1))
      DI=UXVDOT(N,V(L),V(L1))
      CALL UXVDIR(N,-DI,V(L),V(L1),V(L1))
      EI=UXVNOR(N,V(L1))
      IF (EI.LE.ZERO) THEN
      INF=I
      RETURN
      ENDIF
      ELSE
      DI=UXSSMQ(N,M,A,IA,JA,V(L),V(L))
      IF (I.GT.1) DI=DI-EI*UXVDOT(N,V(L),V(L-N))
      ENDIF
      D(I)=DI
      E(I)=EI
      L=L1
    1 CONTINUE
      RETURN
      END
