* SUBROUTINE UXSRB0                ALL SYSTEMS               91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*   QUOTIENT GRAPH UPDATE AFTER A STEP OF MINIMUM DEGREE
*   ALGORITHM. BASED ON SPARSPAK.
*
*  PARAMETERS :
*  II  ROOT THE NODE JUST ELIMINATED. IT BECOMES THE
*        REPRESENTATIVE OF THE NEW SUPERNODE.
*  II  XADJ(N+1) POINTER VECTOR FOR THE ADJACENCY STRUCTURE.
*  IU  ADJNCY(*) ADJACENCY STRUCTURE OF THE INPUT GRAPH.
*  II  RCHSZE SIZE OF THE REACHABLE SET OF ROOT.
*  II  RCHSET(N) REACHABLE SET OF ROOT.
*  II  NBRHD(N) NEIGHBORHOOD TO BE MERGED WITH ROOT.
*
* SEE GEORGE-LIU: SPARSPAK
*
      SUBROUTINE  UXSRB0 ( ROOT, XADJ, ADJNCY, MARKER,
     *                    RCHSZE, RCHSET, NBRHD )
C
         INTEGER ADJNCY(*), MARKER(*), RCHSET(*), NBRHD(*)
         INTEGER XADJ(*), INHD, IRCH, J, JSTRT, JSTOP, LINK,
     *           NABOR, NODE, RCHSZE, ROOT
C
C
         IRCH = 0
         INHD = 0
         NODE = ROOT
  100    JSTRT = XADJ(NODE)
         JSTOP = XADJ(NODE+1) - 2
         IF ( JSTOP .LT. JSTRT )  GO TO 300
C
C PLACE REACH NODES INTO THE ADJACENT LIST OF NODE
C
            DO 200 J = JSTRT, JSTOP
               IRCH = IRCH + 1
               ADJNCY(J) = RCHSET(IRCH)
               IF ( IRCH .GE. RCHSZE )  GOTO 400
  200       CONTINUE
C
C LINK TO OTHER SPACE PROVIDED BY THE NBRHD SET.
C
  300    LINK = ADJNCY(JSTOP+1)
         NODE = - LINK
         IF ( LINK .LT. 0 )  GOTO 100
            INHD = INHD + 1
            NODE = NBRHD(INHD)
            ADJNCY(JSTOP+1) = - NODE
            GO TO 100
C
C ALL REACHABLE NODES HAVE BEEN SAVED.  END THE ADJ LIST.
C ADD ROOT TO THE NBR LIST OF EACH NODE IN THE REACH SET.
C
  400    ADJNCY(J+1) = 0
         DO 600 IRCH = 1, RCHSZE
            NODE = RCHSET(IRCH)
            IF ( MARKER(NODE) .LT. 0 )  GOTO 600
               JSTRT = XADJ(NODE)
               JSTOP = XADJ(NODE+1) - 1
               DO 500 J = JSTRT, JSTOP
                  NABOR = ADJNCY(J)
                  IF ( MARKER(NABOR) .GE. 0 ) GO TO 500
                     ADJNCY(J) = ROOT
                     GOTO 600
  500          CONTINUE
  600    CONTINUE
         RETURN
      END
