* SUBROUTINE UXSRBE                ALL SYSTEMS               91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  SYMBOLIC FACTORIZATION. TAKEN FROM SPARSPAK.
*
*  PARAMETERS :
*  II  NEQNS NUMBER OF VARIABLES.
*  II  XADJ(N+1) POINTER VECTOR FOR THE ADJACENCY STRUCTURE.
*  II  ADJNCY(*) ADJACENCY STRUCTURE OF THE INPUT GRAPH.
*  II  PERM(N)  PERMUTATION VECTOR.
*  II  INVP(N)  INVERSE PERMUTATION VECTOR.
*  II  MAXSUB  SIZE OF THE SUBSCRIPT VECTOR NZSUB.
*  IO  XLNZ(*) POINTERS FOR THE FACTOR ELEMENTS.
*  IO  XNZSUB(N+1)  POINTERS TO THE COMPRESSED SUBSCRIPT VECTORS.
*  IO  NZSUB(*) COMPRESSED SUBSCRIPT VECTORS.
*  IO  MAXLNZ  NUMBER OF NONZEROS IN THE FACTOR L.
*  IO  FLAG  ERROR FLAG.
*  IA  MRGLNK(N) AUXILIARY VECTOR.
*  IA  RCHLNK(N) AUXILIARY VECTOR.
*  IA  MARKER(N) AUXILIARY VECTOR.
*
* SEE GEORGE-LIU: SPARSPAK
*
      SUBROUTINE  UXSRBE ( NEQNS, XADJ, ADJNCY, PERM, INVP,
     1                     XLNZ, MAXLNZ, XNZSUB, NZSUB, MAXSUB,
     1                     RCHLNK, MRGLNK, MARKER, FLAG )
C
         INTEGER    ADJNCY(*), INVP(*)  , MRGLNK(*), NZSUB(*) ,
     1              PERM(*)  , RCHLNK(*), MARKER(*)
         INTEGER    XADJ(*)  , XLNZ(*)  , XNZSUB(*)
         INTEGER    FLAG  , I     , INZ   , J     , JSTOP ,
     1              JSTRT , K     , KNZ   , KXSUB , LMAX  ,
     1              M     , MAXLNZ, MAXSUB, MRGK  , MRKFLG,
     1              NABOR , NEQNS , NODE  , NP1   , NZBEG ,
     1              NZEND , RCHM
C
         IF  ( NEQNS .LE. 0 )  RETURN
C
C        INITIALIZATION ...
C
         NZBEG = 1
         NZEND = 0
         XLNZ(1) = 1
         DO  100  K = 1, NEQNS
             MRGLNK(K) = 0
             MARKER(K) = 0
  100    CONTINUE
C
C        FOR EACH COLUMN ... KNZ COUNTS THE NUMBER
C        OF NONZEROS IN COLUMN K ACCUMULATED IN RCHLNK.
C
         NP1 = NEQNS + 1
         DO  1700  K = 1, NEQNS
             KNZ = 0
             MRGK = MRGLNK(K)
             MRKFLG = 0
             MARKER(K) = K
             IF  ( MRGK .NE. 0 )  MARKER(K) = MARKER(MRGK)
             XNZSUB(K) = NZEND
             NODE = PERM(K)
             JSTRT = XADJ(NODE)
             JSTOP = XADJ(NODE+1) - 1
             IF  ( JSTRT .GT. JSTOP )  GO TO 1600
C
C                USE RCHLNK TO LINK THROUGH THE
C                STRUCTURE OF A(*,K) BELOW DIAGONAL.
C
                 RCHLNK(K) = NP1
                 DO  300  J = JSTRT, JSTOP
                     NABOR = ADJNCY(J)
                     NABOR = INVP(NABOR)
                     IF  ( NABOR .LE. K )  GO TO 300
                         RCHM = K
  200                    CONTINUE
                             M = RCHM
                             RCHM = RCHLNK(M)
                             IF  ( RCHM .LE. NABOR )  GO TO 200
                         KNZ = KNZ+1
                         RCHLNK(M) = NABOR
                         RCHLNK(NABOR) = RCHM
                         IF  ( MARKER(NABOR) .NE. MARKER(K) )
     1                       MRKFLG = 1
  300            CONTINUE
C
C                TEST FOR MASS SYMBOLIC ELIMINATION ...
C
                 LMAX = 0
                 IF  ( MRKFLG .NE. 0  .OR.  MRGK .EQ. 0 )  GO TO 400
                 IF  ( MRGLNK(MRGK) .NE. 0 )  GO TO 400
                     XNZSUB(K) = XNZSUB(MRGK) + 1
                     KNZ = XLNZ(MRGK+1) - (XLNZ(MRGK) + 1)
                     GO TO 1500
  400            CONTINUE
C
C                LINK THROUGH EACH COLUMN I THAT AFFECTS L(*,K).
C
                 I = K
  500            CONTINUE
                     I = MRGLNK(I)
                     IF  ( I .EQ. 0 )  GO TO 900
                         INZ = XLNZ(I+1) - (XLNZ(I) + 1)
                         JSTRT = XNZSUB(I) +  1
                         JSTOP = XNZSUB(I) + INZ
                         IF  ( INZ .LE. LMAX )  GO TO 600
                             LMAX = INZ
                             XNZSUB(K) = JSTRT
  600                    CONTINUE
C
C                        MERGE STRUCTURE OF L(*,I) IN NZSUB
C                        INTO RCHLNK.
C
                         RCHM = K
                         DO  800  J = JSTRT, JSTOP
                             NABOR = NZSUB(J)
  700                        CONTINUE
                                 M = RCHM
                                 RCHM = RCHLNK(M)
                                 IF  ( RCHM .LT. NABOR )  GO TO 700
                             IF  ( RCHM .EQ. NABOR )  GO TO 800
                                 KNZ = KNZ+1
                                 RCHLNK(M) = NABOR
                                 RCHLNK(NABOR) = RCHM
                                 RCHM = NABOR
  800                    CONTINUE
                         GO TO 500
  900            CONTINUE
C
C                CHECK IF SUBSCRIPTS DUPLICATE THOSE
C                OF ANOTHER COLUMN.
C
                 IF  ( KNZ .EQ. LMAX )  GO TO 1500
C
C                    OR IF TAIL OF K-1ST COLUMN MATCHES HEAD OF KTH.
C
                     IF  ( NZBEG .GT. NZEND )  GO TO 1300
                         I = RCHLNK(K)
                         DO  1000  JSTRT = NZBEG, NZEND
                             IF  ( NZSUB(JSTRT) .EQ. I )  GO TO 1100
                             IF  ( NZSUB(JSTRT) .GT. I )  GO TO 1300
 1000                    CONTINUE
                         GO TO 1300
 1100                    CONTINUE
                         XNZSUB(K) = JSTRT
                         DO  1200  J = JSTRT, NZEND
                             IF  ( NZSUB(J) .NE. I )  GO TO 1300
                                 I = RCHLNK(I)
                                 IF  ( I .GT. NEQNS )  GO TO 1500
 1200                    CONTINUE
                         NZEND = JSTRT - 1
 1300                CONTINUE
C
C                    COPY THE STRUCTURE OF L(*,K) FROM RCHLNK
C                    TO THE DATA STRUCTURE (XNZSUB, NZSUB).
C
                     NZBEG = NZEND +  1
                     NZEND = NZEND + KNZ
                     IF  ( NZEND .GT. MAXSUB )  GO TO 1800
                         I = K
                         DO  1400  J = NZBEG, NZEND
                             I = RCHLNK(I)
                             NZSUB(J) = I
                             MARKER(I) = K
 1400                    CONTINUE
                         XNZSUB(K) = NZBEG
                         MARKER(K) = K
 1500            CONTINUE
C
C                UPDATE THE VECTOR MRGLNK.  NOTE COLUMN L(*,K)
C                JUST FOUND IS REQUIRED TO DETERMINE COLUMN
C                L(*,J), WHERE L(J,K) IS THE FIRST NONZERO IN
C                L(*,K) BELOW DIAGONAL.
C
                 IF  ( KNZ .LE. 1 )  GO TO 1600
                     KXSUB = XNZSUB(K)
                     I = NZSUB(KXSUB)
                     MRGLNK(K) = MRGLNK(I)
                     MRGLNK(I) = K
 1600        CONTINUE
             XLNZ(K+1) = XLNZ(K) + KNZ
 1700    CONTINUE
         MAXLNZ = XLNZ(NEQNS) - 1
         MAXSUB = XNZSUB(NEQNS)
         XNZSUB(NEQNS+1) = XNZSUB(NEQNS)
         FLAG = 0
         RETURN
C
 1800    CONTINUE
C
C        ERROR - INSUFFICIENT STORAGE FOR NONZERO SUBSCRIPTS.
C
         FLAG = 51
         CALL UOERR1('UXSRBE',51)
         RETURN
C
      END
