* SUBROUTINE  UXSRO3            ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :  MASKED OF NODES IN ADJACENCY LEVELS OF THE SEPARATOR
*
*  PARAMETERS :
*  II  K  NUMBER OF FIRST FREE BLOCK IN PERM.
*  II  PERM,IPERM  THE NESTED DISSECTION ORDERING.
*  IO  MASK  MASK VECTOR.
*  II  XLS,LS  THIS LEVEL STRUCTURE PAIR IS USED AS
*              TEMPORARY STORAGE .
*  II  NSEP  NUMBER OF NODES IN SEPARATOR
*  II  LEVEL  NUMBER OF LEVEL INSERTS TO THE SEPARATOR.
C
      SUBROUTINE UXSRO3(K,MASK,XLS,LS,PERM,IPERM,NSEP,LEVEL,
     1   LABEL,NLVL,SON)
      INTEGER MASK(*),XLS(*),LS(*),PERM(*),IPERM(*),
     1   LABEL(*),SON(*)
      INTEGER I,J,BPERM,BLOCK,LVL,K,NSEP,LEVEL,NLVL
C  ---------------------------
C  BEGIN OF FREE PART IN PERM.
C  ---------------------------
      BPERM = (K-1) * 3 + 1
C
C  DOPLNENI SEPARATORU
C
      IF (NSEP .LT. XLS(LEVEL+1)-XLS(LEVEL)) THEN
        NSEP = XLS(LEVEL+1) - XLS(LEVEL)
        BLOCK = 0
        DO 50 I=XLS(LEVEL), XLS(LEVEL+1) - 1
          PERM(IPERM(BPERM)+BLOCK) = LS(I)
          BLOCK = BLOCK + 1
          MASK(LS(I)) = 0
   50   CONTINUE
      END IF
C
      IPERM(BPERM+1) = IPERM(BPERM) + NSEP
      IF (LEVEL .GT. 1) THEN
        LVL = LEVEL - 1
        BLOCK = 0
        DO 120 I=XLS(LVL), XLS(LVL+1) - 1
            PERM(IPERM(BPERM+1)+BLOCK) = LS(I)
            BLOCK = BLOCK + 1
            MASK(LS(I)) = 0
  120   CONTINUE
        IPERM(BPERM+2) = IPERM(BPERM+1) + BLOCK
        LVL = LEVEL + 1
        BLOCK = 0
        DO 130 I=XLS(LVL), XLS(LVL+1) - 1
            PERM(IPERM(BPERM+2)+BLOCK) = LS(I)
            BLOCK = BLOCK + 1
            MASK(LS(I)) = 0
  130   CONTINUE
        IPERM(BPERM+3) = IPERM(BPERM+2) + BLOCK
C  ------------------
C  SET LABEL AND SON.
C  ------------------
        J = LABEL(PERM(IPERM(BPERM)))
        SON(J) = 1
        DO 150 I=IPERM(BPERM+1) , IPERM(BPERM+2) - 1
          LABEL(PERM(I)) = -(J * 2)
  150   CONTINUE
        DO 160 I=IPERM(BPERM+2) , IPERM(BPERM+3) - 1
          LABEL(PERM(I)) = -(J * 2 + 1)
  160   CONTINUE
        DO 170 I=1, XLS(LEVEL+1) - 1
          IF (MASK(LS(I)) .EQ. 1) THEN
            LABEL(LS(I)) = J * 2
          END IF
  170   CONTINUE
        DO 180 I=XLS(LEVEL+2), XLS(NLVL+1) - 1
          LABEL(LS(I)) = J * 2 + 1
  180   CONTINUE
C
      ELSE
        DO 300 I=1, 2
          IPERM(BPERM+I+1) = IPERM(BPERM+1)
  300   CONTINUE
      END IF
      RETURN
      END
