* SUBROUTINE  UXSRSC               ALL SYSTEMS               95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :  CREATE COLUMN STRUCTURE OF THE MATRIX.
*
*  PARAMETERS :
*  II  N NUMBER OF COLUMNS OF THE MATRIX.
*  II  M NUMBER OF ROWS OF THE MATRIX.
*  II  NJA NUMBER OF NONZEROS MEMBERS IN THE MATRIX.
*  II  IA(M+1) ROW POINTERS OF THE SPARSE MATRIX.
*  II  JA(NJA) COLUMN INDICES OF THE SPARSE MATRIX.
*  II  IB(N+1) COLUMN POINTERS OF THE SPARSE MATRIX.
*  II  JB(NJA) ROW INDICES OF THE SPARSE MATRIX.
*  IA  WN01(N) AUXILIARY VECTOR.
*
      SUBROUTINE UXSRSC(N,M,NJA,IA,JA,IB,JB,WN01)
      INTEGER N,M,NJA,IA(M+1),JA(NJA),IB(N+1),JB(NJA),WN01(N)
      INTEGER I,J,NUM
C   -------------
C   INITIATE WN01
C   -------------
      DO 50 I=1,N
        WN01(I) = 0
   50 CONTINUE
C   --------------------------------------
C   NUMBER OF NONZEROS MEMBERS ON THE COLUMNS
C   --------------------------------------
      DO 100 I=1, NJA
        WN01(JA(I))=WN01(JA(I)) + 1
  100 CONTINUE
C   --------------------------
C   FIND INDICES TO ARRAY IA
C   --------------------------
      IB(1)=1
      DO 200 I=1,N
        IB(I+1)=IB(I) + WN01(I)
        WN01(I) = 0
  200 CONTINUE
C   --------------------------------------------------------
C   FIND POSITIONS OF NONZEROS MEMBERS ON THE ARRAY JB AND
C   ORDERING OF VALUES ON THE ARRAY B BY ARRAY A.
C   --------------------------------------------------------
      DO 250 I=1,N
        WN01(I)=IB(I) - 1
  250 CONTINUE
      DO 300 I=1,M
        NUM=0
        DO 400 J=IA(I), IA(I+1)-1
          WN01(JA(J)) = WN01(JA(J)) + 1
          JB(WN01(JA(J))) = I
          NUM = NUM + 1
  400   CONTINUE
  300 CONTINUE
      RETURN
      END
