* FUNCTION UXSSM1                  ALL SYSTEMS                88/12/01
C PORTABILITY : ALL SYSTEMS
C 88/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* L1 NORM OF A SPARSE SYMMETRIC MATRIX
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A
*  II  PA(N+1)  POINTER VECTOR OF THE SPARSE MATRIX SCHEME.
*  RI  A(MMAX) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      USUAL FORM.
*  II  MMAX  LENGTH OF THE PRINCIPAL MATRIX VECTORS (SA,A)
*  RR  UXSSM1  L1 NORM OF THE MATRIX A
*
      FUNCTION UXSSM1(N,PA,A,MMAX)
      INTEGER  N,MMAX
      REAL*8  A(MMAX), UXSSM1
      REAL*8  TEMP1, TEMP2
      INTEGER PA(N+1)
      INTEGER  I,J
      REAL*8 ZERO
      PARAMETER  (ZERO = 0.0D0)
      TEMP1 = ZERO
      DO  200 I=1,N
      TEMP2 = ZERO
      DO  100 J=PA(I),PA(I+1)-1
      TEMP2=TEMP2+ABS(A(J))
100   CONTINUE
      TEMP1=MAX(TEMP1,TEMP2)
200   CONTINUE
      UXSSM1 = TEMP1
      RETURN
      END
