* SUBROUTINE UXSSMP                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DIAGONAL PRECONDITIONING USING A SPARSE SYMMETRIC MATRIX A.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  IU  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  RI  X(N)  INPUT VECTOR.
*  RO  Y(N)  OUTPUT VECTOR Y=D**(-1)*X WHERE D IS THE DIAGONAL OF THE
*         MATRIX A.
*
      SUBROUTINE UXSSMP(N,M,A,IA,X,Y)
      INTEGER N,M,IA(N)
      REAL*8  A(M),X(N),Y(N)
      REAL*8 TEMP
      INTEGER I,K
      REAL*8 ZERO,ONE
      PARAMETER (ZERO=0.0D 0,ONE=1.0D 0)
      DO 200 I=1,N
      K=ABS(IA(I))
      TEMP=A(K)
      IF (TEMP.LE.ZERO) TEMP=ONE
      Y(I)=X(I)/TEMP
200   CONTINUE
      RETURN
      END
