* SUBROUTINE UXSSMU                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* CORRECTION OF A SPARSE SYMMETRIC MATRIX A. THE CORRECTION IS DEFINED
* AS A:=A+ALF*X*TRANS(X) WHERE ALF IS A GIVEN SCALING FACTOR AND X IS
* A GIVEN VECTOR.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RI  X(N)  VECTOR IN THE CORRECTION TERM.
*
      SUBROUTINE UXSSMU(N,M,A,IA,JA,ALF,X)
      INTEGER  N,M,IA(N+1),JA(M)
      REAL*8  A(M),X(N),ALF
      INTEGER I,J,K,JSTRT,JSTOP
      JSTOP=0
      DO 200 I=1,N
        JSTRT=JSTOP+1
        JSTOP=IA(I+1)-1
        IF (JA(JSTRT).GT.0) THEN
          DO 100 J=JSTRT,JSTOP
            K=JA(J)
            IF (K.GT.0) A(J)=A(J)+ALF*X(I)*X(K)
100       CONTINUE
        ENDIF
200   CONTINUE
      RETURN
      END
