* SUBROUTINE UXSSMV                ALL SYSTEMS                06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
* SPARSE SYMMETRIC MATRIX A IS AUGMENTED BY ONE ROW AND ONE COLUMN
* DEFINED BOTH BY VECTOR X.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  II  IA(N+1)  POINTERS OF DIAGONAL ELEMENTS OF A.
*  RU  B(M+N+1) ELEMENTS OF AUGMENTED SPARSE SYMMETRIC MATRIX B STORED
*      IN PACKED FORM.
*  IU  IB(N+2)  POINTERS OF DIAGONAL ELEMENTS OF B.
*  IU  JB(M+N+1)  INDICES OF THE NONZERO ELEMENTS OF B.
*  RI  X(N)  INPUT VECTOR.
*
      SUBROUTINE UXSSMV(N,M,IA,B,IB,JB,X)
      INTEGER N,M,IA(N+1),IB(N+2),JB(M+N+1),
     & I,J,POSUN,TEMPA,TEMPB
      REAL*8 B(M+N+1),X(N+1),EPSZR
      PARAMETER (EPSZR=1.0D-6)
      IB(1)=1
      POSUN=0
      TEMPA=1
      DO I=1,N
      TEMPB=IA(I+1)-TEMPA+IB(I)
      TEMPA=IA(I+1)
      IF (DABS(X(I)).GT.EPSZR) THEN
      IB(I+1)=TEMPB+1
      DO J=M,TEMPA,-1
      B(J+POSUN+1)=B(J+POSUN)
      JB(J+POSUN+1)=JB(J+POSUN)
      ENDDO
      B(TEMPA+POSUN)=X(I)
      JB(TEMPA+POSUN)=N+1
      POSUN=POSUN+1
      ELSE
      IB(I+1)=TEMPB
      ENDIF
      ENDDO
      IB(N+2)=IB(N+1)+1
      B(IB(N+1))=X(N+1)
      JB(IB(N+1))=N+1
      END
