* SUBROUTINE UXSTL2                ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* PACKING OF THE WIDTHENED FORM OF THE VECTORS A,IA,JA OF THE SPARSE
* MATRIX
*
* PARAMETERS :
*  II  N ORDER OF THE SPARSE MATRIX.
*  IU  M NUMBER OF NONZERO ELEMENTS IN THE MATRIX.
*  II  MMAX LENGTH OF THE ARRAY JA.
*  RU  A(MMAX) VECTOR OF NUMERICAL VALUES OF THE MATRIX BEING SHRINKED.
*  IU  IA(N+1) POINTER VECTOR OF THE INPUT MATRIX.
*  IU  JA(MMAX) VECTOR OF THE COLUMN INDICES OF THE INPUT MATRIX.
*  IA  PD(N+1) AUXILIARY VECTOR.
*
      SUBROUTINE UXSTL2(N,M,MMAX,A,IA,JA,PD)
      INTEGER N,M,MMAX
      INTEGER IA(N+1),PD(N+1),JA(MMAX)
      REAL*8 A(MMAX)
      INTEGER I,J,L,JSTRT,JSTOP
      L=1
C
C PD DEFINITION
C
      JSTOP=0
      DO 60 I=1,N
        JSTRT=JSTOP+1
        JSTOP=IA(I+1)-1
        DO 50 J=JSTRT,JSTOP
          IF(ABS(JA(J)).EQ.I) THEN
            PD(I)=J
            GO TO 60
          END IF
   50    CONTINUE
   60 CONTINUE
C
C REWRITE THE STRUCTURE
C
      DO 200 I=1,N
        DO 100 J=PD(I),IA(I+1)-1
        JA(L)=JA(J)
        A(L)=A(J)
        L=L+1
100     CONTINUE
      IA(I+1)=L
200   CONTINUE
      IA(1)=1
C
C SET THE LENGTH OF THE PACKED STRUCTURE
C
      M=L-1
      RETURN
      END
