* SUBROUTINE UXSTM1                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A SPARSE SYMMETRIC MATRIX WITH NUMERICAL ELEMENTS
* STORED IN THE INDEX/VALUE STRUCTURE BY THE MULTIPLE OF UNIT VECTOR.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  II  IVAR INDEX OF THE UNIT VECTOR.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RI  STEMP FACTOR OF THE UNIT VECTOR.
*  RO  Y(N)  OUTPUT VECTOR WHERE Y := A * X.
*
      SUBROUTINE UXSTM1(N,M,IVAR,A,IA,JA,STEMP,Y)
      INTEGER N,M,IA(N+1),JA(M),IVAR
      REAL*8  A(M),Y(N),STEMP
      REAL*8 ZERO
      INTEGER I,J,K,L,ISTRT,ISTOP
      PARAMETER   (ZERO = 0.0D 0)
C
C INITIATE
C
      DO 100 I=1,N
      Y(I)=ZERO
100   CONTINUE
C
C MULTIPLY
C
      ISTRT=IA(IVAR)
      ISTOP=IA(IVAR+1)-1
      DO 300 I=ISTRT,ISTOP
        J=JA(I)
        IF(J.GE.IVAR) GO TO 400
        K=A(I)
        Y(J)=A(K)*STEMP
  300 CONTINUE
  400 CONTINUE
      DO 500 J=I,ISTOP
        L=JA(J)
        Y(L)=A(J)*STEMP
  500 CONTINUE
      RETURN
      END
