* SUBROUTINE UXTPGD                ALL SYSTEMS                03/12/01
C PORTABILITY : ALL SYSTEMS
C 03/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF A DIRECTION OF NEGATIVE CURVATURE FOR A
* DECOMPOSED TRIDIAGONAL MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE TRIDIAGONAL MATRIX T.
*  RI  E(N)  SUBDIAGONAL ELEMENTS OF THE LOWER TRIANGULAR MATRIX L IN
*         THE DECOMPOSITION T=L*TRANS(L).
*  RO  X(N)  COMPUTED DIRECTION OF NEGATIVE CURVATURE (I.E.
*         TRANS(X)*A*X<0) IF IT EXISTS.
*  II  INF  INFORMATION OBTAINED IN THE FACTORIZATION PROCESS. THE
*         DIRECTION OF NEGATIVE CURVATURE EXISTS ONLY IF INF>0.
*
      SUBROUTINE UXTPGD(N,E,X,INF)
      INTEGER N,INF
      REAL*8 E(N),X(N)
      INTEGER I
      DO 1 I=1,N
      X(I) = 0.0D 0
    1 CONTINUE
      IF (INF .LE. 0) RETURN
      X(INF) = 1.0D 0
C
C     BACK SUBSTITUTION
C
      DO 3 I=INF-1,1,-1
      X(I)=X(I)-X(I+1)*E(I)
    3 CONTINUE
      RETURN
      END
