* SUBROUTINE UXVREF                ALL SYSTEMS                95/02/24
C PORTABILITY : ALL SYSTEMS
C 95/02/24 RO : ORIGINAL VERSION
*
* PURPOSE :
* HOUSEHOLDER PREMULTIPLICATION OF THE VECTOR X BY THE HOUSEHOLDER
* TRANSFORMATION WITH THE HOUSEHOLDER VECTOR WITH FIRST I-1 ZERO
* COMPONENTS AND STORED WITHOUT ONE AT THE THE COMPONENT I.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  II  I  INDEX OF THE (I)-TH COMPONENT.
*  RI  Y(N-I) HOUSEHOLDER VECTOR. I-TH COMPONENT IS NOT STORED (=1).
*  RI  X(N)  INPUT VECTOR.
*  RO  Z(N) OUTPUT VECTOR Z=P*X WHERE P=I-2*V*V^T/V^T*V.
*
* SUBPROGRAMS USED :
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  S   UXVCOP  COPYING OF A VECTOR.
*  RF  UXVDOT  DOT PRODUCT OF VECTORS.
*
      SUBROUTINE UXVREF(N,I,Y,X,Z)
      INTEGER N,I
      REAL*8  Z(N),X(N),Y(N-I)
      REAL*8 BET,UXVDOT
      REAL*8 ZERO,ONE
      PARAMETER (ZERO=0.0D 0,ONE=1.0D 0)
      IF (I .LT. N) THEN
        BET=-2/(1+UXVDOT(N-I,Y,Y))
        BET=BET*(X(I)+UXVDOT(N-I,X(I+1),Y))
        CALL UXVDIR(N-I,BET,Y,X(I+1),Z(I+1))
        Z(I)=X(I)+BET
        IF (I .GE. 2) THEN
          CALL UXVCOP(I-1,X,Z)
        END IF
      ELSE
        CALL UXVCOP(N,X,Z)
      END IF
      RETURN
      END
