* FUNCTION UYGCR2                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  CRITICAL DISTANCE FOR DENSITY CLUSTERING
*
* PARAMETERS :
*  II  NF  DIMENSION OF THE PROBLEM
*  II  NRND  NUMBER OF POINTS IN THE SAMPLE
*  II  ISTEP  STEP
*  II  ISIGMA  PARAMETER
*  RI  XL(NF)  UPPER BOUNDS
*  RI  XU(NF)  LOWER BOUNDS
*
* SUBPROGRAMS USED:
*  RF  UYGMLN   LN OF GAMA FUNCTION
*  RF  UYLBMS   LEBESQUE MEASURE
*
      FUNCTION UYGCR2(NF,NRND,ISTEP,ISIGMA,XL,XU)
      INTEGER NF,NRND,ISTEP,ISIGMA
      REAL*8 XL(NF),XU(NF)
      REAL*8 UYGCR2,UYLBMS,UYGMLN,GAMA
      DOUBLE PRECISION P
      PARAMETER(P=0.564189D0)
      GAMA=EXP(UYGMLN(1.0D0+DBLE(NF)/2.0D0))
      UYGCR2=P*(DBLE(ISTEP)*GAMA*DBLE(ISIGMA)*UYLBMS(NF,XL,XU)
     &       *LOG(DBLE(NRND))/DBLE(NRND))**(1.0D0/DBLE(NF))
      END
