* SUBROUTINE UYSETA             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF INITIAL VALUES OF THE CONSTRAINT FUNCTIONS.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  AF(NA)  VECTOR CONTAINING VALUES OF THE APPROXIMATED
*         FUNCTIONS.
*  II  IA(NA)  VECTOR CONTAINING TYPES OF DEVIATIONS.
*  RI  AG(NF*NA)  VECTOR CONTAINING SCALING PARAMETERS.
*  RI  AZ(NF+1)  VECTOR OF LAGRANGE MULTIPLIERS.
*  RI  AZS(NF+1)  SAVED VECTOR OF LAGRANGE MULTIPLIERS.
*  RA  S(NF)  DIRECTION VECTOR.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*
      SUBROUTINE UYSETA(NF,N,NA,AF,IA,AG,AZ,AZS,S)
      INTEGER NF,N,NA,IA(NA)
      REAL*8 AF(NA),AG(NF*NA),AZ(NF+1),AZS(NF+1),S(NF)
      REAL*8 UXVDOT
      INTEGER JAG,KA
      CALL UXVCOP(NF-N,AZ,AZS)
      JAG=0
      DO 1 KA=1,NA
      IF (IA(KA).NE.0) AF(KA)=AF(KA)-UXVDOT(NF,S,AG(JAG+1))
      JAG=JAG+NF
    1 CONTINUE
      RETURN
      END
