$INTERFACE U1FDU2                                             97/12/01
$REM LU

  $N='N'
  $ADD(REAL,'\UXVDOT')
  $ADD(INTEGER,'\IMD')
  $ISNF=0
  $ADD(INIT)
    MOT=1
  $ENDADD
  $TYPE='L'
  $UPDATE='NO'
$REM  $IF(CONSTR='U')
    $DEFAULT='V'
    $IF($DEF(KCF))
      $IF(KCF=1) $DEFAULT='C'
    $ENDIF
    $IF($DEF(KCA))
      $IF(KCA=1) $DEFAULT='C'
    $ENDIF
    $HELP
      FORM OF METHOD:
        C - CONJUGATE GRADIENT METHODS
        V - VARIABLE METRIC METHODS WITH LIMITED
             STORAGE
    $CHECK(DECOMP,DEFAULT,'C\V',2,NO)
    $IF(DECOMP='C')
      $HELP
        METHOD
          1 - BASIC CONJUGATE GRADIENT METHODS
          2 - STOREY MODIFIED CONJUGATE GRADIENT METHODS
      $CHECK(NUMBER,1,'1\2',2,NO)
    $ELSE
      $HELP
        METHOD
          1 - METHOD OF GILBERT AND NOCEDAL
          2 - METHOD OF HU AND STOREY
      $CHECK(NUMBER,1,'1\2',2,NO)
    $ENDIF
$REM  $ELSE
$REM    $DECOMP='C'
$REM    $NUMBER=1
$REM    $HELP
$REM      METHOD
$REM        1 - BASIC CONJUGATE GRADIENT METHODS
$REM        2 - STOREY MODIFIED CONJUGATE GRADIENT METHODS
$REM    $CHECK(NUMBER,1,'1\2',2,NO)
$REM  $ENDIF
  $HELP
    SPECIFICATION OF THE SEARCH:
      B - BASIC LINE SEARCH
      H - HAGER LINE SEARCH
      M - LINE SEARCH WITH TRUST REGION BOUND
      N - NONMONOTONE LINE SEARCH
  $CHECK(SEARCH,'B','B\H\M\N',3,NO)
  $HELP
    TOLERANCE FOR DESCENT DIRECTION
  $CHECK(EPS0,'1.0$P-3',REAL,4)
  $DEFAULT=-3
  $IF(DECOMP='V') $DEFAULT=2
  $HELP
    CHOICE OF THE INITIAL STEPSIZE:
              0 - INITIAL STEPSIZE IS SPECIFIED IN THE CALLING PROGRAM
        -1 OR 1 - UNIT INITIAL STEPSIZE
        -2 OR 2 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                  STEPSIZE (DAVIDON)
        -3 OR 3 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                  STEPSIZE (STOREY )
        -4 OR 4 - QUADRATICALLY ESTIMATED INITIAL STEPSIZE
      INITS < 0 - THE PREVIOUS FUNCTION VALUE IS USED
      INITS > 0 - THE MINIMUM  FUNCTION VALUE IS USED 
  $CHECK(INITS,DEFAULT,'-4\-3\-2\-1\0\1\2\3\4',4)
  $IF(NUMBER=2) $ITRG=1
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL='$NAL'
    $ADD(INIT)
     MAL=NAL
    $ENDADD
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $ISNC=3
    $ADD(INIT)
      ISNC=3
    $ENDADD
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
  $IF(CONSTR<>'U') $SUBST('UYFP$(CONSTR)1')
*
*     ---------------------------
*     CONJUGATE DIRECTION METHODS
*     TEMPLATE : U1FDU2
*     ---------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
$L=$10 ; $LABEL
  $KD=1
  $SUBST('UZMODN')
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$20 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GOTO $80
  $IF(CONSTR<>'U') $SUBST('UYRM$(CONSTR)0')
$L=$30 ; $LABEL
  $IF($DEF(MCG))
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  $MAT='V'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMP)$(NUMBER)
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMP)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)1')
  CALL UYSET1
  IF(ITERM.NE.0) GOTO $80
  IF(IREST.NE.0) GOTO $30
  $SUBST('UYTR$(CONSTR)S')
$L=$60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($64,$62) ISB+1
$L=$62 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$64 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GOTO $30
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$70 ; $LABEL
  TXFU=TUXX
  $IF($DEF(MCG))
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYUP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  $SUBST('UYTR$(CONSTR)D')
  $IF(CONSTR<>'U') $SUBST('UYAD$(CONSTR)0')
  GOTO $20
$L=$80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1FDU2'
  $ENDADD
  $EXIT

