$INTERFACE U1FSN1                                             97/12/01
$REM LU

  $N='NF'
  $NN='NC'
  $HESR='S'
  $ADD(REAL,'\UXVDOT')
  $ADD(INTEGER,'\IMD\KBFPOM')
  $IF(MODEL='AF') $HESR='B'
  $IF(MODEL='AQ') $HESR='B'
  $IF(MODEL='AP') $HESR='B'
  $ADD(REAL,'\$CFO($NC+1)')
  $TYPE='L'
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'L','L\G',2,NO)
  $SUBP='Q'
  $DECOMP='M'
  $NUMBER=3
  $HELP
    MERIT FUNCTION
      1 - L1 PENALTY FUNCTION
      2 - HESTENES AUGMENTED LAGRANGIAN FUNCTION
      3 - L1 AUGMENTED LAGRANGIAN FUNCTION
  $CHECK(MEP,3,'1\2\3',2)
  $IF(MEP=1)
    $HELP
      PENALTY COEFFICIENT (IT MUST BE GREATER THEN ONE)
    $CHECK(RPF2,'0.5$P 0',REAL,3)
    $ADD(SINIT)
      CALL UXVSET(NC,ZERO,$CP)
    $ENDADD
  $ELSEIF(MEP=2)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF2,'0.5$P 0',REAL,3)
  $ELSEIF(MEP=3)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF2,'0.5$P 0',REAL,3)
  $ENDIF
  $ISNC=2
  $ADD(INIT)
    ISNC=2
  $ENDADD
  $ADD(SINIT)
    CALL UXVSET(NC,ZERO,$CP)
  $ENDADD
  $IF(TYPE='L')
    $KDS=0
    $HELP
      LINE SEARCH INTERPOLATION
        1 - BISECTION
        2 - TWO POINT QUADRATIC INTERPOLATION
        3 - THREE POINT QUADRATIC INTERPOLATION
        4 - THREE POINT CUBIC INTERPOLATION
        5 - SPECIAL INTERPOLATION
    $CHECK(MES,1,'1\2\3\4\5',3)
    $STEP=1
    $IF(MES=5) $STEP=6
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,1,'1\2\3\4',4)
    $HELP
      TOLERANCE FOR DESCENT DIRECTION
    $CHECK(EPS0,'1.0$P-8',REAL,4)
    $LCS=0
  $ELSE
    $HELP
      CHOICE OF THE VARIABLE METRIC UPDATE AFTER ZERO STEP:
        0 - NO UPDATE
        1 - NORMAL UPDATE
    $CHECK(MOT3,0,'0\1',4)
    $IXA='IXA'
    $NX=NF
    $LCS=1
    $ADD(INIT)
      LCS=1
      INITS=-1
    $ENDADD
    $ADD(SINIT)
      $SUBST('UYINV1')
      CALL UXVINS(NF,-1,$IXA)
    $ENDADD
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2',4)
  $IF(HESR='B')
    $HELP
      TYPE OF SPARSE UPDATE:
        M - BASIC MARWILL UPDATE
        B - PARTITIONED VARIABLE METRIC UPDATES
    $CHECK(UPDATE,'M','M\B',3,NO)
    $IF(UPDATE='B')
      $HELP
        METHOD OF UPDATE OF HESSIAN MATRIX:
          1 - BFGS UPDATE
          2 - DFP UPDATE
          3 - HOSHINO UPDATE
          4 - RANK ONE UPDATE
      $CHECK(MET,1,'1\2\3\4',3)
      $IF(MET=4) $MET1=1
      $SUBST('UFSET2')
      $ISNA=2
      $ADD(INIT)
        ISNA=2
      $ENDADD
    $ELSE
      $HESR='S'
    $ENDIF
  $ELSE
    $UPDATE='M'
  $ENDIF
  $HELP
    CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
    AFTER CHANGE OF BASIS:
      1 - RESTART
      2 - CORRECTION
  $CHECK(MLC,2,'1\2',3)
  $HELP
    PENALTY PARAMETER
  $CHECK(RPF1,'5.0$P 0',REAL,4)
  $NF='$MCOLS'
$REM  CALL UXVSET(MCOLS-NF,ZERO,$GF(NF+1))
$REM  CALL UXVSET(MCOLS-NF,ZERO,$G(NF+1))
  $GN='G'
  $SN='S'
  NDECF=0
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NCL>0)
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL3')
    $IF(NORMF>0) $SUBST('UCTRL3')
  $ENDIF
*
*     ------------------------------------------------------
*     RECURSIVE QUADRATIC PROGRAMMING VARIABLE METRIC METHOD
*     TEMPLATE : U1FSN1
*     ------------------------------------------------------
*
  $LMD=$10
  $LDR=$70
  $LMT=$80
  ASSIGN $30 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  GMAX=ONE
  UMAX=ONE
$L=$10 ; $LABEL
  $KD=1 ; $IF(INITH=3) $KD=2
  $G='GF'
  LDS=LD
  $SUBST('UZMODN')
  LD=LDS
  $SUBST('UC1F03')
  CF(NC+1)=F
  IF (TSS(NS).EQ.'USXX') THEN
  $IF(MEP=1)
    $SUBST('UP0SA9')
  $ELSEIF(MEP=2)
    $SUBST('UP0AF9')
  $ELSEIF(MEP=3)
    $SUBST('UP0AF8')
  $ENDIF
  $IF(LCS=1) $SUBST('UPPRE2')
  $IF(KDS<1)
  $ELSE
    P=UXVDOT(NF,$G,$S)
  $ENDIF
  ENDIF
  GO TO IMD
$L=$ 30 ; $LABEL
  $SUBST('UO2FN3')
  $SUBST('UYFUT2')
  IF (GMAX+UMAX.LE.TOLG.AND.CMAX.LE.TOLC) THEN
  ITERM=4
  TXFU='GRAD TOL'
  ENDIF
  IF(ITERM.NE.0) GOTO $90
  CALL UXVINS(NF,0,$LENR)
  CALL UXVCOP(NF,$X, $XO)
  CALL UXVCOP(NF,$GF,$GO)
  CALL UXSSMM(NF,$IH(NF+1)-1,$H,$IH,$JH,$X,$GF)
  CALL UXVDIF(NF,$GO,$GF,$GF)
  $G='G'
  CALL UXVCOP(NF,$GF,$G)
  $IF(KBF>0)
    CALL UXVINA(NF,$IX)
  $ELSE
    CALL UXVINS(NF,0,$IX)
  $ENDIF
  $IF(KBC>0)
    $ICS=IC
    $IC='ICC'
    CALL UXVICP(NC,$ICS,$IC)
    $ADD(INTEGER,'\$ICS($MROWS)')
    $CLS=CL
    $CL='CCL'
    CALL UXVDIF(NC,$CLS,$CF,$CL)
    CALL UXSRMD(NF,NC,MC,$CG,$ICG,$JCG,$X,ONE,$CL,$CL)
    $ADD(REAL,'\$CLS($MROWS)')
  $ENDIF
  $IF(KBC>1)
    $CUS=CU
    $CU='CCU'
    CALL UXVDIF(NC,$CUS,$CF,$CU)
    CALL UXSRMD(NF,NC,MC,$CG,$ICG,$JCG,$X,ONE,$CU,$CU)
    $ADD(REAL,'\$CUS($MROWS)')
  $ENDIF
$REM  MCL=M
  MFP=1
  LCS=0
  $SUBST('UKLINM')
  $SUBST('UKSGLM')
$L=$ 40 ; $LABEL
  $SUBST('UUSSD1')
  IF(ITERM.NE.0) GOTO $90
  $IF($DEF(MCG))
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  CALL UXVCOP(NC+1,$CF,$CFO)
  HDEL=XMAX
  KBFPOM=KBF
  KBF=0
  MFP=2
  LINP=M
  ITERQ=0
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDSS$(SUBP)1
*     -----------------------
*
  $SUBST('UDSS$(SUBP)1')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $G='GF'
  $IF(KBC>0) $IC=ICS
  $IF(KBC>0) $CL=CLS
  $IF(KBC>1) $CU=CUS
  CALL UXVCOP(NC+1,$CFO,$CF)
  $SUBST('UD1T$(TYPE)2')
  IF(ITERM.NE.0) GOTO $90
  IF(IREST.NE.0) GOTO $40
  $SUBST('UPSET2')
  $IF($DEF(MES))
    $IF(MES=5)
      $CFD(NC+1)=UXVDOT(NF,$GF,$S)
      $SUBST('UCMAXS')
    $ENDIF
  $ELSEIF(LCS=1)
    $CFD(NC+1)=UXVDOT(NF,$GF,$S)
    $SUBST('UCMAXS')
  $ENDIF
  CALL UXVINA(NC,$IC)
  $IF(MEP=1)
    $SUBST('UP0SA9')
  $ELSEIF(MEP=2)
    $SUBST('UP0AF9')
  $ELSEIF(MEP=3)
    $SUBST('UP0AF8')
  $ENDIF
  $IF(LCS=1) $SUBST('UPPRE2')
  $GO='GO'
  $SUBST('UYTRUS')
  CALL UXSCMD(NF,NC,MC,$CG,$ICG,$JCG,$CZ,ONE,$GO,$GO)
  CALL UXVCOP(NC+1,$CF,$CFO)
  CALL UXVCOP(NF,$GF,$XS)
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($74,$72) ISB+1
$L=$ 72 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 74 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  CALL UXVCOP(NC+1,$CFO,$CF)
  CALL UXVCOP(NF,$XS,$GF)
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $40
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $40
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$ 80 ; $LABEL
  TXFU=TUXX
  $SUBST('UYTSUD')
  $SUBST('UYTSLM')
  $SUBST('UYTSSG')
  $IF($DEF(MCG))
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYUPND')
      $ENDIF
    $ENDIF
  $ENDIF
  CALL UXSCMD(NF,NC,MC,$CG,$ICG,$JCG,$CZ,ONE,$G,$XS)
  $G='XS'
  $SUBST('UYTRUD')
  KBF=0
  $SUBST('UUS$(UPDATE)$(DECOMP)1')
  KBF=KBFPOM
  GOTO $30
$L=$ 90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL3')
    $IF(NORMC>0) $SUBST('UCNRL3')
  $ENDIF
  FF=F
  $SUBST('UO1FN2')
  $ADD(INIT)
    NXFU='U1FSN1'
  $ENDADD
  $EXIT
