$INTERFACE U1PSI3                                             09/12/01
$REM LU

  $N='NF'
  $NN='NC'
  $XS='XS'
  $GS='GS'
  $XP='XP'
  $XV='XV'
  $GV='GV'
  $HERF='V'
  $ICC='ICC'
  $RDEL='ONE'
  $IF(KBF>0)
    $XSL='XSL'
    $XZL='XZL'
    $XSU='XSU'
    $XZU='XZU'
    $IF(KBF<2)
      $XU=XL
      $XSU=XSL
      $XZU=XZL
    $ENDIF
  $ELSE
    $XSL=X
    $XZL=X
    $XSU=X
    $XZU=X
  $ENDIF
  $IF(KBC>0)
    $CSL='CSL'
    $CZL='CZL'
    $CSU='CSU'
    $CZU='CZU'
    $IF(KBC<2)
      $CU=CL
      $CSU=CSL
      $CZU=CZL
    $ENDIF
  $ELSE
    $NC=1
    $CSL=CF
    $CZL=CF
    $CSU=CF
    $CZU=CF
  $ENDIF
  $ICCA='ICCA'
  $D='D'
  $ID='ID'
  $JD='JD'
  $NCA='($NX+$NC)'
  $ORDER=1
  $ADD(REAL,'\$CFO($NC+1)\$CFD($NC+1)\RMAXP\RMAXD')
  $ADD(INTEGER,'\$ICC(2*$NCC)')
  $ADD(INTEGER,'\IMD\IFILL')
  $ADD(REAL,'\UXUDOT')
  $ADD(REAL,'\UXVDOT')
  $CONSTR='U'
  $ITRG=1
  $GNS=GN
  $MODP='FF'
  $ADD(INTEGER,'\ISNCS')
  $IF(MODEL='AF') $MODP=MODEL
  $IF(MODEL='AQ') $MODP=MODEL
  $IF(MODEL='AP') $MODP=MODEL
  $IF(MODEL='A?') $ADD(INTEGER,'\ISNAS')
  $TYPE='L'
$REM  $HELP
$REM    TYPE OF THE METHOD:
$REM      L - LINE SEARCH
$REM      G - TRUST REGION
$REM  $CHECK(TYPE,'L','L\G',2,NO)
  $DECOMP='C'
  $IF(MODELA='YES')
    $IF(ISNA<1) $ISNA=1
    $ADD(INIT)
      ISNA=$ISNA
    $ENDADD
  $ENDIF
  $ISNC=2
  $ADD(INIT)
    ISNC=2
  $ENDADD
  $KDS=0
$REM  $HELP
$REM    MAXIMUM NUMBER OF DENSE COLUMNS:
$REM  $CHECK(MD,10,INT,2)
$REM  $HELP
$REM    MINIMUM NUMBER OF NONZERO ELEMENTS IN DENSE ROWS:
$REM  $CHECK(MDE,50,INT,2)
  $MD=0
  $HELP
    STRATEGY FOR UPDATES OF BOX CONSTRAINTS AND SLACK VARIABLES
      -1 OR 1 - SLACK VARIABLES ARE DETERMINED BY LINE SEARCH
      -1 0R 2 - SLACK VARIABLES ARE DETERMINED FROM CONSTRAINTS
     MEP1 > 0 - BOX CONSTRAINTS ARE DETERMINED BY LINE SEARCH
     MEP1 < 0 - BOX CONSTRAINTS ARE ALWAYS FEASIBLE
  $CHECK(MEP1,0,'-2\-1\1\2',4)
  $HELP
    STRATEGY FOR PRIMAL AND DUAL STEPSIZES
      0      - UCCSTP
     -1 OR 1 - R, MIN(R,RMAXP), MIN(R,RMAXD)
     -2 OR 2 - R, MIN(R,RMAXP), MIN(R,RMAXP,RMAXD)
     -3 OR 3 - R, MIN(R,RMAXP,RMAXD), MIN(R,RMAXP,RMAXD)
    MEP2 > 0 - R <= RMAX
    MEP2 < 0 - R <= MIN(RMAX, RMAXP)
  $CHECK(MEP2,0,'-3\-2\-1\0\1\2\3',4)
  $NEP2=MEP2
  $IF(NEP2=-1) $NEP2=1
  $IF(NEP2=-2) $NEP2=2
  $IF(NEP2=-3) $NEP2=3
  $HELP
    CHOICE OF THE BARRIER COEFFICIENT
     -1 - VANDERBEI AND SHANNO
      1 - VANDERBEI AND SHANNO SPECIAL
  $CHECK(MEP3,1,'-1\1',4)
  $MOS5=2
  $ADD(INIT)
    MOS5=2
  $ENDADD
$REM  $HELP
$REM    IP FORMULATION
$REM      1 - PRIMAL
$REM      2 - PRIMAL-DUAL
$REM  $CHECK(MOS5,2,'1\2',4)
  $NUMBER=3
  $HELP
    CHOICE OF THE MERIT STRATEGY:
      P - PENALTY FUNCTION
      M - MARKOV FILTER
      F - FLETCHER-LEYFFER FILTER
      B - BARRIER FILTER
      S - NEW FILTER
  $CHECK(MERIT,'P','P\M\F\B\S',2,NO)
  $HELP
    BARRIER COEFFICIENT
  $CHECK(RPF3,'1.0$P 0',REAL,3)
  $HELP
    EXACT PENALTY COEFFICIENT
  $CHECK(RPF4,'1.0$P 0',REAL,3)
  $IF(MERIT='P')
    $HELP
      MERIT FUNCTION
        0 - MERIT FUNCTION IS NOT USED
        1 - L2 AUGMENTED BARRIER FUNCTION
    $CHECK(MEP,1,'0\1',2)
    $IF(MEP=0) $KTERS=6
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P-4',REAL,3)
    $STEP=1
  $ELSEIF(MERIT='M')
    $FS='FS'
    $ADD(REAL,'\$FS(2)')
    $MEP=-1
    $MEP2=1
    $STEP=8
  $ELSEIF(MERIT='B')
    $ADD(REAL,'\FB')
    $HELP
      MAXIMUM NUMBER OF FILTER SAMPLES
    $CHECK(MS,50,INT,3)
    $IF(MS<5) $MS=5
    $FS='FS'
    $ADD(REAL,'\$FS($MS,4)')
    $MEP=-1
    $MEP2=1
$REM    $STEP=9
    $STEP=7
  $ELSE
    $HELP
      MAXIMUM NUMBER OF FILTER SAMPLES
    $CHECK(MS,50,INT,3)
    $IF(MS<5) $MS=5
    $FS='FS'
    $ADD(REAL,'\$FS($MS,2)')
    $MEP=-1
    $MEP2=1
$REM    $STEP=9
    $STEP=7
    $IF(MERIT='S')
      $ADD(REAL,'\SWITCH')
      $STEP=10
    $ENDIF
  $ENDIF
  $HELP
    TYPE OF REGULARIZATION
      0 - NO REGULARIZATION
      1 - REGULARIZATION BY GILL-MURRAY DECOMPOSITION
  $CHECK(MEP4,0,'0\1',4)
  $IF(MEP4=0)
    $ED=S
  $ELSE
    $ED='ED'
    $ADD(REAL,'\$ED($NCA)')
  $ENDIF
  $IF(MERIT='P')
     $IF(MEP>0) $MES5=1
  $ENDIF
  $HELP
    RESTART IN THE CASE OF UNSUITABLE DIRECTION
      0 - RESTART SUPPRESED
      1 - UNIFORM DESCENT ASSURED
  $CHECK(MES5,0,'0\1',4)
  $HELP
    TOLERANCE FOR DESCENT DIRECTION
  $CHECK(EPS0,'1.0$P-8',REAL,4)
  $HELP
    PRECONDITIONING THE KARUSH-KUHN-TUCKER SYSTEM
           0 - PRECONDITIONING IS SUPPRESSED
     -1 OR 1 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
               APPROXIMATION OF THE HESSIAN MATRIX. NORMAL
               EQUATION APPROACH.
           2 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
               APPROXIMATION OF THE HESSIAN MATRIX. AUGMENTED
               SYSTEM APPROACH.
    MOS2 > 0 - COMPLETE CHOLESKI DECOMPOSITION
    MOS2 < 0 - INCOMPLETE CHOLESKI DECOMPOSITION
  $CHECK(MOS2,1,'-3\-1\0\1\2\3',3)
  $NOS2=MOS2
  $IF(NOS2=-1) $NOS2=1
  $IF(NOS2=-3) $NOS2=3
  $PRECOND=2
  $HELP
    CHOICE OF THE INITIAL STEPSIZE:
      1-UNIT INITIAL STEPSIZE
      2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
        STEPSIZE FOR VM METHODS
      3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
        STEPSIZE FOR CG METHODS
      4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
  $CHECK(INITS,1,'1\2\3\4',4)
  $HELP
    MINIMUM VALUE OF THE BARRIER PARAMETER
  $CHECK(ETA5,ETA0,REAL,3)
  $DEFAULT='0.99$P 0'
  $IF(MEP=1) $DEFAULT='0.95$P 0'
  $HELP
    COEFFICIENT FOR COMPUTING PRIMAL AND DUAL MAXIMUM
    STEPSIZES
  $CHECK(ETA6,DEFAULT,REAL,3)
  $HELP
    TOLERANCE FOR CHANGING THE EXACT PENALTY PARAMETER
  $CHECK(ETA7,'1.0$P 2',REAL,3)
  $HELP
    COEFFICIENT FOR INCREASING THE EXACT PENALTY PARAMETER
  $CHECK(ETA8,'3.0$P 0',REAL,3)
  $HELP
    MAXIMUM STEPSIZE FOR LAGRANGE MULTIPLIERS
  $CHECK(UMAX,'1.0$P 6',REAL,3)
$REM  $IF(MODELA='YES')
$REM    $SUBST('UFSET2')
$REM    $ISNA=2
$REM    $ADD(INIT)
$REM      ISNA=2
$REM    $ENDADD
$REM  $ENDIF
  $MCL=NC
   MCL=NC
  $GN=GV
  $SN=S
  NDECF=0
  CALL UCCACT(NX,NC,NCC,NCA,$IX,$IC,$ICC,$ICA,$ICCA,$ID,$JD)
  IF (ITERM.NE.0) GO TO $80
  $IF(NOS2=1) $SUBST('UCCSS1')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(NCL>0)
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL3')
    $IF(NORMF>0) $SUBST('UCTRL3')
  $ENDIF
  $IF(MODELF='YES')
$REM    $NUM=5
  $ELSE
$REM    $NUM=6
  $ENDIF
  $IF(MOS2>0)
    MS=0
    L=$IB(NCA+1)-1
    CALL UXSPCC(NCA,L,MS,MMAX,$B,$IB,$JB,$PSR,$PERC,$INVP,$WN11,$WN12&
,$WN13,$WN14,$ORDER,IFILL,ITERM)
    IF (ITERM.LT.0) THEN
    TXFU='LACK SPC'
    ENDIF
  $ENDIF
  $JOB=2
*
*     --------------------
*     SPARSE NEWTON METHOD
*     TEMPLATE : U1PSI3
*     --------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO3(0)
  $IF(MEP3>0) $SUBST('UCCST2')
  $IF(KBF>0)
    CALL UXVINI(NF,$IX)
  $ENDIF
  FO=FMIN
  R=ZERO
  IF (ITERM.NE.0) GO TO $80
$L=$ 10 ; $LABEL
  $KD=1
  $SUBST('UP1$(MODP)5')
  IF (ISNC.GT.0) CF(NC+1)=FF
  IF (TSS(NS).EQ.'UUXX') THEN
  ELSE IF (TSS(NS).EQ.'UXFU') THEN
  ELSE
  $IF(TYPE='L')
    $IF(MERIT='M')
      $SUBST('UP0BC9')
      F=CF(NC+1)+RPF3*FP+RPF4*F
    $ELSEIF(MERIT='F')
      $SUBST('UP0BC9')
      F=CF(NC+1)+RPF4*F
    $ELSEIF(MERIT='B')
      $SUBST('UP0BC9')
      FB=FP
      F=CF(NC+1)+RPF3*FB+RPF4*F
    $ELSEIF(MERIT='S')
      $SUBST('UP0BC9')
      F=CF(NC+1)+RPF4*F
    $ELSEIF(MEP=0)
      F=CF(NC+1)+RPF4*F
    $ELSEIF(MEP=1)
      $IF(MEP2=0)
        $SUBST('UP0BC4')
      $ELSE
        $SUBST('UP0BC3')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,-KBF)
  $ENDIF
  ENDIF
  GO TO IMD
$L=$ 20 ; $LABEL
  $IF(MERIT='M')
  $ELSEIF(MERIT='F')
    $SUBST('UP0BC9')
    F=CF(NC+1)+RPF4*F
    KS=1
    FS(1,1)=F
    FS(1,2)=FC
  $ELSEIF(MERIT='B')
    $SUBST('UP0BC9')
    FB=FP
    F=CF(NC+1)+RPF3*FB+RPF4*F
    KS=1
    FS(1,1)=F
    FS(1,2)=FC
    FS(1,3)=FF
    FS(1,4)=FB
  $ELSEIF(MERIT='S')
    $SUBST('UP0BC9')
    F=CF(NC+1)+RPF4*F
    KS=1
    FS(1,1)=F
    FS(1,2)=FC
    $IF(MEP3=1)
      KT=0
    $ENDIF
  $ENDIF
$L=$ 30 ; $LABEL
  $GN=GV
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FN3')
  $SUBST('UYFUT2')
  IF (GMAX.LE.TOLG.AND.CMAX.LE.TOLC.AND.RPF3.LE.ETA5) THEN
  ITERM=4
  TXFU='GRAD TOL'
  ENDIF
$REM  IF (ITERM.EQ.1.AND.ABS(F).GE.1.0$P 10) THEN
  IF (.FALSE.) THEN
  CALL UOERR1('U1PSI3',88)
  ITERM=-88
  TDXX='LIN. DEP.'
  ENDIF
  IF (ITERM.NE.0) GO TO $80
$L=$ 40 ; $LABEL
  IF (IREST.GT.0) THEN
  TUXX='UNIT    '
  CALL UYSET3
  ENDIF
  IF (ITERM.NE.0) GO TO $80
  CALL UXVCOP(NF,$X,$XV)
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KBF>0)
    CALL UXVINF(NF,MC,$IX,$JCG)
    $IF(MODELA='YES') CALL UXVINF(NF,MA,$IX,$JAG)
  $ENDIF
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDS$(TYPE)$(DECOMP)$(NUMBER)
*     -----------------------
*
  $SUBST('UDS$(TYPE)$(DECOMP)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
$REM  $IF(MERIT='S')
$REM    SWITCH=UXSSMQ(NF,M,HF,IH,JH,S,S)
$REM  $ENDIF
  $SUBST('UD1T$(TYPE)3')
  $IF(MEP2=0)
  $ELSE
  CALL UCCMAX(NX,NC,NCA,$IX,$XSL,$XSU,$XZL,$XZU,$IC,$CSL,$CSU&
,$CZL,$CZU,$ICA,$ICCA,$S(NF+1),$GS(NF+1),RMAX,RMAXP,RMAXD,ETA6,RPF4)
$REM  CALL UCCMAX(NF,NX,NC,NCA,$IX,$XSL,$XSU,$XZL,$XZU,$IC,$CSL,$CSU&
$REM ,$CZL,$CZU,$ICA,$S(NF+1),$GS(NF+1),RMAX,RMAXP,RMAXD,ETA6)
    $IF(MEP2<0)
      RMAX=MIN(RMAX,RMAXP)
    $ENDIF
  $ENDIF
$REM  $IF(KBF>0)
$REM    CALL UXVINE(MC,$JCG)
$REM    $IF(MODELA='YES') CALL UXVINE(MA,$JAG)
$REM  $ENDIF
  $IF(MERIT='M')
    $SUBST('UP0BC9')
    FS(1)=CF(NC+1)+RPF3*FP+RPF4*F
    FS(2)=FC
  $ELSEIF(MEP=0)
    F=CF(NC+1)+RPF4*F
  $ELSEIF(MEP=1)
    $IF(MEP2=0)
      $SUBST('UP0BC4')
    $ELSE
      $SUBST('UP0BC3')
    $ENDIF
  $ENDIF
  IF (ITERM.NE.0) GO TO $80
  IF (IREST.NE.0) GO TO $40
$L=$ 50 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  CALL UXVCOP(NC+1,$CF,$CFO)
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  $IF(MEP1<0)
    CALL UXUDIC(NF,R,$S,$XO,$XL,$XU,$X,$IX)
  $ELSE
    CALL UXUDIR(NF,R,$S,$XO,$X,$IX,-KBF)
  $ENDIF
  ISNC=1
  GOTO $10
$L=$ 64 ; $LABEL
  $IF(MERIT='B')
    FS(KS,3)=FF
    FS(KS,4)=FB
  $ENDIF
  ISNC=2
  $IF(KDA=1) LD=0
  $IF(KDC=1) LD=0
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  CALL UXVCOP(NC+1,$CFO,$CF)
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GOTO $40
  ENDIF
  $IF(MEP2=0)
    CALL UCCSTP(NX,NC,NCA,$IX,$XSL,$XSU,$XZL,$XZU,$IC,$CSL,$CSU&
,$CZL,$CZU,$ICA,$S(NF+1),$GS(NF+1),R,ETA6)
  $ELSE
    RMAXP=MIN(R,RMAXP)
    RMAXD=MIN(R,RMAXD)
    $IF(NEP2=2)
      RMAXD=MIN(RMAXP,RMAXD)
    $ENDIF
    $IF(NEP2=3)
      RMAXD=MIN(RMAXP,RMAXD)
      RMAXP=RMAXD
    $ENDIF
    CALL UCCDIR(NX,NC,NCA,$IX,$XSL,$XSU,$XZL,$XZU,$IC,$CSL,$CSU&
,$CZL,$CZU,$ICA,$S(NF+1),$GS(NF+1),R,RMAXP,RMAXD)
  $ENDIF
  CALL UODLI5(R,RMAX,RMAXP,RMAXD)
  $BPAR=1
  $IF(MEP3<0)
    $SUBST('UPSEB$BPAR')
  $ELSE
    $SUBST('UPSEC$BPAR')
  $ENDIF
  RPF3=MAX(RPF3,ETA5)
  $IF(MERIT='B')
    CALL UPSETB(KS,$MS,$FS,RPF3)
  $ENDIF
  IF (PMAX.GT.ETA7*MAX(1.0$P-8,CMAX)) RPF4=MIN(ETA8*RPF4,1.0$P 6)
  IF (KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$ 70 ; $LABEL
  TXFU=TUXX
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYUP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  $SUBST('UYTRED')
$REM  $SUBST('UYTR$(CONSTR)D')
  GOTO $30
$L=$ 80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL3')
    $IF(NORMC>0) $SUBST('UCNRL3')
  $ENDIF
  F=CF(NC+1)
  $SUBST('UCTRF3')
  $SUBST('UO1FC2')
  $GN=GNS
  $ADD(INIT)
    NXFU='U1PSI3'
  $ENDADD
  $EXIT

