$INTERFACE U2MSU1                                             16/12/01
$REM LU

  $F='FF'
  $FO='FFO'
  $N='NF'
  $RDEL='ONE'
  $AZL='AZL'
  $AZU='AZU'
  $IF(IEXT<>0)
    $AZU=AZL
  $ENDIF
  $HF=H
  $HERF='S'
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $ADD(REAL,'\$X($NF+1)\$G($NF+1)\$S($NF+1)\$AF($NA)\$AFO($NA)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\NNIT\IMD\KDS\ISNAS')
  $ADD(REAL,'\FFO\TOLP\UNFUZ1')
  $HELP
    TYPE OF THE METHOD:
      L - LINE SEARCH
      G - TRUST REGION
  $CHECK(TYPE,'L','L\G',2,NO)
  $IF(TYPE='L')
    $DECOMP='G'
  $ELSE
    $HELP
      MATRIX DECOMPOSITION:
      G - GILL-MURRAY DECOMPOSITION
      B - BUNCH-PARLETT DECOMPOSITION
    $CHECK(DECOMP,'G','M\G\B',2,NO)
  $ENDIF
  $ISNA=2
  $ADD(INIT)
    ISNA=2
  $ENDADD
  $HELP
    INITIAL BARRIER COEFFICIENT
  $CHECK(RPF3,'1.0$P 0',REAL,3)
  $KDS=0
  $HELP
    MERIT FUNCTION
      0 - MINIMAX FUNCTION
      1 - LOGARITHMIC BARRIER FUNCTION
      2 - COMPOSITE LOGARITHMIC BARRIER FUNCTION
      3 - BOUNDED LOGARITHMIC BARRIER FUNCTION (BEN-TAL)
      4 - ANOTHER BOUNDED LOGARITHMIC BARRIER FUNCTION 
      5 - RECIPROCAL BARRIER FUNCTION (CARROLL)
  $CHECK(MEP,1,'0\1\2\3\4\5',2)
  $IF(MEP>1)
    $IF(MEP<5)
      $HELP
        PARAMETER OF THE BOUNDED BARRIER
      $CHECK(ETA7,'1.0$P 6',REAL,4)
      PAR=$ETA7
      $IF(MEP=3) 
        PARLOG=LOG(PAR)+THREE/TWO
      $ENDIF  
      $IF(MEP=4) 
        PARLOG=LOG(PAR)+THREE
      $ENDIF  
    $ENDIF
  $ENDIF  
$REM  $HELP
$REM    JACOBIAN MATRIX IN THE KKT SYSTEM
$REM      0 - ORIGINAL JACOBIAN MATRIX
$REM      1 - PERTURBED JACOBIAN MATRIX
$REM   $CHECK(MEP1,0,'0\1',2)
  $HELP
    UPDATE OF THE BARRIER PARAMETER
      1 - GEOMETRIC SEQUENCE
      2 - MONOTONE SEQUENCE
      3 - DELAYED MONOTONE SEQUENCE
      4 - DELAYED MONOTONE SEQUENCE WITH STAGNATIONS
  $CHECK(MEP3,2,'1\2\3\4',2)
  $HELP
    PRECISION TO INNER NONLINEAR EQUATION
  $CHECK(ETA3,'1.0$P-6',REAL,4)
  $HELP
    REDUCTION OF THE BARRIER PARAMETER
  $CHECK(ETA4,'8.5$P-1',REAL,4)
  $HELP
    MINIMUM VALUE OF THE BARRIER PARAMETER
  $CHECK(ETA5,'0.0$P 0',REAL,4)
  $HELP
    SWITCHING VALUE OF THE GRADIENT NORM
  $CHECK(ETA6,'1.0$P 0',REAL,4)
  $IF(TYPE='L')
    $NUMBER=1
    $HELP
      LINE SEARCH INTERPOLATION
        1 - BISECTION
        2 - TWO POINT QUADRATIC INTERPOLATION
        3 - THREE POINT QUADRATIC INTERPOLATION
        4 - THREE POINT CUBIC INTERPOLATION
        5 - SPECIAL INTERPOLATION
    $CHECK(MES,1,'1\2\3\4\5',3)
    $IF(MES=5) 
      $STEP=5
      $HELP
        CHOICE OF THE INITIAL STEPSIZE:
         -1 - SPECIAL INITIAL STEPSIZE FOR THE MINIMAX APPROXIMATION
          1 - UNIT INITIAL STEPSIZE
      $CHECK(INITS,1,'-1\1',4)
    $ELSE  
      $STEP=1
      $HELP
        CHOICE OF THE INITIAL STEPSIZE:
          1-UNIT INITIAL STEPSIZE
          2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
            STEPSIZE FOR VM METHODS
          3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
            STEPSIZE FOR CG METHODS
          4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
      $CHECK(INITS,1,'1\2\3\4',4)
    $ENDIF  
    $HELP
      TOLERANCE FOR DESCENT DIRECTION
    $CHECK(EPS0,'1.0$P-8',REAL,4)
  $ELSE
    $NUMBER=1
  $ENDIF
  $HELP
    COMPUTATION OF SECOND DERIVATIVES
      1 - SECOND DERIVATIVES OF APPROXIMATING AND CONSTRAINT
          FUNCTIONS ARE COMPUTED
      2 - COLEMAN-MORE GRAPH COLORING ALGORITHM IS USED
  $CHECK(NUMDER,1,'1\2',4,NO)
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
     -1 - STEEPEST DESCENT DIRECTION
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - DIAGONAL INITIAL APPROXIMATION
      4 - DIAGONAL INITIAL APPROXIMATION FOR MINIMAX
  $CHECK(INITH,3,'-1\1\2\3\4',4)
  $ADD(INTEGER,'\NACOM\IEXC')
  $IF(IEXT=0)
    $ADD(REAL,'\$AZL($NA)\$AZU($NA)\BARP\PARAM')
    $SET(SINIC)
      COMMON /UMFUZ1/ $AF,$AZL,$AZU,BARP,PARAM,NACOM,IEXC
      EXTERNAL UNFUZ1
    $ENDSET
  $ELSE
    $ADD(REAL,'\$AZL($NA)\BARP\PARAM')
    $SET(SINIC)
      COMMON /UMFUZ1/ $AF,$AZL,BARP,PARAM,NACOM,IEXC
      EXTERNAL UNFUZ1
    $ENDSET
  $ENDIF
$REM  $MCL=NC
$REM   MCL=NC
  $GN='GF'
  $SN='S'
  NDECF=0
  $SUBST('UFSET1')
  $SUBST('UASET2')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
  $IF(KDA<2)
    $IF(NUMDER=2) $SUBST('UYPTSH')
  $ENDIF
  $IF(DECOMP='M')
    $SUBST('UYSFSH')
  $ELSEIF(DECOMP='G')
    $SUBST('UYSFSH')
  $ELSEIF(DECOMP='B')
    $SUBST('UYSFIH')
  $ENDIF
*
*     --------------------
*     SPARSE NEWTON METHOD
*     TEMPLATE : U2MSU1
*     --------------------
*
  $LMD=$10
  ASSIGN $30 TO IMD
  CALL UYPRO1('UXFU',2)
  CALL UYPRO3(0)
  $IF(KBF>0)
    CALL UXVINI(NF,$IX)
  $ENDIF
  R=ZERO
  FO=FMIN
$REM  $IF(MEP=2)
$REM    PAR=ONE/EXP(THREE/TWO)
$REM  $ELSE
$REM    PAR=ZERO
$REM  $ENDIF
  IF (ETA5.LE.ZERO) THEN
    TOLP=ETA0**(TWO/THREE)
  ELSE
    TOLP=ETA5
  ENDIF
  IF (ITERM.NE.0) GO TO $80
$L=$ 10 ; $LABEL
  KDS=KD
  KD=0
$L=$ 15 ; $LABEL
  $KD=1
  $SUBST('UP2MX3')
  IF (KD.LE.0) THEN
  NACOM=NA
  IEXC=IEXT
  BARP=RPF3
  PARAM=PAR
  IF (FF+RPF3.GT.(ONE+ETA0)*FF) THEN
$REM  IF (FF+RPF3.GT.FF) THEN
  $IF(MEP<2)
    $ZL='FF+RPF3'
    $IF(IEXT=0)
      $ZU='FF+RPF3*DBLE(2*NA)'
    $ELSE
      $ZU='FF+RPF3*DBLE(NA)'
    $ENDIF
  $ELSEIF(MEP=3)
    $ZL='FF+MIN(RPF3,PAR)'
    $IF(IEXT=0)
      $ZU='FF+RPF3*DBLE(2*NA)'
    $ELSE
      $ZU='FF+RPF3*DBLE(NA)'
    $ENDIF
  $ELSEIF(MEP=2)
    $ZL='FF+TWO*RPF3/(ONE+SQRT(ONE+FOUR*RPF3/PAR))'
    $IF(IEXT=0)
      $ZU='FF+RPF3*DBLE(4*NA)/(ONE+SQRT(ONE+RPF3*DBLE(8*NA)/PAR))'
    $ELSE
      $ZU='FF+RPF3*DBLE(2*NA)/(ONE+SQRT(ONE+RPF3*DBLE(4*NA)/PAR))'
    $ENDIF
  $ELSEIF(MEP=5)
    $ZL='FF+RPF3'
    $IF(IEXT=0)
      $ZU='FF+RPF3*SQRT(DBLE(2*NA))'
    $ELSE
      $ZU='FF+RPF3*SQRT(DBLE(NA))'
    $ENDIF
  $ELSEIF(MEP=4)
    $ZL='FF+MIN(RPF3,PAR)'
    $IF(IEXT=0)
      $ZU='FF+RPF3*DBLE(2*NA)'
    $ELSE
      $ZU='FF+RPF3*DBLE(NA)'
    $ENDIF
  $ENDIF
  NNIT=20
  CALL UNNEQ1($ZL,$ZU,X(NF+1),G(NF+1),UNFUZ1,ZERO,MIN(ETA3,TOLG),NNIT&
,IER)
  ELSE
  X(NF+1)=(ONE+ETA0)*FF
  G(NF+1)=UNFUZ1(X(NF+1))
  ENDIF
  $IF(MEP=0)
    F=FF
  $ELSE
    $SUBST('UP0BX1')
  $ENDIF
  ENDIF
  IF (KDS.GT.KD) THEN
  KD=KDS
  GO TO $15
  ENDIF
  ISNA=2
  GO TO IMD
$L=$ 30 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT8')
  IF (ITERM.NE.0) GO TO $80
  $IF(CONSTR='C') $SUBST('UYRM$(CONSTR)0')
$L=$ 40 ; $LABEL
  $SUBST('UUSSD1')
  IF (ITERM.NE.0) GO TO $80
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KBF>0)
    CALL UXVINB(NF,M,$IX,$JH)
    CALL UXVINB(NF,MA,$IX,$JAG)
  $ENDIF
  $SUBST('UYTS$(CONSTR)H')
  $DEC=DECOMP
  $DECOMG='X'
  $IF(DEC='M') $DEC='G'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDS$(TYPE)$(DECOMG)$(NUMBER)
*     -----------------------
*
  $SUBST('UDS$(TYPE)$(DECOMG)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)1')
  IF (ITERM.NE.0) GO TO $80
  IF (IREST.NE.0) GO TO $40
  IF (NIT.EQ.LIT+1) KIT=NIT
$L=$ 50 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
  FFO=FF
  $XO(NF+1)=$X(NF+1)
  $GO(NF+1)=$G(NF+1)
  CALL UXVCOP(NA,$AF,$AFO)
  ASSIGN $60 TO IMD
$L=$ 60 ; $LABEL
$REM  IF(FF.LT.FFO) THEN
$REM  TSXX='DECR. FF'
$REM  ITERS=7
$REM  ENDIF
  $SUBST('UZLINS')
  GO TO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  $IF(KBF>0)
    CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GO TO $10
$L=$ 64 ; $LABEL
  $IF(KDA=1) LD=0
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  $IF(TYPE='G')
    IF (ITERS.LT.0) THEN
    RPF3=TOLP
    CALL UYRES1(TSXX)
    CALL UYSET1
    GO TO $40
$REM    ITERM=-1
$REM    GOTO $80
    ENDIF
  $ENDIF
  FF=FFO
  $X(NF+1)=$XO(NF+1)
  $G(NF+1)=$GO(NF+1)
  CALL UXVCOP(NA,$AFO,$AF)
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $40
  ENDIF
$REM  CALL UODLA5(R,RMAX,RMAXP,RMAXD)
  $IF(TYPE='G')
    IF (ITERS.GE.2) THEN
  $ENDIF
  $IF(MEP3=1)
    RPF3=MIN(ETA4*RPF3,GNORM**2)
  $ELSEIF(MEP3=2)
    RPF3=MIN(MAX(ETA4*RPF3,RPF3/(1.0$P 2*RPF3+ONE)),MAX(GNORM**2&
,1.0D-2**(NIT-LIT)))
  $ELSEIF(MEP3=3)
    IF (GNORM.GE.ETA6) THEN
    ELSE
    RPF3=MIN(MAX(ETA4*RPF3,RPF3/(1.0$P 2*RPF3+ONE)),MAX(GNORM**2&
,1.0D-2**(NIT-LIT)))
    ENDIF
  $ELSEIF(MEP3=4)
    IF (GNORM.GE.ETA6) THEN
    ELSE
    IF (RPF3.GE.1.0$P 2*GNORM**2) RPF3=GNORM**2
    ENDIF
  $ENDIF
  RPF3=MAX(RPF3,TOLP,ETA0*ABS(FF))
  $IF(TYPE='G')
    ENDIF
  $ENDIF
  IF (KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$ 70 ; $LABEL
  TXFU=TUXX
  TUXX='NEWTON  '
  $SUBST('UYTRED')
  $IF(CONSTR='C')
$L=$75 ; $LABEL
    $SUBST('UYADC0')
  $ENDIF
  GO TO $30
$L=$ 80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(2)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  F=FF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U2MSU1'
  $ENDADD
  $ADD(SINIT)
    $SUBST('UASET1')
  $ENDADD
  $ADD(SUBROUTINES)
    FUNCTION UNFUZ1(Z)
    INTEGER NACOM,IEXC
    $IF(IEXT=0)
      $FLOAT $AF($NA),$AZL($NA),$AZU($NA),BARP,PARAM
      COMMON /UMFUZ1/ $AF,$AZL,$AZU,BARP,PARAM,NACOM,IEXC
    $ELSEIF(IEXT<0)
      $FLOAT $AF($NA),$AZU($NA),BARP,PARAM
      COMMON /UMFUZ1/ $AF,$AZU,BARP,PARAM,NACOM,IEXC
    $ELSEIF(IEXT>0)
      $FLOAT $AF($NA),$AZL($NA),BARP,PARAM
      COMMON /UMFUZ1/ $AF,$AZL,BARP,PARAM,NACOM,IEXC
    $ENDIF
    $FLOAT Z,UNFUZ1,RHO
    INTEGER KA
    UNFUZ1=1.0$P 0
    DO 1 KA=1,NACOM
    $IF(IEXT<=0)
      $IF(MEP<2)
        $AZU(KA)=BARP/(Z-$AF(KA))
      $ELSEIF(MEP=3)
        RHO=Z-$AF(KA)
        IF (RHO.LE.PARAM) THEN
        $AZU(KA)=BARP/RHO
        ELSE
        $AZU(KA)=BARP*(2.0$P 0-PARAM/RHO)*(PARAM/RHO)/RHO
        ENDIF
      $ELSEIF(MEP=2)
        RHO=Z-$AF(KA)
        $AZU(KA)=BARP*PARAM/RHO/(PARAM+RHO)
      $ELSEIF(MEP=5)
        $AZU(KA)=(BARP/(Z-$AF(KA)))**2
      $ELSEIF(MEP=4)
        RHO=Z-$AF(KA)
        IF (RHO.LE.PARAM) THEN
        $AZU(KA)=BARP/RHO
        ELSE
        $AZU(KA)=BARP*(2.0$P 0*SQRT(PARAM/RHO)-PARAM/RHO)/RHO
        ENDIF
      $ENDIF
      UNFUZ1=UNFUZ1-$AZU(KA)
    $ENDIF
    $IF(IEXT>=0)
      $IF(MEP<2)
        $AZL(KA)=BARP/(Z+$AF(KA))
      $ELSEIF(MEP=3)
        RHO=Z+$AF(KA)
        IF (RHO.LE.PARAM) THEN
        $AZL(KA)=BARP/RHO
        ELSE
        $AZL(KA)=BARP*(2.0$P 0-PARAM/RHO)*(PARAM/RHO)/RHO
        ENDIF
      $ELSEIF(MEP=2)
        RHO=Z+$AF(KA)
        $AZL(KA)=BARP*PARAM/RHO/(PARAM+RHO)
      $ELSEIF(MEP=5)
        $AZL(KA)=(BARP/(Z+$AF(KA)))**2
      $ELSEIF(MEP=4)
        RHO=Z+$AF(KA)
        IF (RHO.LE.PARAM) THEN
        $AZL(KA)=BARP/RHO
        ELSE
        $AZL(KA)=BARP*(2.0$P 0*SQRT(PARAM/RHO)-PARAM/RHO)/RHO
        ENDIF
      $ENDIF
      UNFUZ1=UNFUZ1-$AZL(KA)
    $ENDIF
  1 CONTINUE
    RETURN
    END
  $ENDADD
  $EXIT
