$INTERFACE UA0DF1                                             98/12/01

  $IF(MODELY='YES') $SUBST('UZYSET')
  $IF(GRAPH='NO')
    $NA=1
    $MED=0
    $ADD(SINIT)
      NA=1
      MED=0
    $ENDADD
  $ELSE
    $HELP
      OUTPUT SPECIFICATION
        1 - OUTPUT IN ALL INTEGRATION STEPS
        2 - OUTPUT IN PRESCRIBED MESH POINTS
    $CHECK(MED,2,'1\2',4)
    $HELP
      NUMBER OF MESH POINTS
    $CHECK(NA,50,INT,1)
  $ENDIF
  $IF(MED=2)
    $ADD(SINID)
      CALL UESET1(NA,$AT,TA,TAMAX,HEMAX)
    $ENDADD
  $ENDIF
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $HELP
    TYPE OF METHOD
      DP5 - DORMAN PRINCE OF THE 5'TH ORDER
      DP8 - DORMAN PRINCE OF THE 8'TH ORDER
  $CHECK(SOLVER,'DP8','DP5\DP8\EX1',2,NO)
  $IF(MODELA='YES')
    $MEL='($NE+1)'
  $ELSE
    $MEL='$NE'
  $ENDIF
  $ADD(REAL,'\$AT($NA)\$AY($NA*$NE)\$YA($MEL)')
      $ADD(SINIT)
        CALL UXVSET(NE,ZERO,YA)
      $ENDADD
      $ADD(SINID)
        CALL UESET2(NA,NE,$AT,$AY,$YA,TA)
      $ENDADD
      $IF(MODELY='YES')
        $SUBST('UE0Y01')
        CALL UXVCOP(NE,$YA,$AY)
      $ENDIF
 $00  CALL UA0DF1(NA,NE,MEL,$AT,$AY,$YA,$ETA9,F,FF,TA,HE,MED,MED1,MED2&
,IER)
      GOTO ($40,$10,$30) ISB+1
 $10  CONTINUE
      $LET=$00
      $LED=$20
      $LES=$10
      $SUBST('UEV$SOLVER')
 $20  CONTINUE
      $SUBST('UE0DF1')
      $GO TO $10
 $30  CONTINUE
      $IF(MODELF='YES')
        $MTYPE=FMODF
        $SUBST('UZFMOD')
      $ENDIF
      $GO TO $00
 $40  CONTINUE
      $ADD(INIT)
        NAXX='UA0DF1'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UA0DF1             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION
* WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NA  NUMBER OF MESH POINTS.
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  MEL  ACTUAL NUMBER OF DIFFERENTIAL EQUATIONS.
*  RI  AT(NA)  MESH POINTS.
*  RO  AY(NA*NE)  FIELD OF SOLUTION VECTORS IN THE MESH POINTS.
*  RU  YA(MEL)  SOLUTION VECTOR.
*  RI  ETA9  MAXIMUM VALUE LESS THEN INFINITY.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RI  FF  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RU  TA  VALUE OF THE INTEGRATION PARAMETER.
*  RU  HE  ACTUAL STEPSIZE.
*  II  MED  NUMBER OF STEPS PRECEEDING TEST OF STIFTNESS.
*  II  MED1  CHOICE OF STEP SELECTION.
*  II  MED2  NUMBER OF RESETING SOLUTIONS.
*  IO  IER  ERROR INDICATOR.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  KDF  DEGREE OF ANALYTICALLY COMPUTED DERVATIVES.
*  II  KDA  DEGREE OF ANALYTICALLY COMPUTED DERVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*  S  UXVCOP  COPY OF A VECTOR.
*
      SUBROUTINE UA0DF1(NA,NE,MEL,AT,AY,YA,ETA9,F,FF,TA,HE,MED,MED1,
     & MED2,IER)
      $INCLUDE ('UMCOMM')
      INTEGER NA,NE,MEL,MED,MED1,MED2,IER
      $FLOAT AT(NA),AY(NA*NE),YA(NE+1),ETA9,F,FF,TA,HE
      INTEGER MEDS
      SAVE MEDS
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,2,3) ISP(NS)
    1 CONTINUE
      MEDS=MED
      IF (KD.LT.0) GO TO 4
      IF (KD.LE.LD) GO TO 4
      IF (KDA.LT.0) THEN
      MEL=NE
      ELSE
      MEL=NE+1
      YA(MEL)=ZERO
      ENDIF
      MED=0
      MED1=1
      MED2=0
      TA=AT(1)
      IF (KDY.LT.0) CALL UXVCOP(NE,AY,YA)
      HE=ZERO
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      IF (IER.LT.0) THEN
      F=ETA9
      ITERM=MAX(-96,-90+IER)
      CALL UOERR1('UA0DF1',-ITERM)
      TDXX=TEDX
      GO TO 4
      ENDIF
      IF (ITERM.LT.0) ITERM=0
      IF (KDA.LT.0) THEN
      F=ZERO
      ELSE
      F=YA(MEL)
      ENDIF
      IF (KDF.LT.0) GO TO 4
      CALL UYSET0(2,3)
      RETURN
    3 CONTINUE
      F=F+FF
    4 CALL UYEPI1(-1)
      MED=MEDS
      LD=KD
      RETURN
      END
