$INTERFACE UALNF1                                             97/12/01

  CALL UALNF1(NF,NA,KA,$X,$XN,$AG,FA,ISNA,$NORMF)
  $ADD(REAL,'\$X($NF)\$XN($NF),$AG($NF*$NA)')
$REM  $ADD(REAL,'\FA')
$REM  $ADD(INTEGER,'\NF\NA\KA\ISNA')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UALNF1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE LINEAR FUNCTION VALUE. THE DENSE CASE.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF FUNCTIONS.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING PARAMETERS.
*  RI  AG(NF*NA)  DENSE JACOBIAN MATRIX.
*  RO  FA  VALUE OF THE SELECTED FUNCTION.
*  II  ISNA  SAVING SPECIFICATION. ISNA=0-NO SAVING. ISNA=1-FUNCTION
*         VALUES ARE SAVED. ISNA=2-FUNCTION VALUES AND GRADIENTS ARE
*         SAVED.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  RF   UXVDOT  DOT PRODUCT OF TWO VECTORS.
*  RF   UXVVDP  INVERSELY SCALED DOT PRODUCT OF TWO VECTORS.
*
      SUBROUTINE UALNF1(NF,NA,KA,X,XN,AG,FA,ISNA,NORMF)
      INTEGER NF,NA,KA,ISNA,NORMF
      $FLOAT X(NF),XN(NF),AG(NF*NA),FA
      $FLOAT UXVDOT,UXVVDP
      INTEGER JAG
      JAG=(KA-1)*NF
      IF (NORMF.GT.0.AND.ISNA.GT.2) THEN
      FA=UXVVDP(NF,XN,X,AG(JAG+1))
      ELSE
      FA=UXVDOT(NF,X,AG(JAG+1))
      ENDIF
      RETURN
      END
