$INTERFACE UAMAXD                                             97/12/01

  CALL UAMAXD(NF,NA,NAP,$AF,$AFD,$IA,$AG,$S,F,PAR,$EPS9,$ETA9)
  $ADD(REAL,'\$AF($NA)\$AFD($NA)\$AG($NF*$NA)\$S($NF)')
$REM  $ADD(REAL,'\F\PAR')
  $ADD(INTEGER,'\$IA($NA)')
$REM  $ADD(INTEGER,'\NF\NA\NAP')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UASTEP              ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  DETERMINATION OF THE INITIAL STEPSIZE.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  IA  NAP  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  AF(NA)  VECTOR CONTAINING VALUES OF THE APPROXIMATED
*         FUNCTIONS.
*  RO  AFD(NA)  VECTOR CONTAINING INCREMENTS OF THE APPROXIMATED
*         FUNCTIONS.
*  II  IA(NA)  VECTOR CONTAINING TYPES OF DEVIATIONS.
*  RI  AG(NF*NA)  MATRIX WHOSE COLUMNS ARE GRADIENTS OF THE LINEAR
*          APPROXIMATED FUNCTIONS.
*  RI  S(NF)  DIRECTION VECTOR.
*  RI  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RA  PAR  AUXILIARY VARIABLE.
*  RI  EPS9  TOLERANCE FOR ACTIVE FUNCTIONS.
*  RI  ETA9  MAXIMUM MACHINE NUMBER.
*
* SUBPROGRAMS USED.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*
      SUBROUTINE UAMAXD(NF,NA,NAP,AF,AFD,IA,AG,S,F,PAR,EPS9,ETA9)
      INTEGER NF,NA,NAP,IA(NA)
      $FLOAT AF(NA),AFD(NA),AG(NF*NA),S(NF),F,PAR,EPS9,ETA9
      $FLOAT POM,DER,UXVDOT
      INTEGER JAG,K,KA
      PAR=-ETA9
      JAG=1
      DO 1 KA=1,NA
      IF (IA(KA).NE.0) THEN
      POM=AF(KA)
      K=ABS(IA(KA))
      DER=UXVDOT(NF,AG(JAG),S)
      AFD(KA)=DER
      IF (K.EQ.1.OR.K.GE.3.AND.POM.LT.0.0$P 0) THEN
      POM=-POM
      DER=-DER
      ENDIF
      IF (POM.GE.F-EPS9*MAX(ABS(F),1.0$P 0).AND.PAR.LT.DER) THEN
      PAR=DER
      NAP=KA
      ENDIF
      ENDIF
      JAG=JAG+NF
    1 CONTINUE
      RETURN
      END
