$INTERFACE UANRG1                                             97/12/01

  CALL UANRG1(NF,NA,KA,$AW,$GA,$NORMA)
  $ADD(REAL,'\$AW($NA)\$GA($NF)')
$REM  $ADD(INTEGER,'\NF\NA\KA')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UANRG1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING OF THE SELECTED FUNCTION GRADIENT.
*
* PARAMETERS :
*  II  NF NUMBER OF VARIABLES.
*  II  NA NUMBER OF FUNCTIONS.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RI  AW(NA)  VECTOR CONTAINING SCALING PARAMETERS.
*  RU  GA(NF)  GRADIENT OF THE SELECTED FUNCTION.
*  II  NORMA  SCALING SPECIFICATION. NORMA=0-NO SCALING IS PERFORMED.
*         NORMA=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMA=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAM USED :
*  S   UXVSCL  SCALING OF A VECTOR.
*
      SUBROUTINE UANRG1(NF,NA,KA,AW,GA,NORMA)
      INTEGER NF,NA,KA,NORMA
      $FLOAT AW(NA),GA(NF)
      IF (NORMA.GT.0) THEN
      CALL UXVSCL(NF,AW(KA),GA,GA)
      ENDIF
      RETURN
      END
