$INTERFACE UANRH1                                             97/12/01

  CALL UANRH1(NF,NA,KA,$AW,HA,$NORMA)
  $ADD(REAL,'\$AW($NA)\$HA($NF*($NF+1)/2)')
$REM  $ADD(INTEGER,'\NF\NA\KA')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UANRH1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING OF THE HESSIAN MATRIX OF THE APPROXIMATED FUNCTION.
*
* PARAMETERS :
*  II  NF NUMBER OF VARIABLES.
*  II  NA NUMBER OF FUNCTIONS.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RI  AW(NA)  VECTOR CONTAINING SCALING PARAMETERS.
*  RU  HA(NF*(NF+1)/2)  HESSIAN MATRIX OF THE APPROXIMATED FUNCTION.
*  II  NORMA  SCALING SPECIFICATION. NORMA=0-NO SCALING IS PERFORMED.
*         NORMA=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMA=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   UXDSMS  SCALING OF A SYMMETRIC MATRIX.
*
      SUBROUTINE UANRH1(NF,NA,KA,AW,HA,NORMA)
      INTEGER NF,NA,KA,NORMA
      $FLOAT AW(NA),HA(NF*(NF+1)/2)
      IF (NORMA.GT.0) THEN
      CALL UXDSMS(NF,HA,AW(KA))
      ENDIF
      RETURN
      END
