$INTERFACE UANRL3                                             97/12/01

  CALL UANRL3(NAL,MA,$AW,$AF,$AM,$AG,$IAG,$JAG,$KBA,$NORMA,$JOB)
  $ADD(REAL,'\$AW($NA)\$AF($NA)\$AM($NA)\$AG($MA)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NAL\MA')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UANRL3             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIAL SCALING OF LINEAR FUNCTIONS.
*
* PARAMETERS :
*  II  NA  NUMBER OF LINEAR FUNCTIONS.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD AG.
*  RI  AW(NA)  VECTOR OF SCALING PARAMETERS.
*  RU  AF(NA)  VECTOR CONTAINING FUNCTION VALUES.
*  RU  AM(NA)  VECTOR CONTAINING MEASURED VALUES.
*  RO  AG(MA)  SPARSE JACOBIAN MATRIX.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  RI  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  II  KBA  SPECIFICATION OF MEASURED VALUES. KBA=0-ZERO MEASURED
*         VALUES. KBA=1 MEASURED VALUES ARE GIVEN IN THE FIELD AM.
*  II  NORMA  SCALING SPECIFICATION. NORMA=0-NO SCALING IS PERFORMED.
*         NORMA=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMA=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  JOB  SCALING SPECIFICATION. IF JOB=1 THEN FORWARD SCALING
*         IS PERFORMED. IF JOB=-1 THEN BACKWARD SCALING IS PERFORMED.
*
      SUBROUTINE UANRL3(NAL,MA,AW,AF,AM,AG,IAG,JAG,KBA,NORMA,JOB)
      INTEGER NAL,MA,IAG(NAL+1),JAG(MA),KBA,NORMA,JOB
      $FLOAT AW(NAL),AF(NAL),AM(NAL),AG(MA)
      $FLOAT POM
      INTEGER J,JP,K,L,KA
      IF (NORMA.LE.0) RETURN
      IF (JOB.EQ.0) RETURN
      DO 2 KA=1,NAL
      POM=AW(KA)
      IF (JOB.LT.0) POM=1.0$P 0/POM
      K=IAG(KA)
      L=IAG(KA+1)-K
      DO 1 J=1,L
      JP=ABS(JAG(K))
      AG(K)=AG(K)*POM
      K=K+1
    1 CONTINUE
      IF (KBA.GT.0) THEN
      IF (JOB.LT.0) AF(KA)=AF(KA)+AM(KA)
      AM(KA)=POM*AM(KA)
      ENDIF
      IF (JOB.LT.0) AF(KA)=POM*AF(KA)
    2 CONTINUE
      RETURN
      END
