$INTERFACE UC2F02                                             97/12/01

      $HELP
        MAXIMUM SIZE OF THE PARTITIONED HESSIAN MATRIX
      $CHECK(MCH,'25*$NC',INT,1)
 $00  CALL UC2F02
      GOTO ($80,$10,$20,$40) ISB+1
 $10  CONTINUE
      $MTYPE=FMODC
      $SUBST('UZCMOD')
      $GO TO $00
 $20  CONTINUE
      $IF(GMODC='G')
        $MTYPE='G'
        $SUBST('UZCMOD')
        GOTO $00
      $ELSEIF(FMODC='F')
        $IF(JACC='S')
          $SUBST('UC0G$(CON)4')
        $ELSE
          $SUBST('UC0G$(CON)2')
        $ENDIF
        GOTO ($00,$30) ISB+1
 $30  CONTINUE
        $MTYPE=FMODC
        $SUBST('UZCMOD')
        GO TO $20
      $ELSE
        IF (LDC.LT.0) GOTO $00
        $MTYPE=FMODC
        $SUBST('UZCMOD')
        GO TO $00
      $ENDIF
  $40 CONTINUE
      $IF(HMODC='H')
        $MTYPE='H'
        $SUBST('UZCMOD')
        GOTO $00
      $ELSEIF(GMODC='G')
        $IF(JACC='S')
          $SUBST('UC1H$(CON)4')
        $ELSE
          $SUBST('UC1H$(CON)2')
        $ENDIF
        GOTO ($00,$50) ISB+1
  $50 CONTINUE
        $MTYPE=GMODC
        $SUBST('UZCMOD')
        GO TO $40
      $ELSEIF(FMODC='F')
        $IF(JACC='S')
          $SUBST('UC0H$(CON)4')
        $ELSE
          $SUBST('UC0H$(CON)2')
        $ENDIF
        GO TO ($00,$60) ISB+1
  $60 CONTINUE
        $MTYPE=FMODC
        $SUBST('UZCMOD')
        GO TO $40
      $ELSEIF(FMODC='FG')
        $IF(JACC='S')
          $SUBST('UC1H$(CON)4')
        $ELSE
          $SUBST('UC1H$(CON)2')
        $ENDIF
        GO TO ($00,$70) ISB+1
  $70 CONTINUE
        $MTYPE=FMODC
        $SUBST('UZCMOD')
        GO TO $40
      $ELSE
        IF (LDC.LT.0) GOTO $00
        $MTYPE=FMODC
        $SUBST('UZCMOD')
        GO TO $00
      $ENDIF
 $80  CONTINUE
      $ADD(INIT)
        NCXX='UC2F02'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UC2F02               ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SIMULTANEOUS COMPUTATION OF THE APPROXIMATED FUNCTION VALUES AND
* GRADIENTS.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  LDC  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UC2F02
      $INCLUDE ('UMCOMM')
      IF (TSS(NS).NE.'UCXX') CALL UYPRO1('UCXX',-1)
      GO TO (1,2,4,6) ISP(NS)
    1 CONTINUE
      IF (KD.LT.0) GO TO 5
      IF (LDC.GE.0) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      LDC=0
    3 IF (KD.LT.1) GO TO 7
      IF (LDC.GE.1) GO TO 5
      CALL UYSET0(2,3)
      RETURN
    4 CONTINUE
      LDC=1
    5 IF (KD.LT.2) GO TO 7
      IF (LDC.GE.2) GO TO 7
      CALL UYSET0(3,4)
      RETURN
    6 CONTINUE
      LDC=2
    7 CALL UYEPI1(-1)
      RETURN
      END
