* SUBROUTINE UCCDIR             ALL SYSTEMS                 08/12/01
C PORTABILITY : ALL SYSTEMS
C 08/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* STEP FOR LAGRANGIAN MULTIPLIERS.
*
* PARAMETERS :
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  IX(NX)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  XZL(NX)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NX)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  II  ICA(NCA)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  S(NCA)  VECTOR CONTAINING NEWTON INCREMENTS.
*  RI  GS(NCA)  VECTOR CONTAINING ACTIVE SLACK INCREMENTS.
*  RI  R  STEPSIZE  PARAMETER.
*  RI  RP  PRIMAL STEPSIZE  PARAMETER.
*  RI  RD  DUAL STEPSIZE  PARAMETER.
*
      SUBROUTINE UCCDIR(NX,NC,NCA,IX,XSL,XSU,XZL,XZU,IC,CSL,CSU,
     & CZL,CZU,ICA,S,GS,R,RP,RD)
      INTEGER NX,NC,NCA,IX(NX),IC(NC),ICA(NCA)
      $FLOAT XSL(NX),XSU(NX),XZL(NX),XZU(NX),CSL(NC),CSU(NC),CZL(NC),
     & CZU(NC),S(NCA),GS(NCA),R,RP,RD
      INTEGER I,K,KK
      DO 1 I=1,NCA
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      KK=-IX(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      XZL(K)=XZL(K)+RD*S(I)
      XSL(K)=XSL(K)+RP*GS(I)
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      XZU(K)=XZU(K)+RD*S(I)
      XSU(K)=XSU(K)+RP*GS(I)
      ENDIF
      ELSE
      KK=-IC(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      CZL(K)=CZL(K)+RD*S(I)
      CSL(K)=CSL(K)+RP*GS(I)
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      CZU(K)=CZU(K)+RD*S(I)
      CSU(K)=CSU(K)+RP*GS(I)
      ELSE IF (KK.EQ.5) THEN
      CZL(K)=CZL(K)+R*S(I)
      ENDIF
      ENDIF
    1 CONTINUE
      RETURN
      END
