* SUBROUTINE UCFDOT             ALL SYSTEMS                 01/12/01
C PORTABILITY : ALL SYSTEMS
C 01/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* RESIDUAL TERM FOR PRECISION CONTROL.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  XZL(NF)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NF)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  RI  CF(NF)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  IO  ICA(NX+NC)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RO  CP(NX+NC)  RIGHT HAND SIDE VECTOR.
*
      FUNCTION UCFDOT(NF,NX,NC,NCA,X,IX,XL,XU,XSL,XSU,XZL,XZU,CF,IC,
     & CL,CU,CSL,CSU,CZL,CZU,ICA,CP)
      INTEGER NF,NX,NC,NCA,IX(NX),IC(NC),ICA(NCA)
      $FLOAT X(NF),XL(NX),XU(NX),XSL(NX),XSU(NX),XZL(NX),XZU(NX),
     & CF(NC),CL(NC),CU(NC),CSL(NC),CSU(NC),CZL(NC),CZU(NC),CP(NCA),
     & UCFDOT
      INTEGER I,K
      $FLOAT TEMP,TEMP1
      TEMP=0.0$P 0
      DO 1 I=1,NCA
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      IF (IX(K).EQ.-1.OR.IX(K).EQ.-3) THEN
      TEMP1=XSL(K)+XL(K)-X(I)
      TEMP=TEMP-CP(I)*TEMP1*(TEMP1-XZL(K))/XSL(K)
      ELSE IF (IX(K).EQ.-2.OR.IX(K).EQ.-4) THEN
      TEMP1=XSU(K)+X(K)-XU(K)
      TEMP=TEMP+CP(I)*TEMP1*(TEMP1-XZU(K))/XSU(K)
      ENDIF
      ELSE
      IF (IC(K).EQ.-1.OR.IC(K).EQ.-3) THEN
      TEMP1=CSL(K)+CL(K)-CF(I)
      TEMP=TEMP-CP(I)*TEMP1*(TEMP1-CZL(K))/CSL(K)
      ELSE IF (IC(K).EQ.-2.OR.IC(K).EQ.-4) THEN
      TEMP1=CSU(K)+CF(K)-CU(K)
      TEMP=TEMP+CP(I)*TEMP1*(TEMP1-CZU(K))/CSU(K)
      ELSE IF (IC(K).EQ.-5) THEN
      TEMP=TEMP+CP(I)*CF(K)
      ENDIF
      ENDIF
    1 CONTINUE
      UCFDOT=TEMP
      RETURN
      END
