* SUBROUTINE UCICDC             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* CONVERSION OF THE ACTIVE CONSTRAINT MATRIX CG TO A DENSE RECTANGULAR
* MATRIX.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS IN THE FIELD CG.
*  IO  ICA(NCA)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  CG(MC)  ELEMENTS OF THE CONSTRAINT JACOBIAN MATRIX.
*  II  ICG(NC+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD CG.
*  II  JCG(MC)  COLUMN INDICES OF ELEMENTS IN THE FIELD CG.
*  RO  CA(NF*NC)  DENSE RECTANGULAR MATRIX.
*
* SUBPROGRAMS USED :
*  S   UXVSET  INITIATION OF A VECTOR.
*
      SUBROUTINE UCICDC(NF,NC,NCA,MC,ICA,CG,ICG,JCG,CA)
      INTEGER NF,NC,NCA,MC,ICA(NCA),ICG(NC+1),JCG(MC)
      $FLOAT CG(MC),CA(NF*NCA)
      INTEGER I,J,JP,K,KC,L
      $FLOAT ZERO,ONE
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0)
      CALL UXVSET(NF*NCA,ZERO,CA)
      DO 2 I=1,NCA
      KC=ICA(I)
      IF (KC.LT.0) THEN
      K=-KC
      CA((I-1)*NF+K)=ONE
      ELSE
      K=ICG(KC)
      L=ICG(KC+1)-K
      DO 1 J=1,L
      JP=JCG(K)
      IF (JP.GT.0) CA((I-1)*NF+JP)=CG(K)
      K=K+1
    1 CONTINUE
      ENDIF
    2 CONTINUE
      RETURN
      END
