* SUBROUTINE UCIDOT             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* RESIDUAL TERM FOR PRECISION CONTROL.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  CF(NF)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  IO  ICA(NX+NC)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RO  CP(NX+NC)  RIGHT HAND SIDE VECTOR.
*
      FUNCTION UCIDOT(NF,NX,NC,NCA,X,IX,XL,XU,XSL,XSU,CF,IC,CL,CU,
     & CSL,CSU,ICA,CP)
      INTEGER NF,NX,NC,NCA,IX(NX),IC(NC),ICA(NCA)
      $FLOAT X(NF),XL(NX),XU(NX),XSL(NX),XSU(NX),CF(NC),CL(NC),CU(NC),
     & CSL(NC),CSU(NC),CP(NCA),UCIDOT
      INTEGER I,K
      $FLOAT TEMP
      TEMP=0.0$P 0
      DO 1 I=1,NCA
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      IF (IX(K).EQ.-1.OR.IX(K).EQ.-3) THEN
      TEMP=TEMP+CP(I)*(XL(K)-X(K)+XSL(K))
      ELSE IF (IX(K).EQ.-2.OR.IX(K).EQ.-4) THEN
      TEMP=TEMP+CP(I)*(X(K)-XU(K)+XSU(K))
      ENDIF
      ELSE
      IF (IC(K).EQ.-1.OR.IC(K).EQ.-3) THEN
      TEMP=TEMP+CP(I)*(CL(K)-CF(K)+CSL(K))
      ELSE IF (IC(K).EQ.-2.OR.IC(K).EQ.-4) THEN
      TEMP=TEMP+CP(I)*(CF(K)-CU(K)+CSU(K))
      ELSE IF (IC(K).EQ.-5) THEN
      TEMP=TEMP+CP(I)*CF(K)
      ENDIF
      ENDIF
    1 CONTINUE
      UCIDOT=TEMP
      RETURN
      END
