* SUBROUTINE UCMLAG             ALL SYSTEMS                 09/12/01
C PORTABILITY : ALL SYSTEMS
C 09/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION.
* COMPUTATION OF THE VALUES AND THE GRADIENTS OF THE CONSTRAINT
* FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATING FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  RI  AZL(NA)  VECTOR CONTAINING LOVER MULTIPLIERS FOR APPROXIMATING
*         FUNCTIONS.
*  RI  AZU(NA)  VECTOR CONTAINING UPPER MULTIPLIERS FOR APPROXIMATING
*         FUNCTIONS.
*  RI  AG(MA)  NEW GRADIENT OF THE SELECTED FUNCTION.
*  RI  AGO(MA)  OLD GRADIENT OF THE SELECTED FUNCTION.
*  II  IAG(NA+1)  POSITIONS OF THE FIRST ROWS ELEMENTS IN THE SPARSE
*         JACOBIAN STRUCTURE.
*  II  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE SPARSE JACOBIAN
*         STRUCTURE.
*  RO  GO(NF)  DIFFERENCE OF GRADIENTS OF THE LAGRANGIAN FUNCTION.
*
* COMMON DATA :
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*
      SUBROUTINE UCMLAG(NF,NA,MA,AZL,AZU,AG,AGO,IAG,JAG,GO)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NA,MA,IAG(NA+1),JAG(MA)
      $FLOAT AZL(NA),AZU(NA),AG(MA),AGO(MA),GO(NF)
      INTEGER J,K,KA,L,JP
      CALL UXVSET(NF,ZERO,GO)
      DO 4 KA=1,NA
      K=IAG(KA)
      L=IAG(KA+1)-K
      DO 3 J=1,L
      JP=ABS(JAG(K))
      IF (IEXT.EQ.0) THEN
      GO(JP)=GO(JP)+(AZU(KA)-AZL(KA))*(AG(K)-AGO(K))
      ELSE IF (IEXT.LT.0) THEN
      GO(JP)=GO(JP)+AZU(KA)*(AG(K)-AGO(K))
      ELSE IF (IEXT.GT.0) THEN
      GO(JP)=GO(JP)-AZL(KA)*(AG(K)-AGO(K))
      ENDIF
      K=K+1
    3 CONTINUE
    4 CONTINUE
      RETURN
      END
