$INTERFACE UDCLM3                                             98/12/01
$REM LU

  $CON0='1.0$P-8'
  $CON1='1.0$P-3'
  $CON2='0.1$P-9'
  $CON3='7.5$P 1'
  $CON4='1.0$P-7'
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $GSS=GS
  $XSS=XS
  $GS=XS
  $XS=XO
  $HELP
    PRECONDITIONING TECHNIQUE
      ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
      ABS(MOS2)=1 - INCOMPLETE GILL-MURRAY PRECONDITIONING
         MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
         MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                    BY PRECONDITIONED ITERATIVE PROCESS
  $CHECK(MOS2,0,'-1\0\1',1)
  $HELP
    PRECONDITIONING IN ILL-CONTITIONED CASES
      0 - PRECONDITIONING IS SUPPRESSED
      1 - PRECONDITIONING IS USED
  $CHECK(MOS3,0,'0\1',1)
  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-8',REAL,4)
  $HELP
    TOLERANCE FOR ILL CONDITIONED MATRICES
  $CHECK(ETA2,'1.0$P-4',REAL,4)
  $ADD(REAL,'\$H($MMAX)\$GN($NF)\$SN($NF)\$XS($NF)\$GO($NF)\$GS($NF)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\$IX($NX)')
  $DEFAULT='0.25$P 0'
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $ADD(REAL,'\UXUDOT')
  $ADD(REAL,'\RHO\RHO1\RHO2\SIG\ALF')
  $ADD(INTEGER,'\NOS2')
  $NOS2=0
  CALL UOD1D1
  $IF(MOS2= 1) $NOS2=1
  $IF(MOS2=-1) $NOS2=1
  $N='NF'
  IF (IDECF.LT.0) IDECF=0
  IF (IDECF.NE.0.AND.IDECF.NE.1) THEN
  ITERD=-1
  CALL UOERR1('UDCLM3',1)
  TDXX='BAD DEC1'
  GO TO $60
  $IF(NOS2=1)
    ELSE IF (IDECF.EQ.0) THEN
    INF=0
    ALF=ETA2
    NOS2=ABS(MOS2)
    IF (2*M.GE.$MMAX) THEN
    CALL UOERR2('UDCLM3',48,2*M,$MMAX)
    ITERM=-48
    TDXX='LACK SPC'
    GO TO $60
    ENDIF
    CALL UXVCOP(M,$H,$H(M+1))
    CALL UXSPIF($N,M,$H(M+1),$IH,$JH,INF,ALF,SIG,GO)
    $IF(MOS3=0)
      IF (INF.LT.0) NOS2=0
    $ENDIF
    NDECF=NDECF+1
    IDECF=1
  $ENDIF
  ENDIF
  RHO1=UXUNOB($N,$GN,$IX,KBF)
  GNORM=RHO1
  INITD=MAX(ABS(INITD),1)
  PAR=MIN(EPS6,SQRT(GNORM))
  IF (PAR.GT.TEN*$CON1) THEN
  IF (MOS.EQ.1) THEN
  ELSE IF (MOS.EQ.2) THEN
  PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  IF (NIT-LIT.GE.NF) PAR=$CON4
  ELSE IF (MOS.EQ.3) THEN
  PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  ENDIF
  ENDIF
$REM  $IF(MOS2=1)
  $IF(.FALSE.)
    CALL UXVNEG($N,$GN,$SN)
    CALL UXSPIB($N,M,$H(M+1),$IH,$JH,$SN,0)
    CALL UXSSMD($N,M,$H,$IH,$JH,$SN,ONE,$GN,$GO)
    IF (UXUDOT($N,$GO,$GO,$IX,KBF).LE.PAR*RHO1) THEN
    SNORM=SQRT(UXUDOT($N,$SN,$SN,$IX,KBF))
    ITERD=2
    TDXX='G.M. REG'
    GO TO $60
    ENDIF
  $ENDIF
  RHO=RHO1
  SNORM=ZERO
  CALL UXVSET($N,ZERO,$SN)
  CALL UXVNEG($N,$GN,$GS)
  CALL UXVNEG($N,$GN,$XS)
  $IF(NOS2=1)
    IF (NOS2.EQ.1) THEN
    CALL UXSPIB($N,M,$H(M+1),$IH,$JH,$XS,0)
    RHO=UXUDOT($N,$GS,$XS,$IX,KBF)
    ENDIF
  $ENDIF
  SIG=RHO
  NRED=0
$20 CONTINUE
  NRED=NRED+1
  IF(NRED.GT.N+3) GO TO $50
  CALL UXSSMM($N,M,$H,$IH,$JH,$XS,$GO)
  ALF=UXUDOT($N,$XS,$GO,$IX,KBF)
  IF (ALF.LE.$CON0*SIG) THEN
*
*     CG FAILS (THE MATRIX IS NOT POSITIVE DEFINITE)
*
  CALL UOD1D5(ALF,SIG,INF)
  IF (NRED.EQ.1) THEN
  CALL UXVNEG($N,$GN,$SN)
  SNORM=GNORM
  ENDIF
  ITERD=0
  TDXX='CG  FAIL'
  GO TO $60
  ELSE
  TDXX='CG  STEP'
  ITERD=2
  ENDIF
*
*     CG STEP
*
  ALF=RHO/ALF
  CALL UXUDIR($N, ALF,$XS,$SN,$SN,$IX,KBF)
  CALL UXUDIR($N,-ALF,$GO,$GS,$GS,$IX,KBF)
  RHO2=UXUDOT($N,$GS,$GS,$IX,KBF)
  SNORM=SQRT(UXUDOT($N,$S,$S,$IX,KBF))
  CALL UOD1D4(RHO1,RHO2,PAR,SNORM,XDEL)
  IF (RHO2.LE.PAR*RHO1) GO TO $60
  IF (NRED.GE.N+3) GO TO $50
  $IF(NOS2=1)
    IF (NOS2.EQ.1) THEN
    CALL UXVCOP($N,$GS,$GO)
    CALL UXSPIB($N,M,$H(M+1),$IH,$JH,$GO,0)
    RHO2=UXUDOT($N,$GS,$GO,$IX,KBF)
    ALF=RHO2/RHO
    CALL UXUDIR($N,ALF,$XS,$GO,$XS,$IX,KBF)
    ELSE
    ALF=RHO2/RHO
    CALL UXUDIR($N,ALF,$XS,$GS,$XS,$IX,KBF)
    ENDIF
  $ELSE
    ALF=RHO2/RHO
    CALL UXUDIR($N,ALF,$XS,$GS,$XS,$IX,KBF)
  $ENDIF
  RHO=RHO2
  SIG=RHO2+ALF*ALF*SIG
  GO TO $20
$50 CONTINUE
  TDXX='MAX ITER'
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$60 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $GS=GSS
  $XS=XSS
  $ADD(INIT)
    NDXX='UDCLM3'
  $ENDADD
  $EXIT

