$INTERFACE UDDEQ2                                             99/12/01
$REM LU

  $CON1='5.0$P-2'
  $CON2='1.0$P 1'
  $ADD(REAL,'\$X($NF)\$XO($NF)\$G($NF)\$S($NF)\$AG($NF*$NA)')
  $ADD(REAL,'\DEL\RHO\ETA\TEMP\FTEMP\XSTEP\DNORM\DNORMO')
  $ADD(INTEGER,'\I\J\K\LA')
  $ADD(LOGICAL,'\L1')
  $N='N
  IF (NIT.LE.LIT+1) THEN
*
*     INITIALIZE SOME OF THE VARIABLES.
*
  NI1=-1
  NI2=-1
  NI3= 0
  ETA=DSQRT(ETA0)
  DEL=$CON2*XNORM
  IF (XNORM.EQ.ZERO) DEL=$CON2
*
*     DETERMINE AN OPTIMAL VALUE FOR MIC.
*
  RHO=ZERO
  DO $10 J=1,N
  TEMP=LOG($DBLE(J+1))/$DBLE(N+2*J+1)
  IF (TEMP.LT.RHO) GO TO $10
  MIC=J
  RHO=TEMP
$10 CONTINUE
  ENDIF
*
*     ENTER THE PRINCIPAL ITERATION.
*
  NS=N
  FO=F
  DNORMO=DNORM
  F=ZERO
*
*     COMPUTE THE STEP H FOR THE DIVIDED DIFFERENCE WHICH
*     APPROXIMATES THE K-TH ROW OF THE JACOBIAN MATRIX.
*
  XSTEP=ETA*XNORM
  IF (XSTEP.EQ.ZERO) XSTEP=ETA
*  CALL UXDRMO(N,N,XSTEP,$AG)
  CALL UXDRMI(N,N,$AG)
  CALL UXDRDS(N,N,$AG,XSTEP)
  CALL UXVCOP(N,$X,$XO)
*
*     ENTER A SUBITERATION.
*
  KA=0
$20 KA=KA+1
  IF (KA.GT.NA) GO TO $55
  ASSIGN $30 TO IMD
$25 CONTINUE
  $IF(NAL>0)
    IF (KA.LE.NAL) THEN
    $SUBST('UALNF1')
    $IF(KBA>0) $SUBST('UATRF1')
    $IF(ISNA>0) $SUBST('UASVF1')
    GO TO IMD
    ENDIF
  $ENDIF
  $IF(NAL<$NA)
    $MTYPE=FMODA
    $SUBST('UZAMOD')
    $IF(NORMA>0) $SUBST('UANRF1')
    $IF(KBA>0) $SUBST('UATRF1')
    $IF(ISNA>0) $SUBST('UASVF1')
    GO TO IMD
  $ENDIF
$30 CONTINUE
  FTEMP=FA
  F=MAX(F,ABS(FA))
*
*     COMPUTE THE K-TH ROW OF THE JACOBIAN MATRIX.
*
  CALL UXVCOP(N,$X,$G)
  K=(KA-1)*N+1
  DO $40 J=KA,N
  CALL UXVSUM(N,$AG(K),$G,$X)
  ASSIGN $35 TO IMD
  GO TO $25
$35 CONTINUE
  $S(J)=FA-FTEMP
  K=K+N
$40 CONTINUE
*
*      COMPUTE THE HOUSEHOLDER TRANSFORMATION TO REDUCE THE K-TH ROW
*      OF THE JACOBIAN MATRIX TO A MULTIPLE OF THE K-TH UNIT VECTOR.
*
  LA=NA-KA+1
  RHO=UXVMAX(LA,$S(KA))
  IF (RHO.EQ.ZERO) THEN
  CALL UXVCOP(N,$G,$X)
  GO TO $20
  ENDIF
  NS=NS-1
  CALL UXVSCL(LA,ONE/RHO,$S(KA))
  SNORM=UXVNOR(LA,$S(KA))
  IF ($S(KA).LT.ZERO) SNORM=-SNORM
  $S(KA)=$S(KA)+SNORM
*
*     APPLY THE TRANSFORMATION AND COMPUTE THE MATRIX $AG.
*
  CALL UXVSET(N,ZERO,$X)
  K=(KA-1)*N+1
  DO $45 J=KA,N
  CALL UXVDIR(N,$S(J),$AG(K),$X,$X)
  K=K+N
$45 CONTINUE
  K=(KA-1)*N+1
  DO $50 J=KA,N
  CALL UXVDIR(N,-$S(J)/(SNORM*$S(K)),$X,$AG(K),$AG(K))
  K=K+N
$50 CONTINUE
*
*     COMPUTE THE SUBITERATE.
*
  $S(KA)=SNORM*RHO
  TEMP=FTEMP/$S(KA)
  IF (XSTEP*ABS(TEMP).GT.DEL) TEMP=SIGN(DEL/XSTEP,TEMP)
  CALL UXVDIR(N,TEMP,$AG((KA-1)*N+1),$G,$X)
  GO TO $20
$55 CONTINUE
*
*     COMPUTE THE NORMS OF THE ITERATE AND CORRECTION VECTOR.
*
  XNORM=UXVMAX(N,$X)
  DNORM=UXVMX2(N,$XO,$X)
  CALL UXVCOP(N,$X,$XO)
*
*     UPDATE THE BOUND ON THE CORRECTION VECTOR.
*
  DEL=MAX(DEL,$CON2*XNORM)
*
*     DETERMINE THE PROGRESS OF THE ITERATION.
*
  L1=(F.LT.FO.AND.DNORM.LT.DNORMO.AND.NS.EQ.0)
  NI1=NI1+1
  NI2=NI2+1
  NI3=NI3+1
  IF (L1) NI1=0
  IF (F.LT.FO.OR.DNORM.LT.DNORMO) NI2=0
  IF (DNORM.GT.ETA*XNORM) NI3=0
*
*     TESTS FOR CONVERGENCE.
*
  IF (F*F.LE.$TOLB) ITERM=3
  IF (DNORM.LE.$TOLX*XNORM.AND.L1) ITERM=1
  IF (F.LE.$TOLB.AND.ITERM.EQ.1) ITERM=3
  IF (ITERM.NE.0) GO TO $80
*
*     TESTS FOR TERMINATION.
*
  IF (NS.EQ.N) ITERM=-5
  IF (NI1.EQ.5) ITERM=-6
  IF (NI2.EQ.3) ITERM=-7
  IF (NI3.EQ.4) ITERM=-8
  IF (ITERM.NE.0) GO TO $80
*
*     ITERATIVE REFINEMENT IS USED IF THE ITERATION IS CONVERGING.
*
  IF (.NOT.L1.OR.DNORM.GT.$CON1*XNORM.OR.MIC.EQ.1) GO TO $80
*
*     START ITERATIVE REFINEMENT.
*
  NIC=1
$60 NIC=NIC+1
  IF (NIC.GT.MIC) GO TO $80
  FO=F
  F=ZERO
  KA=0
$65 KA=KA+1
  IF (KA.GT.NA) GO TO $75
  K=(KA-1)*$N+1
  ASSIGN $70 TO IMD
  GO TO $25
$70 CONTINUE
  F=MAX(F,ABS(FA))
*
*     ITERATIVE REFINEMENT IS TERMINATED IF IT DOES NOT
*     GIVE A REDUCTION OF THE RESIDUALS.
*
  IF (F.GE.FO) THEN
  F=FO
  GO TO $80
  ENDIF
  CALL UXVDIR(N,FA/$S(K),$AG(K),$X,$X)
  GO TO $65
$75 CONTINUE
*
*     COMPUTE THE NORMS OF THE ITERATE AND CORRECTION VECTOR.
*
  XNORM=UXVMAX(N,$X)
  DNORM=UXVMX2(N,$XO,$X)
  CALL UXVCOP(N,$X,$XO)
*
*     STOPPING CRITERIA FOR ITERATIVE REFINEMENT.
*
  IF (F*F.LE.$TOLB) ITERM=3
  IF (DNORM.LE.$TOLX*XNORM) ITERM=1
  IF (F*F.LE.$TOLB.AND.ITERM.EQ.1) ITERM=3
  IF (ITERM.NE.0) GO TO $80
  GO TO $60
$80 CONTINUE
*
*     END OF THE ITERATIVE REFINEMENT.
*     TERMINATION, EITHER NORMAL OR USER IMPOSED.
*
  NFV=NAV/(NA-NAL)
  $ADD(INIT)
    NDXX='UDDEQ2'
  $ENDADD
  $EXIT
