$INTERFACE UDDLI1                                             08/12/01
$REM LU

  $HELP
    COMPUTATION OF THE DIRECTION VECTOR:
      0 - USING MATRIX MULTIPLICATION
      1 - USING THE VARIABLE METRIC UPDATE 
  $CHECK(MOS5,0,'0\1',3)
  $ADD(REAL,'\$GN($NF)\$SN($NF)')
  $ADD(REAL,'\ALF\BET')
  CALL UOD1D1
  $ADD(REAL,'\$H($M)')
  $ADD(REAL,'\UXVDOT')
  $POM1='V'
  $POM2=')'
  $N='N'
  IF (IDECF.LT.0) THEN
  $IDECF=9
  IDECF=9
  INF=0
  ENDIF
  TDXX(1:4)='INV '
  IF (IDECF.EQ.9) THEN
  ELSE
  ITERD=-1
  TDXX='BAD DEC$IDECF'
  CALL UOERR1('UDDLI1',1)
  GO TO $30
  ENDIF
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
  $IF(MOS5=0)
*
*     MATRIX MULTIPLICATION
*
    CALL UXDSMM($N,$H,$GN,$SN)
    CALL UXVNEG($N,$SN,$SN)
  $ELSE
    $IF(UPDATE='B')
    IF (NIT.EQ.KIT) THEN
*
*     STEEPEST DESCENT
*
    CALL UXVNEG($N,$GN,$SN)
    ELSE IF (ITERH.NE.0) THEN
*
*     MATRIX MULTIPLICATION
*
    CALL UXDSMM($N,$H,$GN,$SN)
    CALL UXVNEG($N,$SN,$SN)
    ELSE
*
*     VARIABLE METRIC UPDATE
*
    $IF(MET=1)
      RPF1=GAM*AUPD/BUPD-(RHO+GAM*AUPD/BUPD)*P/BUPD
      RPF2=GAM*(P/BUPD-ONE)
    $ELSEIF(MET=2)
      RPF1=GAM/R-RHO*P/BUPD
      RPF2=-(GAM/R)*BUPD/AUPD
    $ELSE
      RPF2=(GAM/R)*(ETA*(AUPD*CUPD/BUPD**2-ONE)+ONE)
      RPF1=RPF2+RHO*((CUPD/BUPD)/R-ONE)
      RPF2=-RPF2*BUPD/AUPD
    $ENDIF
    CALL UXVLIN($N,RPF1,$XO,RPF2,$S,$S)
    ENDIF
    $ELSEIF(UPDATE='L')
    IF (NIT.EQ.KIT) THEN
*
*     STEEPEST DESCENT
*
    CALL UXVNEG($N,$GN,$SN)
    ELSE IF (ITERH.NE.0.OR.TUXX.EQ.'BFGS    ') THEN
*
*     MATRIX MULTIPLICATION
*
    CALL UXDSMM($N,$H,$GN,$SN)
    CALL UXVNEG($N,$SN,$SN)
*
*     VARIABLE METRIC UPDATE
*
    ELSE
    RPF1=UXVDOT($N,$GN,$XS)
    RPF2=UXVDOT($N,$GN,$XP)
    CALL UXVDIR($N,-GAM/R,$XO,$SN,$SN)
    CALL UXVDIR($N,RPF1/BET,$XS,$SN,$SN)
    CALL UXVDIR($N,-ETA*RPF2/BET,$XP,$SN,$SN)
    CALL UXVNEG($N,$SN,$SN)
    ENDIF
    $ENDIF
  $ENDIF
  INITD=MAX(ABS(INITD),1)
  ITERD=1
  IF(INF.EQ.0) THEN
  TDXX(5:8)=' POS'
  ELSEIF(INF.LT.0) THEN
  TDXX(5:8)=' ZER'
  ELSE
  TDXX(5:8)=' NEG'
  ENDIF
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  NRED=INF
  CALL UOD1D5(ALF,BET,INF)
$30 CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UDDLI1'
  $ENDADD
  $EXIT

