$INTERFACE UDGGG1                                             16/12/01
$REM LU

$REM  $IF(DEC='R') $DEC='G'
$REM  $IF(DEC='C') $DEC='S'
  $CON0='1.0$P-8'
  $CON1='0.95$P 0'
  $POM1='V'
  $POM2=')'
  $IF(CONSTR='C')
    $IF(HERF='S')
      $POM1='U'
      $POM2=',$$IX,KBF)'
    $ENDIF
  $ENDIF
  $HELP
    METHOD SELECTION:
      1 - SINGLE  DOG-LEG STRATEGY
      2 - DOUBLE  DOG-LEG STRATEGY
      3 - OPTIMUM DOG-LEG STRATEGY
  $CHECK(MOS,2,'1\2\3',3)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0$P-3',REAL,4)
  $HELP
    UPPER BOUND FOR STEPSIZE PARAMETER
  $CHECK(ALF2,'1.0$P 6',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $ADD(REAL,'\$H($M)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)')
  $ADD(REAL,'\UX$(POM1)DOT')
  $ADD(REAL,'\B1\B2\B3\D3\S1\S2')
  $IF(MOS=3)
    $ADD(REAL,'\D1\D2\G1\G2')
  $ENDIF
  CALL UOD1D1
  IF (IDECF.LT.0) THEN
  $IF(HERF='D')
    $HELP
      CHOICE OF THE SCALING MATRIX:
        0 - UNIT MATRIX (NO SCALING)
        1 - SQUARE OF THE MATRIX H DIAGONAL
    $CHECK(MOS1,0,'0\1',4)
    $IF(MOS1=0)
      $XSS=XS
      $XS=XO
      $GSS=GS
      $GS=GO
    $ENDIF
    $ADD(REAL,'\$XS($NF)\$GS($NF)')
    $ADD(REAL,'\UXDSMQ')
    $N='N'
$REM    $B='H'
    $IF(DEC='M')
      $ADD(INTEGER,'\JDECF')
      $ADD(REAL,'\$B($M)')
      $ADD(REAL,'\UXDPGQ')
      $HELP
         TYPE OF DECOMPOSITION
           0 - GILL-MURRAY DECOMPOSITION
           1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,0,'0\1\2',2)
      $IF(MOS2=0)
      $ELSE
        $IF(MOS2=1) 
          $LET='L'
          $ART=',$IB)'
          $ADD(INTEGER,'\$IB($NF)')
        $ELSE  
          $LET='S'
          $ART=')'
        $ENDIF
        $ADD(INTEGER,'\$IH($NF)')
        CALL UXVINP($N,$IH)
      $ENDIF
      $IDECF=0
      IDECF=0
      INF=0
      ENDIF
      IF (IDECF.EQ.0) THEN
      CALL UXDSMC($N,$H,$B)
      $HS=H
      $H=B
      $IF(MOS1>0)
        CALL UXDSMX($N,$H,$GS)
        CALL UXVCOP($N,$GN,$XS)
        CALL UXVMUL($N,$GS,$GN,$GN,1)
      $ENDIF
      JDECF=0
    $ELSEIF(DEC='G')
      $ADD(REAL,'\UXDPGQ')
      $IDECF=1
      IDECF=1
      INF=0
      ENDIF
      IF (IDECF.EQ.0) THEN
      $IF(MOS1>0)
        CALL UXDSMX($N,$H,$GS)
        CALL UXVCOP($N,$GN,$XS)
        CALL UXVMUL($N,$GS,$GN,$GN,1)
      $ENDIF
      ELSE IF (IDECF.EQ.1) THEN
$REM      ELSE IF (IDECF.EQ.2) THEN
$REM      CALL UXDPRT($N,$H)
$REM      IDECF=1
    $ELSEIF(DEC='S')
      $HELP
         TYPE OF DECOMPOSITION
           1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,1,'1\2',2)
      $IF(MOS2=1) 
        $LET='L'
        $ART=',$IB)'
        $ADD(INTEGER,'\$IB($NF)')
      $ELSE  
        $LET='S'
        $ART=')'
      $ENDIF
      $ADD(INTEGER,'\$IH($NF)')
      $ADD(REAL,'\UXDPGQ')
      CALL UXVINP($N,$IH)
      $IDECF=4
      IDECF=4
      INF=0
      ENDIF
      IF (IDECF.EQ.0) THEN
      $IF(MOS1>0)
        CALL UXDSMX($N,$H,$GS)
        CALL UXVCOP($N,$GN,$XS)
        CALL UXVMUL($N,$GS,$GN,$GN,1)
      $ENDIF
$REM      ELSE IF (IDECF.EQ.1) THEN
$REM      CALL UXVINP($N,$IH)
$REM      IDECF=4
      ELSE IF (IDECF.EQ.4) THEN
    $ELSEIF(DEC='B')
      $ADD(INTEGER,'\$IH($NF)')
      $HELP
         TYPE OF DECOMPOSITION
           1 - BUNCH-PARLETT DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - BUNCH-KAUFMAN DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           3 - BUNCH PARLETT DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,1,'1\2\3',2)
      $IF(MOS2<3)
        $LET='L'
        $ART=',MOS2)'
        $ADD(REAL,'\UXDLBQ')
      $ELSE
        $LET=S
        $ART=')'
        $ADD(REAL,'\UXDSBQ')
      $ENDIF
      CALL UXVINP($N,$IH)
      $IDECF=3
      IDECF=3
      INF=0
      ENDIF
      IF (IDECF.EQ.0) THEN
      $IF(MOS1>0)
        CALL UXDSMX($N,$H,$GS)
        CALL UXVCOP($N,$GN,$XS)
        CALL UXVMUL($N,$GS,$GN,$GN,1)
      $ENDIF
      ELSE IF (IDECF.EQ.3) THEN
    $ELSEIF(DEC='R') 
      $IDECF=2
      IDECF=2
      INF=0
      ENDIF
      IF (IDECF.EQ.2) THEN
    $ELSEIF(DEC='C') 
      $ADD(INTEGER,'\$IH($NF)')
      $ADD(REAL,'\$SO($NF)')
      $HELP
        QR DECOMPOSITION SPECIFICATION
          1 - RANK REVEALING QR DECOMPOSITION
              WITH PERMUTATIONS
          2 - FULL QR DECOMPOSITION WITH
              PERMUTATIONS
      $CHECK(MOS3,1,'1\2',3)
      $IDECF=5
      IDECF=5
      INF=0
      ENDIF
      IF (IDECF.EQ.5) THEN
    $ENDIF
  $ELSEIF(HERF='S')
    $ADD(INTEGER,'\MM')
    $N='NF'
    $IF(DEC='G')
      $ADD(REAL,'\$XS($NF)')
      $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$PSL($NF+1)\$PERM($NF)')
      $ADD(INTEGER,'\$WN11($NF+1)\$WN12($NF+1)')
      $ADD(REAL,'\UXSSMQ\UXSPCQ')
      $IDECF=1
      IDECF=0
      INF=0
      ENDIF
      MM=$IH($N+1)-1
      IF (IDECF.EQ.0) THEN
      ELSE IF (IDECF.EQ.1) THEN
    $ELSEIF(DEC='B')
      $HS='HS'
      $ADD(REAL,'\$HS($M)\$XS($NF)')
      $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\$KH($M)\$IW($MMAX)&
      \$IW1(2*$NF+1)\$IW2(3*$NF+1)')
      $ADD(REAL,'\UXSSMQ')
      $IDECF=3
      IDECF=0
      INF=0
      ENDIF
      MM=$IH($N+1)-1
      IF (IDECF.EQ.0) THEN
      ELSE IF (IDECF.EQ.3) THEN
    $ENDIF
  $ENDIF
  ELSE
  ITERD=-1
  TDXX='BAD DEC$IDECF'
  CALL UOERR1('UD$(HERF)G$(DEC)1',1)
  GO TO $30
  ENDIF
  B2=UX$(POM1)DOT($N,$GN,$GN$POM2
  GNORM=SQRT(B2)
  INITD=MAX(ABS(INITD),1)
  INF=0
  MODE=1
  IF(ALF2*GNORM.LE.XDEL) THEN
  MODE=2
  $IF(HERF='D')
    $IF(DEC='M')
      IF (JDECF.EQ.0) THEN
      $IF(MOS2=0)
*
*     GILL-MURRAY DECOMPOSITION
*
        S1=ETA2
        CALL UXDPGF($N,$H,INF,S1,S2)
        NDECF=NDECF+1
        JDECF=1
        ENDIF
        IF(INF.GT.0) THEN
        CALL UXDPGD($N,$H,$SN,INF)
      $ELSE
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
        S1=ETA2
        CALL UXD$(LET)GF($N,$H,$IH,$GO,INF,S1,S2$ART
        NDECF=NDECF+1
        JDECF=4
        ENDIF
        IF(INF.GT.0) THEN
        CALL UXD$(LET)GD($N,$H,IH,$SN,INF)
      $ENDIF
    $ELSEIF(DEC='G')
      IF (IDECF.EQ.0) THEN
*
*     GILL-MURRAY DECOMPOSITION
*
      S1=ETA2
      CALL UXDPGF($N,$H,INF,S1,S2)
      NDECF=NDECF+1
      IDECF=1
      ENDIF
      IF(INF.GT.0) THEN
      CALL UXDPGD($N,$H,$SN,INF)
    $ELSEIF(DEC='S')
      IF (IDECF.EQ.0) THEN
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
      S1=ETA2
      CALL UXD$(LET)GF($N,$H,$IH,$GO,INF,S1,S2$ART
      NDECF=NDECF+1
      IDECF=4
      ENDIF
      IF(INF.GT.0) THEN
      CALL UXD$(LET)GD($N,$H,IH,$SN,INF)
    $ELSEIF(DEC='B')
      IF (IDECF.EQ.0) THEN
*
*     BUNCH PARLETT DECOMPOSITION
*
      S1=ETA2
      CALL UXD$(LET)BF($N,$H,$IH,INF,S1$ART
      NDECF=NDECF+1
      IDECF=3
      ENDIF
      IF(INF.GT.0) THEN
      CALL UXD$(LET)BD($N,$H,$IH,$SN,S1,INF)
    $ELSEIF(DEC='C')
      $IF(MOS3=2)
        IF (IDECA.EQ.6) THEN
*
*     FULL QR DECOMPOSITION
*
        CALL UXDTTF($N,INF,$H,$IH,$SO)
        ENDIF
       $ENDIF
    $ENDIF
  $ELSEIF(HERF='S')
    $IF(DEC='G')
      IF (IDECF.EQ.0) THEN
      CALL UXSPCT($N,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
      IF (ITERM.NE.0) THEN
      TDXX='LACK SPC'
      GO TO $30
      ENDIF
*
*     SPARSE GILL-MURRAY DECOMPOSITION
*
      S1=ETA2
      CALL UXSPCF($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$XS,INF&
,S1,S2)
      NDECF=NDECF+1
      IDECF=1
      ENDIF
      IF(INF.GT.0) THEN
      CALL UXSPCD($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$SN,INF)
      CALL UXVSBP($N,$PERM,$SN,$XS)
    $ELSEIF(DEC='B')
      S1=ETA2
$REM    IF (IDECF.EQ.0) THEN
$REM*
$REM*     SPARSE BUNCH-PARLETT DECOMPOSITION
$REM*
$REM    CALL UXVCOP($IH($N+1)-1,$H,$HS)
$REM    CALL UXSIBF($N,MM,$KH,$JH,$H,MMAX,$IW,MMAX,$IW1,$IW2,NAU,NUP&
$REM,ITERM)
$REM    IF (ITERM.LT.0) THEN
$REM    TXFU='LACK SPC'
$REM    GO TO $30
$REM    ENDIF
$REM    NDECF=NDECF+1
$REM    IDECF=3
$REM    ENDIF
      INF=0
      IF(INF.GT.0) THEN
$REM      CALL UXSIBD($N,$H,$IH,$SN,S1,INF)
    $ENDIF
  $ENDIF
  $IF(DEC='R')
  $ELSEIF(DEC='C')
  $ELSE
  
*
*     DIRECTION OF NEGATIVE CURVATURE
*
    SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
    IF(SNORM*SNORM*GNORM+S1*XDEL.LE.ZERO) THEN
    CALL UXVSCL($N,XDEL/SNORM,$SN,$SN)
    SNORM=XDEL
    INITD=-ABS(INITD)
    ITERD=4
    TDXX='NEG  DIR'
    GO TO $20
    ENDIF
    ELSE IF (GNORM.LE.ZERO) THEN
*
*     ZERO DIRECTION
*
    SNORM=ZERO
    CALL UXVSET($N,ZERO,$SN)
    TDXX='ZERO DIR'
    GO TO $20
    ENDIF
  $ENDIF
  ENDIF
  $IF(HERF='D')
    $IF(DEC='M')
      IF (JDECF.EQ.0) THEN
      B1=UXDSMQ($N,$H,$GN,$GN)
      ELSE
      CALL UXVCOP($N,$GN,$GO)
      $IF(MOS2=0)
        CALL UXDPGM($N,$H,$GO,1)
        B1=UXDPGQ($N,$H,$GO,$GO)
      $ELSE
        CALL UXD$(LET)GM($N,$H,$IH,$GO,1)
        B1=UXDPGQ($N,$H,$GO,$GO)
      $ENDIF
      ENDIF
    $ELSEIF(DEC='G')
      IF (IDECF.EQ.0) THEN
      B1=UXDSMQ($N,$H,$GN,$GN)
      ELSE
      CALL UXVCOP($N,$GN,$GO)
      CALL UXDPGM($N,$H,$GO,1)
      B1=UXDPGQ($N,$H,$GO,$GO)
      ENDIF
    $ELSEIF(DEC='S')
      IF (IDECF.EQ.0) THEN
      B1=UXDSMQ($N,$H,$GN,$GN)
      ELSE
      CALL UXVCOP($N,$GN,$GO)
      CALL UXD$(LET)GM($N,$H,$IH,$GO,1)
      B1=UXDPGQ($N,$H,$GO,$GO)
      ENDIF
    $ELSEIF(DEC='B')
      IF (IDECF.EQ.0) THEN
      B1=UXDSMQ($N,$H,$GN,$GN)
      ELSE
      CALL UXVCOP($N,$GN,$GO)
      CALL UXD$(LET)BM($N,$H,$IH,$GO,1)
      $IF(MOS2<3) 
        B1=UXDLBQ($N,$H,$IH,$GO)
      $ELSE
        B1=UXDSBQ($N,$H,$IH,$GO,$GO)
      $ENDIF
      ENDIF
    $ELSEIF(DEC='R')  
      CALL UXVCOP($N,$GN,$GO)
      CALL UXDPRM($N,$H,$GO,1)
      B1=UXVDOT($N,$GO,$GO)
    $ELSEIF(DEC='C')  
      CALL UXVCOP($N,$GN,$GO)
      CALL UXDSRM($N,$H,$IH,$GO,1)
      B1=UXVDOT($N,$GO,$GO)
    $ENDIF
  $ELSEIF(HERF='S')
    $IF(DEC='G')
      IF (IDECF.EQ.0) THEN
      $IF(CHORDAL='YES')
        CALL UX$(POM1)COP($N,$GN,$GO$POM2
        CALL UXVSFP($N,$PERM,$GO,$XS)
        B1=UXSSMQ($N,MMAX,$H,$IH,$JH,$GO,$GO)
      $ELSE
        B1=UXSSMQ($N,MMAX,$H,$IH,$JH,$GN,$GN)
      $ENDIF
      ELSE
      CALL UX$(POM1)COP($N,$GN,$GO$POM2
      CALL UXVSFP($N,$PERM,$GO,$XS)
      CALL UXSPCM($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$GO,$XS,1)
      B1=UXSPCQ($N,MMAX-MM,$H(MM+1),$PSL,$GO)
$REM    CALL UXVSBP($N,$PERM,$GO,$XS)
      ENDIF
    $ELSEIF(DEC='B')
      B1=UXSSMQ($N,MMAX-MM,$H,$IH,$JH,$GN,$GN)
    $ENDIF
  $ENDIF
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  IF (B1.LE.ZERO) THEN
  XDEL=GNORM
  ELSE
  XDEL=(B2/B1)*GNORM
  ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  $IF(MOS=3)
*
*     OPTIMUM DOG-LEG STRATEGY
*
    $IF(HERF='D')
      $IF(DEC='M')
        IF (JDECF.EQ.0) THEN
        $IF(MOS2=0)
*
*     GILL-MURRAY DECOMPOSITION
*
          S1=ETA2
          CALL UXDPGF($N,$H,INF,S1,S2)
          NDECF=NDECF+1
          JDECF=1
          ENDIF
          CALL UXVCOP($N,$GN,$GO)
          CALL UXDPGB($N,$H,$GO,0)
        $ELSE
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
          S1=ETA2
          CALL UXD$(LET)GF($N,$H,$IH,$GO,INF,S1$ART
          NDECF=NDECF+1
          JDECF=4
          ENDIF
          CALL UXVCOP($N,$GN,$GO)
          CALL UXD$(LET)GB($N,$H,$IH,$GO,0)
        $ENDIF
      $ELSEIF(DEC='G')
        IF (IDECF.EQ.0) THEN
*
*     GILL-MURRAY DECOMPOSITION
*
        S1=ETA2
        CALL UXDPGF($N,$H,INF,S1,S2)
        NDECF=NDECF+1
        IDECF=1
        ENDIF
        CALL UXVCOP($N,$GN,$GO)
        CALL UXDPGB($N,$H,$GO,0)
      $ELSEIF(DEC='S')
        IF (IDECF.EQ.0) THEN
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
        S1=ETA2
        CALL UXD$(LET)GF($N,$H,$IH,$GO,INF,S1,S2)
        NDECF=NDECF+1
        IDECF=4
        ENDIF
        CALL UXVCOP($N,$GN,$GO)
        CALL UXD$(LET)GB($N,$H,$IH,$GO,0)
      $ELSEIF(DEC='B')
        IF (IDECF.EQ.0) THEN
*
*     BUNCH PARLETT DECOMPOSITION
*
        S1=ETA2
        CALL UXD$(LET)BF($N,$H,$IH,INF,S1$ART
        NDECF=NDECF+1
        IDECF=3
        ENDIF
        CALL UXVCOP($N,$GN,$GO)
        CALL UXD$(LET)BB($N,$H,$IH,$GO,0)
      $ELSEIF(DEC='R')
        IF (IDECA.EQ.5) THEN  
        CALL UXVCOP($N,$SN,$GO)
        S1=ETA2
        CALL UXDTGB($N,INF,$H,$GO,S1)
        ELSE
        CALL UXVCOP($N,$GN,$GO)
        CALL UXDPRB($N,$H,$GO,0)
        ENDIF
      $ELSEIF(DEC='C')
        IF (IDECA.EQ.6) THEN  
        CALL UXVCOP($N,$SN,$GO)
        S1=ETA2
        $IF(MOS3=2)
*
*     FULL QR DECOMPOSITION
*
          CALL UXDTTF($N,INF,$H,$IH,$SO)
          CALL UXDTTB($N,INF,$H,$IH,$XO,$SO,$GO,S1)
        $ELSE  
        $ENDIF
        ELSE
        CALL UXVCOP($N,$GN,$GO)
        CALL UXDSRB($N,$H,$IH,$GO,0)
        ENDIF
      $ENDIF
    $ELSEIF(HERF='S')
      $IF(DEC='G')
        IF (IDECF.EQ.0) THEN
        CALL UXSPCT($N,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
        IF (ITERM.NE.0) THEN
        TDXX='LACK SPC'
        GO TO $30
        ENDIF
*
*     SPARSE GILL-MURRAY DECOMPOSITION
*
        S1=ETA2
        CALL UXSPCF($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$XS&
,INF,S1,S2)
        NDECF=NDECF+1
        IDECF=1
        ENDIF
        CALL UX$(POM1)COP($N,$GN,$GO$POM2
        CALL UXVSFP($N,$PERM,$GO,$XS)
        CALL UXSPCB($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$GO,0)
        CALL UXVSBP($N,$PERM,$GO,$XS)
      $ELSEIF(DEC='B')
        IF (IDECF.EQ.0) THEN
*
*     SPARSE BUNCH-PARLETT DECOMPOSITION
*
        CALL UXVCOP($IH($N+1)-1,$H,$HS)
        CALL UXSIBF($N,MM,$KH,$JH,$HS,MMAX,$IW,MMAX,$IW1,$IW2,NAU,NUP&
,ITERM)
        IF (ITERM.LT.0) THEN
        TXFU='LACK SPC'
        GO TO $30
        ENDIF
        NDECF=NDECF+1
        IDECF=3
        ENDIF
        CALL UX$(POM1)COP($N,$GN,$GO$POM2
        CALL UXSIBB($N,$HS,MMAX,$IW,MMAX,$XS,$GO,$IW1,NAU,NUP)
      $ENDIF
    $ENDIF
    B3=UX$(POM1)DOT($N,$GN,$GO$POM2
    D1=B2
    D2=B3
    D3=UX$(POM1)DOT($N,$GO,$GO$POM2
    G1=B2
    G2=B3
    CALL UNLCS2(B1,B2,B3,D1,D2,D3,G1,G2,S1,S2,XDEL,IER)
    IF (IER.EQ.1) THEN
    CALL UXVSCL($N,S1,$GN,$SN)
    CALL UX$(POM1)DIR($N,S2,$GO,$SN,$SN$POM2
    SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
    ITERD=3
    TDXX='DOG MAX4'
    GO TO $20
    ELSE IF (IER.EQ.0) THEN
    CALL UX$(POM1)NEG($N,$GO,$SN$POM2
    SNORM=SQRT(D3)
    ITERD=1
    TDXX='DOG STEP'
    GO TO $20
    ELSE
    D3=SQRT(D3)
    ENDIF
  $ENDIF
  IF (B1.LE.ZERO.OR.B2*GNORM.GE.B1*XDEL) THEN
*
*     SCALED STEEPEST DESCENT DIRECTION IS ACCEPTED
*
  CALL UXVSCL($N,-XDEL/GNORM,$GN,$SN)
  SNORM=XDEL
  ITERD=3
  TDXX='SD  MAX '
  GO TO $20
  ENDIF
  $IF(MOS<3)
    $IF(HERF='D')
      $IF(DEC='M')
        IF (JDECF.EQ.0) THEN
        $IF(MOS2=0)
*
*     GILL-MURRAY DECOMPOSITION
*
          S1=ETA2
          CALL UXDPGF($N,$H,INF,S1,S2)
          NDECF=NDECF+1
          JDECF=1
          ENDIF
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
          CALL UXVNEG($N,$GN,$GO)
          CALL UXDPGB($N,$H,$GO,0)
        $ELSE
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
          S1=ETA2
          CALL UXD$(LET)GF($N,$H,$IH,$GO,INF,S1,S2$ART
          NDECF=NDECF+1
          JDECF=4
          ENDIF
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
          CALL UXVNEG($N,$GN,$GO)
          CALL UXD$(LET)GB($N,$H,$IH,$GO,0)
        $ENDIF
      $ELSEIF(DEC='G')
        IF (IDECF.EQ.0) THEN
*
*     GILL-MURRAY DECOMPOSITION
*
        S1=ETA2
        CALL UXDPGF($N,$H,INF,S1,S2)
        NDECF=NDECF+1
        IDECF=1
        ENDIF
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
        CALL UXVNEG($N,$GN,$GO)
        CALL UXDPGB($N,$H,$GO,0)
      $ELSEIF(DEC='S')
        IF (IDECF.EQ.0) THEN
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
          S1=ETA2
          CALL UXD$(LET)GF($N,$H,$IH,$GO,INF,S1,S2$ART
          NDECF=NDECF+1
          IDECF=4
          ENDIF
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
          CALL UXVNEG($N,$GN,$GO)
          CALL UXD$(LET)GB($N,$H,$IH,$GO,0)          
      $ELSEIF(DEC='B')
        IF (IDECF.EQ.0) THEN
*
*     BUNCH PARLETT DECOMPOSITION
*
        S1=ETA2
        CALL UXD$(LET)BF($N,$H,$IH,INF,S1$ART
        NDECF=NDECF+1
        IDECF=3
        ENDIF
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
        CALL UXVNEG($N,$GN,$GO)
        $IF(MOS2<3) 
          CALL UXDLBB($N,$H,$IH,$GO,0)
        $ELSE
          CALL UXDSBB($N,$H,$IH,$GO,0)
        $ENDIF
      $ELSEIF(DEC='R')
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
        IF (IDECA.EQ.5) THEN  
        CALL UXVCOP($N,$SN,$GO)
        S1=ETA2
        CALL UXDTGB($N,INF,$H,$GO,S1)
        ELSE
        CALL UXVCOP($N,$GN,$GO)
        CALL UXDPRB($N,$H,$GO,0)
        ENDIF
      $ELSEIF(DEC='C')
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
        IF (IDECA.EQ.6) THEN  
        CALL UXVCOP($N,$SN,$GO)
        S1=ETA2
        $IF(MOS3=2)
          CALL UXDTTB($N,INF,$H,$IH,$XO,$SO,$GO,S1)
        $ELSE
        $ENDIF  
        ELSE
        CALL UXVCOP($N,$GN,$GO)
        CALL UXDSRB($N,$H,$IH,$GO,0)
        ENDIF
      $ENDIF
    $ELSEIF(HERF='S')
      $IF(DEC='G')
        IF (IDECF.EQ.0) THEN
        CALL UXSPCT($N,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
        IF (ITERM.NE.0) THEN
        TDXX='LACK SPC'
        GO TO $30
        ENDIF
*
*     SPARSE GILL-MURRAY DECOMPOSITION
*
      S1=ETA2
      CALL UXSPCF($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$XS&
,INF,S1,S2)
        NDECF=NDECF+1
        IDECF=1
        ENDIF
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
        CALL UX$(POM1)NEG($N,$GN,$GO$POM2
        CALL UXVSFP($N,$PERM,$GO,$XS)
        CALL UXSPCB($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$GO,0)
        CALL UXVSBP($N,$PERM,$GO,$XS)
      $ELSEIF(DEC='B')
        IF (IDECF.EQ.0) THEN
*
*     SPARSE BUNCH-PARLETT DECOMPOSITION
*
        CALL UXVCOP($IH($N+1)-1,$H,$HS)
        CALL UXSIBF($N,MM,$KH,$JH,$HS,MMAX,$IW,MMAX,$IW1,$IW2,NAU,NUP&
,ITERM)
        IF (ITERM.LT.0) THEN
        TXFU='LACK SPC'
        GO TO $30
        ENDIF
        NDECF=NDECF+1
        IDECF=3
        ENDIF
        CALL UX$(POM1)NEG($N,$GN,$GO$POM2
        CALL UXSIBB($N,$HS,MMAX,$IW,MMAX,$XS,$GO,$IW1,NAU,NUP)
      $ENDIF
    $ENDIF
    D3=SQRT(UX$(POM1)DOT($N,$GO,$GO$POM2)
  $ENDIF
*
*     COMPUTATION OF THE STEEPEST DESCENT DIRECTION
*
  B2=B2/B1
  SNORM=B2*GNORM
  CALL UXVSCL($N,-B2,$GN,$SN)
$REM  CALL UX$(POM1)NEG($N,$GO,$GO$POM2
  CALL UX$(POM1)DIF($N,$GO,$SN,$XO$POM2
  B1=UX$(POM1)DOT($N,$SN,$XO$POM2
  B2=UX$(POM1)DOT($N,$XO,$XO$POM2
  IF (B2.LE.$CON0*XDEL*XDEL) THEN
*
*     NEWTON AND THE STEEPEST DESCENT DIRECTION ARE
*     APPROXIMATELY EQUAL
*
  CALL UX$(POM1)COP($N,$GO,$SN$POM2
  SNORM=D3
  ITERD=1
  TDXX='DOG STEP'
  ELSE IF (B1.LE.ZERO) THEN
*
*     BOUNDARY STEP WITH NEGATIVE INCREMENT
*
  CALL UNSTEP(XDEL,SNORM,-B1,B2,B3)
  CALL UX$(POM1)DIR($N,-B3,$XO,$SN,$SN$POM2
  SNORM=XDEL
  ITERD=3
  TDXX='DOG NEG '
  ELSE IF (D3.LE.XDEL) THEN
*
*     NEWTON DIRECTION IS ACCEPTED
*
  CALL UX$(POM1)COP($N,$GO,$SN$POM2
  SNORM=D3
  ITERD=1
  TDXX='DOG STEP'
  ELSE
  $IF(MOS=1)
*
*     SINGLE DOGLEG STRATEGY
*
    CALL UNSTEP(XDEL,SNORM,B1,B2,B3)
    CALL UX$(POM1)DIR($N,B3,$XO,$SN,$SN$POM2
    SNORM=XDEL
    ITERD=3
    TDXX='DOG MAX1'
  $ELSE
*
*     DOUBLE DOGLEG STRATEGY
*
    D3=XDEL/D3
    B3=UX$(POM1)DOT($N,$SN,$GO$POM2
    D3=MAX(D3,SNORM*SNORM/B3)
    CALL UX$(POM1)DIR($N,-D3,$GO,$SN,$XO$POM2
    B1=SNORM*SNORM-D3*B3
    B2=UX$(POM1)DOT($N,$XO,$XO$POM2
    CALL UNSTEP(XDEL,SNORM,-B1,B2,B3)
    CALL UX$(POM1)DIR($N,-B3,$XO,$SN,$SN$POM2
    SNORM=XDEL
    ITERD=3
    TDXX='DOG MAX2'
  $ENDIF
  ENDIF
$20 CONTINUE
  $IF(HERF='D')
    $IF(DEC='M')
      IF(JDECF.EQ.0) THEN
      PP=UXDSMQ($N,$H,$SN,$SN)*HALF
      ELSE
      CALL UXVCOP($N,$SN,$GO)
      $IF(MOS2=0)
        CALL UXDPGM($N,$H,$GO,1)
        PP=UXDPGQ($N,$H,$GO,$GO)*HALF
      $ELSE
        CALL UXD$(LET)GM($N,$H,$IH,$GO,1)
        PP=UXDPGQ($N,$H,$GO,$GO)*HALF
      $ENDIF
      $H=HS
      ENDIF
    $ELSEIF(DEC='G')
      IF(IDECF.EQ.0) THEN
      PP=UXDSMQ($N,$H,$SN,$SN)*HALF
      ELSE
      CALL UXVCOP($N,$SN,$GO)
      CALL UXDPGM($N,$H,$GO,1)
      PP=UXDPGQ($N,$H,$GO,$GO)*HALF
      ENDIF
    $ELSEIF(DEC='S')
      IF(IDECF.EQ.0) THEN
      PP=UXDSMQ($N,$H,$SN,$SN)*HALF
      ELSE
      CALL UXVCOP($N,$SN,$GO)
      CALL UXD$(LET)GM($N,$H,$IH,$GO,1)
      PP=UXDPGQ($N,$H,$GO,$GO)*HALF
      ENDIF
    $ELSEIF(DEC='B')
      IF(IDECF.EQ.0) THEN
      PP=UXDSMQ($N,$H,$SN,$SN)*HALF
      ELSE
      CALL UXVCOP($N,$SN,$GO)
      $IF(MOS2<3) 
        CALL UXDLBM($N,$H,$IH,$GO,1)
        PP=UXDLBQ($N,$H,$IH,$GO)*HALF
      $ELSE
        CALL UXDSBM($N,$H,$IH,$GO,1)
        PP=UXDSBQ($N,$H,$IH,$GO,$GO)*HALF
      $ENDIF
      ENDIF
  $ELSEIF(DEC='R')  
      CALL UXVCOP($N,$SN,$GO)
      CALL UXDPRM($N,$H,$GO,1)
      PP=UXVDOT($N,$GO,$GO)*HALF
    $ELSEIF(DEC='C')  
      CALL UXVCOP($N,$SN,$GO)
      CALL UXDSRM($N,$H,$IH,$GO,1)
      PP=UXVDOT($N,$GO,$GO)*HALF
    $ENDIF
  $ELSEIF(HERF='S')
    $IF(DEC='G')
      IF(IDECF.EQ.0) THEN
      IF (MOT2.EQ.0) THEN
      $IF(CHORDAL='YES')
        CALL UX$(POM1)COP($N,$SN,$GO$POM2
        CALL UXVSFP($N,$PERM,$GO,$XS)
        PP=UXSSMQ($N,MMAX,$H,$IH,$JH,$GO,$GO)*HALF
      $ELSE
        PP=UXSSMQ($N,MMAX,$H,$IH,$JH,$SN,$SN)*HALF
      $ENDIF  
      ENDIF
      ELSE
      IF (MOT2.EQ.0) THEN
      CALL UX$(POM1)COP($N,$SN,$GO$POM2
      CALL UXVSFP($N,$PERM,$GO,$XS)
      CALL UXSPCM($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$GO,$XS,1)
      PP=UXSPCQ($N,MMAX-MM,$H(MM+1),$PSL,$GO)*HALF
$REM    CALL UXVSBP($N,$PERM,$GO,$XS)
      ENDIF
      IF (ITERD.EQ.1.AND.INF.NE.0) ITERD=2
      ENDIF
    $ELSEIF(DEC='B')
      IF (MOT2.EQ.0) THEN
      PP=UXSSMQ($N,MMAX,$H,$IH,$JH,$SN,$SN)*HALF
      ENDIF
    $ENDIF
  $ENDIF
$30 CALL UOD1D2($N,$GN,$SN)
  $IF(HERF='D')
    $IF(MOS1=0)
      $GS=GSS
      $XS=XSS
    $ENDIF
  $ENDIF
  $ADD(INIT)
    NDXX='UD$(HERF)G$(DEC)1'
  $ENDADD
  $EXIT
