$INTERFACE UDGGM3                                             03/12/01
$REM LU

  $CON1='1.0$P-3'
  $CON2='1.0$P 5'
  $CON3='7.5$P 1'
  $CON4='1.0$P-6'
  $CON5='1.0$P 3'
  $CON6='5.0$P-2'
  $CON7='1.0$P 5'
  $IW='IW'
  $IF(HERF='V')
    $SNS=SN
    $GAS=GA
    $GA=G
  $ELSE
    $GSS=GS
    $XSS=XS
    $GS=XS
    $XS=XO
  $ENDIF
  $LSIZE=10
  $LTYPE=1
  $HELP
    MAXIMUM NUMBER OF CG ITERATIONS
  $CHECK(MCGR,0,INT,3,NO)
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $ADD(INTEGER,'\MMX')
  $ADD(REAL,'\$GN($NF)\$SN($NF)\$XS($NF)\$GO($NF)\$GS($NF)')
  $NOS2=0
  $IF(HERF='D')
    $ADD(REAL,'\$H($M)')
    $ADD(REAL,'\UX$(HERF)SMQ')
    $POM1='V'
    $POM2=')'
    $DEFAULT='0.4$P 0'
    $IF(MOS=1) $DEFAULT='0.1$P 0'
  $ELSEIF(HERF='V')
    $HELP
      RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
      IRES1*N+IRES2 ITERATIONS.
    $CHECK(IRES1,100,INT,4)
    $HELP
      DIRECTION AFTER RESTART:
        0 - NEWTON DIRECTION AFTER RESTART
        1 - STEEPEST DESCENT DIRECTION AFTER RESTART
    $CHECK(MOT1,0,'0\1',2)
    $HELP
      PRECONDITIONING TECHNIQUE:
        ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
        ABS(MOS2)=1 - PRECONDITIONING BY THE LM-VM VECTOR UPDATE
        ABS(MOS2)=2 - PRECONDITIONING BY THE LM-VM MATRIX UPDATE
        ABS(MOS2)=3 - DIAGONAL PRECONDITIONING
        ABS(MOS2)=4 - TRIDIAGONAL PRECONDITIONING
        ABS(MOS2)=5 - PENTADIAGONAL PRECONDITIONING
        ABS(MOS2)=6 - PRECONDITIONING BY THE LANCZOS METHOD
        MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
        MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                   BY THE PRECONDITIONED ITERATIVE PROCESS
    $CHECK(MOS2,0,'-6\-5\-4\-3\-2\-1\0\1\2\3\4\5\6',2)
    $NOS2=MOS2
    $IF(MOS2=-1) $NOS2=1
    $IF(MOS2=-2) $NOS2=2
    $IF(MOS2=-3) $NOS2=3
    $IF(MOS2=-4) $NOS2=4
    $IF(MOS2=-5) $NOS2=5
    $IF(MOS2=-6) $NOS2=6
    $IF(NOS2=1)
      $HELP
        REALIZATION OF THE L-BFGS UPDATE
          1 - BFGS UPDATE
          2 - HU STOREY UPDATE
          3 - MODIFIED BFGS UPDATE THAT USES THE PREVIOUS VECTORS
          4 - MODIFIED BFGS UPDATE THAT USES ORTHOGONAL VECTORS
      $CHECK(MOS3,1,'1\2\3\4',1)
      $IF(MOS3=2)
        $ADD(INTEGER,'\KK')
      $ENDIF
    $ELSEIF(NOS2=2)
      $HELP
        REALIZATION OF THE L-BFGS UPDATE
          1 - EXPLICITLY DERIVED MATRICES
          2 - RECURSIVE DERIVED MATRICES
      $CHECK(MOS3,1,'1\2',1)
      $MET5=1
    $ELSE
      $HELP
        PRECONDITIONING IN ILL-CONTITIONED AND INDEFINITE CASES
          0 - PRECONDITIONING IN BOTH THESE CASES IS SUPPRESSED
          1 - PRECONDITIONING IN ILL-CONDITIONED CASE IS SUPPRESSED
          2 - PRECONDITIONING IS ALWAYS USED
      $CHECK(MOS4,0,'0\1\2',1)
      $IF(NOS2=6)
        $HELP
          DIMENSION OF THE LANCZOS MATRIX
        $CHECK(MOS3,5,INT,3)
$REM        $MOS5=1
        $HELP
          TYPE OF PRECONDITIONING
            1 - PRECONDITIONING IN THE SAME ITERATION
            2 - PRECONDITIONING IN THE NEXT ITERATION
        $CHECK(MOS5,1,'\1\2',3)
        $IF(MOS5=1)
          $XM=GM
        $ENDIF
        $ADD(REAL,'\ALFO\BET\BETO\EPS')
      $ELSE
        $HELP
          TYPE OF THE BAND MATRIX DETERMINANTION
            1 - NUMERICAL DIFFERENTIATION
            2 - INNER BFGS UPDATE
            3 - OUTER BFGS UPDATE
        $CHECK(MOS3,1,'\1\2\3',3)
        $IF(MOS3=2)
          $HELP
            NUMBER OF INNER BFGS UPDATES
            IF MOS3=0 THEN THIS NUMBER IS INFINITY
          $CHECK(MOS3,0,INT,3)
          $HELP
            METHOD OF UPDATE OF HESSIAN MATRIX:
              1 - BFGS UPDATE
              2 - DFP UPDATE
              3 - HOSHINO UPDATE
              4 - RANK-ONE UPDATE
          $CHECK(MET,1,'1\2\3\4',3)
          $ADD(REAL,'\BET')
        $ENDIF
        $IF(NOS2=3)
$REM          $IF(MOS3=1)
            $HELP
              CORRECTION OF THE DIAGOMAL MATRIX
                0 - STANDARD DIAGONAL
                1 - POSITIVE DIAGONAL
                2 - POSITIVE DIAGONAL WITH SUFFICIENTLY LARGE ELEMENTS
            $CHECK(MOS5,1,'\0\1\2',3)
$REM          $ELSE
$REM            $HELP
$REM              CORRECTION OF THE DIAGOMAL MATRIX
$REM                0 - STANDARD DIAGONAL
$REM                1 - DIAGONAL WITH ADDED FIRST SUPERDIAGONAL ELEMENTS
$REM                2 - DIAGONAL WITH ADDED FIRST AND SECOND SUPERDIAGONAL
$REM                    ELEMENTS
$REM            $CHECK(MOS5,0,'\0\1\2',3)
$REM          $ENDIF
        $ELSE
          $IF(MOS3=1)
            $HELP
              CORRECTION OF THE DIAGOMAL MATRIX
                0 - STANDARD DIAGONAL
                1 - POSITIVE DIAGONAL
                2 - POSITIVE DIAGONAL WITH SUFFICIENTLY LARGE ELEMENTS
                3 - POSITIVE DIAGONAL WITH SUPERDIAGONAL CORRECTION
            $CHECK(MOS5,2,'\0\1\2\3',3)
            $IF(MOS5=2)
              $ADD(REAL,'\UXVMAX')
            $ENDIF
          $ELSE
            $HELP
              CORRECTION OF THE BAND MATRIX
                0 - NO CORRECTION
                1 - SUPERDIAGONAL DECREASING
                2 - ADAPTIVE SUPERDIAGONAL DECREASING
                3 - ADAPTIVE SUPERDIAGONAL CORRECTION
            $CHECK(MOS5,3,'\0\1\2\3',3)
          $ENDIF
        $ENDIF
      $ENDIF
      $DEFAULT='1.0$P-2'
      $IF(MOS4=0)
        $IF(MOS3=1) $DEFAULT='1.0$P-12'
      $ENDIF
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,DEFAULT,REAL,4)
      $ADD(INTEGER,'\NOS2')
    $ENDIF
    $ADD(REAL,'\$X($NF)\$G($NF)\$XO($NF)')
    $ADD(INTEGER,'\MX\I')
    $IF(CONSTR='C')
      $POM1='U'
      $POM2=',$$IX,KBF)'
      $POM3='C'
    $ELSE
      $POM1='V'
      $POM2=')'
      $POM3='S'
    $ENDIF
    $DEFAULT='0.45$P 0'
    $IF(MOS=1) $DEFAULT='0.25$P 0'
  $ELSEIF(HERF='S')
    $HELP
      PRECONDITIONING TECHNIQUE
        ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
        ABS(MOS2)=1 - INCOMPLETE GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=2 - ILUT-TYPE  GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=3 - ILUT-TYPE  GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=4 - ILUT-TYPE  GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=5 - INCOMPLETE GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=6 - SSOR PRECONDITIONING
           MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
           MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                      BY PRECONDITIONED ITERATIVE PROCESS
    $CHECK(MOS2,0,'-6\-5\-4\-3\-2\-1\0\1\2\3\4\5\6',2)
    $IF(MOS2=6) $MOS2=-6
    $NOS2=MOS2
    $IF(MOS2=-1) $NOS2=1
    $IF(MOS2=-2) $NOS2=2
    $IF(MOS2=-3) $NOS2=3
    $IF(MOS2=-4) $NOS2=4
    $IF(MOS2=-5) $NOS2=5
    $IF(MOS2=-6) $NOS2=6
    $IF(NOS2=0)
      $MOS3=0
    $ELSEIF(NOS2=6)
      $MOS3=0
    $ELSE
      $HELP
        TRUST REGION IN THE PRECONDITIONED CASE
          0 - BASIC TRUST REGION
          1 - MODIFIED TRUST REGION DEFINED BY THE PRECONDITIONER
      $CHECK(MOS3,0,'0\1',1)
    $ENDIF
    $HELP
      PRECONDITIONING IN ILL-CONTITIONED AND INDEFINITE CASES
        0 - PRECONDITIONING IN BOTH THESE CASES IS SUPPRESSED
        1 - PRECONDITIONING IN ILL-CONDITIONED CASE IS SUPPRESSED
        2 - PRECONDITIONING IS ALWAYS USED
    $CHECK(MOS4,0,'0\1\2',1)
    $IF(NOS2=1)
      $HELP
        TYPE OF THE GILL-MURRAY STRATEGY
          1 - BASIC STRATEGY
          2 - MODIFIED STRATEGY THAT USE ARTIFICIAL SOLUTION VECTOR
      $CHECK(MOS5,1,'1\2',1)
    $ENDIF
    $IF(NOS2=0)
      $ADD(REAL,'\$H($M)')
      $ADD(INTEGER,'\$IH($NF+1)\$JH($M)')
    $ELSEIF(NOS2=1)
      $ADD(REAL,'\$H($MMAX)')
      $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\IW($NF+1)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ELSEIF(NOS2=2)
      $ADD(REAL,'\$H($MMAX)\$WR01($NF)')
      $ADD(INTEGER,'\$IH(2*$NF+2)\$JH($MMAX)\IW(4*$NF+4)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ELSEIF(NOS2=3)
      $ADD(REAL,'\$H($MMAX)\$WR01($NF)')
      $ADD(INTEGER,'\$IH(2*$NF+2)\$JH($MMAX)\IW(4*$NF+4)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ELSEIF(NOS2=4)
      $ADD(REAL,'\$H($MMAX)\$WR01($NF)')
      $ADD(INTEGER,'\$IH(2*$NF+2)\$JH($MMAX)\IW(4*$NF+4)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ELSEIF(NOS2=5)
      $ADD(REAL,'\$H($MMAX)')
      $ADD(INTEGER,'\$IH($NF+1)\$JH($M)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ENDIF
    $IF(MOS3=1)
      $ADD(REAL,'\$XP($NF)\$GP($NF)')
    $ENDIF
    $ADD(INTEGER,'\$IX($NX)\NOS2')
    $ADD(REAL,'\UX$(HERF)SMQ')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $DEFAULT='0.9$P 0'
    $IF(MOS=1) $DEFAULT='0.1$P 0'
  $ELSEIF(HERF='B')
    $ADD(REAL,'\$AH($MAH)')
    $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$IX($NX)')
    $ADD(REAL,'\UX$(HERF)SMQ')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $DEFAULT='0.4$P 0'
    $IF(MOS=1) $DEFAULT='0.2$P 0'
  $ELSEIF(HERF='L')
    $ADD(REAL,'\$XM($NF*$MF)\$GM($NF*$MF)\$XR($MF*($MF+1)/2)&
    \$GR($MF*($MF+1)/2)\$HR($MF*($MF+1)/2)\$DR($MF)')
    $ADD(INTEGER,'\$IX($NX)\MX')
    $ADD(REAL,'\UX$(HERF)SMQ')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $DEFAULT='0.4$P 0'
    $IF(MOS=1) $DEFAULT='0.2$P 0'
  $ENDIF
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $ADD(REAL,'\UX$(POM1)DOT\UX$(POM1)DEL')
  $ADD(REAL,'\RHO\RHO1\RHO2\SIG\ALF\EPS\GNORMO')
  $ADD(INTEGER,'\MMX')
  CALL UOD1D1
  IF (NIT.LE.LIT+1) THEN
  GNORMO=$ETA9
  EPS=$EPS6
  ENDIF
  $IF(HERF='D')
    $N='N'
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0) THEN
  $ELSEIF(HERF='V')
    $N='NF'
    IF (IREST.NE.0) THEN
    CALL UYSET3
    IF (MOT1.GT.0) THEN
    CALL UXVNEG($N,$GN,$SN)
    GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
    SNORM=GNORM
    PP=HALF*GNORM
    TUXX='INITIAL '
    TDXX='ST DESC '
    GO TO $90
    ENDIF
    ENDIF
    IF (IDECF.LT.0) IDECF=0
    $IF(MOS1=0)
      IF (IDECF.NE.0.AND.IDECF.NE.1) THEN
    $ELSE
      IF (IPREC.EQ.0) THEN
      NOS2=0
      ELSE IF (IDECF.NE.0.AND.IDECF.NE.1) THEN
    $ENDIF
  $ELSEIF(HERF='S')
    $N='NF'
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0.AND.IDECF.NE.1) THEN
  $ELSEIF(HERF='B')
    $N='NF'
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0) THEN
  $ELSEIF(HERF='L')
    $N='NF'
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0) THEN
  $ENDIF
  ITERD=-1
  CALL UOERR1('UD$(HERF)GM3',1)
  TDXX='BAD DEC1'
  GO TO $80
  $IF(HERF='V')
    $IF(NOS2<3)
    $ELSEIF(NOS2<6)
      ELSE IF (IDECF.EQ.0) THEN
      INF=0
      ALF=ETA2
      NOS2=$NOS2
      $IF(NOS2=3)
$REM        $IF(MOS3=1)
          $IF(MOS5>0)
            CALL UXVABS($N,$D,$D)
          $ENDIF
          $IF(MOS5=2)
            SIG=UXVMAX($N,$D)
            DO $10 I=1,$N
            IF ($D(I).LE.TWO*ALF*SIG) $D(I)=ONE
$10         CONTINUE
          $ENDIF
$REM        $ENDIF
        CALL UXVPGF($N,$D,INF,ALF,SIG)
      $ELSEIF(NOS2=4)
        $IF(MOS3=1)
          $IF(MOS5>0)
            CALL UXVABS($N,$D,$D)
          $ENDIF
          $IF(MOS5=2)
            SIG=UXVMAX($N,$D)
            DO $10 I=1,$N
            IF ($D(I).LE.TWO*ALF*SIG) $D(I)=ONE
$10         CONTINUE
          $ELSEIF(MOS5=3)
            CALL UXTSMC($N,$D,$DU,MOS5)
          $ENDIF
        $ELSE
          $IF(MOS5>0)
            CALL UXTSMC($N,$D,$DU,MOS5)
          $ENDIF
        $ENDIF
        CALL UXTPGF($N,$D,$DU,INF,ALF,SIG)
      $ELSEIF(NOS2=5)
        $IF(MOS3=1)
          $IF(MOS5>0)
            CALL UXVABS($N,$D,$D)
          $ENDIF
          $IF(MOS5=2)
            SIG=UXVMAX($N,$D)
            DO $10 I=1,$N
            IF ($D(I).LE.TWO*ALF*SIG) $D(I)=ONE
$10         CONTINUE
          $ELSEIF(MOS5=3)
            CALL UXPSMC($N,$D,$DU,$DV,MOS5)
          $ENDIF
        $ELSE
          $IF(MOS5>0)
            CALL UXPSMC($N,$D,$DU,$DV,MOS5)
          $ENDIF
        $ENDIF
        CALL UXPPGF($N,$D,$DU,$DV,INF,ALF,SIG)
      $ENDIF
      $IF(MOS4=0)
        IF (INF.NE.0) NOS2=0
      $ELSEIF(MOS4=1)
        IF (INF.LT.0) NOS2=0
      $ENDIF
      NDECF=NDECF+1
      IDECF=1
      ELSE IF (IREST.NE.0) THEN
      NOS2=0
      $IF(MOS3=1)
        ENDIF
        IF (NOS2.NE.0) THEN
        NUPD=NUPD+1
        $IF(MOS1>0)
          ELSE
          IPREC=0
        $ENDIF
      $ELSEIF(MOS3=2)
        ENDIF
        IF (NOS2.EQ.0) THEN
        $IF(NOS2>4)
          CALL UXVSET($N,ZERO,$DDV)
        $ENDIF
        $IF(NOS2>3)
          CALL UXVSET($N,ZERO,$DDU)
        $ENDIF
        $IF(NOS2>2)
          CALL UXVSET($N,ONE,$DD)
        $ENDIF
        $IF(MOS1>0)
          IPREC=0
        $ENDIF
        ELSE
        NUPD=NUPD+1
      $ENDIF
    $ELSEIF(MOS5>1)
      ELSE IF (IDECF.EQ.0) THEN
      IF (NOS2.EQ.6) THEN
      IF (MX.GT.0) THEN
      INF=0
      ALF=ETA2
      CALL UXTPGF(MX,$D,$DU,INF,ALF,SIG)
      $IF(MOS4=0)
        IF (INF.NE.0) NOS2=0
      $ELSEIF(MOS4=1)
        IF (INF.LT.0) NOS2=0
      $ENDIF
      NDECF=NDECF+1
      IDECF=1
      ELSE
      NOS2=0
      ENDIF
      ENDIF
      ELSE IF (IREST.NE.0) THEN
      NOS2=0
    $ENDIF
  $ELSEIF(NOS2=0)
  $ELSEIF(NOS2=6)
  $ELSE
    ELSE IF (IDECF.EQ.0) THEN
*
*     INCOMPLETE GILL-MURRAY DECOMPOSITION
*
    INF=0
    ALF=ETA2
    NOS2=$NOS2
    IF (2*M.GE.$MMAX) THEN
    CALL UOERR2('UD$(HERF)GM3',48,2*M,$MMAX)
    ITERM=-48
    TDXX='LACK SPC'
    GO TO $80
    ENDIF
    $IF(NOS2=1)
      CALL UXVCOP(M,$H,$H(M+1))
      $IF(MOS5=1)
        CALL UXSPTF($N,M,$H(M+1),$IH,$JH,$IW,INF,ALF,SIG)
      $ELSE
        CALL UXSPLF($N,M,$H(M+1),$IH,$JH,$IW,$GO,INF,ALF,SIG)
      $ENDIF
    $ELSEIF(NOS2=2)
      CALL UXSPT2($N,M,$MMAX-M,$H,$IH,$JH,$H(M+1),$IH($N+2),$JH(M+1)&
,$IW,$IW($N+2),$IW(2*$N+3),$IW(3*$N+4),$WR01,$CON6,$LTYPE,$LSIZE,INF&
,ALF,SIG)
    $ELSEIF(NOS2=3)
      CALL UXSPT3($N,M,$MMAX-M,$H,$IH,$JH,$H(M+1),$IH($N+2),$JH(M+1)&
,$IW,$IW($N+2),$IW(2*$N+3),$IW(3*$N+4),$WR01,$CON6,$LTYPE,INF,ALF,SIG)
    $ELSEIF(NOS2=4)
      CALL UXSPT4($N,M,$MMAX-M,$H,$IH,$JH,$H(M+1),$IH($N+2),$JH(M+1)&
,$IW,$IW($N+2),$IW(2*$N+3),$IW(3*$N+4),$WR01,$GO,$CON6,INF,ALF,SIG)
    $ELSEIF(NOS2=5)
      CALL UXVCOP(M,$H,$H(M+1))
      CALL UXSPIF($N,M,$H(M+1),$IH,$JH,INF,ALF,SIG,GO)
    $ENDIF
    IF (INF+10.LT.0) THEN
    CALL UOERR1('UD$(HERF)GM3',48)
    ITERM=-48
    TDXX='LACK SPC'
    GO TO $80
    ENDIF
    $IF(MOS4=0)
      IF (INF.NE.0) NOS2=0
    $ELSEIF(MOS4=1)
      IF (INF.LT.0) NOS2=0
    $ENDIF
    NDECF=NDECF+1
    IDECF=1
  $ENDIF
  ENDIF
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
  IF (GNORM.GE.$CON5*GNORMO) EPS=$CON4
  GNORMO=GNORM
  INITD=MAX(ABS(INITD),1)
$REM  RHO1=GNORM*GNORM
  RHO1=UX$(POM1)DOT($N,$GN,$GN$POM2
  IF(XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  $IF(HERF='V')
    XDEL=GNORM
  $ELSE
    $IF(HERF='D')
      RHO2=UXDSMQ($N,$H,$GN,$GN)
    $ELSEIF(HERF='S')
      RHO2=UXSSMQ($N,M,$H,$IH,$JH,$GN,$GN)
    $ELSEIF(HERF='B')
      RHO2=UXBSMQ($N,MAH,NA,MA,$AH,$IAG,$JAG,$GN,$GN)
    $ELSEIF(HERF='L')
      $IF(CONSTR='C')
        CALL UX$(POM1)COP($N,$GN,$SN$POM2
        CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$SN,$GO,PAR3&
,$MET)
        RHO2=UXVDOT($N,$SN,$GO)
      $ELSE
        CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$GN,$GO,PAR3&
,$MET)
        RHO2=UXVDOT($N,$GN,$GO)
      $ENDIF
    $ENDIF
    IF(RHO2.LE.ZERO) THEN
    XDEL=GNORM
    ELSE
    XDEL=(GNORM*GNORM/RHO2)*GNORM
    ENDIF
  $ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  PAR=MIN(EPS,SQRT(GNORM))
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
    IF (NIT-LIT.GE.$N) PAR=MIN(PAR,$CON4)
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
  $IF(HERF='V')
    $IF(MOS3=1)
      $PREL=0
      $IF(MOS2=4)
        $PREL=1
        IF (NOS2.EQ.0) GO TO $16
        CALL UXVNEG($N,$GN,$XS)
        CALL UXTPGB($N,$D,$DU,$XS,0)
      $ELSEIF(MOS2=5)
        $PREL=1
        IF (NOS2.EQ.0) GO TO $16
        CALL UXVNEG($N,$GN,$XS)
        CALL UXPPGB($N,$D,$DU,$DV,$XS,0)
      $ENDIF
      $IF(PREL=1)
*
*     PRELIMINARY INEXACT SOLUTION
*
        CALL UXVCOP($N,$XS,$SN)
        SNORM=SQRT(UX$(POM1)DOT($N,$XS,$XS$POM2)
        IF (SNORM.GT.XDEL*$CON2) GO TO $16
        IF (SNORM.LE.XDEL) THEN
        ITERD=2
        TDXX='G-M REG '
        ELSE
        CALL UXVSCL($N,XDEL/SNORM,$SN,$SN)
        SNORM=XDEL
        ITERD=3
        TDXX='G-M MAX '
        ENDIF
        FO=F
        PP=SQRT(ETA0/UX$(POM1)DOT($N,$SN,$SN$POM2)
        LD=MIN(MAX(KDF,KDA)-1,0)
        $IF(MODEL='AF')
          LDA=LD
        $ELSE
          LDA=-1
        $ENDIF
        I=ISNA
        ISNA=0
        $SN=XS
        $SUBST('UYTR$(CONSTR)X')
        ASSIGN $15 TO IMD
        GO TO $LMD
$15     CONTINUE
        ISNA=I
        $SN=SNS
        $SUBST('UYTR$(CONSTR)A')
        CALL UXVDIF($N,$G,$GN,$GO)
        F=FO
        CALL UXVSCL($N,ONE/PP,$GO,$GO)
        CALL UXVDIR($N,ONE,$GN,$GO,$GO)
        IF (UX$(POM1)DOT($N,$GO,$GO$POM2.LE.1.0$P-2*PAR*RHO1) GO TO $80
$16     CONTINUE
      $ENDIF
    $ENDIF
  $ELSEIF(HERF='S')
    $IF(MOS2>0)
*
*     PRELIMINARY INEXACT SOLUTION
*
      CALL UXVNEG($N,$GN,$XS)
      IF (NOS2.NE.0) THEN
      $IF(NOS2=5)
        CALL UXSPIB($N,M,$H(M+1),$IH,$JH,$XS,0)
      $ELSEIF(NOS2=1)
        CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH,$JH,$XS,0)
      $ELSE
        CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH($N+2),$JH(M+1),$XS,0)
      $ENDIF
      SNORM=SQRT(UX$(POM1)DOT($N,$XS,$XS$POM2)
      IF (SNORM.LE.XDEL*$CON2) THEN
      CALL UXVCOP($N,$XS,$SN)
      IF (SNORM.LE.XDEL) THEN
      ITERD=2
      TDXX='G-M REG '
      ELSE
      CALL UXVSCL($N,XDEL/SNORM,$SN,$SN)
      SNORM=XDEL
      ITERD=3
      TDXX='G-M MAX '
      ENDIF
      CALL UXSSMD($N,M,$H,$IH,$JH,$SN,ONE,$GN,$GO)
      IF (UX$(POM1)DOT($N,$GO,$GO$POM2.LE.1.0$P-2*PAR*RHO1) GO TO $80
      ENDIF
      ENDIF
    $ENDIF
  $ENDIF
*
*     CG INITIATION
*
  RHO=RHO1
  SNORM=ZERO
  CALL UXVSET($N,ZERO,$SN)
  CALL UXVNEG($N,$GN,$GS)
  $IF(HERF='V')
    $IF(NOS2=1)
      $IF(MOS3=1)
        CALL UXVCOP($N,$GS,$XS)
        IF (MX.GT.0) THEN
        B=UX$(POM1)DOT($N,$XM,$GM$POM2
        IF (B.GT.ZERO) THEN
        $U1(1)=ONE/B
        CALL UXDR$(POM3)B($N,MX,$XM,$GM,$U1,$U2,$XS$POM2
        A=UX$(POM1)DOT($N,$GM,$GM$POM2
        IF (A.GT.ZERO) CALL UXVSCL($N,B/A,$XS,$XS)
        CALL UXDR$(POM3)F($N,MX,$XM,$GM,$U1,$U2,$XS$POM2
        ENDIF
        ENDIF
      $ELSEIF(MOS3=2)
        CALL UXDRSC($N,MX,$XM,$GM,$XP,$GP,$U1,KK)
        IF (KK.LE.0) THEN
          B=ZERO
        ELSE
          B=ONE/$U1(1)
        ENDIF
        IF (B.GT.ZERO) THEN
        CALL UXDRMM($N,KK,$XP,$GS,$U2)
        CALL UXVMUL(KK,$U1,$U2,$U2,1)
        CALL UXDCMM($N,KK,$XP,$U2,$XS)
        CALL UXDCMM($N,KK,$GP,$U2,$D)
        CALL UXVDIF($N,$GS,$D,$D)
        A=UXVDOT($N,$GM,$GM)
        IF (A.GT.ZERO) CALL UXVSCL($N,B/A,$D,$D)
        CALL UXDRMM($N,KK,$GP,$D,$U2)
        CALL UXVMUL(KK,$U1,$U2,$U2,1)
        CALL UXVSUM($N,$D,$XS,$XS)
        CALL UXDCMM($N,KK,$XP,$U2,$D)
        CALL UXVDIF($N,$XS,$D,$XS)
        ELSE
        CALL UXVCOP($N,$GS,$XS)
        ENDIF
      $ELSE
        IF (B.GT.ZERO) THEN
        BP=B/UXVDOT($N,$GO,$GO)
        CALL UXDRSV($N,MX,$XM,$GM,$GS,$XS,$GR,$XR,BP)
        ELSE
        CALL UXVCOP($N,$GS,$XS)
        ENDIF
      $ENDIF
    $ELSEIF(NOS2=2)
      $IF(MOS3=1)
        CALL UXLSIS($N,MX,$XM,$GM,$XR,$HR,$IHR,$U1,$U2,$GS,$XS,PAR3&
,MET,MET5)
      $ELSEIF(MOS3=2)
        CALL UXLSIG($N,MX,$XM,$HR,$U1,$U3,$GS,$XS,PAR3,MET1,MET5)
      $ENDIF
    $ELSEIF(NOS2=3)
      IF (NOS2.EQ.3) THEN
      CALL UXVMUL($N,$D,$GS,$XS,-1)
      ELSE
      CALL UXVCOP($N,$GS,$XS)
      ENDIF
    $ELSEIF(NOS2=4)
      CALL UXVCOP($N,$GS,$XS)
      IF (NOS2.EQ.4) CALL UXTPGB($N,$D,$DU,$XS,0)
    $ELSEIF(NOS2=5)
      CALL UXVCOP($N,$GS,$XS)
      IF (NOS2.EQ.5) CALL UXPPGB($N,$D,$DU,$DV,$XS,0)
    $ELSEIF(NOS2=6)
      CALL UXVCOP($N,$GS,$XS)
      $IF(MOS5>1)
        IF (NOS2.EQ.6) THEN
        CALL UXDRMM($N,MX,$GM,$GS,$G)
        CALL UXVCOP(MX,$G,$XS)
        CALL UXTPGB(MX,$D,$DU,$XS,0)
        CALL UXVDIF(MX,$XS,$G,$G)
        CALL UXDCMD($N,MX,$GM,$G,ONE,$GS,$GO)
        NUPD=NUPD+1
$REM        ELSE
$REM        MX=0
        ENDIF
      $ELSE
        MX=0
      $ENDIF
    $ELSE
      CALL UXVCOP($N,$GS,$XS)
    $ENDIF
    RHO=UX$(POM1)DOT($N,$GS,$XS$POM2
    $IF(NOS2=6)
      IF (NOS2.EQ.0) THEN
      CALL UXVSCL($N,ONE/SQRT(RHO),$GS,$GM)
      MX=0
      EPS=ONE
      ALFO=ONE
      BETO=ZERO
      ENDIF
    $ENDIF
  $ELSEIF(HERF='S')
    $IF(NOS2=0)
      CALL UXVNEG($N,$GN,$XS)
    $ELSEIF(NOS2=6)
      CALL UXVNEG($N,$GN,$XS)
      CALL UXSPPB($N,M,$H,$IH,$JH,$XS)
      RHO=UX$(POM1)DOT($N,$GS,$XS$POM2
    $ELSEIF(MOS2>0)
      IF (NOS2.NE.0) THEN
      RHO=UX$(POM1)DOT($N,$GS,$XS$POM2
      ENDIF
    $ELSE
      CALL UXVNEG($N,$GN,$XS)
      IF (NOS2.NE.0) THEN
      $IF(NOS2=5)
        CALL UXSPIB($N,M,$H(M+1),$IH,$JH,$XS,0)
      $ELSEIF(NOS2=1)
        CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH,$JH,$XS,0)
      $ELSE
        CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH($N+2),$JH(M+1),$XS,0)
      $ENDIF
      RHO=UX$(POM1)DOT($N,$GS,$XS$POM2
      ENDIF
    $ENDIF
  $ELSE
    CALL UXVNEG($N,$GN,$XS)
  $ENDIF
  MMX=$N+3
  $IF(MCGR>0)
    MMX=MIN(MMX,$MCGR)
  $ENDIF
  NRED=0
$20 CONTINUE
  NRED=NRED+1
  IF(NRED.GT.MMX) GO TO $40
  $IF(HERF='D')
    CALL UXDSMM($N,$H,$XS,$GO)
  $ELSEIF(HERF='V')
    FO=F
    PP=SQRT(ETA0/UX$(POM1)DOT($N,$XS,$XS$POM2)
    LD=MIN(MAX(KDF,KDA)-1,0)
    $IF(MODEL='AF')
      LDA=LD
    $ELSE
      LDA=-1
    $ENDIF
    I=ISNA
    ISNA=0
    $SN=XS
    $SUBST('UYTR$(CONSTR)X')
    ASSIGN $30 TO IMD
    GO TO $LMD
$30 CONTINUE
    ISNA=I
    $SN=SNS
    $SUBST('UYTR$(CONSTR)A')
    CALL UXVDIF($N,$G,$GN,$GO)
    F=FO
    CALL UXVSCL($N,ONE/PP,$GO,$GO)
  $ELSEIF(HERF='S')
    CALL UXSSMM($N,M,$H,$IH,$JH,$XS,$GO)
  $ELSEIF(HERF='B')
    CALL UXBSMM($N,MAH,NA,MA,$AH,$IAG,$JAG,$XS,$GO)
  $ELSEIF(HERF='L')
    $IF(CONSTR='C') CALL UX$(POM1)COP($N,$XS,$XS$POM2
    CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$XS,$GO,PAR3&
,$MET)
  $ENDIF
  ALF=UX$(POM1)DOT($N,$XS,$GO$POM2
  TDXX='CG  MAX1'
  IF (ALF.LE.ZERO) GO TO $60
$REM  ALF=RHO/ALF
  $IF(HERF='S')
    $IF(MOS3=0)
      RHO2=SQRT(UX$(POM1)DEL($N,RHO/ALF,$XS,$SN$POM2)
    $ELSE
      CALL UX$(POM1)DIR($N,RHO/ALF,$XS,$SN,$XP$POM2
      $IF(NOS2=5)
        CALL UXSPIM($N,M,$H(M+1),$IH,$JH,$XP,1)
        RHO2=SQRT(UXSPIQ($N,$MMAX-M,$H(M+1),$IH,$XP,$XP))
      $ELSEIF(NOS2=1)
        CALL UXSPTM($N,$MMAX-M,$H(M+1),$IH,$JH,$XP,$GP,1)
        RHO2=SQRT(UXSPIP($N,$MMAX-M,$H(M+1),$IH,$XP,$XP))
      $ELSE
        CALL UXSPTM($N,$MMAX-M,$H(M+1),$IH($N+2),$JH(M+1),$XP,$GP,1)
        RHO2=SQRT(UXSPIP($N,$MMAX-M,$H(M+1),$IH,$XP,$XP))
      $ENDIF
    $ENDIF
  $ELSE
    RHO2=SQRT(UX$(POM1)DEL($N,RHO/ALF,$XS,$SN$POM2)
  $ENDIF
  TDXX='CG  MAX2'
  IF (RHO2.GE.XDEL) GO TO $60
  TDXX='CG  STEP'
*
*     CG STEP
*
  $IF(HERF='V')
    $IF(NOS2<3)
      ALF=RHO/ALF
    $ELSEIF(NOS2<6)
      $IF(MOS3=2)
        $IF(MET3>0)
          IF (NRED.LE.MOS3) THEN
        $ENDIF
        BET=UXVDOT($N,$XS,$GS)
        $IF(MET=1)
          $IF(NOS2=3)
            CALL UXVSMU($N,$DD,-ONE/BET,$GS)
            CALL UXVSMU($N,$DD, ONE/ALF,$GO)
          $ELSEIF(NOS2=4)
            CALL UXTSMU($N,$DD,$DDU,-ONE/BET,$GS)
            CALL UXTSMU($N,$DD,$DDU, ONE/ALF,$GO)
          $ELSEIF(NOS2=5)
            CALL UXPSMU($N,$DD,$DDU,$DDV,-ONE/BET,$GS)
            CALL UXPSMU($N,$DD,$DDU,$DDV, ONE/ALF,$GO)
          $ENDIF
        $ELSEIF(MET=2)
          $IF(NOS2=3)
            CALL UXVSMU($N,$DD,(ONE+BET/ALF)/ALF,$GO)
            CALL UXVSMZ($N,$DD,-ONE/ALF,$GS,$GO)
          $ELSEIF(NOS2=4)
            CALL UXTSMU($N,$DD,$DDU,(ONE+BET/ALF)/ALF,$GO)
            CALL UXTSMZ($N,$DD,$DDU,-ONE/ALF,$GS,$GO)
          $ELSEIF(NOS2=5)
            CALL UXPSMU($N,$DD,$DDU,$DDV,(ONE+BET/ALF)/ALF,$GO)
            CALL UXPSMZ($N,$DD,$DDU,$DDV,-ONE/ALF,$GS,$GO)
          $ENDIF
        $ELSEIF(MET=3)
          $IF(NOS2=3)
            CALL UXVSUM($N,$GO,$GS,$G)
            CALL UXVSMU($N,$DD,-ONE/(ALF+BET),$G)
            CALL UXVSMU($N,$DD, TWO/ALF,$GO)
          $ELSEIF(NOS2=4)
            CALL UXVSUM($N,$GO,$GS,$G)
            CALL UXTSMU($N,$DD,$DDU,-ONE/(ALF+BET),$G)
            CALL UXTSMU($N,$DD,$DDU, TWO/ALF,$GO)
          $ELSEIF(NOS2=5)
            CALL UXVSUM($N,$GO,$GS,$G)
            CALL UXPSMU($N,$DD,$DDU,$DDV,-ONE/(ALF+BET),$G)
            CALL UXPSMU($N,$DD,$DDU,$DDV, TWO/ALF,$GO)
          $ENDIF
        $ELSEIF(MET=4)
          $IF(NOS2=3)
            IF (ALF.GT.BET) THEN
            CALL UXVDIF($N,$GO,$GS,$G)
            CALL UXVSMU($N,$DD,ONE/(ALF-BET),$G)
            ELSE
            CALL UXVSMU($N,$DD,-ONE/BET,$GS)
            CALL UXVSMU($N,$DD, ONE/ALF,$GO)
            ENDIF
          $ELSEIF(NOS2=4)
            IF (ALF.GT.BET) THEN
            CALL UXVDIF($N,$GO,$GS,$G)
            CALL UXTSMU($N,$DD,$DDU,ONE/(ALF-BET),$G)
            ELSE
            CALL UXTSMU($N,$DD,$DDU,-ONE/BET,$GS)
            CALL UXTSMU($N,$DD,$DDU, ONE/ALF,$GO)
            ENDIF
          $ELSEIF(NOS2=5)
            IF (ALF.GT.BET) THEN
            CALL UXVDIF($N,$GO,$GS,$G)
            CALL UXPSMU($N,$DD,$DDU,$DDV,ONE/(ALF-BET),$G)
            ELSE
            CALL UXPSMU($N,$DD,$DDU,$DDV,-ONE/BET,$GS)
            CALL UXPSMU($N,$DD,$DDU,$DDV, ONE/ALF,$GO)
            ENDIF
          $ENDIF
        $ENDIF
        $IF(MET3>0)
          ENDIF
        $ENDIF
      $ENDIF
      ALF=RHO/ALF
    $ELSE
      ALF=RHO/ALF
      IF (NOS2.EQ.0) THEN
      IF (NRED.LE.MOS3) THEN
      MX=MX+1
      $D(MX)=ONE/ALF+BETO/ALFO
      $DU(MX)=ZERO
      ENDIF
      ENDIF
    $ENDIF
  $ELSE
    ALF=RHO/ALF
  $ENDIF
  CALL UX$(POM1)DIR($N, ALF,$XS,$SN,$SN$POM2
  CALL UX$(POM1)DIR($N,-ALF,$GO,$GS,$GS$POM2
  SNORM=RHO2
  RHO2=UX$(POM1)DOT($N,$GS,$GS$POM2
  CALL UOD1D4(RHO1,RHO2,PAR,SNORM,XDEL)
  IF (RHO2.LE.PAR*RHO1) GO TO $50
  IF (NRED.GE.MMX) GO TO $40
  $IF(HERF='V')
    $IF(NOS2=1)
      $IF(MOS3=1)
        IF (B.GT.ZERO) THEN
        CALL UXVCOP($N,$GS,$GO)
        CALL UXDR$(POM3)B($N,MX,$XM,$GM,$U1,$U2,$GO$POM2
        IF (A.GT.ZERO) CALL UXVSCL($N,B/A,$GO,$GO)
        CALL UXDR$(POM3)F($N,MX,$XM,$GM,$U1,$U2,$GO$POM2
        RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
        ALF=RHO2/RHO
        CALL UX$(POM1)DIR($N,ALF,$XS,$GO,$XS$POM2
        ELSE
        ALF=RHO2/RHO
        CALL UX$(POM1)DIR($N,ALF,$XS,$GS,$XS$POM2
        ENDIF
      $ELSEIF(MOS3=2)
        IF (B.GT.ZERO) THEN
        CALL UXDRMM($N,KK,$XP,$GS,$U2)
        CALL UXVMUL(KK,$U1,$U2,$U2,1)
        CALL UXDCMM($N,KK,$XP,$U2,$GO)
        CALL UXDCMM($N,KK,$GP,$U2,$D)
        CALL UXVDIF($N,$GS,$D,$D)
        IF (A.GT.ZERO) CALL UXVSCL($N,B/A,$D,$D)
        CALL UXDRMM($N,KK,$GP,$D,$U2)
        CALL UXVMUL(KK,$U1,$U2,$U2,1)
        CALL UXVSUM($N,$D,$GO,$GO)
        CALL UXDCMM($N,KK,$XP,$U2,$D)
        CALL UXVDIF($N,$GO,$D,$GO)
        RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
        ALF=RHO2/RHO
        CALL UX$(POM1)DIR($N,ALF,$XS,$GO,$XS$POM2
        ELSE
        ALF=RHO2/RHO
        CALL UX$(POM1)DIR($N,ALF,$XS,$GS,$XS$POM2
        ENDIF
      $ELSE
        IF (MX.EQ.0) B=ZERO
        IF (B.GT.ZERO) THEN
        CALL UXDRSV($N,MX,$XM,$GM,$GS,$GO,$GR,$XR,BP)
        RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
        ALF=RHO2/RHO
        CALL UX$(POM1)DIR($N,ALF,$XS,$GO,$XS$POM2
        ELSE
        ALF=RHO2/RHO
        CALL UX$(POM1)DIR($N,ALF,$XS,$GS,$XS$POM2
        ENDIF
      $ENDIF
    $ELSEIF(NOS2=2)
      $IF(MOS3=1)
        CALL UXLSIS($N,MX,$XM,$GM,$XR,$HR,$IHR,$U1,$U2,$GS,$GO,PAR3&
,MET,MET5)
      $ELSEIF(MOS3=2)
        CALL UXLSIG($N,MX,$XM,$HR,$U1,$U3,$GS,$GO,PAR3,MET1,MET5)
      $ENDIF
      RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GO,$XS$POM2
    $ELSEIF(NOS2=3)
      IF (NOS2.EQ.3) THEN
      CALL UXVMUL($N,$D,$GS,$GO,-1)
      ELSE
      CALL UXVCOP($N,$GS,$GO)
      ENDIF
      RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GO,$XS$POM2
    $ELSEIF(NOS2=4)
      CALL UXVCOP($N,$GS,$GO)
      IF (NOS2.EQ.4) CALL UXTPGB($N,$D,$DU,$GO,0)
      RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GO,$XS$POM2
    $ELSEIF(NOS2=5)
      CALL UXVCOP($N,$GS,$GO)
      IF (NOS2.EQ.5) CALL UXPPGB($N,$D,$DU,$DV,$GO,0)
      RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GO,$XS$POM2
    $ELSEIF(NOS2=6)
      IF (NOS2.EQ.0) THEN
      IF (NRED.LT.MOS3) THEN
      BET=RHO2/RHO
      EPS=-EPS*SIGN(ONE,ALF)
      $DU(MX)=SQRT(BET)/ABS(ALF)
      CALL UXVSCL($N,EPS/SQRT(RHO2),$GS,$GM($N*MX+1))
      ALFO=ALF
      BETO=BET
      $IF(MOS5=1)
        NOS2=0
        ELSE IF (NRED.EQ.MOS3) THEN
        INF=0
        ALF=ETA2
        NOS2=$NOS2
        CALL UXTPGF(MX,$D,$DU,INF,ALF,SIG)
        $IF(MOS4=0)
          IF (INF.NE.0) NOS2=0
        $ELSEIF(MOS4=1)
          IF (INF.LT.0) NOS2=0
        $ENDIF
        IF (NOS2.EQ.6) NUPD=NUPD+1
      $ENDIF
      ENDIF
      ENDIF
      IF (NOS2.EQ.6) THEN
      CALL UXDRMM($N,MX,$GM,$GS,$G)
      CALL UXVCOP(MX,$G,$GO)
      CALL UXTPGB(MX,$D,$DU,$GO,0)
      CALL UXVDIF(MX,$GO,$G,$G)
      CALL UXDCMD($N,MX,$GM,$G,ONE,$GS,$GO)
      RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GO,$XS$POM2
      ELSE
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GS,$XS$POM2
      ENDIF
    $ELSE
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GS,$XS$POM2
    $ENDIF
  $ELSEIF(HERF='S')
    $IF(NOS2=0)
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GS,$XS$POM2
    $ELSEIF(NOS2=6)
      CALL UXVCOP($N,$GS,$GO)
      CALL UXSPPB($N,M,$H,$IH,$JH,$GO)
      RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GO,$XS$POM2
    $ELSE
      IF (NOS2.NE.0) THEN
      CALL UXVCOP($N,$GS,$GO)
      $IF(NOS2=5)
        CALL UXSPIB($N,M,$H(M+1),$IH,$JH,$GO,0)
      $ELSEIF(NOS2=1)
        CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH,$JH,$GO,0)
      $ELSE
        CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH($N+2),$JH(M+1),$GO,0)
      $ENDIF
      RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GO,$XS$POM2
      ELSE
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GS,$XS$POM2
      ENDIF
    $ENDIF
  $ELSE
    ALF=RHO2/RHO
    CALL UX$(POM1)DIR($N,ALF,$XS,$GS,$XS$POM2
  $ENDIF
  RHO=RHO2
  GO TO $20
$40 CONTINUE
  TDXX='MAX ITER'
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$50 CONTINUE
  $IF(HERF='S')
    $IF(MOS3=0)
      SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
    $ENDIF
  $ELSE
    SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  $ENDIF
  ITERD=2
  TDXX='CG  STEP'
  GO TO $80
*
*     BOUNDARY STEP IS COMPUTED
*
$60 CONTINUE
  $IF(HERF='S')
    $IF(MOS3=0)
      RHO1=UX$(POM1)DOT($N,$XS,$SN$POM2
      RHO2=UX$(POM1)DOT($N,$XS,$XS$POM2
    $ELSE
      CALL UXVCOP($N,$XS,$XP)
      $IF(NOS2=5)
        CALL UXSPIM($N,M,$H(M+1),$IH,$JH,$XP,0)
      $ELSEIF(NOS2=1)
        CALL UXSPTM($N,$MMAX-M,$H(M+1),$IH,$JH,$XP,$GP,0)
      $ELSE
        CALL UXSPTM($N,$MMAX-M,$H(M+1),$IH($N+2),$JH(M+1),$XP,$GP,0)
      $ENDIF
      RHO1=UX$(POM1)DOT($N,$XP,$SN$POM2
      RHO2=UX$(POM1)DOT($N,$XP,$XS$POM2
    $ENDIF
  $ELSE
    RHO1=UX$(POM1)DOT($N,$XS,$SN$POM2
    RHO2=UX$(POM1)DOT($N,$XS,$XS$POM2
  $ENDIF
  CALL UNSTEP(XDEL,SNORM,RHO1,RHO2,ALF)
  CALL UX$(POM1)DIR($N,ALF,$XS,$SN,$SN$POM2
  SNORM=XDEL
  ITERD=3
  NRED=-NRED
$80 CONTINUE
  $IF(HERF='S')
    $IF(MOS3=0)
    $ELSE
      SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
    $ENDIF
  $ENDIF
  $IF(HERF='D')
    PP=UXDSMQ($N,$H,$SN,$SN)*HALF
  $ELSEIF(HERF='V')
    FO=F
    PP=SQRT(ETA0/UX$(POM1)DOT($N,$SN,$SN$POM2)
    LD=MIN(MAX(KDF,KDA)-1,0)
    $IF(MODEL='AF')
      LDA=LD
    $ELSE
      LDA=-1
    $ENDIF
    I=ISNA
    ISNA=0
    $SUBST('UYTR$(CONSTR)X')
    ASSIGN $85 TO IMD
    GO TO $LMD
$85 CONTINUE
    ISNA=I
    $SUBST('UYTR$(CONSTR)A')
    CALL UX$(POM1)DIF($N,$G,$GN,$GO$POM2
    F=FO
    CALL UXVSCL($N,ONE/PP,$GO,$GO)
    PP=HALF*UX$(POM1)DOT($N,$SN,$GO$POM2
$90 CONTINUE
  $ELSEIF(HERF='S')
    IF (MOT2.EQ.0) THEN
    PP=UXSSMQ($N,M,$H,$IH,$JH,$SN,$SN)*HALF
    ENDIF
  $ELSEIF(HERF='B')
    PP=UXBSMQ($N,MAH,NA,MA,$AH,$IAG,$JAG,$SN,$SN)*HALF
  $ELSEIF(HERF='L')
    $IF(CONSTR='C') CALL UX$(POM1)COP($N,$SN,$SN$POM2
    CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$SN,$GO,PAR3&
,$MET)
    PP=UXVDOT($N,$SN,$GO)*HALF
  $ENDIF
  $IF(NOS2=6)
    $IF(MOS5>1)
      IF (NOS2.EQ.0) THEN
      NOS2=6
      IDECF=0
      NREDO=NRED
      ELSE IF (NRED.GT.8*NREDO/10) THEN
      NOS2=0
      NREDO=NRED
      ENDIF
    $ELSE
      NOS2=0
    $ENDIF
  $ENDIF
  CALL UOD1D2($N,$GN,$SN)
  $IF(HERF='V')
    $IF(MOS1>0)
      IF (IPREC.EQ.0.AND.NRED.GE.MOS1) IPREC=1
    $ENDIF
    $GA=GAS
  $ELSE
    $GS=GSS
    $XS=XSS
  $ENDIF
  $ADD(INIT)
    NDXX='UD$(HERF)GM3'
  $ENDADD
  $EXIT
