$INTERFACE UDGLA3                                             97/12/01
$REM LU

  $CON0='1.0$P-8'
  $CON1='1.0$P-3'
  $CON2='0.85$P 0'
  $CON3='5.0$P-3'
  $CON4='0.5$P 0'
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $IF(JARA='D')
    $ADD(REAL,'\$AG($NF*$NA)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
    \$AF($NA)\$AFO($NA)\$AFD($NA)')
    $POM1='V'
    $POM2=')'
    $N='N'
  $ELSEIF(JARA='S')
    $MAA=MA
    $NAA=NA
    $IF(DEC='R')
      $MAA='$MA+$NF'
      $NAA='$NA+1'
      $ADD(REAL,'\PPB\PPJ')
      $ADD(INTEGER,'\IPOM\JPOM')
      $ADD(LOGICAL,'\L1')
      $HELP
        SWITCH FOR THE HYBRID METHOD:
          1 - THE FLETCHER AND XU SWITCH
          2 - THE DENNIS AND WELSCH SWITCH
          3 - THE RAMSIN AND WEDIN SWITCH
      $CHECK(MOT2,1,'1\2\3',3)
    $ENDIF
    $ADD(REAL,'\$AG($MAA)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
    \$AF($NAA)\$AFO($NAA)\$AFD($NAA)')
    $ADD(INTEGER,'\$IAG($NAA+1)\$JAG($MAA)\$IX($NX)')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $ADD(REAL,'\UX$(POM1)DOT')
    $N='NF'
  $ELSEIF(JARA='L')
    $U='U'
    $UM='UM'
    $HELP
      LIMITED STORAGE UPDATE:
        1 - BROYDEN UPDATE
        2 - COLUMN  UPDATE
    $CHECK(MET,1,'1\2',3)
    $HELP
      NUMBER OF BFGS CORRECTIONS
    $CHECK(MF,5,INT,2)
    $ADD(REAL,'\$AG($MA)\$XM($NF*$MF)\$GM($NA*$MF)\$XR($MF*($MF+1)/2)&
    \$UM($MF)\$U($NF)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
    \$AF($NA)\$AFO($NA)\$AFD($NA)')
    $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$JB($MF)\$IX($NX)')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $ADD(REAL,'\UX$(POM1)DOT')
    $N='NF'
  $ENDIF
  $ADD(REAL,'\UXVDOT')
  $ADD(REAL,'\RHO\RHO1\RHO2\SIG\ALF')
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,'0.25$P 0',REAL,4)
  CALL UOD1D1
  IF (IDECA.NE.0) THEN
  ITERD=-1
  CALL UOERR1('UD$(JARA)L$(DEC)3',1)
  TDXX='BAD DEC0'
  GO TO $30
  ENDIF
  $IF(JARA='D')
    IF (LD.LE.ZERO) CALL UXDCMM($N,NA,$AG,$AF,$GN)
  $ELSEIF(JARA='S')
    IF (LD.LE.ZERO) CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AF,$GN)
  $ELSEIF(JARA='L')
    MX=MIN(NIT-KIT,MF)
    IF (LD.LE.ZERO) THEN
    CALL UXLCMM($N,MX,NA,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$AF,$GN&
,MET)
    ENDIF
  $ENDIF
  $IF(DEC='R')
    IF (NIT.LE.LIT+1) THEN
    IPOM=0
    JPOM=0
    PPJ=ZERO
    PPB=ZERO
    ELSE
    $IF(MOT2=2)
      RHO=R*R
      PPJ=PPJ*RHO
      PPB=PPB*RHO
    $ENDIF
    ENDIF
*
*     DETERMINATION OF THE UPDATE VECTORS
*
    $IF(MOT2=3)
      L1=IPOM.EQ.1.OR.PPJ.LT.CON3*FO.AND.PPJ.LT.$CON4*PPB
    $ELSEIF(MOT2=2)
      L1=.TRUE.
    $ELSE
      L1=FO-F.LE.ETA5*FO
    $ENDIF
    IPOM=0
    JPOM=0
    IF (ITERS.LE.0) GO TO $60
    IF (L1) THEN
    RHO1=UX$(POM1)DOT(NF,$XO,$GO$POM2
    IF (RHO1.LE.ZERO) GO TO $60
    CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$XO,$AFO)
    CALL UXSCMD($N,NA,MA,$AG,$IAG,$JAG,$AFO,-ONE,$GO,$SN)
    RHO2=-UX$(POM1)DOT($N,$XO,$SN$POM2
    IF (RHO2.LE.ZERO) GO TO $60
    CALL UXVSCL($N,SQRT(ONE/RHO2),$SN,$SN)
    CALL UXVCOP($N,$SN,$AG($IAG(NA+1)))
    AF(NA+1)=ZERO
    $IF(MOT2=2)
      JPOM=1
      IF (PPB*PPJ.EQ.ZERO) GO TO $60
      IF (ABS((F-FO)/(PO+PPB)-ONE).LE.$CON2*ABS((F-FO)/(PO+PPJ)-ONE))&
      IPOM=1
    $ELSE
      IPOM=1
    $ENDIF
    ENDIF
$60 CONTINUE
    IF (IPOM.EQ.1) NA=NA+1
  $ENDIF
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
  SNORM=ZERO
  PAR=MIN(EPS6,SQRT(GNORM))
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**($DBLE(NIT-LIT)/$DBLE(NF)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
  CALL UXVSET($N,ZERO,$SN)
  CALL UXVNEG($N,$GN,$XO)
  CALL UXVNEG($N,$GN,$GO)
  CALL UXVNEG(NA,$AF,$AFO)
  RHO1=UX$(POM1)DOT($N,$GO,$GO$POM2
  RHO=RHO1
  SIG=RHO1
  DO $10 NRED=1,$N+3
  $IF(JARA='D')
    CALL UXDRMM($N,NA,$AG,$XO,$AFD)
  $ELSEIF(JARA='S')
    CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$XO,$AFD)
  $ELSEIF(JARA='L')
    CALL UXLRMM($N,MX,NA,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$XO&
,$AFD,MET)
  $ENDIF
  ALF=UXVDOT(NA,$AFD,$AFD)
  IF (ALF.LE.$CON0*SIG) THEN
*
*     CG FAILS (THE MATRIX IS NOT POSITIVE DEFINITE)
*
  CALL UOD1D5(ALF,SIG,INF)
  IF (NRED.EQ.1) THEN
  CALL UXVNEG($N,$G,$S)
  SNORM=GNORM
  ENDIF
  ITERD=0
  TDXX='CG  FAIL'
  GO TO $30
  ENDIF
*
*     CG STEP
*
  TDXX='CG  STEP'
  ALF=RHO/ALF
  CALL UX$(POM1)DIR($N,ALF,$XO,$SN,$SN$POM2
  CALL UXVDIR(NA,-ALF,$AFD,$AFO,$AFO)
  $IF(JARA='D')
    CALL UXDCMM($N,NA,$AG,$AFO,$GO)
  $ELSEIF(JARA='S')
    CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AFO,$GO)
  $ELSEIF(JARA='L')
    CALL UXLCMM($N,MX,NA,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$AFO,$GO&
,MET)
  $ENDIF
  RHO2=UX$(POM1)DOT($N,$GO,$GO$POM2
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  CALL UOD1D4(RHO1,RHO2,PAR,SNORM,XDEL)
  IF (RHO2.LE.PAR*RHO1) GO TO $20
  ALF=RHO2/RHO
  CALL UX$(POM1)DIR($N,ALF,$XO,$GO,$XO$POM2
  RHO=RHO2
  SIG=RHO2+ALF*ALF*SIG
$10 CONTINUE
  TDXX='MAX ITER'
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$20 CONTINUE
  ITERD=2
$30 CONTINUE
  $IF(DEC='R')
    IF (IPOM.EQ.1) NA=NA-1
    $IF(MOT2>1)
      RHO=PPJ
      CALL UXSRMM($N,NA,MA,AG,IAG,JAG,S,AFO)
      PPJ=UXVDOT(NA,AFO,AFO)*HALF
      PPB=ZERO
    $ENDIF
    IF (JPOM.NE.0) THEN
    PPB=UX$(POM1)DOT($N,AG(IAG(NA+1)),S$POM2
    PPB=PPJ+HALF*PPB**2
    ENDIF
    $IF(MOT2=3)
      PPB=RHO
    $ENDIF
  $ENDIF
  CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UD$(JARA)L$(DEC)3'
  $ENDADD
  $EXIT


