$INTERFACE UDSGZ3                                             03/12/01
$REM LU

  $CON1='1.0$P-3'
  $CON3='0.8$P 0'
  $CON4='0.2$P 0'
  $CON5='1.0$P-3'
  $CON6='1.0$P 6'
  $POM1='U'
  $POM2=',$$IX,KBF)'
$REM  $HELP
$REM    MAXIMUM NUMBER OF DENSE COLUMNS:
$REM  $CHECK(MD,10,INT,2)
$REM  $HELP
$REM    MINIMUM NUMBER OF NONZERO ELEMENTS IN DENSE ROWS:
$REM  $CHECK(MDE,50,INT,2)
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $HELP
    CHOICE OF THE PENALTY PARAMETER
      0 - CONSTANT PENALTY PARAMETER
      1 - EXTENDED CHOICE OF THE PENALTY PARAMETER
  $CHECK(MOS1,0,'0\1',4)
  $HELP
    DECISION AFTER NEGATIVE CURVATURE IS FOUND
      1 - INDEFINITE ITERATIONS
      2 - DETERMINATION OF THE BOUNDARY STEP
  $CHECK(MOS3,1,'1\2',4)
  $HELP
    METHOD SELECTION:
      1 - BISECTION
      2 - TWO POINT QUADRATIC INTERPOLATION
      3 - THREE POINT QUADRATIC INTERPOLATION
      4 - THREE POINT CUBIC INTERPOLATION
  $CHECK(MES,1,'1\2\3\4',3)
  $IF(MEP=0)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P-4',REAL,3)
  $ELSEIF(MEP=1)
    $HELP
      PENALTY COEFFICIENT (IT MUST BE GREATER THEN ONE)
    $CHECK(RPF1,'1.5$P 0',REAL,3)
    $ADD(SINIT)
      CALL UXVSET($NN,ZERO,$CP)
    $ENDADD
  $ELSEIF(MEP=2)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.5$P 0',REAL,3)
  $ELSEIF(MEP=3)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 0',REAL,3)
  $ELSEIF(MEP=4)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 0',REAL,3)
  $ELSEIF(MEP=5)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 2',REAL,3)
  $ENDIF
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $DEFAULT='0.9$P 0'
  $IF(MOS=1) $DEFAULT='0.1$P 0'
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'5.0D-5',REAL,4)
  $ADD(REAL,'\$H($MMAX)\$CG($MC)\$CF($NC)\$GC($NF)\$G($NF)&
  \$S($NF+$NC)\$XO($NF)\$XS($NF)\$GS($NF)\$CZ($NC)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$ICG($NC+1)\$JCG($MC)&
  \$IX($NX)\$WN11($NF+1)\$WN12($NF+1)')
  $ADD(REAL,'\RHO\RHO1\RHO2\ALF\DEL\TEMP\TEMP1')
  $ADD(REAL,'\UX$(POM1)DOT\UXVDOT\UXWDOT')
  $ADD(INTEGER,'\I\K\L\MMX\IPOM\KPOM')
  $ADD(LOGICAL,'\L1')
  CALL UOD1D1
  $GRAD=G
  $IF(HERF='S')
    M=$IH(NF+1)-1
  $ELSEIF(HERF='L')
    $ADD(INTEGER,'\MX')
    MX=MIN(NIT-KIT,MF)
  $ELSEIF(HERF='V')
    $GRAD=GN
    $SNS=SN
    $GAS=GA
    $XOS=XO
    $GCS=GC
    $GC=GP
  $ENDIF
  IPOM=0
  IF (IDECF.LT.0) IDECF=0
  IF(IDECF.NE.0) THEN
  ITERD=-1
  TDXX='BAD DEC0'
  CALL UOERR1('UD$(HERF)LZ3',1)
  GO TO $90
  ENDIF
  GNORM=SQRT(UX$(POM1)DOT($N,$G,$G$POM2)
  INITD=MAX(ABS(INITD),1)
  IF(XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  XDEL=GNORM
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  IF (XDEL.LE.ZERO) XDEL=XMAX
  ENDIF
*
*     CONSTRUCTION OF PRECONDITIONER
*
  $IF(NOS2=1)
    $ADD(REAL,'\$GO($NF)\$B($MMAX)')
    $ADD(INTEGER,'\$IB($NC+1)\$JB($MMAX)')
    $ADD(INTEGER,'\$PSR($NC+1)\$PERC($NC)')
    $ADD(INTEGER,'\MS')
    $IF(MD>0)
      $BD='BD'
      $ADD(REAL,'\$BD($MD*($MD+1)/2)\$CP($NC)')
    $ENDIF
    CALL UXVSET($N,ONE,$GC)
    $D=GC
    L=$IB($NN+1)-1
    IF (L.GE.$MMAX) THEN
    CALL UOERR2('UD$(HERF)LZ3',49,L,$MMAX)
    ITERM=-49
    TDXX='LACK SPC'
    GO TO $90
    ENDIF
    $SUBST('UCENS1')
    RHO=ETA0
    CALL UXSPCT($NN,L,MS,MMAX,$B,$JB,$PSR,ITERM)
    IF (ITERM.NE.0) THEN
    TDXX='LACK SPC'
    GO TO $90
    ENDIF
*
*     GILL-MURRAY DECOMPOSITION
*
    CALL UXSPCF($NN,MMAX-L,$B(L+1),$PSR,$JB(L+1),$WN11,$WN12,$XS,INF&
,RHO,ALF)
    $IF(MD>0)
      IF (ND.GT.0) THEN
      CALL UXSPCX($NN,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD&
,$BD,$S,$S($N+1))
      ENDIF
    $ENDIF
  $ELSEIF(NOS2=2)
    $ADD(REAL,'\$B($MMAX)\$GO($NF+$NC)\$SO($NF+$NC)\$XP($NF)')
    $ADD(INTEGER,'\$IB($NF+$NC+1)\$JB($NF+$MC+$NC)\$KB($NF+$MC+$NC)&
    \$IW($MMAX)\$IW1(2*($NF+$NC))\$IW2(3*($NF+$NC))\$KCG($MC)')
    CALL UXVSET($N,ONE,$GC)
    CALL UXVINP($N+1,$IW1)
    CALL UXSKIN($N,$N,$GC,$IW1,$NN,MC,$CG,$JCG,$KCG,$B,$IB)
*
*     BUNCH-PARLETT DECOMPOSITION
*
    CALL UXSIBF($N+$NN,$N+$NN+MC,$KB,$JB,$B,MMAX,$IW,MMAX,$IW1,$IW2,NAU&
,NUP,INF)
    IF (INF.LT.0) THEN
    TDXX='LACK SPC'
    ITERM=INF
    GO TO $90
    ENDIF
  $ENDIF
  NDECC=NDECC+1
*
*     RANGE SPACE (VERTICAL) DIRECTION USING THE DOG-LEG STRATEGY
*
  DEL=$CON3*XDEL
  CALL UXSCMM($N,$NN,MC,$CG,$ICG,$JCG,$CF,$XS)
  CALL UXSRMM($N,$NN,MC,$CG,$ICG,$JCG,$XS,$S($N+1))
  RHO1=UXVDOT($NN,$CF,$S($N+1))
  RHO2=UXVDOT($NN,$S($N+1),$S($N+1))
  IF (RHO1.LE.ZERO.OR.RHO2.LE.ZERO) THEN
  CALL UXVSET($N,ZERO,$S)
  SNORM=ZERO
  ELSE
  SNORM=RHO1**(THREE/TWO)/RHO2
  IF (SNORM.GE.DEL) THEN
  CALL UXVSCL($N,-DEL/SQRT(RHO1),$XS,$S)
  SNORM=DEL
  ELSE
  CALL UXVSCL($N,-RHO1/RHO2,$XS,$XS)
  $IF(NOS2=1)
    CALL UXVNEG($NN,$CF,$S($N+1))
    $IF(MD>0)
      CALL UXSPCZ($NN,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD,$BD&
,$GO,$S($N+1),$CP)
    $ELSE
      CALL UXVSFP($NN,$PERC,$S($N+1),$GO)
      CALL UXSPCB($NN,MMAX-L,$B(L+1),$PSR,$JB(L+1),$S($N+1),0)
      CALL UXVSBP($NN,$PERC,$S($N+1),$GO)
    $ENDIF
    CALL UXSCMM($N,$NN,MC,$CG,$ICG,$JCG,$S($N+1),$S)
  $ELSEIF(NOS2=2)
    CALL UXVSET($N,ZERO,$S)
    CALL UXVNEG($NN,$CF,$S($N+1))
    CALL UXSIBB($N+$NN,$B,MMAX,$IW,MMAX,$SO,$S,$IW1,NAU,NUP)
  $ENDIF
  RHO1=SNORM
  SNORM=SQRT(UX$(POM1)DOT($N,$S,$S$POM2)
  IF (SNORM.GT.DEL) THEN
  CALL UX$(POM1)DIF($N,$S,$XS,$S$POM2
  SNORM=RHO1
  RHO1=UX$(POM1)DOT($N,$S,$XS$POM2
  RHO2=UX$(POM1)DOT($N,$S,$S$POM2
  CALL UNSTEP(DEL,SNORM,RHO1,RHO2,ALF)
  CALL UX$(POM1)DIR($N,ALF,$S,$XS,$S$POM2
  SNORM=DEL
  ENDIF
  ENDIF
  ENDIF
*
*     NULL SPACE (HORIZONTAL) DIRECTION USING THE CG METHOD
*
*
*     CG INITIATION
*
  $IF(HERF='D')
    CALL UXDSMD($N,$H,$S,ONE,$G,$GO)
  $ELSEIF(HERF='S')
    CALL UXSSMD($N,M,$H,$IH,$JH,$S,ONE,$G,$GO)
  $ELSEIF(HERF='L')
    $IF(UPDATE='E')
      CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$S,$GO,PAR3&
,MET)
    $ELSE
      CALL UXLSMG($N,MX,$XM,$HR,$U1,$U3,$S,$GO,PAR3,MET1)
    $ENDIF
    CALL UXVSUM($N,$GO,$G,$GO)
  $ELSEIF(HERF='V')
    IF (IREST.NE.0) THEN
    CALL UXVCOP($N,$S,$GO)
    GO TO $25
    ENDIF
    FO=F
    PP=UX$(POM1)DOT($N,$S,$S$POM2
    IF (PP.EQ.ZERO) THEN
    CALL UXVCOP($N,$S,$GO)
    GO TO $25
    ENDIF
    PP=SQRT(ETA0/PP)
    $IF(MODP='FF')
      LD=MIN(KDF-1,0)
    $ELSE
      LD=MIN(KDA-1,0)
      $IF(MODEL='AF')
        LDA=LD
      $ELSE
        LDA=-1
      $ENDIF
      ISNAS=ISNA
      ISNA=0
    $ENDIF
    LDC=LD
    ISNCS=ISNC
    ISNC=0
    $SN=S
    $XO=XV
    $SUBST('UYTR$(CONSTR)X')
    ASSIGN $20 TO IMD
    GO TO $LMD
$20 CONTINUE
    $IF(MODEL='AF')
      ISNA=ISNAS
    $ENDIF
    ISNC=ISNCS
    $XO=XOS
    $SN=SNS
    $GA=G
    $SUBST('UYTR$(CONSTR)A')
    CALL UXVDIF($N,$G,$GN,$GO)
    F=FO
    CALL UXVSCL($N,ONE/PP,$GO,$GO)
    $GA=GAS
$25 CONTINUE
    CALL UXVSUM($N,$GO,$GN,$GO)
  $ENDIF
  CALL UXVNEG($N,$GO,$XS)
*
*     CG PRECONDITIONING
*
  $IF(NOS2=1)
    CALL UXSRMM($N,$NN,MC,$CG,$ICG,$JCG,$GO,$S($N+1))
    $IF(MD>0)
      CALL UXSPCZ($NN,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD&
,$BD,$GO,$S($N+1),$CP)
    $ELSE
      CALL UXVSFP($NN,$PERC,$S($N+1),$GO)
      CALL UXSPCB($NN,MMAX-L,$B(L+1),$PSR,$JB(L+1),$S($N+1),0)
      CALL UXVSBP($NN,$PERC,$S($N+1),$GO)
    $ENDIF
    CALL UXSCMD($N,$NN,MC,$CG,$ICG,$JCG,$S($N+1),ONE,XS,$GO)
    CALL UXVNEG($NN,$S($N+1),$S($N+1))
  $ELSEIF(NOS2=2)
    CALL UXVNEG($N,$GO,$GO)
    CALL UXVSET($NN,ZERO,$GO($N+1))
    CALL UXSIBB($N+$NN,$B,MMAX,$IW,MMAX,$SO,$GO,$IW1,NAU,NUP)
    CALL UXVCOP($NN,$GO($N+1),$S($N+1))
  $ENDIF
  CALL UXVCOP($N,$GO,$XO)
  RHO1=UX$(POM1)DOT($N,$GO,$XS$POM2
  RHO=RHO1
  PAR=MIN(EPS6,RHO1)
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**(DBLE(NIT-LIT)/DBLE($N-$NN)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  KPOM=0
  MMX=MIN(20,2*($N-$NN))
$REM  MMX=2*($N-$NN)
*
*     CG ITERATIONS
*
  DO $50 NRED=1,MMX
  CALL UX$(POM1)COP($N,$S,$GS$POM2
  $IF(HERF='D')
    CALL UXDSMM($N,$H,$XO,$GO)
  $ELSEIF(HERF='S')
    CALL UXSSMM($N,M,$H,$IH,$JH,$XO,$GO)
  $ELSEIF(HERF='L')
    CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$XO,$GO,PAR3&
,$MET)
  $ELSEIF(HERF='V')
    IF (IREST.NE.0) THEN
    CALL UXVCOP($N,$XO,$GO)
    GO TO $35
    ENDIF
    FO=F
    PP=SQRT(ETA0/UX$(POM1)DOT($N,$XO,$XO$POM2)
    $IF(MODP='FF')
      LD=MIN(KDF-1,0)
    $ELSE
      LD=MIN(KDA-1,0)
      $IF(MODEL='AF')
        LDA=LD
      $ELSE
        LDA=-1
      $ENDIF
      ISNAS=ISNA
      ISNA=0
    $ENDIF
    LDC=LD
    ISNCS=ISNC
    ISNC=0
    $SN=XO
    $XO=XV
    $SUBST('UYTR$(CONSTR)X')
    ASSIGN $30 TO IMD
    GO TO $LMD
$30 CONTINUE
    $IF(MODEL='AF')
      ISNA=ISNAS
    $ENDIF
    ISNC=ISNCS
    $XO=XOS
    $SN=SNS
    $GA=G
    $SUBST('UYTR$(CONSTR)A')
    CALL UXVDIF($N,$G,$GN,$GO)
    F=FO
    CALL UXVSCL($N,ONE/PP,$GO,$GO)
    $GA=GAS
$35 CONTINUE
  $ENDIF
  ALF=UX$(POM1)DOT($N,$XO,$GO$POM2
  $IF(MOS3=0)
    IF (ALF.EQ.ZERO) THEN
    ITERD=-5
    TDXX='CG BREAK'
    CALL UOERR1('UD$(HERF)GZ3',5)
    GO TO $90
    ENDIF
  $ELSEIF(MOS3=1)
    IF (ALF.LE.ZERO) GO TO $70
  $ENDIF
  ALF=RHO/ALF
  CALL UX$(POM1)DIR($N,ALF,$XO,$S,$S$POM2
  RHO2=SQRT(UX$(POM1)DOT($N,$S,$S$POM2)
  IF (RHO2.GE.XDEL) GO TO $70
  SNORM=RHO2
*
*     CG STEP
*
  CALL UX$(POM1)DIR($N,-ALF,$GO,$XS,$XS$POM2
  CALL UXVNEG($N,$XS,$GO)
*
*     CG PRECONDITIONING
*
  $IF(NOS2=1)
    CALL UXSRMM($N,$NN,MC,$CG,$ICG,$JCG,$GO,$S($N+1))
    $IF(MD>0)
      CALL UXSPCZ($NN,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD&
,$BD,$GO,$S($N+1),$CP)
    $ELSE
      CALL UXVSFP($NN,$PERC,$S($N+1),$GO)
      CALL UXSPCB($NN,MMAX-L,$B(L+1),$PSR,$JB(L+1),$S($N+1),0)
      CALL UXVSBP($NN,$PERC,$S($N+1),$GO)
    $ENDIF
    CALL UXSCMD($N,$NN,MC,$CG,$ICG,$JCG,$S($N+1),ONE,XS,$GO)
    CALL UXVNEG($NN,$S($N+1),$S($N+1))
  $ELSEIF(NOS2=2)
    CALL UXVNEG($N,$GO,$GO)
    CALL UXVSET($NN,ZERO,$GO($N+1))
    CALL UXSIBB($N+$NN,$B,MMAX,$IW,MMAX,$SO,$GO,$IW1,NAU,NUP)
    CALL UXVCOP($NN,$GO($N+1),$S($N+1))
  $ENDIF
  RHO2=UX$(POM1)DOT($N,$GO,$XS$POM2
  IF (RHO2.LE.PAR*RHO1) GO TO $60
  CALL UOD1D4(RHO1,RHO2,PAR,SNORM,XDEL)
  ALF=RHO2/RHO
  CALL UX$(POM1)DIR($N,ALF,$XO,$GO,$XO$POM2
  RHO=RHO2
$50 CONTINUE
  TDXX='MAX ITER'
$60 CONTINUE
*
*     AN INEXACT SOLUTION IS OBTAINED
*
  ITERD=2
  TDXX='CG  STEP'
  GO TO $80
*
*     BOUNDARY STEP IS COMPUTED
*
$70 CONTINUE
  ITERD=3
  TDXX='CG  MAX2'
  RHO1=UX$(POM1)DOT($N,$GS,$XO$POM2
  RHO2=UX$(POM1)DOT($N,$XO,$XO$POM2
  CALL UNSTEP(XDEL,SNORM,RHO1,RHO2,ALF)
  CALL UX$(POM1)DIR($N,ALF,$XO,$GS,$S$POM2
  SNORM=XDEL
  CALL UX$(POM1)DIR($N,-ALF,$GO,$XS,$XS$POM2
  $IF(NOS2=1)
    CALL UXSRMM($N,$NN,MC,$CG,$ICG,$JCG,$XS,$S($N+1))
    $IF(MD>0)
      CALL UXSPCZ($NN,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD&
,$BD,$GO,$S($N+1),$CP)
    $ELSE
      CALL UXVSFP($NN,$PERC,$S($N+1),$GO)
      CALL UXSPCB($NN,MMAX-L,$B(L+1),$PSR,$JB(L+1),$S($N+1),0)
      CALL UXVSBP($NN,$PERC,$S($N+1),$GO)
    $ENDIF
  $ELSEIF(NOS2=2)
    CALL UXVNEG($N,$XS,$GO)
    CALL UXVSET($NN,ZERO,$GO($N+1))
    CALL UXSIBB($N+$NN,$B,MMAX,$IW,MMAX,$SO,$GO,$IW1,NAU,NUP)
$REM    CALL UXVCOP($NN,$GO($N+1),$S($N+1))
    CALL UXVNEG($NN,$GO($N+1),$S($N+1))
  $ENDIF
  NRED=-NRED
$80 CONTINUE
  RPF2=RPF1
  $SUBST('UDSGZD')
$90 CONTINUE
  $IF(HERF='V')
    CALL UXVCOP(NF,$XV,$X)
    CALL UXVCOP(NF,$GN,$G)
    $GC=GCS
  $ENDIF
  CALL UOD1D2($N,$G,$S)
  $ADD(INIT)
    NDXX='UDSGZ3'
  $ENDADD
  $EXIT

