$INTERFACE UDVLV2                                             97/12/01
$REM LU

  $D='D'
  $UO='UO'
  $VO='VO'
  $HELP
    NUMBER OF BFGS CORRECTIONS
  $CHECK(MF,3,INT,2,NO)
  $ADD(INIT)
    MF=$MF
  $ENDADD
  $HELP
    SELECTION OF THE SELF SCALING
      1 - SELF SCALING SUPRESSED
      2 - SCALAR SELF SCALING
  $CHECK(MET1,2,'1\2',4)
  $HELP
    TERMINATION CRITERION:
      1-PERFECT LINE SEARCH
      2-GOLDSTEIN STEPSIZE
      3-WEAK WOLFE STEPSIZE
      4-STRONG WOLFE STEPSIZE
      5-ARMIJO STEPSIZE
  $CHECK(KTERS,3,'1\2\3\4\5',4)
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES1,999,INT,4)
  $HELP
    TERMINATION TOLERANCE FOR LINE SEARCH
    (IN TEST ON THE CHANGE OF THE DIRECTIONAL DERIVATES)
  $CHECK(EPS2,'0.8$P 0',REAL,4)
  $ADD(REAL,'\$GN($NF)\$SN($NF)\$XO($NF*$MF)\$GO($NF*$MF)&
  \$XS($NF*$MF)\$GS($NF*$MF)\$UO($MF)\$VO($MF)\$D($NF)')
  $ADD(REAL,'\A\B')
  $ADD(REAL,'\UXVDOT')
  $ADD(INTEGER,'\K\KK')
$REM  $N='N'
  CALL UOD1D1
  GNORM=SQRT(UXVDOT($N,$GN,$GN))
  INITD=MAX(ABS(INITD),1)
  IF (IREST.NE.0) GO TO $20
  K=MIN(NIT-KIT,MF)
  IF (K.LE.0) THEN
  CALL UYRES1('EMPTY   ')
  GO TO $20
  ENDIF
  CALL UXDRSC($N,K,$XO,$GO,$XS,$GS,$UO,KK)
*
*     DETERMINATION OF THE PARAMETER B
*
  B=ONE/$UO(1)
  IF(B.LE.ZERO) THEN
  CALL UYRES1('B   NEG.')
  GO TO $20
  ENDIF
  CALL UXDRMM($N,KK,$XS,$GN,$VO)
  CALL UXVMUL(KK,$UO,$VO,$VO,1)
  CALL UXDCMM($N,KK,$XS,$VO,$SN)
  CALL UXDCMM($N,KK,$GS,$VO,$D)
  CALL UXVDIF($N,$GN,$D,$D)
  TDXX='UNIT    '
  $IF(MET1=1)
  $ELSEIF(MET1=2)
    A=UXVDOT($N,$GO,$GO)
    IF (A.GT.ZERO) THEN
    CALL UXVSCL($N,B/A,$D,$D)
    TDXX='SCALAR  '
    ENDIF
  $ENDIF
  CALL UXDRMM($N,KK,$GS,$D,$VO)
  CALL UXVMUL(KK,$UO,$VO,$VO,1)
  CALL UXVSUM($N,$D,$SN,$SN)
  CALL UXDCMM($N,KK,$XS,$VO,$D)
  CALL UXVDIF($N,$D,$SN,$SN)
  SNORM=SQRT(UXVDOT($N,$SN,$SN))
  TUXX='BFGS-   '
  WRITE (TUXX(6:7),'(I2)') KK
  K=MIN(K+1,MF)
  CALL UXDRSU($N,K,$XO,$GO,$UO)
$20 ITERD=0
  IF (IREST.NE.0) THEN
*
*     STEEPEST DESCENT DIRECTION
*
  CALL UXVNEG($N,$GN,$SN)
  SNORM=GNORM
  TUXX='INITIAL '
  TDXX='ST.DESC.'
  CALL UYSET3
  ENDIF
  CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UDVLV2'
  $ENDADD
  $EXIT
