$INTERFACE UE0DQ1                                             97/12/01

      $SUBST('UZESET')
 $ADD(REAL,'\$YA($MEL)\$EF($MEL)')
$REM $ADD(INTEGER,'\NE\MEL\KE')
$REM $ADD(REAL,'\FE\WE\YE')
 $00  CALL UE0DQ1(NE,MEL,KE,$YA,$EF,FE,WE,YE)
      GO TO ($20,$10) ISB+1
 $10  CONTINUE
      $IF(LED<0)
        $MTYPE=FMODE
        $SUBST('UZEMOD')
      $ELSE
        FE=$EF(KE)
      $ENDIF
      GOTO $00
 $20  CONTINUE
      $ADD(INIT)
        NEXX='UE0DQ1'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UE0DQ1             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION
* WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  MEL  ACTUAL NUMBER OF DIFFERENTIAL EQUATIONS.
*  IU  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*  RI  YA(MEL)  SOLUTION VECTOR.
*  RO  EF(MEL)  RIGHT HAND SIDE VECTOR.
*  RI  FE  VALUE OF THE RIGHT HAND SIDE FUNCTION.
*  RI  WE  WEIGHT COEFFICIENT.
*  RI  YE  REQUIRED VALUE OF THE RIGHT HAND SIDE FUNCTION.
*
* COMMON DATA :
*  II  KDA  ORDER OF ANALYTICALLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UE0DQ1(NE,MEL,KE,YA,EF,FE,WE,YE)
      $INCLUDE ('UMCOMM')
      INTEGER NE,MEL,KE
      $FLOAT YA(MEL),EF(MEL),FE,WE,YE
      IF (TSS(NS).NE.'UEXX') CALL UYPRO1('UEXX',-1)
      GO TO (1,5) ISP(NS)
    1 CONTINUE
      IF (KDA.GE.0) EF(NE+1)=ZERO
      KE=1
    4 IF (KE.GT.NE) GO TO 6
      CALL UYSET0(1,2)
      RETURN
    5 CONTINUE
      EF(KE)=FE
      IF (KDA.GE.0) EF(NE+1)=EF(NE+1)+HALF*WE*(YA(KE)-YE)**2
      KE=KE+1
      GO TO 4
    6 CALL UYEPI1(-1)
      RETURN
      END
