$INTERFACE UESVD1                                             98/12/01

  $IF($DEF(ISYS))
    $IF(ISYS=1)
      $ET='ET'
    $ELSE
      $ET='EF'
    $ENDIF
  $ELSE
    $ET='EF'
    $ISYS=0
  $ENDIF
  CALL UESVD1(NE,KE,$DE,$ED,$ET,TE,$ISYS)
  $ADD(REAL,'\$DE($MEL)\$ED($MEL*$MEL)\$ET($MEL)')
$REM  $ADD(INTEGER,'\NE\KE')
$REM  $ADD(REAL,'\TE')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UESVD1             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SAVING THE DERIVATIVE OF THE RIGHT HAND SIDE FUNCTION.
*
* PARAMETERS :
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  KE  INDEX OF THE RIGHT HAND SIDE FUNCTION.
*  RI  DE(NE)  DERIVATIVE OF A RIGHT HAND SIDE.
*  RO  ED(NE*NE)  JACOBIAN MATRIX OF THE RIGHT HAND SIDE FUNCTION
*  RO  ET(NE)  DERIVATIVE OF THE RIGHT HAND SIDE FUNCTION WITH RESPECT
*         TO THE INDEPENDENT VARIABLE.
*  II  ISYS  TYPE OF THE DIFFERENTIAL SYSTEM. ISYS=0 - FOR AUTONOMOUS
*         SYSTEM, ISYS=1 - FOR GENERAL SYSTEM.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPY OF A VECTOR.
*
      SUBROUTINE UESVD1(NE,KE,DE,ED,ET,TE,ISYS)
      INTEGER NE,KE,ISYS
      $FLOAT DE(NE),ED(NE*NE),ET(NE),TE
      CALL UXVCOP(NE,DE,ED((KE-1)*NE+1))
      IF (ISYS.GT.0) ET(NE)=TE
      RETURN
      END
