$INTERFACE UF0FQ2                                             97/12/01

  $HELP
    TYPE OF EXTREMUM
      0 - MINIMUM
      1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,4)
  $ADD(REAL,'\$X($NF)\$GF($NF)\$HF($M)')
$REM  $ADD(REAL,'\FF\F')
  $ADD(INTEGER,'\$IH($MCOLS+1)\$JH($M)')
$REM  $ADD(INTEGER,'\NF\M')
  CALL UF0FQ2(NF,M,$X,$GF,$HF,$IH,$JH,FF,F)
  $ADD(INIT)
    NFXX='UF0FQ2'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UF0FQ2                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE OF THE QUADRATIC OBJECTIVE FUNCTION -
* SPARSE CASE.
*
* PARAMETERS:
*  II  NF NUMBER OF VARIABLES.
*  II  M  SIZE OF THE SPARSE MATRIX WORK SPACE.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  GF(NF)  GRADIENT OF THE QUADRATIC MODEL FUNCTION.
*  RI  HF(M)  HESSIAN ELEMENTS OF THE QUADRATIC MODEL FUNCTION.
*  II  IH(NF+1)  POINTERS OF THE DIAGONAL ELEMENTS OF HESSIAN MATRIX.
*  II  JH(M)  INDICES OF THE NONZERO ELEMENTS OF HESSIAN MATRIX.
*  RI  FF  CONSTANT TERM OF THE QUADRATIC MODEL FUNCTION.
*  RO  F  VALUE OF THE QUADRATIC OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*
* SUBPROGRAMS USED :
*  RF  UXSSMQ  COMPUTATION OF THE QUADRATIC TERM.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*
      SUBROUTINE UF0FQ2(NF,M,X,GF,HF,IH,JH,FF,F)
      $INCLUDE ('UMCOMM')
      INTEGER NF,M,IH(NF+1),JH(M)
      $FLOAT X(NF),GF(NF),HF(M),FF,F
      $FLOAT UXVDOT,UXSSMQ
      F=UXSSMQ(NF,M,HF,IH,JH,X,X)
      F=FF+UXVDOT(NF,X,GF)+HALF*F
      IF (IEXT.GT.0) F=-F
      RETURN
      END
