$INTERFACE UF0HS2                                             97/12/01

  $HELP
    PRECISION OF THE COMPUTED VALUES
  $CHECK(ETA1,ETA0,REAL,4)
  CALL UF0HS2(NF,M,$X,$IX,$XN,$HF,$IH,$JH,$GO,$GS,FF,$ETA1)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$HF($M)\$GO($NF)\$GS($NF)')
$REM  $ADD(REAL,'\FF')
  $ADD(INTEGER,'\$IX($NX)\$IH($NF+1)\$JH($M)\$COL($NF)')
$REM  $ADD(INTEGER,'\NF\M')
  $ADD(INIT)
    NFHX='UF0HS2'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UF0HS2                ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* NUMERICAL COMPUTATION OF THE HESSIAN MATRIX OF THE MODEL FUNCTION
* USING ITS VALUES.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  HF(M) HESSIAN MATRIX OF THE MODEL FUNCTION.
*  II  IH(NF+1) POINTER VECTOR OF SPARSE HESSIAN MATRIX.
*  II  JH(M) INDEX VECTOR OF THE HESSIAN MATRIX.
*  RA  GO(NF)  AUXILIARY VECTOR.
*  RA  GS(NF)  AUXILIARY VECTOR.
*  RI  FF  VALUE OF THE MODEL FUNCTION.
*  RI  ETA1  PRECISION OF THE COMPUTED VALUES.
*
* COMMON DATA :
*  II  KBF  TYPE OF BOUNDS. KBF=0-BOUNDS ARE NOT USED. KBF=1-ONE SIDED
*         BOUNDS. KBF=1-TWO SIDED BOUNDS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UF0HS2(NF,M,X,IX,XN,HF,IH,JH,GO,GS,FF,ETA1)
      $INCLUDE('UMCOMM')
      INTEGER NF,M,IX(NF)
      $FLOAT X(NF),XN(NF),HF(M),GO(NF),GS(NF),FF,ETA1
      $FLOAT XTEMPI,XTEMPJ,FTEMP,ETA
      INTEGER IH(NF+1),JH(M)
      INTEGER I,J,L,JSTRT,JSTOP,IVAR
      SAVE XTEMPI,XTEMPJ,FTEMP,ETA
      SAVE I,J,L,IVAR
      IF(ITERM.NE.0) GO TO 12
      IF (TSS(NS).NE.'UFHX') CALL UYPRO1('UFHX',-1)
      GO TO (1,3,6,8) ISP(NS)
    1 CONTINUE
      ETA=ETA1**(ONE/THREE)
      FTEMP=FF
      IVAR=0
    2 CONTINUE
      IVAR=IVAR+1
      IF (IVAR .GT. NF) GO TO 4
      IF (KBF.GT.0) THEN
      IF (IX(IVAR).LE.-5) GO TO 2
      ENDIF
      IF (NORMF.GT.0) THEN
      GO(IVAR)=XN(IVAR)
      ELSE
      GO(IVAR)=ONE
      ENDIF
      GO(IVAR)=ETA*MAX(ABS(X(IVAR)),GO(IVAR))*SIGN(ONE,X(IVAR))
      XTEMPI=X(IVAR)
      X(IVAR)=X(IVAR)+GO(IVAR)
      GO(IVAR)=X(IVAR)-XTEMPI
      CALL UYSET0(1,2)
      RETURN
    3 CONTINUE
      GS(IVAR)=FF
      X(IVAR)=XTEMPI
      GO TO 2
    4 I=0
    5 CONTINUE
      I=I+1
      IF(I.GT.NF) GO TO 10
      IF (KBF.GT.0) THEN
      IF (IX(I).LE.-7) GO TO 5
      ENDIF
      XTEMPI=X(I)
      X(I)=X(I)+TWO*GO(I)
      CALL UYSET0(1,3)
      RETURN
    6 CONTINUE
      JSTRT=IH(I)
      JSTOP=IH(I+1)-1
      HF(JSTRT)=((FTEMP-GS(I))+(FF-GS(I)))/(GO(I)*GO(I))
      X(I)=XTEMPI+GO(I)
      J=JSTRT
    7 CONTINUE
      J=J+1
      L=JH(J)
      IF (KBF.GT.0) THEN
      IF (IX(J).LE.-7) GO TO 7
      ENDIF
      IF(J.GT.JSTOP) GO TO 9
      XTEMPJ=X(L)
      X(L)=X(L)+GO(L)
      CALL UYSET0(1,4)
      RETURN
    8 CONTINUE
      HF(J)=((FTEMP-GS(I))+(FF-GS(L)))/(GO(I)*GO(L))
      X(L) =XTEMPJ
      GO TO 7
    9 X(I) =XTEMPI
      GO TO 5
   10 FF=FTEMP
      CALL UYEPI1(-1)
   12 CONTINUE
      RETURN
      END
