$INTERFACE UF1F02                                             09/12/01

  $HELP
    TYPE OF EXTREMUM:
      0 - MINIMUM
      1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $IF(IEXT=0)
    $G=GF
  $ENDIF
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $LHLP=1
  $IF(NOS2=3)
    $DU=D
    $DV=D
    $KHLP=3
    $IF(MOS4=1) $LHLP=2
    $ADD(REAL,'\$D($NF)')
  $ELSEIF(NOS2=4)
    $DV=DU
    $KHLP=4
    $IF(MOS4=1) $LHLP=2
    $ADD(REAL,'\$D($NF)\$DU($NF)')
  $ELSEIF(NOS2=5)
    $KHLP=5
    $IF(MOS4=1) $LHLP=2
    $ADD(REAL,'\$D($NF)\$DU($NF)\$DV($NF)')
  $ELSE
    $ADD(REAL,'\$GF($NF)\$G($NF)')
  $ENDIF
$REM  $ADD(REAL,'\FF\F')
$REM  $ADD(INTEGER,'\NF')
      $IF(LHLP=1)
 $00    CALL UF1F01(NF,$GF,$G,FF,F)
        GOTO ($40,$10,$20) ISB+1
      $ELSE
 $00    CALL UF1F02(NF,$GF,$G,$D,$DU,$DV,FF,F,NOS2)
        GOTO ($80,$10,$20,$40) ISB+1
      $ENDIF
 $10  CONTINUE
      $MTYPE=FMODF
      $SUBST('UZFMOD')
      GOTO $00
 $20  CONTINUE
      $IF(GMODF='G')
        $MTYPE='G'
        $SUBST('UZFMOD')
        GOTO $00
      $ELSEIF(FMODF='F')
        $HELP
          METHOD FOR DETERMINATION OF DIFFERENCE USED FOR
          NUMERICAL COMPUTATION OF GRADIENT:
            0 - CONSTANT DIFFERENCE
            1 - EASY COMPARATIVE METHOD
            2 - STEWART'S METHOD.
        $CHECK(MCG,2,'0\1\2',3)
        $IF(MCG=0)
          $SUBST('UF0G$(CON)1')
        $ELSE
          $ADD(SINID)
            CALL UXVSET(NF,ZERO,$GF)
            CALL UXVSET(NF,ONE,$HD)
          $ENDADD
          $SUBST('UF0G$(CON)2')
        $ENDIF
        GOTO ($00,$30) ISB+1
 $30  CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $20
      $ELSE
        IF (LD.LT.0) GOTO $00
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $00
      $ENDIF
 $40  CONTINUE
      $IF(LHLP=2)
        $IF(GMODF='G')
          $SUBST('UF1H$(CON)$(KHLP)')
          GOTO ($00,$50) ISB+1
 $50    CONTINUE
          $MTYPE=GMODF
          $SUBST('UZFMOD')
          GO TO $40
        $ELSEIF(FMODF='F')
          $SUBST('UF0H$(CON)$(KHLP)')
          GO TO ($00,$60) ISB+1
 $60    CONTINUE
          $MTYPE=FMODF
          $SUBST('UZFMOD')
          GO TO $40
        $ELSEIF(FMODF='FG')
          $SUBST('UF1H$(CON)$(KHLP)')
          GO TO ($00,$70) ISB+1
 $70    CONTINUE
          $MTYPE=FMODF
          $SUBST('UZFMOD')
          GO TO $40
        $ELSE
          IF (LD.LT.0) GOTO $00
          $MTYPE=FMODF
          $SUBST('UZFMOD')
          GO TO $00
        $ENDIF
 $80    CONTINUE
      $ENDIF
      $ADD(INIT)
        NFXX='UF1F02'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UF1F02                ALL SYSTEMS                09/12/01
C PORTABILITY : ALL SYSTEMS
C 09/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  RI  GF(NF)  GRADIENT OF THE MODEL FUNCTION.
*  RO  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RU  D(N)  THE DIAGONAL OF THE BAND PRECONDITIONER.
*  RU  DU(N)  THE FIRST SUPERDIAGONAL OF THE BAND PRECONDITIONER.
*  RU  DV(N)  THE SECOND SUPERDIAGONAL OF THE BAND PRECONDITIONER.
*  RI  FF  VALUE OF THE MODEL FUNCTION.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  II  MOS2  TYPE OF PRECONDITIONING: MOS2=0-NO PRECONDITIONING,
*         MOS2=1-LBFGS PRECONDITIONING, MOS2=2=BNS PROCONDITIONING,
*         MOS2=3-DIAGONAL PRECONDITIONING. MOS2=4-TRIDIAGONAL
*         PRECONDITIONING. MOS2=5-PENTADIAGONAL PRECONDITIONING.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*  II  NEXT  NUMBER OF THE PROBLEM SOLVED.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVNEG  COPYING OF A VECTOR WITH CHANGE OF THE SIGN.
*
      SUBROUTINE UF1F02(NF,GF,G,D,DU,DV,FF,F,MOS2)
      $INCLUDE ('UMCOMM')
      INTEGER NF,MOS2
      $FLOAT GF(NF),G(NF),D(NF),DU(NF),DV(NF),FF,F
      IF (NS.EQ.0) THEN
      CALL UYPRO1('UFXX',-1)
      ELSE IF (TSS(NS).NE.'UFXX') THEN
      CALL UYPRO1('UFXX',-1)
      ENDIF
      GO TO (1,2,4,6) ISP(NS)
    1 CONTINUE
      IF (KD.LT.0) GO TO 7
      IF (LD.GE.0) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      IF (IEXT.LE.0) THEN
      F= FF
      ELSE
      F=-FF
      ENDIF
    3 IF (KD.LT.1) GO TO 7
      IF (LD.GE.1) GO TO 5
      CALL UYSET0(2,3)
      RETURN
    4 CONTINUE
      IF (IEXT.GT.0) THEN
      CALL UXVNEG(NF,GF,G)
      ELSE IF (NEXT.GT.0) THEN
      CALL UXVCOP(NF,GF,G)
      ENDIF
    5 IF (KD.LT.2) GO TO 7
      CALL UYSET0(3,4)
      RETURN
    6 CONTINUE
      IDECF=0
      IF (IEXT.GT.0) THEN
      CALL UXVNEG(NF,D,D)
      IF (MOS2.EQ.4) CALL UXVNEG(NF,DU,DU)
      IF (MOS2.EQ.5) CALL UXVNEG(NF,DV,DV)
      ENDIF
    7 CALL UYEPI1(-1)
      LD=KD
      RETURN
      END

