$INTERFACE UF1FQ1                                             97/12/01

  $HELP
    TYPE OF EXTREMUM
      0 - MINIMUM
      1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,3)
  $ADD(REAL,'\$X($NF)\$GF($NF)\$G($NF)\$HF($NF*($NF+1)/2)')
$REM  $ADD(REAL,'\FF\F')
$REM  $ADD(INTEGER,'\NF')
  CALL UF1FQ1(NF,$X,$GF,$G,$HF,FF,F)
  $ADD(INIT)
    NFXX='UF1FQ1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UF1FQ1              ALL SYSTEMS                  97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE QUADRATIC OBJECTIVE
* FUNCTION.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  GF(NF)  GRADIENT OF THE QUADRATIC MODEL FUNCTION.
*  RO  G(NF)  GRADIENT OF THE QUADRATIC OBJECTIVE FUNCTION.
*  RI  HF(NF*(NF+1)/2)  HESSIAN MATRIX OF THE QUADRATIC MODEL FUNCTION.
*  RI  FF  CONSTANT TERM OF THE QUADRATIC MODEL FUNCTION.
*  RO  F  VALUE OF THE QUADRATIC OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*
* SUBPROGRAMS USED :
*  S   UXDSMM  MATRIX VECTOR PRODUCT.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*  S   UXVNEG  COPYING OF A VECTOR WITH CHANGE OF THE SIGN.
*  S   UXVSUM  SUM OF TWO VECTORS.
*
      SUBROUTINE UF1FQ1(NF,X,GF,G,HF,FF,F)
      $INCLUDE ('UMCOMM')
      INTEGER NF
      $FLOAT X(NF),GF(NF),G(NF),HF(NF*(NF+1)/2),FF,F
      $FLOAT UXVDOT
      CALL UXDSMM(NF,HF,X,G)
      CALL UXVSUM(NF,GF,G,G)
      F=FF+HALF*(UXVDOT(NF,X,GF)+UXVDOT(NF,X,G))
      IF (IEXT.GT.0) F=-F
      IF (IEXT.GT.0) CALL UXVNEG(NF,G,G)
      RETURN
      END
