$INTERFACE UF1FQ2                                             97/12/01

  $H=HF
  $HELP
    TYPE OF EXTREMUM
      0 - MINIMUM
      1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $ADD(REAL,'\$X($MCOLS)\$GF($MCOLS)\$G($MCOLS)\$HF($MMAX)')
$REM  $ADD(REAL,'\FF\F')
  $ADD(INTEGER,'\$IH($MCOLS+1)\$JH($MMAX)')
$REM  $ADD(INTEGER,'\NF')
  CALL UF1FQ2(NF,$IH(NF+1)-1,$X,$GF,$G,$HF,$IH,$JH,FF,F)
  $ADD(INIT)
    NFXX='UF1FQ2'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UF1FQ2                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE QUADRATIC OBJECTIVE
* FUNCTION - SPARSE CASE.
*
* PARAMETERS:
*  II  NF NUMBER OF VARIABLES.
*  II  M  SIZE OF THE SPARSE MATRIX WORK SPACE.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  GF(NF)  GRADIENT OF THE QUADRATIC MODEL FUNCTION.
*  RO  G(NF)  GRADIENT OF THE QUADRATIC OBJECTIVE FUNCTION.
*  RI  HF(M)  HESSIAN ELEMENTS OF THE QUADRATIC MODEL FUNCTION.
*  II  IH(NF+1)  POINTERS OF THE DIAGONAL ELEMENTS OF HESSIAN MATRIX.
*  II  JH(M)  INDICES OF THE NONZERO ELEMENTS OF HESSIAN MATRIX.
*  RI  FF  CONSTANT TERM OF THE QUADRATIC MODEL FUNCTION.
*  RO  F  VALUE OF THE QUADRATIC OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*
* SUBPROGRAMS USED :
*  S   UXSSMM  MATRIX VECTOR PRODUCT.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*  S   UXVNEG  COPYING OF A VECTOR WITH CHANGE OF THE SIGN.
*  S   UXVSUM  SUM OF TWO VECTORS.
*
      SUBROUTINE UF1FQ2(NF,M,X,GF,G,HF,IH,JH,FF,F)
      $INCLUDE ('UMCOMM')
      INTEGER NF,M,IH(NF+1),JH(M)
      $FLOAT X(NF),GF(NF),G(NF),HF(M),FF,F
      $FLOAT UXVDOT
      CALL UXSSMM(NF,M,HF,IH,JH,X,G)
      CALL UXVSUM(NF,GF,G,G)
      F=FF+HALF*(UXVDOT(NF,X,GF)+UXVDOT(NF,X,G))
      IF (IEXT.GT.0) F=-F
      IF (IEXT.GT.0) CALL UXVNEG(NF,G,G)
      RETURN
      END

