$INTERFACE UF2F01                                             97/12/01

  $HELP
    TYPE OF EXTREMUM
      0 - MINIMUM
      1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $IF(IEXT=0)
    $G=GF
    $H=HF
  $ENDIF
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $IF(HESF='D')
    $KHLP=1
  $ELSEIF(HESF='S')
    $KHLP=2
  $ENDIF
  $ADD(REAL,'\$GF($NF)\$G($NF)\$H($M)\$HF($M)')
$REM  $ADD(REAL,'\FF\F')
$REM  $ADD(INTEGER,'\NF\M')
  $00 CALL UF2F01(NF,M,$GF,$G,$HF,$H,FF,F)
      GOTO ($80,$10,$20,$40) ISB+1
  $10 CONTINUE
      $MTYPE=FMODF
      $SUBST('UZFMOD')
      GOTO $00
  $20 CONTINUE
      $IF(GMODF='G')
        $MTYPE='G'
        $SUBST('UZFMOD')
        GOTO $00
      $ELSEIF(FMODF='F')
        $HELP
          METHOD FOR DETERMINATION OF DIFFERENCE USED FOR
          NUMERICAL COMPUTATION OF GRADIENT:
            0 - CONSTANT DIFFERENCE
            1 - EASY COMPARATIVE METHOD
            2 - STEWART'S METHOD.
        $CHECK(MCG,2,'0\1\2',3)
        $IF(MCG=0)
          $SUBST('UF0G$(CON)1')
        $ELSE
          $ADD(SINID)
            CALL UXVSET(NF,ZERO,$GF)
            CALL UXVSET(NF,ONE,$HD)
          $ENDADD
          $SUBST('UF0G$(CON)2')
        $ENDIF
        GOTO ($00,$30) ISB+1
  $30 CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $20
      $ELSE
        IF (LD.LT.0) GOTO $00
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $00
      $ENDIF
  $40 CONTINUE
      $IF(HMODF='H')
        $MTYPE='H'
        $SUBST('UZFMOD')
        GOTO $00
      $ELSEIF(GMODF='G')
        $SUBST('UF1H$(CON)$(KHLP)')
        GOTO ($00,$50) ISB+1
  $50 CONTINUE
        $MTYPE=GMODF
        $SUBST('UZFMOD')
        GO TO $40
      $ELSEIF(FMODF='F')
        $SUBST('UF0H$(CON)$(KHLP)')
        GO TO ($00,$60) ISB+1
  $60 CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $40
      $ELSEIF(FMODF='FG')
        $SUBST('UF1H$(CON)$(KHLP)')
        GO TO ($00,$70) ISB+1
  $70 CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $40
      $ELSE
        IF (LD.LT.0) GOTO $00
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $00
      $ENDIF
  $80 CONTINUE
      $ADD(INIT)
        NFXX='UF2F01'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UF2F01             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT AND THE HESSIAN MATRIX
* OF THE OBJECTIVE FUNCTION.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  II  M  NUMBER OF ELEMENTS OF THE HESSIAN MATRIX (DENSE OR SPARSE).
*  RI  GF(NF)  GRADIENT OF THE MODEL FUNCTION.
*  RO  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  HF(M)  HESSIAN MATRIX OF THE MODEL FUNCTION.
*  RO  H(M)  HESSIAN MATRIX OF THE OBJECTIVE FUNCTION.
*  RI  FF  VALUE OF THE MODEL FUNCTION.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*  II  NEXT  NUMBER OF THE PROBLEM SOLVED.
*  IO  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVNEG  COPYING OF A VECTOR WITH CHANGE OF THE SIGN.
*
      SUBROUTINE UF2F01(NF,M,GF,G,HF,H,FF,F)
      $INCLUDE ('UMCOMM')
      INTEGER NF,M
      $FLOAT GF(NF),G(NF),HF(M),H(M),FF,F
      IF (TSS(NS).NE.'UFXX') CALL UYPRO1('UFXX',-1)
      GO TO (1,2,4,6) ISP(NS)
    1 CONTINUE
      IF (KD.LT.0) GO TO 7
      IF (LD.GE.0) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      IF (IEXT.LE.0) THEN
      F= FF
      ELSE
      F=-FF
      ENDIF
    3 IF (KD.LT.1) GO TO 7
      IF (LD.GE.1) GO TO 5
      CALL UYSET0(2,3)
      RETURN
    4 CONTINUE
      IF (IEXT.GT.0) THEN
      CALL UXVNEG(NF,GF,G)
      ELSE IF (NEXT.GT.0) THEN
      CALL UXVCOP(NF,GF,G)
      ENDIF
    5 IF (KD.LT.2) GO TO 7
      IF (LD.GE.2) GO TO 7
      CALL UYSET0(3,4)
      RETURN
    6 CONTINUE
      IDECF=0
      IF (IEXT.GT.0) THEN
      CALL UXVNEG(M,HF,H)
      ELSE IF (NEXT.GT.0) THEN
      CALL UXVCOP(M,HF,H)
      ENDIF
    7 CALL UYEPI1(-1)
      LD=KD
      RETURN
      END

