$INTERFACE UF2FL1                                             97/12/01

  $HELP
    TYPE OF EXTREMUM
      0 - MINIMUM
      1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $IF(IEXT=0)
    $G=GF
  $ENDIF
  $ADD(REAL,'\$X($NF)\$GF($NF)\$G($NF)\$H($M)')
$REM  $ADD(REAL,'\FF\F')
$REM  $ADD(INTEGER,'\NF')
  CALL UF2FL1(NF,$X,$GF,$G,$H,FF,F)
  $ADD(INIT)
    NFXX='UF2FL1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UF2FL1             ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT AND THE HESSIAN MATRIX
* OF THE LINEAR OBJECTIVE FUNCTION.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  GF(NF)  GRADIENT OF THE LINEAR MODEL FUNCTION.
*  RO  G(NF)  GRADIENT OF THE LINEAR OBJECTIVE FUNCTION.
*  RO  H(NF*(NF+1)/2)  HESSIAN MATRIX OF THE LINEAR OBJECTIVE FUNCTION.
*  RI  FF  CONSTANT TERM OF THE LINEAR MODEL FUNCTION.
*  RO  F  VALUE OF THE LINEAR OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*  S   UXVNEG  COPYING OF A VECTOR WITH CHANGE OF THE SIGN.
*  S   UXVSET  INITIATION OF THE SYMMETRIC MATRIX.
*
      SUBROUTINE UF2FL1(NF,X,GF,G,H,FF,F)
      $INCLUDE ('UMCOMM')
      INTEGER NF
      $FLOAT X(NF),GF(NF),G(NF),H(NF*(NF+1)/2),FF,F
      $FLOAT UXVDOT
      F=FF+UXVDOT(NF,X,GF)
      IF (IEXT.GT.0) F=-F
      IF (IEXT.GT.0) THEN
      CALL UXVNEG(NF,GF,G)
      ELSE IF (NEXT.GT.0) THEN
      CALL UXVCOP(NF,GF,G)
      ENDIF
      CALL UXVSET(NF*(NF+1)/2,ZERO,H)
      RETURN
      END
