* SUBROUTINE UFSETI             ALL SYSTEMS                   06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE SPARSE HESSIAN MATRIX FROM THE PARTITIONED HESSIAN
* MATRIX.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIADLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  NCL  NUMBER OF LINEAR CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  II  MB  NUMBER OF NONZERO ELEMENTS OF THE PARTITIONED HESSIAN MATRIX.
*  IO  M  NUMBER OF NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  RU  B(M)  ELEMENTS OF THE SPARSE MATRIX B.
*  IO  IH(NF+1)  POINTERS OF THE DIAGONAL ELEMENTS OF B.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF B.
*  II  CH(MB)  ELEMENTS OF THE PARTITIONED MATRIX H.
*  II  ICG(NC+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  II  JCG(MC)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  II  ICA(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  II  JOB  SUBJECTS OF UPDATES. JOB=0-CONSTRAINT FUNCTIONS.
*         JOB=1-CONSTRAINT FUNCTIONS MULTIPLIED BY SIGNS OF THE
*         LAGRANGIAN MULTIPLIERS. JOB-2-ACTIVE TERMS OF THE LAGRANGIAN
*         FUNCTION. JOB-3-ALL TERMS OF THE LAGRANGIAN FUNCTION.
*
      SUBROUTINE UFSETI(NF,NC,NCL,MC,MB,M,B,IH,JH,CH,ICG,JCG,ICA,
     & CZL,CZU,JOB)
      INTEGER NF,NC,NCL,MC,MB,M,IH(NF+1),JH(M),ICG(NC+1),JCG(MC),
     & ICA(NC),JOB
      $FLOAT B(M),CH(MB),CZL(NC),CZU(NC)
      INTEGER I,II,IC,J,JJ,JC,JF,K,KK,L,LL,KC
      $FLOAT TEMP
      KK=0
      DO 7 KC=1,NC
      IF (JOB.LE.1) THEN
      LL=ABS(ICA(KC))
      IF (LL.EQ.3.OR.LL.EQ.4) THEN
      TEMP= CZU(KC)-CZL(KC)
      ELSE IF (LL.EQ.1) THEN
      TEMP=-CZL(KC)
      ELSE IF (LL.EQ.2) THEN
      TEMP= CZU(KC)
      ELSE IF (LL.EQ.5) THEN
      TEMP= CZL(KC)
      ENDIF
      IF (JOB.EQ.1) TEMP=ABS(TEMP)
      ELSE IF (JOB.EQ.2) THEN
      IF (ICA(KC).GE.0) THEN
      KK=KK+L*(L+1)/2
      GO TO 7
      ELSE
      TEMP=1.0$P 0
      ENDIF
      ELSE
      TEMP=1.0$P 0
      ENDIF
      II=ICG(KC)
      L=ICG(KC+1)-II
      DO 6 IC=1,L
      KK=KK+IC
      IF (KC.LE.NCL) GO TO 5
      I=JCG(II)
      IF (I.LE.0) GO TO 5
      JF=IH(I)
      JJ=II
      K=KK
      DO 4 JC=IC,L
      J=JCG(JJ)
      IF (J.LE.0) GO TO 3
    2 IF (JH(JF).LT.J) THEN
      JF=JF+1
      GO TO 2
      ENDIF
      B(JF)=B(JF)+TEMP*CH(K)
    3 K=K+JC
      JJ=JJ+1
    4 CONTINUE
    5 II=II+1
    6 CONTINUE
    7 CONTINUE
      RETURN
      END
