* SUBROUTINE UG1F01             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  COMPUTATION OF THE TUNNELING FUNCTION AND ITS GRADIENT.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES
*  RU  F  FUNCTION VALUE
*  RI  X(NF)  VECTOR OF VARIABLES
*  RI  FMIN  FUNCTION VALUE IN XMIN
*  RI  XMIN(NF)  VECTOR OF VARIABLES IN MINIMUM
*  RU  G(NF)  GRADIENT
*  II  IALF  TUNNELING PARAMETER
*  II  KD  REQUIRED DEGREE OF DERIVATION
*
      SUBROUTINE UG1F01(NF,F,X,FMIN,XMIN,G,IALF,KD)
      INTEGER NF,IALF,KD
      $FLOAT F,X(NF),FMIN,XMIN(NF),G(NF)
      INTEGER I
      $FLOAT SUM
      SUM=0.0$P 0
      DO 10 I=1,NF
        SUM=SUM+(X(I)-XMIN(I))**2
   10 CONTINUE
      IF (KD.GT.0) THEN
        DO 20 I=1,NF
          G(I)=G(I)/SUM**IALF-(F-FMIN)*2.0$P 0*IALF*(X(I)-XMIN(I))
     &         /((SUM**IALF)*SUM)
   20   CONTINUE
      ENDIF
      F=(F-FMIN)/(SUM**IALF)
      END
