$INTERFACE UKLINI                                             98/12/01

  CALL UKLINI(MROWS,MCOLS,NZ,NZA,NEL,IBEG,IENDLU,$IC,$CL,$CU,$IX,$X,$XL&
,$XU,$PINR,$INR,$LENR,IER)
  $ADD(REAL,'\$XL($MCOLS)\$XU($MCOLS)\$CL($MCOLS)\$CU($MCOLS)')
  $ADD(INTEGER,'\$IC($MROWS)\$IX($MCOLS)\$PINR($MROWS+1)\$INR($NZ)')
  $ADD(INTEGER,'\$LENR($MROWS)\$X($MCOLS)')
$REM  $ADD(INTEGER,'\MROWS\MCOLS\NZ\NZA\NEL\IBEG\IENDLU\IER')
  $ADD(INIT)
    NFXX='UKLINI'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UKLINI                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF PRINCIPAL ARRAYS FOR SPARSE QP/LP. SETTING DEFAULTS.
*
* PARAMETERS :
*  II  MROWS MAXIMUM NUMBER OF ROWS.
*  II  MCOLS MAXIMUM NUMBER OF COLUMNS.
*  II  NZ  SIZE OF ARRAYS INR/CNR.
*  IO  NEL NUMBER OF ELEMENTS INSERTED INTO THE INPUT STRUCTURE.
*  IO  IBEG  BEGINNING OF THE ROW SCHEME OF THE FACTOR U IN CNR.
*  IO  IENDLU  END OF THE ROW INDICES OF THE FACTOR U IN CNR.
*  IU  IC(MROWS) TYPES OF THE MATRIX ROWS:
*        =1 FOR LOWER BOUNDED ROW.
*        =2 FOR UPPER BOUNDED ROW.
*        =3 FOR LOWER AND UPPER BOUNDED ROW
*           WITH NON-EQUAL BOUNDS.
*        =5 FOR LOWER AND UPPER BOUNDED ROW
*           WITH EQUAL BOUNDS.
*  RU  CL(MROWS) LOWER BOUNDS ON MATRIX ROWS.
*  RU  CU(MROWS) UPPER BOUNDS ON MATRIX ROWS.
*  IU  IX(MCOLS) TYPES OF THE VARIABLES:
*        =1 FOR LOWER BOUNDED VARIABLE.
*        =2 FOR UPPER BOUNDED VARIABLE.
*        =3 FOR LOWER AND UPPER BOUNDED
*           VARIABLE.
*        =5 FOR FIXED VARIABLES.
*        =6 FOR FREE VARIABLES.
*  RU  XL(MCOLS) LOWER BOUNDS ON VARIABLES.
*  RU  XU(MCOLS) UPPER BOUNDS ON VARIABLES.
*  II  PINR(MROWS) VECTOR SHOWING BEGINNINGS OF THE INPUT MATRIX ROWS.
*  II  INR(NZ) INPUT MATRIX COLUMN INDICES.
*  IO  LENR(MROWS) LENGTHS OF THE MATRIX ROWS.
*  IO  IER  ERROR INDICATOR.
*
* COMMON DATA:
*
*
      SUBROUTINE UKLINI(MROWS,MCOLS,NZ,NZA,NEL,IBEG,IENDLU,IC,CL,CU,IX,
     & X,XL,XU,PINR,INR,LENR,IER)
      INTEGER MROWS,MCOLS,NZ,NZA,NEL,IBEG,IENDLU,IC(MROWS),IX(MCOLS),
     & PINR(MROWS),INR(NZ),LENR(MROWS),IER
      $FLOAT CL(MROWS),CU(MROWS),XL(MCOLS),XU(MCOLS),X(MCOLS)
      INTEGER I
      $FLOAT VALUE
C
C MATRIX STRUCTURE INITIAL DATA
C
      NEL=0
      IER=0
      DO 1 I=1,MROWS
      LENR(I)=0
      IC(I)=5
      CL(I)=0
      CU(I)=0
   1  CONTINUE
      DO 2 I=1,MCOLS
      IX(I)=1
      X(I)=0
      XL(I)=0
      XU(I)=0
   2  CONTINUE
      DO 3 I=1,NZA-1
      INR(I)=0
   3  CONTINUE
      INR(NZA)=1
      IENDLU=0
      IBEG=0
      VALUE=((NZA-1)/MROWS)*0.7
      PINR(1)=1
      DO 4 I=2,MROWS
      PINR(I)=PINR(I-1)+VALUE
   4  CONTINUE
      RETURN
      END
