$INTERFACE UKLNF4                                             00/12/01

  CALL UKLNF4(NF,NC,M,MROWS,MCOLS,NZA,$RNR,$PRNR,$A,$IC,$X,$CF)
  $ADD(REAL,'\$CF($MROWS)')
$REM  $ADD(INTEGER,'NF\NC\M\MROWS\MCOLS\NZA')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UKSGLM                 ALL SYSTEMS                00/12/01
C PORTABILITY : ALL SYSTEMS
C 00/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* FIRST PHASE DRIVER.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NF  NUMBER OF CONSTRAINTS.
*  II  M  NUMBER OF ROWS.
*  II  MROWS  DECLARED NUMBER OF ROWS.
*  II  MCOLS  DECLARED NUMBER OF COLUMNS.
*  II  NZA  SIZE OF ARRAYS A/RNR.
*  IO  RNR(NZA)  COLUMNS OF THE MATRIX OF CONSTRAINTS.
*  IO  PRNR(MCOLS+1)  POINTER VECTOR FOR RNR.
*  RO  A(NZA)  NUMERICAL VALUES OF THE MATRIX OF CONSTRAINTS.
*  II  TYPC(MROWS) TYPES OF THE MATRIX ROWS:
*                                     =1 FOR LOWER BOUNDED ROW.
*                                     =2 FOR UPPER BOUNDED ROW.
*                                     =3 FOR LOWER AND UPPER BOUNDED ROW
*                                        WITH NON-EQUAL BOUNDS.
*                                     =4 FOR LOWER AND UPPER BOUNDED ROW
*                                        WITH EQUAL BOUNDS.
*  RO  X(MCOLS)  VECTOR OF SOLUTION.
*  RO  CF(MROWS) VALUES OF THE CONSTRAINT FUNCTIONS.
*
      SUBROUTINE UKLNF4(NF,NC,M,MROWS,MCOLS,NZA,RNR,PRNR,A,TYPC,X,CF)
      INTEGER NF,NC,M,MROWS,MCOLS,NZA,RNR(NZA),PRNR(MCOLS+1),TYPC(NC)
      $FLOAT A(NZA),X(MCOLS),CF(MROWS)
      INTEGER I,J,K,ISTRT,ISTOP
C
C COMPUTE CONSTRAINT FUNCTIONS
C
      DO 700 I=1,M
        CF(I)=0.0D0
 700  CONTINUE
C
      DO 800 I=1,NF
        ISTRT=PRNR(I)
        ISTOP=PRNR(I+1)-1
        DO 900 J=ISTRT,ISTOP
          K=RNR(J)
          CF(K)=CF(K)+A(J)*X(I)
 900    CONTINUE
 800  CONTINUE
      DO 850 I=1,NC
      CF(I)=CF(TYPC(I))
 850  CONTINUE
      RETURN
      END
