* SUBROUTINE UKMFI1                 ALL SYSTEMS                99/06/01
C PORTABILITY : ALL SYSTEMS
C 99/06/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INPUT OF THE HESSIAN MATRIX ELEMENT H(I,J)
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  M  NUMBER OF ELEMENTS IN THE FIELD H.
*  IU  IH(NF+1) VECTOR POINTING DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  IU  JH(MA) HESSIAN COLUMN INDICES.
*  RU  AG(MA) HESSIAN MATRIX VALUES.
*  II  JOB  OPTION. JOB=0-NUMERICAL VALUE IS NOT INSERTED.
*  IO  IER  OUTPUT ERROR INFORMATION.
*  II  K  INPUT ROW INDEX.
*  II  J  INPUT COLUMN INDEX.
*  RI  VAL  INPUT NUMERICAL VALUE.
*
      SUBROUTINE UKMFI1(NF,M,IH,JH,H,JOB,IER,I,J,VAL)
      INTEGER NF,M,IH(NF+1),JH(M),JOB,IER,I,J
      $FLOAT H(M),VAL
      INTEGER K,L,II,JJ
      IER=0
      IF (I.LE.0.OR.I.GT.NF) IER=2
      IF (J.LE.0.OR.J.GT.NF) IER=3
      IF (IER.NE.0) RETURN
      II=MIN(I,J)
      JJ=MAX(I,J)
      L=IH(II+1)
      DO 1 K=IH(II),L-1
      IF (JH(K).EQ.JJ) THEN
      IF (JOB.NE.0) H(K)=VAL
      IER=1
      RETURN
      ELSE IF (JH(K).GT.JJ) THEN
      L=K
      GO TO 2
      ENDIF
    1 CONTINUE
    2 DO 3 K=IH(NF+1)-1,L,-1
      JH(K+1)=JH(K)
      IF (JOB.NE.0) H(K+1)=H(K)
    3 CONTINUE
      JH(L)=JJ
      IF (JOB.NE.0) H(L)=VAL
      DO 4 K=II+1,NF+1
      IH(K)=IH(K)+1
    4 CONTINUE
      RETURN
      END
