* SUBROUTINE UKMFI2                 ALL SYSTEMS                98/06/01
C PORTABILITY : ALL SYSTEMS
C 98/06/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  INPUT OF THE MATRIX ELEMENT A(I,J)
*
* PARAMETERS :
*  II  MROWS DECLARED NUMBER OF ROWS.
*  II  MCOLS DECLARED NUMBER OF COLUMNS.
*  II  NZ  SIZE OF ARRAYS INR/CNR.
*  II  NAU SIZE OF ARRAUS AI/AU.
*  IU  NEL NUMBER OF NONZEROS SO FAR INSERTED INTO THE STRUCTURE.
*  II  I  INPUT ROW INDEX.
*  II  J  INPUT COLUMN INDEX.
*  RI  AIJ  INPUT NUMERICAL VALUE.
*  IU  PINR(MROWS) VECTOR POINTING AT BEGINNINGS OF THE INPUT MATRIX ROWS
*  IU  INR(NZ) INPUT MATRIX COLUMN INDICES.
*  RU  AI(NAU) INPUT MATRIX VALUES.
*  IU  LENR(MROWS) LENGTHS OF THE INPUT MATRIX ROWS.
*  IU  IER  INFORMATION FLAG: =0 FOR SUCCESFUL WORK,=1 WHEN ELEMENT
*           IS STORED REPEATEDLY,=2 WHEN LACK OF SPACE IS FACED,
*           =3 WHEN SOME OTHER ERROR IS FACED.
*
* SUBROUTINES USED:
*  S   UKMCPR  GARBAGE COLLECTION
*
      SUBROUTINE UKMFI2(MROWS,MCOLS,NZ,NAU,NEL,I,J,AIJ,PINR,INR,AI,
     & LENR,IER)
      INTEGER MROWS,MCOLS,NZ,NAU,NEL,I,J,PINR(MROWS),INR(NZ),
     & LENR(MROWS),IER
      $FLOAT AIJ,AI(NAU)
      INTEGER KSTRT,KSTOP,L,K,J1,J2,J3,IQCMPR
C
C     NEL COUNTS INPUT NONZEROS
C
C     INITIALIZE IER
C
      IF(IER.GT.1) THEN
        RETURN
      END IF
C
C     ROW BEGINS AT KSTRT
C
      I=INT(I)
      IF(I.LE.0.OR.I.GE.MROWS) THEN
        IER=3
        RETURN
      ENDIF
      KSTRT=PINR(I)
      KSTOP=KSTRT+LENR(I)-1
      J=INT(J)
      IF(J.LE.0.OR.J.GE.MCOLS) THEN
        IER=3
        RETURN
      END IF
      DO 100 K=KSTRT,KSTOP
      L=INR(K)
      IF(L.EQ.J) THEN
        IER=1
        AI(K)=AIJ
        RETURN
      END IF
100   CONTINUE
C
C     TRY TO PLACE ELEMENT AT THE END
C
200   IF(INR(KSTOP+1).EQ.0) THEN
                            IQCMPR=0
                            KSTOP=KSTOP+1
                            INR(KSTOP)=J
                            AI(KSTOP)=AIJ
                            NEL=MAX(NEL,KSTOP)
                            LENR(I)=LENR(I)+1
                            ELSE
                            J1=KSTOP-KSTRT+1
          IF((NEL+J1).LT.MIN(NZ,NAU)) THEN
                                  DO 300 J2=1,J1
                                  J3=KSTRT+J2-1
                                  INR(J2+NEL)=INR(J3)
                                  AI(J2+NEL)=AI(J3)
                                  INR(J3)=0
300                               CONTINUE
                                  KSTRT=NEL+1
                                  PINR(I)=KSTRT
                                  KSTOP=NEL+J1
                                  GO TO 200
                                           ELSE
              IF(IQCMPR.EQ.1) THEN
                              IER=2
                              RETURN
              END IF
              IQCMPR=1
              CALL UKMCPR(MROWS,MCOLS,NZ,NAU,PINR,LENR,INR,AI,1,NEL+1)
              KSTRT=PINR(I)
              KSTOP=KSTRT+LENR(L)-1
              GO TO 200
          END IF
      END IF
      RETURN
      END
