* SUBROUTINE UKQGLT                 ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTING
*      WR01(1,...M-LINP)=INV*(-TRANS(S)*TRANS(B)**-1/I)*C(1,...,LINP).
*
* PARAMETERS :
*  II  M  NUMBER OF ROWS OF THE SPARSE MATRIX.
*  II  MROWS DECLARED NUMBER OF ROWS.
*  II  MCOLS DECLARED NUMBER OF VARIABLES.
*  II  NZ SIZE OF THE INDEX ARRAY CNR
*  II  NZA SIZE OF THE INDEX ARRAY RNR.
*  II  NAU SIZE OF THE ARRAY THAT STORES THE NUMERICAL ELEMENTS OF
*          THE PROCESSED MATRIX.
*  II  NUP  LENGTH OF THE ARRAYS LI,LJ,CM.
*  II  NEL  NUMBER OF TRIPLES IN ARRAYS (LI,LJ,CM).
*  II  PTL(MROWS) POINTER VECTOR OF THE COLUMNS OF THE L-FACTOR.
*  II  LENL(MROWS) LENGTHS OF THE COLUMNS OF THE FACTOR L.
*  II  CNR(NZ) CONTAINS THE INDICES OF THE FACTORS.
*  II  PTR(MROWS) POINTER VECTOR OF THE ROWS OF THE FACTOR U.
*  II  LENR(MROWS) LENGTHS OF THE ROWS OF THE FACTOR U.
*  II  RNR(NZA) COLUMNS OF THE ORIGINAL MATRIX A.
*  II  PRNR(MCOLS+1) INDEX VECTOR FOR THE ARRAY RNR.
*  II  ORDC(MROWS) COLUMN PERMUTATION.
*  II  ORDR(MROWS) ROW PERMUTATION.
*  II  ORDL(MROWS) ROW PERMUTATION OF THE ORIGINAL FACTOR L.
*  II  LI(NUP) ROW INDICES OF THE L-UPDATES.
*  II  LJ(NUP) COLUMN INDICES OF THE L-UPDATES.
*  RI  CM(NUP) UPDATE MULTIPLIERS.
*  RI  AU(NZ) NUMERICAL VALUES OF THE FACTORS.
*  RI  A(NZA) NUMERICAL VALUES OF THE MATRIX.
*  RU  WR01(MCOLS) WR01 = TRANS(Z)*C(BCOL(1..LINP)), WHERE Z IS THE
*        BASIS OF THE SPACE  ORTHOGONAL TO THE ONE FORMED BY THE ROWS
*        OF THE MATRIX A.
*  RA  WR02(MCOLS) AUXILIARY ARRAY.
*  II  BCOL(MCOLS) PERMUTATION ARRAY: FIRST M COMPONENTS FORM BASIS,
*              NEXT LINP-M FORM SUPERBASIS AND REST CORRESPOND TO
*              THE NON-BASIC VARIABLES.
*  RI  C(MCOLS) INPUT VECTOR.
*  II  INV  VARIABLE DETERMINING THE SIGN OF THE RESULT.
*  II  LINP NUMBER OF BASICS AND SUPERBASICS.
*
      SUBROUTINE UKQGLT(M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,PTL,LENL,
     & CNR,PTR,LENR,RNR,PRNR,ORDC,ORDR,ORDL,LI,LJ,CM,AU,A,WR01,WR02,
     & BCOL,C,INV,LINP)
      INTEGER M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,PTL(MROWS),
     & LENL(MROWS),CNR(NZ),PTR(MROWS),LENR(MROWS),RNR(NZA),
     & PRNR(MCOLS+1),ORDC(MROWS),ORDR(MROWS),ORDL(MROWS),LI(NUP),
     & LJ(NUP),BCOL(MCOLS),INV,LINP
      $FLOAT CM(NUP),AU(NAU),A(NZA),WR01(MCOLS),WR02(MCOLS),C(MCOLS)
      INTEGER I,JOB
C
C     FILL ARRAY WR01
C
      DO 50 I=1,LINP
      WR01(I)=C(I)
50    CONTINUE
C
C     BTRAN
C
      JOB=0
      CALL UXSGFT(M,NZ,NAU,NEL,NUP,PTL,LENL,CNR,PTR,LENR,ORDC,ORDR,
     *            ORDL,LI,LJ,CM,AU,WR01,WR02,JOB)
C
C     COMPUTE NEW REDUCED GRADIENT
C
C
C     FIRST: COMPUTE TRANS(S)*WR01(1,...,M)
C
      JOB=0
      CALL UXSGMT(M,LINP-M,NZA,RNR,PRNR,ORDR,BCOL(M+1),A,WR01,WR02,
     *            JOB)
C
C     COMPUTE WR01(1,..,M-LINP)=WR01(M+1,..,LINP)-WR02(1,...,LINP-M).
C     IT IS THE SAME AS WR01(1,..,M-LINP)=C(M+1,..,LINP)-
C                                             WR02(1,...,LINP-M).
C
      DO 100 I=M+1,LINP
      WR01(I-M)=INV*(WR01(I)-WR02(I-M))
100   CONTINUE
      RETURN
      END
