* SUBROUTINE UKSII4                 ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* INPUT OF NUMERICAL VALUE OF THE ELEMENT A(I,J) INTO THE MATRIX
* OF CONSTRAINTS - SEQUENTIAL REPLACING.
*
* PARAMETERS :
*  II  MCOLS DECLARED NUMBER OF COLUMNS.
*  II  NZA  SIZE OF ARRAYS RNR/A.
*  II  I  INPUT ROW INDEX.
*  II  J  INPUT COLUMN INDEX.
*  RI  AIJ  NUMERICAL VALUE.
*  IO  RNR(NZA) ROW INDICES OF CONSTRAINT MATRIX.
*  RO  A(NZA) NUMERICAL VALUES OF THE CONSTRAINT MATRIX
*             CORRESPONDING TO RNR.
*  IU  WN01(MCOLS) POINTERS AFTER THE REPLACED ELEMENTS OF RNR.
*  II  TYPC(MCOLS) POSITIONS OF THE ROWS IN THE TRANSFORMED SYSTEM.
*
      SUBROUTINE UKSII4(MCOLS,NZA,I,J,AIJ,RNR,A,WN01,TYPC)
      INTEGER MCOLS,NZA,I,J,RNR(NZA),WN01(MCOLS),TYPC(MCOLS)
      $FLOAT AIJ,A(NZA)
      INTEGER I1,K
C
      I1=TYPC(I)
      K=WN01(J)
      IF(I1.LT.0) THEN
        RNR(K)=I1
        A(K)=AIJ
        K=K+1
        A(K)=AIJ
        RNR(K)=I1+1
      ELSE
        RNR(K)=I1
        A(K)=AIJ
      ENDIF
      WN01(J)=K+1
      RETURN
      END
