* SUBROUTINE ULDIRA               ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE NEW VALUES OF THE APPROXIMATED FUNCTIONS.
*
* PARAMETERS :
*  II  NA  NUMBER OF DECLARED LINEAR APPROXIMATED FUNCTIONS.
*  II  NAD  NUMBER OF CURRENT LINEAR APPROXIMATED FUNCTIONS.
*  RU  AF(2*NA)  VECTOR CONTAINING VALUES OF THE APPROXIMATED FUNCTIONS.
*  RI  AFD(2*NA)  VECTOR CONTAINING INCREMENTS OF THE APPROXIMATED
*         FUNCTIONS.
*  II  IA(2*NA)  VECTOR CONTAINING TYPES OF APPROXIMATED FUNCTIONS.
*  RI  STEP  CURRENT STEPSIZE.
*  RI  XNORM  VALUE OF A LINEARIZED MINIMAX FUNCTION.
*  RI  SNORM  SLOPE OF A LINEARIZED MINIMAX FUNCTION DECREASE.
*
      SUBROUTINE ULDIRA(NA,NAD,AF,AFD,IA,STEP,XNORM,SNORM)
      INTEGER NA,NAD,IA(2*NA)
      $FLOAT AF(2*NA),AFD(2*NA),STEP,XNORM,SNORM
      INTEGER KA
      DO 1 KA=1,NAD
      IF (IA(KA).GT.0.AND.IA(KA).LE.10) THEN
      AF(KA)=AF(KA)+STEP*AFD(KA)
      ELSE IF (IA(KA).EQ.-1.OR.IA(KA).EQ.-3) THEN
      AF(KA)=AF(KA)-STEP*SNORM
      ELSE
      AF(KA)=AF(KA)+STEP*SNORM
      ENDIF
    1 CONTINUE
      XNORM=XNORM+STEP*SNORM
      RETURN
      END
