* SUBROUTINE ULDLAG               ALL SYSTEMS                06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR FOR DUAL QP METHOD IS DETERMINED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NA  NUMBER OF CURRENT LINEAR APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF LINEARIZED CONSTRAINTS.
*  II  IA(2*NA)  VECTOR CONTAINING TYPES OF DEVIATIONS.
*  II  IAA(NF+1)  VECTOR CONTAINING INDICES OF ACTIVE FUNCTIONS.
*  RO  AZ(NF+1)  OUTPUT VECTOR.
*  IA  KOLD  AUXILIARY VARIABLE.
*
      SUBROUTINE ULDLAG(NF,N,NA,NC,IA,IAA,AZ,KOLD)
      INTEGER NF,N,NA,NC,IA(2*NA),IAA(NF+1),KOLD
      $FLOAT AZ(NF+1)
      $FLOAT TEMP
      INTEGER NAA,J,L
      NAA=NF-N
      KOLD=0
      DO 1 J=1,NAA
      L=IAA(J)
      IF (L.GT.NC) THEN
      L=L-NC
      TEMP=1.0$P 0
      IF (IA(L).EQ.-2.OR.IA(L).EQ.-4) TEMP=-TEMP
      AZ(J)=TEMP
      KOLD=1
      ELSE
      AZ(J)=0.0$P 0
      ENDIF
    1 CONTINUE
      RETURN
      END
