* SUBROUTINE ULNEWA             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* TEST ON ACTIVITY OF A GIVEN LINEAR CONSTRAINT.
*
* PARAMETERS :
*  II  NA  NUMBER OF CURRENT LINEAR APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF CURRENT LINEAR CONSTRAINTS.
*  II  KA  INDEX OF A GIVEN APPROXIMATED FUNCTION.
*  RI  AF(2*NA)  VECTOR CONTAINING VALUES OF THE APPROXIMATED FUNCTIONS.
*  II  IA(2*NA)  VECTOR CONTAINING TYPES OF APPROXIMATED FUNCTIONS.
*  RI  EPS9  TOLERANCE FOR ACTIVE FUNCTIONS.
*  RI  XNORM  VALUE OF LINEARIZED MINIMAX FUNCTION.
*  IO  INEW  INDEX OF THE NEW ACTIVE FUNCTION.
*  IO  KNEW  SIGNUM OF THE NEW ACTIVE GRADIENT.
*
      SUBROUTINE ULNEWA(NA,NC,KA,AF,IA,EPS9,XNORM,INEW,KNEW)
      INTEGER NA,NC,KA,IA(2*NA),INEW,KNEW
      $FLOAT AF(2*NA),EPS9,XNORM
      $FLOAT TEMP
      IF (IA(KA).GT.0.AND.IA(KA).LE.10) THEN
      TEMP=EPS9*MAX(ABS(XNORM),1.0$P 0)
      IF (IA(KA).EQ.1.OR.IA(KA).EQ.3) THEN
      IF (AF(KA).LE.TEMP-XNORM) THEN
      IA(KA)=IA(KA)+10
      INEW=KA+NC
      KNEW=1
      ENDIF
      ELSE
      IF (AF(KA).GE.XNORM-TEMP) THEN
      IA(KA)=IA(KA)+10
      INEW=KA+NC
      KNEW=-1
      ENDIF
      ENDIF
      ENDIF
      RETURN
      END
