* SUBROUTINE ULNEWL             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* TEST ON ACTIVITY OF A GIVEN LINEAR CONSTRAINT.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  KC  INDEX OF A GIVEN CONSTRAINT.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  EPS9  TOLERANCE FOR ACTIVE CONSTRAINTS.
*  IO  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*
      SUBROUTINE ULNEWL(NC,KC,CF,IC,CL,CU,EPS9,INEW)
      INTEGER NC,KC,IC(NC),INEW
      $FLOAT CF(NC),CL(NC),CU(NC),EPS9
      $FLOAT TEMP
      IF (IC(KC).LT.-10) IC(KC)=-IC(KC)-10
      IF (IC(KC).LE.0) THEN
      ELSE IF (IC(KC).EQ.1) THEN
      TEMP=EPS9*MAX(ABS(CL(KC)),1.0$P 0)
      IF (CF(KC).GT.CL(KC)+TEMP) THEN
      ELSE IF (CF(KC).GE.CL(KC)-TEMP) THEN
      IC(KC)=11
      INEW=KC
      ELSE
      IC(KC)=-11
      ENDIF
      ELSE IF (IC(KC).EQ.2) THEN
      TEMP=EPS9*MAX(ABS(CU(KC)),1.0$P 0)
      IF (CF(KC).LT.CU(KC)-TEMP) THEN
      ELSE IF (CF(KC).LE.CU(KC)+TEMP) THEN
      IC(KC)=12
      INEW=KC
      ELSE
      IC(KC)=-12
      ENDIF
      ELSE IF (IC(KC).EQ.3.OR.IC(KC).EQ.4) THEN
      TEMP=EPS9*MAX(ABS(CL(KC)),1.0$P 0)
      IF (CF(KC).GT.CL(KC)+TEMP) THEN
      TEMP=EPS9*MAX(ABS(CU(KC)),1.0$P 0)
      IF (CF(KC).LT.CU(KC)-TEMP) THEN
      ELSE IF (CF(KC).LE.CU(KC)+TEMP) THEN
      IC(KC)=14
      INEW=KC
      ELSE
      IC(KC)=-14
      ENDIF
      ELSE IF (CF(KC).GE.CL(KC)-TEMP) THEN
      IC(KC)=13
      INEW=KC
      ELSE
      IC(KC)=-13
      ENDIF
      ELSE IF (IC(KC).EQ.5.OR.IC(KC).EQ.6) THEN
      TEMP=EPS9*MAX(ABS(CL(KC)),1.0$P 0)
      IF (CF(KC).GT.CL(KC)+TEMP) THEN
      TEMP=EPS9*MAX(ABS(CU(KC)),1.0$P 0)
      IF (CF(KC).LT.CU(KC)-TEMP) THEN
      ELSE IF (CF(KC).LE.CU(KC)+TEMP) THEN
      IC(KC)=16
      INEW=KC
      ELSE
      IC(KC)=-16
      ENDIF
      ELSE IF (CF(KC).GE.CL(KC)-TEMP) THEN
      IC(KC)=15
      INEW=KC
      ELSE
      IC(KC)=-15
      ENDIF
      ENDIF
      RETURN
      END
