* SUBROUTINE ULRMF0             ALL SYSTEMS                   06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* OPERATIONS AFTER CONSTRAINT DELETION.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NB  NUMBER OF DECLARED CONSTRAINTS OR APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  IXA(NF)  VECTOR CONTAINING INFORMATION ON TRUST REGION ACTIVITY.
*  II  IA(2*NA)  VECTOR CONTAINING TYPES OF DEVIATIONS.
*  II  IAA(NF+1)  VECTOR CONTAINING INDICES OF ACTIVE FUNCTIONS.
*  RI  AR((NF+1)*(NF+2)/2)  TRIANGULAR DECOMPOSITION OF KERNEL OF THE
*         ORTHOGONAL PROJECTION.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RA  S(NF+1)  AUXILIARY VECTOR.
*  II  LCS  VARIABLE WHICH SPECIFIES TRUST REGION BOUNDS.
*  II  IOLD  INDEX OF THE OLD ACTIVE CONSTRAINT.
*  IO  KREM  AUXILIARY VARIABLE.
*  IU  NREM NUMBER OF CONSTRAINT DELETION.
*  IO  IER  ERROR INDICATOR.
*
* SUBPROGRAMS USED :
*  S   ULRMR0  CORRECTION OF KERNEL OF THE ORTHOGONAL PROJECTION
*         AFTER CONSTRAINT DELETION.
*
      SUBROUTINE ULRMF0(NF,N,NA,NB,NC,IX,IXA,IA,IAA,AR,IC,S,LCS,IOLD,
     & KREM,NREM,IER)
      INTEGER NF,N,NA,NB,NC,IX(NF),IXA(NF),IA(*),IAA(*),IC(NB),
     & LCS,IOLD,KREM,NREM,IER
      $FLOAT AR(*),S(*)
      INTEGER L
      CALL ULRMR0(NF,N,IAA,AR,S,IOLD,KREM,IER)
      N=N+1
      NREM=NREM+1
      L=IAA(NF-N+1)
      IF (L.GT.NC) THEN
      L=L-NC
      IA(L)=-IA(L)
      ELSE IF (L.GT.0) THEN
      IC(L)=-IC(L)
      ELSE
      L=-L
      IX(L)=-IX(L)
      IF (LCS.GT.0) THEN
      IF (IXA(L).GE.0) THEN
      IX(L)=IXA(L)
      IXA(L)=-1
      ENDIF
      ENDIF
      ENDIF
      RETURN
      END


