* SUBROUTINE ULSETC             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF INITIAL VALUES OF THE CONSTRAINT FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CURRENT LINEAR CONSTRAINTS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  XO(NF)  SAVED VECTOR OF VARIABLES.
*  RI  CF(NF)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCYIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CG(NF*MCL)  MATRIX WHOSE COLUMNS ARE NORMALS OF THE LINEAR
*         CONSTRAINTS.
*  RA  S(NF)  AUXILIARY VECTOR.
*  II  ISNC  SAVING SPECIFICATION. ISNC=0-NO SAVING. ISNC=1-FUNCTION
*         VALUES ARE SAVED. ISNC=2-FUNCTION VALUES AND GRADIENTS ARE
*         SAVED.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   UXVDIF  DIFFERENCE OF TWO VECTORS.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*  S   UXVMUL  DIAGONAL PREMULTIPLICATION OF A VECTOR.
*
      SUBROUTINE ULSETC(NF,NC,X,XN,XO,CF,IC,CG,S,ISNC,NORMF)
      INTEGER NF,NC,IC(NC),ISNC,NORMF
      $FLOAT X(NF),XN(NF),XO(NF),CF(NC),CG(NF*NC),S(NF)
      $FLOAT UXVDOT
      INTEGER JCG,KC
      CALL UXVDIF(NF,X,XO,S)
      IF (NORMF.GT.0.AND.ISNC.GT.2) CALL UXVMUL(NF,XN,S,S,-1)
      JCG=0
      DO 1 KC=1,NC
      IF (IC(KC).NE.0) CF(KC)=CF(KC)+UXVDOT(NF,S,CG(JCG+1))
      JCG=JCG+NF
    1 CONTINUE
      RETURN
      END


