* SUBROUTINE UMSETG             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* GRADIENT DETERMINATION IN THE FIRST PHASE OF LP SUBROUTINE.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  MC  NUMBER OF ELEMENTS IN THE FIELD CG.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CG(MC)  SPARSE CONSTRAINT JACOBIAN MATRIX.
*  II  ICG(NC+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD CG.
*  II  JCG(MC) COLUMN INDICES OF ELEMENTS IN THE FIELD CG.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  IU  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*
* SUBPROGRAMS USED :
*  S   UXVSET  INITIATION OF A VECTOR.
*  S   UXWDIR  VECTOR AUGMENTED BY THE SCALED SPARSE VECTOR.
*
      SUBROUTINE UMSETG(NF,NC,MC,IC,CG,ICG,JCG,G,INEW)
      INTEGER NF,NC,MC,IC(NC),ICG(NC+1),JCG(MC),INEW
      $FLOAT CG(MC),G(NF)
      INTEGER K,L,KC
      CALL UXVSET(NF,0.0$P 0,G)
      INEW=0
      DO 4 KC=1,NC
      K=ICG(KC)
      L=ICG(KC+1)-K
      IF (IC(KC).GE.-10) THEN
      ELSE IF (IC(KC).EQ.-11.OR.IC(KC).EQ.-13.OR.IC(KC).EQ.-15) THEN
      CALL UXWDIR(L,NF,JCG(K),-1.0$P 0,CG(K),G,G,1)
      INEW=1
      ELSE IF (IC(KC).EQ.-12.OR.IC(KC).EQ.-14.OR.IC(KC).EQ.-16) THEN
      CALL UXWDIR(L,NF,JCG(K), 1.0$P 0,CG(K),G,G,1)
      INEW=1
      ENDIF
    4 CONTINUE
      RETURN
      END


