* SUBROUTINE UNCUR2                ALL SYSTEMS                15/12/01
C PORTABILITY : ALL SYSTEMS
C 15/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* ROOTS OF A QUADRATIC EQUATION.
*
* PARAMETERS :
*  RI  A0  COEFFICIENT OF THE QUADRATI EQUATION.
*  RI  A1  COEFFICIENT OF THE QUADRATI EQUATION.
*  RI  A2  COEFFICIENT OF THE QUADRATI EQUATION.
*  RO  X  THE POSITIVE ROOT.
*  IO  INF  THE CASE INDICATOR. INF=0-POSITIVE ROOT WAS COMPUTED.
*         INF=-1-COEFFICIENT A0 IS NONNEGATIVE, INF=-2-COEFFICIENT
*         A2 IS NONPOSITIVE. 
*
      SUBROUTINE UNCUR2(A0,A1,A2,X,INF)
      REAL*8 A0,A1,A2,X
      INTEGER INF
      REAL*8 D
      REAL*8 ZERO,TWO,FOUR
      PARAMETER (ZERO=0.0$P 0,TWO=2.0$P 0,FOUR=4.0$P 0)
      INF=0
      IF (A0.GE.ZERO) THEN
      INF=-1
      RETURN 
      ELSE IF (A2.LE.ZERO) THEN
      INF=-2
      RETURN
      ENDIF
      D=A1*A1-FOUR*A0*A2
      X=-(A1-SQRT(D))/TWO*A2
      RETURN
      END   
        
     