* SUBROUTINE UNMINK                ALL SYSTEMS                 02/04/05
C PORTABILITY : ALL SYSTEMS
C 02/04/05 VL : ORIGINAL VERSION
*
* PURPOSE :
* QUADRATIC INTERPOLATION IN A BOUNDED INTERVAL.
*
* PARAMETERS :
*  RI  F1  FUNCTION VALUE.
*  RI  F2  FUNCTION VALUE.
*  RI  F3  FUNCTION VALUE.
*  RI  F4  FUNCTION VALUE.
*  RI  H  STEPSIZE.
*  RI  X1  POINT IN THE INTERVAL [XL,XP].
*  RI  XL  LEFT  POINT OF THE INTERVAL [XL,XP].
*  RI  XP  RIHGT POINT OF THE INTERVAL [XL,XP].
*  RO  XMIN  POINT WITH MINIMUM FUNCTION  VALUE.
*
* SUBPROGRAMS USED :
*
* S   UNMINK
*
      SUBROUTINE UNMINK(F1,F2,F3,F4,H,X1,XL,XP,XMIN)
      $FLOAT F1,F2,F3,F4,H,XL,XMIN,XP,X1,  A,B,C,D
C
C     Bod minima v [XL,XP] pol.2.|3.st. na [X1,X3|X4]->[-H,H|2*H]
C     (rovn.deleni X)
C
      IF(H.GT.0.0$P 0)GOTO1
      IF(F1-F2-F2+F3.LE.0.0$P 0)GOTO3
      XMIN=X1-H-H*0.5$P 0*(F1-F3)/(F1-F2-F2+F3)
      GOTO2
   1  A=(F4-F1-3.0$P 0*(F3-F2))/6.0$P 0
      B=(F1+F3)*0.5$P 0-F2
      C=F3-(F1+F1+F2+F2+F2+F4)/6.0$P 0
      D=B*B-3.0$P 0*A*C
      IF(D.LE.0.0$P 0.OR.(A.EQ.0.0$P 0.AND.B.LE.0.0$P 0))GOTO3
      IF(B.LE.0.0$P 0)XMIN=(-B+SQRT(D))/(3.0$P 0*A)
      IF(B.GT.0.0$P 0)XMIN=-C/(B+SQRT(D))
      D=((A*XMIN+B)*XMIN+C)*XMIN+F2
      IF(D.GT.MIN(F1,F4))GOTO3
      XMIN=X1+H+H*XMIN
   2  XMIN=MIN(MAX(XMIN,XL),XP)
      RETURN
   3  XMIN=X1+ABS(5.0$P 0*H+ABS(H))*0.5$P 0
      IF((F3-SIGN(F3,H))+(F4+SIGN(F4,H)).GE.F1+F1)XMIN=X1
      RETURN
      END
