* FUNCTION UNRAN2                ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  RANDOM NUMBER GENERATOR. RETURNS A UNIFORM DEVIATE BETWEEN 0.0
*  AND 1.0.
*
* PARAMETERS :
*  IU  IDUM  SET IDUM TO ANY NEGATIVE VALUE TO INITIALIZE OR
*            REINITIALIZE THE SEQUANCE.
*
* METHOD :
*  NUMERICAL RECEPIES (P.196-197).
*
      FUNCTION UNRAN2(IDUM)
      REAL*4 UNRAN2
      INTEGER IDUM
      INTEGER M1,M2,M3,IA1,IA2,IA3,IC1,IC2,IC3
      REAL*4 RM1,RM2
      PARAMETER (M1=259200,IA1=7141,IC1=54773,RM1=3.8580247E-6)
      PARAMETER (M2=134456,IA2=8121,IC2=28411,RM2=7.4373773E-6)
      PARAMETER (M3=243000,IA3=4561,IC3=51349)
      REAL*4 R(97)
      INTEGER IFF,J,IX1,IX2,IX3
      SAVE R,IFF,IX1,IX2,IX3
      DATA IFF /0/
C
C INITIALIZE ON FIRST CALL
C
      IF (IDUM.LT.0.OR.IFF.EQ.0) THEN
        IFF=1
C
C SEED THE FIRST ROUTINE
C
        IX1=MOD(IC1-IDUM,M1)
        IX1=MOD(IA1*IX1+IC1,M1)
C
C AND USE IT TO SEED THE SECOND
C
        IX2=MOD(IX1,M2)
        IX1=MOD(IA1*IX1+IC1,M1)
C
C AND THIRD ROUTINES.
C
        IX3=MOD(IX1,M3)
C
C FILL THE TABLE WITH SEQUENTIAL UNIFORM DEVIATES GENERATED BY
C THE FIRST TWO ROUTINES.
C
        DO 10 J=1,97
          IX1=MOD(IA1*IX1+IC1,M1)
          IX2=MOD(IA2*IX2+IC2,M2)
          R(J)=($DBLE(IX1)+$DBLE(IX2)*RM2)*RM1
   10   CONTINUE
        IDUM=1
      ENDIF
C
C GENERATE THE NEXT NUMBER FOR EACH SEQUANCE.
C
      IX1=MOD(IA1*IX1+IC1,M1)
      IX2=MOD(IA2*IX2+IC2,M2)
      IX3=MOD(IA3*IX3+IC3,M3)
C
C USE THE THIRD SEQUANCE TO GET AN INTEGER BETWEEN 1 AND 97.
C
      J=1+(97*IX3)/M3
      IF(J.GT.97.OR.J.LT.1) STOP
C
C RETURN THE TABLE ENTRY
C
      UNRAN2=R(J)
C
C AND REFILL IT
C
      R(J)=($DBLE(IX1)+$DBLE(IX2)*RM2)*RM1
      RETURN
      END
