* SUBROUTINE UNVDP8                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INTERPOLATION IN MESH POINTS FOR THE SUBROUTINE UEVRK2.
*
* PARAMETERS :
*  II  NA  NUMBER OF MESH POINTS.
*  II  NAL  NUMBER OF MESH POINTS.
*  II  NE  DECLARED NUMBER OF EQUATIONS.
*  II  MEL  ACTUAL NUMBER OF EQUATIONS.
*  IU  KA  INDEX OF THE MESH POINT.
*  RI  AT(NA)  MESH POINTS.
*  RO  AY(NA*NE)  FIELD OF SOLUTION VECTORS IN THE MESH POINTS.
*  RA  ES(8*MEL)  AUXILIARY VECTOR.
*  RU  TA  VALUE OF THE INTEGRATION PARAMETER.
*  RU  TAO  OLD VALUE OF THE INTEGRATION PARAMETER.
*  RU  HE  ACTUAL STEPSIZE.
*  IO  IER  ERROR INDICATOR.
*  JOB  II  TYPE OF OUTPUT.
*
* COMMON DATA :
*  II  MEL  ACTUAL NUMBER OF EQUATIONS.
*  II  NA  NUMBER OF MESH POINTS.
*  IU  KA  INDEX OF THE MESH POINT.
*  RU  TA  VALUE OF THE INTEGRATION PARAMETER.
*  RU  TAO  OLD VALUE OF THE INTEGRATION PARAMETER.
*  IER  IO  ERROR INDICATOR.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*
      SUBROUTINE UNVDP8(NA,NAL,NE,MEL,KA,AT,AY,ES,TA,TAO,HE,IER,JOB)
      $INCLUDE('UMCOMM')
      INTEGER NA,NAL,NE,MEL,KA,IER,JOB
      $FLOAT AT(*),AY(*),ES(*),TA,TAO,HE
      INTEGER NE1,NE2,NE3,NE4,NE5,NE6,NE7,I,K
      SAVE NE1,NE2,NE3,NE4,NE5,NE6,NE7
      $FLOAT S,S1,CONPAR
      IF (JOB.EQ.-2) THEN
        NE1=MEL
        NE2=2*MEL
        NE3=3*MEL
        NE4=4*MEL
        NE5=5*MEL
        NE6=6*MEL
        NE7=7*MEL
      ELSE IF (JOB.EQ.1) THEN
        K=(KA-1)*NE
        IF (KA.LE.NAL) THEN
          AT(KA)=TA
          CALL UXVCOP(NE,ES,AY(K+1))
        ELSE
          IER=-11
          TEDX='LACK SP.'
          RETURN
        END IF
        KA=KA+1
      ELSE IF (JOB.EQ.2) THEN
 10     CONTINUE
        K=(KA-1)*NE
        IF (KA.LE.NA) THEN
        IF (HE*(TA-AT(KA)).GE.ZERO) THEN
          S=(AT(KA)-TAO)/HE
          S1=ONE-S
          DO 20 I=1,NE
          CONPAR=ES(NE4+I)+S*(ES(NE5+I)+S1*(ES(NE6+I)+S*ES(NE7+I)))
          AY(I+K)=ES(I)+S*(ES(NE1+I)+S1*(ES(NE2+I)+S*(ES(NE3+I)+
     &            S1*CONPAR)))
 20       CONTINUE
          KA=KA+1
          GO TO 10
        END IF
        END IF
      ELSE IF (JOB.EQ.3) THEN
        K=(KA-1)*NE
        CALL UXVCOP(NE,ES,AY(K+1))
      END IF
      RETURN
      END
