$INTERFACE UO1FD2                                             97/12/01

 CALL UO1FD2(NF,NA,NAL,MAL,NC,NCL,MCL,NE,$X,$XL,$XU,$IX,$PARA,$AM&
,$PARC,$CL,$CU,$IC,$AT,EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7&
,EPS8,EPS9,ETA0,ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,ALF1,ALF2&
,ALF3,BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,F,FMIN,FMAX,DMAX&
,GMAX,XMAX,XDEL,RPF1,RPF2,RPF3,RPF4,RPF5,MET,MET1,MET2,MET3,MET4,MET5&
,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1&
,MOS2,MOS3,MOS4,MOS5,MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3&
,MEP4,MEP5,MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5&
,MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,KSF,KCF,KSA&
,KCA,KSC,KCC,KTERS,INITD,INITS,INITH,IREM,IADD,MRED,IRES1,IRES2)
$EXIT

* IMPLEMENTATION

* SUBROUTINE UO1FD2                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  STANDARD LINE SEARCH WITH DIRECTIONAL DERIVATIVES.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RO  AF(NA)  VECTOR CONTAINING EITHER VALUES OF APPROXIMATED
*         FUNCTIONS OR COMPUTED SOLUTIONS OF DIFFERENTIAL EQUATIONS.
*  RI  AM(NA)  VECTOR CONTAINING REQUIRED VALUES OF APPROXIMATED
*         FUNCTIONS.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  AT(NA)  VECTOR CONTAINING MESH POINTS.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS.
*  II  KBA  SPECIFICATION OF DEVIATIONS.
*  II  KBC  SPECIFICATION OF GENERAL CONSTRAINTS.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
      SUBROUTINE UO1FD2(NF,NA,NAL,MAL,NC,NCL,MCL,NE,X,XL,XU,IX,AF,AM,
     & CF,CL,CU,IC,AT,EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,
     & EPS8,EPS9,ETA0,ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,
     & ALF1,ALF2,ALF3,BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,
     & F,FMIN,FMAX,DMAX,GMAX,XMAX,XDEL,RPF1,RPF2,RPF3,RPF4,RPF5,
     & MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
     & MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
     & MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
     & MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
     & KSF,KCF,KSA,KCA,KSC,KCC,KTERS,INITD,INITS,INITH,IREM,IADD,
     & MRED,IRES1,IRES2)
      $INCLUDE('UMCOMM')
      INTEGER NF,NA,NAL,MAL,NC,NCL,MCL,NE,IX(NF),IC(NC),
     & MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
     & MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
     & MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
     & MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
     & KSF,KCF,KSA,KCA,KSC,KCC,KTERS,INITD,INITS,INITH,IREM,IADD,
     & MRED,IRES1,IRES2
      $FLOAT X(NF),XL(NF),XU(NF),AF(*),AM(NA),CF(NC),CL(NC),CU(NC),
     & AT(NA),EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,ETA0,
     & ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,ALF1,ALF2,ALF3,
     & BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,F,FMIN,FMAX,DMAX,
     & GMAX,XMAX,XDEL,RPF1,RPF2,RPF3,RPF4,RPF5
      INTEGER I,K,USEK,POSUN,POCET,IND,NAVRAT,KA,KC,KE
      INTEGER*2 VYSL,TYP
      CHARACTER*65 TEXT
      IF (TSS(NS).NE.'UOXX') CALL UYPRO1('UOXX',-1)
      GO TO (1,700) ISP(NS)
    1 CONTINUE
      IF (ABS(MOUT).GE.2) PAUSE
      DO 2 I=1,65
      TEXT(I:I)=' '
    2 CONTINUE
      IF (NF.GT.0) TEXT(1:11)='Variables  '
      IF (NA.GT.0) TEXT(12:19)='Approx  '
      IF (NC.GT.0) TEXT(20:27)='Constr  '
      TEXT(28:32)='Fun  '
      TEXT(33:38)='Data  '
      TEXT(39:47)='Options  '
      TEXT(48:54)='paraM  '
      TEXT(55:59)='    '
      TEXT(60:65)='Quit :'
      NAVRAT=0
      POCET=21
      TYP=4
      K=0
      USEK=0
C
C psani tabulky
C
    3 CONTINUE
      IF (NAVRAT.EQ.1) GO TO 700
      IF (TYP.EQ.1) GOTO 100
      IF (TYP.EQ.3) GOTO 300
      IF (TYP.EQ.4) GOTO 400
      IF (NE.LE.0) GOTO 200
    4 WRITE (ITR,5)
    5 FORMAT ('+','VAR=')
      READ(*,'(I3)',ERR=4) KE
      IF (NF.LE.0.OR.KBA.LE.0) GOTO 700
      CALL UYSET0(1,2)
      RETURN
C
C variables
C
  100 IF (USEK.LT.0) USEK=0
      IF (USEK*POCET.GE.NF) USEK=USEK-1
      POSUN=USEK*POCET
      TEXT(1:11)='variables  '
      IF (NF.GT.POCET) TEXT(48:59)='Prev  Next  '
      IF (KBF.LE.0) THEN
      WRITE (ITR,101)
  101 FORMAT (' ',5X,'I',9X,'X(I)')
      ELSE
      WRITE (ITR,102)
  102 FORMAT (' ',5X,'I',9X,'X(I)',12X,'XL(I)',12X,'XU(I)')
      ENDIF
      DO 108 I=1,POCET
      IND=I+POSUN
      IF (IND.LE.NF) THEN
      IF (KBF.LE.0) THEN
      WRITE (ITR,103) IND,X(IND)
  103 FORMAT (' ',1X,I5,3X,D14.7)
      ELSE IF (IX(IND).EQ.0) THEN
      WRITE (ITR,103) IND,X(IND)
      ELSE IF (ABS(IX(IND)).EQ.1) THEN
      WRITE (ITR,104) IND,X(IND),XL(IND)
  104 FORMAT (' ',1X,I5,3X,D14.7,3X,D14.7)
      ELSE IF (ABS(IX(IND)).EQ.2) THEN
      WRITE (ITR,105) IND,X(IND),XU(IND)
  105 FORMAT (' ',1X,I5,3X,D14.7,20X,D14.7)
      ELSE IF (ABS(IX(IND)).EQ.3.OR.ABS(IX(IND)).EQ.4) THEN
      WRITE (ITR,106) IND,X(IND),XL(IND),XU(IND)
  106 FORMAT (' ',1X,I5,3X,D14.7,3X,D14.7,3X,D14.7)
      ELSE IF (ABS(IX(IND)).EQ.5) THEN
      WRITE (ITR,107) IND,X(IND)
  107 FORMAT (' ',1X,I5,3X,D14.7,17X,'fixed')
      ENDIF
      ELSE
      WRITE (ITR,'('' '')')
      ENDIF
  108 CONTINUE
  109 CALL MDREAD(VYSL,TYP,USEK,TEXT)
      IF (TYP.EQ.2.AND.NA.LE.0) VYSL=0
      IF (TYP.EQ.3.AND.NC.LE.0) VYSL=0
      IF (VYSL.EQ.0.OR.TYP.EQ.1) THEN
      GOTO 109
      ENDIF
      TEXT(1:11)='Variables  '
      TEXT(48:54)='paraM  '
      TEXT(55:59)='    '
C
      IF ((TYP.EQ.7).OR.(TYP.EQ.8)) GOTO 100
      USEK=0
      IF (TYP.EQ.9) GOTO 500
      IF (TYP.EQ.10) GOTO 600
      IF (TYP.EQ.11) GOTO 900
      IF (TYP.EQ.6) GOTO 800
      GOTO 3
C
C approximation
C
  200 IF (USEK.LT.0) USEK=0
      IF (USEK*POCET.GE.NA) USEK=USEK-1
      POSUN=USEK*POCET
      TEXT(12:19)='approx  '
      IF (NA.GT.POCET) TEXT(48:59)='Prev  Next  '
      IF (KBA.LE.0) THEN
      WRITE (ITR,201)
  201 FORMAT (' ',5X,'KA',10X,'AF(KA)')
      ELSE
      WRITE (ITR,202)
  202 FORMAT (' ',5X,'KA',8X,'AF(KA)',11X,'AM(KA)',7X,'AF(KA)-AM(KA)')
      ENDIF
      DO 208 KA=1,POCET
      IND=KA+POSUN
      IF (IND.LE.NA) THEN
      IF (KBA.LE.0) THEN
      WRITE (ITR,203) IND,AF(IND)
  203 FORMAT (' ',2X,I5,3X,D14.7)
      ELSE
      WRITE (ITR,204) IND,AF(IND),AM(IND),AF(IND)-AM(IND)
  204 FORMAT (' ',2X,I5,3X,D14.7,3X,D14.7,3X,D14.7)
      ENDIF
      ELSE
      WRITE (ITR,'('' '')')
      ENDIF
  208 CONTINUE
  209 CALL MDREAD(VYSL,TYP,USEK,TEXT)
      IF (TYP.EQ.1.AND.NF.LE.0) VYSL=0
      IF (TYP.EQ.3.AND.NC.LE.0) VYSL=0
      IF (VYSL.EQ.0.OR.TYP.EQ.2) THEN
      GOTO  209
      ENDIF
      TEXT(12:19)='Approx  '
      TEXT(48:54)='paraM  '
      TEXT(55:59)='    '
C
      IF ((TYP.EQ.7).OR.(TYP.EQ.8)) GOTO 200
      USEK=0
      IF (TYP.EQ.9) GOTO 500
      IF (TYP.EQ.10) GOTO 600
      IF (TYP.EQ.11) GOTO 900
      IF (TYP.EQ.6) GOTO 800
      GOTO 3
C
C constraints
C
  300 IF (USEK.LT.0) USEK=0
      IF (USEK*POCET.GE.NC) USEK=USEK-1
      POSUN=USEK*POCET
      TEXT(20:27)='constr  '
      IF (NC.GT.POCET) TEXT(48:59)='Prev  Next  '
      IF (KBC.LE.0) THEN
      WRITE (ITR,301)
  301 FORMAT (' ',4X,'KC',8X,'CF(KC)')
      ELSE
      WRITE (ITR,302)
  302 FORMAT (' ',4X,'KC',8X,'CF(KC)',11X,'CL(KC)',11X,'CU(KC)')
      ENDIF
      DO 308 KC=1,POCET
      IND=KC+POSUN
      IF (IND.LE.NC) THEN
      IF (KBC.LE.0) THEN
      WRITE (ITR,303) IND,CF(IND)
  303 FORMAT (' ',1X,I5,3X,D14.7)
      ELSE IF (IC(IND).EQ.0) THEN
      WRITE (ITR,303) IND,CF(IND)
      ELSE IF (ABS(IC(IND)).EQ.1.OR.ABS(IC(IND)).EQ.5) THEN
      WRITE (ITR,304) IND,CF(IND),CL(IND)
  304 FORMAT (' ',1X,I5,3X,D14.7,3X,D14.7)
      ELSE IF (ABS(IC(IND)).EQ.2) THEN
      WRITE (ITR,305) IND,CF(IND),CU(IND)
  305 FORMAT (' ',1X,I5,3X,D14.7,20X,D14.7)
      ELSE IF (ABS(IC(IND)).EQ.3.OR.ABS(IC(IND)).EQ.4) THEN
      WRITE (ITR,306) IND,CF(IND),CL(IND),CU(IND)
  306 FORMAT (' ',1X,I5,3X,D14.7,3X,D14.7,3X,D14.7)
      ENDIF
      ELSE
      WRITE (ITR,'('' '')')
      ENDIF
  308 CONTINUE
  309 CALL MDREAD(VYSL,TYP,USEK,TEXT)
      IF (TYP.EQ.1.AND.NF.LE.0) VYSL=0
      IF (TYP.EQ.2.AND.NA.LE.0) VYSL=0
      IF (VYSL.EQ.0.OR.TYP.EQ.3) THEN
      GOTO 309
      ENDIF
      TEXT(20:27)='Constr  '
      TEXT(48:54)='paraM  '
      TEXT(55:59)='    '
C
      IF ((TYP.EQ.7).OR.(TYP.EQ.8)) GOTO 300
      USEK=0
      IF (TYP.EQ.9) GOTO 500
      IF (TYP.EQ.10) GOTO 600
      IF (TYP.EQ.11) GOTO 900
      IF (TYP.EQ.6) GOTO 800
      GOTO 3
C
C function
C
  400 IF (K.EQ.1) THEN
      ELSE
      K=1
      ENDIF
      TEXT(28:32)='fun  '
C
      CALL UODSD3(F,DMAX,GMAX)
      WRITE ( ITR, 9) ITERM, TXFU
    9 FORMAT (/ ' ','ITERM =',I3,5X,A8)
      CALL MWRITE(14)
C
  409 CALL MDREAD(VYSL,TYP,USEK,TEXT)
      IF (TYP.EQ.1.AND.NF.LE.0) VYSL=0
      IF (TYP.EQ.2.AND.NA.LE.0) VYSL=0
      IF (TYP.EQ.3.AND.NC.LE.0) VYSL=0
      IF (VYSL.EQ.0.OR.TYP.EQ.4.OR.TYP.EQ.7.OR.TYP.EQ.8) THEN
      GOTO 409
      ENDIF
      TEXT(28:32)='Fun  '
C
      IF (TYP.EQ.9) GOTO 500
      IF (TYP.EQ.10) GOTO 600
      IF (TYP.EQ.11) GOTO 900
      IF (TYP.EQ.6) GOTO 800
      GOTO 3
C
C data
C
  500 CONTINUE
      TEXT(33:38)='data  '
C
      CALL UODSD1(NF,NA,NAL,MAL,NC,NCL,MCL,KSF,KCF,KSA,KCA,KSC,KCC)
      CALL MWRITE(13)
C
  509 CALL MDREAD(VYSL,TYP,USEK,TEXT)
      IF (TYP.EQ.1.AND.NF.LE.0) VYSL=0
      IF (TYP.EQ.2.AND.NA.LE.0) VYSL=0
      IF (TYP.EQ.3.AND.NC.LE.0) VYSL=0
      IF (VYSL.EQ.0.OR.TYP.EQ.9.OR.TYP.EQ.7.OR.TYP.EQ.8) THEN
      GOTO 509
      ENDIF
      TEXT(33:38)='Data  '
C
      IF (TYP.EQ.10) GOTO 600
      IF (TYP.EQ.11) GOTO 900
      IF (TYP.EQ.6) GOTO 800
      GOTO 3
C
C options
C
  600 CONTINUE
      TEXT(39:47)='options  '
C
      CALL UODSD2(XDEL,XMAX,FMIN,FMAX,RPF1,RPF2,RPF3,RPF4,RPF5,
     & EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,
     & ETA0,ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,
     & ALF1,ALF2,ALF3,BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,
     & MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
     & MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
     & MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
     & MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
     & KTERS,INITD,INITS,INITH,IREM,IADD,MRED,IRES1,IRES2,1)
      WRITE (ITR,'('' '')')
      WRITE (ITR,'('' '')')
      WRITE (ITR,'('' '')')
      WRITE (ITR,'('' '')')
      WRITE (ITR,'('' '')')
      WRITE (ITR,'('' '')')
C
  609 CALL MDREAD(VYSL,TYP,USEK,TEXT)
      IF (TYP.EQ.1.AND.NF.LE.0) VYSL=0
      IF (TYP.EQ.2.AND.NA.LE.0) VYSL=0
      IF (TYP.EQ.3.AND.NC.LE.0) VYSL=0
      IF (VYSL.EQ.0.OR.TYP.EQ.10.OR.TYP.EQ.7.OR.TYP.EQ.8) THEN
      GOTO 609
      ENDIF
      TEXT(39:47)='Options  '
C
      IF (TYP.EQ.9) GOTO 500
      IF (TYP.EQ.11) GOTO 900
      IF (TYP.EQ.6) GOTO 800
      GOTO 3
C
C parameters
C
  900 CONTINUE
      TEXT(48:54)='param  '
C
      CALL UODSD2(XDEL,XMAX,FMIN,FMAX,RPF1,RPF2,RPF3,RPF4,RPF5,
     & EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,
     & ETA0,ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,
     & ALF1,ALF2,ALF3,BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,
     & MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
     & MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
     & MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
     & MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
     & KTERS,INITD,INITS,INITH,IREM,IADD,MRED,IRES1,IRES2,2)
      WRITE (ITR,'('' '')')
      WRITE (ITR,'('' '')')
      WRITE (ITR,'('' '')')
      WRITE (ITR,'('' '')')
      WRITE (ITR,'('' '')')
      WRITE (ITR,'('' '')')
      WRITE (ITR,'('' '')')
      WRITE (ITR,'('' '')')
      WRITE (ITR,'('' '')')
      WRITE (ITR,'('' '')')
C
  909 CALL MDREAD(VYSL,TYP,USEK,TEXT)
      IF (TYP.EQ.1.AND.NF.LE.0) VYSL=0
      IF (TYP.EQ.2.AND.NA.LE.0) VYSL=0
      IF (TYP.EQ.3.AND.NC.LE.0) VYSL=0
      IF (VYSL.EQ.0.OR.TYP.EQ.11.OR.TYP.EQ.7.OR.TYP.EQ.8) THEN
      GOTO 909
      ENDIF
      TEXT(48:54)='paraM  '
C
      IF (TYP.EQ.9) GOTO 500
      IF (TYP.EQ.10) GOTO 600
      IF (TYP.EQ.6) GOTO 800
      GOTO 3
C
C differential equations
C
  700 IF (USEK.LT.0) USEK=0
      IF (USEK*POCET.GE.NA) USEK=USEK-1
      POSUN=USEK*POCET
      TEXT(12:19)='approx  '
      IF (NA.GT.POCET) TEXT(48:59)='Prev  Next  '
      IF (KBA.LE.0) THEN
      WRITE (ITR,701)
  701 FORMAT (' ',6X,'AT(KA)',11X,'AY(KA)')
      ELSE
      WRITE (ITR,702)
  702 FORMAT (' ',6X,'AT(KA)',11X,'AF(KA)',11X,'AM(KA)',7X,
     & 'AY(KA)-AM(KA)')
      ENDIF
      DO 708 KA=1,POCET
      IND=KA+POSUN
      IF (IND.LE.NA) THEN
      IF (KBA.LE.0) THEN
      WRITE (ITR,703) AT(IND),AF((IND-1)*NE+KE)
  703 FORMAT (' ',1X,D14.7,3X,D14.7)
      ELSE
      WRITE (ITR,704) AT(IND),AF((IND-1)*NE+KE),AM(IND),
     & AF((IND-1)*NE+KE)-AM(IND)
  704 FORMAT (' ',1X,D14.7,3X,D14.7,3X,D14.7,3X,D14.7)
      ENDIF
      ELSE
      WRITE (ITR,'('' '')')
      ENDIF
  708 CONTINUE
      NAVRAT=0
  709 CALL MDREAD(VYSL,TYP,USEK,TEXT)
      IF (TYP.EQ.1.AND.NF.LE.0) VYSL=0
      IF (TYP.EQ.3.AND.NC.LE.0) VYSL=0
      IF (VYSL.EQ.0) THEN
      GOTO 709
      ENDIF
      TEXT(12:19)='Approx  '
C
      IF ((TYP.EQ.7).OR.(TYP.EQ.8)) GOTO 700
      USEK=0
      IF (TYP.EQ.9) GOTO 500
      IF (TYP.EQ.10) GOTO 600
      IF (TYP.EQ.11) GOTO 900
      IF (TYP.EQ.6) GOTO 800
      GOTO 3
C
  800 CONTINUE
      CALL UYEPI1(-1)
      RETURN
      END
C
      SUBROUTINE MDREAD(VYSL,TYP,USEK,TEXT)
C     VYSL=0 pro ENTER nebo v retezci neuvedeny znak
C     TYP=1 variables
C     TYP=2 approximations
C     TYP=3 constraints
C     TYP=4 function
C     TYP=6 ukonceni
C     TYP=7 postup vpred,tj dalsi usek
C     TYP=8 postup vzad, tj predchozi usek
C     TYP=9 data
C     TYP=10 options
C     TYP=11 parameters
      CHARACTER*1 CHAR
      CHARACTER*65 TEXT
      INTEGER USEK
      INTEGER*2 VYSL,TYP
      WRITE (*,10) TEXT
   10 FORMAT(/ ' ',A65)
   11 FORMAT (A1)
      READ (*,11) CHAR
C      VYSL=SCAN('VvAaCcPpNnQqFfDdOo',CHAR)
      VYSL=0
      IF (CHAR.EQ.'V') VYSL=1
      IF (CHAR.EQ.'v') VYSL=2
      IF (CHAR.EQ.'A') VYSL=3
      IF (CHAR.EQ.'a') VYSL=4
      IF (CHAR.EQ.'C') VYSL=5
      IF (CHAR.EQ.'c') VYSL=6
      IF (CHAR.EQ.'P') VYSL=7
      IF (CHAR.EQ.'p') VYSL=8
      IF (CHAR.EQ.'N') VYSL=9
      IF (CHAR.EQ.'n') VYSL=10
      IF (CHAR.EQ.'Q') VYSL=11
      IF (CHAR.EQ.'q') VYSL=12
      IF (CHAR.EQ.'F') VYSL=13
      IF (CHAR.EQ.'f') VYSL=14
      IF (CHAR.EQ.'D') VYSL=15
      IF (CHAR.EQ.'d') VYSL=16
      IF (CHAR.EQ.'O') VYSL=17
      IF (CHAR.EQ.'o') VYSL=18
      IF (CHAR.EQ.'M') VYSL=19
      IF (CHAR.EQ.'m') VYSL=20
      IF ((VYSL.EQ.1).OR.(VYSL.EQ.2)) TYP=1
      IF ((VYSL.EQ.3).OR.(VYSL.EQ.4)) TYP=2
      IF ((VYSL.EQ.5).OR.(VYSL.EQ.6)) TYP=3
      IF ((VYSL.EQ.7).OR.(VYSL.EQ.8)) THEN
      USEK=USEK-1
      TYP=7
      ENDIF
      IF ((VYSL.EQ.9).OR.(VYSL.EQ.10)) THEN
      USEK=USEK+1
      TYP=8
      ENDIF
      IF ((VYSL.EQ.11).OR.(VYSL.EQ.12)) TYP=6
      IF ((VYSL.EQ.13).OR.(VYSL.EQ.14)) TYP=4
      IF ((VYSL.EQ.15).OR.(VYSL.EQ.16)) TYP=9
      IF ((VYSL.EQ.17).OR.(VYSL.EQ.18)) TYP=10
      IF ((VYSL.EQ.19).OR.(VYSL.EQ.20)) TYP=11
      RETURN
      END
C
      SUBROUTINE MWRITE(N)
      INTEGER N,I
      DO 1 I=1,N
      WRITE (*,'('' '')')
    1 CONTINUE
      RETURN
      END


