$INTERFACE UO1FU2                                             98/12/01

$IF(KDF>0)
  $PARGF='$$GF'
  $DIMGF='$$NF'
$ELSE
  $PARGF='X'
  $DIMGF='$$NF'
$ENDIF
$IF(NE<>0)
  $PARAF='X'
  $DIMAF='$$NF'
$ELSEIF(NAP>0)
  $IF(ISNA>0)
    $PARAF='$$AF'
    $DIMAF='$$NA'
  $ELSE
    $PARAF='X'
    $DIMAF='$$NF'
  $ENDIF
  $IF(KBA>0)
    CALL UXVSUM(NA,$AF,$AM,$AF)
  $ENDIF
$ELSE
  $PARAF='X'
  $DIMAF='$$NF'
$ENDIF
$IF(NCP>0)
  $IF(ISNC>0)
    $PARCF='$$CF'
    $DIMCF='$$NC'
  $ELSE
    $PARCF='X'
    $DIMCF='$$NF'
  $ENDIF
$ELSE
  $PARCF='X'
  $DIMCF='$$NF'
$ENDIF
$OUT CONTINUE
$IF(GRAPHICS<0)
$ELSEIF(GRAPH<>'NO')
  CALL UOERR3(KOUT,LOUT,MOUT,ITERM,IER)
  IF (IER.NE.0) THEN
    CALL UOGRST
    WRITE(ITR,*) ' '
  ENDIF
$ENDIF
$GMAX='GMAX'
$IF(CONSTR='C') $GMAX='GMAX+UMAX'
$IF(MODEL='FL')
  $IF(IEXT>0)
    FF=-F
  $ELSE
    FF= F
  $ENDIF
$ENDIF
$IF(MODEL='FQ')
  $IF(IEXT>0)
    FF=-F
  $ELSE
    FF= F
  $ENDIF
$ENDIF
IF(NCYC.LE.1) THEN
CALL UO1FU2(NF,NA,NC,$X,$PARGF,$PARAF,$PARCF,FF,F,FO,DMAX,$GMAX,XMAX&
,EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,BET1,BET2,GAM1,GAM2,ETA1,ETA2,MET,MET1&
,MET2,MET3,MOT,MOT1,MOT2,MOT3,MES,MES1,MES2,MES3,MOS,MOS1,MOS2,MOS3&
,INITD,INITS,INITH,IRES1,KTERS,IPRN)
ENDIF
$ADD(REAL,'\$X($NF)\$PARGF($DIMGF)\$PARAF($DIMAF)\$PARCF($DIMCF)')
$IF(KBF<>0)
  IF (KBF.GT.0) CALL UXVINE(NF,$IX)
$ENDIF
$IF(KBC<>0)
  CALL UXVINE(NC,$IC)
$ENDIF  
$IF(RECURSIVE='NO')
  $IF(DISPLAY='YES')
    $SUBST('UOGFG2')
  $ELSEIF(GRAPH='INTERNAL')
    $SUBST('UOGFG2')
  $ELSEIF(GRAPH='EXTERNAL')
    $SUBST('UOGFG3')
  $ENDIF
$ENDIF
$EXIT

* IMPLEMENTATION

* SUBROUTINE UO1FU2                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF EXIT FROM FUNCTION MINIMIZATION.
*
* PARAMETERS:
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF CONSTRAINTS
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  GF(NF)  GRADIENT OF THE MODEL FUNCTION.
*  RI  AF(NA)  VALUES OF THE APPROXIMATED FUNCTIONS.
*  RI  CF(NC)  VALUES OF THE CONSTRAINT FUNCTIONS.
*
* COMMON DATA :
*  IU  NAV  NUMBER OF VALUES OF THE APPROXIMATED FUNCTIONS.
*  IU  NAG  NUMBER OF GRADIENTS OF THE APPROXIMATED FUNCTIONS.
*  IU  NAH  NUMBER OF HESSIAN MATRICES OF THE APPROXIMATED FUNCTIONS.
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  KDF  DEGREE OF ANALYTICALLY COMPUTED DERIVATIVES.
*  II  ISNA  LEVEL OF PRINT. IF ISNA>0 VALUES OF THE APPROXIMATED
*         FUNCTIONS ARE PRINTED.
*  II  ISNC  LEVEL OF PRINT. IF ISNC>0 VALUES OF CONSTRAINTS ARE
*         PRINTED.
*  II  IOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INITIAL VALUES
*         AND FINAL RESULTS. IOUT=0-NO PRINT. IOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*  II  MOUT  LEVEL OF PRINT ON THE TERMINAL DEVICE.
*         MOUT=0 - NO PRINT.
*         MOUT=1 - PRINT OF FINAL RESULTS.
*         MOUT=2 - ADDITIONAL PRINT OF ITERATIONS.
*
* OUTPUT VARIABLES :
* FF,X(NF),GF(NF),AF(NA*NAP),CF(NC),ITERM,TXFU,F,GMAX,DMAX,NIT,
* NFV,NFG,NFH,NAV,NAG,NAH,NCV,NCG,NCH,NRES,NREM,NADD,NEXT,MET,
* MET1,MET2,MET3,MOT,MOT1,MOT2,MOT3,MES,MES1,MES2,MES3,MOS,MOS1,
* MOS2,MOS3,INITD,INITS,INITH,IRES1,IRES2,EPS0,EPS1,EPS2,EPS3,
* EPS4,EPS5,BET1,BET2,GAM1,GAM2,ETA1,ETA2,XMAX
*
      SUBROUTINE UO1FU2(NF,NA,NC,X,GF,AF,CF,FF,F,FO,DMAX,GMAX,XMAX,
     & EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,BET1,BET2,GAM1,GAM2,ETA1,ETA2,
     & MET,MET1,MET2,MET3,MOT,MOT1,MOT2,MOT3,MES,MES1,MES2,MES3,MOS,
     & MOS1,MOS2,MOS3,INITD,INITS,INITH,IRES1,KTERS,IPRN)
      $INCLUDE ('UMCOMM')
      $INCLUDE ('UMCOMD')
      INTEGER NF,NA,NC,MET,MET1,MET2,MET3,MOT,MOT1,MOT2,MOT3,MES,MES1,
     & MES2,MES3,MOS,MOS1,MOS2,MOS3,INITD,INITS,INITH,IRES1,KTERS,IPRN
      $FLOAT X(NF),GF(NF),AF(*),CF(*),FF,F,FO,DMAX,GMAX,XMAX,
     & EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,BET1,BET2,GAM1,GAM2,ETA1,ETA2
      INTEGER I,NIGR
      LOGICAL LL
      NDEM=NF
      NIGR=MAX(1,NIT)
      LL=KOUT.EQ.0.AND.LOUT.GT.0
      IF (KOUT.EQ.0.AND.LOUT.LT.0) IPRN=0
      IF (ABS(MOUT).GT.0) THEN
      IF (KD.LE.0) THEN
      IF (ABS(LOUT).LE.1) THEN
      WRITE (ITR,16) NEXT,NIT,NFV,NDECF+NDECA,NCGR/NIGR,F
      IF (LL) WRITE (IWR,16) NEXT,NIT,NFV,NDECF+NDECA,NCGR/NIGR,F
      ELSE
      WRITE (ITR,26) NEXT,NIT,NFV,NDECF+NDECA,TXFU,F
      IF (LL) WRITE (IWR,26) NEXT,NIT,NFV,NDECF+NDECA,TXFU,F
      ENDIF
      ELSE
      IF (ABS(LOUT).LE.1) THEN
      WRITE (ITR,17) NEXT,NIT,NFV,NFG,NDECF+NDECA,NCGR/NIGR,F,GMAX
      IF (LL) WRITE(IWR,17) NEXT,NIT,NFV,NFG,NDECF+NDECA,NCGR/NIGR,F,
     & GMAX
      ELSE
      WRITE (ITR,27) NEXT,NIT,NFV,NFG,TXFU,F,GMAX
      IF (LL) WRITE (IWR,27) NEXT,NIT,NFV,NFG,TXFU,F,GMAX
      ENDIF
      ENDIF
      IF (ITERM.GE.0.AND.ITERM.LE.10.OR.ITERM.GE.20.OR.ITERM.EQ.-6.AND.
     & GMAX.LE.1.0$P 3*TOLG) THEN
      ELSE
      WRITE (ITR,'(A80)') TER
      IF (LL) WRITE (IWR,'(A80)') TER
      IF (NOUT1.GT.0) THEN
      WRITE (ITR,'('' ACTUAL VALUE:'',I8,
     & ''   -   DECLARED VALUE:'',I8)') NOUT1,NOUT2
      IF (LL) WRITE(IWR,'('' ACTUAL VALUE:'',I8,
     & ''   -   DECLARED VALUE:'',I8)') NOUT1,NOUT2
      ENDIF
      ENDIF
      ENDIF
      IF(NOUT.NE.0) THEN
      IF(KDF.GE.0) THEN
      WRITE ( ITR, 18)  FF
      IF(LL) WRITE ( IWR, 18)  FF
      ELSEIF(NA.GT.0) THEN
      FO=F
      IF (IEXT.GT.0) FO=-FO
      WRITE ( ITR, 28)  FO
      IF(LL) WRITE ( IWR, 28)  FO
      ENDIF
      WRITE ( ITR, 19)  (X(I), I=1,MIN(NF,100))
      IF(LL) WRITE ( IWR, 19)  (X(I), I=1,MIN(NF,100))
      IF(ABS(NOUT).GT.1) THEN
      IF (NA.GT.0.AND.ISNA.GT.0) THEN
      WRITE ( ITR, 20)  (AF(I), I=1,MIN(NA,100))
      IF(LL) WRITE ( IWR, 20)  (AF(I), I=1,MIN(NA,100))
      ENDIF
      IF (NC.GT.0.AND.ISNC.GT.0) THEN
      WRITE ( ITR, 21)  (CF(I), I=1,MIN(NC,100))
      IF(LL) WRITE ( IWR, 21)  (CF(I), I=1,MIN(NC,100))
      ENDIF
      ENDIF
      ENDIF
      IF(IPRN.EQ.0.OR.IOUT.EQ.0.OR.KOUT.EQ.0) GO TO 10
      WRITE ( IWR, 1)
    1 FORMAT ( /1X,'FINAL RESULTS'/1X,13('-'))
      IF(NOUT.NE.0) THEN
      IF (KDF.GE.0) THEN
      WRITE ( IWR, 2)  FF
      ELSEIF(NA.GT.0) THEN
      FO=F
      IF (IEXT.GT.0) FO=-FO
      WRITE ( IWR, 28)  FO
      ENDIF
    2 FORMAT (/1X,'FF=',$P 18.10)
      WRITE (IWR,3) (X(I),I=1,MIN(NF,100))
    3 FORMAT (' ', 'X =',4$P 18.10:/( 4X,4$P 18.10))
      IF (ABS(NOUT).GT.1) THEN
      IF (KDF .GE.1) WRITE ( IWR, 4)  (GF(I), I=1,MIN(NF,100))
    4 FORMAT (' ','GF=',4$P 18.10:/(4X,4$P 18.10))
      IF (NA.GT.0.AND.ISNA.GT.0) WRITE (IWR,5) (AF(I),I=1,MIN(NA,100))
    5 FORMAT (' ','AF=',4$P 18.10:/(4X,4$P 18.10))
      IF (NC.GT.0.AND.ISNC.GT.0) WRITE (IWR,6) (CF(I),I=1,MIN(NC,100))
    6 FORMAT (' ','CF=',4$P 18.10:/(4X,4$P 18.10))
      ENDIF
      ENDIF
      IF (KD.LE.0) THEN
      WRITE (IWR,7) ITERM,TXFU,F,DMAX
    7 FORMAT (/1X,'TERMINATION:',I4,2X,A8,2X,
     *        'F=',$P 9.3,1X,'D=',$P 9.3)
      ELSE
      WRITE (IWR,8) ITERM,TXFU,F,GMAX,DMAX
    8 FORMAT (/1X,'TERMINATION:',I4,2X,A8,2X,
     *        'F=',$P 9.3,1X,'G=',$P 9.3,1X,'D=',$P 9.3)
      ENDIF
      IF(ITERM.LT.0) WRITE(IWR,'(A80)') TER
      IF(NA.GE.1) THEN
        NAV=NAV/NA
        NAG=NAG/NA
        NAH=NAH/NA
      ENDIF
      WRITE (IWR,9) NIT, NDECF+NDECA,
     *              NFV, NAV, NCV, NRES,
     *              NFG, NAG, NCG, NREM,
     *              NFH, NAH, NCH, NADD
    9 FORMAT (/1X,'STATISTICS'/1X,10('-')/
     *     ' ','NIT  =',I5,3X,'NDEC =',I5/
     *     ' ','NFV  =',I5,3X,'NAV  =',I5,3X,'NCV  =',I5,3X,'NRES =',I5/
     *     ' ','NFG  =',I5,3X,'NAG  =',I5,3X,'NCG  =',I5,3X,'NREM =',I5/
     *     ' ','NFH  =',I5,3X,'NAH  =',I5,3X,'NCH  =',I5,3X,'NADD =',I5)
      RETURN
   10 IF (KOUT.NE.0.OR.LOUT.GE.0) RETURN
      WRITE (IWR,11) NEXT
   11 FORMAT (/1X,'PROBLEM NO',I5/' ',15('-'))
      WRITE (IWR,12) MET,MET1,MET2,MET3,MOT,MOT1,MOT2,MOT3,
     *               MES,MES1,MES2,MES3,MOS,MOS1,MOS2,MOS3,
     *               INITD,INITS,INITH,KTERS,IRES1
   12 FORMAT (' ','MET  MET1 MET2 MET3 MOT  MOT1 MOT2 MOT3 ',
     *            'MES  MES1 MES2 MES3 MOS  MOS1 MOS2 MOS3 ',
     *            'INITD INITS INITH KTERS IRES1'/
     *            ' ',16(I3,2X),5(I4,2X)/' ',117('-'))
      WRITE (IWR,13) EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,
     *               BET1,BET2,GAM1,GAM2,ETA1,ETA2,XMAX
   13 FORMAT (' ','     EPS0     EPS1     EPS2     EPS3     EPS4',
     *            '     EPS5     BET1     BET2     GAM1     GAM2',
     *            '     ETA1     ETA2     XMAX'/' ',13$P 9.2/
     *            ' ',117('-'))
      IF(KD.LE.0) THEN
      WRITE (IWR,14) TXFU,F,NIT,NFV,NFG,NFH,NRES
      ELSE
      WRITE (IWR,15) TXFU,F,GMAX,NIT,NFV,NFG,NFH,NRES
      ENDIF
   14 FORMAT (' ','TERMINATION : ',A8,2X,'F =',$P 10.3,2X,
     *            'NIT=',I5,2X,'NFV=',I5,2X,
     *            'NFG=',I5,2X,'NFH=',I5,2X,'NRES=',I4)
   15 FORMAT (' ','TERMINATION : ',A8,2X,'F =',$P 10.3,2X,
     *            'G =',$P 10.3,2X,'NIT=',I5,2X,'NFV=',I5,2X,
     *            'NFG=',I5,2X,'NFH=',I5,2X,'NRES=',I4)
   16 FORMAT(' ',I3,1X,'NIT=',I5,1X,'NFV=',I5,1X,'NDC=',I5,1X,
     *           'NCG=',I4,1X,'F=',D9.3)
   26 FORMAT(' ',I3,1X,'NIT=',I5,1X,'NFV=',I5,1X,'NDC=',I5,2X,
     *           A8,2X,'F=',G17.10)
   17 FORMAT(' ',I3,1X,'NIT=',I5,1X,'NFV=',I5,1X,'NFG=',I5,1X,
     *           'NDC=',I5,1X,'NCG=',I4,1X,'F=',D9.3,1X,'G=',D9.3)
   27 FORMAT(' ',I3,1X,'NIT=',I5,1X,'NFV=',I5,1X,'NFG=',I5,2X,
     *           A8,2X,'F=',G17.10,1X,'G=',D9.3)
   18 FORMAT ( ' ', 'FF =',$P 18.10)
   28 FORMAT ( ' ', 'F  =',$P 18.10)
   19 FORMAT ( ' ', 'X  =',4$P 18.10:/(5X,4$P 18.10))
   20 FORMAT ( ' ', 'AF =',4$P 18.10:/(5X,4$P 18.10))
   21 FORMAT ( ' ', 'CF =',4$P 18.10:/(5X,4$P 18.10))
      RETURN
      END

