* SUBROUTINE UO3FU3                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF OUTPUT FROM GLOBAL MINIMIZATION
*
* PARAMETERS:
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  FV  VALUE OF GLOBAL EXTREM
*  RI  X(NF)  POINT OF GLOBAL EXTREM
*
* COMMON DATA :
*  IU  NIT  ACTUAL NUMBER OF ITERATIONS.
*  IU  NFV  ACTUAL NUMBER OF COMPUTED FUNCTION VALUES.
*  IU  NFG  ACTUAL NUMBER OF COMPUTED GRADIENTS.
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  ITR  NUMBER OF THE OUTPUT UNIT.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  II  MOUT  LEVEL OF PRINT ON THE TERMINAL DEVICE.
*         MOUT=0 - NO PRINT.
*         MOUT=1 - PRINT OF FINAL RESULTS.
*         MOUT=2 - ADDITIONAL PRINT OF ITERATIONS.
*
      SUBROUTINE UO3FU3(NF,FV,X)
      $INCLUDE ('UMCOMM')
      INTEGER NF
      $FLOAT FV,X(NF)
      INTEGER I
      LOGICAL LL
      LL=KOUT.EQ.0.AND.LOUT.GT.0
      IF (ABS(MOUT).GT.0) THEN
        IF(KD.LE.0) THEN
          IF(MOUT.GT.0) THEN
            WRITE(ITR,16) NEXT,NIT,NFV,NDECF+NDECA,FV
            IF(LL) WRITE(IWR,16) NEXT,NIT,NFV,NDECF+NDECA,FV
          ELSE
            WRITE(ITR,26) NEXT,NIT,NFV,NDECF+NDECA,TXFU,FV
            IF(LL) WRITE(IWR,26) NEXT,NIT,NFV,NDECF+NDECA,TXFU,FV
          ENDIF
        ELSE
          IF(MOUT.GT.0) THEN
            WRITE(ITR,17) NEXT,NIT,NFV,NFG,NDECF+NDECA,FV
            IF(LL) WRITE(IWR,17) NEXT,NIT,NFV,NFG,NDECF+NDECA,FV
          ELSE
            WRITE(ITR,27) NEXT,NIT,NFV,NFG,NDECF+NDECA,TXFU,FV
            IF(LL) WRITE(IWR,27) NEXT,NIT,NFV,NFG,NDECF+NDECA,TXFU,FV
          ENDIF
        ENDIF
      ENDIF
      IF(NOUT.GT.0) THEN
        WRITE ( ITR, 18) FV
        IF(LL) WRITE ( IWR, 18) FV
        WRITE ( ITR, 19)  (X(I), I=1,NF)
        IF(LL) WRITE ( IWR, 19)  (X(I), I=1,NF)
      ENDIF
      IF (KOUT.NE.0) THEN
        WRITE(IWR,30)
        WRITE(IWR,40) FV,(X(I),I=1,NF)
        WRITE(IWR,50) NFV,NFG,NFH
      ENDIF
   16 FORMAT(' ',I3,2X,'NIT=',I6,2X,'NFV=',I6,2X,'NDC=',I4,2X,
     *           'F=',D10.3)
   26 FORMAT(' ',I3,2X,'NIT=',I6,2X,'NFV=',I6,2X,'NDC=',I4,2X,
     *           A8,2X,'F=',G17.10)
   17 FORMAT(' ',I3,2X,'NIT=',I4,2X,'NFV=',I4,2X,'NFG=',I4,2X,
     *           'NDC=',I4,2X,'F=',D10.3,2X)
   27 FORMAT(' ',I3,2X,'NIT=',I4,2X,'NFV=',I4,2X,'NFG=',I4,2X,
     *           'NDC=',I4,2X,A8,2X,'F=',G17.10,2X)
   18 FORMAT ( ' ', 'F =',$P 18.10)
   19 FORMAT ( ' ', 'X =',4$P 18.10:/(4X,4$P 18.10))
   30 FORMAT (/1X, 'FINAL RESULTS' / ' ', 13('-'))
   40 FORMAT (/1X,'GL. EXTREM:'/ ' ','F  =', $P 19.10 /
     &  ' ','X  =', 6$P 19.10:/( 5X, 6$P 19.10))
   50 FORMAT (/1X, 'STATISTICS' / ' ', 10('-') //
     &  ' NFV =',I5,3X,'NFG =',I5,3X,'NFH =',I5)
      END

