* SUBROUTINE UOD1D4                ALL SYSTEMS               94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ITERATIONS IN DIRECTION DETERMINATION.
*
* PARAMETERS :
*  RI  RHO1  NORM OF OLD RESIDUUM.
*  RI  RHO2  NORM OF NEW RESIDUUM.
*  RI  PREC  PRINTED COEFFICIENT.
*  RI  SNORM  NORM OF THE DIRECTION VECTOR.
*  RI  XDEL  TRUST REGION RADIUS.
*
* COMMON DATA :
*  IU  NCGR  NUMBER OF CG ITERATIONS.
*  II  NRED  NUMBER OF THE CURRENT ITERATION
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*
      SUBROUTINE UOD1D4(RHO1,RHO2,PREC,SNORM,XDEL)
      $INCLUDE ('UMCOMM')
      $FLOAT RHO1,RHO2,PREC,SNORM,XDEL
      NCGR=NCGR+1
      IF(JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.2) RETURN
      WRITE(IWR,1) NRED,SQRT(ABS(RHO1)),SQRT(ABS(RHO2)),
     & SQRT(ABS(PREC)),SNORM,XDEL
    1 FORMAT (' ',I5,2X,'G =',$P 9.3,2X,'R =',$P 9.3,2X,'P =',$P 9.3,
     & 2X,'S =',$P 9.3,2X,'D =',$P 9.3)
      RETURN
      END
