* SUBROUTINE UOD1D6                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF INFORMATION DURING DIRECTION DETERMINATION.
*
* PARAMETERS :
*  RI  T  TRUST REGION (LEVENBERG) PARAMETER.
*  RI  TO  OLD TRUST REGION PARAMETER.
*  RI  E  LOWER BOUND FOR MINIMUM EIGENVALUE.
*  RI  SNORM  NORM OF THE DIRECTION VECTOR.
*
* COMMON DATA :
*  II  NRED  NUMBER OF REDUCTIONS.
*  IU  IDIR INDICATOR FOR DIRECTION DETERMINATION.
*         IDIR=0-BASIC DETERMINATION. IDIR=1-DETERMINATION
*         AFTER ZERO STEP.
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  TI  TDXX  PRINTED TEXT.
*
      SUBROUTINE UOD1D6(T,TO,E,SNORM)
      $INCLUDE ('UMCOMM')
      $FLOAT T,TO,E,SNORM
      IF (JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.2) RETURN
      WRITE (IWR,1) IDIR,NRED,T,TO,E,SNORM,TDXX
    1 FORMAT (' ',I1,2X,I3,2X,'T=',$P 9.3,1X,
     &  'TO=',$P 9.3,1X,'E=',$P 9.3,1X,'S=',$P 9.3,1X,A8)
      RETURN
      END
