* SUBROUTINE UOD1D7             ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF INFORMATION DURING DIRECTION DETERMINATION.
*
* PARAMETERS :
*  RI  T  TRUST REGION (LEVENBERG) PARAMETER.
*  RI  TL  LOWER BOUND FOR TRUST REGION PARAMETER.
*  RI  TU  UPPER BOUND FOR TRUST REGION PARAMETER.
*  RI  E  LOWER BOUND FOR MINIMUM EIGENVALUE.
*  RI  DMAX  MAXIMUM STEPSIZE.
*  RI  SNORM  NORM OF THE DIRECTION VECTOR.
*
* COMMON DATA :
*  II  NRED  NUMBER OF REDUCTIONS.
*  IU  IDIR INDICATOR FOR DIRECTION DETERMINATION.
*         IDIR=0-BASIC DETERMINATION. IDIR=1-DETERMINATION
*         AFTER ZERO STEP.
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  TI  TDXX  PRINTED TEXT.
*
      SUBROUTINE UOD1D7(T,TL,TU,E,DMAX,SNORM)
      $INCLUDE ('UMCOMM')
      $FLOAT T,TL,TU,E,DMAX,SNORM
      IF (JOUT.EQ.0) RETURN
      IF (ABS(KOUT) .LE. 2) RETURN
      WRITE (IWR,1) IDIR,NRED,T,TL,TU,E,DMAX,SNORM,TDXX
    1 FORMAT(' ',I1,2X,I3,2X,'T=',$P 9.3,1X,'L=',$P 9.3,1X,'U=',$P 9.3,
     &       1X,'E=',$P 9.3,1X,'D=',$P 9.3,1X,'S=',$P 9.3,1X,A8)
      RETURN
      END
