* SUBROUTINE UOD1D8             ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF EXIT FROM DIRECTION DETERMINATION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  G(N)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  S(N)  DIRECTION VECTOR.
*  RI  GNORM  NORM OF THE GRADIENT VECTOR.
*  RI  SNORM  NORM OF THE DIRECTION VECTOR.
*  RI  P  VALUE OF THE DIRECTIONAL DERIVATIVE.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  LEVEL OF PRINT. LOUT=0-PRINT OF SCALAR VALUES.
*         LOUT=1-ADDITIONAL PRINT OF BASIC VECTORS.
*         LOUT=2-ADDITIONAL PRINT OF OTHER VECTORS.
*         LOUT=3-ADDITIONAL PRINT OF MATRICES.
*
      SUBROUTINE UOD1D8(N,G,S,GNORM,SNORM,P)
      $INCLUDE ('UMCOMM')
      INTEGER N
      $FLOAT G(N),S(N),GNORM,SNORM,P
      INTEGER I
      IF(JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.2) RETURN
      IF (ABS(LOUT).GE.2) WRITE (IWR,2) (G(I),I=1,MIN(N,25))
    2 FORMAT (' ','G   =',5$P 14.5:/(6X,5$P 14.5))
      IF (ABS(LOUT).GE.2) WRITE ( IWR, 3) (S(I),I=1,MIN(N,25))
    3 FORMAT (' ','S   =',5$P 14.5:/(6X,5$P 14.5))
      WRITE (IWR,4) GNORM,SNORM,P
    4 FORMAT (' ','G   =',$P 14.5,2X,'S   =',$P 14.5,2X,'P   =',$P 14.5)
      RETURN
      END
