$INTERFACE UOJRF1                                             10/12/01

  $ADD(INTEGER,'\NFV1\NAV1') 
  $ADD(REAL,'\$X($NF)')
  $ADD(REAL4,'\$FL($NGR,$NGR)')
$REM  $ADD(INTEGER,'\NF')
$REM  $ADD(REAL,'\F\FO')
      $IF(NA>0)
        CALL UXVCOP(NA,$AF,$AFO)
        $ADD(REAL,'\$AFO($NA)')
      $ENDIF
      IF (NF.LE.1) THEN
      WRITE(12,'(2I5)') 0,0
      GO TO $LGR
      ELSE
      WRITE(12,'(2I5)') 1,NGR
      ENDIF
  $50 CONTINUE
      CALL UOJRF1(NF,$X,$FL,F,FO,$ETA9)
      GOTO ($60,$70) ISB+1
  $60 CONTINUE
      $IF(NA>0)
        CALL UXVCOP(NA,$AFO,$AF)
      $ENDIF
      GOTO $LGR
  $70 CONTINUE
      NFV1=NFV
      NAV1=NAV
      $SUBST('UZMODL')
      NFV=NFV1
      NAV=NAV1
      GOTO $50
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOJRF1                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRAPHICAL OUTPUT - MAP, HILLS, ISOLINES.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RO  FL(NGR,NGR)  FIELD OF DRAWN FUNCTION VALUES.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  FO  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA9  MAXIMUM MACHINE CONSTANT.
*
* COMMON DATA :
*  II  NGR  TOTAL NUMBER OF DRAWN NODES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
      SUBROUTINE UOJRF1(NF,X,FL,F,FO,ETA9)
      $INCLUDE ('UMCOMM')
      $INCLUDE ('UMCOMG')
      INTEGER NF
      REAL*4 FL(NGR,NGR)
      $FLOAT X(NF),F,FO,ETA9
      $FLOAT STIGR,STJGR,DFIGR,DFJGR
      $FLOAT CON1,CON2
      PARAMETER(CON1=1.0$P-60,CON2=1.0$P 60)
      INTEGER IVAR,JVAR
      SAVE IVAR,JVAR,STIGR,STJGR,DFIGR,DFJGR
      IF (TSS(NS).NE.'UYXX') CALL UYPRO1('UYXX',0)
      GO TO (1,4) ISP(NS)
    1 CONTINUE
      IF (IGR.LE. 0) GO TO 5
      IF (IGR.GT.NF) GO TO 5
      CALL UOJZD3(NF,X,IGR,XLIGR,XUIGR)
      IF (JGR.LE. 0) GO TO 5
      IF (JGR.GT.NF) GO TO 5
      CALL UOJZD3(NF,X,JGR,XLJGR,XUJGR)
      FO=F
      XIGR=X(IGR)
      XJGR=X(JGR)
      STIGR=(XUIGR-XLIGR)/(NGR-1)
      STJGR=(XUJGR-XLJGR)/(NGR-1)
      DFIGR=ETA9
      DFJGR=ETA9
      VALMIN= ETA9
      VALMAX=-ETA9
      IVAR=0
    2 IVAR=IVAR+1
      X(IGR)=XLIGR+(IVAR-1)*STIGR
      JVAR=0
    3 JVAR=JVAR+1
      X(JGR)=XLJGR+(JVAR-1)*STJGR
      CALL UYSET2
      CALL UYSET0(1,2)
      RETURN
    4 CONTINUE
      IF (ABS(F).GE.CON2) THEN
      FL(IVAR,JVAR)=SIGN(CON2,F)
      ELSE IF (ABS(F).LE.CON1) THEN
      FL(IVAR,JVAR)=SIGN(CON1,F)
      ELSE
      FL(IVAR,JVAR)=F
      ENDIF
      IF (ABS(XIGR-X(IGR)).LT.DFIGR) THEN
      DFIGR=ABS(XIGR-X(IGR))
      IMIN=IVAR
      ENDIF
      IF (ABS(XJGR-X(JGR)).LT.DFJGR) THEN
      DFJGR=ABS(XJGR-X(JGR))
      JMIN=JVAR
      ENDIF
      IF (FL(IVAR,JVAR).LT.VALMIN) VALMIN=FL(IVAR,JVAR)
      IF (FL(IVAR,JVAR).GT.VALMAX) VALMAX=FL(IVAR,JVAR)
      IF (JVAR.LT.NGR) GO TO 3
      IF (IVAR.LT.NGR) GO TO 2
      IF (XIGR.LT.XLIGR.OR.XIGR.GT.XUIGR) IMIN=0
      IF (XJGR.LT.XLJGR.OR.XJGR.GT.XUJGR) JMIN=0
      X(IGR)=XIGR
      X(JGR)=XJGR
      F=FO
      WRITE(12,'(I5,I5,3D20.12)') 1,NGR,FO,VALMIN,VALMAX
      WRITE(12,'(I5,I5,3D20.12)') IGR,IMIN,XIGR,XLIGR,XUIGR
      WRITE(12,'(I5,I5,3D20.12)') JGR,JMIN,XJGR,XLJGR,XUJGR
      WRITE(12,'(4D20.12)')((FL(IVAR,JVAR),IVAR=1,NGR),JVAR=1,NGR)
    5 CONTINUE
      CALL UYEPI1(0)
      RETURN
      END
