$INTERFACE UOJRF3                                             10/12/01

  $FTH='FTH'
  $ADD(INTEGER,'\NFV1\NAV1') 
  $ADD(REAL4,'\$FL($NGR,$NGR)\$FTH($NGR,2)\$XPA($NPA,2)')
  $ADD(REAL,'\$X($NF)')
      $IF(NA>0)
        CALL UXVCOP(NA,$AF,$AFO)
        $ADD(REAL,'\$AFO($NA)')
      $ENDIF
      IF (NF.LE.1) THEN
      WRITE(15,'(2I5)') 0,0
      GO TO $LGR
      ELSE
      WRITE(15,'(2I5)') 1,NGR
      ENDIF
  $50 CONTINUE
      CALL UOJRF3(NF,$X,$XPA,$FL,F,FO,$ETA9)
      GOTO ($60,$70) ISB+1
  $60 CONTINUE
      $IF(NA>0)
        CALL UXVCOP(NA,$AFO,$AF)
      $ENDIF
      GOTO $LGR
  $70 CONTINUE
      NFV1=NFV
      NAV1=NAV
      $SUBST('UZMODL')
      NFV=NFV1
      NAV=NAV1
      GOTO $50
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOJRF3                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRAPHICAL OUTPUT - PATH.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XPA(NPA,2)  VALUES OF SELECTED VARIABLES.
*  RO  FL(NGR,NGR)  FIELD OF DRAWN FUNCTION VALUES.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  FO  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA9  MAXIMUM MACHINE CONSTANT.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
      SUBROUTINE UOJRF3(NF,X,XPA,FL,F,FO,ETA9)
      $INCLUDE ('UMCOMM')
      $INCLUDE ('UMCOMG')
      INTEGER NF
      REAL*4 FL(NGR,NGR),XPA(NPA,2)
      $FLOAT X(NF),F,FO,ETA9
      $FLOAT STIGR,STJGR
      $FLOAT CON1,CON2
      PARAMETER(CON1=1.0$P-60,CON2=1.0$P 60)
      INTEGER IVAR,JVAR,I,IPAC,NPAC
      SAVE IVAR,JVAR,IPAC,NPAC,STIGR,STJGR
      IF (TSS(NS).NE.'UYXX') CALL UYPRO1('UYXX',0)
      GO TO (1,4) ISP(NS)
    1 CONTINUE
      IPA=MIN(NPA,NIT)
C
C     COMPUTATION OF BOUNDS
C
      NPAC=MIN(NPA,NIT)
      IPAC=MAX(NPAC-IPA+1,1)
      XLIGR=X(IGR)
      XUIGR=X(IGR)
      XLJGR=X(JGR)
      XUJGR=X(JGR)
      DO 13 I=IPAC,NPAC
      XLIGR=MIN(XLIGR,$DBLE(XPA(I,1)))
      XUIGR=MAX(XUIGR,$DBLE(XPA(I,1)))
      XLJGR=MIN(XLJGR,$DBLE(XPA(I,2)))
      XUJGR=MAX(XUJGR,$DBLE(XPA(I,2)))
   13 CONTINUE
      STIGR=MAX((XUIGR-XLIGR)/TEN,(XUIGR+XLIGR)*1D-6,1.0D-16)
      STJGR=MAX((XUJGR-XLJGR)/TEN,(XUJGR+XLJGR)*1D-6,1.0D-16)
      XLIGR=XLIGR-STIGR
      XUIGR=XUIGR+STIGR
      XLJGR=XLJGR-STJGR
      XUJGR=XUJGR+STJGR
      FO=F
      XIGR=X(IGR)
      XJGR=X(JGR)
      STIGR=(XUIGR-XLIGR)/(NGR-1)
      STJGR=(XUJGR-XLJGR)/(NGR-1)
      VALMIN= ETA9
      VALMAX=-ETA9
      IVAR=0
    2 IVAR=IVAR+1
      X(IGR)=XLIGR+(IVAR-1)*STIGR
      JVAR=0
    3 JVAR=JVAR+1
      X(JGR)=XLJGR+(JVAR-1)*STJGR
      CALL UYSET2
      CALL UYSET0(1,2)
      RETURN
    4 CONTINUE
      IF (ABS(F).GE.CON2) THEN
      FL(IVAR,JVAR)=SIGN(CON2,F)
      ELSE IF (ABS(F).LE.CON1) THEN
      FL(IVAR,JVAR)=SIGN(CON1,F)
      ELSE
      FL(IVAR,JVAR)=F
      ENDIF
      IF (FL(IVAR,JVAR).LT.VALMIN) THEN
      VALMIN=FL(IVAR,JVAR)
      IMIN=IVAR
      JMIN=JVAR
      ENDIF
      IF (FL(IVAR,JVAR).GT.VALMAX) VALMAX=FL(IVAR,JVAR)
      IF (JVAR.LT.NGR) GO TO 3
      IF (IVAR.LT.NGR) GO TO 2
      X(IGR)=XIGR
      X(JGR)=XJGR
      F=FO
      WRITE(15,'(I5,I5,4D20.12)') 1,NGR,FO,VALMIN,VALMAX
      WRITE(15,'(I5,I5,3D20.12)') IGR,IMIN,XIGR,XLIGR,XUIGR
      WRITE(15,'(I5,I5,3D20.12)') JGR,JMIN,XJGR,XLJGR,XUJGR
      WRITE(15,'(4D20.12)')((FL(IVAR,JVAR),IVAR=1,NGR),JVAR=1,NGR)
      CALL UYEPI1(0)
      RETURN
      END
