* SUBROUTINE UOKIT3                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF PERMUTATIONS FROM SPARSE INITIAL TRANSFORMATION SUBROUTINE.
*
* PARAMETERS:
*  II  NF NUMBER OF VARIABLES.
*  II  M  TRANSFORMED NUMBER OF CONSTRAINTS.
*  II  MCOLS DECLARED NUMBER OF COLUMNS.
*  IU  WN01(N) AUXILIARY VECTOR WITH INVERSE PERMUTATION OF
*         ROWS AFTER TRANSFORMATION.
*  II  IPRMC(N) INPUT COLUMN INVERSE PERMUTATION VECTOR.
*
* COMMON DATA :
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  PRINT OF ITERATIONS. LOUT=0-STANDARD PAPER SAVING PRINT.
*         LOUT=1-ADDITIONAL PRINT OF FINAL RESULTS OF SUBROUTINES.
*         LOUT=2-ADDITIONAL PRINT OF VARIABLES. LOUT=3-ADDITIONAL
*         PRINT OF THE GRADIENT. LOUT=4-ADDITIONAL PRINT OF THE HESSIAN
*         MATRIX.
*
      SUBROUTINE UOKIT3(NF,M,MCOLS,WN01,IPRMC)
      $INCLUDE('UMCOMM')
      INTEGER NF,M,MCOLS,WN01(MCOLS),IPRMC(MCOLS)
      INTEGER I,K
      IF(JOUT.EQ.0) RETURN
      IF(ABS(KOUT).LE.3) RETURN
      IF(ABS(LOUT).GT.2) WRITE(IWR,5)(WN01(I),I=1,MIN(M,50))
    5 FORMAT(' ','ORIGINAL POSITIONS OF MATRIX ROWS'/(6X,10I7))
      IF(ABS(LOUT).GT.2) THEN
      DO 100 I=1,MCOLS
      K=IPRMC(I)
      IF(K.NE.0) WN01(K)=I
  100 CONTINUE
      WRITE(IWR,6)(WN01(I),I=1,MIN(NF,50))
    6 FORMAT(' ','ORIGINAL POSITIONS OF VARIABLES  '/(6X,10I7))
      ENDIF
      RETURN
      END
