* SUBROUTINE UOMAPN                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB AND SCILAB GRAPHICAL VISUALIZATION OF APPROXIMATIONS - PRINTING OF THE VALUES FOR PLOTTING.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  AF(NA)  VECTOR CONTAINING THE VALUES OF APPROXIMATED FUNCTIONS.
*  RI  AM(NA)  VECTOR CONTAINING REQUIRED VALUES OF APPROXIMATED FUNCTIONS.
*  II  INFO  SPECIFICATION OF THE PLOT.
*  II  STA  START INDEX OF THE VARIABLES IN THE GRAPH.
*  II  STO  STOP INDEX OF THE VARIABLES IN THE GRAPH.
*  RO  MINIM  MINIMAL VALUE AMONG THE PLOTTING VALUES.
*  RO  MAXIM  MAXIMAL VALUE AMONG THE PLOTTING VALUES.
*
      SUBROUTINE UOMAPN(NA,AF,AM,INFO,STA,STO,MINIM,MAXIM)
      $OPTION(CHEOL='^')
      INTEGER NA,INFO,STA,STO,I,J,K
      $FLOAT AF(NA),AM(NA),WY(10),MAXIM,MINIM
      CHARACTER*16 RETSTA,RETSTO
      CHARACTER*250 RET
C
      WRITE(RETSTA,'(I10)') STA
      RETSTA=ADJUSTL(RETSTA)
      WRITE(RETSTO,'(I10)') STO
      RETSTO=ADJUSTL(RETSTO)
      WRITE(11,'(5A)') 'ii=', TRIM(RETSTA), ':', TRIM(RETSTO), ';'
C
      IF (INFO.GE.1.AND.INFO.LE.6) THEN
        WRITE(11,'(A)') 'af=['
        J=0
        DO I=STA,STO
          J=J+1
          WY(J)=AF(I)
          IF (J.EQ.10) THEN
            WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
            WRITE(11,'(2A)') TRIM(RET), ' ...'
            J=0
          ENDIF
        ENDDO
        IF (J.GT.0) THEN
          WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
          WRITE(11,'(2A)') TRIM(RET), ' ...'
        ENDIF
        WRITE(11,'(A)') '];'
      ENDIF
C
      IF (INFO.GE.4.AND.INFO.LE.6) THEN
        WRITE(11,'(A)') 'am=['
        J=0
        DO I=STA,STO
          J=J+1
          WY(J)=AM(I)
          IF (J.EQ.10) THEN
            WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
            WRITE(11,'(2A)') TRIM(RET), ' ...'
            J=0
          ENDIF
        ENDDO
        IF (J.GT.0) THEN
          WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
          WRITE(11,'(2A)') TRIM(RET), ' ...'
        ENDIF
        WRITE(11,'(A)') '];'
      ENDIF
C
      IF (INFO.GE.7.AND.INFO.LE.9) THEN
        WRITE(11,'(A)') 'dif=['
        J=0
        DO I=STA,STO
          J=J+1
          WY(J)=AF(I)-AM(I)
          IF (J.EQ.10) THEN
            WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
            WRITE(11,'(2A)') TRIM(RET), ' ...'
            J=0
          ENDIF
        ENDDO
        IF (J.GT.0) THEN
          WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
          WRITE(11,'(2A)') TRIM(RET), ' ...'
        ENDIF
        WRITE(11,'(A)') '];'
      ENDIF
C
      MINIM= 1.0D60
      MAXIM=-1.0D60
      IF (INFO.LE.6) THEN
        DO I=STA,STO
          MINIM=MIN(MINIM,AF(I))
          MAXIM=MAX(MAXIM,AF(I))
        ENDDO
        IF (INFO.GE.4) THEN
          DO I=STA,STO
            MINIM=MIN(MINIM,AM(I))
            MAXIM=MAX(MAXIM,AM(I))
          ENDDO
        ENDIF
      ELSE
        DO I=STA,STO
          MINIM=MIN(MINIM,AF(I)-AM(I))
          MAXIM=MAX(MAXIM,AF(I)-AM(I))
        ENDDO
      ENDIF
      IF (MOD(INFO,3).EQ.0) THEN
        MINIM=MIN(MINIM,0.0D0)
        MAXIM=MAX(MAXIM,0.0D0)
      ENDIF
      RETURN
      $OPTION(CHEOL=';')
      END