* SUBROUTINE UOMMAP                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL VISUALIZATION OF MAP.
*
* PARAMETERS :
*  II  NGR  THE NUMBER OF NODES CORRESPONDING TO EVERY SELECTED VARIABLE
*  II  IGR  THE INDEX OF THE FIRST SELECTED VARIABLE
*  II  JGR  THE INDEX OF THE SECOND SELECTED VARIABLE
*  RI  XIGR  THE VALUE OF THE FIRST VARIABLE IN THE MINIMUM POINT
*  RI  XJGR  THE VALUE OF THE SECOND VARIABLE IN THE MINIMUM POINT
*  RI  XLIGR  THE MINIMUM VALUE OF THE FIRST VARIABLE OF THE SELECTED REGION
*  RI  XUIGR  THE MAXIMUM VALUE OF THE FIRST VARIABLE OF THE SELECTED REGION
*  RI  XLJGR  THE MINIMUM VALUE OF THE SECOND VARIABLE OF THE SELECTED REGION
*  RI  XUIGR  THE MAXIMUM VALUE OF THE SECOND VARIABLE OF THE SELECTED REGION
*  II  IMIN  THE FIRST COORDINATE OF THE MINIMUM IN THE SELECTED REGION
*  II  JMIN  THE SECOND COORDINATE OF THE MINIMUM IN THE SELECTED REGION
*  RI  FL(NGR,NGR)  THE FIELD CONTAINING DRAWN FUNCTION VALUES
*  LU  VYPISF   THE SAME DRAWN FUNCTION VALUES CAN BE PUT INTO P.m ONLY ONCE
*  II  LEVEL  NUMBER OF CONTOUR LEVELS
*  II  SCALE  LINEAR OR LOGARITHMIC SCALE OF THE PLOT
*  II  CISLO  THE NUMBER OF THE GRAPH
*  II  GFMT  GRAPHIC FORMAT
*
      SUBROUTINE UOMMAP(NGR,IGR,JGR,XIGR,XJGR,XLIGR,XUIGR,XLJGR,XUJGR,
     & IMIN,JMIN,FL,VYPISF,LEVEL,SCALE,CISLO,GFMT)
      $OPTION(CHEOL='#')
      INTEGER NGR,IGR,JGR,IMIN,JMIN,LEVEL,SCALE,CISLO,GFMT
      REAL*4 FL(NGR,NGR)
      $FLOAT XIGR,XJGR,XLIGR,XUIGR,XLJGR,XUJGR
      CHARACTER*25 RET
      LOGICAL VYPISF,ENLX,ENLY,CONSTF
C
      CALL UOMOPN(12,GFMT)
      CALL UOMIMS(NGR,XIGR,XJGR,XLIGR,XUIGR,XLJGR,XUJGR,
     & IMIN,JMIN,FL,VYPISF,SCALE,'M',ENLX,ENLY,CONSTF)
C
      WRITE(RET,'(I15)') LEVEL
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'level=', TRIM(RET),';'
      WRITE(12,'(A)') 'contourf(x,y,f,level);'
      WRITE(12,'(A)') 'mn=min(f(:));'
      WRITE(12,'(A)') 'mx=max(f(:));'
      IF (CONSTF.OR.ENLX.OR.ENLY) WRITE(12,'(A)') 'eps=1.0d-6;'
      IF (CONSTF) THEN
        WRITE(12,'(A)') 'set(gca, ''CLim'', [mn-eps, mx+eps]);'
      ELSE
        WRITE(12,'(A)') 'set(gca, ''CLim'', [mn, mx]);'
      ENDIF
      WRITE(12,'(A)') 'colorbar;'
      IF (IMIN.GT.0.OR.JMIN.GT.0) THEN
        WRITE(12,'(A)') 'hold on;'
        WRITE(12,'(A)') 'pm=plot(xm,ym);'
        WRITE(12,'(A)') 'set(pm,{''Marker''},{''s''});'
        WRITE(12,'(A)') 'set(pm,{''MarkerSize''},{10});'
        IF (CONSTF) THEN
          WRITE(12,'(A)') 'set(pm,{''MarkerEdgeColor''},{''k''});'
          WRITE(12,'(A)') 'set(pm,{''MarkerFaceColor''},{''k''});'
        ELSE
          WRITE(12,'(A)') 'set(pm,{''MarkerEdgeColor''},{''w''});'
          WRITE(12,'(A)') 'set(pm,{''MarkerFaceColor''},{''w''});'
        ENDIF
      ENDIF
      IF (ENLX.AND.ENLY) THEN
       WRITE(12,'(A)')'axis([xligr-eps xuigr+eps xljgr-eps xujgr+eps]);'
      ELSEIF (ENLX) THEN
       WRITE(12,'(A)')'axis([xligr-eps xuigr+eps xljgr xujgr]);'
      ELSEIF (ENLY) THEN
       WRITE(12,'(A)')'axis([xligr xuigr xljgr-eps xujgr+eps]);'
      ELSE
       WRITE(12,'(A)')'axis([xligr xuigr xljgr xujgr]);'
      ENDIF
      IF (CONSTF) THEN
        IF (SCALE.EQ.2) THEN
          WRITE(12,'(A)') 'tit=title(''Map (constant, log scale)'');'
        ELSE
          WRITE(12,'(A)') 'tit=title(''Map (constant)'');'
        ENDIF
      ELSE
        IF (SCALE.EQ.2) THEN
          WRITE(12,'(A)') 'tit=title(''Map (log scale)'');'
        ELSE
          WRITE(12,'(A)') 'tit=title(''Map'');'
        ENDIF
      ENDIF
      WRITE(RET,'(I15)') IGR
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'xl=xlabel(''X(', TRIM(RET), ')'');'
      WRITE(RET,'(I15)') JGR
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'yl=ylabel(''X(', TRIM(RET), ')'');'
      WRITE(12,'(A)') 'set(gca,''FontSize'',15);'
      WRITE(12,'(A)') 'set(tit,''FontSize'',25);'
      WRITE(12,'(A)') 'set(xl,''FontSize'',15);'
      WRITE(12,'(A)') 'set(yl,''FontSize'',15);'
      CALL UOMGRX(12,'PMMAP',CISLO,GFMT)
      RETURN
      $OPTION(CHEOL=';')
      END
