* SUBROUTINE UOMPW2                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL VISUALIZATION OF PATH WITH ISOLINES AND/OR MAP - PRINTING OF THE PLOTTING INSTRUCTIONS.
*
* PARAMETERS :
*  II  POINTS  THE NUMBER OF PLOTTING POINTS
*  II  IGR  THE INDEX OF THE FIRST SELECTED VARIABLE
*  II  JGR  THE INDEX OF THE SECOND SELECTED VARIABLE
*  II  LEVEL  NUMBER OF CONTOUR LEVELS
*  II  SCALE  LINEAR OR LOGARITHMIC SCALE OF THE PLOT
*  LI  ENLX  IF THE PLOTTING BOX IN X-AXES IS SUFFICIENTLY LARGE
*  LI  ENLY  IF THE PLOTTING BOX IN Y-AXES IS SUFFICIENTLY LARGE
*  LI  CONSTF  IF THE DIFFERENCE BETWEEN MAX AND MIN OF THE PLOTTING VALUES IS SUFFICIENTLY LARGE
*  LI  INFO  INFORMATION ABOUT THE CASE: 'I' - PATH WITH ISOLINES, 'M' - PATH WITH MAP
*  II  CISLO  INDICATES THE PARAMETERS OF THE GRAPH
*
      SUBROUTINE UOMPW2
     &  (POINTS,IGR,JGR,LEVEL,SCALE,ENLX,ENLY,CONSTF,INFO,CISLO)
      $OPTION(CHEOL='^')
      INTEGER POINTS,IGR,JGR,LEVEL,SCALE,CISLO
      CHARACTER INFO
      CHARACTER*25 RET
      CHARACTER*10 ISOMAP
      LOGICAL ENLX,ENLY,CONSTF
C
      WRITE(RET,'(I15)') LEVEL
      RET=ADJUSTL(RET)
      WRITE(15,'(3A)') 'level=', TRIM(RET),';'
      IF (INFO.EQ.'I') WRITE(15,'(A)') 'contour(x,y,f,level);'
      IF (INFO.EQ.'M') WRITE(15,'(A)') 'contourf(x,y,f,level);'
      WRITE(15,'(A)') 'mn=min(f(:));'
      WRITE(15,'(A)') 'mx=max(f(:));'
      IF (CONSTF) THEN
        WRITE(15,'(A)') 'eps=1.0d-6;'
        WRITE(15,'(A)') 'set(gca, ''CLim'', [mn-eps, mx+eps]);'
      ELSE
        WRITE(15,'(A)') 'set(gca, ''CLim'', [mn, mx]);'
      ENDIF
      WRITE(15,'(A)') 'colorbar;'
C
      WRITE(15,'(A)') 'hold on;'
      WRITE(15,'(A)') 'h=plot(x1,x2);'
      IF (MOD(CISLO,10).EQ.1) THEN
        WRITE(15,'(A)') 'set(h,{''LineStyle''},{''none''});'
      ELSEIF (MOD(CISLO,10).EQ.2.OR.MOD(CISLO,10).EQ.3) THEN
        WRITE(15,'(A)') 'set(h,{''LineStyle''},{''-''});'
        WRITE(15,'(A)') 'set(h,{''LineWidth''},{1});'
        IF (INFO.EQ.'I') WRITE(15,'(A)') 'set(h,{''Color''},{''k''});'
        IF (INFO.EQ.'M') THEN
          IF (CONSTF) THEN
            WRITE(15,'(A)') 'set(h,{''Color''},{''k''});'
          ELSE
            WRITE(15,'(A)') 'set(h,{''Color''},{''w''});'
          ENDIF
        ENDIF
      ENDIF
      IF (MOD(CISLO,10).EQ.1.OR.MOD(CISLO,10).EQ.3) THEN
        WRITE(15,'(A)') 'set(h,{''Marker''},{''o''});'
        WRITE(15,'(A)') 'set(h,{''MarkerSize''},{4});'
        IF (INFO.EQ.'I') THEN
          WRITE(15,'(A)') 'set(h,{''MarkerEdgeColor''},{''k''});'
          WRITE(15,'(A)') 'set(h,{''MarkerFaceColor''},{''k''});'
        ENDIF
        IF (INFO.EQ.'M') THEN
          IF (CONSTF) THEN
            WRITE(15,'(A)') 'set(h,{''MarkerEdgeColor''},{''k''});'
            WRITE(15,'(A)') 'set(h,{''MarkerFaceColor''},{''k''});'
          ELSE
            WRITE(15,'(A)') 'set(h,{''MarkerEdgeColor''},{''w''});'
            WRITE(15,'(A)') 'set(h,{''MarkerFaceColor''},{''w''});'
          ENDIF
        ENDIF
      ENDIF
C
      WRITE(15,'(A)') 'hold on;'
      WRITE(15,'(A)') 'p=plot(xm,ym);'
      WRITE(15,'(A)') 'set(p,{''Marker''},{''s''});'
      WRITE(15,'(A)') 'set(p,{''MarkerSize''},{10});'
      IF (INFO.EQ.'I') THEN
        WRITE(15,'(A)') 'set(p,{''MarkerEdgeColor''},{''k''});'
        WRITE(15,'(A)') 'set(p,{''MarkerFaceColor''},{''k''});'
      ENDIF
      IF (INFO.EQ.'M') THEN
        IF (CONSTF) THEN
          WRITE(15,'(A)') 'set(p,{''MarkerEdgeColor''},{''k''});'
          WRITE(15,'(A)') 'set(p,{''MarkerFaceColor''},{''k''});'
        ELSE
          WRITE(15,'(A)') 'set(p,{''MarkerEdgeColor''},{''w''});'
          WRITE(15,'(A)') 'set(p,{''MarkerFaceColor''},{''w''});'
        ENDIF
      ENDIF
C
      IF (ENLX.OR.ENLY) THEN
        WRITE(15,'(A)') 'eps=1.0d-6;'
      ENDIF
      IF (ENLX.AND.ENLY) THEN
       WRITE(15,'(A)')'axis([xligr-eps xuigr+eps xljgr-eps xujgr+eps]);'
      ELSEIF (ENLX) THEN
       WRITE(15,'(A)')'axis([xligr-eps xuigr+eps xljgr xujgr]);'
      ELSEIF (ENLY) THEN
       WRITE(15,'(A)')'axis([xligr xuigr xljgr-eps xujgr+eps]);'
      ELSE
       WRITE(15,'(A)')'axis([xligr xuigr xljgr xujgr]);'
      ENDIF
      WRITE(RET,'(I15)') POINTS
      RET=ADJUSTL(RET)
      IF (INFO.EQ.'I') ISOMAP='isolines'
      IF (INFO.EQ.'M') ISOMAP='map'
      IF (CONSTF) THEN
        IF (SCALE.EQ.2) THEN
         WRITE(15,'(5A)') 'tit=title(''Path with ', TRIM(ISOMAP),
     &    ' (constant, log scale, ', TRIM(RET),' points)'');'
        ELSE
         WRITE(15,'(5A)') 'tit=title(''Path with ', TRIM(ISOMAP), 
     &    ' (constant, ', TRIM(RET),' points)'');'
        ENDIF
      ELSE
        IF (SCALE.EQ.2) THEN
          WRITE(15,'(5A)')'tit=title(''Path with ', TRIM(ISOMAP), 
     &     ' (log scale, ', TRIM(RET),' points)'');'
        ELSE
          WRITE(15,'(5A)') 'tit=title(''Path with ', TRIM(ISOMAP), 
     &     ' (', TRIM(RET),' points)'');'
        ENDIF
      ENDIF
      WRITE(RET,'(I15)') IGR
      RET=ADJUSTL(RET)
      WRITE(15,'(3A)') 'xl=xlabel(''X(', TRIM(RET),')'');'
      WRITE(RET,'(I15)') JGR
      RET=ADJUSTL(RET)
      WRITE(15,'(3A)') 'yl=ylabel(''X(', TRIM(RET),')'');'
      WRITE(15,'(A)') 'set(gca,''FontSize'',15);'
      WRITE(15,'(A)') 'set(tit,''FontSize'',25);'
      WRITE(15,'(A)') 'set(xl,''FontSize'',15);'
      WRITE(15,'(A)') 'set(yl,''FontSize'',15);'
      RETURN
      $OPTION(CHEOL=';')
      END