* SUBROUTINE UOMVC1                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB AND SCILAB GRAPHICAL VISUALIZATION OF VARIABLES OR CONSTRAINTS - PRINTING OF THE VALUES FOR PLOTTING.
*
* PARAMETERS :
*  II  NY  DECLARED NUMBER OF VARIABLES (NF) OR CONSTRAINTS (NC).
*  II  KBY  SPECIFICATION OF SIMPLE BOUNDS OR GENERAL CONSTRAINTS.
*  RI  Y(NY)  VECTOR OF VARIABLES (X) OR VALUES OF THE CONSTRAINT FUNCTIONS (CF).
*  RI  YL(NY)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES (XL) OR CONSTRAINT FUNCTIONS (CL).
*  RI  YU(NY)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES (XU) OR CONSTRAINT FUNCTIONS (CU).
*  II  IY(NY)  VECTOR CONTAINING TYPES OF BOUNDS (IX) OR CONSTRAINTS (IC).
*  II  STA  START INDEX OF THE VARIABLES OR CONSTRAINTS IN THE GRAPH.
*  II  STO  STOP INDEX OF THE VARIABLES OR CONSTRAINTS IN THE GRAPH.
*  LI  INFO  INFORMATION ABOUT THE CASE: 'V' - VARIABLES, 'C' - CONSTRAINTS.
*  RO  MINIM  MINIMAL VALUE AMONG THE PLOTTING VALUES.
*  RO  MAXIM  MAXIMAL VALUE AMONG THE PLOTTING VALUES.
*  LO  LBOUND  IF THERE EXISTS AT LEAST ONE LOWER BOUND XL OR CL.
*  LO  UBOUND  IF THERE EXISTS AT LEAST ONE UPPER BOUND XU OR CU.
*
      SUBROUTINE UOMVC1
     &  (NY,KBY,Y,YL,YU,IY,STA,STO,INFO,MINIM,MAXIM,LBOUND,UBOUND)
      $OPTION(CHEOL='#')
      INTEGER NY,KBY,IY(NY),STA,STO,I,J,K,WI(10)
      $FLOAT Y(NY),YL(NY),YU(NY),MINIM,MAXIM,TEMP,WY(10)
      CHARACTER INFO
      CHARACTER*250 RET
      LOGICAL LBOUND,UBOUND
C
      MAXIM=-1D60
      MINIM= 1D60
      LBOUND=.FALSE.   ! JESTLI EXISTUJE ALESPON JEDNA DOLNI MEZ
      UBOUND=.FALSE.   ! JESTLI EXISTUJE ALESPON JEDNA HORNI MEZ
      IF (KBY.EQ.0) GOTO 93
      DO I=STA,STO
        IF (IY(I).EQ.1) THEN
          LBOUND=.TRUE.
        ELSEIF (IY(I).EQ.2) THEN
          UBOUND=.TRUE.
        ELSEIF (IY(I).EQ.3.OR.IY(I).EQ.4.OR.IY(I).EQ.5) THEN
          LBOUND=.TRUE.
          UBOUND=.TRUE.
        ENDIF
        IF (LBOUND.AND.UBOUND) GOTO 91
      ENDDO
C INDEXY DOLNICH MEZI
   91 IF (.NOT.LBOUND) GOTO 92
      WRITE(11,'(A)') 'il=['
      J=0
      DO I=STA,STO
        IF (IY(I).EQ.1.OR.IY(I).EQ.3.OR.IY(I).EQ.4.OR.IY(I).EQ.5) THEN
          J=J+1
          WI(J)=I
          IF (J.EQ.10) THEN
            WRITE(RET,'(10I10)') (WI(K),K=1,J)
            WRITE(11,'(2A)') TRIM(RET), ' ...'
            J=0
          ENDIF
        ENDIF
      ENDDO
      IF (J.GT.0) THEN
        WRITE(RET,'(10I10)') (WI(K),K=1,J)
        WRITE(11,'(2A)') TRIM(RET), ' ...'
      ENDIF
      WRITE(11,'(A)') '];'
C HODNOTY DOLNICH MEZI
      IF (INFO.EQ.'V') WRITE(11,'(A)') 'xl=['
      IF (INFO.EQ.'C') WRITE(11,'(A)') 'cl=['
      J=0
      DO I=STA,STO
        IF (IY(I).EQ.1.OR.IY(I).EQ.3.OR.IY(I).EQ.4.OR.IY(I).EQ.5) THEN
          J=J+1
          WY(J)=YL(I)
          IF (J.EQ.10) THEN
            WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
            WRITE(11,'(2A)') TRIM(RET), ' ...'
            TEMP=MINVAL(WY)
            MINIM=MIN(MINIM,TEMP)
            J=0
          ENDIF
        ENDIF
      ENDDO
      IF (J.GT.0) THEN
        WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
        WRITE(11,'(2A)') TRIM(RET), ' ...'
        DO K=1,J
          MINIM=MIN(MINIM,WY(K))
        ENDDO
      ENDIF
      WRITE(11,'(A)') '];'
C INDEXY HORNICH MEZI
   92 IF (.NOT.UBOUND) GOTO 93
      WRITE(11,'(A)') 'iu=['
      J=0
      DO I=STA,STO
        IF (IY(I).EQ.2.OR.IY(I).EQ.3.OR.IY(I).EQ.4.OR.IY(I).EQ.5) THEN
          J=J+1
          WI(J)=I
          IF (J.EQ.10) THEN
            WRITE(RET,'(10I10)') (WI(K),K=1,J)
            WRITE(11,'(2A)') TRIM(RET), ' ...'
            J=0
          ENDIF
        ENDIF
      ENDDO
      IF (J.GT.0) THEN
        WRITE(RET,'(10I10)') (WI(K),K=1,J)
        WRITE(11,'(2A)') TRIM(RET), ' ...'
      ENDIF
      WRITE(11,'(A)') '];'
C HODNOTY HORNICH MEZI
      IF (INFO.EQ.'V') WRITE(11,'(A)') 'xu=['
      IF (INFO.EQ.'C') WRITE(11,'(A)') 'cu=['
      J=0
      DO I=STA,STO
        IF (IY(I).EQ.2.OR.IY(I).EQ.3.OR.IY(I).EQ.4.OR.IY(I).EQ.5) THEN
          J=J+1
          IF (IY(I).EQ.2.AND.KBY.EQ.1.OR.IY(I).EQ.5) THEN
            WY(J)=YL(I)
          ELSE
            WY(J)=YU(I)
          ENDIF
          IF (J.EQ.10) THEN
            WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
            WRITE(11,'(2A)') TRIM(RET), ' ...'
            TEMP=MAXVAL(WY)
            MAXIM=MAX(MAXIM,TEMP)
            J=0
          ENDIF
        ENDIF
      ENDDO
      IF (J.GT.0) THEN
        WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
        WRITE(11,'(2A)') TRIM(RET), ' ...'
        DO K=1,J
          MAXIM=MAX(MAXIM,WY(K))
        ENDDO
      ENDIF
      WRITE(11,'(A)') '];'
C INDEXY PROMENNE X / CF
   93 CONTINUE
      IF (INFO.EQ.'V') WRITE(11,'(A)') 'ix=['
      IF (INFO.EQ.'C') WRITE(11,'(A)') 'ic=['
      J=0
      DO I=STA,STO
        J=J+1
        WI(J)=I
        IF (J.EQ.10) THEN
          WRITE(RET,'(10I10)') (WI(K),K=1,J)
          WRITE(11,'(2A)') TRIM(RET), ' ...'
          J=0
        ENDIF
      ENDDO
      IF (J.GT.0) THEN
        WRITE(RET,'(10I10)') (WI(K),K=1,J)
        WRITE(11,'(2A)') TRIM(RET), ' ...'
      ENDIF
      WRITE(11,'(A)') '];'
C HODNOTY PROMENNE X / CF
      IF (INFO.EQ.'V') WRITE(11,'(A)') 'xi=['
      IF (INFO.EQ.'C') WRITE(11,'(A)') 'ci=['
      J=0
      DO I=STA,STO
        J=J+1
        WY(J)=Y(I)
        MINIM=MIN(MINIM,Y(I))
        MAXIM=MAX(MAXIM,Y(I))
        IF (J.EQ.10) THEN
          WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
          WRITE(11,'(2A)') TRIM(RET), ' ...'
          J=0
        ENDIF
      ENDDO
      IF (J.GT.0) THEN
        WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
        WRITE(11,'(2A)') TRIM(RET), ' ...'
      ENDIF
      WRITE(11,'(A)') '];'
      RETURN
      $OPTION(CHEOL=';')
      END