* SUBROUTINE UOMVC2                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL VISUALIZATION OF VARIABLES OR CONSTRAINTS - PRINTING OF THE PLOTTING INSTRUCTIONS.
*
* PARAMETERS :
*  RI  MINIM  MINIMAL VALUE AMONG PLOTTING VALUES.
*  RI  MAXIM  MAXIMAL VALUE AMONG PLOTTING VALUES.
*  LI  LBOUND  IF THERE EXISTS AT LEAST ONE LOWER BOUND XL OR CL.
*  LI  UBOUND  IF THERE EXISTS AT LEAST ONE UPPER BOUND XU OR CU.
*  II  STA  START INDEX OF THE VARIABLES OR CONSTRAINTS IN THE GRAPH.
*  II  STO  STOP INDEX OF THE VARIABLES OR CONSTRAINTS IN THE GRAPH.
*  LI  INFO  INFORMATION ABOUT THE CASE: 'V' - VARIABLES, 'C' - CONSTRAINTS.
*  II  CISLO  INDICATES THE PARAMETERS OF THE GRAPH.
*
      SUBROUTINE UOMVC2(MINIM,MAXIM,LBOUND,UBOUND,STA,STO,INFO,CISLO)
      $OPTION(CHEOL='#')
      INTEGER STA,STO,CISLO
      $FLOAT MINIM,MAXIM,EPS,TEMP
      CHARACTER INFO
      CHARACTER*16 RETSTA,RETSTO,RET
      CHARACTER*25 RETMIN,RETMAX
      LOGICAL LBOUND,UBOUND
C
      EPS=1.0D-15
      IF (LBOUND.AND.UBOUND) THEN
        IF (INFO.EQ.'V') WRITE(11,'(A)') 'h = plot(il,xl,iu,xu,ix,xi);'
        IF (INFO.EQ.'C') WRITE(11,'(A)') 'h = plot(il,cl,iu,cu,ic,ci);'
        IF (CISLO.EQ.1) THEN
          WRITE(11,'(A)') 'set(h,{''LineStyle''},{''none''});'
        ELSE IF (CISLO.EQ.2) THEN
          WRITE(11,'(A)')
     &      'set(h,{''LineStyle''},{''none'';''none'';''-''});'
          WRITE(11,'(A)') 'set(h,{''LineWidth''},{1});'
          WRITE(11,'(A)') 'set(h,{''Color''},{''r''});'
        ENDIF
        WRITE(11,'(A)') 'set(h,{''Marker''},{''^'';''v'';''o''});'
        WRITE(11,'(A)') 'set(h,{''MarkerSize''},{6;6;6});'
        WRITE(11,'(A)')
     &    'set(h,{''MarkerEdgeColor''},{''b'';''b'';''r''});'
        WRITE(11,'(A)')
     &    'set(h,{''MarkerFaceColor''},{''b'';''b'';''r''});'
      ELSEIF (LBOUND.OR.UBOUND) THEN
        IF (INFO.EQ.'V') THEN
          IF (LBOUND) WRITE(11,'(A)') 'h = plot(il,xl,ix,xi);'
          IF (UBOUND) WRITE(11,'(A)') 'h = plot(iu,xu,ix,xi);'
        ENDIF
        IF (INFO.EQ.'C') THEN
          IF (LBOUND) WRITE(11,'(A)') 'h = plot(il,cl,ic,ci);'
          IF (UBOUND) WRITE(11,'(A)') 'h = plot(iu,cu,ic,ci);'
        ENDIF
        IF (CISLO.EQ.1) THEN
          WRITE(11,'(A)') 'set(h,{''LineStyle''},{''none''});'
        ELSE IF (CISLO.EQ.2) THEN
          WRITE(11,'(A)') 'set(h,{''LineStyle''},{''none'';''-''});'
          WRITE(11,'(A)') 'set(h,{''LineWidth''},{1});'
          WRITE(11,'(A)') 'set(h,{''Color''},{''r''});'
        ENDIF
        IF (LBOUND) WRITE(11,'(A)') 'set(h,{''Marker''},{''^'';''o''});'
        IF (UBOUND) WRITE(11,'(A)') 'set(h,{''Marker''},{''v'';''o''});'
        WRITE(11,'(A)') 'set(h,{''MarkerSize''},{6;6});'
        WRITE(11,'(A)') 'set(h,{''MarkerEdgeColor''},{''b'';''r''});'
        WRITE(11,'(A)') 'set(h,{''MarkerFaceColor''},{''b'';''r''});'
      ELSE
        IF (INFO.EQ.'V') WRITE(11,'(A)') 'h = plot(ix,xi);'
        IF (INFO.EQ.'C') WRITE(11,'(A)') 'h = plot(ic,ci);'
        IF (CISLO.EQ.1) THEN
          WRITE(11,'(A)') 'set(h,{''LineStyle''},{''none''});'
        ELSE IF (CISLO.EQ.2) THEN
          WRITE(11,'(A)') 'set(h,{''LineStyle''},{''-''});'
          WRITE(11,'(A)') 'set(h,{''LineWidth''},{1});'
          WRITE(11,'(A)') 'set(h,{''Color''},{''r''});'
        ENDIF
        WRITE(11,'(A)') 'set(h,{''Marker''},{''o''});'
        WRITE(11,'(A)') 'set(h,{''MarkerSize''},{6});'
        WRITE(11,'(A)') 'set(h,{''MarkerEdgeColor''},{''r''});'
        WRITE(11,'(A)') 'set(h,{''MarkerFaceColor''},{''r''});'
      ENDIF
      IF (CISLO.EQ.1) THEN
        IF (LBOUND) THEN
          IF (STA.EQ.1) THEN
            RET='il(i)'
          ELSE
            WRITE(RET,'(I10)') STA-1
            RET=ADJUSTL(RET)
            RET='il(i)'//'-'//RET(1:LEN_TRIM(RET))
          ENDIF
          WRITE(11,'(A)') 'for i=1:length(il)'
          IF (INFO.EQ.'V') WRITE(11,'(3A)')
     &      'll=line([il(i) il(i)],[xl(i) xi(',TRIM(RET),')]);'
          IF (INFO.EQ.'C') WRITE(11,'(3A)')
     &      'll=line([il(i) il(i)],[cl(i) ci(',TRIM(RET),')]);'
          WRITE(11,'(A)') 'set(ll,{''LineWidth''},{1});'
          WRITE(11,'(A)') 'set(ll,{''Color''},{''b''});'
          WRITE(11,'(A)') 'end'
        ENDIF
        IF (UBOUND) THEN
          IF (STA.EQ.1) THEN
            RET='iu(i)'
          ELSE
            WRITE(RET,'(I10)') STA-1
            RET=ADJUSTL(RET)
            RET='iu(i)'//'-'//RET(1:LEN_TRIM(RET))
          ENDIF
          WRITE(11,'(A)') 'for i=1:length(iu)'
          IF (INFO.EQ.'V') WRITE(11,'(3A)')
     &      'lu=line([iu(i) iu(i)],[xu(i) xi(',TRIM(RET),')]);'
          IF (INFO.EQ.'C') WRITE(11,'(3A)')
     &      'lu=line([iu(i) iu(i)],[cu(i) ci(',TRIM(RET),')]);'
          WRITE(11,'(A)') 'set(lu,{''LineWidth''},{1});'
          WRITE(11,'(A)') 'set(lu,{''Color''},{''b''});'
          WRITE(11,'(A)') 'end'
        ENDIF
      ENDIF
      TEMP=(MAXIM-MINIM)*1.0D-1
      IF ((MAXIM-MINIM).LE.MAX(ABS(MAXIM+MINIM),1.0D0)*EPS) TEMP=EPS
      WRITE(RETSTA,'(I16)') STA-1
      RETSTA=ADJUSTL(RETSTA)
      WRITE(RETSTO,'(I16)') STO+1
      RETSTO=ADJUSTL(RETSTO)
      WRITE(RETMIN,'(D25.16)') MINIM-TEMP
      RETMIN=ADJUSTL(RETMIN)
      WRITE(RETMAX,'(D25.16)') MAXIM+TEMP
      RETMAX=ADJUSTL(RETMAX)
      WRITE(11,'(9A)') 'axis([',TRIM(RETSTA), ' ', TRIM(RETSTO), ' ',
     &  TRIM(RETMIN), ' ', TRIM(RETMAX), ']);'
      IF (INFO.EQ.'V') THEN
        WRITE(11,'(A)') 'tit=title(''Variables'');'
        WRITE(11,'(A)') 'xl=xlabel(''Indices of variables'');'
        WRITE(11,'(A)') 'yl=ylabel(''Bounds and values of variables'');'
      ENDIF
      IF (INFO.EQ.'C') THEN
        WRITE(11,'(A)') 'tit=title(''Constraints'');'
        WRITE(11,'(A)') 'xl=xlabel(''Indices of constraints'');'
        WRITE(11,'(A)')
     &    'yl=ylabel(''Bounds and values of constraints'');'
      ENDIF
      WRITE(11,'(A)') 'set(gca,''FontSize'',15);'
      WRITE(11,'(A)') 'set(tit,''FontSize'',25);'
      WRITE(11,'(A)') 'set(xl,''FontSize'',15);'
      WRITE(11,'(A)') 'set(yl,''FontSize'',15);'
      RETURN
      $OPTION(CHEOL=';')
      END