* SUBROUTINE UOS0G3                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ITERATIONS IN STEPSIZE SELECTION.
*
* PARAMETERS :
*  RI  R  CURRENT VALUE OF THE STEPSIZE PARAMETER.
*  RI  F  CURRENT VALUE OF THE OBJECTIVE FUNCTION.
*  RI  FO  INITIAL VALUE OF THE OBJECTIVE FUNCTION.
*  RI  PO  INITIAL VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RI  PP  VALUE OF THE QUADRATIC TERM.
*  RI  XDEL  TRUST REGION RADIUS.
*  RI  SNORM  NORM OF THE DIRECTION VECTOR.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  TI  TSXX  PRINTED TEXT.
*
      SUBROUTINE UOS0G3(R,F,FO,PO,PP,XDEL,SNORM)
      $INCLUDE ('UMCOMM')
      $FLOAT R,F,FO,PO,PP,XDEL,SNORM
      IF(JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.1) RETURN
      WRITE(IWR,1) R,F,XDEL,SNORM,FO-F,-R*(PO+R*PP)
    1 FORMAT (' ','R=',$P 9.3,1X,'F=',$P 9.3,1X,'D=',$P 9.3,1X,
     & 'S=',$P 9.3,1X,'A=',$P 9.3,1X,'P=',$P 9.3)
      RETURN
      END
