* SUBROUTINE UOS0G4                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ITERATIONS IN STEPSIZE SELECTION.
*
* PARAMETERS :
*  RI  R  CURRENT VALUE OF THE STEPSIZE PARAMETER.
*  RI  F  CURRENT VALUE OF THE OBJECTIVE FUNCTION.
*  RI  RF  RATIO OF ACTUAL AND PREDICTED REDUCTION.
*  RI  XDEL  TRUST REGION RADIUS.
*  RI  SNORM  NORM OF THE DIRECTION VECTOR.
*  II  IPOM3  INTEGER PARAMETER.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*
      SUBROUTINE UOS0G4(R,F,RF,XDEL,SNORM,IPOM3)
      $INCLUDE ('UMCOMM')
      INTEGER IPOM3
      $FLOAT R,F,RF,XDEL,SNORM
      IF(JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.1) RETURN
      WRITE(IWR,1) R,F,XDEL,SNORM,RF,IPOM3
    1 FORMAT (' ','R =',$P 9.3,1X,'F =',$P 9.3,1X,'D=',$P 9.3,1X,
     & 'S=',$P 9.3,1X,'RATI0=',$P 9.3,1X,I3)
      RETURN
      END
