* SUBROUTINE UOSPTH                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  SCILAB GRAPHICAL VISUALIZATION OF THE PATH OF ITERATIONS.
*
* PARAMETERS :
*  II  NPAC  NUMBER OF VALUES FOR PLOTTING.
*  RI  YPA(3*NPAC)  VECTOR CONTAINING VALUES FOR PLOTTING.
*  II  I1  INDEX OF THE 1-ST PLOTTING VARIABLE.
*  II  I2  INDEX OF THE 2-ND PLOTTING VARIABLE.
*  II  I3  INDEX OF THE 3-RD PLOTTING VARIABLE.
*  II  INFO  HOW MANY AND WHAT TYPE OF GRAPHS TO PLOT [MT]
*  II  CISLO  SERIAL NUMBER OF THE MATLAB SOURCE CODE
*  II  GFMT  GRAPHIC FORMAT
*
      SUBROUTINE UOSPTH(NPAC,YPA,I1,I2,I3,INFO,CISLO,GFMT)
      $OPTION(CHEOL='^')
      INTEGER NPAC,I1,I2,I3,INFO,CISLO,GFMT
      $FLOAT YPA(3*NPAC),MINIM,MAXIM,TEMP,EPS
      CHARACTER*25 T1,T2,T3
C
      CALL UOSOPN(15,GFMT)
      CALL UOMPAT(NPAC,YPA,INFO,MINIM,MAXIM)
C
      EPS=1.0D-6
      IF (INFO/10.EQ.0) THEN
C       FUNCTION F
        WRITE(15,'(A)')'plot(x,f);'
        WRITE(15,'(A)')'e=gce();'
        IF (MOD(INFO,10).EQ.1) THEN
          WRITE(15,'(A)')'e.children.line_mode="off";'
          WRITE(15,'(A)')'e.children.mark_mode="on";'
          WRITE(15,'(A)')'e.children.mark_size=4;'
          WRITE(15,'(A)')'e.children.mark_style=9;'
          WRITE(15,'(A)')'e.children.mark_foreground=2;'
          WRITE(15,'(A)')'e.children.mark_background=2;'
        ELSEIF (MOD(INFO,10).EQ.2) THEN
          WRITE(15,'(A)')'e.children.line_mode="on";'
          WRITE(15,'(A)')'e.children.mark_mode="off";'
          WRITE(15,'(A)')'e.children.polyline_style=1;'
          WRITE(15,'(A)')'e.children.line_style=1;'
          WRITE(15,'(A)')'e.children.thickness=2;'
          WRITE(15,'(A)')'e.children.foreground=2;'
        ENDIF
        WRITE(15,'(A)')'title(''Iterations of F'',''fontsize'',5);'
      ELSEIF (INFO/10.EQ.1) THEN
C       X(I1)
        WRITE(15,'(A)')'plot(x,x1);'
        WRITE(15,'(A)')'e=gce();'
        IF (MOD(INFO,10).EQ.1) THEN
          WRITE(15,'(A)')'e.children(1).line_mode="off";'
          WRITE(15,'(A)')'e.children(1).mark_mode="on";'
          WRITE(15,'(A)')'e.children(1).mark_size=4;'
          WRITE(15,'(A)')'e.children(1).mark_style=9;'
          WRITE(15,'(A)')'e.children(1).mark_foreground=2;'
          WRITE(15,'(A)')'e.children(1).mark_background=2;'
        ELSEIF (MOD(INFO,10).EQ.2) THEN
          WRITE(15,'(A)')'e.children(1).line_mode="on";'
          WRITE(15,'(A)')'e.children(1).mark_mode="off";'
          WRITE(15,'(A)')'e.children(1).polyline_style=1;'
          WRITE(15,'(A)')'e.children(1).line_style=1;'
          WRITE(15,'(A)')'e.children(1).thickness=2;'
          WRITE(15,'(A)')'e.children(1).foreground=2;'
        ENDIF
        WRITE(T1,'(I10)')I1
        T1=ADJUSTL(T1)
        WRITE(15,'(3A)')
     &   'title(''$$\textrm{Iterations of \textcolor{blue}{X(',
     &   TRIM(T1),')}}$$'',''fontsize'',5);'
      ELSEIF (INFO/10.EQ.2) THEN
C       X(I1), X(I2)
        WRITE(15,'(A)')'plot(x,x1,x,x2);'
        WRITE(15,'(A)')'e=gce();'
        IF (MOD(INFO,10).EQ.1) THEN
          WRITE(15,'(A)')'e.children(1).line_mode="off";'
          WRITE(15,'(A)')'e.children(1).mark_mode="on";'
          WRITE(15,'(A)')'e.children(1).mark_size=4;'
          WRITE(15,'(A)')'e.children(1).mark_style=9;'
          WRITE(15,'(A)')'e.children(1).mark_foreground=5;'
          WRITE(15,'(A)')'e.children(1).mark_background=5;'
          WRITE(15,'(A)')'e.children(2).line_mode="off";'
          WRITE(15,'(A)')'e.children(2).mark_mode="on";'
          WRITE(15,'(A)')'e.children(2).mark_size=4;'
          WRITE(15,'(A)')'e.children(2).mark_style=9;'
          WRITE(15,'(A)')'e.children(2).mark_foreground=2;'
          WRITE(15,'(A)')'e.children(2).mark_background=2;'
        ELSEIF (MOD(INFO,10).EQ.2) THEN
          WRITE(15,'(A)')'e.children(1).line_mode="on";'
          WRITE(15,'(A)')'e.children(1).mark_mode="off";'
          WRITE(15,'(A)')'e.children(1).polyline_style=1;'
          WRITE(15,'(A)')'e.children(1).line_style=3;'
          WRITE(15,'(A)')'e.children(1).thickness=2;'
          WRITE(15,'(A)')'e.children(1).foreground=5;'
          WRITE(15,'(A)')'e.children(2).line_mode="on";'
          WRITE(15,'(A)')'e.children(2).mark_mode="off";'
          WRITE(15,'(A)')'e.children(2).polyline_style=1;'
          WRITE(15,'(A)')'e.children(2).line_style=1;'
          WRITE(15,'(A)')'e.children(2).thickness=2;'
          WRITE(15,'(A)')'e.children(2).foreground=2;'
        ENDIF
        WRITE(T1,'(I10)')I1
        T1=ADJUSTL(T1)
        WRITE(T2,'(I10)')I2
        T2=ADJUSTL(T2)
        WRITE(15,'(5A)')
     &   'title(''$$\textrm{Iterations of \textcolor{blue}{X(',
     &   TRIM(T1),')}, \textcolor{red}{X(',TRIM(T2),
     &   ')}}$$'',''fontsize'',5);'
      ELSEIF (INFO/10.EQ.3) THEN
C       X(I1), X(I2), X(I3)
        WRITE(15,'(A)')'plot(x,x1,x,x2,x,x3);'
        WRITE(15,'(A)')'e=gce();'
        IF (MOD(INFO,10).EQ.1) THEN
          WRITE(15,'(A)')'e.children(1).line_mode="off";'
          WRITE(15,'(A)')'e.children(1).mark_mode="on";'
          WRITE(15,'(A)')'e.children(1).mark_size=4;'
          WRITE(15,'(A)')'e.children(1).mark_style=9;'
          WRITE(15,'(A)')'e.children(1).mark_foreground=13;'
          WRITE(15,'(A)')'e.children(1).mark_background=13;'
          WRITE(15,'(A)')'e.children(2).line_mode="off";'
          WRITE(15,'(A)')'e.children(2).mark_mode="on";'
          WRITE(15,'(A)')'e.children(2).mark_size=4;'
          WRITE(15,'(A)')'e.children(2).mark_style=9;'
          WRITE(15,'(A)')'e.children(2).mark_foreground=5;'
          WRITE(15,'(A)')'e.children(2).mark_background=5;'
          WRITE(15,'(A)')'e.children(3).line_mode="off";'
          WRITE(15,'(A)')'e.children(3).mark_mode="on";'
          WRITE(15,'(A)')'e.children(3).mark_size=4;'
          WRITE(15,'(A)')'e.children(3).mark_style=9;'
          WRITE(15,'(A)')'e.children(3).mark_foreground=2;'
          WRITE(15,'(A)')'e.children(3).mark_background=2;'
        ELSEIF (MOD(INFO,10).EQ.2) THEN
          WRITE(15,'(A)')'e.children(1).line_mode="on";'
          WRITE(15,'(A)')'e.children(1).mark_mode="off";'
          WRITE(15,'(A)')'e.children(1).polyline_style=1;'
          WRITE(15,'(A)')'e.children(1).line_style=4;'
          WRITE(15,'(A)')'e.children(1).thickness=2;'
          WRITE(15,'(A)')'e.children(1).foreground=13;'
          WRITE(15,'(A)')'e.children(2).line_mode="on";'
          WRITE(15,'(A)')'e.children(2).mark_mode="off";'
          WRITE(15,'(A)')'e.children(2).polyline_style=1;'
          WRITE(15,'(A)')'e.children(2).line_style=3;'
          WRITE(15,'(A)')'e.children(2).thickness=2;'
          WRITE(15,'(A)')'e.children(2).foreground=5;'
          WRITE(15,'(A)')'e.children(3).line_mode="on";'
          WRITE(15,'(A)')'e.children(3).mark_mode="off";'
          WRITE(15,'(A)')'e.children(3).polyline_style=1;'
          WRITE(15,'(A)')'e.children(3).line_style=1;'
          WRITE(15,'(A)')'e.children(3).thickness=2;'
          WRITE(15,'(A)')'e.children(3).foreground=2;'
        ENDIF
        WRITE(T1,'(I10)')I1
        T1=ADJUSTL(T1)
        WRITE(T2,'(I10)')I2
        T2=ADJUSTL(T2)
        WRITE(T3,'(I10)')I3
        T3=ADJUSTL(T3)
        WRITE(15,'(7A)')
     &   'title(''$$\textrm{Iterations of \textcolor{blue}{X(',
     &   TRIM(T1),')}, \textcolor{red}{X(',TRIM(T2),
     &   ')}, \textcolor{0,0.5,0}{X(',TRIM(T3),
     &   ')}}$$'',''fontsize'',5);'
      ENDIF
C
      WRITE(15,'(A)')'set(gca(),"grid",[1 1]);'
      WRITE(15,'(A)')'a=gca();'
      WRITE(15,'(A)')'a.font_size=4;'
      WRITE(T1,'(I10)')NPAC
      T1=ADJUSTL(T1)
      TEMP=(MAXIM-MINIM)*1.0D-1
      IF ((MAXIM-MINIM).LE.MAX(ABS(MAXIM+MINIM),1.0D0)*EPS) TEMP=EPS
      WRITE(T2,'(D25.16)') MINIM-TEMP
      T2=ADJUSTL(T2)
      WRITE(T3,'(D25.16)') MAXIM+TEMP
      T3=ADJUSTL(T3)
      WRITE(15,'(7A)')'a.zoom_box=[1 ',TRIM(T2),' ',
     & TRIM(T1),' ',TRIM(T3),'];'
      WRITE(15,'(A)')'a.thickness=0.5;'
      WRITE(15,'(A)')'xlabel(''Iteration'',''fontsize'',4);'
      WRITE(15,'(A)')'ylabel(''Values'',''fontsize'',4);'
      CALL UOSGRX(15,'PSPTH',CISLO,GFMT)
      RETURN
      $OPTION(CHEOL=';')
      END
