$INTERFACE UOSRF3                                             10/12/01

  $FTH='FTH'
  $IF(PATH='YES')
    $DIM=2
  $ELSE
    $IF(GRAPH='INTERNAL')
      $DIM=NF
    $ELSE
      $DIM=3
    $ENDIF  
  $ENDIF
  $ADD(INTEGER,'\NFV1\NAV1') 
  $ADD(REAL4,'\$FL($NGR,$NGR)\$FTH($NGR,2)\$XPA($NPA,$DIM)')
  $ADD(REAL,'\$X($NF)')
      $IF(NA>0)
        CALL UXVCOP(NA,$AF,$AFO)
        $ADD(REAL,'\$AFO($NA)')
      $ENDIF
$REM      IF (NF.LE.1) THEN
$REM      WRITE(15,'(2I5)') 0,0
$REM      GO TO $LGR
$REM      ELSE
$REM      WRITE(15,'(2I5)') 1,NGR
$REM      ENDIF
  $50 CONTINUE
      CALL UOSRF3(NF,$X,$XPA,$FL,F,FO,$ETA9,$OBR,$JOB)
      GOTO ($60,$70) ISB+1
  $60 CONTINUE
      $IF(NA>0)
        CALL UXVCOP(NA,$AFO,$AF)
      $ENDIF
      GOTO $LGR
  $70 CONTINUE
      NFV1=NFV
      NAV1=NAV
      $SUBST('UZMODL')
      NFV=NFV1
      NAV=NAV1
      GOTO $50
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOSRF3                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  SCILAB GRAPHICAL OUTPUT - PATH.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XPA(NPA,2)  VALUES OF SELECTED VARIABLES.
*  RO  FL(NGR,NGR)  FIELD OF DRAWN FUNCTION VALUES.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  FO  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA9  MAXIMUM MACHINE CONSTANT.
*  RI  GFMT  GRAPHIC FORMAT: 0=INTERNAL GRAPHICS,
*                            1=EXTERNAL GRAPHICS (*.EPS FILES),
*                            2=EXTERNAL GRAPHICS (*.PNG FILES).
*  II  JOB  JOB=1 IF PATH=YES, JOB=2 IF PATH=EXTENDED
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
      SUBROUTINE UOSRF3(NF,X,XPA,FL,F,FO,ETA9,GFMT,JOB)
      $INCLUDE ('UMCOMM')
      $INCLUDE ('UMCOMG')
      INTEGER NF,GFMT,JOB
      REAL*4 FL(NGR,NGR),XPA(NPA,*)
      $FLOAT X(NF),F,FO,ETA9
      $FLOAT STIGR,STJGR
      $FLOAT CON1,CON2
      LOGICAL VYPISF
      PARAMETER(CON1=1.0$P-60,CON2=1.0$P 60)
      INTEGER IVAR,JVAR,I,IPAC,NPAC,INFO,CISLOGRAFU,LEVEL,SCALE,II,JJ
      SAVE IVAR,JVAR,IPAC,NPAC,STIGR,STJGR
      SAVE INFO,LEVEL,SCALE
C
      IF (TSS(NS).NE.'UYXX') CALL UYPRO1('UYXX',0)
      GO TO (1,4) ISP(NS)
    1 CONTINUE
      IF (JOB.EQ.2) THEN
        IF (NF.LE.2) THEN
          IGR=1
          JGR=NF
        ELSE
   11     WRITE(*,'(A)') 'INDEX OF THE 1-ST VARIABLE:'
          READ(*,*,ERR=11) IGR
          IF (IGR.LE.0.OR.IGR.GT.NF) GO TO 11
   12     WRITE(*,'(A)') 'INDEX OF THE 2-ND VARIABLE:'
          READ(*,*,ERR=12) JGR
          IF (JGR.LE.0.OR.JGR.GT.NF.OR.JGR.EQ.IGR) GO TO 12
        ENDIF
      ENDIF
C
   21 CONTINUE
      IPA=MIN(NPA,NIT)   ! NUMBER OF POINTS
      LEVEL=16
      CALL UOMSCR('I',IPA,JOB,0,0,0,GFMT,0,0,INFO,LEVEL,SCALE)
      IF (INFO.EQ.0) GOTO 5
      IF (INFO.EQ.-1) GOTO 1
C
C     COMPUTATION OF BOUNDS
C
      NPAC=MIN(NPA,NIT)
      IPAC=MAX(NPAC-IPA+1,1)
      XLIGR=X(IGR)
      XUIGR=X(IGR)
      XLJGR=X(JGR)
      XUJGR=X(JGR)
      IF (JOB.EQ.1) THEN
        II=1
        JJ=2
      ELSE
        II=IGR
        JJ=JGR
      ENDIF
      DO I=IPAC,NPAC
        XLIGR=MIN(XLIGR,$DBLE(XPA(I,II)))
        XUIGR=MAX(XUIGR,$DBLE(XPA(I,II)))
        XLJGR=MIN(XLJGR,$DBLE(XPA(I,JJ)))
        XUJGR=MAX(XUJGR,$DBLE(XPA(I,JJ)))
      ENDDO
      STIGR=MAX((XUIGR-XLIGR)/TEN,(XUIGR+XLIGR)*1D-6,1.0D-16)
      STJGR=MAX((XUJGR-XLJGR)/TEN,(XUJGR+XLJGR)*1D-6,1.0D-16)
      XLIGR=XLIGR-STIGR
      XUIGR=XUIGR+STIGR
      XLJGR=XLJGR-STJGR
      XUJGR=XUJGR+STJGR
      FO=F
      XIGR=X(IGR)
      XJGR=X(JGR)
      STIGR=(XUIGR-XLIGR)/(NGR-1)
      STJGR=(XUJGR-XLJGR)/(NGR-1)
      VALMIN= ETA9
      VALMAX=-ETA9
      IVAR=0
    2 IVAR=IVAR+1
      X(IGR)=XLIGR+(IVAR-1)*STIGR
      JVAR=0
    3 JVAR=JVAR+1
      X(JGR)=XLJGR+(JVAR-1)*STJGR
      CALL UYSET2
      CALL UYSET0(1,2)
      RETURN
    4 CONTINUE
      IF (ABS(F).GE.CON2) THEN
      FL(IVAR,JVAR)=SIGN(CON2,F)
      ELSE IF (ABS(F).LE.CON1) THEN
      FL(IVAR,JVAR)=SIGN(CON1,F)
      ELSE
      FL(IVAR,JVAR)=F
      ENDIF
      IF (FL(IVAR,JVAR).LT.VALMIN) THEN
      VALMIN=FL(IVAR,JVAR)
      IMIN=IVAR
      JMIN=JVAR
      ENDIF
      IF (FL(IVAR,JVAR).GT.VALMAX) VALMAX=FL(IVAR,JVAR)
      IF (JVAR.LT.NGR) GO TO 3
      IF (IVAR.LT.NGR) GO TO 2
      X(IGR)=XIGR
      X(JGR)=XJGR
      F=FO
C
      VYPISF=.FALSE.
      CISLOGRAFU=10+MOD(INFO,10)
      IF (JOB.EQ.1) THEN
        IF (INFO/10.EQ.1.OR.INFO/10.EQ.12)
     &    CALL UOSPWI(IPAC,NPAC,NGR,IGR,JGR,XIGR,XJGR,
     &    XLIGR,XUIGR,XLJGR,XUJGR,XPA(:,1),XPA(:,2),
     &    FL,VYPISF,LEVEL,SCALE,CISLOGRAFU,GFMT)
        IF (INFO/10.EQ.2.OR.INFO/10.EQ.12)
     &    CALL UOSPWM(IPAC,NPAC,NGR,IGR,JGR,XIGR,XJGR,
     &    XLIGR,XUIGR,XLJGR,XUJGR,XPA(:,1),XPA(:,2),
     &    FL,VYPISF,LEVEL,SCALE,CISLOGRAFU,GFMT)
      ELSE
        IF (INFO/10.EQ.1.OR.INFO/10.EQ.12)
     &    CALL UOSPWI(IPAC,NPAC,NGR,IGR,JGR,XIGR,XJGR,
     &    XLIGR,XUIGR,XLJGR,XUJGR,XPA(:,IGR),XPA(:,JGR),
     &    FL,VYPISF,LEVEL,SCALE,CISLOGRAFU,GFMT)
        IF (INFO/10.EQ.2.OR.INFO/10.EQ.12)
     &    CALL UOSPWM(IPAC,NPAC,NGR,IGR,JGR,XIGR,XJGR,
     &    XLIGR,XUIGR,XLJGR,XUJGR,XPA(:,IGR),XPA(:,JGR),
     &    FL,VYPISF,LEVEL,SCALE,CISLOGRAFU,GFMT)
      ENDIF
      IF (GFMT.EQ.0) GOTO 21
    5 CONTINUE
      CALL UYEPI1(0)
      RETURN
      END

