* SUBROUTINE UOSVC2                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  SCILAB GRAPHICAL VISUALIZATION OF VARIABLES OR CONSTRAINTS - PRINTING OF THE PLOTTING INSTRUCTIONS.
*
* PARAMETERS :
*  RI  MINIM  MINIMAL VALUE AMONG PLOTTING VALUES.
*  RI  MAXIM  MAXIMAL VALUE AMONG PLOTTING VALUES.
*  LI  LBOUND  IF THERE EXISTS AT LEAST ONE LOWER BOUND XL OR CL.
*  LI  UBOUND  IF THERE EXISTS AT LEAST ONE UPPER BOUND XU OR CU.
*  II  STA  START INDEX OF THE VARIABLES OR CONSTRAINTS IN THE GRAPH.
*  II  STO  STOP INDEX OF THE VARIABLES OR CONSTRAINTS IN THE GRAPH.
*  LI  INFO  INFORMATION ABOUT THE CASE: 'V' - VARIABLES, 'C' - CONSTRAINTS.
*  II  CISLO  INDICATES THE PARAMETERS OF THE GRAPH.
*
      SUBROUTINE UOSVC2(MINIM,MAXIM,LBOUND,UBOUND,STA,STO,INFO,CISLO)
      $OPTION(CHEOL='#')
      INTEGER STA,STO,CISLO
      $FLOAT MINIM,MAXIM,EPS,TEMP
      CHARACTER INFO
      CHARACTER*16 RETSTA,RETSTO
      CHARACTER*25 RETMIN,RETMAX
      LOGICAL LBOUND,UBOUND
C
      EPS=1.0D-6
      IF (INFO.EQ.'V') THEN
        IF (LBOUND.AND.UBOUND) THEN
          WRITE(11,'(A)') 'plot(iu,xu,il,xl,ix,xi);'
        ELSEIF (LBOUND) THEN
          WRITE(11,'(A)') 'plot(il,xl,ix,xi);'
        ELSEIF (UBOUND) THEN
          WRITE(11,'(A)') 'plot(iu,xu,ix,xi);'
        ELSE
          WRITE(11,'(A)') 'plot(ix,xi);'
        ENDIF
      ENDIF
      IF (INFO.EQ.'C') THEN
        IF (LBOUND.AND.UBOUND) THEN
          WRITE(11,'(A)') 'plot(iu,cu,il,cl,ic,ci);'
        ELSEIF (LBOUND) THEN
          WRITE(11,'(A)') 'plot(il,cl,ic,ci);'
        ELSEIF (UBOUND) THEN
          WRITE(11,'(A)') 'plot(iu,cu,ic,ci);'
        ELSE
          WRITE(11,'(A)') 'plot(ic,ci);'
        ENDIF
      ENDIF
      WRITE(11,'(A)') 'p=get("hdl");'
      IF (CISLO.EQ.1) THEN
        WRITE(11,'(A)') 'p.children(1).line_mode="off";'
      ELSE IF (CISLO.EQ.2) THEN
        WRITE(11,'(A)') 'p.children(1).line_mode="on";'
        WRITE(11,'(A)') 'p.children(1).polyline_style=1;'
        WRITE(11,'(A)') 'p.children(1).line_style=1;'
        WRITE(11,'(A)') 'p.children(1).thickness=1;'
        WRITE(11,'(A)') 'p.children(1).foreground=5;'
      ENDIF
      WRITE(11,'(A)') 'p.children(1).mark_mode="on";'
      WRITE(11,'(A)') 'p.children(1).mark_size=6;'
      WRITE(11,'(A)') 'p.children(1).mark_style=9;'
      WRITE(11,'(A)') 'p.children(1).mark_foreground=5;'
      WRITE(11,'(A)') 'p.children(1).mark_background=5;'
      IF (LBOUND) THEN
        WRITE(11,'(A)') 'p.children(2).line_mode="off";'
        WRITE(11,'(A)') 'p.children(2).mark_mode="on";'
        WRITE(11,'(A)') 'p.children(2).mark_size=12;'
        WRITE(11,'(A)') 'p.children(2).mark_style=6;'
        WRITE(11,'(A)') 'p.children(2).mark_foreground=2;'
        WRITE(11,'(A)') 'p.children(2).mark_background=2;'
      ENDIF
      IF (.NOT.LBOUND.AND.UBOUND) THEN
        WRITE(11,'(A)') 'p.children(2).line_mode="off";'
        WRITE(11,'(A)') 'p.children(2).mark_mode="on";'
        WRITE(11,'(A)') 'p.children(2).mark_size=12;'
        WRITE(11,'(A)') 'p.children(2).mark_style=7;'
        WRITE(11,'(A)') 'p.children(2).mark_foreground=2;'
        WRITE(11,'(A)') 'p.children(2).mark_background=2;'
      ELSEIF (LBOUND.AND.UBOUND) THEN
        WRITE(11,'(A)') 'p.children(3).line_mode="off";'
        WRITE(11,'(A)') 'p.children(3).mark_mode="on";'
        WRITE(11,'(A)') 'p.children(3).mark_size=12;'
        WRITE(11,'(A)') 'p.children(3).mark_style=7;'
        WRITE(11,'(A)') 'p.children(3).mark_foreground=2;'
        WRITE(11,'(A)') 'p.children(3).mark_background=2;'
      ENDIF
      IF (CISLO.EQ.1) THEN
        IF (LBOUND) THEN
          WRITE(11,'(A)') 'for i=1:length(il)'
          IF (INFO.EQ.'V')
     &      WRITE(11,'(A)') 'plot([il(i) il(i)],[xl(i) xi(il(i))]);'
          IF (INFO.EQ.'C')
     &      WRITE(11,'(A)') 'plot([il(i) il(i)],[cl(i) ci(il(i))]);'
          WRITE(11,'(A)') 'pl=get("hdl");'
          WRITE(11,'(A)') 'pl.children.line_mode="on";'
          WRITE(11,'(A)') 'pl.children.polyline_style=1;'
          WRITE(11,'(A)') 'pl.children.line_style=1;'
          WRITE(11,'(A)') 'pl.children.thickness=1;'
          WRITE(11,'(A)') 'pl.children.foreground=2;'
          WRITE(11,'(A)') 'end'
        ENDIF
        IF (UBOUND) THEN
          WRITE(11,'(A)') 'for i=1:length(iu)'
          IF (INFO.EQ.'V')
     &      WRITE(11,'(A)') 'plot([iu(i) iu(i)],[xu(i) xi(iu(i))]);'
          IF (INFO.EQ.'C')
     &      WRITE(11,'(A)') 'plot([iu(i) iu(i)],[cu(i) ci(iu(i))]);'
          WRITE(11,'(A)') 'pu=get("hdl");'
          WRITE(11,'(A)') 'pu.children.line_mode="on";'
          WRITE(11,'(A)') 'pu.children.polyline_style=1;'
          WRITE(11,'(A)') 'pu.children.line_style=1;'
          WRITE(11,'(A)') 'pu.children.thickness=1;'
          WRITE(11,'(A)') 'pu.children.foreground=2;'
          WRITE(11,'(A)') 'end'
        ENDIF
      ENDIF
      WRITE(11,'(A)') 'a=gca();'
      WRITE(11,'(A)') 'a.font_size=3;'
      TEMP=(MAXIM-MINIM)*1.0D-1
      IF ((MAXIM-MINIM).LE.MAX(ABS(MAXIM+MINIM),1.0D0)*EPS) TEMP=EPS
      WRITE(RETSTA,'(I16)') STA-1
      RETSTA=ADJUSTL(RETSTA)
      WRITE(RETSTO,'(I16)') STO+1
      RETSTO=ADJUSTL(RETSTO)
      WRITE(RETMIN,'(D25.16)') MINIM-TEMP
      RETMIN=ADJUSTL(RETMIN)
      WRITE(RETMAX,'(D25.16)') MAXIM+TEMP
      RETMAX=ADJUSTL(RETMAX)
      WRITE(11,'(9A)') 'a.zoom_box=[', TRIM(RETSTA), ' ', TRIM(RETMIN),
     &    ' ', TRIM(RETSTO), ' ', TRIM(RETMAX), '];'
      IF (INFO.EQ.'V') THEN
        WRITE(11,'(A)') 'title(''Variables'',''fontsize'',5);'
        WRITE(11,'(A)')
     &    'xlabel(''Indices of variables'',''fontsize'',3);'
        WRITE(11,'(A)')
     &    'ylabel(''Bounds and values of variables'',''fontsize'',3);'
      ENDIF
      IF (INFO.EQ.'C') THEN
        WRITE(11,'(A)') 'title(''Constraints'',''fontsize'',5);'
        WRITE(11,'(A)')
     &    'xlabel(''Indices of constraints'',''fontsize'',3);'
        WRITE(11,'(A)')
     &    'ylabel(''Bounds and values of constraints'',''fontsize'',3);'
      ENDIF
      RETURN
      $OPTION(CHEOL=';')
      END