* SUBROUTINE UOYAD3                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF INFORMATION ON CONSTRAINT ADDITION.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*  II  IER  INFORMATION FROM CONSTRAINT ADDITION.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  LEVEL OF PRINT. LOUT=0-PRINT OF SCALAR VALUES.
*         LOUT=1-ADDITIONAL PRINT OF BASIC VECTORS.
*         LOUT=2-ADDITIONAL PRINT OF OTHER VECTORS.
*         LOUT=3-ADDITIONAL PRINT OF MATRICES.
*
      SUBROUTINE UOYAD3(NF,N,IX,INEW,IER)
      $INCLUDE('UMCOMM')
      INTEGER NF,N,IX(NF),INEW,IER
      INTEGER I
      IF(JOUT.EQ.0) RETURN
      IF(ABS(KOUT).LE.3) RETURN
      IF(IER.LT.0.OR.IER.GT.1) RETURN
      WRITE(IWR,1) INEW,N
    1 FORMAT(' ','NEW=',I3,2X,'N=',I3)
      IF(IER.NE.0) RETURN
      IF(ABS(LOUT).GE.2.AND.KBF.GT.0) THEN
      WRITE(IWR,3) (IX(I),I=1,MIN(NF,50))
    3 FORMAT(' ','IX  =',10I7:/(6X,10I7))
      ENDIF
      WRITE(IWR,8) N,IER
    8 FORMAT(' ','END OF CONSTRAINT ADDITION : N = ',I3,3X,'IER = ',I3)
      RETURN
      END
