* SUBROUTINE UOYAD6                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF INFORMATION ON CONSTRAINT ADDITION.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES
*  II  NC  NUMBER OF LINEAR CONSTRAINTS.
*  II  MMAX  MAXIMUM NUMBER OF NONZERO ELEMENTS.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  II  ICA(NF)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  CR(MMAX)  TRIANGULAR DECOMPOSITION OF KERNEL OF THE
*         ORTHOGONAL PROJECTION.
*  II  ICR(NF+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD CR.
*  II  JCR(MMAX) COLUMN INDICES OF ELEMENTS IN THE FIELD CR.
*  RI  CZ(NF)  VECTOR OF LAGRANGE MULTIPLIERS.
*  RO  GMAX  NORM OF THE TRANSFORMED GRADIENT.
*  RI  UMAX  MAXIMUN ABSOLUTE VALUE OF THE NEGATIVE LAGRANGE MULTIPLIER.
*  II  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*  II  IER  INFORMATION FROM CONSTRAINT ADDITION.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  LEVEL OF PRINT. LOUT=0-PRINT OF SCALAR VALUES.
*         LOUT=1-ADDITIONAL PRINT OF BASIC VECTORS.
*         LOUT=2-ADDITIONAL PRINT OF OTHER VECTORS.
*         LOUT=3-ADDITIONAL PRINT OF MATRICES.
*
      SUBROUTINE UOYAD6(NF,N,NC,MMAX,IX,IC,ICA,CR,ICR,JCR,CZ,UMAX,GMAX,
     & INEW,IER)
      $INCLUDE('UMCOMM')
      INTEGER NF,N,NC,MMAX,IX(NF),IC(NC),ICA(NF),ICR(NF+1),JCR(MMAX),
     & INEW,IER
      $FLOAT CR(MMAX),CZ(NF),UMAX,GMAX
      INTEGER I
      IF(JOUT.EQ.0) RETURN
      IF(ABS(KOUT).LE.3) RETURN
      IF(IER.LT.0.OR.IER.GT.1) RETURN
      WRITE(IWR,1) INEW,N,UMAX,GMAX
    1 FORMAT(' ','NEW=',I3,2X,'N=',I3,2X,'U =',$P 9.3,1X,'G =',$P 9.3)
      IF(IER.NE.0) RETURN
      IF(ABS(LOUT).GE.1) THEN
      WRITE(IWR,2) (ICA(I),I=1,MIN(NF-N,50))
    2 FORMAT(' ','ICA =',10I7:/(6X,10I7))
      ENDIF
      IF(ABS(LOUT).GE.2.AND.KBF.GT.0) THEN
      WRITE(IWR,3) (IX(I),I=1,MIN(NF,50))
    3 FORMAT(' ','IX  =',10I7:/(6X,10I7))
      ENDIF
      IF(ABS(LOUT).GE.2.AND.KBC.GT.0) THEN
      WRITE(IWR,4) (IC(I),I=1,MIN(NC,50))
    4 FORMAT(' ','IC  =',10I7:/(6X,10I7))
      ENDIF
      IF(ABS(LOUT).GE.2) WRITE(IWR,5) (CZ(I),I=1,MIN(NF-N,25))
    5 FORMAT(' ','CZ  =',5$P 14.5:/(6X,5$P 14.5))
      IF(ABS(LOUT).GE.3) THEN
      WRITE(IWR,6) (CR(I),I=1,MIN(ICR(NF-N+1)-1,30))
    6 FORMAT(' ','CR  =',5$P 14.5:/(6X,5$P 14.5))
      WRITE(IWR,7) (JCR(I),I=1,MIN(ICR(NF-N+1)-1,50))
    7 FORMAT(' ','JCR =',10I7:/(6X,10I7))
      ENDIF
      WRITE(IWR,8) N,IER
    8 FORMAT(' ','END OF CONSTRAINT ADDITION : N = ',I3,3X,'IER = ',I3)
      RETURN
      END
