$INTERFACE UP0SA9                                             97/12/01

  CALL UP0SA9(NC,$CF,$IC,$CL,$CU,$CP,FC,F)
  $ADD(REAL,'\$CF($NC+1)\$CL($NC)\$CU($NC)\$CP($NC)')
$REM  $ADD(REAL,'\FC\F')
  $ADD(INTEGER,'\$IC($NC)')
$REM  $ADD(INTEGER,'\NC')
  $ADD(INIT)
    NPFX='UP0SA9'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UP0SA9             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE  OF THE L1 EXACT PENALTY FUNCTION.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINTS.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF THE CONSTRAINTS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CP(NC)  VECTOR CONTAINING PENALTY PARAMETERS.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE PENALTY FUNCTION.
*
      SUBROUTINE UP0SA9(NC,CF,IC,CL,CU,CP,FC,F)
      INTEGER NC,IC(NC)
      $FLOAT CF(NC+1),CL(NC),CU(NC),CP(NC),FC,F
      $FLOAT POM,TEMP
      INTEGER KC
      FC=0.0$P 0
      DO 1 KC=1,NC
      IF (IC(KC).GT.0) THEN
      POM=0.0$P 0
      TEMP=CF(KC)
      IF (IC(KC).EQ.1.OR.IC(KC).GE.3) POM=MIN(POM,TEMP-CL(KC))
      IF (IC(KC).EQ.2.OR.IC(KC).GE.3) POM=MIN(POM,CU(KC)-TEMP)
      IF (POM.LT.0.0$P 0) THEN
      FC=FC-CP(KC)*POM
      ENDIF
      ENDIF
    1 CONTINUE
      F=CF(NC+1)+FC
      RETURN
      END
