$INTERFACE UP1MX2                                             97/12/01

  $SUBST('UZCSET')
  $HELP
    TYPE OF EXTREMUM:
       0 - MINIMUM
       1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
$REM  $ADD(REAL,'\F')
  $ADD(REAL,'\$AF(2*$NC+1)')
$REM  $ADD(INTEGER,'\NC\KA\KAP\KC\KCP')
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ---------------------------
*     PENALTY FUNCTION DEFINITION
*     ---------------------------
*
$OPTION(CHDIR=CHPOM)
 $00  CALL UP1MX2(NC,KA,KAP,KC,KCP,$AF,F)
      GOTO ($80,$10,$20,$40,$50) ISB+1
 $10  CONTINUE
      $MTYPE=FMODF
      $SUBST('UZFMOD')
      $SUBST('UCSVF2')
      GO TO $00
 $20  CONTINUE
      $IF(GMODF='G')
        $MTYPE='G'
        $SUBST('UZFMOD')
        $SUBST('UCSVG2')
        GO TO $00
      $ELSEIF(FMODF='F')
        $HELP
          METHOD FOR DETERMINATION OF DIFFERENCE USED FOR
          NUMERICAL COMPUTATION OF GRADIENT:
            0 - CONSTANT DIFFERENCE
            1 - EASY COMPARATIVE METHOD
            2 - STEWART'S METHOD.
        $CHECK(MCG,2,'0\1\2',3)
        $IF(MCG=0)
          $SUBST('UF0G$(CON)1')
        $ELSE
          $SUBST('UF0G$(CON)2')
        $ENDIF
        GOTO ($90,$30) ISB+1
 $30  CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $20
 $90  CONTINUE
        $SUBST('UCSVG2')
        GO TO $00
      $ENDIF
 $40  CONTINUE
      $IF(SAVC>-1)
        IF(LDC.GE.0) THEN
        FC=$CF(KC)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNF1')
        $IF(ISNC>0)
          $SUBST('UCSVF1')
        $ENDIF
        $SUBST('UCSVF2')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<0)
        $IF(NCL<NC)
          $MTYPE=FMODC
          $SUBST('UZCMOD')
          $IF(NORMC>0) $SUBST('UCNRF1')
          $IF(ISNC>0)
            $SUBST('UCSVF1')
          $ENDIF
          $SUBST('UCSVF2')
          $IF(FMODC<>'F')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $SUBST('UCSVG2')
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $50  CONTINUE
      $IF(SAVC>0)
        IF(LDC.GE.1) THEN
        $SUBST('UCLNG1')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNG1')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<1)
        $IF(NCL<NC)
          $IF(GMODC='G')
            $MTYPE='G'
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(NORMF>0) CALL UXVMUL($NF,$XN,$GC,$GC,1)
            $SUBST('UCSVG2')
            GOTO $00
          $ELSEIF(FMODC='F')
            $IF(ISNC>0)
              IF (LD.GE.0) FC=$CF(KC)
            $ENDIF
 $55  CONTINUE
            $SUBST('UC0G$(CON)1')
            GOTO ($70,$60) ISB+1
 $60  CONTINUE
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0)
              $SUBST('UCNRF1')
            $ENDIF
            GO TO $55
 $70  CONTINUE
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(NORMF>0) CALL UXVMUL($NF,$XN,$GC,$GC,1)
            $SUBST('UCSVG2')
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $80  CONTINUE
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ----------------------------------
*     END OF PENALTY FUNCTION DEFINITION
*     ----------------------------------
*
$OPTION(CHDIR=CHPOM)
      $ADD(INIT)
        NPXX='UP1MX2'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UP1MX2             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION
* WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINTS.
*  IU  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  IU  KAP  OPTIMUM INDEX OF THE APPROXIMATED FUNCTION.
*  IU  KC  INDEX OF THE CONSTRAINT FUNCTION.
*  IU  KCP  OPTIMUM INDEX OF THE CONSTRAINT FUNCTION.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UP1MX2(NC,KA,KAP,KC,KCP,AF,F)
      $INCLUDE ('UMCOMM')
      INTEGER NC,KA,KAP,KC,KCP
      $FLOAT AF(2*NC+1),F
      INTEGER I
      IF (TSS(NS).NE.'UPXX') CALL UYPRO1('UPXX',-1)
      GO TO (1,2,3,5,7) ISP(NS)
    1 CONTINUE
      IF (KD.LE.LD) GO TO 9
      KA=0
      KC=0
      IF (LD.GE.0) GO TO 2
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      IF (LD.LT.0) THEN
      F=AF(1)
      KAP=1
      ENDIF
      IF (KD.LT.1) GO TO 3
      CALL UYSET0(2,3)
      RETURN
    3 CONTINUE
      KC=1
    4 IF (KC.GT.NC) GOTO 8
      KA=KCP
      IF (LD.GE.0) GOTO 5
      CALL UYSET0(3,4)
      RETURN
    5 CONTINUE
      IF (LD.LT.0) THEN
      DO 6 I=KA+1,KCP
      IF (F.LT.AF(I)) THEN
      F=AF(I)
      KAP=I
      ENDIF
    6 CONTINUE
      ENDIF
      IF (KD.LT.1) GO TO 7
      CALL UYSET0(4,5)
      RETURN
    7 CONTINUE
      KC=KC+1
      GO TO 4
    8 CONTINUE
    9 CALL UYEPI1(-1)
      LD=KD
      RETURN
      END
