$INTERFACE UPLAG8                                             16/12/01

  CALL UPLAG8(NA,$AF,$AZ,$AS,RPF3,MEP2)
  $ADD(REAL,'\$AF($NA)\$AZ($NA)\$AS($NA)')
$REM  $ADD(REAL,'\RPF3')
$REM  $ADD(INTEGER,'\NF\NA\MEP2')
  $ADD(INIT)
    NPFX='UPLAG8'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UPLAG8             ALL SYSTEMS                 05/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  AF(NA)  VECTOR CONTAINING VALUES OF APPROXIMATED FUNCTIONS.
*  RI  AZ(NA)  VECTOR CONTAINING LAGRANGE MULTIPLIERS.
*  RI  AS(NA)  VECTOR CONTAINING EXPONENTIAL TERMS.
*  RI  RPF3  BARRIER COEFFICIENT.
*  II  MEP2  SAVING EXPONENTIAL TERMS. MEP2=0-SAVING SUPPRESSED.
*         MEP2=1-SAVING EXPONENTIAL TERMS.
*
      SUBROUTINE UPLAG8(NA,AF,AZ,AS,RPF3,MEP2)
      INTEGER NA,MEP2
      $FLOAT AF(NA),AZ(NA),AS(NA),RPF3
      $FLOAT FA,TEMP
      INTEGER KA
      DO 1 KA=1,NA
      FA=AF(KA)
      TEMP=EXP(-2.0$P 0*ABS(FA)/RPF3)
      IF (MEP2.NE.0) AS(KA)=TEMP
      AZ(KA)=SIGN(1.0$P 0-TEMP,FA)/(1.0$P 0+TEMP) 
    1 CONTINUE
      RETURN
      END
