$INTERFACE UPPAR1                                             05/12/01

  CALL UPPAR1(NF,NX,NC,$X,$IX,$XL,$XU,$XZL,$XZU,$XP,$CF,$IC,$CL,$CU&
,$CZL,$CZU,$CP,RPF3)
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XZL($NX)\$XZU($NX)\$XP($NX)&
  \$CF($NC)\$CL($NC)\$CU($NC)\$CSL($NC)\$CSU($NC)\$CZL($NC)\$CZU($NC)&
  \$CP($NC)')
  $ADD(INTEGER,'\$IX($NX)\$IC($NC)')
$REM  $ADD(REAL,'\RPF3')
$REM  $ADD(INTEGER,'\NF\NX\NC')
  $ADD(INIT)
    NPFX='UPPAR1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UPPAR1             ALL SYSTEMS                 05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XZL(NF)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NF)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  RI  XP(NC)  VECTOR CONTAINING PENALTY PARAMETERS FOR VARIABLES.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF APPROXIMATED FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CP(NC)  VECTOR CONTAINING PENALTY PARAMETERS FOR CONSTRAINTS.
*  RI  RPF3  BARRIER COEFFICIENT.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
      SUBROUTINE UPPAR1(NF,NX,NC,X,IX,XL,XU,XZL,XZU,XP,CF,IC,CL,CU,
     & CZL,CZU,CP,RPF3)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NX,NC,IX(NX),IC(NC)
      $FLOAT X(NF),XL(NX),XU(NX),XZL(NX),XZU(NX),XP(NX), CF(NC),
     & CL(NC),CU(NC),CZL(NC),CZU(NC),CP(NC),RPF3
      INTEGER K,KK
      IF (KBF.GT.0) THEN
      DO 1 K=1,NX
      KK=ABS(IX(K))
      IF (KK.EQ.1.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      IF (XL(K)-X(K).GT.RPF3.OR.XP(K).LE.XZL(K)+RPF3) THEN
      XP(K)=MAX(XP(K),TWO*XZL(K))
      ENDIF 
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      IF (X(K)-XU(K).GT.RPF3.OR.XP(K).LE.XZU(K)+RPF3) THEN
      XP(K)=MAX(XP(K),TWO*XZU(K))
      ENDIF
      ENDIF 
    1 CONTINUE
      ENDIF
      IF (KBC.GT.0) THEN
      DO 2 K=1,NC
      KK=ABS(IC(K))
      IF (KK.EQ.1.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      IF (CL(K)-CF(K).GT.RPF3.OR.CP(K).LE.CZL(K)+RPF3) THEN
      CP(K)=MAX(CP(K),TWO*CZL(K))
      ENDIF
      ENDIF 
      IF (KK.EQ.2.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      IF (CF(K)-CU(K).GT.RPF3.OR.CP(K).LE.CZU(K)+RPF3) THEN
      CP(K)=MAX(CP(K),TWO*CZU(K))
      ENDIF
      ENDIF 
    2 CONTINUE
      ENDIF
      RETURN
      END

