* SUBROUTINE UPPRE1             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF ARTICICIAL CONSTRAINT VIOLATION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NX)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NX)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NX)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RO  FC  VALUE OF THE PENALTY TERM.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
      SUBROUTINE UPPRE1(NF,NX,NC,X,IX,XL,XU,XSL,XSU,CF,IC,CL,CU,CSL,CSU,
     & FC)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NX,NC,IX(NX),IC(NC)
      $FLOAT X(NF),XL(NX),XU(NX),XSL(NX),XSU(NX),CF(NC+1),CL(NC),CU(NC),
     & CSL(NC),CSU(NC),FC
      INTEGER I,KC,KK
      FC=ZERO
      IF (KBF.GT.0) THEN
      DO 1 I=1,NX
      KK=ABS(IX(I))
      IF (KK.EQ.1.OR.KK.EQ.3.OR.KK.EQ.4) FC=MAX(FC,ABS(XL(I)-X(I)+
     & XSL(I)))
      IF (KK.EQ.2.OR.KK.EQ.3.OR.KK.EQ.4) FC=MAX(FC,ABS(X(I)-XU(I)+
     & XSU(I)))
    1 CONTINUE
      ENDIF
      IF (KBC.GT.0) THEN
      DO 2 KC=1,NC
      KK=ABS(IC(KC))
      IF (KK.EQ.1.OR.KK.EQ.3.OR.KK.EQ.4) FC=MAX(FC,ABS(CL(KC)-CF(KC)+
     & CSL(KC)))
      IF (KK.EQ.2.OR.KK.EQ.3.OR.KK.EQ.4) FC=MAX(FC,ABS(CF(KC)-CU(KC)+
     & CSU(KC)))
      IF (KK.EQ.5) FC=MAX(FC,ABS(CF(KC)))
    2 CONTINUE
      ENDIF
      RETURN
      END
