$INTERFACE UPSEB2                                             99/01/23

  CALL UPSEB2(NX,$NN,$IX,$XSL,$XSU,$XZL,$XZU,$IC,$CSL,$CSU,$CZL,$CZU&
,RPF3)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UPSEB2            ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 MC : ORIGINAL VERSION
*
* PURPOSE :
* BARRIER PARAMETER DETERMINATION (EL-BAKRY)
*
* PARAMETERS :
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  IX(NX)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  XZL(NF)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NF)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  RI  RPF3  BARRIER COEFFICIENT.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*

      SUBROUTINE UPSEB2(NX,NC,IX,XSL,XSU,XZL,XZU,IC,CSL,CSU,CZL,CZU,
     & RPF3)
      $INCLUDE ('UMCOMM')
      INTEGER NX,NC,IX(NX),IC(NC)
      $FLOAT XSL(NX),XSU(NX),XZL(NX),XZU(NX),CSL(NC),CSU(NC),CZL(NC),
     & CZU(NC),RPF3
      $FLOAT CDOT1,SXI
      INTEGER I,K,IIC
      IIC=0
      CDOT1=ZERO
      IF (KBF.GT.0) THEN
        DO 2 I=1,NX
          K=ABS(IX(I))
          IF (K.EQ.1.OR.K.EQ.3.OR.K.EQ.4) THEN
            SXI=XSL(I)*XZL(I)
            CDOT1=CDOT1+SXI
            IIC=IIC+1
          ENDIF
          IF (K.EQ.2.OR.K.EQ.3.OR.K.EQ.4) THEN
            SXI=XSU(I)*XZU(I)
            CDOT1=CDOT1+SXI
            IIC=IIC+1
          ENDIF
    2   CONTINUE
      ENDIF
      IF (KBC.GT.0) THEN
        DO 3 I=1,NC
          K=ABS(IC(I))
          IF (K.EQ.1.OR.K.EQ.3.OR.K.EQ.4) THEN
            SXI=CSL(I)*CZL(I)
            CDOT1=CDOT1+SXI
            IIC=IIC+1
          ENDIF
          IF (K.EQ.2.OR.K.EQ.3.OR.K.EQ.4) THEN
            SXI=CSU(I)*CZU(I)
            CDOT1=CDOT1+SXI
            IIC=IIC+1
          ENDIF
    3   CONTINUE
      ENDIF
      IF (IIC.EQ.0) THEN
        RPF3=ZERO
        RETURN
      ENDIF
      SXI=MIN(2$P-1,100$P 0*CDOT1)
      CDOT1=CDOT1/$DBLE(IIC)
      RPF3=SXI*CDOT1
      END
