* SUBROUTINE UQOPTI                ALL SYSTEMS               98/12/01
* PORTABILITY : ALL SYSTEMS
* 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE 'OPTION(PARAMETER=VALUE)'
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  II  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  IU  NLINES - NUMBER OF LINES
*  IO  IER - ERROR INDICATOR
*
* COMMON DATA :
*  II  LENOPT(NOPT) - LENGTHS OF OPTION PARAMETER NAMES
*  TI  OPTNM(*) - NAMES OF OPTION PARAMETERS
*  II  NOPT - NUMBER OF OPTIONS
*  TI  WTRUE - STRING '.TRUE.'
*  TI  WFALSE - STRING '.FALSE.'
*  TU  CHDIR - THE DIRECTIVE CHARACTER
*  TU  CHEOL - THE END OF LINE MARKER
*  TU  CHCON - THE CONTINUATION MARKER
*  TU  CHDS - THE DATA SEPARATOR MARKER
*  TU  FN1 - FILENAME PART 1 (E.G. LIBRARY)
*  TU  FN2 - FILENAME PART 2 (E.G. EXTENSION)
*  IU  DIALOG - TYPE OF DIALOGUE (0-NO DIALOGUE, 1-SHORT DIALOGUE,
*               2-FULL DIALOGUE)
*  IU  MODERW - READ/WRITE MODE (1-READ/WRITE, 2-READ/APPEND,
*               3-READ ONLY)
*  IU  ILNLEN - THE NUMBER OF CHARACTERS PER LINE OF INPUT
*  IU  OLNLEN - THE NUMBER OF CHARACTERS PER LINE OF OUTPUT
*  IU  OUNIT - THE OUTPUT UNIT NUMBER
*  IU  IUNIT - THE INPUT UNIT NUMBER
*  IU  INUNIT - THE INCLUDE UNIT NUMBER
*  IU  IIUNIT - THE INPUT INTERACTIVE UNIT NUMBER
*  IU  OIUNIT - THE OUTPUT INTERACTIVE UNIT NUMBER
*  IU  LABEL1 - STARTING VALUE OF LABEL
*  IU  LABEL2 - STEP OF LABEL AFTER SUBST('FILENAME')
*  IU  ADF - PERFORM AUTOMATICAL DIFFERENTIATION ON FMODELF? WHAT TYPE?
*  LU  LSUBS - PERFORM SUBSTITUTIONS ?
*  LU  LFORTO - IS IT A FORTRAN ?
*  LU  LOUT - OUTPUT FILE ?
*  LU  LSMLET - LOWERCASE LETTERS ALLOWED ?
*  LU  LFRFMT - IS IT A FORTRAN IN FREE FORMAT ?
*  LU  SIFDEC - IS A SIF FILE USED ?
*
* SUBPROGRAMS USED :
*  S   UQSADR - SYNTAX ANALYSIS OF DIRECTIVE LINE
*  LF  UQSTRC - COMPARISON OF TWO SUBSTRINGS
*  IF  UQINTI - CONVERT A SUBSTRING TO AN INTEGER NUMBER
*
      SUBROUTINE UQOPTI(BUFFER,MLENB,IPOSD,IPOS2,SYMTAB,MLENST,
     *                  IPOINT,MNP,NLINES,IER)
      INTEGER MLENB,IPOSD,IPOS2,MLENST,MNP,IPOINT(MNP,6),NLINES,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
C ----------------------------------------------------------------------
      INTEGER        LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT(30),NSUB,MNSUB,
     *        NDIR,LENDIR(30),NMSG,MNIF,NIF1,NIF2,TABCH(0:255),ADF,
     *        ADA,ADC,ARD,CRD
      COMMON/UQINT2/ LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT,NSUB,MNSUB,
     *        NDIR,LENDIR,NMSG,MNIF,NIF1,NIF2,TABCH,ADF,ADA,ADC,ARD,CRD
      INTEGER*4      LABEL1,LABEL2,MAXLAB,LEVLAB(20)
      COMMON/UQINT4/ LABEL1,LABEL2,MAXLAB,LEVLAB
      CHARACTER*1    CHCON,CHEOL,CHDS,CHDIR,WTRUE(6),WFALSE(7),
     *        ASCII(32:127),OPTNM(200),DIRNM(200)
      COMMON/UQCHR1/ CHCON,CHEOL,CHDS,CHDIR,WTRUE,WFALSE,
     *        ASCII,OPTNM,DIRNM
      CHARACTER*50   FN1,FN2,FNAMES(20),NAME,MSG(50)*70
      COMMON/UQCHRX/ FN1,FN2,FNAMES,NAME,MSG
      LOGICAL        LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON(20),
     *        LELSE(20),CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
      COMMON/UQLOGL/ LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON,
     *        LELSE,CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
C ----------------------------------------------------------------------
      INTEGER I,J,K,IV,LEN
      INTEGER*4 UQINTI
      CHARACTER*1 CHV
      CHARACTER*50 FN
      LOGICAL LV,UQSTRC
      INTEGER MNPAR
      PARAMETER(MNPAR=3)
      INTEGER NPAR,IPOSP(MNPAR,2),ITYPE(MNPAR)
      CALL UQSADR(BUFFER,MLENB,IPOSD,IPOS2,IPOSP,MNPAR,NPAR,ITYPE,IER)
      IF(IER.NE.0) RETURN
      IF(NPAR.NE.3) GOTO 29
      IF(ITYPE(1).NE.5) GOTO 30
      IF(ITYPE(2).NE.3) GOTO 31
      IF(ITYPE(3).LT.5.OR.ITYPE(3).GT.9) GOTO 32
      IF(ITYPE(3).EQ.5) THEN
        CALL UQGVAL(BUFFER,MLENB,IPOSP(3,1),IPOSP(3,2),SYMTAB,
     *              MLENST,IPOSP(3,1),IPOSP(3,2),IPOINT,MNP,IER)
        IF(IER.NE.0) RETURN
      ENDIF
C
C     NAME OF OPTION
C
      K=0
      LEN=IPOSP(1,2)-IPOSP(1,1)+1
      DO 2 I=1,NOPT
        IF(LEN.EQ.LENOPT(I)) THEN
          DO 1 J=1,LEN
            IF(BUFFER(IPOSP(1,1)+J-1).NE.OPTNM(K+J)) THEN
              K=K+LEN
              GOTO 2
            ENDIF
    1     CONTINUE
          GOTO 3
        ELSE
          K=K+LENOPT(I)
        ENDIF
    2 CONTINUE
      GOTO 28
C
C     LOGICAL OPTION
C
    3 IF(I.GE.18.AND.(.NOT.(I.EQ.25)).AND.(.NOT.(I.EQ.26))
     *      .AND.(.NOT.(I.EQ.27))
     *      .AND.(.NOT.(I.EQ.29)).AND.(.NOT.(I.EQ.30))) THEN
        IF(ITYPE(3).EQ.5) THEN
          IF(UQSTRC(SYMTAB,MLENST,IPOSP(3,1),IPOSP(3,2),
     *      WTRUE,6,1,6)) THEN
            LV=.TRUE.
          ELSEIF(UQSTRC(SYMTAB,MLENST,IPOSP(3,1),IPOSP(3,2),
     *      WFALSE,7,1,7)) THEN
            LV=.FALSE.
          ELSE
            GOTO 28
          ENDIF
        ELSE
          IF(ITYPE(3).EQ.8) THEN
            LV=.TRUE.
          ELSEIF(ITYPE(3).EQ.9) THEN
            LV=.FALSE.
          ELSE
            GOTO 28
          ENDIF
        ENDIF
C
C     NUMERICAL OPTION
C
      ELSEIF(I.GE.7) THEN
        IF(ITYPE(3).EQ.5) THEN
          IV=UQINTI(SYMTAB,MLENST,IPOSP(3,1),IPOSP(3,2),IER)
        ELSE
          IV=UQINTI(BUFFER,MLENB,IPOSP(3,1),IPOSP(3,2),IER)
        ENDIF
        IF(IER.NE.0) RETURN
        IF(IV.LT.0) GOTO 28
C
C     CHARACTER OPTION
C
      ELSEIF(I.LE.4) THEN
        IF(IPOSP(3,2).NE.IPOSP(3,1)) GOTO 28
        IF(ITYPE(3).EQ.5) THEN
          CHV=SYMTAB(IPOSP(3,1))
        ELSEIF(ITYPE(3).LE.7) THEN
          CHV=BUFFER(IPOSP(3,1))
        ELSE
          GOTO 28
        ENDIF
C
C     STRING OPTION
C
      ELSE
        FN=' '
        LEN=IPOSP(3,2)-IPOSP(3,1)+1
        IF(LEN.GT.50) GOTO 28
        IF(ITYPE(3).EQ.5) THEN
          DO 4 J=1,LEN
            FN(J:J)=SYMTAB(IPOSP(3,1)+J-1)
    4     CONTINUE
        ELSEIF(ITYPE(3).EQ.6) THEN
          DO 5 J=1,LEN
            FN(J:J)=BUFFER(IPOSP(3,1)+J-1)
    5     CONTINUE
        ELSE
          GOTO 28
        ENDIF
      ENDIF
      GOTO (6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
     *      21,22,23,24,25,26,27,37,38,39,40,41,42,43,44), I
    6 CHDIR=CHV
      RETURN
    7 CHEOL=CHV
      RETURN
    8 CHCON=CHV
      RETURN
    9 CHDS=CHV
      RETURN
   10 FN1=FN
      RETURN
   11 FN2=FN
      RETURN
   12 DIALOG=IV
      RETURN
   13 IF(IV.GT.3.OR.IV.LT.1) GOTO 28
      MODERW=IV
      RETURN
   14 ILNLEN=IV
      RETURN
   15 OLNLEN=IV
      RETURN
   16 OUNIT=IV
      RETURN
   17 IUNIT=IV
      NLINES=0
      RETURN
   18 INUNIT=IV
      RETURN
   19 IIUNIT=IV
      RETURN
   20 OIUNIT=IV
      RETURN
   21 LABEL1=IV
      RETURN
   22 LABEL2=IV
      RETURN
   23 LSUBS=LV
      RETURN
   24 LFORTO=LV
      RETURN
   25 LOUT=LV
      RETURN
   26 LSMLET=LV
      RETURN
   27 LFRFMT=LV
      RETURN
   37 SIFDEC=LV
      IF (SIFDEC) THEN
      CALL UQSIFD(SYMTAB,MLENST,IPOINT,MNP,IER)
      SIFDEC=.FALSE.
      ENDIF
      RETURN
   38 DIALGR=LV
      RETURN
   39 ADF=IV
      IF (ADF.EQ.1) THEN
      CALL UQADI1(SYMTAB,MLENST,IPOINT,MNP,'F',IER)
      ENDIF
      IF (ADF.EQ.2) THEN
      CALL UQADI1(SYMTAB,MLENST,IPOINT,MNP,'F',IER)
      CALL UQADI3(SYMTAB,MLENST,IPOINT,MNP,'F',IER)
      ENDIF
      RETURN
   40 ADA=IV
      IF (ADA.EQ.1) THEN
      CALL UQADI1(SYMTAB,MLENST,IPOINT,MNP,'A',IER)
      ENDIF
      IF (ADA.EQ.2) THEN
      CALL UQADI1(SYMTAB,MLENST,IPOINT,MNP,'A',IER)
      CALL UQADI3(SYMTAB,MLENST,IPOINT,MNP,'A',IER)
      ENDIF
      RETURN
   41 ADC=IV
      IF (ADC.EQ.1) THEN
      CALL UQADI1(SYMTAB,MLENST,IPOINT,MNP,'C',IER)
      ENDIF
      IF (ADC.EQ.2) THEN
      CALL UQADI1(SYMTAB,MLENST,IPOINT,MNP,'C',IER)
      CALL UQADI3(SYMTAB,MLENST,IPOINT,MNP,'C',IER)
      ENDIF
      RETURN
   42 LPERFD=LV
      RETURN
   43 ARD=IV
      RETURN
   44 CRD=IV
      RETURN
C
C     ERROR IN DIRECTIVE 'OPTION'
C
   28 IER=32
      RETURN
C
C ERROR: SYNTAX ERROR
C
   29 IER=20
      RETURN
C
C ERROR: MACRO NAME EXPECTED
C
   30 IER=23
      RETURN
C
C ERROR: '=' EXPECTED
C
   31 IER=29
      RETURN
C
C ERROR: IDENTIFIER,STRING,INTEGER CONSTANT,.TRUE. OR .FALSE. EXPECTED
C
   32 IER=30
      RETURN
      END
