* SUBROUTINE UQSETV                ALL SYSTEMS                98/12/01
* PORTABILITY : ALL SYSTEMS
* 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  SET MACRO VARIABLE TO THE SYMBOL TABLE
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOS11 - POSITION OF THE FIRST CHARACTER OF A MACRO NAME
*               IN THE BUFFER
*  II  IPOS12 - POSITION OF THE LAST CHARACTER OF A MACRO NAME
*               IN THE BUFFER
*  II  IPOS13 - POSITION OF THE FIRST CHARACTER OF A MACRO VALUE
*  II  IPOS14 - POSITION OF THE LAST CHARACTER OF A MACRO VALUE
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE.
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW
*  II  MNP - MAX. NUMBER OF POINTERS
*  II  IOPT - IOPT=1 - VALUE OF MACRO IS IN THE BUFFER
*             IOPT=2 - VALUE OF MACRO IS IN THE SYMBOL TABLE
*  IO  IER - ERROR INDICATOR
*
* COMMON DATA :
*  IU  LENST - ACTUAL LENGTH OF THE SYMBOL TABLE
*  IU  LP - LAST POINTER TO THE SYMBOL TABLE
*  II  MODERW - READ/WRITE MODE (1-READ/WRITE, 2-READ/APPEND,
*               3-READ ONLY)
*

      SUBROUTINE UQSETV(BUFFER,MLENB,IPOS11,IPOS12,IPOS13,IPOS14,
     *                  SYMTAB,MLENST,IPOINT,MNP,IOPT,IER)
      INTEGER MLENB,IPOS11,IPOS12,IPOS13,IPOS14,MLENST,MNP,
     *        IPOINT(MNP,6),IOPT,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
C ----------------------------------------------------------------------
      INTEGER        LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT(30),NSUB,MNSUB,
     *        NDIR,LENDIR(30),NMSG,MNIF,NIF1,NIF2,TABCH(0:255),ADF,
     *        ADA,ADC,ARD,CRD
      COMMON/UQINT2/ LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT,NSUB,MNSUB,
     *        NDIR,LENDIR,NMSG,MNIF,NIF1,NIF2,TABCH,ADF,ADA,ADC,ARD,CRD
      INTEGER*4      LABEL1,LABEL2,MAXLAB,LEVLAB(20)
      COMMON/UQINT4/ LABEL1,LABEL2,MAXLAB,LEVLAB
      CHARACTER*1    CHCON,CHEOL,CHDS,CHDIR,WTRUE(6),WFALSE(7),
     *        ASCII(32:127),OPTNM(200),DIRNM(200)
      COMMON/UQCHR1/ CHCON,CHEOL,CHDS,CHDIR,WTRUE,WFALSE,
     *        ASCII,OPTNM,DIRNM
      CHARACTER*50   FN1,FN2,FNAMES(20),NAME,MSG(50)*70
      COMMON/UQCHRX/ FN1,FN2,FNAMES,NAME,MSG
      LOGICAL        LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON(20),
     *        LELSE(20),CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
      COMMON/UQLOGL/ LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON,
     *        LELSE,CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
C ----------------------------------------------------------------------
      INTEGER IP,IPPRED,I,LEN,LENM,LENN,IPOS
      LENN=IPOS12-IPOS11+1
      LENM=IPOS14-IPOS13+1
      LEN=LENN+LENM
C
C TRY TO FIND MACRO
C
      IF(LP.NE.0) THEN
        IP=LP
    1   IF(LENN.EQ.IPOINT(IP,3)) THEN
          DO 2 I=0,LENN-1
            IF(BUFFER(IPOS11+I).NE.SYMTAB(IPOINT(IP,2)+I)) GOTO 3
    2     CONTINUE
C
C MACRO FOUND
C
          IF(IPOINT(IP,6).GT.1) GOTO 22
          IF(IP.EQ.LP) THEN
            IF(IPOINT(IP,2)+LEN.LE.MLENST) THEN
              LENST=IPOINT(IP,2)+LEN-1
              GOTO 9
            ELSE
              LENST=IPOINT(IPOINT(IP,1),4)
              GOTO 7
            ENDIF
          ELSEIF(IPOINT(IPPRED,2)-IPOINT(IP,2).GE.LEN) THEN
            GOTO 9
          ELSE
            IPOINT(IPPRED,1)=IPOINT(IP,1)
            GOTO 6
          ENDIF
        ENDIF
    3   IPPRED=IP
        IP=IPOINT(IP,1)
        IF(IP.GT.0) GOTO 1
      ENDIF
C
C MACRO NOT FOUND, FIND FREE POINTER
C
      DO 4 IP=LP+1,MNP
        IF(IPOINT(IP,1).EQ.-1) GOTO 6
    4 CONTINUE
      DO 5 IP=LP-1,1,-1
        IF(IPOINT(IP,1).EQ.-1) GOTO 6
    5 CONTINUE
      GOTO 20
C
C CREATE NEW POINTER AND LINK IT
C
    6 IPOINT(IP,1)=LP
      LP=IP
      IPOINT(IP,3)=LENN
    7 IF(LEN+LENST.GE.MLENST) GOTO 21
      IPOINT(IP,2)=LENST+1
      LENST=LENST+LEN
C
C SET MACRO NAME TO SYMTAB
C
      DO 8 I=0,LENN-1
        SYMTAB(IPOINT(IP,2)+I)=BUFFER(IPOS11+I)
    8 CONTINUE
C
C SET MACRO VALUE TO SYMTAB
C
    9 IPOINT(IP,4)=IPOINT(IP,2)+LEN-1
      IPOINT(IP,5)=1
      IPOINT(IP,6)=MODERW
      IF(LENM.EQ.0) RETURN
      IPOS=IPOINT(IP,2)+LENN
      IF(IOPT.EQ.1) THEN
        DO 10 I=0,LENM-1
          SYMTAB(IPOS+I)=BUFFER(IPOS13+I)
   10   CONTINUE
      ELSE
        DO 11 I=0,LENM-1
          SYMTAB(IPOS+I)=SYMTAB(IPOS13+I)
   11   CONTINUE
      ENDIF
      RETURN
C
C ERROR: MAX. NUMBER OF POINTERS TO SYMBOL TABLE EXCEEDED
C
   20 IER=14
      RETURN
C
C ERROR: MAX. LENGTH OF SYMBOL TABLE EXCEEDED
C
   21 IER=4
      RETURN
C
C ERROR: ATTEMPT TO OVERWRITE RO/RA VARIABLE
C
   22 IER=8
      RETURN
      END
