$INTERFACE UUDDG1                                             16/12/01
$REM LU

  $CON0='0.1$P 0'
  $CON1='0.618034$P 0'
  $CON2='4.0$P 0'
  $CON3='0.2$P 0'
  $CON4='1.0$P-2'
  $CON5='3.0$P-8'
  $CON6='0.5$P 0'
  $CON7='3.0$P 0'
  $HELP
    METHOD OF UPDATE OF HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP UPDATE
      3 - HOSHINO UPDATE
      4 - SAFEGUARDED RANK ONE UPDATE
      5 - OPTIMALLY CONDITIONED UPDATE
      6 - SIMPLE PRECONVEX UPDATE
      7 - VARIATIONALLY DERIVED PRECONVEX UPDATE
      8 - NEW COMBINED UPDATE
      9 - PRECONVEX UPDATE DERIVED FROM MATRIX FACTORIZATION
     10 - ANGLE MINIMIZING UPDATE
     11 - NORM MINIMIZING UPDATE
  $CHECK(MET,1,'1\2\3\4\5\6\7\8\9\10\11',3)
  $IF(MET=2)
    $MET1=5
  $ELSE
    $HELP
      SELECTION OF SELF SCALING:
        1 - SELF SCALING SUPPRESSED
        2 - INITIAL SELF SCALING
        3 - CONTROLLED SELF SCALING
        4 - SIMPLIFIED CONTROLLED SELF SCALING
        5 - SELF SCALING IN EACH ITERATION
    $CHECK(MET1,3,'1\2\3\4\5',4)
  $ENDIF
  $HELP
    SELECTION OF THE LINE SEARCH MODEL:
      1 - QUADRATIC MODEL
      2 - BACKWARD TAYLOR EXPANSION (3 TERMS)
      3 - BACKWARD TAYLOR EXPANSION (4 TERMS)
      4 - HOMOGENEOUS MODEL
  $CHECK(MET2,4,'1\2\3\4',4)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,ETA0,REAL,4)
  $N='N'
  $ADD(REAL,'\$H($NF*($NF+1)/2)\$SN($NF)\$XO($NF)\$GO($NF)&
  \$XS($NF)\$GS($NF)\$XP($NF)\$GP($NF)')
$REM  $ADD(REAL,'\PAR1\PAR2')
  $IF(DEC='G')
    $POM1='UXDPGU(N,H'
    $POM2=')'
    $POM3='$$N,$$H'
    $POM5='N,H'
  $ELSEIF(DEC='S')
    $POM1='UXD$(LET)GU(N,H,IH'
    $POM2=')'
    $POM3='$$N,$$H,$$IH'
    $POM5='N,H,IH'
    $ADD(INTEGER,'\$IH($NF)')
  $ELSEIF(DEC='B')
    $HELP
      TYPE OF DECOMPOSITION
        1 - BUNCH-PARLETT DECOMPOSITION WITH NUMERICAL PERMUTATIONS
        2 - BUNCH-KAUFMAN DECOMPOSITION WITH NUMERICAL PERMUTATIONS
        3 - BUNCH PARLETT DECOMPOSITION WITH TWO LEVEL INDICES
    $CHECK(MOS2,1,'1\2\3',2)
    $IF(MOS2<3)
      $IQ='IQ'
      $POM1='UXDLBU(N,H,IH'
      $POM2=',IQ)'
      $POM3='$N,$H,$IH'
      $POM5='N,H,IH'
      $ADD(INTEGER,'\$IH($NF)\$IQ($NF)')
    $ELSE
      $POM1='UXDSBU(N,H,IH'
      $POM2=')'
      $POM3='$N,$H,$IH'
      $POM5='N,H,IH'
      $ADD(INTEGER,'\$IH($NF)')
    $ENDIF
  $ENDIF
  $ADD(POM3,',$S,$XO,$GO,$XS,$GS,$XP,$GP,R,PO')
  $ADD(POM5,',S,XO,GO,XS,GS,XP,GP,R,PO')
  $IF(MET2<>1)
    $ADD(POM3,',F,FO,P')
    $ADD(POM5,',F,FO,P')
  $ENDIF
  $IF(MET1=3)
    $ADD(POM3,',PAR1,PAR2')
    $ADD(POM5,',PAR1,PAR2')
  $ENDIF
  $ADD(POM3,',ETA2,ETA9,MET')
  $ADD(POM5,',ETA2,ETA9,MET')
  $IF(DEC='B')
    $IF(MOS2<3)
      $ADD(POM3,',MOS2')
      $ADD(POM5,',MOS2')
    $ENDIF
  $ENDIF
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUDD$(DEC)1$(NUMSUB)($POM3)
  $ADD(SUBROUTINES)
*     ----------------------------------------
*     DAVIDON CLASS OF VARIABLE METRIC UPDATES
*     TEMPLATE : UUDDG1
*     ----------------------------------------
  SUBROUTINE UUDD$(DEC)1$(NUMSUB)($POM5)
  $$INCLUDE('UMCOMM')
  INTEGER N,MET
  $$IF(DEC='B')
    $$IF(MOS2<3)
      INTEGER IQ(N),MOS2
    $$ENDIF
  $$ENDIF
  $$IF(DEC='S') INTEGER IH(N)
  $$IF(DEC='B') INTEGER IH(N)
  $$FLOAT H(N*(N+1)/2),S(N),XO(N),GO(N),XS(N),GS(N),XP(N),GP(N),R,PO&
,ETA2,ETA9
  $$IF($MET2<>1) $$FLOAT F,FO,P
  $$IF($MET1=3) $$FLOAT PAR1,PAR2
  $$FLOAT AA,CC
  COMMON /UMFUN1/ AA,CC
  $$FLOAT UXVDOT,UNFUN1
  $$IF (DEC='G') $$FLOAT UXDPGP
  $$IF (DEC='S') $$FLOAT UXDPGP
  $$IF (DEC='B')
    $$IF(MOS2<3)
      $$FLOAT UXDLBP
    $$ELSE
      $$FLOAT UXDSBP
    $$ENDIF
  $$ENDIF
  $$FLOAT DEN,DIS,POM,A,B,C,ALF,RHO,GAM,DEL,TAU,SIG,EPS,PAR
  $$IF($MET>8)
    $$FLOAT POM1,POM2
  $$ELSEIF($MET2>1)
    $$FLOAT POM1,POM2
  $$ENDIF
  INTEGER INSW
  LOGICAL L1,L3
  $$IF ($MET1=3) LOGICAL L2
  SAVE INSW
  EXTERNAL UNFUN1
  IF (MET.LE.0) GO TO 22
  CALL UOU1D1(N,XO,GO)
  $$IF(DEC='G')
    $$I=1
    IF (IDECF.EQ.0) THEN
    DEN=ETA2
    CALL UXDPGF(N,H,INF,DEN,DIS)
  $$ELSEIF(DEC='S')
    $$I=4
    IF (IDECF.EQ.0) THEN
    DEN=ETA2
    CALL UXD$$(LET)GF(N,H,IH,S,INF,DEN,DIS$$ART
  $$ELSEIF(DEC='B')
    $$I=3
    IF (IDECF.EQ.0) THEN
    DEN=ETA2
    $$IF(MOS2<3)
      CALL UXDLBF(N,H,IH,INF,DEN,MOS2)
    $$ELSE
      CALL UXDSBF(N,H,IH,INF,DEN)
    $$ENDIF
  $$ENDIF
  NDECF=NDECF+1
  IDECF=$$I
  ELSE IF (IDECF.NE.$$I) THEN
  ITERH=-1
  TUXX='BAD DEC$$I'
  CALL UOERR1('UUDB$(DEC)1',1)
  GO TO 22
  ENDIF
  L1=$MET1.GE.3.OR.$MET1.EQ.2.AND.NIT.EQ.KIT
  L3=.NOT.L1
*
*     DETERMINATION OF THE PARAMETERS GAM, DEL, TAU, SIG, EPS
*
  CALL UXVCOP(N,XO,S)
  $$IF(DEC='G')
    CALL UXDPGM(N,H,S,0)
  $$ELSEIF(DEC='S')
    CALL UXD$$(LET)GM(N,H,IH,S,0)
  $$ELSEIF(DEC='B')
    $$IF(MOS2<3)
      CALL UXDLBM(N,H,IH,S,0)
    $$ELSE
      CALL UXDSBM(N,H,IH,S,0)
    $$ENDIF
  $$ENDIF
  IF (NIT.EQ.KIT) THEN
  INSW=0
  CALL UXVCOP(N,S,XP)
  ENDIF
  CALL UXVDIF(N,GO,S,GP)
  CALL UXVCOP(N,GP,GS)
  $$IF(DEC='G')
    CALL UXDPGB(N,H,GS,1)
    TAU=UXDPGP(N,H,GS,GS)
  $$ELSEIF(DEC='S')
    CALL UXD$$(LET)GB(N,H,IH,GS,1)
    TAU=UXDPGP(N,H,GS,GS)
  $$ELSEIF(DEC='B')
    $$IF(MOS2<3)
      CALL UXDLBB(N,H,IH,GS,1)
      TAU=UXDLBP(N,H,IH,GS)
    $$ELSE
      CALL UXDSBB(N,H,IH,GS,1)
      TAU=UXDSBP(N,H,IH,GS,GS)
    $$ENDIF  
  $$ENDIF
  IF (TAU.LE.ZERO) THEN
  ITERH=5
  TUXX='TAU-NEG.'
  GO TO 22
  ENDIF
  CALL UXVCOP(N,XP,XS)
  $$IF(DEC='G')
    CALL UXDPGB(N,H,XS,1)
    EPS=UXDPGP(N,H,XS,XS)
  $$ELSEIF(DEC='S')
    CALL UXD$$(LET)GB(N,H,IH,XS,1)
    EPS=UXDPGP(N,H,XS,XS)
  $$ELSEIF(DEC='B')
    $$IF(MOS2<3)
      CALL UXDLBB(N,H,IH,XS,1)
      EPS=UXDLBP(N,H,IH,XS)
    $$ELSE
      CALL UXDSBB(N,H,IH,XS,1)
      EPS=UXDSBP(N,H,IH,XS,XS)
    $$ENDIF  
  $$ENDIF
  IF (EPS.LE.ZERO) THEN
  ITERH=7
  TUXX='EPS-NEG.'
  GO TO 22
  ELSE
  ENDIF
  SIG=SQRT(TAU/EPS)
  CALL UXVSCL(N,SIG,XP,XP)
  EPS=TAU
  GAM=UXVDOT(N,XP,XO)
  DEL=UXVDOT(N,GP,XO)
  SIG=SIG*UXDPGP(N,H,XS,GS)
  GAM=GAM/TAU
  DEL=DEL/TAU
  SIG=SIG/TAU
*
*     COMPUTATION OF THE DETERMINANT AND TEST ON LINEAR DEPENDENCE
*
  DEN=ONE-SIG**2
  IF (DEN.LE.$CON5) THEN
  IF (INSW.EQ.0) THEN
  INSW=1
  GO TO 22
  ELSE
  INSW=0
  B=UXVDOT(N,XO,GO)
  GO TO 23
  ENDIF
  ELSE
  INSW=0
  ENDIF
*
*     COMPUTATION OF PROJECTIONS
*
  DIS=DEL-GAM*SIG
  CALL UXVSCL(N,DIS/DEN,GP,XS)
  DIS=GAM-DEL*SIG
  CALL UXVDIR(N,DIS/DEN,XP,XS,XS)
  CALL UXVSUM(N,GP,XS,GS)
*
*     COMPUTATION OF THE PARAMETER B AND TEST ON POSITIVITY
*
  B=UXVDOT(N,XO,GS)
  IF (B.LE.ZERO) THEN
  B=UXVDOT(N,XO,GO)
  ELSE
  CALL UXVCOP(N,XS,S)
  CALL UXVCOP(N,GS,GO)
  ENDIF
*
*    COMPUTATION OF THE PARAMETERS A, C
*
23 CONTINUE
  IF (MET.GE.4.OR.L1) THEN
  CALL UXVCOP(N,GO,GS)
  $$IF(DEC='G')
    CALL UXDPGB(N,H,GS,1)
    A=UXDPGP(N,H,GS,GS)
  $$ELSEIF(DEC='S')
    CALL UXD$$(LET)GB(N,H,IH,GS,1)
    A=UXDPGP(N,H,GS,GS)
  $$ELSEIF(DEC='B')
    $$IF(MOS2<3)
      CALL UXDLBB(N,H,IH,GS,1)
      A=UXDLBP(N,H,IH,GS)
    $$ELSE
      CALL UXDSBB(N,H,IH,GS,1)
      A=UXDSBP(N,H,IH,GS,GS)
    $$ENDIF  
  $$ENDIF
  IF (A.LE.ZERO) THEN
  ITERH=1
  TUXX='A - NEG.'
  GO TO 22
  ENDIF
  ELSE
  A=ZERO
  ENDIF
  C=UXVDOT(N,XO,S)
  IF (C.LE.ZERO) THEN
  ITERH=3
  TUXX='C - NEG.'
  GO TO 22
  ENDIF
  IF (B.LE.$CON5*C) THEN
  ITERH=0
  TUXX='B - NEG.'
  GO TO 22
  ENDIF
*
*     CORRECTION OF THE DAVIDON VECTOR
*
  CALL UXVSCL(N,DEL,XP,XP)
  CALL UXVDIR(N,-GAM,GP,XP,XP)
*
*     DETERMINATION OF THE PARAMETER RHO (NONQUADRATIC PROPERTIES)
*
  $$IF($MET2=1)
    RHO=ONE
  $$ELSE
    POM1=(F-FO)/PO
    POM2=P/PO
    $$IF($MET2=2)
      IF (POM1.EQ.POM2.OR.POM2.EQ.ONE) THEN
      RHO=ONE
      ELSE
      RHO=HALF*(POM2-ONE)/(POM2-POM1)
      ENDIF
    $$ELSEIF($MET2=3)
      IF (TWO*(POM2-ONE)-THREE*(POM1-ONE).EQ.ZERO) THEN
      RHO=ONE
      ELSE
      RHO=HALF*(POM2-ONE)/(TWO*(POM2-ONE)-THREE*(POM1-ONE))
      ENDIF
    $$ELSEIF($MET2=4)
      IF (POM1.EQ.ONE.OR.POM2.EQ.POM1) THEN
      RHO=ONE
      ELSE
      RHO=(POM1-ONE)/(POM2-POM1)
      ENDIF
    $$ENDIF
    IF(RHO.LE.$CON4) RHO=ONE
    IF(RHO*$CON4.GE.ONE) RHO=ONE
  $$ENDIF
  AA=A/B
  CC=C/B
  IF (L1) THEN
*
*     DETERMINATION OF THE PARAMETER ALF (SELF SCALING)
*
  IF (A.LE.ZERO) THEN
  PAR=C/B
  ELSE
  $$IF($MET=1)
    PAR=C/B
  $$ELSEIF($MET=2)
    PAR=C/B
  $$ELSEIF($MET=3)
    PAR=SQRT(C/A)
  $$ELSEIF($MET=4)
    PAR=SQRT(C/A)
  $$ELSEIF($MET=5)
    PAR=SQRT(C/A)
  $$ELSEIF($MET=6)
    PAR=C/B
  $$ELSEIF($MET=7)
    PAR=C/B
  $$ELSEIF($MET=8)
    PAR=SQRT(C/A)
  $$ELSEIF($MET=9)
    PAR=C/B
  $$ELSEIF($MET=10)
    PAR=SQRT(C/A)
  $$ELSEIF($MET=11)
    PAR=SQRT(C/A)
  $$ENDIF
  ENDIF
  ALF=PAR*RHO
  $$IF($MET1=3)
    IF (NIT.NE.KIT) THEN
    L2=PAR2.LE.ZERO
    L3=L2.AND.ABS(PAR1).LE.$CON3
    L3=L3.OR.(.NOT.L2.AND.ALF.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.LT.ZERO.AND.ALF.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.GT.ZERO.AND.ALF.LT.ONE)
    L3=L3.OR.ALF.LT.$CON6
    L3=L3.OR.ALF.GT.$CON7
    ENDIF
  $$ELSEIF($MET1=4)
    IF (NIT.NE.KIT) THEN
    L3=ALF.LT.$CON6.OR.ALF.GT.$CON2
    ENDIF
  $$ENDIF
  ENDIF
  IF (L3) THEN
  ALF=ONE
  PAR=ALF/RHO
  ENDIF
  $$U17=0
  $$U18=0
  $$U19=0
  $$U20=0
  $$IF($MET=1)
    $$U17=1
    NUPD=NUPD+1
  $$ELSEIF($MET=2)
*
*     DFP UPDATE
*
    $$U20=1
    POM=ONE
    TUXX='DFP     '
    NUPD=NUPD+1
  $$ELSEIF($MET=3)
*
*     HOSHINO UPDATE
*
    DEN=PAR*B+C
    DIS=HALF*B
    POM=PAR*B/DEN
    CALL UXVDIR(N,PAR,GO,S,S)
    CALL $POM1,PAR/DIS,GO,XO$POM2
    CALL $POM1,-ONE/DEN,S,XO$POM2
    TUXX='HOSHINO '
    NUPD=NUPD+1
  $$ELSEIF($MET=4)
*
*     SAFEGUARDED RANK ONE UPDATE
*
    $$U17=1
    $$U18=1
    DIS=PAR*A-B
    DEN=PAR*B-C
    IF (DIS.LT.ZERO.AND.DEN.NE.ZERO) GO TO 18
  $$ELSEIF($MET=5)
*
*     OPTIMALLY CONDITIONED UPDATE
*
    $$U17=1
    $$U18=1
    $$U19=1
    DEN=PAR*B-C
    DIS=PAR*A-B
    IF (PAR*A*DEN.LE.C*DIS) GO TO 19
    IF (DEN.NE.ZERO) GO TO 18
  $$ELSEIF($MET=6)
*
*     SIMPLE PRECONVEX UPDATE
*
    $$U20=1
    POM=ONE-ONE/SQRT(MAX($ETA0,ONE-ONE/(AA*CC)))
    TUXX='LUKSAN 1'
    NUPD=NUPD+1
  $$ELSEIF($MET=7)
*
*     VARIATIONALLY DERIVED PRECONVEX UPDATE
*
    $$U20=1
    POM=-ONE/(TWO*AA*CC-ONE)
    TUXX='LUKSAN 2'
    NUPD=NUPD+1
  $$ELSEIF($MET=8)
*
*     NEW UPDATE
*
    $$U20=1
    POM=ONE/(AA*CC)
    DEN=MAX(POM+$ETA0,(C/A)**0.20D0)
    POM=POM*(ONE/DEN-ONE)/MAX($ETA0,ONE-POM)
    TUXX='NEW     '
    NUPD=NUPD+1
  $$ELSEIF($MET=9)
*
*     TEWARSON-1 UPDATE
*
    $$U20=1
    POM1=SQRT(ONE/CC)
    POM2=SQRT(AA)
    CALL UNNEQ3(POM1,POM2,POM,DEN,UNFUN1,$CON5,$ETA0,NRED,MODE)
    POM=-(ONE/CC)/(POM+ONE)**2
    TUXX='TEWARS 1'
    NUPD=NUPD+1
  $$ELSEIF($MET=10)
*
*     TEWARSON-2 UPDATE
*
    $$U20=1
    DEN=(R*SNORM)**2
    DIS=UXVDOT(N,XO,S)
    POM1=ONE-ONE/(R*AA)
    POM2=ONE-CC/R
    DEN=POM1*DEN-POM2*DIS/AA
    DIS=POM1*DIS-POM2*UXVDOT(N,S,S)/AA
    POM1=DEN-DIS/AA
    DIS=AA*CC
    IF (POM1.EQ.ZERO) THEN
    POM=TWO*DIS
    ELSE
    POM=POM2/POM1
    IF (POM.GT.ZERO) THEN
    POM=R*PAR*DEN*POM
    POM=MAX(DIS,MIN(TWO*DIS,POM))
    ELSE
    POM=TWO*DIS
    ENDIF
    ENDIF
    POM=(POM-ONE)/MAX($ETA0,DIS-ONE)
    POM=(ONE-POM)/(ONE+POM*(AA*CC-ONE))
    TUXX='TEWARS 2'
    NUPD=NUPD+1
  $$ELSEIF($MET=11)
*
*     TEWARSON-3 UPDATE
*
    $$U20=1
    DEN=(R*SNORM)**2
    DIS=UXVDOT(N,XO,S)
    POM2=ONE-CC/R
    DEN=DEN-DIS/AA
    DIS=DIS-UXVDOT(N,S,S)/AA
    POM1=DEN-DIS/AA
    DIS=AA*CC
    IF (POM1.EQ.ZERO) THEN
    POM=TWO*DIS
    ELSE
    POM=POM2/POM1
    POM=R*PAR*DEN*POM
    POM=MAX(DIS,MIN(TWO*DIS,POM))
    ENDIF
    POM=(POM-ONE)/MAX($ETA0,DIS-ONE)
    POM=(ONE-POM)/(ONE+POM*(AA*CC-ONE))
    TUXX='TEWARS 3'
    NUPD=NUPD+1
  $$ENDIF
  $$IF(U17>0)
17 CONTINUE
*
*     BFGS UPDATE
*
    POM=ZERO
    CALL $POM1,PAR/B,GO,XO$POM2
    CALL $POM1,-ONE/C,S,XO$POM2
    TUXX='BFGS    '
    GO TO 21
  $$ENDIF
  $$IF(U18>0)
18 CONTINUE
*
*     RANK ONE UPDATE
*
    POM=PAR*B/DEN
    CALL UXVDIR(N,-PAR,GO,S,GO)
    CALL $POM1,ONE/DEN,GO,XO$POM2
    TUXX='RANK ONE'
    NUPD=NUPD+1
    GO TO 21
  $$ENDIF
  $$IF(U19>0)
19 CONTINUE
*
*     DAVIDON'S UPDATE
*
    DEN=AA*CC-ONE
    IF (DEN.LE.ZERO) GO TO 17
    POM=(PAR*AA-ONE)/DEN
    TUXX='DAVIDON '
    NUPD=NUPD+1
  $$ENDIF
  $$IF(U20>0)
20 CONTINUE
*
*     GENERAL UPDATE
*
    CALL $POM1,PAR/B,GO,XO$POM2
    CALL $POM1,-ONE/C,S,XO$POM2
    CALL UXVDIR(N,-C/B,GO,S,GO)
    CALL $POM1,POM/C,GO,XO$POM2
  $$ENDIF
21 CONTINUE
  ITERH=0
  IF (ALF.EQ.ONE)  GO TO 22
*
*     SCALING
*
  $$IF(DEC='G')
    CALL UXDPGS(N,H,ONE/ALF)
  $$ELSEIF(DEC='S')
    CALL UXDPGS(N,H,ONE/ALF)
  $$ELSEIF(DEC='B')
    $$IF(MOS2<3)
      CALL UXDLBS(N,H,IH,ONE/ALF)
    $$ELSE
      CALL UXDSBS(N,H,IH,ONE/ALF)
    $$ENDIF
  $$ENDIF
  NSCL=NSCL+1
22 CONTINUE
  CALL UOU1D2(N,H,S,RHO,ALF,PAR,A,B,C,POM,ETA9)
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUDB$(DEC)1'
  $ENDADD
  $EXIT
