$INTERFACE UUDSD4                                             97/12/01

  $ADD(REAL,'\$H($NF*($NF+1)/2)\$HH($NF*($NF+1)/2)')
  $N='N'
  CALL UUDSD4($N,$H,$HH,IPOM1,IPOM2)
$REM  $ADD(INTEGER\$N\IPOM1\IPOM2)')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUDSD4                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF A DENSE SYMMETRIC POSITIVE DEFINITE MATRIX
*
* PARAMETERS :
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RU  H(N*(N+1)/2)  FACTORIZATION H=L*D*TRANS(L) OF A POSITIVE
*         SEMIDEFINITE HESSIAN MATRIX.
*  RU  B(N*(N+1)/2)  FACTORIZATION B=L*D*TRANS(L) OF A POSITIVE
*         DEFINITE APPROXIMATION OF THE HESSIAN MATRIX.
*  IU  IPOM1  METHOD INDICATOR.
*  IU  IPOM2  INDICATOR FOR SCALING.
*
* COMMON DATA :
*  II  ITERS  TERMINATION INDICATOR. ITERS=0-ZERO STEP.
*  II  LCS  INDICATION OF LOCALLY CONSTRAINED STEP. LCS=0 IF LOCALLY
*         CONSTRAINED STEP (TRUST REGION) WAS NOT USED.
*  TO  TUXX   TEXT INFORMATION ON THE RESTART USED.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXDSDA  DIAGONAL MODIFICATION OF A DENSE SYMMETRIC MATRIX.
*
      SUBROUTINE UUDSD4(N,H,B,IPOM1,IPOM2)
      $INCLUDE('UMCOMM')
      INTEGER N,IPOM1,IPOM2
      $FLOAT H(N*(N+1)/2),B(N*(N+1)/2)
      $FLOAT CON
      PARAMETER (CON=0.04$P 0)
      IF (IPOM1.EQ.0) THEN
      IF (ITERS.GT.0) THEN
      CALL UXVCOP(N*(N+1)/2,H,B)
      IF (LCS.EQ.0) CALL UXDSDA(N,B,CON)
      ENDIF
      TUXX='NEWTON  '
      IPOM2=2
      ENDIF
      RETURN
      END
