$INTERFACE UULBA1                                             97/12/01

  CALL UULBA1(NF,MF,NA,$XM,$GM,$JB,$XR,$XO,$AFO,$MET)
  $ADD(REAL,'\$XM($NF*$MF)\$GM($NA*$MF)\$XR($MF*($MF+1)/2)&
  \$XO($NF)\$AFO($NA)')
  $ADD(INTEGER,'\$JB($MF)')
$REM  $ADD(INTEGER,'\NF\MF\NA')
  $HELP
    UPDATE OF THE JACOBIAN MATRIX:
      1 - BROYDEN UPDATE
      2 - COLUMN UPDATE
  $CHECK(MET,1,'1\2',3)
  $ADD(INIT)
    NUXX='UULBA1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UULBA1                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* LIMITED STORAGE VARIABLE METRIC UPDATES.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  MF  MAXIMUM NUMBER OF VARIABLE METRIC STEPS.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RU  XM(NF*MF)  SET OF VECTOR OF VARIABLES DIFFERENCES.
*  RU  GM(NA*MF)  SET OF GRADIENT DIFFERENCES.
*  II  IM(MF)  VECTOR OF INDICES.
*  RU  XR(MF*(MF+1)/2)  MATRIX TRANS(XM)*XM STORED IN PACKED FORM.
*  RU  XO(NF)  VECTOR OF VARIABLES DIFFERENCE.
*  RI  AFO(NA)  RIGHT HAND SIDE DIFFERENCE.
*
* COMMON DATA :
*  IU  IREST  RESTART INDICATOR.
*  IO  ITERH  TERMINATION INDICATOR. ITERH<0-BAD DECOMPOSITION.
*         ITERH=0-SUCCESSFUL UPDATE. ITERH>0-NONPOSITIVE PARAMETERS.
*  II  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  KIT  NUMBER OF THE ITERATION AFTER LAST RESTART.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*  RF  UXVMX1  L-INFINITY NORM OF A VECTOR.
*  S   UOERR1  ERROR MESAGES.
*
* METHOD :
* LIMITED STORAGE VARIABLE METRIC METHODS.
*
      SUBROUTINE UULBA1(NF,MF,NA,XM,GM,IM,XR,XO,AFO,MET)
      $INCLUDE('UMCOMM')
      INTEGER NF,MF,NA,IM(MF),MET
      $FLOAT XM(NF*MF),GM(NA*MF),XR(MF*(MF+1)/2),XO(NF),AFO(NA)
      INTEGER I,I1,J1,MM
      $FLOAT TEMP
      $FLOAT UXVDOT,UXVMX1
      MM=MIN(NIT-KIT,MF)
      IF (MM.GE.MF) THEN
      IREST=1
      ELSE
      I1=MM*NF+1
      J1=MM*(MM+1)/2
      MM=MM+1
      CALL UXVCOP(NF,XO,XM(I1))
      CALL UXVCOP(NF,AFO,GM(I1))
      IF (MET.EQ.1) THEN
      I1=1
      DO 2 I=1,MM
      XR(J1+I)=UXVDOT(NF,XM(I1),XO)
      I1=I1+NF
    2 CONTINUE
      IF (XR(J1+MM).LE.ZERO) THEN
      ITERH=2
      TUXX='ZERO DEN'
      CALL UOERR1('UULBA1',1)
      ELSE
      TUXX='BROYD 1 '
      NUPD=NUPD+1
      ITERH=0
      ENDIF
      ELSE
      TEMP=UXVMX1(NF,XO,IM(MM))
      DO 3 I=1,MM
      XR(J1+I)=XO(IM(I))
    3 CONTINUE
      IF (TEMP.LE.ZERO) THEN
      ITERH=2
      TUXX='ZERO DEN'
      CALL UOERR1('UULBA1',1)
      ELSE
      TUXX='COLUMN  '
      NUPD=NUPD+1
      ITERH=0
      ENDIF
      ENDIF
      ENDIF
      RETURN
      END
