$INTERFACE UULSD1                                             02/12/01

  CALL UULSD1(NF,MF,PAR,$G,$GO,$XM)
  NN=MIN(NF,MF)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UULSD1                ALL SYSTEMS                02/12/01
C PORTABILITY : ALL SYSTEMS
C 02/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF A DENSE SYMMETRIC POSITIVE DEFINITE MATRIX
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  M  NUMBER OF VECTORS IN THE LIMITED MEMORY METHOD.
*  II  ALF  WEIGHT PARAMETER.
*  II  G  GRADIENT VECTOR.
*  IA  GO  AUXILIARY VECTOR.
*  RO  XM(N*M)  INITIAL VECTORS IN THE LIMITED MEMORY METHOD.
*
* COMMON DATA :
*  II  IREST  RESTART SPECIFICATION. IF IREST=0 DOES NOT HOLD
*         THEN A RESTART IS PERFORMED.
*  IU  ITERM  TERMINATION INDICATOR. ITERM<0 AFTER UNSUCCESSFUL
*         RESTART.
*  IU  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  TO  TUXX   TEXT INFORMATION ON THE RESTART USED.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*  RF  UXVNOR  EUCLIDEAN NORM OF A VECTOR.
*  S   UXVSCL  SCALING OF A VECTOR.
*  S   UXVSET  INITIATION OF A VECTOR.
*  S   UYSET3  DEFINITION OF THE RESTART VARIABLES.
*
      SUBROUTINE UULSD1(N,M,ALF,G,GO,XM)
      $INCLUDE('UMCOMM')
      INTEGER N,M
      $FLOAT ALF,G(N),GO(N),XM(N*M)
      INTEGER I,J,K,L
      $FLOAT BET,UXVNOR
      $FLOAT CON
      PARAMETER (CON=0.4$P 0)
      IF(IREST.LE.0) RETURN
      ALF=CON
      BET=SQRT(1.0$P 0-ALF)
      K=0
      L=(M-1)*N
      DO 1 I=1,N
      GO(I)=$DBLE(I)
    1 CONTINUE
      CALL UXVSET(L,0.0$P 0,XM)
      CALL UXVCOP(N,G,XM(L+1))
      CALL UXVSR8(N,XM(L+1),GO)
      CALL UXVCOP(N,G,XM(L+1))
      DO 2 I=1,M-1
      J=INT(GO(I))
      XM(K+J)=BET
      XM(L+J)=0.0$P 0
      K=K+N
    2 CONTINUE
      BET=BET/UXVNOR(N,XM(L+1))
      CALL UXVSCL(N,BET,XM(L+1),XM(L+1))
      TUXX='ORTHOG  '
      LD=MIN(LD,1)
      CALL UYSET3
      RETURN
      END
