$INTERFACE UULSP5                                             08/12/01

  $XR='XR'
  $GR='GR'
  $ADD(REAL,'\$XM($NF*$MF)\$GM($NF*$MF)\$XR(3*$MF)\$GR(3*$MF)\$XO($NF)&
  \$GO($NF)\$S($NF)\$XS($NF)')
  $ADD(REAL,'\RHO')
$REM  $ADD(INTEGER,'\NF\NN\MF')
  CALL UULSP5(NF,NN,MF,$XM,$GM,$XR,$GR,$XO,$GO,$S,$XS,R,PAR,RHO,ETA3)
  $ADD(INIT)
    NUXX='UULSP5'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UULSP5                ALL SYSTEMS                08/12/01
C PORTABILITY : ALL SYSTEMS
C 08/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
* LIMITED-STORAGE VARIABLE-METRIC STARTING BROYDEN CLASS UPDATE.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES (NUMBER OF ROWS OF XM, GM).
*  II  M  NUMBER OF COLUMNS OF XM, GM.
*  II  MM  MAXIMUM NUMBER OF COLUMNS OF XM, GM.
*  RU  XM(N*MM)  RECTANGULAR VM MATRIX STORED COLUMNWISE,
*         H=ZET*I-GM*TRANS(GM)+XM*TRANS(XM).
*  RU  GM(N*MM)  RECTANGULAR VM MATRIX STORED COLUMNWISE.
*  RI  XR(MM)  VECTOR TRANS(XM)*GO.
*  RI  GR(MM)  VECTOR TRANS(GM)*GO.
*  RI  XO(N)  VECTOR OF VARIABLES DIFFERENCE.
*  RI  GO(N)  VECTOR OF GRADIENT DIFFERENCE.
*  RA  S(N)  AUXILIARY VECTOR.
*  RA  XS(N)  AUXILIARY VECTOR.
*  RI  R  STEPSIZE PARAMETER.
*  RI  ZET  INPUT PARAMETER.
*  RI  RHO  NONQUADRATIC CORRECTION PARAMETER.
*  RI  ETA  BROYDEN PARAMETER.
*
* SUBPROGRAMS USED :
*  S   UXDCMM  RECTANGULAR MATRIX BY VECTOR MULTIPLICATION.
*  S   UXDRMM  RECTANGULAR MATRIX BY VECTOR MULTIPLICATION.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*
* METHOD :
*
      SUBROUTINE UULSP5(N,M,MM,XM,GM,XR,GR,XO,GO,S,XS,R,ZET,RHO,ETA)
      $INCLUDE('UMCOMM')
C
C     STARTING BC UPDATE FOR MET=1/3
C
      INTEGER M,MM,N,I,J,L
      REAL*8 GM(N*MM),XM(N*MM),XR(MM),GR(MM),XO(N),GO(N),S(N),XS(N),R,
     & ZET,RHO,ETA
      REAL*8 ALF,A,AC,AH,AP,B,D,ET,GAM,OM,SN,UXVDOT
      B=UXVDOT(N,XO,GO)
      IF (B.LE.ZERO) THEN
      ITERH=2
      TUXX='B - NEG.'
      RETURN
      ENDIF
      CALL UXDRMM(N,M,XM,GO,XR)
      AH=UXVDOT(N,GO,GO)
      AP=UXVDOT(M,XR,XR)
      CALL UXDRMM(N,M,GM,GO,GR)
      CALL UXDCMM(N,M,GM,GR,XS)
      AC=ZET*AH-UXVDOT(M,GR,GR)
      IF (AC.LE.ZERO) THEN
      ITERH=1
      TUXX='A - NEG.'
      RETURN
      ENDIF
      A=AC+AP
      GAM=B/A
C      IF (GAM.LT.1.0$P-3) GAM=B/AC
      ET=ETA
      IF (RHO/GAM*B/A.GT.1.0$P 0) ET=MIN(ET,B/(B-A*GAM/RHO)*0.95$P 0)
      D=ET+(B/A)/GAM*RHO*(1.0$P 0-ET)
      CALL UXDCMM(N,M,XM,XR,S)
      OM=RHO/GAM*ET+AC/B*D
      ALF=B/A*(ET-1.0$P 0)/(ET+SQRT(D))
      DO 2 I=1,N
        L=I
        SN=XO(I)-ALF*(ZET*GO(I)-XS(I)+S(I))
        DO 1 J=1,M
          GM(L)=SQRT(GAM)*GM(L)
          XM(L)=SQRT(GAM)*(XM(L)-XR(J)*SN/B*SQRT(D))
          L=L+N
    1   CONTINUE
        GM(L)=(ZET*GO(I)-XS(I))*SQRT(GAM*D/(B*OM))
        XM(L)=SN*SQRT(GAM*OM/B)-GM(L)
    2 CONTINUE
      ZET=ZET*GAM
      M=M+1
      TUXX='BR CLASS'
      NUPD=NUPD+1
      NSCL=NSCL+1
      ITERH=0
      RETURN
      END
