$INTERFACE UUSAMC                                             98/12/01


  $JHH='JHH'
  CALL UXVICP($IH(NF+1)-1,$JH,$JHH)
  CALL UUSAMC(NF,MMAX,$IH,$JHH,$COL,$S,$XO,$GO,$WN11,$WN12,$XS)
  $ADD(REAL,'\$S($NF)\$XO($NF)\$GO($NF+1)\$XS($NF)')
  $ADD(INTEGER,'\$COL($NF)\$WN11($NF+1)\$WN12($NF+1)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$JHH($MMAX)')
$REM  $ADD(INTEGER,'\NF\MMAX')
  $ADD(INIT)
    NFHX='UUSAMC'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUSAMC                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* FRACTIONED UPDATE COLORING ALGORITHM.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  MMAX  SIZE OF THE SPARSE HESSIAN ARRAY.
*  II  IH(NF+1) POINTER VECTOR OF SPARSE HESSIAN MATRIX.
*  II  JH(MMAX) INDEX VECTOR OF THE HESSIAN MATRIX.
*  IO  COL(NF) VECTOR DISCERNING GROUPS OF THE HESSIAN COLUMN OF THE
*              SAME COLOUR.
*  RA  DEG(NF) DEGREES OF THE ADJACENCY GRAPH.
*  RA  ORD(NF) AUXILIARY ARRAY.
*  RA  RADIX(NF+1) AUXILIARY ARRAY.
*  IA  WN11(NF+1) AUXILIARY VECTOR USED FOR INDICES OF THE COLUMNS
*        THAT HAVE NOT BEEN COLOURED YET.
*  IA  WN12(NF+1) AUXILIARY VECTOR.
*  RA  XS(NF) AUXILIARY VECTOR.
*
* COMMON DATA
*
      SUBROUTINE UUSAMC(NF,MMAX,IH,JH,COL,DEG,ORD,RADIX,WN11,WN12,XS)
      $INCLUDE('UMCOMM')
      INTEGER NF,MMAX,IH(NF+1),JH(MMAX),COL(NF)
      INTEGER WN11(NF+1),WN12(NF+1)
      $FLOAT RADIX(NF+1),ORD(NF)
      $FLOAT XS(NF),DEG(NF)
      INTEGER NCOL,CNM,I,ML,J,L,M
C
C SAVE SYMBOLIC STRUCTURE OF FACTOR
C
      M=IH(NF+1)-1
      IF(2*M-NF+2.GE.MMAX) THEN
        ITERM=-36
        TDXX='LACK SPC'
        GO TO 1100
      END IF
C
C WIDTHEN THE STRUCTURE
C
      CALL UXSTG1(NF,ML,MMAX,IH,JH,WN12,WN11)
C
      DO 100 I=1,NF
      COL(I)=NF
      WN12(I)=0
      WN11(I)=I
100   CONTINUE
C
C     NUMBER OF THE FREE COLUMNS
C
      CNM=NF
C
C     NUMBER OF USED COLOURS
C
      NCOL=1
C
C     DEGREE RECOUNT
C
      CALL UYSDEG(NF,NF,IH,DEG)
C
C     COLUMN RESORT
C
200   CALL UXVSR2(NF,DEG,ORD,RADIX,WN11,CNM)
C
C     ORD REWRITE INTO THE ARRAY INVP
C
      DO 250 I=1,CNM
        WN11(I)=ORD(I)
250   CONTINUE
C
C     COLUMNS OF THE NEW COLOUR NCOL
C
      CALL UYCSER(NF,MMAX,JH,IH,WN12,XS,DEG,WN11,COL,NCOL,CNM)
C
C     STOP TEST
C
      IF(CNM.GE.1) THEN
        NCOL=NCOL+1
        GO TO 200
      END IF
C
C SHRINK THE STRUCTURE
C
      CALL UXSTL1(NF,ML,MMAX,IH,JH,WN12)
C
C INTO COL GIVE INDICES OF THE INDIVIDUAL GROUPS ONE AFTER ANOTHER,
C END OF THE GROUP IS MARKED BY THE NEGATIVE INDEX VALUE.
C
C
C READ COL
C
      DO 300 I=1,NF
        WN11(I)=0
 300  CONTINUE
      DO 400 I=1,NF
        J=COL(I)
        WN11(J)=WN11(J)+1
 400  CONTINUE
      WN12(1)=1
      L=1
      DO 500 I=2,NF
        L=L+WN11(I-1)
        WN12(I)=L
        IF(WN11(I).EQ.0) GO TO 550
 500  CONTINUE
 550  CONTINUE
C
C CHANGE COL
C
      DO 600 I=1,NF
        J=COL(I)
        WN11(I)=J
 600  CONTINUE
      DO 700 I=1,NF
        J=WN11(I)
        COL(WN12(J))=I
        WN12(J)=WN12(J)+1
 700  CONTINUE
      DO 800 I=1,NCOL
        L=WN12(I)-1
        IF(L.GT.NF) GO TO 900
        COL(L)=-COL(L)
 800  CONTINUE
 900  CONTINUE
 1100 CONTINUE
      RETURN
      END
