* SUBROUTINE UUSIG1                ALL SYSTEMS                02/12/01
C PORTABILITY : ALL SYSTEMS
C 02/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE SHIFT PARAMETER.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  XO(N)  VECTORS OF VARIABLES DIFFERENCE.
*  RI  A  INPUT PARAMETER.
*  RI  B  INPUT PARAMETER.
*  RI  C  INPUT PARAMETER.
*  RI  AA  INPUT PARAMETER.
*  RI  AH  INPUT PARAMETER.
*  RI  PAR  NUMBER RHO/GAM.
*  RI  ZET  SHIFT PARAMETER ZETA.
*  RU  SIG  SHIFT PARAMETER SIGMA.
*  RI  CON  CONSTANT FOR THE PARAMETER SIGMA DETERMINATION.
*  II  MET3  CHOICE OF THE SHIFT PARAMETER. MET3=0-PREVIOUS CHOICE.
*         MET3=1-SIMPLE CHOICE WITH A CONSTANT RELATIVE PARAMETER.
*         MET3=2-USING QUADRATIC EQUATION. MET3=3-HEURISTIC CHOICE
*         WITH A RELATIVE PARAMETER LESS THEN HALF. MET3=4-HEURISTIC
*         CHOICE WITH THE OPTIMUM CONDITION NUMBER IN THE FIRST
*         ITERATION. MET3=5-HEURISTIC CHOICE DERIVED FROM THE LOWEST
*         EIGENVALUE
*
* COMMON DATA :
*  II  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  KIT  NUMBER OF THE ITERATION AFTER LAST RESTART.
*
      SUBROUTINE UUSIG1(N,XO,A,B,C,AA,AH,PAR,ZET,SIG,CON,MET3)
      $INCLUDE('UMCOMM')
      INTEGER N,MET3
      $FLOAT XO(N),A,B,C,AA,AH,PAR,ZET,SIG,CON
      $FLOAT DEN,POM,UXVDOT
C
C     DETERMINATION OF THE PARAMETER SIG (SHIFT)
C
      POM=B/AH
      DEN=ZET*AH
      IF (MET3.EQ.1) THEN
      SIG=CON*POM
      ELSE IF (MET3.EQ.2) THEN
      IF (AA.LE.ZERO) THEN
      SIG=CON*POM
      ELSE
      SIG=SIG*TWO*B/(DEN+SQRT(DEN**2+FOUR*PAR*AA*B))
      SIG=MAX(SIG,1.8$P-1*POM)
      SIG=MIN(SIG,6.0$P-1*POM)
C      IF (SIG.LE.1.8$P-1*POM) SIG=CON*POM
C      IF (SIG.GE.7.0$P-1*POM) SIG=CON*POM
      ENDIF
      ELSE IF (MET3.EQ.3) THEN
      SIG=HALF*SQRT(SIG*AH/A)*POM
      SIG=MAX(SIG,1.8$P-1*POM)
      ELSE IF (MET3.EQ.4) THEN
      IF (A.GT.ZERO) THEN
      DEN=UXVDOT(N,XO,XO)
      SIG=SQRT(MAX(ZERO,ONE-AA/A))/(ONE+SQRT(MAX(ZERO,ONE-B*B/
     & (DEN*AH))))*POM
      SIG=MAX(SIG,2.0$P-1*POM)
      SIG=MIN(SIG,8.0$P-1*POM)
      ELSE
      SIG=CON*POM
      ENDIF
      ELSE IF (MET3.EQ.5) THEN
      IF (A.GT.ZERO) THEN
      DEN=UXVDOT(N,XO,XO)
      SIG=SQRT(SIG*AH/A)/(ONE+SQRT(MAX(ZERO,ONE-B*B/(DEN*AH))))*POM
      SIG=MAX(SIG,2.0$P-1*POM)
      SIG=MIN(SIG,8.0$P-1*POM)
      ELSE
      SIG=CON*POM
      ENDIF
      ELSE IF (MET3.EQ.6) THEN
      DEN=MAX(ONE,(A/B)*(C/B))+C/B
      SIG=SIG*HALF*DEN*(ONE-SQRT(ONE-FOUR*(C/B)/(DEN*DEN)))
      SIG=SQRT(SIG*HALF*POM)
      SIG=MAX(SIG,1.8$P-1*POM)
      SIG=MIN(SIG,7.0$P-1*POM)
      ELSE
      SIG=MAX(SIG,1.5D-1*POM)
      SIG=MIN(SIG,4.5D-1*POM)
      ENDIF
      RETURN
      END
