$INTERFACE UUSSD1                                             97/12/01

  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE SPARSE
    HESSIAN  MATRIX:
     -1 - STEEPEST DESCENT DIRECTION
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - DIAGONAL INITIAL APPROXIMATION
      4 - DIAGONAL INITIAL APPROXIMATION FOR MINIMAX
  $CHECK(INITH,1,'-1\1\2\3\4',4)
  $N='NF'
  $ADD(REAL,'\$H($M)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($M)')
$REM  $ADD(INTEGER,'\$N')
  CALL UUSSD1($N,$IH($N+1)-1,$H,$IH,$JH,GMAX,$INITH)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUSSD1                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF A SPARSE SYMMETRIC POSITIVE DEFINITE MATRIX
*
* PARAMETERS :
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX H.
*  RO  H(M)  NUMERICAL VALUES OF THE SPARSE HESSIAN MATRIX STORED
*         IN THE PACKED ROW FORM.
*  II  IH(NF+1)  POINTERS OF THE DIAGONAL ELEMENTS OF THE SPARSE
*         HESSIAN MATRIX.
*  II  JH(M)  INDICES OF THE NONZERO ELEMENTS OF THE SPARSE HESSIAN
*         MATRIX IN THE PACKED ROW FORM.
*  RI  SIZE  L1-NORM OF THE GRADIENT VECTOR.
*  II  INITH  CHOICE OF THE INITIAL APPROXIMATION OF THE SPARSE
*         HESSIAN MATRIX. INITH=1-UNIT INITIAL APPROXIMATION.
*         INITH=2-RANDOM INITIAL APPROXIMATION. INITH=3-DIAGONAL
*         INITIAL APPROXIMATION.
*
* COMMON DATA :
*  RU  RAN  RANDOM NUMBER.
*  II  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*  II  IREST  RESTART SPECIFICATION. IF IREST=0 DOES NOT HOLD THEN A
*         RESTART IS PERFORMED.
*  IU  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  TO  TUXX   TEXT INFORMATION ON THE RESTART USED.
*
* SUBPROGRAMS USED :
*  S   UXSSMI  GENERATION OF THE UNIT MATRIX.
*  S   UXSSDO  INITIATION OF A DIAGONAL MATRIX.
*  RF  UNRAN1  RANDOM NUMBER GENERATOR.
*  S   UYSET3  DEFINITION OF THE RESTART VARIABLES.
*
      SUBROUTINE UUSSD1(N,M,H,IH,JH,SIZE,INITH)
      $INCLUDE('UMCOMM')
      INTEGER N,M,IH(N+1),JH(M),INITH
      $FLOAT H(M),SIZE
      INTEGER I,J,JSTRT,JSTOP
      $FLOAT POM,UNRAN1
      $FLOAT CON,CON1,CON2
      PARAMETER (CON=1.0$P 1,CON1=5.0$P-3,CON2=5.0$P 2)
      IF(IREST.LE.0) RETURN
      IF(INITH.LE.0) RETURN
      GOTO (1,2,4,5) INITH
    1 CALL UXSSMI(N,M,H,IH)
      TUXX='UNIT    '
      LD=MIN(LD,1)
      GO TO 9
    2 POM=(CON-ONE)/(CON+ONE)
      POM=POM/$DBLE(N+1)
      DO 3 J=1,IH(N+1)-1
      H(J)=POM*(TWO*UNRAN1(RAN)-ONE)
    3 CONTINUE
      CALL UXSSDO(N,M,ONE,H,IH,JH)
      TUXX='RANDOM  '
      LD=MIN(LD,1)
      GO TO 9
    4 POM=SIZE/TEN
      GO TO 6
    5 POM=SIZE
    6 DO 8 I=1,N
      JSTRT=IH(I)
      JSTOP=IH(I+1)-1
      H(JSTRT)=MIN(MAX(POM*ABS(H(JSTRT)),CON1),CON2)
      DO 7 J=JSTRT+1,JSTOP
      H(J)=ZERO
    7 CONTINUE
    8 CONTINUE
      TUXX='DIAGONAL'
      LD=MIN(LD,1)
    9 IDECF=0
      CALL UYSET3
      RETURN
      END
