* SUBROUTINE UUSSLT                ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* UPDATED SPARSE MATRIX IS REWRITED INTO THE DATA STRUCTURE
* OF THE COMPRESSED CHOLESKY FACTOR.
*
*  PARAMETERS :
*  II  N  MATRIX ORDER.
*  II  MMAX  SIZE OF THE PRINCIPAL ARRAYS OF THE SPARSE MATRIX.
*  II  M  SIZE OF THE UPDATED HESSIAN MATRIX.
*  RO  A(MMAX)   NUMERICAL VALUES OF THE SPARSE HESSIAN APPROXIMATION
*             STORED AT THE POSITIONS 1, ...,M. LOWER TRIANGULAR
*             FACTOR OF THE HESSIAN APPROXIMATION STORED AT THE
*             POSITIONS M+1, ..., M+MB.
*  II  IA(NF) POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  II  JA(MMAX)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW FORM AT THE FIRST M POSITIONS. COMPACT
*             STRUCTURE OF INDICES OF ITS TRIANGULAR FACTOR IS ROWWISE
*             STORED.
*  II  PSL(NF+1)  POINTER VECTOR OF THE COMPACT FORM OF THE TRIANGULAR
*             FACTOR OF THE HESSIAN APPROXIMATION.
*  IA  WN13(NF) AUXILIARY VECTOR.
*
      SUBROUTINE UUSSLT(N,MMAX,M,A,IA,JA,PSL,WN13)
      INTEGER N,MMAX,M
      INTEGER WN13(N+1)
      INTEGER PSL(N+1),IA(N+1),JA(MMAX)
      INTEGER JSTRT,JSTOP,I,J,K,L,L1
      $FLOAT A(MMAX)
C
C REWRITE ELEMENTS OF HESSIAN APPROXIMATION INTO THE
C STRUCTURE OF FACTOR - AFTER FIRST M POSITIONS
C
      DO 740 I=1,N
      WN13(I)=0
  740 CONTINUE
      L1=M+PSL(1)
      DO 750 I=1,N
        JSTRT=IA(I)
        JSTOP=IA(I+1)-1
        DO 741 J=JSTRT,JSTOP
        K=JA(J)
        WN13(K)=J
  741   CONTINUE
        JSTRT=JA(M+I)+N+1
C
C DIAGONAL ELEMENT INCLUDED
C
        K=WN13(I)
        WN13(I)=0
        A(L1)=A(K)
        L1=L1+1
        DO 742 J=JSTRT,JSTRT+PSL(I+1)-PSL(I)-1
          L=JA(M+J)
          IF(WN13(L).NE.0) THEN
            A(L1)=A(WN13(L))
            WN13(L)=0
          ELSE
            A(L1)=0
          END IF
          L1=L1+1
  742   CONTINUE
  750 CONTINUE
      RETURN
      END
