* SUBROUTINE UUVLVC                ALL SYSTEMS                31/12/16
C PORTABILITY : ALL SYSTEMS
C 31/12/16 VL :                                       ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF  B~  AND  A~ = Y~^T . HH: . Y~, WHERE  HH:  IS THE LAST
* BUT ONE VARIABLE METRIC AUXILIARY MATRIX.
*
* PARAMETERS :
*  II  M  NUMBER OF COLUMNS OF MATRICES XM, GM.
*  II  MM  MAXIMUM NUMBER OF COLUMNS OF MATRICES XM, GM.
*  II  LD  ORDER OF THE CURRENT BLOCK.
*  RI  XR(MM,MM)  MATRIX  XM^T . GM .
*  RO  WW(M+M)  AUXILIARY VECTOR.
*  RI  GR(M*(M+1)/2)  SYMMETRIC MATRIX  GM^T . GM  STORED COLUMNWISE.
*  RO  HRB(MM,MM)  BLOCK UPPER TRIANGULAR MATRIX  U-bar.
*  RO  EE(MM,MM)  MATRIX  E-bar.
*  RO  B  AUXILIARY PARAMETER  B = S^T . Y .
*  RO  BV  OUTPUT PARAMETER  B~ = S~^T . Y~ .
*  RO  ADD  OUTPUT PARAMETER  A~ = Y~^T . HH: . Y~ .
*
* SUBPROGRAMS USED :
*  S  UXDSMM  MULTIPLICATION OF SYMMETRIC MATRIX STORED COLUMNWISE
*     BY VECTOR.
*  S  UXELVI  STEPWISE INVERSION OF NONSYMMETRIC MATRIX.
*  S  UXECMM  MULTIPLICATION OF TWO-DIMENSIONAL RECTANGULAR MATRIX BY VECTOR.
*
      SUBROUTINE UUVLVC(M,MM,LD,XR,WW,GR,HRB,EE,B,BV,ADD)
      INTEGER L,LD,M,MM, I,IR,J,K
      $FLOAT EE(M),WW(M+M),XR(MM,MM),HRB(MM,MM),GR(M*(M+1)/2),ADD,B,BV,Q
      $FLOAT A,BB,UXVDOT
C   vypocet  BV=(s*)^T.y*=b-s^TY_(S_^T.Y_)^-1.S_^Ty,  :a=(y*)^T.H.y*=y^T.H~.y
      IF(M.LE.1)STOP 56
      L=M-LD
      HRB(:LD,:LD)=XR(L+1:M,L+1:M)
      B=XR(M,M)
      HRB(1,1)=1.0$P 0/HRB(1,1)
      BV=B
      DO K=2,LD
        CALL UXELVI(K,MM,LD-K,HRB,WW,BV,I)
      END DO
      HRB=0.0$P 0
      EE=0.0$P 0
C    vytvor.matic  Upruh=HRB ,  Epruh=EE
      DO J=1,L
        DO I=1,J
          HRB(I,J)=XR(I,J)
        END DO
        EE(J)=XR(J,J)
      END DO
      HRB(:M-1,L+1:M-1)=XR(:M-1,L+1:M-1)
      HRB(1,1)=1.0$P 0/HRB(1,1)
      DO K=1,M-1
        CALL UXELVI(K,MM,1,HRB,WW,Q,IR)
      END DO
      IF(IR.LT.0)STOP 55
      A=GR(M*(M+1)/2)
      BB=B/A
      ADD=0.0$P 0
      IF(IR.GT.0)CALL UXECMM(M-1,M-1,MM,HRB,XR(:M-1,M),WW)
      IF(IR.GT.0)CALL UXDSMM(M-1,GR,WW,WW(M+1))
      ADD=B+BB*UXVDOT(M-1,WW,WW(M+1))
      DO J=1,M-1
        ADD=ADD+WW(J)*(EE(J)*WW(J)-2.0$P 0*BB*GR(M*(M-1)/2+J))
      END DO
      RETURN
      END
