* SUBROUTINE UXBSBU                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* CORRECTION OF A BLOCKED SYMMETRIC MATRIX A. THE CORRECTION IS DEFINED
* AS A:=A+ALF*X*TRANS(X) WHERE ALF IS A GIVEN SCALING FACTOR AND X IS
* A GIVEN VECTOR.
*
* PARAMETERS :
*  II  L  BLOCK DIMENSION.
*  II  N  VECTOR DIMENSION.
*  RI  ABL(L*(L+1)/2)  VALUES OF NONZERO ELEMENTS OF THE GIVEN BLOCK.
*  II  JBL(L)  INDICES OF THE INDIVIDUAL BLOCKS
*  RI  ALF  SCALING FACTOR.
*  RI  X(N)  UNPACKED OR PACKED INPUT VECTOR.
*  II  JOB  FORM OF THE VECTOR X. JOB=1-UNPACKED FORM. JOB=2-PACKED
*         FORM.
*
      SUBROUTINE UXBSBU(L,N,ABL,JBL,ALF,X,JOB)
      INTEGER L,N,JBL(L),JOB
      $FLOAT ABL(L*(L+1)/2),ALF,X(*)
      INTEGER I,J,IP,JP,K
      K=0
      IF (JOB.EQ.1) THEN
      DO 3 I=1,L
        IP=JBL(I)
        DO 2 J=1,I
          JP=JBL(J)
          K=K+1
          IF (IP.GT.0.AND.JP.GT.0) THEN
            ABL(K)=ABL(K)+ALF*X(IP)*X(JP)
          ENDIF
    2   CONTINUE
    3 CONTINUE
      ELSE
      DO 5 I=1,L
        IP=JBL(I)
        DO 4 J=1,I
          JP=JBL(J)
          K=K+1
          IF (IP.GT.0.AND.JP.GT.0) THEN
          ABL(K)=ABL(K)+ALF*X(I)*X(J)
          ENDIF
    4   CONTINUE
    5 CONTINUE
      ENDIF
      RETURN
      END
