* SUBROUTINE UXBSDS                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  A SCALAR IS SET TO ALL DIAGONAL ELEMENTS OF THE SYMMETRIC BLOCKED
*  MATRIX.
*
* PARAMETERS :
*  II  NBLA  DIMENSION OF THE ARRAY ABL.
*  II  NBLKS  NUMBER OF BLOCKS OF THE MATRIX.
*  RI  ALF  SCALAR WHICH IS SET TO ALL DIAGONAL ELEMENTS
*           OF THE MATRIX.
*  RI  ABL(NBLA)  VALUES OF THE NONZERO ELEMENTS OF THE MATRIX.
*  II  IBLBG(NBLKS+1)  BEGINNINGS OF THE BLOCKS IN THE MATRIX.
*  RI  X(NBLKS)  INPUT VECTOR.
*
* SUBROUTINES USED :
*  UXDSDA  A SCALAR IS SET TO ALL DIAGONAL ELEMENTS OF A DENSE
*  SYMMETRIC MATRIX.

*  MATRIX.
*
      SUBROUTINE UXBSDS(NBLA,NBLKS,ALF,ABL,IBLBG,X)
      INTEGER NBLKS,NBLA,IBLBG(NBLKS+1)
      $FLOAT ALF,ABL(NBLA),X(NBLKS)
      INTEGER I,K,KBEG,KLEN
      $FLOAT ZERO
      PARAMETER (ZERO=1.0$P 0)
      K=1
      DO 1 I=1,NBLKS
      KBEG=IBLBG(I)
      KLEN=IBLBG(I+1)-KBEG
      IF (X(I).GE.ZERO) THEN
      CALL UXDSDO(KLEN, ALF,ABL(K))
      ELSE
      CALL UXDSDO(KLEN,-ALF,ABL(K))
      ENDIF
      K=K+KLEN*(KLEN+1)/2
   1  CONTINUE
      RETURN
      END
