* SUBROUTINE UXBSMO                ALL SYSTEMS                06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* BLOCKS OF THE SYMMETRIC BLOCKED MATRIX ARE SET TO THE UNIT MATRICES.
*
* PARAMETERS :
*  II  NBLA  DIMENSION OF THE ARRAY ABL.
*  II  NBLKS  NUMBER OF BLOCKS OF THE MATRIX.
*  RI  ABL(NBLA)  VALUES OF THE NONZERO ELEMENTS OF THE MATRIX.
*  II  IBLBG(NBLKS+1)  BEGINNINGS OF THE BLOCKS IN THE MATRIX.
*
* SUBROUTINES USED :
*  UXDSMI  DENSE SYMMETRIC MATRIX IS SET TO THE UNIT MATRIX.
*
      SUBROUTINE UXBSMO(NBLA,NBLKS,ALF,ABL,IBLBG)
      INTEGER NBLKS,NBLA,IBLBG(NBLKS+1)
      $FLOAT ALF,ABL(NBLA)
      INTEGER I,K,KBEG,KLEN
      K=1
      DO 1 I=1,NBLKS
      KBEG=IBLBG(I)
      KLEN=IBLBG(I+1)-KBEG
      CALL UXDSMO(KLEN,ALF,ABL(K))
      K=K+KLEN*(KLEN+1)/2
   1  CONTINUE
      RETURN
      END
