* FUNCTION UXBSMQ                  ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* VALUE OF A QUADRATIC FORM WITH A BLOCKED SYMMETRIC MATRIX.
*
* PARAMETERS :
*  II  N  MATRIX DIMENSION.
*  II  NBLA  DIMENSION OF THE ARRAY ABL.
*  II  NBLKS  NUMBER OF BLOCKS OF THE MATRIX.
*  II  NBLJ  DIMENSION OF THE ARRAY JBL.
*  RI  ABL(NBLA)  VALUES OF THE NONZERO ELEMENTS OF THE MATRIX.
*  II  IBLBG(NBLKS+1)  BEGINNINGS OF THE BLOCKS IN THE MATRIX.
*  II  JBL(NBLJ)  INDICES OF THE INDIVIDUAL BLOCKS
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*
      FUNCTION UXBSMQ(N,NBLA,NBLKS,NBLJ,ABL,IBLBG,JBL,X,Y)
      INTEGER N,NBLKS,NBLJ,NBLA,IBLBG(NBLKS+1),JBL(NBLJ)
      $FLOAT ABL(NBLA),X(N),Y(N),UXBSMQ
      $FLOAT TEMP,TEMP1,TEMP2,ZERO
      INTEGER I,J,I1,J1,K,KBEG,KBEG1,KLEN,I2
      PARAMETER  (ZERO = 0.0$P 0)
      TEMP=ZERO
      K=0
      DO 4 I=1,NBLKS
         KBEG=IBLBG(I)
         KBEG1=KBEG-1
         KLEN=IBLBG(I+1)-KBEG
         DO 3 I2=1,KLEN
            I1=JBL(I2+KBEG1)
            TEMP1=ZERO
            TEMP2=ZERO
            DO 2 J=1,I2-1
               J1=JBL(J+KBEG1)
               K=K+1
               IF (I1.GT.0.AND.J1.GT.0) THEN
                 TEMP1=TEMP1+ABL(K)*X(J1)
                 TEMP2=TEMP2+ABL(K)*Y(J1)
               ENDIF
    2       CONTINUE
            K=K+1
            IF (I1.GT.0) THEN
              TEMP=TEMP+X(I1)*(TEMP2+ABL(K)*Y(I1))+Y(I1)*TEMP1
            ENDIF
    3    CONTINUE
    4 CONTINUE
      UXBSMQ=TEMP
      RETURN
      END
