* SUBROUTINE UXBSMU                ALL SYSTEMS                92/06/01
C PORTABILITY : ALL SYSTEMS
C 92/06/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* CORRECTION OF A BLOCKED SYMMETRIC MATRIX A. THE CORRECTION IS DEFINED
* AS A:=A+ALF*X*TRANS(X) WHERE ALF IS A GIVEN SCALING FACTOR AND X IS
* A GIVEN VECTOR.
*
* PARAMETERS :
*  II  N  MATRIX DIMENSION.
*  II  NBLA  DIMENSION OF THE ARRAY ABL.
*  II  NBLKS  NUMBER OF BLOCKS OF THE MATRIX.
*  II  NBLJ  DIMENSION OF THE ARRAY JBL.
*  RI  ABL(NBLA)  VALUES OF THE NONZERO ELEMENTS OF THE MATRIX.
*  II  IBLBG(NBLKS+1)  BEGINNINGS OF THE BLOCKS IN THE MATRIX.
*  II  JBL(NBLJ)  INDICES OF THE INDIVIDUAL BLOCKS
*  RI  ALF  SCALING FACTOR.
*  RI  X(N)  INPUT VECTOR.
*
      SUBROUTINE UXBSMU(N,NBLA,NBLKS,NBLJ,ABL,IBLBG,JBL,ALF,X)
      INTEGER N,NBLKS,NBLJ,NBLA,IBLBG(NBLKS+1),JBL(NBLJ)
      $FLOAT ABL(NBLA),ALF,X(N)
      INTEGER I,J,I1,J1,K,KBEG,KBEG1,KLEN,I2
      DO 4 I=1,NBLKS
         KBEG=IBLBG(I)
         KBEG1=KBEG-1
         KLEN=IBLBG(I+1)-KBEG
         K=0
         DO 3 I2=1,KLEN
           I1=JBL(I2+KBEG1)
           DO 2 J=1,I2
             J1=JBL(J+KBEG1)
             K=K+1
             IF (I1.GT.0.AND.J1.GT.0) THEN
               ABL(K)=ABL(K)+ALF*X(I1)*X(J1)
             ENDIF
    2       CONTINUE
    3    CONTINUE
    4 CONTINUE
      RETURN
      END
