* SUBROUTINE UXDCHR               ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PSEUDORANK DETERMINATION AFTER QR DECOMPOSITION USING RIGHT HAND
* SIDE VECTOR.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RI  A(M*N)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX.
*  RI  TOL  TOLERANCE FOR PSEUDORANK DETERMINATION.
*  IO  NM  ASSUMED RANK OF THE MATRIX A. 
*  IO  NP  PSEUDORANK OF THE MATRIX A.
*
      SUBROUTINE UXDCHR(N,M,A,IA,TOL,NM,NP)
      INTEGER N,M,IA(N),NM,NP
      $FLOAT A(M*N),TOL
      $FLOAT POM,TEMP,TOL1
      INTEGER J,K,KP
      TOL1=SQRT(TOL)
      TEMP=TOL1
      NP=0
      DO 1 K=1,NM
      J=IA(K)
      KP=(J-1)*M
      POM=ABS(A(KP+K))
      IF (K.EQ.1) TEMP=TOL1*MAX(TEMP,POM)
      IF (POM.LE.TEMP) RETURN
      NP=K
    1 CONTINUE
      RETURN
      END
