* SUBROUTINE UXDCMC               ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF CENTER OF COLUMNS OF THE MATRIX A.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  M  NUMBER OF COLUMNS OF THE MATRIX A.
*  RI  A(N*M)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  RO  X(M)  OUTPUT VECTOR.
*
* SUBPROGRAMS USED :
*  S   UXVSCL  SCALING OF A VECTOR.
*  S   UXVSET  INITIATION OF A VECTOR.
*  S   UXVSUM  SUM OF TWO VECTORS.
*
      SUBROUTINE UXDCMC(N,M,A,X,K)
      INTEGER N,M,K
      $FLOAT A(N*M),X(M)
      INTEGER I,J,L
      $FLOAT ZERO,ONE
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0)
      CALL UXVSET(N,ZERO,X)
      L=M
      J=1
      DO 1 I=1,M
      IF (I.NE.K) THEN
      CALL UXVSUM(N,A(J),X,X)
      ELSE
      L=L-1
      ENDIF
      J=J+N
    1 CONTINUE
      CALL UXVSCL(N,ONE/$DBLE(L),X,X)
      RETURN
      END
