* SUBROUTINE UXDCMD               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A COLUMNWISE STORED DENSE RECTANGULAR MATRIX A
* BY A VECTOR X AND ADDITION OF THE SCALED VECTOR ALF*Y.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  M  NUMBER OF COLUMNS OF THE MATRIX A.
*  RI  A(N*M)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  RI  X(M)  INPUT VECTOR.
*  RI  ALF  SCALING FACTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR EQUAL TO A*X+ALF*Y.
*
* SUBPROGRAMS USED :
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  S   UXVSCL  SCALING OF A VECTOR.
*
      SUBROUTINE UXDCMD(N,M,A,X,ALF,Y,Z)
      INTEGER N,M
      $FLOAT A(N*M),X(M),ALF,Y(N),Z(N)
      INTEGER J,K
      CALL UXVSCL(N,ALF,Y,Z)
      K=0
      DO 1 J=1,M
      CALL UXVDIR(N,X(J),A(K+1),Z,Z)
      K=K+N
    1 CONTINUE
      RETURN
      END
