* SUBROUTINE UXDCMO               ALL SYSTEMS                17/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COLUMNWISE STORED DENSE RECTANGULAR MATRIX A IS AUGMENTED BY THE  
* SCALED UNIT MATRIX.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  IO  NM  NUMBER OF ROWS OF THE AUGMENTED MATRIX.
*  II  ALF  INPUT PARAMETER.
*  RI  A(M*N)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE             
*         ONE-DIMENSIONAL ARRAY. 
*  RO  AO((N+M)*N)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*         ONE-DIMENSIONAL EQUAL TO TRANS([TRANS(A),I]).
*
      SUBROUTINE UXDCMO(N,M,NM,ALF,A,AO)
      INTEGER N,M,NM
      $FLOAT ALF,A(M*N),AO((N+M)*N)
      INTEGER I,K,L
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      NM=N+M
      K=(N-1)*M
      L=(N-1)*NM
      DO 1 I=N,1,-1
      CALL UXVCOP(M,A(K+1),AO(L+1))
      CALL UXVSET(N,ZERO,AO(L+M+1))
      AO(L+M+I)=ALF
      K=K-M
      L=L-NM 
    1 CONTINUE
      RETURN
      END
