* SUBROUTINE UXDCTM                ALL SYSTEMS               16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  TRANSFORMATION OF SOLUTION OBTAINED FROM THE TOTAL QR DECOMPOSITION.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M*N)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  IO  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX.
*  RU  X(N)  SOLUTION VECTOR.
*  RO  D(N)  VECTOR CONTAINING INFORMATION ABOUT HOUSEHOLDER
*         TRANSFORMATIONS.
*  II  NP  PSAUDORANK OF THE MATRIX A.
*
      SUBROUTINE UXDCTM(N,M,A,IA,X,D,NP)
      INTEGER N,M,IA(N),NP
      $FLOAT A(M*N),D(N),X(N)
      $FLOAT POM
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      INTEGER I,J,K,L,JP,KP
      IF (NP.LT.N) THEN
      DO 6 K=NP,1,-1
      L=IA(K)
      KP=(L-1)*M
      POM=D(L)*X(L)
      DO 4 J=NP+1,N
      I=IA(J)
      JP=(I-1)*M
      POM=POM+A(K+JP)*X(I)
    4 CONTINUE
      X(L)=X(L)-POM
      POM=POM/D(L)
      DO 5 J=NP+1,N
      I=IA(J)
      JP=(I-1)*M
      X(I)=X(I)-POM*A(K+JP)
    5 CONTINUE
    6 CONTINUE
      ENDIF
      RETURN
      END
