* SUBROUTINE UXDGGM                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A GIVEN VECTOR X BY A DENSE UNSYMMETRIC
* MATRIX A USING THE FACTORIZATION A*P=L*U OBTAINED BY THE SUBROUTINE
* UXDGGM.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*N)  THE FACTORIZATION A*P = L*U OBTAINED BY THE SUBROUTINE
*         UXDGGF
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*  RU  X(N)  INPUT VECTOR.
*  RA  Y(N)  AUXILIARY VECTOR
*  JOB  OPTION. JOB=0 - MULTIPLICATION BY THE ORIGINAL MATRIX.
*         JOB=1 - MULTIPLICATION BY THE MATRIX TRSANSPOSE.
*
      SUBROUTINE UXDGGM(N,A,IA,X,Y,JOB)
      INTEGER N,IA(N),JOB
      $FLOAT A(N*N),X(N),Y(N)
      INTEGER J,K,KP
      IF (JOB.LE.0) THEN
      DO 2 K=1,N
      KP=IA(K)
      X(K)=X(K)*A(KP+K)
      DO 1 J=K+1,N
      X(K)=X(K)+A(KP+J)*X(J)
    1 CONTINUE
    2 CONTINUE
      DO 4 K=N,1,-1
      KP=IA(K)
      DO 3 J=1,K-1
      X(K)=X(K)+A(KP+J)*X(J)
    3 CONTINUE
    4 CONTINUE
      CALL UXVGBP(N,IA,X,Y)
      ELSE
      CALL UXVGFP(N,IA,X,Y)
      DO 6 K=1,N
      KP=IA(K)
      DO 5 J=1,K-1
      X(J)=X(J)+A(KP+J)*X(K)
    5 CONTINUE
    6 CONTINUE
      DO 8 K=N,1,-1
      KP=IA(K)
      DO 7 J=K+1,N
      X(J)=X(J)+A(KP+J)*X(K)
    7 CONTINUE
      X(K)=X(K)*A(KP+K)
    8 CONTINUE
      ENDIF
      RETURN
      END
