* FUNCTION UXDLBQ                  ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER UXDLBQ=TRANS(X)*D*X WHERE D IS A
* BLOCK DIAGONAL MATRIX IN THE FACTORIZATION A=P*U*D*TRANS(U)*TRANS(P)
* OBTAINED BY THE SUBROUTINE UXDLBF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  FACTORIZATION A=P*U*D*TRANS(U)*TRANS(P) OBTAINED
*         BY THE SUBROUTINE UXDLBF.
*  II  IA(N)  PERMUTATION FIELD OBTAINED BY THE SUBROUTINE UXDLBF.
*  RI  X(N)  INPUT VECTOR.
*  RR  UXDLBQ  COMPUTED NUMBER UXDLBQ=TRANS(X)*D*X.
*
      FUNCTION UXDLBQ(N,A,IA,X)
      INTEGER  N,IA(N)
      $FLOAT  A(N*(N+1)/2), X(N), UXDLBQ
      INTEGER K, KC
      $FLOAT TEMP
*
      K = N
      KC = N*( N+1 ) / 2
      TEMP = 0.0$P 0
   10 CONTINUE
      IF( K.LT.1 ) GO TO 30
      IF( IA( K ).GT.0 ) THEN
*
*         1 x 1 diagonal block
*
          TEMP = TEMP + X(K)*X(K)*A(KC)
          KC = KC - K
          K = K - 1
      ELSE
*
*         2 x 2 diagonal block
*
          TEMP = TEMP + X(K)*X(K)*A(KC)
          TEMP = TEMP + X(K-1)*X(K-1)*A(KC-K)
          TEMP = TEMP + 2.0$P 0*X(K-1)*X(K)*A(KC-1)
          KC = KC - 2*K + 1
          K = K - 2
      END IF
      GOTO 10
   30 CONTINUE
      UXDLBQ = TEMP
      RETURN
      END
