* SUBROUTINE UXDPRB                ALL SYSTEMS                89/12/01
C PORTABILITY : ALL SYSTEMS
C 89/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SOLUTION OF A SYSTEM OF LINEAR EQUATIONS WITH A DENSE SYMMETRIC
* POSITIVE DEFINITE MATRIX A USING THE FACTORIZATION A=TRANS(R)*R.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2) FACTORIZATION A=TRANS(R)*R.
*  RU  X(N)  ON INPUT THE RIGHT HAND SIDE OF A SYSTEM OF LINEAR
*         EQUATIONS. ON OUTPUT THE SOLUTION OF A SYSTEM OF LINEAR
*         EQUATIONS.
*  II  JOB  OPTION. IF JOB=0 THEN X:=A**(-1)*X. IF JOB>0 THEN
*         X:=TRANS(R)**(-1)*X. IF JOB<0 THEN X:=R**(-1)*X.
*
* METHOD :
* BACK SUBSTITUTION
*
      SUBROUTINE UXDPRB(N,A,X,JOB)
      INTEGER  N, JOB
      $FLOAT  A(N*(N+1)/2), X(N)
      INTEGER  I, J, II, IJ
      IF (JOB .GE. 0) THEN
C
C     PHASE 1 : X:=TRANS(R)**(-1)*X
C
      IJ = 0
      DO 3 I = 1,N
      DO 2 J = 1,I-1
      IJ = IJ + 1
      X(I) = X(I) - A(IJ)*X(J)
    2 CONTINUE
      IJ = IJ + 1
      X(I) = X(I)/A(IJ)
    3 CONTINUE
      ENDIF
      IF (JOB .LE. 0) THEN
C
C     PHASE 2 : X:=R**(-1)*X
C
      II = N*(N+1)/2
      DO 6  I = N, 1, -1
      IJ = II
      DO 5  J = I+1, N
      IJ = IJ + J - 1
      X(I) = X(I) - A(IJ)*X(J)
    5 CONTINUE
      X(I) = X(I)/A(II)
      II = II - I
    6 CONTINUE
      ENDIF
      RETURN
      END
