* SUBROUTINE UXDRDB                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE VECTOR X:=(D**2+ALF*I)**(-1)*X WHERE I IS
* THE UNIT MATRIX AND D IS THE DIAGONAL OF THE MATRIX R IN THE
* FACTORIZATION A=TRANS(R)*R.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2) FACTORIZATION A=TRANS(R)*R.
*  RI  ALF  INPUT PARAMETER.
*  RU  X(N)  UPDATED VECTOR X:=(D**2+ALF*I)**(-1)*X.
*
* METHOD :
* BACK SUBSTITUTION.
*
      SUBROUTINE UXDRDB(N,A,ALF,X)
      INTEGER N
      $FLOAT A(N*(N+1)/2),ALF,X(N)
      INTEGER I,II
      II=0
      DO 4 I=1,N
      II=II+I
      X(I)=X(I)/(A(II)**2+ALF)
    4 CONTINUE
      RETURN
      END
