* SUBROUTINE UXDRSC               ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SHIFT OF COLUMNS OF THE RECTANGULAR MATRICES A AND B. SHIFT OF
* ELEMENTS OF THE VECTOR U. THESE SHIFTS ARE USED IN THE LIMITED
* MEMORY HU AND STOREY METHOD.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A AND B.
*  II  M  NUMBER OF COLUMNS OF THE MATRIX A AND B.
*  RU  A(N*M)  RECTANGULAR MATRIX STORED AS A ONE-DIMENSIONAL ARRAY.
*  RU  B(N*M)  RECTANGULAR MATRIX STORED AS A ONE-DIMENSIONAL ARRAY.
*  RU  C(N*M)  RECTANGULAR MATRIX STORED AS A ONE-DIMENSIONAL ARRAY.
*  RU  D(N*M)  RECTANGULAR MATRIX STORED AS A ONE-DIMENSIONAL ARRAY.
*  RU  U(M)  VECTOR.
*  IO  MM  NUMBER OF NONDEGENERATED COLUMNS OF THE MATRIX C AND D.
*
      SUBROUTINE UXDRSC(N,M,A,B,C,D,U,MM)
      INTEGER N,M,MM
      $FLOAT A(N*M),B(N*M),C(N*M),D(N*M),U(M)
      $FLOAT TEMP,UXVDOT
      INTEGER I,J,K,L
      $FLOAT ZERO,ONE
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0)
      K=1
      MM=0
      DO 2 I=1,M
      CALL UXVCOP(N,A(K),C(K))
      CALL UXVCOP(N,B(K),D(K))
      L=1
      DO 1 J=1,I-1
      TEMP=UXVDOT(N,A(K),D(L))
      CALL UXVDIR(N,-TEMP*U(J),C(L),C(K),C(K))
      TEMP=UXVDOT(N,B(K),C(L))
      CALL UXVDIR(N,-TEMP*U(J),D(L),D(K),D(K))
      L=L+N
    1 CONTINUE
      TEMP=UXVDOT(N,C(K),D(K))
      IF (TEMP.EQ.ZERO) RETURN
      U(I)=ONE/TEMP
      MM=MM+1
      K=K+N
    2 CONTINUE
      RETURN
      END
