* SUBROUTINE UXDRTF                ALL SYSTEMS               93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  TOTAL QR DECOMPOSITION USING HOUSEHOLDER TRANSFORMATIONS.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  IO  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX.
*  RO  D(N)  VECTOR CONTAINING INFORMATION ABOUT HOUSEHOLDER
*         TRANSFORMATIONS.
*  II  NP  PSEUDORANK OF THE MATRIX A.
*
      SUBROUTINE UXDRTF(N,M,A,IA,D,NP)
      INTEGER N,M,IA(N),NP
      $FLOAT A(M*N),D(N)
      $FLOAT ALF,POM
      INTEGER I,J,K,L,LL,IP,JP,KP
      $FLOAT ONE
      PARAMETER (ONE=1.0$P 0)
      IF(NP.LT.N) THEN
      L=NP*N
      DO 8 K=NP,1,-1
      L=L-N
      KP=IA(K)
      POM=A(L+KP)**2
      DO 2 J=NP+1,N
      JP=IA(J)
      POM=POM+A(L+JP)**2
    2 CONTINUE
      POM=SIGN(SQRT(POM),A(L+KP))
      A(L+KP)=A(L+KP)/POM+ONE
      DO 3 J=NP+1,N
      JP=IA(J)
      A(L+JP)=A(L+JP)/POM
    3 CONTINUE
      LL=0
      DO 6 I=1,K-1
      IP=IA(I)
      ALF=A(L+KP)*A(LL+KP)
      DO 4 J=NP+1,N
      JP=IA(J)
      ALF=ALF+A(L+JP)*A(LL+JP)
    4 CONTINUE
      A(LL+KP)=A(LL+KP)-ALF
      ALF=ALF/A(L+KP)
      DO 5 J=NP+1,N
      JP=IA(J)
      A(LL+JP)=A(LL+JP)-ALF*A(L+JP)
    5 CONTINUE
      LL=LL+N
    6 CONTINUE
      D(KP)=A(L+KP)
      A(L+KP)=-POM
    8 CONTINUE
      ENDIF
      RETURN
      END
