* SUBROUTINE UXDSBM                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A GIVEN VECTOR X BY A DENSE SYMMETRIC MATRIX
* A USING THE FACTORIZATION A=P*L*D*TRANS(L)*TRANS(P) OBTAINED BY THE
* SUBROUTINE UXDSBF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  FACTORIZATION A=P*L*D*TRANS(L)*TRANS(P) OBTAINED
*         BY THE SUBROUTINE UXDSBF.
*  II  IA(N)  PERMUTATION FIELD OBTAINED BY THE SUBROUTINE UXDSBF.
*  RU  X(N)  ON INPUT THE GIVEN VECTOR. ON OUTPUT THE RESULT OF
*         MULTIPLICATION.
*  II  JOB  OPTION. IF JOB=0 THEN X:=A*X. IF JOB>0 THEN
*         X:=TRANS(L)*TRANS(P)*X. IF JOB<0 THEN X:=P*L*X.
*
      SUBROUTINE UXDSBM(N,A,IA,X,JOB)
      INTEGER N,IA(N),JOB
      $FLOAT A(N*(N+1)/2),X(N)
      $FLOAT XI,XJ
      INTEGER IS,IP,JP,I,J,II,JJ,IJ,IND
      IND(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      IF (JOB.GE.0) THEN
C
C     PHASE 1 : X:=TRANS(P)*TRANS(L)*X
C
      IS=1
      DO 2 IP=1,N
      I=IA(IP)
      IF (I.LT.0) THEN
      I=-I
      IS=-IS
      ENDIF
      DO 1 JP=IP+(3-IS)/2,N
      J=IA(JP)
      IF (J.LT.0) J=-J
      IJ=IND(I,J)
      X(I)=X(I)+A(IJ)*X(J)
    1 CONTINUE
    2 CONTINUE
      ENDIF
      IF (JOB.EQ.0) THEN
C
C     PHASE 2 : X:=D*X
C
      IP=1
    3 IF (IP.LE.N) THEN
      I=IA(IP)
      IF (I.GE.0) THEN
      II=IND(I,I)
      X(I)=X(I)*A(II)
      ELSE
      IP=IP+1
      I=-I
      J=-IA(IP)
      II=IND(I,I)
      IJ=IND(I,J)
      JJ=IND(J,J)
      XI=A(II)*X(I)+A(IJ)*X(J)
      XJ=A(IJ)*X(I)+A(JJ)*X(J)
      X(I)=XI
      X(J)=XJ
      ENDIF
      IP=IP+1
      GO TO 3
      ENDIF
      ENDIF
      IF (JOB.LE.0) THEN
C
C     PHASE 3 : X:=P*L*X
C
      IS=1
      DO 5 IP=N,1,-1
      I=IA(IP)
      IF (I.LT.0) THEN
      I=-I
      IS=-IS
      ENDIF
      DO 4 JP=1,IP-(3-IS)/2
      J=IA(JP)
      IF (J.LT.0) J=-J
      IJ=IND(I,J)
      X(I)=X(I)+A(IJ)*X(J)
    4 CONTINUE
    5 CONTINUE
      ENDIF
      RETURN
      END
