* FUNCTION UXDSBQ                  ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER UXDSBQ=TRANS(X)*D*Y WHERE D IS A
* BLOCK DIAGONAL MATRIX IN THE FACTORIZATION A=P*L*D*TRANS(L)*TRANS(P)
* OBTAINED BY THE SUBROUTINE UXDSBF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  FACTORIZATION A=P*L*D*TRANS(L)*TRANS(P) OBTAINED
*         BY THE SUBROUTINE UXDSBF.
*  II  IA(N)  PERMUTATION FIELD OBTAINED BY THE SUBROUTINE UXDSBF.
*  RI  X(N)  INPUT VECTOR.
*  RR  UXDSBQ  COMPUTED NUMBER UXDSBQ=TRANS(X)*D*Y.
*
      FUNCTION UXDSBQ(N,A,IA,X,Y)
      INTEGER  N,IA(N)
      $FLOAT  A(N*(N+1)/2), X(N), Y(N), UXDSBQ
      $FLOAT TEMP
      INTEGER  IP,I,J,II,JJ,IJ,IND
      $FLOAT ZERO
      PARAMETER (ZERO = 0.0$P 0)
      IND(I,J) = MAX(I,J) * (MAX(I,J) - 1) / 2 + MIN(I,J)
      TEMP = ZERO
      IP=1
    1 IF (IP.LE.N) THEN
      I = IA(IP)
      IF (I .GE. 0) THEN
      II = IND(I,I)
      TEMP=TEMP+X(I)*Y(I)*A(II)
      ELSE
      IP = IP + 1
      I = -I
      J = -IA(IP)
      II = IND(I,I)
      IJ = IND(I,J)
      JJ = IND(J,J)
      TEMP=TEMP+X(I)*(A(II)*Y(I)+A(IJ)*Y(J))
      TEMP=TEMP+X(J)*(A(JJ)*Y(J)+A(IJ)*Y(I))
      ENDIF
      IP=IP+1
      GO TO 1
      ENDIF
      UXDSBQ=TEMP
      RETURN
      END
