* SUBROUTINE UXDSBS                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING OF A DENSE SYMMETRIC MATRIX A USING THE FACTORIZATION
* A=P*L*D*TRANS(L)*TRANS(P) OBTAINED BY THE SUBROUTINE UXDSBF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RU  A(N*(N+1)/2)  FACTORIZATION A=P*L*D*TRANS(L)*TRANS(P) OBTAINED
*         BY THE SUBROUTINE UXDSBF.
*  II  IA(N)  PERMUTATION FIELD OBTAINED BY THE SUBROUTINE UXDSBF.
*  RI  ALF SCALING FACTOR.
*
      SUBROUTINE UXDSBS( N, A, IA, ALF)
      INTEGER  N,IA(N)
      $FLOAT  A(N*(N+1)/2), ALF
      INTEGER  IP,I,J,II,JJ,IJ,IND
      IND(I,J) = MAX(I,J) * (MAX(I,J) - 1) / 2 + MIN(I,J)
      IP=1
    1 IF (IP.LE.N) THEN
      I = IA(IP)
      IF (I .GE. 0) THEN
      II = IND(I,I)
      A(II)=A(II)*ALF
      ELSE
      IP = IP + 1
      I = -I
      J = -IA(IP)
      II = IND(I,I)
      IJ = IND(I,J)
      JJ = IND(J,J)
      A(II)=A(II)*ALF
      A(IJ)=A(IJ)*ALF
      A(JJ)=A(JJ)*ALF
      ENDIF
      IP=IP+1
      GO TO 1
      ENDIF
      RETURN
      END
