* FUNCTION UXDSDP                  ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER UXDSDP=TRANS(X)*(D+ALF*I)**(-1)*Y WHERE I
* IS THE UNIT MATRIX AND D IS THE DIAGONAL MATRIX IN THE FACTORIZATION
* A+E=L*D*TRANS(L) OBTAINED BY THE SUBROUTINE UXDPGF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2) FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXDPGF.
*  RI  ALF  INPUT PARAMETER.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RR  UXDPGP  COMPUTED NUMBER UXDSDP=TRANS(X)*(D+ALF*I)**(-1)*Y.
*
      FUNCTION UXDSDP(N,A,ALF,X,Y)
      INTEGER N
      $FLOAT A(N*(N+1)/2),ALF,X(N),Y(N),UXDSDP
      $FLOAT TEMP
      INTEGER I,J
      $FLOAT ZERO,CON
      PARAMETER (ZERO=0.0$P 0,CON=1.0$(P)120)
      J=0
      TEMP=ZERO
      DO 1 I=1,N
      J=J+I
      TEMP=TEMP+X(I)*Y(I)/(A(J)+ALF)
    1 CONTINUE
      UXDSDP=TEMP
      RETURN
      END
