* SUBROUTINE UXDSML                ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DENSE SYMMETRIC LANCZOS RECURRENCE.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2) ELEMENTS OF THE DENSE SYMMETRIC MATRIX STORED IN
*      THE PACKED FORM.
*  RO  D(K)  DIAGONAL ELEMENTS OF THE LANCZOS TRIDIAGONAL MATRIX.
*  RO  E(K)  SUBDIAGONAL ELEMENTS OF THE LANCZOS TRIDIAGONAL MATRIX.
*  RU  U(N)  INPUT VECTOR.
*  RO  V(N)  OUTPUT VECTOR.
*  II  K  NUMBER OF THE LANCZOS STEPS.
*  IO  INF  ERROR INDICATOR. IF INF>0 THE ALGORITHM FAILED.
*
      SUBROUTINE UXDSML(N,A,D,E,U,V,K,INF)
      INTEGER N,K,INF
      $FLOAT  A(N*(N+1)/2),D(K),E(K),U(N),V(N)
      $FLOAT  DI,EI,UXVDOT,UXVNOR
      $FLOAT ZERO,ONE
      INTEGER I,J
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0)
      INF=0
      CALL UXVSET(N,ZERO,V)
      CALL UXVSCL(N,ONE/UXVNOR(N,U),U,U)
      DO 2 I=1,K
      IF (I.GT.1) THEN
      DO 1 J=1,N
      DI=U(J)
      U(J)=V(J)/EI
      V(J)=-EI*DI
    1 CONTINUE
      ENDIF
      CALL UXDSMD(N,A,U,ONE,V,V)
      DI=UXVDOT(N,U,V)
      CALL UXVDIR(N,-DI,U,V,V)
      EI=UXVNOR(N,V)
      IF (EI.LE.ZERO) THEN
      INF=I
      RETURN
      ENDIF
      D(I)=DI
      E(I)=EI
    2 CONTINUE
      RETURN
      END
