* SUBROUTINE UXDSMU                ALL SYSTEMS                89/12/01
C PORTABILITY : ALL SYSTEMS
C 89/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* UPDATE OF A DENSE SYMMETRIC MATRIX A. THIS UPDATE IS DEFINED AS
* A:=A+ALF*X*TRANS(X) WHERE ALF IS A GIVEN SCALING FACTOR AND X IS
* A GIVEN VECTOR.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RU  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RI  ALF  SCALING FACTOR IN THE CORRECTION TERM.
*  RI  X(N)  VECTOR IN THE CORRECTION TERM.
*
      SUBROUTINE UXDSMU( N, A, ALF, X)
      INTEGER N
      $FLOAT  A(N*(N+1)/2), X(N), ALF
      $FLOAT TEMP
      INTEGER  I, J, K
      K = 0
      DO 2  I = 1, N
      TEMP = ALF * X(I)
      DO 1  J = 1, I
      K = K + 1
      A(K) = A(K) + TEMP * X(J)
    1 CONTINUE
    2 CONTINUE
      RETURN
      END
