* SUBROUTINE UXDSRM                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A GIVEN VECTOR X BY A DENSE SYMMETRIC POSITIVE
* DEFINITE MATRIX A USING THE FACTORIZATION A=TRANS(P)*TRANS(R)*R*P.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2) FACTORIZATION A=TRANS(P)*TRANS(R)*R*P.
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*  RU  X(N)  ON INPUT THE GIVEN VECTOR. ON OUTPUT THE RESULT OF
*         MULTIPLICATION.
*  II  JOB  OPTION. IF JOB=0 THEN X:=A*X. IF JOB>0 THEN X:=R*P*X.
*         IF JOB<0 THEN X:=TRANS(P)*TRANS(R)*X.
*
      SUBROUTINE UXDSRM( N, A, IA, X, JOB)
      INTEGER N, IA(N), JOB
      $FLOAT  A(N*(N+1)/2), X(N)
      INTEGER  I, J, IP, JP, II, IJ, IND
      IND(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      IF (JOB .GE. 0)  THEN
C
C     PHASE 1 : X:=R*P*X
C
      DO 3  I = 1, N
      IP = IA(I)
      II = IND(IP,IP)
      X(IP) = A(II) * X(IP)
      DO 2  J = I+1, N
      JP = IA(J)
      IJ = IND(IP,JP)
      X(IP) = X(IP) + A(IJ) * X(JP)
    2 CONTINUE
    3 CONTINUE
      ENDIF
      IF (JOB .LE. 0)  THEN
C
C     PHASE 2 : X:=TRANS(P)*TRANS(R)*X
C
      DO 6  I = N, 1, -1
      IP = IA(I)
      II = IND(IP,IP)
      X(IP) = A(II) * X(IP)
      DO 5  J = I-1, 1, -1
      JP = IA(J)
      IJ = IND(IP,JP)
      X(IP) = X(IP) + A(IJ) * X(JP)
    5 CONTINUE
    6 CONTINUE
      ENDIF
      RETURN
      END
