* SUBROUTINE UXDTGM                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* CORRECTIVE ORTHOGONAL TRANSFORMATION OF A SET OF LINEAR
* EQUATIONS USING GIVENS ROTATIONS.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  IU  M  ACTUAL NUMBER OF ROWS IN THE MATRIX A.
*  RU  A(N*(N+1)/2) UPPER TRIANGULAR MATRIX OBTAINED USING ORTHOGONAL
*         TRANSFORMATION OF A SET OF LINEAR EQUATIONS.
*  RU  B(N)  RIGHT HAND SIDE VECTOR OBTAINED USING ORTHOGONAL
*         TRANSFORMATION OF A SET OF LINEAR EQUATIONS.
*  RA  X(N)  AUXILIARY VECTOR.
*  RI  Y  CORRECTIVE PARAMETER.
*
* SUBPROGRAMS :
*  S   UXVSET  INITIATION OF A VECTOR.
*  S   UXDTGR  RECURSIVE ORTHOGONAL TRANSFORMATION OF A SET OF
*              LINEAR EQUATIONS.
*
* METHOD :
*  GIVENS ROTATIONS WITH SQUARE ROOTS.
*
      SUBROUTINE UXDTGM(N,M,A,B,X,Y)
      INTEGER N,M
      $FLOAT A(N*(N+1)/2),B(N),X(N),Y
      $FLOAT TEMP, TEMP1
      INTEGER I
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      IF(Y.LE.ZERO) RETURN
      TEMP1=Y
      TEMP=SQRT(Y)
      DO 1 I=1,N
      CALL UXVSET(N,X,ZERO)
      X(I)=TEMP
      Y=ZERO
      CALL UXDTGR(N,M,A,B,X,Y)
    1 CONTINUE
      Y=TEMP1
      RETURN
      END

