* SUBROUTINE UXDTGR                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* RECURSIVE ORTHOGONAL TRANSFORMATION OF A SET OF LINEAR
* EQUATIONS USING GIVENS ROTATIONS.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  IU  M  ACTUAL NUMBER OF ROWS IN THE MATRIX A.
*  RU  A(N*(N+1)/2) UPPER TRIANGULAR MATRIX OBTAINED USING ORTHOGONAL
*         TRANSFORMATION OF A SET OF LINEAR EQUATIONS.
*  RU  B(N)  RIGHT HAND SIDE VECTOR OBTAINED USING ORTHOGONAL
*         TRANSFORMATION OF A SET OF LINEAR EQUATIONS.
*  RU  X(N)  COEFFICIENTS OF A NEW LINEAR EQUATION.
*  RU  Y  RIGHT HAND SIDE OF A NEW LINEAR EQUATION.
*
* SUBPROGRAMS USED :
*  S   UXVORT  COMPUTATION OF THE PLANE ROTATION MATRIX.
*  S   UXVROT  PLANE ROTATION IS APPLIED TO TWO NUMBERS.
*
* METHOD :
*  GIVENS ROTATIONS WITH SQUARE ROOTS.
*
      SUBROUTINE UXDTGR(N,M,A,B,X,Y)
      INTEGER N,M
      $FLOAT A(N*(N+1)/2),B(N),X(N),Y
      $FLOAT C,S
      INTEGER I,J,II,IJ,JJ
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      II=0
      DO 2 I=1,M
      II=II+I
      IF(X(I).NE.ZERO) THEN
      CALL UXVORT(A(II),X(I),C,S,JJ)
      IJ=II
      DO 1 J=I+1,N
      IJ=IJ+J-1
      CALL UXVROT(A(IJ),X(J),C,S,JJ)
    1 CONTINUE
      CALL UXVROT(B(I),Y,C,S,JJ)
      ENDIF
    2 CONTINUE
      IF(M.LT.N) THEN
      IJ=II+1
      DO 3 J=M+1,N
      IJ=IJ+J-1
      A(IJ)=X(J)
    3 CONTINUE
      M=M+1
      B(M)=Y
      ENDIF
      RETURN
      END
