* SUBROUTINE UXDTTB                ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* TRANSFORMATION OF SOLUTION OBTAINED FROM THE TOTAL QR DECOMPOSITION.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMERICAL RANK OF THE MATRIX A.
*  RI  A(N*(N+1)/2) UPPER TRIANGULAR MATRIX.
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*  RO  D(N)  VECTOR CONTAINING INFORMATION ABOUT HOUSEHOLDER
*         TRANSFORMATIONS.
*  RU  B(N)  TRANSFORMED RIGHT HAND SIDE.
*  RU  X(N)  SOLUTION VECTOR.
*
      SUBROUTINE UXDTTB(N,M,A,IA,D,B,X,JOB)
      INTEGER N,M,IA(N),JOB
      $FLOAT A(N*(N+1)/2),D(N),B(N),X(N)
      $FLOAT POM
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      INTEGER I,J,K,JP,KP,KJ,KK,IND
      IND(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      DO 1 K=M+1,N
      KP=IA(K)
      X(KP)=ZERO
    1 CONTINUE
      DO 3 K=M,1,-1
      KP=IA(K)
      X(KP)=B(K)
      DO 2 J=K+1,M
      JP=IA(J)
      KJ=IND(KP,JP)
      X(KP)=X(KP)-A(KJ)*X(JP)
    2 CONTINUE
      KK=IND(KP,KP)
      X(KP)=X(KP)/A(KK)
    3 CONTINUE
      IF(JOB.GT.0.AND.M.LT.N) THEN
      DO 6 K=1,M
      KP=IA(K)
      KK=IND(KP,KP)
      POM=D(KP)*X(KP)
      DO 4 J=M+1,N
      JP=IA(J)
      KJ=IND(KP,JP)
      POM=POM+A(KJ)*X(JP)
    4 CONTINUE
      X(KP)=X(KP)-POM
      POM=POM/D(KP)
      DO 5 J=M+1,N
      JP=IA(J)
      KJ=IND(KP,JP)
      X(JP)=X(JP)-POM*A(KJ)
    5 CONTINUE
    6 CONTINUE
      ENDIF
      RETURN
      END
