* SUBROUTINE UXELVF                ALL SYSTEMS                31/12/16
C PORTABILITY : ALL SYSTEMS
C 31/12/16 VL :                                       ORIGINAL VERSION
*
* PURPOSE :
* POSITIVE DEFINITE MATRIX  RL  FACTORIZATION.
*
* PARAMETERS :
*  II  M  NUMBER OF COLUMNS OF MATRICES XM, GM.
*  II  MM  MAXIMUM NUMBER OF COLUMNS OF MATRICES XM, GM.
*  RU  XRP(MM,MM)  COPY OF MATRIX  XM^T . GM .
*  RO  HL(M*(M+1)/2)  LOWER TRIANGULAR MATRIX  L  STORED ROWWISE.
*  RO  HR(M*(M+1)/2)  UPPER TRIANGULAR MATRIX  R  STORED COLUMNWISE.
*  IO  IR  FACTORIZATION SUCCESS INDICATOR.
*
* SUBPROGRAMS USED :
*  S  UXELVT  SAVING OF UPPER TRIANGULAR PART OF MATRIX.
*
      SUBROUTINE UXELVF(M,MM,XRP,HL,HR,IR)
      INTEGER M,MM, I,IR,J,K,L
      $FLOAT XRP(MM,MM),HR(M*(M+1)/2),HL(M*(M+1)/2)
C   Transf.matice prevadejici pd  S^T.Y  na hor.trojuh.mat.:  XRP.HL^-1 -> HRB
      IR=-1
      DO J=M,1,-1
C        IF(XRP(J,J).LE.0.0$P 0)write(*,*)'DR<=0',XRP(J,J)
C        IF(XRP(J,J).LE.0.0$P 0)XRP(J,J)=1.0$P-4*XRP(M,M)
        IF(XRP(J,J).LE.0.0$P 0)RETURN
        L=J*(J-1)/2
        DO I=1,J
          HL(L+I)=XRP(J,I)/XRP(J,J)
          DO K=1,J-1
            XRP(I,K)=XRP(I,K)-XRP(J,K)*XRP(I,J)/XRP(J,J)
          END DO
        END DO
      END DO
      IR=0
      CALL UXELVT(M,MM,XRP,HR)
      RETURN
      END
