* SUBROUTINE UXSCMM               ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A SPARSE RECTANGULAR MATRIX A BY A VECTOR X.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  NA NUMBER OF COLUMNS OF THE MATRIX A.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD A.
*  RI  A(MA)  RECTANGULAR MATRIX STORED AS A TWO-DIMENSIONAL ARRAY.
*  II  IA(NA+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD A.
*  II  JA(MA) COLUMN INDICES OF ELEMENTS IN THE FIELD A.
*  RI  X(NA)  INPUT VECTOR.
*  RO  Y(N)  OUTPUT VECTOR EQUAL TO A*X.
*
* SUBPROGRAMS USED :
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  S   UXVSET  INITIATION OF A VECTOR.
*
      SUBROUTINE UXSCMM(N,NA,MA,A,IA,JA,X,Y)
      INTEGER N,NA,MA,IA(NA+1),JA(MA)
      $FLOAT A(MA),X(NA),Y(N)
      INTEGER I,J,K,L,JP
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      CALL UXVSET(N,ZERO,Y)
      DO 2 I=1,NA
      K=IA(I)
      L=IA(I+1)-K
      DO 1 J=1,L
      JP=JA(K)
      IF (JP.GT.0) Y(JP)=Y(JP)+A(K)*X(I)
      K=K+1
    1 CONTINUE
    2 CONTINUE
      RETURN
      END
