* SUBROUTINE UXSGD2                 ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 DA : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSGDB FROM UMFPACK.
*
      SUBROUTINE UXSGD2(NPIV,B,XX,II,W,X,ABLKP,AOFFP,AOFFI,
     & LUBLP,LUP,PERMR,PERMC,AOFFX,AN,ABLKS,
     & LUNS,ANZOFF,ABSPT,Z,VL)
      INTEGER AN,ABLKS,LUNS,II(*),ABLKP(ABLKS+1),NPIV,
     & AOFFP(AN+1),ANZOFF,AOFFI(*),LUBLP(ABLKS+1),
     & LUP(LUNS),PERMR(AN),PERMC(AN),I,ROW,K,M,N,
     & LXP,LIP,J,S,COL,KB,NODE,P,UXP,UIP,EP,
     & VL,M1,UXP1,PXP,K1,KI,KJ,LXP1,NODE1,KNODE
      $FLOAT XX(*),AOFFX(*),B(AN),X(AN),
     & W(AN),Y,ABSPT,Z(AN),PIV
      DO 15 ROW = 1, AN
      W (ABS (PERMC (ROW))) = B (ROW)
15    CONTINUE
C
C     COPY THE STARTING W VECTOR INTO X, SO THAT WE CAN RECOVER
C     FROM ZERO PIVOTS
C
      DO 125 K = 1, AN
      X (K) = W (K)
125   CONTINUE
      NPIV = AN
      DO 100 KB = 1, ABLKS
C
C     DO FORWARD SUBSTITUTION FOR EACH ELEMENT IN LU FACTOR OF
C     DIAGONAL BLOCK
C
      K = ABLKP (KB) - 1
      DO 35 S = LUBLP (KB), LUBLP (KB+1) - 1
      EP = LUP (S)
      NODE = II((EP)+1)
      LXP = II(EP)
      UIP = ((EP)+5+II((EP)+3))
      IF (NODE .EQ. 1) THEN
C
C     ONLY ONE PIVOT, STRIDE-1 SAXPY
C
      PIV = XX (LXP)
      K = K + 1
      M = II((EP)+3) + 1
      N = II((EP)+2) + 1
      UXP = LXP + M
      IF (ABS (PIV) .LE. ABSPT) THEN
      Y = X (K)
      NPIV = NPIV - 1
      ELSE
      Y = W (K) / PIV
      ENDIF
      W (K) = Y
      DO 325 I = 2, N
      W (II(UIP)) = W (II(UIP)) - XX (UXP) * Y
      UIP = UIP + 1
      UXP = UXP + 1
325   CONTINUE
      ELSE
C
C     DO TRIANGULAR PART, STRIDE-1 DOT PRODUCT
C
      NODE1 = NODE + 1
      M = II((EP)+3) + NODE
      N = II((EP)+2) + NODE
      UXP = LXP + NODE*M
      M1 = M + 1
      PXP = LXP
      K1 = K + 1
      KI = K1
      KNODE = K + NODE
      DO 225 I = 1, NODE
      PIV = XX (PXP)
      IF (ABS (PIV) .LE. ABSPT) THEN
      Y = X (KI)
      NPIV = NPIV - 1
      ELSE
      LXP1 = LXP
      Y = W (KI)
      DO 425 KJ = K1, KI-1
      Y = Y - XX (LXP1) * W (KJ)
      LXP1 = LXP1 + 1
425   CONTINUE
      Y = Y / PIV
      ENDIF
      W (KI) = Y
      PXP = PXP + M1
      LXP = LXP + M
      KI = KI + 1
225   CONTINUE
C
C     DO BLOCK PART (MATRIX MULTIPLY)
C
      IF (NODE .LT. VL) THEN
C
C     NON-STRIDE-1 SAXPY'S, LONGER LOOPS THAN IF STRIDE-1
C
      UIP = UIP - NODE1
      DO 101 I = NODE1, N
      Z (I) = W (II(UIP+I))
101   CONTINUE
      DO 21 KJ = K1, KNODE
      UXP1 = UXP
      Y = W (KJ)
      DO 25 I = NODE1, N
      Z (I) = Z (I) - XX (UXP1) * Y
      UXP1 = UXP1 + NODE
25    CONTINUE
      UXP = UXP + 1
21    CONTINUE
      DO 102 I = NODE1, N
      W (II(UIP+I)) = Z (I)
102   CONTINUE
      ELSE
C
C     STRIDE-1 DOT PRODUCTS
C
      DO 230 I = NODE1, N
      ROW = II (UIP)
      UIP = UIP + 1
      Y = W (ROW)
      DO 240 KJ = K1, KNODE
      Y = Y - XX (UXP) * W (KJ)
      UXP = UXP + 1
240   CONTINUE
      W (ROW) = Y
230   CONTINUE
      ENDIF
      K = KNODE
      ENDIF
35    CONTINUE
C
C     DO BACK-SUBSTITUTION FOR EACH ELEMENT IN LU FACTOR OF
C     DIAGONAL BLOCK
C
      DO 90 S = LUBLP (KB+1) - 1, LUBLP (KB), -1
      EP = LUP (S)
      NODE = II((EP)+1)
      LXP = II(EP)
      LIP = ((EP)+5)
      IF (NODE .EQ. 1) THEN
C
C     ONLY ONE PIVOT, STRIDE-1 DOT PRODUCT
C
      M = II((EP)+3) + 1
      PIV = XX (LXP)
      LXP = LXP + 1
      IF (ABS (PIV) .GT. ABSPT) THEN
      Y = W (K)
      DO 40 J = 2, M
      Y = Y - XX (LXP) * W (II (LIP))
      LXP = LXP + 1
      LIP = LIP + 1
40    CONTINUE
      W (K) = Y
      ENDIF
      K = K - 1
      ELSE
C
C     STRIDE-1 DOT PRODUCTS, AMORTIZED GATHER/SCATTER
C
      M = II((EP)+3) + NODE
      K = K - NODE
      M1 = M + 1
      NODE1 = NODE + 1
      PXP = LXP + (NODE-1)*M1
      DO 50 J = 1, NODE
      Z (J) = W (K+J)
50    CONTINUE
      DO 55 J = NODE1, M
      Z (J) = W (II (LIP))
      LIP = LIP + 1
55    CONTINUE
      DO 60 I = NODE, 1, -1
      PIV = XX (PXP)
      IF (ABS (PIV) .GT. ABSPT) THEN
      LXP = PXP + 1
      Y = Z (I)
      DO 70 J = I+1, M
      Y = Y - XX (LXP) * Z(J)
      LXP = LXP + 1
70    CONTINUE
      Z (I) = Y
      ENDIF
      PXP = PXP - M1
60    CONTINUE
      DO 80 J = 1, NODE
      W (K+J) = Z (J)
80    CONTINUE
      ENDIF
90    CONTINUE
C
C     DO THE OFF-DIAGONAL BLOCK
C
      IF (ANZOFF .GT. 0 .AND. KB .LT. ABLKS) THEN
      DO 110 COL = ABLKP (KB), ABLKP (KB+1) - 1
      Y = W (COL)
      DO 120 P = AOFFP (COL), AOFFP (COL+1)-1
      W (AOFFI(P)) = W (AOFFI(P)) - Y * AOFFX (P)
120   CONTINUE
110   CONTINUE
      ENDIF
100   CONTINUE
C
C     COMPUTE THE FINAL SOLUTION, X = P^T * DROW * W
C
      DO 215 COL = 1, AN
      X (COL) = W (ABS (PERMR (COL)))
215   CONTINUE
      RETURN
      END
