* SUBROUTINE UXSGIF                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INCOMPLETE FACTORIZATION OF A GENERAL SPARSE MATRIX A.
*
* PARAMETERS :
*  II  N  MATRIX DIMENSION.
*  II  M  NUMBER OF MATRIX NONZERO ELEMENTS.
*  RU  A(M)  NONZERO ELEMENTS OF THE MATRIX A.
*  II  IA(N+1)  ROW POINTERS OF THE MATRIX A.
*  II  JA(M)  COLUMN INDICES OF THE MATRIX A.
*  IO  IP(N)  PERMUTATION VECTOR.
*  IO  ID(N)  DIAGONAL POINTERS OF THE MATRIX A.
*  RA  IW(N)  AUXILIARY VECTOR.
*  RI  TOL  PIVOT TOLERANCE.
*  IO  INF  INFORMATION.
*
      SUBROUTINE UXSGIF(N,M,A,IA,JA,IP,ID,IW,TOL,INF)
      INTEGER N,M,IA(N+1),JA(M),IP(N),ID(N),IW(N),INF
      $FLOAT A(M),TOL
      INTEGER I,J,K,II,JJ,KK,JSTRT,JSTOP,KSTRT,KSTOP
      $FLOAT TEMP
      $FLOAT ZERO,ONE,CON
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0,CON=1.0D-30)
      INF=0
      DO 11 I=1,N
      IF (IP(I).LE.0.OR.IP(I).GT.N) THEN
      CALL UXVINP(N,IP)
      GO TO 12
      ENDIF
   11 CONTINUE
   12 CALL UXVINS(N,0,IW)
      DO 5 K=1,N
      KSTRT=IA(K)
      KSTOP=IA(K+1)-1
      ID(K)=0
      DO 1 JJ=KSTRT,KSTOP
      J=JA(JJ)
      IW(J)=JJ
      IF (IP(J).EQ.K) ID(K)=JJ
    1 CONTINUE
      IF (ID(K).EQ.0) THEN
      INF=-45
      CALL UOERR1('UXSGIF',45)
      RETURN
      ENDIF
      IF (TOL.GT.ZERO) A(ID(K))=(ONE+TOL)*A(ID(K))
      IF (ABS(A(ID(K))).LT.TOL) A(ID(K))=A(ID(K))+SIGN(TOL,A(ID(K)))
      DO 3 JJ=KSTRT,KSTOP
      J=IP(JA(JJ))
      IF (J.LT.K) THEN
      JSTRT=IA(J)
      JSTOP=IA(J+1)-1
      TEMP=A(JJ)/A(ID(J))
      A(JJ)=TEMP
      DO 2 II=JSTRT,JSTOP
      I=JA(II)
      IF (IP(I).GT.J) THEN
      KK=IW(I)
      IF (KK.NE.0) A(KK)=A(KK)-TEMP*A(II)
      ENDIF
    2 CONTINUE
      ENDIF
    3 CONTINUE
      KK=ID(K)
      IF (ABS(A(KK)).LT.CON) THEN
      INF=K
      IF (A(KK).EQ.ZERO) THEN
      A(KK)=CON
      ELSE
      A(KK)=SIGN(CON,A(KK))
      ENDIF
      ENDIF
      DO 4 JJ=KSTRT,KSTOP
      J=JA(JJ)
      IW(J)=0
    4 CONTINUE
    5 CONTINUE
      RETURN
      END
