* SUBROUTINE UXSPIM                ALL SYSTEMS                96/12/01
C PORTABILITY : ALL SYSTEMS
C 96/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SOLUTION OF A SYSTEM OF LINEAR EQUATIONS WITH A SPARSE SYMMETRIC
* POSITIVE DEFINITE MATRIX A+E USING INCOMPLETE FACTORIZATION
* A+E=L*D*TRANS(L) OBTAINED BY THE SUBROUTINE UXSPIF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  II  M NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) INCOMPLETE FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXSPGF.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RU  X(N)  ON INPUT THE RIGHT HAND SIDE OF A SYSTEM OF LINEAR
*         EQUATIONS. ON OUTPUT THE SOLUTION OF A SYSTEM OF LINEAR
*         EQUATIONS.
*  II  JOB  OPTION. IF JOB=0 THEN X:=(A+E)**(-1)*X. IF JOB>0 THEN
*         X:=L**(-1)*X. IF JOB<0 THEN X:=TRANS(L)**(-1)*X.
*
* METHOD :
* BACK SUBSTITUTION
*
      SUBROUTINE UXSPIM(N,M,A,IA,JA,X,JOB)
      INTEGER N,M,IA(N+1),JA(M),JOB
      $FLOAT A(M),X(N)
      INTEGER I,K,IK,KK,LL
      $FLOAT ZERO,CON
      PARAMETER (ZERO=0.0$P 0,CON=1.0$(P)120)
      IF (JOB .GE. 0) THEN
C
C     PHASE 1 : X:=TRANS(L)*X
C
      KK=1
      DO 3 K=1,N
      LL=IA(K+1)
      DO 2 IK=KK+1,LL-1
      I=JA(IK)
      X(K)=X(K)+A(IK)*X(I)
    2 CONTINUE
      KK=LL
    3 CONTINUE
      ENDIF
      IF (JOB .EQ. 0) THEN
C
C     PHASE 2 : X:=D*X
C
      DO 4 K=1,N
      X(K)=X(K)*A(IA(K))
    4 CONTINUE
      ENDIF
      IF (JOB .LE. 0) THEN
C
C     PHASE 3 : X:=L*X
C
      LL=IA(N+1)
      DO 6 K=N,1,-1
      KK=IA(K)
      DO 5 IK=KK+1,LL-1
      I=JA(IK)
      X(I)=X(I)+A(IK)*X(K)
    5 CONTINUE
      LL=KK
    6 CONTINUE
      ENDIF
      RETURN
      END
