* SUBROUTINE UXSRBF                ALL SYSTEMS               94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  SYMBOLIC FACTORIZATION. TAKEN FROM SPARSPAK.
*
*  PARAMETERS :
*  II  M NUMBER OF MATRIX ROWS.
*  II  N NUMBER OF MATRIX COLUMNS.
*  IO  IER ERROR MESSAGE.
*  II  MAXNJB MAXIMUM SIZE OF NJB.
*  II  NJB DIMENSION OF THE ARRAYS JB.
*  II  NJBR DIMENSION OF THE ARRAY B.
*  II  IB(M+1) INDICES OF THE FIRST MEMBERS IN ROWS OF THE MATRIX.
*  II  JB(MAXNJA) COLUMN INDICES OF THE MATRIX. 
*  II  IA(N+1) INDICES OF THE FIRST MEMBERS IN COLUMNS OF THE MATRIX.
*  IO  INVP(N+1) INVERSE OF THE OUTPUT ORDERING.
*  II  PERMC(N+1) INDIVIDUAL ORDERING BEFORE UXSRBD.
*  IA  WN01(M+1) AUXILIARY ARRAY.
*  IA  WN02(M+1) AUXILIARY ARRAY.
*  IA  WN03(M+1) AUXILIARY ARRAY.
*  IA  WN04(M+1) AUXILIARY ARRAY.
*  II  B SPARSE RECTANGULAR MATRIX.
*  II  RHS(M) RIGHT HAND SIDE.
*    
*  
      SUBROUTINE UXSRBF(M,N,IER,MAXNJB,NJB,NJBR,IB,JB,IA,
     *        INVP,PERMC,WN01,WN02,WN03,WN04,B,RHS)
      INTEGER M,N,IER,MAXNJB,NJB,NJBR
      INTEGER IA(M+1),IB(N+1),JB(MAXNJB),INVP(N+1),PERMC(N+1)
      INTEGER WN01(M+1),WN02(M+1),WN03(M+1),WN04(M+1)
      $FLOAT  B(MAXNJB),RHS(M)
      INTEGER NRHS
      NRHS = 1
C      FTOP = 2 * NJA
C
C NUMERICAL PART OF DECOMPOSITION
C
      CALL UXSRD2(N,NRHS,M,NJB,NJBR,IA,IB,JB,B,INVP,PERMC,
     *     WN01,WN02,WN03,WN04,IER,RHS)
      RETURN
      END
