* SUBROUTINE UXSRBN                ALL SYSTEMS               91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  INCOMPLETE NESTED DISSECTION. MODIFIED FROM SPARSPAK.
*
*  PARAMETERS :
*  II  NEQNS NUMBER OF VARIABLES.
*  II  XADJ(N+1) POINTER VECTOR FOR THE ADJACENCY STRUCTURE.
*  II  ADJNCY(*) ADJACENCY STRUCTURE OF THE INPUT GRAPH.
*  IO  PERM(N) PERMUTATION VECTOR.
*  IO  INVP(N) INVERSE PERMUATTION VECTOR.
*  IA  MASK(N)  USED TO MASK VARIABLES YET ORDERED.
*  IA  XLS(N+1) POINTER VECTOR FOR THE ROOTED LEVEL STRUCTURE.
*  IA  LS(N) INDICES OF THE ROOTED LEVEL STRUCTURE.
*
C
C     CHANGED 23.3.1992 - HN
      SUBROUTINE  UXSRBN ( NEQNS, XADJ, ADJNCY, MASK, PERM,IPERM,
     &                    XLS, LS , LABEL,SON)
C
         INTEGER    NEQNS,XADJ(NEQNS+1),ADJNCY(*),MASK(NEQNS+1),
     &              PERM(*),IPERM(*),XLS(*),LS(*),LABEL(*),SON(*)
         INTEGER    I, NLVL, NSEP, NUM, ROOT, LEVEL
C
         IF  ( NEQNS .LE. 0 )  RETURN
C
         DO  100  I = 1, NEQNS
             MASK(I) = 1
             LABEL(I) = 1
             SON(I) = 0
  100    CONTINUE
         NUM = 0
         IPERM(1) = 1
C
         DO  300  I = 1, NEQNS
C
C            FOR EACH MASKED COMPONENT ...
C
  200        CONTINUE
                 IF  ( MASK(I) .EQ. 0 )  GO TO 300
                     ROOT = I
                     NUM = NUM + 1
C
C                FIND A SEPARATOR AND NUMBER THE NODES NEXT.
C
                 CALL  UXSRO4 ( ROOT, XADJ, ADJNCY, MASK,NSEP,
     &           PERM(IPERM((NUM-1)*3+1)), XLS, LS,LEVEL,NLVL )
                 CALL UXSRO3(NUM,MASK,XLS,LS,PERM,IPERM,NSEP,LEVEL,
     &           LABEL,NLVL,SON)
                 IF (IPERM(NUM*3+1)-1 .GE. NEQNS) GO TO 400
               GO TO 200
  300    CONTINUE
  400    CONTINUE
         RETURN
      END
