* SUBROUTINE  UXSRBP               ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE : ROWS PERMUTATION.
*
*  PARAMETERS :
*  II  M NUMBER OF ROWS OF THE MATRIX.
*  II  N NUMBER OF COLUMN OF THE MATRIX.
*  II  IA INDICES OF THE FIRST MEMBERS IN COLUMNS OF THE MATRIX.
*  II  IB INDICES OF THE FIRST MEMBERS IN ROWS OF THE MATRIX.
*  II  JA INDICES OF MEMBERS OF THE MATRIX.
*  II  JB
*  IA  LABEL(N+1) VERTICES OF THE NEIGHBORHOOD.
*  IA  WN02(M) AUXILIARY VECTOR.
*  IA  LABEL2(N+1) THE MARKER VECTOR FOR REACH AND NBRHD SETS.
*  II  PERMC(N) COLUMN PERMUTATION.
*  IO  PERMR(M) ROW PERMUTATION.
*  IA  WN01(M) AUXILIARY VECTOR.
*  IA  WN03(*) AUXILIARY VECTOR.
*  IA  WN0X(*) AUXILIARY VECTOR.
*  IA  SON(N+1) THE DEGREE VECTOR. SONG(I).LT.0 MEANS THE NODE
*              BELONGS TO THE FINAL SUBSET.
*  II  IPERMC(N) INVERSE COLUMN PERMUTATION.
*
*  CHANGED : 23.11.1992
*
      SUBROUTINE UXSRBP(M,N,IA,IB,JA,JB,LABEL,WN02,LABEL2,PERMC,PERMR,
     + WN01,WN03,WN0X,SON,IPERMC)
      INTEGER K,M,N,I,J,JJ,NUM,LL,IND,J1,J2,J3,NUM0,JP
      INTEGER PERMC(N),PERMR(M),IA(N+1),JA(*),WN01(M),LABEL2(N),IB(M+1)
      INTEGER LABEL(N),WN02(M),WN03(*),WN0X(*),IPERMC(N),SON(N),JB(*)
      NUM = 0
      NUM0 = 1
      JP = 1
C
C  NULOVANI POLE WN01 URCENEHO PRO INVERZNI RADKOVOU PERMUTACI
C
      DO 300 I=1, M
        WN01(I) = 0
        WN02(I) = 0
        WN03(I) = 0
  300 CONTINUE
C
C ZPRACOVANI JJ-TEHO SLOUPCE
C
      DO 100 JJ=1, N
C
C KTERY SLOUPEC J JE NYNI NA MISTE JJ-TEHO SLOUPCE
C
        J = PERMC(JJ)
C
C DO KTEREHO BLOKU J1 PATRI SLOUPEC NA MISTE JJ
C
        J1=LABEL2(JJ)
C
C PATRI-LI JJ-TY SLOUPEC DO NOVEHO BLOKU - VOLEJ UXSRBR
C
        IF (JP.GT.0.AND.J1.NE.JP) CALL UXSRBR(JP,IB,JB,LABEL2,LABEL,SON,
     +  PERMR,IPERMC,WN01,WN03,WN0X,NUM0,NUM,M,N)
C
C URCUJE MISTO J2 VE STROMOVE STRUKTURE, KAM PATRI SLOUPEC J
C
        J2=ABS(LABEL(J))
C
C BLOK J1 NENI SUDY ZAPORNY SEPARATOR
C
        IF (J1.GT.0) THEN
C
C CYKLUS PROBIRA JEDNOTLIVE NENULOVE PRVKY J-TEHO SLOUPCE
C
          DO 200 I=IA(J), IA(J+1) - 1
C
C V J3 JE ULOZEN RADEK, NA KTEREM LEZI PRAVE ZPRACOVAVANY NENUL. PRVEK
C
            J3=JA(I)
            IF (WN01(J3).EQ.0.OR.WN01(J3).LT.0.AND.J2.GE.WN02(J3)) THEN
              NUM = NUM + 1
              PERMR(NUM) = J3
              WN01(J3) = NUM
            END IF
  200     CONTINUE
C
C BLOK J1 JE SUDY ZAPORNY SEPARATOR
C
        ELSE
          DO 400 I=IA(J), IA(J+1) - 1
            J3=JA(I)
            IF (WN01(J3).EQ.0.OR.WN01(J3).LT.0.AND.J2.GE.WN02(J3)) THEN
             WN01(J3) = -(NUM+1)
             WN02(J3) = J2
            END IF
  400     CONTINUE
        END IF
        JP = J1
  100 CONTINUE
      CALL UXSRBR(JP,IB,JB,LABEL2,LABEL,SON,
     +      PERMR,IPERMC,WN01,WN03,WN0X,NUM0,NUM,M,N)
C
C JSOU-LI ZPRACOVANY VSECHNY RADKY MATICE - KONEC
C
      IF (NUM .EQ. M) RETURN
      J = 0
      DO 1100 I=1, M
        IF (WN01(I) .LT. 0) THEN
          J = J + 1
          LABEL2(J) = -WN01(I)
          PERMC(J) = I
        END IF
 1100 CONTINUE
      CALL UXVSR7(J,LABEL2,PERMC)
      LL = M
      IND = J
 1400 K = LABEL2(IND)
      DO 1200 I=NUM, K, -1
        PERMR(LL) = PERMR(I)
        LL = LL - 1
 1200 CONTINUE
 1300 PERMR(LL) = PERMC(IND)
      LL = LL - 1
      IND = IND - 1
      IF (IND .EQ. 0) GO TO 1500
      IF (LABEL2(IND) .EQ. K) GO TO 1300
      NUM = K - 1
      GO TO 1400
 1500 DO 1600 I=K, M
        WN01(PERMR(I)) = I
 1600 CONTINUE
      RETURN
      END
