* SUBROUTINE UXSSMM                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A SPARSE SYMMETRIC MATRIX BY A VECTOR X.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RI  X(N)  INPUT VECTOR.
*  RO  Y(N)  OUTPUT VECTOR WHERE Y := A * X.
*
      SUBROUTINE UXSSMM(N,M,A,IA,JA,X,Y)
      INTEGER N,M,IA(N+1),JA(M)
      $FLOAT  A(M),X(N),Y(N)
      $FLOAT ZERO
      INTEGER I,J,K,JSTRT,JSTOP
      PARAMETER   (ZERO = 0.0$P 0)
      DO 100 I=1,N
      Y(I)=ZERO
100   CONTINUE
      JSTOP=0
      DO 300 I=1,N
        JSTRT=JSTOP+1
        JSTOP=IA(I+1)-1
        IF (JA(JSTRT).GT.0) THEN
          DO 200 J=JSTRT,JSTOP
            K=JA(J)
            IF(J.EQ.JSTRT) THEN
              Y(I)=Y(I)+A(J)*X(I)
            ELSE IF (K.GT.0) THEN
              Y(K)=Y(K)+A(J)*X(I)
              Y(I)=Y(I)+A(J)*X(K)
            ENDIF
200       CONTINUE
        ENDIF
300   CONTINUE
      RETURN
      END
