* SUBROUTINE UXSSMN                ALL SYSTEMS                89/12/01
C PORTABILITY : ALL SYSTEMS
C 89/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* THIS SUBROUTINE FINDS THE PERMUTATION VECTOR PERM FOR THE
* SPARSE SYMMETRIC MATRIX GIVEN IN THE VECTOR PAIR PA,SA.IT USES
* THE SO-CALLED NESTED DISSECTION METHOD.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  II  MMAX  LENGTH OF THE PRINCIPAL MATRIX VECTORS.
*  II  PA(N+1) POINTER VECTOR OF THE INPUT MATRIX.
*  II  SA(MMAX) VECTOR OF THE COLUMN INDICES OF THE INPUT MATRIX.
*  IO  PERM(N) PERMUTATION VECTOR.
*  IA  WN11(N+1) AUXILIARY VECTOR.
*  IA  WN12(N+1) AUXILIARY VECTOR.
*  IA  WN13(N+1) AUXILIARY VECTOR.
*
* METHOD :
* NESTED DISSECTION METHOD
*
*
      SUBROUTINE UXSSMN( N,MMAX,PA,SA,PERM,WN11,WN12,WN13)
      INTEGER N,MMAX
      INTEGER PA(N+1),SA(MMAX),PERM(N)
      INTEGER WN11(N+1),WN12(N+1),WN13(N+1)
      INTEGER I,J,K,NUM,ROOT,NLVL,LVLEND,LBEGIN,ICS
      INTEGER NN,N1,MINDEG,N2,LVSIZE,NDEG,NUNLVL,MIDLVL
      INTEGER TEMP,NPUL,NSEP,I1,I2,I3,I4,J1,J2
      DO 100 I = 1, N
      WN11(I) = 1
  100 CONTINUE
      NUM= 0
      DO 2000 I = 1, N
  200 IF ( WN11(I) .EQ. 0 ) GO TO 2000
      ROOT = I
      WN11(ROOT) = 0
      WN13(1) = ROOT
      NLVL = 0
      LVLEND = 0
      ICS = 1
  300 LBEGIN = LVLEND + 1
      LVLEND = ICS
      NLVL = NLVL + 1
      WN12(NLVL) = LBEGIN
      DO 500 K = LBEGIN, LVLEND
      NN = WN13(K)
      DO 400 J=PA(NN),PA(NN+1)-1
      N2 = SA(J)
      IF(N2.EQ.NN) GO TO 400
      IF  (WN11(N2).EQ.0) GO TO 400
      ICS = ICS + 1
      WN13(ICS) = N2
      WN11(N2) = 0
  400 CONTINUE
  500 CONTINUE
      LVSIZE=ICS-LVLEND
      IF(LVSIZE.GT.0) GO TO 300
      WN12(NLVL+1) = LVLEND + 1
      DO 600 K = 1, ICS
      NN = WN13(K)
      WN11(NN) = 1
  600 CONTINUE
      ICS = WN12(NLVL+1) - 1
      IF  ( NLVL .EQ. 1 .OR. NLVL .EQ. ICS )GO TO 1470
  700 J1 = WN12(NLVL)
      MINDEG = ICS
      ROOT = WN13(J1)
      IF  ( ICS .EQ. J1 ) GO TO 1000
      DO 900 J = J1, ICS
      NN = WN13(J)
      NDEG = 0
      DO 800 K=PA(NN),PA(NN+1)-1
      N1 = SA(K)
      IF(N1.EQ.NN) GO TO 800
      IF  ( WN11(N1)  .GT. 0 ) NDEG = NDEG + 1
  800 CONTINUE
      IF  ( NDEG .GE. MINDEG  ) GO TO 900
      ROOT = NN
      MINDEG = NDEG
  900 CONTINUE
 1000 CONTINUE
      WN11(ROOT) = 0
      WN13(1) = ROOT
      NUNLVL = 0
      LVLEND = 0
      ICS = 1
 1100 LBEGIN = LVLEND + 1
      LVLEND = ICS
      NUNLVL = NUNLVL + 1
      WN12(NUNLVL) = LBEGIN
      DO 1300 K = LBEGIN, LVLEND
      NN = WN13(K)
      DO 1200 J=PA(NN),PA(NN+1)-1
      N2 = SA(J)
      IF(N2.EQ.NN) GO TO 1200
      IF  (WN11(N2).EQ.0) GO TO 1200
      ICS = ICS + 1
      WN13(ICS) = N2
      WN11(N2) = 0
 1200 CONTINUE
 1300 CONTINUE
      LVSIZE=ICS-LVLEND
      IF(LVSIZE.GT.0) GO TO 1100
      WN12(NUNLVL+1) = LVLEND + 1
      DO 1400 K = 1, ICS
      NN = WN13(K)
      WN11(NN) = 1
 1400 CONTINUE
      IF(NUNLVL .LE.NLVL) GO TO 1470
      NLVL=NUNLVL
      IF(NLVL.LT.ICS) GO TO 700
1470  CONTINUE
      IF ( NLVL .GE. 3 ) GO TO 1600
      NSEP = WN12(NLVL+1) - 1
      DO 1500 K = 1, NSEP
      NN = WN13(K)
      PERM(NUM+K) = NN
      WN11(NN) = 0
 1500 CONTINUE
      GO TO 1950
 1600 MIDLVL = (NLVL+2)/2
      I3 = WN12(MIDLVL)
      I1 = WN12(MIDLVL + 1)
      I4 = I1 - 1
      I2 = WN12(MIDLVL+2) - 1
      DO 1700 K = I1, I2
      NN = WN13(K)
      PA(NN) = - PA(NN)
 1700 CONTINUE
      NSEP = 0
      DO 1800 K = I3, I4
      NN = WN13(K)
      J1 = PA(NN)
      J2 = IABS(PA(NN+1)) - 1
      DO 1750 J = J1, J2
      N2 = SA(J)
      IF(N2.EQ.NN) GO TO 1750
      IF ( PA(N2) .GT. 0 ) GO TO 1750
      NSEP = NSEP + 1
      PERM(NSEP+NUM) = NN
      WN11(NN) = 0
      GO TO 1800
 1750 CONTINUE
 1800 CONTINUE
      DO 1900 K = I1, I2
      NN = WN13(K)
      PA(NN) = - PA(NN)
 1900 CONTINUE
 1950 CONTINUE
      NUM = NUM + NSEP
      IF ( NUM .GE. N ) GO TO 2100
      GO TO 200
 2000 CONTINUE
 2100 CONTINUE
      IF (N.LT.2) GO TO 2300
      NPUL = N/2
      DO 2200 I=1,NPUL
      TEMP=PERM(I)
      PERM(I)=PERM(N-I+1)
      PERM(N-I+1)=TEMP
2200  CONTINUE
2300  CONTINUE
      RETURN
      END
