* FUNCTION UXUDEL                  ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  SQUARED NORM OF A SHIFTED VECTOR IN A BOUND CONSTRAINED CASE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  SCALING FACTOR.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*  RR  UXUDEL SQUARED NORM OF Y+A*X.
*
      FUNCTION UXUDEL(N,A,X,Y,IX,JOB)
      INTEGER N,IX(N),JOB
      $FLOAT A,X(N),Y(N),UXUDEL
      INTEGER I
      $FLOAT ZERO
      PARAMETER(ZERO=0.0$P 0)
      DOUBLE PRECISION TEMP
      TEMP=ZERO
      IF (JOB.EQ.0) THEN
      DO 1 I=1,N
      TEMP=TEMP+(Y(I)+A*X(I))**2
    1 CONTINUE
      ELSE IF (JOB.GT.0) THEN
      DO 2 I=1,N
      IF (IX(I).GE. 0) TEMP=TEMP+(Y(I)+A*X(I))**2
    2 CONTINUE
      ELSE
      DO 3 I=1,N
      IF (IX(I).NE.-5) TEMP=TEMP+(Y(I)+A*X(I))**2
    3 CONTINUE
      ENDIF
      UXUDEL=TEMP
      RETURN
      END
