* FUNCTION  UXUNOR               ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* EUCLIDEAN NORM OF A VECTOR IN A BOUND CONSTRAINED CASE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*  RR  UXUNOR  EUCLIDEAN NORM OF X.
*
      FUNCTION UXUNOR(N,X,IX,JOB)
      INTEGER N,IX(N),JOB
      $FLOAT X(N),UXUNOR
      $FLOAT POM,DEN
      INTEGER I
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      DEN=ZERO
      IF (JOB.EQ.0) THEN
      DO 1 I=1,N
      DEN=MAX(DEN,ABS(X(I)))
    1 CONTINUE
      ELSE IF (JOB.GT.0) THEN
      DO 2 I=1,N
      IF (IX(I).GE. 0) DEN=MAX(DEN,ABS(X(I)))
    2 CONTINUE
      ELSE
      DO 3 I=1,N
      IF (IX(I).NE.-5) DEN=MAX(DEN,ABS(X(I)))
    3 CONTINUE
      ENDIF
      POM=ZERO
      IF (DEN.GT.ZERO) THEN
      IF (JOB.EQ.0) THEN
      DO 4 I=1,N
      POM=POM+(X(I)/DEN)**2
    4 CONTINUE
      ELSE IF (JOB.GT.0) THEN
      DO 5 I=1,N
      IF (IX(I).GE. 0) POM=POM+(X(I)/DEN)**2
    5 CONTINUE
      ELSE
      DO 6 I=1,N
      IF (IX(I).NE.-5) POM=POM+(X(I)/DEN)**2
    6 CONTINUE
      ENDIF
      ENDIF
      UXUNOR=DEN*SQRT(POM)
      RETURN
      END
