* SUBROUTINE UXUTRS                ALL SYSTEMS                03/12/01
C PORTABILITY : ALL SYSTEMS
C 03/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF A SCALING FACTOR FOR THE BOUNDARY STEP.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  DEL  MAXIMUM STEPSIZE.
*  RI  X(N)  INTERIOR VECTOR.
*  RI  Y(N)  EXTERIOR VECTOR.
*  RU  ALF  SCALING FACTOR FOR THE BOUNDARY STEP.
*  II  INT  CHOICE OF THE INTERIOR VECTOR. INTERIOR VECTOR IS
*         EQUAL TO ZERO IF INT=0.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*
      SUBROUTINE UXUTRS(N,DEL,X,Y,ALF,INT,IX,JOB)
      INTEGER N,INT,IX(N),JOB
      $FLOAT DEL,X(N),Y(N),ALF
      $FLOAT VINT,VDIF
      INTEGER I,IPOM
      IPOM= 1
      IF (ALF.LT.0.0$P 0) THEN
      IPOM=-1
      ALF=-ALF
      ENDIF
      DO 1 I=1,N
      IF (JOB.LT.0.AND.IX(I).EQ.-5) GO TO 1
      IF (JOB.GT.0.AND.IX(I).LT. 0) GO TO 1
      IF (INT.EQ.0) THEN
      VINT=0.0$P 0
      ELSE
      VINT=X(I)
      ENDIF
      IF (INT.GE.0) THEN
      VDIF=Y(I)
      ELSE
      VDIF=Y(I)-VINT
      ENDIF
      IF (IPOM.LT.0) VDIF=-VDIF
      IF (VDIF.GT.0.0$P 0) THEN
      ALF=MIN(ALF,( DEL-VINT)/VDIF)
      ELSE IF (VDIF.LT.0.0$P 0) THEN
      ALF=MIN(ALF,(-DEL-VINT)/VDIF)
      ENDIF
    1 CONTINUE
      IF (IPOM.LT.0) ALF=-ALF
      RETURN
      END
