* SUBROUTINE  UXVETS              ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE : POSTORDERING OF THE ELIMINATION TREE
*
*  PARAMETERS :
*  II  NN  NUMBER OF BLOCK COLUMNS OF A.
*  II  PARENT(NN)
*  IA  WN01(NN) AUXILIARY VECTOR.
*  IA  SON(NN)
*  IA  ISON(NN+1)
*  IO  PSTORD(NN)
*
      SUBROUTINE UXVETS(NN,PARENT,WN01,SON,ISON,PSTORD)
      INTEGER NN,PARENT(NN),WN01(NN),I,OLDAD
      INTEGER SON(NN),ISON(NN+1),DAD,PSTORD(NN)
C
      DO 190 I=1,NN
        WN01(I)=0
 190  CONTINUE
C  -----------------------------------------
C  THE NUMBER OF SONS OF INDIVIDUAL PARENTS.
C  -----------------------------------------
      DO 200 I=1,NN-1
        WN01(PARENT(I)) = WN01(PARENT(I)) + 1
  200 CONTINUE
C  ---------------------------
C  FIND INDICES OF ARRAY ISON.
C  ---------------------------
      ISON(1) = 1
      DO 300 I=1, NN
        ISON(I+1) = ISON(I) + WN01(I)
        WN01(I) = 0
  300 CONTINUE
C  --------------------------
C  FIND MEMBERS OF ARRAY SON.
C  --------------------------
      DO 400 I=1, NN-1
        SON(ISON(PARENT(I))+WN01(PARENT(I))) = I
        WN01(PARENT(I)) = WN01(PARENT(I)) + 1
  400 CONTINUE
C  ----------------------------------
C  SORTED SON BY MAIN BRANCH OF TREE.
C  ----------------------------------
      OLDAD = 1
  450 DAD = PARENT(OLDAD)
      IF (DAD.EQ.0) GO TO 490
      IF (ISON(DAD).EQ.ISON(DAD+1)-1) GO TO 480
      WN01(ISON(DAD)) = OLDAD
      DO 460 I=ISON(DAD), ISON(DAD+1) - 1
        WN01(I+1) = SON(I)
        SON(I) = WN01(I)
        IF (WN01(I+1).EQ.OLDAD) GO TO 480
  460 CONTINUE
  480 OLDAD = DAD
      GO TO 450
C  ------------------------
C  CREATED OF ARRAY PSTORD.
C  ------------------------
  490 DAD = 1
      DO 500 I=1, NN
  510   IF (ISON(DAD).EQ.ISON(DAD+1).OR.SON(ISON(DAD)).LT.0) THEN
          PSTORD(I) = DAD
          DAD = PARENT(DAD)
          IF (DAD.EQ.0) GO TO 600
          IF (ISON(DAD).NE.ISON(DAD+1)) THEN
            SON(ISON(DAD)) = -SON(ISON(DAD))
            ISON(DAD) = ISON(DAD) + 1
          END IF
          GO TO 500
        END IF
        DAD = SON(ISON(DAD))
        GO TO 510
  500 CONTINUE
C  ----
C  END.
C  ----
  600 RETURN
      END
