* SUBROUTINE UXVORT               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF AN ELEMENTARY ORTHOGONAL MATRIX FOR PLANE ROTATION.
*
* PARAMETERS :
*  RU  XK  FIRST VALUE FOR PLANE ROTATION (XK IS TRANSFORMED TO
*         SQRT(XK**2+XL**2))
*  RU  XL  SECOND VALUE FOR PLANE ROTATION (XL IS TRANSFORMED TO
*         ZERO)
*  RO  CK  DIAGONAL ELEMENT OF THE ELEMENTARY ORTHOGONAL MATRIX.
*  RO  CL  OFF-DIAGONAL ELEMENT OF THE ELEMENTARY ORTHOGONAL MATRIX.
*  IO  IER  INFORMATION ON THE TRANSFORMATION. IER=0-GENERAL PLANE
*         ROTATION. IER=1-PERMUTATION. IER=2-TRANSFORMATION SUPPRESSED.
*
      SUBROUTINE UXVORT(XK,XL,CK,CL,IER)
      INTEGER IER
      $FLOAT XK,XL,CK,CL
      $FLOAT POM,DEN
      $FLOAT ZERO,ONE
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0)
      IF (XL.EQ.ZERO) THEN
      IER=2
      ELSE IF (XK.EQ.ZERO) THEN
      XK=XL
      XL=ZERO
      IER=1
      ELSE
      IF (ABS(XK).GE.ABS(XL)) THEN
      POM=XL/XK
      DEN=SQRT(ONE+POM*POM)
      CK=ONE/DEN
      CL=POM/DEN
      XK=XK*DEN
      ELSE
      POM=XK/XL
      DEN=SQRT(ONE+POM*POM)
      CL=ONE/DEN
      CK=POM/DEN
      XK=XL*DEN
      ENDIF
      XL=ZERO
      IER=0
      ENDIF
      RETURN
      END
