* SUBROUTINE UXVSR3                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SMALLEST-LAST ORDERING OF THE GRAPH.
*
* PARAMETERS :
*  II  MCOLS  NUMBER OF INTEGER VALUES OF THE SORTED ARRAY.
*  II  JH(1)  INDICES OF NONZERO ELEMENTS OF A SPARSE
*         SYMMETRIC MATRIX.
*  II  IH(MCOLS+1)  POINTERS OF DIAGONAL ELEMENTS OF A SPARSE
*         SYMMETRIC MATRIX.
*  RI  DEG(MCOLS)  VALUES OF THE SORTED ARRAY.
*  RO  ORD(MCOLS)  SORTED OUTPUT.
*  RA  RADIX(MCOLS+1)  REAL AUXILIARY ARRAY.
*  IA  WN01(MCOLS)  INTEGER AUXILIARY ARRAY.
*  IA  WN02(MCOLS)  INTEGER AUXILIARY ARRAY.
*
      SUBROUTINE UXVSR3(MCOLS,JH,IH,DEG,ORD,RADIX,WN01,WN02)
      INTEGER MCOLS,JH(1),IH(MCOLS+1),WN01(MCOLS),WN02(MCOLS)
      $FLOAT DEG(MCOLS),ORD(MCOLS),RADIX(MCOLS+1)
      INTEGER I,J,L,L1,L2,L3,L4,L5,L6,JSTRT,JSTOP
C
C RADIX IS SHIFTED : 0-(MCOLS-1) --- 1-MCOLS
C
      DO 50 I=1,MCOLS
      RADIX(I)=0
50    CONTINUE
C
      DO 100 I=1,MCOLS
      L=DEG(I)
      RADIX(L+1)=RADIX(L+1)+1
100   CONTINUE
C
C     RADIX COUNTS THE NUMBER OF VERTICES WITH DEG(I)>=L
C
      L=0
      DO 200 I=MCOLS,0,-1
      L=RADIX(I+1)+L
      RADIX(I+1)=L
      WN01(I+1)=L
200   CONTINUE
C
C     ARRAY ORD IS FILLED
C
      DO 300 I=1,MCOLS
      L=DEG(I)
      L1=RADIX(L+1)
      ORD(L1)=I
      RADIX(L+1)=L1-1
      WN02(I)=L1
300   CONTINUE
C
C     SMALLEST-LAST ORDERING OF ITS OWN
      DO 400 I=MCOLS,3,-1
      L=ORD(I)
      L1=DEG(L)
      WN01(L1+1)=I-1
      JSTRT=IH(L)
      JSTOP=IH(L+1)-1
C
C     DELETE CYCLE
C
      DO 500 J=JSTRT,JSTOP
      L2=WN02(JH(J))
      IF(L2.LT.I) THEN
        L6=JH(J)
        L3=DEG(L6)
        L4=WN01(L3+1)
        L5=ORD(L4)
        ORD(L2)=L5
        ORD(L4)=L6
        WN02(L5)=L2
        WN02(L6)=L4
        WN01(L3+1)=L4-1
        DEG(L6)=L3-1
      END IF
500   CONTINUE
400   CONTINUE
C
      RETURN
      END
