* FUNCTION UXVVDP                  ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER UXVVDP=TRANS(X)*D**(-1)*Y WHERE D IS A
* DIAGONAL MATRIX STORED AS A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  D(N)  DIAGONAL MATRIX STORED AS A VECTOR.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RR  UXVVDP  COMPUTED NUMBER UXVVDP=TRANS(X)*D**(-1)*Y.
*
      FUNCTION UXVVDP(N,D,X,Y)
      INTEGER N
      $FLOAT  D(N), X(N), Y(N), UXVVDP
      $FLOAT  TEMP
      INTEGER  I
      $FLOAT ZERO
      PARAMETER (ZERO = 0.0$P 0)
      TEMP = ZERO
      DO  1  I = 1, N
      TEMP = TEMP + X(I)*Y(I)/D(I)
    1 CONTINUE
      UXVVDP = TEMP
      RETURN
      END
