* FUNCTION UXWDOT                  ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DOT PRODUCT OF TWO VECTORS IN THE PACKED CASE.
*
* PARAMETERS :
*  II  L  PACKED VECTOR DIMENSION.
*  II  N  UNPACKED VECTOR DIMENSION.
*  II  JBL(L)  INDICES OF PACKED VECTOR.
*  RI  X(N)  UNPACKED OR PACKED INPUT VECTOR.
*  RI  Y(N)  UNPACKED INPUT VECTOR.
*  II  JOB  FORM OF THE VECTOR X. JOB=1-UNPACKED FORM. JOB=2-PACKED
*          FORM.
*  RR  UXVDOT  VALUE OF DOT PRODUCT UXVDOT=TRANS(X)*Y.
*
      FUNCTION UXWDOT(L,N,JBL,X,Y,JOB)
      INTEGER L,N,JBL(L),JOB
      $FLOAT  X(*), Y(N), UXWDOT
      DOUBLE PRECISION TEMP
      INTEGER I,IP
      TEMP=0.0D0
      IF (JOB.EQ.1) THEN
      DO 1 I=1,L
      IP=JBL(I)
      IF (IP.GT.0) TEMP=TEMP+X(IP)*Y(IP)
    1 CONTINUE
      ELSE
      DO 2 I=1,L
      IP=JBL(I)
      IF (IP.GT.0) TEMP=TEMP+X(I)*Y(IP)
    2 CONTINUE
      ENDIF
      UXWDOT=TEMP
      RETURN
      END
