$INTERFACE UYADC1                                             98/12/01

  CALL UYADC1(NF,M,$X,$IX,$XL,$XU,$H,$IH,$S,$GO,$GS,INEW)
  $ADD(REAL,'\$X($NF)\$XL($NF)\$XU($NF)\$H($M)\$S($NF)\$GO($NF)&
  \$GS($NF)')
  $ADD(INTEGER,'\$IX($NX)\$IH($NF+1)')
$REM  $ADD(INTEGER,'\NF\M\INEW')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYADC1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* NEW SIMPLE BOUNDS ARE ADDED TO THE ACTIVE SET. GRADIENT AND DIRECTION
* VECTOR ARE UPDATED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE HESSIAN MATRIX.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  H(M)  HESSIAN MATRIX OR ITS APPROXIMATION.
*  II  IH(NF+1) POINTERS OF THE HESSIAN MATRIX STORED IN A COMPACT
*         FORM.
*  RI  S(NF)  DIRECTION VECTOR.
*  RU  GO(NF)  GRADIENT OF THE QUADRATIC APPROXIMATION.
*  RU  GS(NF)  DIRECTION VECTOR MULTIPLIED BY THE HESSIAN MATRIX.
*  IO  INEW  NUMBER OF ACTIVE CONSTRAINTS.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*
* SUBPROGRAMS USED :
*  S   UXUDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*
      SUBROUTINE UYADC1(NF,M,X,IX,XL,XU,H,IH,S,GO,GS,INEW)
      $INCLUDE ('UMCOMM')
      INTEGER NF,M,IX(NF),IH(NF+1),INEW
      $FLOAT  X(NF),XL(NF),XU(NF),H(M),S(NF),GO(NF),GS(NF)
      INTEGER I,II,IXI
      INEW=0
      DO 1 I=1,NF
      II=IX(I)
      IXI=ABS(II)
      IF (IXI.GE.5) THEN
      IX(I)=-IXI
      ELSE IF ((IXI.EQ.1.OR.IXI.EQ.3.OR.IXI.EQ.4).AND.X(I).LE.XL(I))
     & THEN
      X(I)=XL(I)
      IF (IXI.EQ.4) THEN
      IX(I)=-3
      ELSE
      IX(I)=-IXI
      ENDIF
      IF (II.GT.0) INEW=INEW+1
      CALL UXUDIR(NF,1.0$P 0,GS,GO,GO,IX,KBF)
      GS(I)=GS(I)+H(IH(I))*S(I)-2.0$P 0*GS(I)
      ELSE IF ((IXI.EQ.2.OR.IXI.EQ.3.OR.IXI.EQ.4).AND.X(I).GE.XU(I))
     & THEN
      X(I)=XU(I)
      IF (IXI.EQ.3) THEN
      IX(I)=-4
      ELSE
      IX(I)=-IXI
      ENDIF
      IF (II.GT.0) INEW=INEW+1
      CALL UXUDIR(NF,1.0$P 0,GS,GO,GO,IX,KBF)
      GS(I)=GS(I)+H(IH(I))*S(I)-2.0$P 0*GS(I)
      ENDIF
    1 CONTINUE
      IF (INEW.GT.0) THEN
      CALL UOYAD1(0,'UYADC1')
      CALL UOYAD3(NF,NF,IX,INEW,0)
      ENDIF
      RETURN
      END
