$INTERFACE UYADS1                                             98/12/01

  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-8',REAL,4)
  CALL UYADS1(NF,N,$X,$IX,$XN,$XL,$XU,$H,$S,$EPS9,NORMF,INEW)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$XL($NF)\$XU($NF)\$H($NF*($NF+1)/2)&
  \$S($NF)')
  $ADD(INTEGER,'\$IX($NX)')
$REM  $ADD(INTEGER,'\NF\N\INEW')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYADS1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* NEW SIMPLE BOUNDS ARE ADDED TO THE ACTIVE SET. GILL-MURRAY
* FACTORIZATION OF THE TRANSFORMED HESSIAN MATRIX APPROXIMATION IS
* UPDATED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  IU  N  ACTUAL NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RU  H(NF*(NF+1)/2)  GILL-MURRAY FACTORIZATION OF THE TRANSFORMED
*         HESSIAN MATRIX APPROXIMATION.
*  RA  S(NF)  AUXILIARY VECTOR.
*  RI  EPS9  TOLERANCE FOR ACTIVE CONSTRAINTS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  IO  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*
* SUBPROGRAMS USED :
*  S   ULNEWS  IDENTIFICATION OF ACTIVE BOUNDS.
*  S   UXDPGU  CORRECTION OF THE L*D*TRANS(L) FACTORIZATION OF THE
*         SYMMETRIC POSITIVE DEFINITE MATRIX.
*  S   UXVSET  INITIATION OF A VECTOR.
*  S   UOYAD1  PRINT OF ENTRY TO CONSTRAINT ADDITION.
*  S   UOYAD3  PRINT OF INFORMATION ON CONSTRAINT ADDITION.
*
      SUBROUTINE UYADS1(NF,N,X,IX,XN,XL,XU,H,S,EPS9,NORMF,INEW)
      INTEGER NF,N,IX(NF),NORMF,INEW
      $FLOAT X(NF),XN(NF),XL(NF),XU(NF),H(NF*(NF+1)/2),S(NF),EPS9
      $FLOAT TEMP
      INTEGER I,J,K,L,KK,LL
      K=0
      DO 3 L=1,NF
      IF(IX(L).GE.0) K=K+1
      INEW=0
      CALL ULNEWS(NF,X,IX,XN,XL,XU,EPS9,NORMF,L,INEW)
      IF (INEW.NE.0) THEN
      IX(L)=10-IX(L)
      CALL UXVSET(K-1,0.0$P 0,S)
      KK=K*(K-1)/2
      LL=KK+K
      TEMP=H(LL)
      DO 2 I=K+1,N
      DO 1 J=1,I
      LL = LL + 1
      IF ( J .EQ. K) THEN
      S(I-1)=H(LL)
      ELSE
      KK = KK + 1
      H(KK) = H(LL)
      ENDIF
    1 CONTINUE
    2 CONTINUE
      N=N-1
      CALL UOYAD1(0,'UYADS1')
      CALL UOYAD3(NF,N,IX,INEW,0)
      CALL UXDPGU(N,H,TEMP,S,H(KK+1))
      ENDIF
    3 CONTINUE
      RETURN
      END
