$INTERFACE UYADS4                                             98/12/01

  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-8',REAL,4)
  CALL UYADS4(NF,N,$X,$IX,$XN,$XL,$XU,$H,$EPS9,NORMF,INEW)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$XL($NF)\$XU($NF)\$H($NF*($NF+1)/2)')
  $ADD(INTEGER,'\$IX($NX)')
$REM  $ADD(INTEGER,'\NF\N\INEW')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYADS4                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* NEW SIMPLE BOUNDS ARE ADDED TO THE ACTIVE SET. INVERSION OF THE
* TRANSFORMED HESSIAN MATRIX APPROXIMATION IS UPDATED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  IU  N  ACTUAL NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RU  H(NF*(NF+1)/2)  GILL-MURRAY FACTORIZATION OF THE TRANSFORMED
*         HESSIAN MATRIX APPROXIMATION.
*  RI  EPS9  TOLERANCE FOR ACTIVE CONSTRAINTS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  IO  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*
* SUBPROGRAMS USED :
*  S   ULNEWS  IDENTIFICATION OF ACTIVE BOUNDS.
*  S   UOYAD1  PRINT OF ENTRY TO CONSTRAINT ADDITION.
*  S   UOYAD3  PRINT OF INFORMATION ON CONSTRAINT ADDITION.
*
      SUBROUTINE UYADS4(NF,N,X,IX,XN,XL,XU,H,EPS9,NORMF,INEW)
      INTEGER NF,N,IX(NF),NORMF,INEW
      $FLOAT X(NF),XN(NF),XL(NF),XU(NF),H(NF*(NF+1)/2),EPS9
      $FLOAT DEN,TEMP
      INTEGER I,J,K,L,KK,LL,IK,IJ,KJ
      K=0
      DO 5 L=1,NF
      IF(IX(L).GE.0) K=K+1
      INEW=0
      CALL ULNEWS(NF,X,IX,XN,XL,XU,EPS9,NORMF,L,INEW)
      IF (INEW.NE.0) THEN
      IX(L)=10-IX(L)
      KK=K*(K-1)/2
      DEN=H(KK+K)
      IF (DEN.NE.0.0$P 0) THEN
      IJ=0
      KJ=KK
      DO 2 J=1,N
      IF (J.LE.K) THEN
      KJ=KJ+1
      ELSE
      KJ=KJ+J-1
      ENDIF
      IF (J.NE.K) TEMP=H(KJ)/DEN
      IK=KK
      DO 1 I=1,J
      IF (I.LE.K) THEN
      IK=IK+1
      ELSE
      IK=IK+I-1
      ENDIF
      IJ=IJ+1
      IF (I.NE.K.AND.J.NE.K) H(IJ)=H(IJ)+TEMP*H(IK)
    1 CONTINUE
    2 CONTINUE
      ENDIF
      LL=KK+K
      DO 4 I=K+1,N
      DO 3 J=1,I
      LL = LL + 1
      IF ( J .NE. K) THEN
      KK = KK + 1
      H(KK) = H(LL)
      ENDIF
    3 CONTINUE
    4 CONTINUE
      N=N-1
      CALL UOYAD1(0,'UYADS4')
      CALL UOYAD3(NF,N,IX,INEW,0)
      ENDIF
    5 CONTINUE
      RETURN
      END
