$INTERFACE UYCPSD                                             98/12/01

  CALL UYCPSD(NF,$IX,$H,$HD,MCG1)
  $ADD(INTEGER,'\$IX($NX)')
  $ADD(REAL,'\$H($NF*($NF+1)/2)\$HD($NF)')
$REM  $ADD(INTEGER,'\NF\MCG1')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYCPSD             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  NATURAL UPDATE OF THE DIAGONAL MATRIX.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  H(NF*(NF+1)/2)  HESSIAN MATRIX OR ITS APPROXIMATION.
*  RU  HD(NF)  UPDATED DIAGONAL MATRIX.
*  II  MCG1  DETERMINATION OF THE SECOND DERIVATIVES. MCG1=1-VARIABLE
*         METRIC METHOD. MCG1=2-NUMERICAL APPROXIMATION.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  KIT  NUMBER OF THE ITERATION AFTER LAST RESTART.
*  II  NIT  ACTUAL NUMBER OF ITERATIONS.
*
      SUBROUTINE UYCPSD(NF,IX,H,HD,MCG1)
      $INCLUDE('UMCOMM')
      INTEGER NF,IX(NF),MCG1
      $FLOAT H(NF*(NF+1)/2),HD(NF)
      INTEGER I,K
      IF (MCG1.EQ.1) THEN
      IF(LD.EQ.2) THEN
      K=0
      DO 1 I=1,NF
      K=K+I
      IF (KBF.GT.0) THEN
      IF (IX(I).LE.-5) GO TO 1
      ENDIF
      HD(I)=H(K)
    1 CONTINUE
      ELSE IF(NIT.LE.KIT) THEN
      DO 2 I=1,NF
      IF (KBF.GT.0) THEN
      IF (IX(I).LE.-5) GO TO 2
      ENDIF
      HD(I)=ONE
    2 CONTINUE
      ENDIF
      ENDIF
      RETURN
      END
