* SUBROUTINE UYGFT1             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  STOPPING CRITERIA FOR LOCAL MINIMIZATION DURING FILLING
*  (FOR FILLED FUNCTION METHOD OF GLOBAL OPTIMIZATION).
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XL(NF)  LOWER BOUND FOR X.
*  RI  XU(NF)  UPPER BOUND FOR X.
*  RI  FN  FUNCTION VALUE.
*  RI  FMINGL  GLOBAL MINIMUM.
*
* COMMON DATA :
*  IO  ITERM  TERMINATION INDICATOR. ITERM=21-BASIN OF NEW MINIMA
*        FOUND. ITERM=22-OUT OF S.
*  TO  TXFU  TEXT INFORMATION ON THE CAUSE OF TERMINATION.
*
        SUBROUTINE UYGFT1(NF,X,XL,XU,FN,FMINGL)
        $INCLUDE('UMCOMM')
        INTEGER NF
        $FLOAT X(NF),XL(NF),XU(NF),FN,FMINGL
        INTEGER I
        ITERM=0
        IF (FN.LT.FMINGL) THEN
          TXFU='NEWBASIN'
          ITERM=21
        ELSE
          IF (ITERM.GT.0) RETURN
          DO 10 I=1,NF
            IF (X(I).LE.XL(I).OR.X(I).GT.XU(I)) THEN
              TXFU='OUT OF S'
              ITERM=22
            ENDIF
   10     CONTINUE
        ENDIF
        END
