$INTERFACE UYNOR1                                             98/12/01

  CALL UYNOR1(NF,$X,$XN)
  $ADD(REAL,'\$X($NF)\$XN($NF)')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYNOR1             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE SCALING FACTORS.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*         NORMF=3-SCALING FACTORS ARE DETERMINED FROM THE DIAGONAL
*         ELEMENTS OF THE HESSIAN MATRIX OR ITS APPROXIMATION.
*
      SUBROUTINE UYNOR1(NF,X,XN)
      $INCLUDE ('UMCOMM')
      INTEGER NF
      $FLOAT X(NF),XN(NF)
      INTEGER I
      IF(NORMF.NE.1.AND.NORMF.NE.2) RETURN
      DO 1 I=1,NF
      IF(NORMF.EQ.1) XN(I)=MAX(ABS(X(I)),ONE)
      IF(XN(I).LE.ZERO) XN(I)=ONE
    1 CONTINUE
      RETURN
      END
