* SUBROUTINE UYPRO3                ALL SYSTEMS                96/12/01
C PORTABILITY : ALL SYSTEMS
C 96/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PROLOGUE - INITIATION OF THE COMMON VARIABLES.
*
* PARAMETERS :
*  II  K  RESTART SPECIFICATION.
*
* COMMON DATA :
*  IO  IREST  RESTART INDICATOR. RESTART IS PERFORMED IF IREST>0.
*  IO  NTESX  ACTUAL NUMBER OF TESTS ON STEPLENGTH.
*  IO  NTESF  ACTUAL NUMBER OF TESTS ON FUNCTION DECREASE.
*  IO  KIT  NUMBER OF THE ITERATION AFTER LAST RESTART.
*  II  LIT  NUMBER OF THE FIRST ITERATION.
*  IO  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  LFV  NUMBER OF THE FIRST COMPUTED FUNCTION VALUE.
*  IO  NFV  ACTUAL NUMBER OF COMPUTED FUNCTION VALUES.
*  IO  ITERS  TERMINATION INDICATOR FOR STEPLENGTH DETERMINATION.
*  IO  IREST  RESTART INDICATOR.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*  II  KOUT1  LOWER ITERATION IN WHICH INFORMATION IS PRINTED.
*  II  KOUT2  UPPER ITERATION IN WHICH INFORMATION IS PRINTED.
*  II  KOUT3  NUMBER OF ITERATIONS AFTER THAT INFORMATION IS PRINTED.
*
      SUBROUTINE UYPRO3(K)
      $INCLUDE ('UMCOMM')
      INTEGER K
      LIT = NIT
      KIT = NIT
      LFV = NFV
      LFG = NFG
      NTESX = 0
      NTESF = 0
      ITERS = 2
      IREST = K
      TUXX='NEWTON  '
      JOUT=0
      IF(KOUT.EQ.0.OR.KOUT3.LE.0) RETURN
      IF(KOUT1.LE.KOUT2) THEN
      IF(0.GE.KOUT1.AND.0.LE.KOUT2) JOUT=1
      ELSE
      IF(0.GE.KOUT1.OR. 0.LE.KOUT2) JOUT=1
      ENDIF
      RETURN
      END
