$INTERFACE UYRMC0                                             98/12/01

  $HELP
    TOLERANCE FOR CONSTRAINTS TO BE REMOVED
  $CHECK(EPS8,'1.0$P 0',REAL,4)
  CALL UYRMC0(NF,N,$IX,$XN,$G,$GN,EPS8,UMAX,GMAX,RMAX,MOT,IOLD)
  $ADD(INTEGER,'\$IX($NX)')
  $ADD(REAL,'\$XN($NF)\$G($NF)\$GN($NF)')
$REM  $ADD(REAL,'\UMAX\GMAX\RMAX')
$REM  $ADD(INTEGER,'\NF\N\MOT\IOLD')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYRMC0                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* OLD SIMPLE BOUND IS REMOVED FROM THE ACTIVE SET. TRANSFORMED
* GRADIENT OF THE OBJECTIVE FUNCTION IS UPDATED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RU  GN(NF)  TRANSFORMED GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  EPS8  TOLERANCE FOR CONSTRAINT TO BE REMOVED.
*  RI  UMAX  MAXIMUN ABSOLUTE VALUE OF THE NEGATIVE LAGRANGE MULTIPLIER.
*  RI  GMAX  NORM OF THE TRANSFORMED GRADIENT.
*  RO  RMAX  MAXIMUM VALUE OF THE STEPSIZE PARAMETER.
*  II  MOT  SPECIFICATION OF RESTART AFTER CHANGE OF ACTIVE
*         CONSTRAINTS. MOT=1-RESTART AFTER EACH CHANGE OF ACTIVE
*         CONSTRAINTS. MOT=2-NO RESTART.
*  II  IOLD  NUMBER OF REMOVED CONSTRAINTS.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   UYRES1  DEFINITION OF THE RESTART VARIABLES.
*
      SUBROUTINE UYRMC0(NF,N,IX,XN,G,GN,EPS8,UMAX,GMAX,RMAX,MOT,IOLD)
      $INCLUDE ('UMCOMM')
      INTEGER NF,N,IX(NF),MOT,IOLD
      $FLOAT XN(NF),G(NF),GN(NF),EPS8,UMAX,GMAX,RMAX
      INTEGER I,IXI
      IF (N.EQ.0.OR.RMAX.GT.ZERO) THEN
      IF (UMAX.GT.EPS8*GMAX) THEN
      IOLD=0
      DO 1 I=1,NF
      IXI=IX(I)
      IF (IXI.GE.0) THEN
      ELSE IF (IXI.LE.-5) THEN
      ELSE IF ((IXI.EQ.-1.OR.IXI.EQ.-3).AND.-G(I).LE.ZERO) THEN
      ELSE IF ((IXI.EQ.-2.OR.IXI.EQ.-4).AND. G(I).LE.ZERO) THEN
      ELSE
      IOLD=IOLD+1
      IX(I)=MIN(ABS(IX(I)),3)
      IF (NORMF.GT.0) THEN
      GN(I)=G(I)*XN(I)
      ELSE
      GN(I)=G(I)
      ENDIF
      IF (RMAX.EQ.0) GO TO 2
      ENDIF
    1 CONTINUE
    2 CALL UOYRM1(N,GMAX,UMAX,IOLD,'UYRMC0')
      CALL UOYRM3(NF,N+IOLD,IX,0)
      IF(IOLD.GT.1.OR.MOT.EQ.1) CALL UYRES1('REM CONS')
      ENDIF
      ENDIF
      RETURN
      END
