$INTERFACE UYSFIS                                             16/12/01

  $IBG='IBG'
  $JBG='JBG'
  $KBG='KBG'
  $IW='IW'
  $IW1='IW1'
  $IW2='IW2'
  MA=IAG(NA+1)-1
  CALL UYSFIS(NF,NA,MA,MMAX,$IAG,$JAG,$IBG,$JBG,$KBG,$IW,$IW1,$IW2&
,NAU,INF)
  IF ($IBG(NA+NF+1)-1.GT.$MMAX) THEN
  CALL UOERR2('UYSFIS',97,$IBG(NA+NF+1)-1,$MMAX)
  CALL UOERR4
  ITERM=-97
  ENDIF
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$IW($MMAX)\$IW1(2*($NA+$NF))&
  \$IW2(3*($NA+$NF))')
  $ADD(INTEGER,'\$IBG($NA+$NF+1)\$JBG($MA+$NA+$NF)\$KBG($MA+$NA+$NF)')
$REM  $ADD(INTEGER,'\NF\NA\MA\NAU\INF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYSFIS                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SYMBOLIC FACTORIZATION OF THE SYMMETRIC (HESSIAN) MATRIX.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATING FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE JACOBIAN MATRIX.
*  II  MMAX  SIZE OF THE SPARSE HESSIAN ARRAY.
*  II  IH(NF+1) POINTERS OF THE HESSIAN MATRIX STORED
*           IN A COMPACT FORM.
*  II  IAG(NA+1)  POINTERS OF THE JACOBIAN MATRIX.
*  II  JAG(MA)  COLUMN INDICES OF THE JACOBIAN MATRIX.
*  IO  IB(NA+NF+1)  POINTERS OF THE AUGMENTED SYSTEM MATRIX.
*  IO  JB(MA+NA+NF)  COLUMN INDICES OF THE AUGMENTED SYSTEM MATRIX.
*  IO  KB(MA+NA+NF)  ROW INDICES OF THE AUGMENTED SYSTEM MATRIX.
*  II  IW(MMAX) WORKING ARRAY.
*  II  IW1(2*NF) WORKING ARRAY.
*  II  IW2(3*NF) WORKING ARRAY.
*  IO  NAU  NUMBER OF MAJOR STEPS.
*  IO  INF  ERROR INDICATOR. INF=0-NO ERRORS.
*
* COMMON DATA :
*  IO  ITERM  TERMINATION INDICATOR.
*  TO  TXFU  TEXT INFORMATION ON THE CAUSE OF TERMINATION.
*
* SUBPROGRAMS USED :
*  S   UXSIBS  MINIMUM DEGREE ORDERING.
*
      SUBROUTINE UYSFIS(NF,NA,MA,MMAX,IAG,JAG,IB,JB,KB,IW,IW1,IW2,
     & NAU,INF)
      $INCLUDE('UMCOMM')
      INTEGER NF,NA,MA,MMAX,IAG(NA+1),JAG(MA),IB(NA+NF+1),JB(MA+NA+NF),
     & KB(MA+NA+NF),IW(MMAX),IW1(2*(NF+NA)+1),IW2(3*(NF+NA)),NAU,INF
      INTEGER I,J,NN,MM
      NN=NA+NF
      MM=MA+NN
      CALL UXSMIS(NF,NA,MA,IAG,JAG,IB,JB)
      DO 2 I=1,NN
      DO 1 J=IB(I),IB(I+1)-1
      KB(J)=I
    1 CONTINUE
    2 CONTINUE
      CALL UXSIBS(NN,MM,KB,JB,IW,MMAX,IW1,IW2,NAU,INF)
      IF (INF.LT.0) THEN
      ITERM=INF
      TXFU='LACK SPC'
      ENDIF
      RETURN
      END
