$INTERFACE UYSFSG                                             98/12/01

  $IW1='IW1'
  $IW2='IW2'
  CALL UYSFSG(NF,NA,NAA,MA,MAA,$MMAX,$IAG,$JAG,$IH,$IW1,$IW2,INF)
  $ADD(INTEGER,'\$IAG($NA+$NF+1)\$JAG($MMAX)\$IH($NF+1)&
  \$IW1(11*($NF+1))\$IW2(6*($NA+$NF+1))')
$REM  $ADD(INTEGER,'\NF\NA\NAA\MA\MAA\INF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYSFSG                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* INITIALIZE MULTIFRONTAL SPARSE QR DECOMPOSITION.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF CURRENT APPROXIMATED FUNCTIONS.
*  IO  NAA  NUMBER OF ROWS IN THE AUGMENTED JACOBIAN MATRIX.
*  IO  MA  NUMBER OF ELEMENTS IN THE JACOBIAN MATRIX.
*  IO  MAA  NUMBER OF ELEMENTS IN THE AUGMENTES JACOBIAN MATRIX.
*  II  MMAX LENGTH OF THE ARRAY JA.
*  IU  IA(NAA+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE AUGMENTED
*         JACOBIAN MATRIX.
*  IU  JA(MMAX) COLUMN INDICES OF ELEMENTS IN THE AUGMENTED JACOBIAN 
*         MATRIX.
*  IO  IB(NF+1)  COLUMN POINTERS.
*  IO  IW1(11*(NF+1))  AUXILIARY VECTOR.
*  IO  IW2(6*(NA+NF+2))  AUXILIARY VECTOR.
*  IO  INF  ERROR INDICATOR. INF=0-NO ERRORS.
*
* SUBPROGRAMS USED :
*  S   UXSRBI  INITIALIZE SPARSE QR DECOMPOSITION. MULTIFRONTAL
*         ALGORITHM.
*
* METHOD :
* TUMA: ROW ORDERING IN SPARSE QR DECOMPOSITION (MANUSCRIPT)
*
      SUBROUTINE UYSFSG(NF,NA,NAA,MA,MAA,MMAX,IA,JA,IB,IW1,IW2,INF)
      INTEGER NF,NA,MA,MMAX,IA(NA+NF+1),JA(MMAX),IB(NF+1),
     & IW1(11*(NF+1)),IW2(6*(NA+NF+1)),INF
      INTEGER NAA,MAA,I
      MA=IA(NA+1)-1
      NAA=NA+NF
      MAA=MA+NF
      CALL UXVINP(NF,JA(MA+1))
      DO 3 I=1,NF
      IA(NA+I+1)=IA(NA+I)+1
    3 CONTINUE
      INF=0
      CALL UXSRBI(NAA,NF,MAA,INF,MMAX,MMAX,IA,JA,IB,IW1,IW1(NF+2),
     & IW1(2*NF+3),IW1(3*NF+4),IW1(4*NF+5),IW1(5*NF+6),IW1(6*NF+7),
     & IW1(7*NF+8),IW1(8*NF+9),IW1(9*NF+10),IW1(10*NF+11),IW2,
     & IW2(NAA+2),IW2(2*NAA+3),IW2(3*NAA+4),IW2(4*NAA+5),IW2(5*NAA+6))
      RETURN
      END
