$INTERFACE UYSFSL                                             98/12/01


  $IW1='IW1'
  $IW2='IW2'
  CALL UYSFSL(NF,NA,MA,$MMAX,$IAG,$JAG,$IH,$IW1,$IW2,INF)
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MMAX)\$IH($NF+1)\$IW1(11*($NF+1))&
  \$IW2(6*($NA+1))')
$REM  $ADD(INTEGER,'\NF\NA\MA\INF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYSFSL                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* INITIALIZE MULTIFRONTAL SPARSE QR DECOMPOSITION.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF CURRENT APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD AG.
*  II  MMAX LENGTH OF THE ARRAY JA.
*  II  IA(NA+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD AG.
*  II  JA(MMAX) COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  IO  IB(NF+1)  COLUMN POINTERS.
*  IO  IW1(11*(NF+1))  AUXILIARY VECTOR.
*  IO  IW2(6*(NA+2))  AUXILIARY VECTOR.
*  IO  INF  ERROR INDICATOR. INF=0-NO ERRORS.
*
* SUBPROGRAMS USED :
*  S    UXSRBI  SYMBOLIC SPARSE QR DECOMPOSITION. MULTIFRONTAL
*         ALGORITHM.
*
* METHOD :
* TUMA: ROW ORDERING IN SPARSE QR DECOMPOSITION (MANUSCRIPT)
*
      SUBROUTINE UYSFSL(NF,NA,MA,MMAX,IA,JA,IB,IW1,IW2,INF)
      INTEGER NF,NA,MA,MMAX,IA(NA+1),JA(MMAX),IB(NF+1),IW1(11*(NF+1)),
     & IW2(6*(NA+1)),INF
      INF=0
      CALL UXSRBI(NA,NF,MA,INF,MMAX,MMAX,IA,JA,IB,IW1,IW1(NF+2),
     & IW1(2*NF+3),IW1(3*NF+4),IW1(4*NF+5),IW1(5*NF+6),IW1(6*NF+7),
     & IW1(7*NF+8),IW1(8*NF+9),IW1(9*NF+10),IW1(10*NF+11),IW2,IW2(NA+2),
     & IW2(2*NA+3),IW2(3*NA+4),IW2(4*NA+5),IW2(5*NA+6))
      RETURN
      END
