$INTERFACE UYTBUH                                             98/12/01

  CALL UYTBUH(NF,NA,MA,MAH,$XN,$AH,$IAG,$JAG)
  $ADD(REAL,'\$XN($NF)\$AH($MAH)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NF\NA\MA\MAH')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTBUH             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* HESSIAN MATRIX OF THE OBJECTIVE FUNCTION OR ITS APPROXIMATION
* IS SCALED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS IN THE FIELD AG.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RU  H(M)  HESSIAN MATRIX OR ITS APPROXIMATION.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  RI  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  ITERS  TERMINATION INDICATOR FOR STEPLENGTH DETERMINATION.
*         ITERS=0 FOR ZERO STEP.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
      SUBROUTINE UYTBUH(NF,NA,MA,M,XN,H,IAG,JAG)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NA,MA,M,IAG(NA+1),JAG(MA)
      $FLOAT XN(NF),H(M)
      INTEGER I,J,K,L,IP,JP,KP,LP,KA
      IF (LD.NE.2.OR.ITERS.EQ.0) RETURN
      IF (NORMF.LE.0) RETURN
      LP=0
      DO 3 KA=1,NA
      K=IAG(KA)
      KP=K-1
      L=IAG(KA+1)-K
      DO 2 I=1,L
      IP=JAG(I+KP)
      DO 1 J=1,I
      JP=JAG(J+KP)
      LP=LP+1
      IF (IP.GT.0.AND.JP.GT.0) H(LP)=H(LP)*XN(IP)*XN(JP)
    1 CONTINUE
    2 CONTINUE
    3 CONTINUE
      RETURN
      END
