$INTERFACE UYTRBH                                            98/12/01

  CALL UYTRBH(NF,N,$XN,$CR,$CZ,$H,$S)
  $ADD(REAL,'\$XN($NF)\$CR($NF*($NF+1)/2)\$CZ($NF*$NF)&
  \$H($NF*($NF+1)/2)\$S($NF)')
$REM  $ADD(INTEGER,'\NF\N')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRBH               ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* HESSIAN MATRIX OF THE OBJECTIVE FUNCTION OR ITS APPROXIMATION IS
* SCALED AND REDUCED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  CR(NF*(NF+1)/2)  TRIANGULAR DECOMPOSITION OF KERNEL OF THE
*         ORTHOGONAL PROJECTION.
*  RI  CZ(NF*NF)  MATRIX WHOSE COLUMNS ARE BASIC VECTORS FROM THE
*         CURRENT REDUCED SUBSPACE.
*  RI  H(NF*(NF+1)/2)  HESSIAN MATRIX OR ITS APPROXIMATION.
*  RA  S(NF)  AUXILIARY VECTOR.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  ITERS  TERMINATION INDICATOR FOR STEPLENGTH DETERMINATION.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* SUBPROGRAMS USED :
*  S   UXDSMM  MATRIX VECTOR PRODUCT.
*  S   UXVCOP  COPYING OF A VECTOR.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*  S   UOFTH1  PRINT OF ENTRY TO TRANSFORMATION OF THE HESSIAN MATRIX
*         OR ITS APPROXIMATION.
*  S   UOFTH2  PRINT OF EXIT FROM TRANSFORMATION OF THE HESSIAN MATRIX
*         OR ITS APPROXIMATION.
*
      SUBROUTINE UYTRBH(NF,N,XN,CR,CZ,H,S)
      $INCLUDE ('UMCOMM')
      INTEGER NF,N
      $FLOAT XN(NF),CR(NF*(NF+1)/2),CZ(NF*NF),H(NF*(NF+1)/2),S(NF)
      $FLOAT TEMP,UXVDOT
      INTEGER NCA,NCR,ICZ,JCZ,I,J,K
      IF (LD.NE.2.OR.ITERS.EQ.0) RETURN
      IF (N.LE.0) RETURN
      CALL UOFTH1(NF,NF*(NF+1)/2,H,XN)
      IF (NORMF.GT.0) THEN
      K=0
      DO 2 I=1,NF
      TEMP=XN(I)
      DO 1 J=1,I
      K=K+1
      H(K)=TEMP*H(K)*XN(J)
    1 CONTINUE
    2 CONTINUE
      ENDIF
      NCA=NF-N
      NCR=NCA*(NCA+1)/2
      K=NCR
      JCZ=1
      DO 4 J=1,N
      CALL UXDSMM(NF,H,CZ(JCZ),S)
      ICZ=1
      DO 3 I=1,J
      K=K+1
      CR(K)=UXVDOT(NF,CZ(ICZ),S)
      ICZ=ICZ+NF
    3 CONTINUE
      JCZ=JCZ+NF
    4 CONTINUE
      CALL UXVCOP(N*(N+1)/2,CR(NCR+1),H)
      CALL UOFTH2(N*(N+1)/2,H)
      RETURN
      END
