$INTERFACE UYTRCA                                             07/12/01

  CALL UYTRCA(NF,N,$IX,$XN,$GA)
  $ADD(REAL,'\$XN($NF)\$GA($NF)')
  $ADD(INTEGER,'\$IX($NX)')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRCA             ALL SYSTEMS                   07/12/01
C PORTABILITY : ALL SYSTEMS
C 07/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENT OF THE APPROXIMATED FUNCTION IS SCALED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  GA(NF)  GRADIENT OF THE APPROXIMATED FUNCTION.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UYTRCA(NF,N,IX,XN,GA)
      $INCLUDE ('UMCOMM')
      INTEGER NF,N,IX(NF)
      $FLOAT XN(NF),GA(NF)
      INTEGER I
      IF (NORMF.GT.0) THEN
      DO 1 I=1,NF
      IF (IX(I).GT.0) GA(I)=GA(I)*XN(I)
    1 CONTINUE
      ENDIF
      N=NF
      RETURN
      END
