$INTERFACE UYTRCH                                             98/12/01

  CALL UYTRCH(NF,M,$IX,$XN,$H,$IH)
  $ADD(INTEGER,'\$IX($NX)\$IH($NF+1)')
  $ADD(REAL,'\$XN($NF)\$H($M)')
$REM  $ADD(INTEGER,'\NF\M')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRCH             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* HESSIAN MATRIX OF THE OBJECTIVE FUNCTION OR ITS APPROXIMATION
* IS SCALED AND REDUCED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  M  DIMENSION OF THE ARRAY H.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RU  H(M)  HESSIAN MATRIX OR ITS APPROXIMATION.
*  II  IH(NF+1)  POINTERS IN THE ARRAY H.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  ITERS  TERMINATION INDICATOR FOR STEPLENGTH DETERMINATION.
*         ITERS=0 FOR ZERO STEP.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
      SUBROUTINE UYTRCH(NF,M,IX,XN,H,IH)
      $INCLUDE ('UMCOMM')
      INTEGER NF,M,IX(NF),IH(NF+1)
      $FLOAT XN(NF),H(M)
      INTEGER I,J
      IF ( LD.NE.2.OR.ITERS.EQ.0) RETURN
      CALL UOFTH1(NF,M,H,XN)
      DO 2 I=1,NF
      IF (IX(I).LT.0) THEN
      IF (NORMF.GT.0) THEN
      H(IH(I))=XN(I)**2
      ELSE
      H(IH(I))=1.0$P 0
      ENDIF
      DO 1 J=IH(I)+1,IH(I+1)-1
      H(J)=0.0$P 0
    1 CONTINUE
      ENDIF
    2 CONTINUE
      CALL UOFTH2(M,H)
      RETURN
      END
