$INTERFACE UYTRCS                                             98/12/01

  CALL UYTRCS(NF,$X,$IX,$XN,$XO,$XL,$XU,$G,$GO,$SN,$S,RO,FP,FO,F,PO,P&
,RMAX)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$XO($NF)\$XL($NF)\$XU($NF)\$G($NF)&
  \$GO($NF)\$SN($NF)\$S($NF)')
  $ADD(INTEGER,'\$IX($NX)')
$REM  $ADD(REAL,'\RO\FP\FO\F\PO\P\RMAX')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRCS             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALED AND REDUCED DIRECTION VECTOR IS BACK TRANSFORMED. VECTORS
* X,G AND VALUES F,P ARE SAVED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  XO(NF)  SAVED VECTOR OF VARIABLES.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RO  GO(NF)  SAVED GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  SN(NF)  TRANSFORMED DIRECTION VECTOR.
*  RO  S(NF)  DIRECTION VECTOR.
*  RO  RO  SAVED VALUE OF THE STEPSIZE PARAMETER.
*  RO  FP  PREVIOUS VALUE OF THE OBJECTIVE FUNCTION.
*  RU  FO  SAVED VALUE OF THE OBJECTIVE FUNCTION.
*  RI  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  PO  SAVED VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RI  P  VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RO  RMAX  MAXIMUM VALUE OF THE STEPSIZE PARAMETER.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   ULMAXS  DETERMINATION OF THE MAXIMUM STEPSIZE USING SIMPLE
*         BOUNDS.
*  S   UXVCOP  COPYING OF A VECTOR.
*
      SUBROUTINE UYTRCS(NF,X,IX,XN,XO,XL,XU,G,GO,SN,S,RO,FP,FO,F,PO,P,
     & RMAX)
      $INCLUDE ('UMCOMM')
      INTEGER NF,IX(NF)
      $FLOAT X(NF),XN(NF),XO(NF),XL(NF),XU(NF),G(NF),GO(NF),SN(NF),
     & S(NF),RO,FP,FO,F,PO,P,RMAX
      INTEGER I
      FP = FO
      RO = ZERO
      FO = F
      PO = P
      CALL UXVCOP(NF,X,XO)
      CALL UXVCOP(NF,G,GO)
      DO 1 I=1,NF
      IF (NORMF.GT.0) THEN
      S(I)=SN(I)*XN(I)
      ELSE
      S(I)=SN(I)
      ENDIF
      IF(IX(I).LT.0) THEN
      S(I)=ZERO
      ELSE
      IF(IX(I).EQ.1.OR.IX(I).GE.3) THEN
      IF (S(I).LT.0.0D 0) RMAX=MIN(RMAX,(XL(I)-X(I))/S(I))
      ENDIF
      IF(IX(I).EQ.2.OR.IX(I).GE.3) THEN
      IF (S(I).GT.0.0D 0) RMAX=MIN(RMAX,(XU(I)-X(I))/S(I))
      ENDIF
      ENDIF
    1 CONTINUE
      RETURN
      END
