$INTERFACE UYTRSG                                             98/12/01

  CALL UYTRSG(NF,N,$IX,$XN,$G,$GN,UMAX,GMAX,IOLD,KOLD)
  $ADD(REAL,'\$XN($NF)\$G($NF)\$GN($NF)')
  $ADD(INTEGER,'\$IX($NX)')
$REM  $ADD(INTEGER,'\NF\N\IOLD\KOLD')
$REM  $ADD(REAL,'\UMAX\GMAX')
  $ADD(INIT)
    ITRAN=2
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRSG                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENT OF THE OBJECTIVE FUNCTION IS SCALED AND REDUCED. TEST VALUES
*  GMAX AND UMAX ARE COMPUTED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RO  GN(NF)  TRANSFORMED GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  UMAX  MAXIMUN ABSOLUTE VALUE OF THE NEGATIVE LAGRANGE MULTIPLIER.
*  RI  GMAX  NORM OF THE TRANSFORMED GRADIENT.
*  II  IOLD  INDEX OF THE REMOVED CONSTRAINT.
*  II  KOLD  INDEX OF THE NEW POSITION IN THE TRANSFORMED HESSIAN
*         MATRIX.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UYTRSG(NF,N,IX,XN,G,GN,UMAX,GMAX,IOLD,KOLD)
      $INCLUDE ('UMCOMM')
      INTEGER NF,N,IX(NF),IOLD,KOLD
      $FLOAT XN(NF),G(NF),GN(NF),UMAX,GMAX
      $FLOAT TEMP
      INTEGER I,K
      GMAX = 0.0$P 0
      UMAX = 0.0$P 0
      K=0
      IOLD=0
      KOLD=0
      DO 1 I=1,NF
      IF (NORMF.GT.0) THEN
      TEMP=G(I)*XN(I)
      ELSE
      TEMP=G(I)
      ENDIF
      IF ( IX(I) .GE. 0) THEN
      K=K+1
      GN(K)=TEMP
      GMAX=MAX(GMAX,ABS(TEMP))
      ELSE IF (IX(I).LE.-5) THEN
      ELSE IF (( IX(I) .EQ. -1 .OR. IX(I) .EQ. -3)
     * .AND. UMAX+TEMP .GE. 0.0$P 0) THEN
      ELSE IF (( IX(I) .EQ. -2 .OR. IX(I) .EQ. -4)
     * .AND. UMAX-TEMP .GE. 0.0$P 0) THEN
      ELSE
      IOLD=I
      KOLD=K+1
      UMAX=ABS(TEMP)
      ENDIF
    1 CONTINUE
      N=K
      RETURN
      END
