$INTERFACE UYTRSS                                             98/12/01

  CALL UYTRSS(NF,N,$X,$IX,$XN,$XO,$XL,$XU,$G,$GO,$SN,$S,RO,FP,FO,F,PO&
,P,RMAX,KREM,INEW)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$XO($NF)\$XL($NF)\$XU($NF)\$G($NF)&
  \$GO($NF)\$SN($NF)\$S($NF)')
  $ADD(INTEGER,'\$IX($NX)')
$REM  $ADD(REAL,'\RO\FP\FO\F\PO\P\RMAX')
$REM  $ADD(INTEGER,'\NF\N\KREM\INEW')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRSS             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALED AND REDUCED DIRECTION VECTOR IS BACK TRANSFORMED. VECTORS
* X,G AND VALUES F,P ARE SAVED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  N ACTUAL NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  XO(NF)  SAVED VECTOR OF VARIABLES.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RO  GO(NF)  SAVED GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  SN(NF)  TRANSFORMED DIRECTION VECTOR.
*  RO  S(NF)  DIRECTION VECTOR.
*  RO  RO  SAVED VALUE OF THE STEPSIZE PARAMETER.
*  RO  FP  PREVIOUS VALUE OF THE OBJECTIVE FUNCTION.
*  RU  FO  SAVED VALUE OF THE OBJECTIVE FUNCTION.
*  RI  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  PO  SAVED VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RI  P  VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RO  RMAX  MAXIMUM VALUE OF THE STEPSIZE PARAMETER.
*  II  KREM  INDICATION OF LINEARLY DEPENDENT GRADIENTS.
*  IO  INEW  INDEX OF THE NEW ACTIVE FUNCTION.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   ULMAXS  DETERMINATION OF THE MAXIMUM STEPSIZE USING SIMPLE
*         BOUNDS.
*  S   UXVCOP  COPYING OF A VECTOR.
*
      SUBROUTINE UYTRSS(NF,N,X,IX,XN,XO,XL,XU,G,GO,SN,S,RO,FP,FO,F,PO,P,
     & RMAX,KREM,INEW)
      $INCLUDE ('UMCOMM')
      INTEGER NF,N,IX(NF),KREM,INEW
      $FLOAT X(NF),XN(NF),XO(NF),XL(NF),XU(NF),G(NF),GO(NF),SN(NF),
     & S(NF),RO,FP,FO,F,PO,P,RMAX
      INTEGER I,K
      FP = FO
      RO = 0.0$P 0
      FO = F
      PO = P
      CALL UXVCOP(NF,X,XO)
      CALL UXVCOP(NF,G,GO)
      K=N+1
      DO 1 I=NF,1,-1
      IF(IX(I).LT.0) THEN
      S(I)=0.0$P 0
      ELSE
      K=K-1
      IF (NORMF.GT.0) THEN
      S(I)=SN(K)*XN(I)
      ELSE
      S(I)=SN(K)
      ENDIF
      ENDIF
    1 CONTINUE
      INEW=0
      CALL ULMAXS(NF,X,IX,XL,XU,S,RMAX,KBF,KREM,INEW)
      RETURN
      END
