$INTERFACE UYTRSX                                             98/12/01

  CALL UYTRSX(NF,N,$X,$IX,$XN,$XO,$SN,PP)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$XO($NF)\$SN($NF)')
  $ADD(INTEGER,'\$IX($NX)')
$REM  $ADD(INTEGER,'\NF\N')
$REM  $ADD(REAL,'\PP')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRSX             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* STEP WITH THE SIZE PP IS PERFORMED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  XO(NF)  SAVED VECTOR OF VARIABLES.
*  RI  SN(NF)  TRANSFORMED DIRECTION VECTOR.
*  RI  PP  DIFFERENCE FOR COMPUTING DIRECTIONAL DERIVATIVES.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UYTRSX(NF,N,X,IX,XN,XO,SN,PP)
      $INCLUDE ('UMCOMM')
      INTEGER NF,N,IX(NF)
      $FLOAT X(NF),XN(NF),XO(NF),SN(NF),PP
      $FLOAT TEMP
      INTEGER I, K
      K=N+1
      DO 1 I=NF,1,-1
      IF(IX(I).LT.0) THEN
      TEMP=ZERO
      ELSE
      K=K-1
      IF (NORMF.GT.0) THEN
      TEMP=SN(K)*XN(I)
      ELSE
      TEMP=SN(K)
      ENDIF
      ENDIF
      X(I)=XO(I)+PP*TEMP
    1 CONTINUE
      RETURN
      END
