$INTERFACE UYTRUX                                             98/12/01

  CALL UYTRUX(NF,$X,$XN,$XO,$SN,PP)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$XO($NF)\$SN($NF)')
$REM  $ADD(INTEGER,'\NF')
$REM  $ADD(REAL,'\PP')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRUX                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* STEP WITH THE SIZE PP IS PERFORMED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  XO(NF)  SAVED VECTOR OF VARIABLES.
*  RI  SN(NF)  TRANSFORMED DIRECTION VECTOR.
*  RI  PP  DIFFERENCE FOR COMPUTING DIRECTIONAL DERIVATIVE.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UYTRUX(NF,X,XN,XO,SN,PP)
      $INCLUDE ('UMCOMM')
      INTEGER NF
      $FLOAT X(NF),XN(NF),XO(NF),SN(NF),PP
      INTEGER I
      $FLOAT TEMP
      DO 1 I=1,NF
      IF (NORMF.GT.0) THEN
      TEMP=SN(I)*XN(I)
      ELSE
      TEMP=SN(I)
      ENDIF
      X(I)=XO(I)+PP*TEMP
    1 CONTINUE
      RETURN
      END
