$INTERFACE UYUPND                                            98/12/01

  CALL UYUPND(NF,$IX,$XO,$G,$GO,$HD,P,MCG1)
  $ADD(INTEGER,'\$IX($NX)')
  $ADD(REAL,'\$XO($NF)\$G($NF)\$GO($NF)\$HD($NF)')
$REM  $ADD(REAL,'\P')
$REM  $ADD(INTEGER,'\NF\MCG1')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYUPND             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VARIABLE METRIC UPDATE OF THE DIAGONAL MATRIX.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XO(NF)  OLD VECTOR OF VARIABLES.
*  RI  G(NF)   GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  GO(NF)   OLD GRADIENT OF THE OBJECTIVE FUNCTION.
*  RU  HD(NF)  UPDATED DIAGONAL MATRIX.
*  II  P  VALUE OF THE DIRECTIONAL DERIVATIVE.
*  II  MCG1  DETERMINATION OF THE SECOND DERIVATIVES. MCG1=1-VARIABLE
*         METRIC METHOD. MCG1=2-NUMERICAL APPROXIMATION.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*
      SUBROUTINE UYUPND(NF,IX,XO,G,GO,HD,P,MCG1)
      $INCLUDE('UMCOMM')
      INTEGER NF,IX(NF),MCG1
      $FLOAT XO(NF),G(NF),GO(NF),HD(NF),P
      $FLOAT B
      INTEGER I
      IF (MCG1.EQ.1) THEN
      B=ZERO
      DO 1 I=1,NF
      IF (KBF.GT.0) THEN
      IF (IX(I).LE.-5) GO TO 1
      ENDIF
      B=B+XO(I)*GO(I)
    1 CONTINUE
      IF (B.EQ.ZERO) RETURN
      DO 2 I=1,NF
      IF (KBF.GT.0) THEN
      IF (IX(I).LE.-5) GO TO 2
      ENDIF
      HD(I)=HD(I)+GO(I)**2/B+(G(I)-GO(I))**2/P
    2 CONTINUE
      ENDIF
      RETURN
      END
