$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZMODL                                    01/12/97  +
$REM + SI                                                            +
$REM + PURPOSE:  INCLUDE MODEL IN GENERATED PROGRAM                  +
$REM +---------------------------------------------------------------+
*
*     -----------------
*     MODEL DESCRIPTION
*     -----------------
*
$IF($DEF(JACA))
  $IF(JACA='D')
    $IF(NAL>0) $JASA='R'
    $HELP
      STORE OF JACOBIAN MATRIX FOR APPROXIMATED FUNCTIONS
        R - ROWWISE
        C - COLUMNWISE
    $CHECK(JASA,'R','R\C',1,NO)
  $ENDIF
$ENDIF
$JASC='R'
$IHLP=1
$IF(MODEL='FF')
  $IF(CLASS='TN') $IHLP=3
  $SUBST('UF$(KD)F0$IHLP')
$ELSEIF(MODEL='FL')
  $IF(JACC='S')
    $IF(NUMBER=1) $IHLP=2
  $ENDIF
  $KDD=KD
  $IF(KD=0) $KDD=1
  $SUBST('UF$(KDD)FL$IHLP')
$ELSEIF(MODEL='FQ')
  $IF(JACC='S')
    $IHLP=2
  $ENDIF
  $KDD=KD
  $IF(KD=0) $KDD=1
  $SUBST('UF$(KDD)FQ$IHLP')
$ELSEIF(MODEL='AF')
  $IF(KD>0)
    $IF(JACA='S')
      $IHLP=3
      $IF(KD>1)
        $IF(HESF='S') $IHLP=4
        $IF(HESF='D') $IHLP=5
      $ENDIF
    $ENDIF
  $ENDIF
  $SUBST('UA$(KD)SF$IHLP')
$ELSEIF(MODEL='AQ')
  $IF(CLASS='TN')
  $ELSEIF($DEF(DECOMP))
    $IF(DECOMP='A') $IHLP=2
    $IF(DECOMP='Q') $IHLP=2
    $IF(DECOMP='R') $IHLP=2
    $IF(DECOMP='C') $IHLP=2
    $IF(DECOMP='E') $IHLP=2
  $ENDIF
  $IF(KD>0)
    $IF(JACA='S')
      $IHLP=3
      $IF(KD=1)
        $IF(HESF='B') $IHLP=6
        $IF(UPDATE='B') $IHLP=6
      $ENDIF
      $IF(KD>1)
        $IF(HESF='S') $IHLP=4
        $IF(HESF='D') $IHLP=5
        $IF(UPDATE='B') $IHLP=6
        $IF(UPDATE='F') $IHLP=6
        $IF(CLASS='MN')
          $IF(HESF='B') $IHLP=7
          $IF(HESF='S') $IHLP=8
        $ENDIF
      $ENDIF
    $ENDIF
  $ELSEIF(JACA='S')
    $IF(NUMDER=1) $IHLP=3
    $IF(NUMDER=2) $IHLP=1
  $ELSEIF(CLASS='TN')
    $IF(NUMDER=3) $IHLP=2
  $ENDIF
  $SUBST('UA$(KD)SQ$IHLP')
$ELSEIF(MODEL='AP')
  $IF(CLASS='TN')
  $ELSEIF($DEF(DECOMP))
    $IF(DECOMP='A') $IHLP=2
    $IF(DECOMP='Q') $IHLP=2
    $IF(DECOMP='R') $IHLP=2
    $IF(DECOMP='C') $IHLP=2
    $IF(DECOMP='E') $IHLP=2
  $ENDIF
  $IF(KD>0)
    $IF(JACA='S')
      $IHLP=3
      $IF(KD=1)
        $IF(HESF='B') $IHLP=6
        $IF(UPDATE='B') $IHLP=6
      $ENDIF
      $IF(KD>1)
        $IF(HESF='S') $IHLP=4
        $IF(HESF='D') $IHLP=5
        $IF(UPDATE='B') $IHLP=6
        $IF(UPDATE='F') $IHLP=6
        $IF(CLASS='MN')
          $IF(HESF='B') $IHLP=7
          $IF(HESF='S') $IHLP=8
        $ENDIF
      $ENDIF
    $ENDIF
  $ENDIF
  $SUBST('UA$(KD)SP$IHLP')
$ELSEIF(MODEL='AA')
  $IHLP=1
  $IF(KD>0)
    $IF(JACA='S') $IHLP=3
  $ENDIF
  $SUBST('UA$(KD)SA$IHLP')
$ELSEIF(MODEL='AM')
  $IHLP=1
  $IF(KD>0)
    $IF(FORM='SL') $IHLP=2
    $IF(JACA='S')
      $IHLP=3
      $IF(CLASS='BV') $IHLP=4
    $ENDIF
  $ENDIF
  $SUBST('UA$(KD)MX$IHLP')
$ELSEIF(MODEL='D?')
  $IF(KD=0) $SYSTEM='F'
  $IF(KD=2) $SYSTEM='F'
  $HELP
    COMPUTATION OF THE GRADIENT VECTOR
      F - FORWARD INTEGRATION USING AN AUGMENTED SYSTEM
      B - BACKWARD INTEGRATION USING THE ADJOINT SYSTEM
  $CHECK(SYSTEM,'F','F\B',2,NO)
  $IHLP=1
  $IF(SYSTEM='B') $IHLP=2
  $SUBST('UA$(KD)$(MODEL)$IHLP')
  $IF(MODELF='NO')
    NFV=NFV+1
    IF (KD.GT.0) NFG=NFG+1
  $ELSEIF(MODEL='DQ')
    NFV=NFV+1
    IF (KD.GT.0) NFG=NFG+1
  $ENDIF
$ENDIF
*
*     ------------------------
*     END OF MODEL DESCRIPTION
*     ------------------------
*
$IF($DEF(NUMDER))
  $IF(NUMDER=1)
    $IF($DEF(PENALFNC))
      $PENALFNC
    $ENDIF
  $ENDIF
$ELSE
  $IF($DEF(PENALFNC))
    $PENALFNC
  $ENDIF
$ENDIF
$IF(MODEL='A?')
  $IF(LAD<KDA)
    $IF(KD>1)
      $IF(JACA='S')
        $HA=HAS
        $MHA=MHAS
      $ENDIF
    $ENDIF
  $ENDIF
$ENDIF
